; File: Auto_clean_onePartilce_by_oneParticle_mos.pro

; modified by Ted Fisher 2013-09-30
; - changed formatting/indent to standard 4 spaces
; - changed memory allocation to use pointers instead of copying data




pro Auto_clean_one_by_one_event, event  ; For cleanAll, with used specified roundness.
    Widget_Control, event.top, Get_UValue=info, /No_Copy  ; get our info structure

    AllOrKps='All'
    liqorice='DontKnow'

    Auto_clean_oneParticle_by_oneParticle,'H',info,AllOrKps,liqorice;  This is for cleaning all both ice or liq

    print,'Done H channel Cleaning '+AllOrKps+'****';         with user specified roundness

    Auto_clean_oneParticle_by_oneParticle,'V',info,AllorKps,liqorice;  This is for cleaning all both ice or liq

    print,'Done V channel Cleaning '+AllOrKps+'****';         ;with user specified roundness

    Widget_Control, event.top, Set_UValue=info, /No_Copy
end



pro Auto_clean_one_by_one4_event, event  ; For keeping splashes, with user specified roundess
    ; this is just clean statistical noise dot + line noise, but keep the splashes.
    AllOrKps='KeepSplashes'
    liqorice='DontKnow'

    Widget_Control, event.top, Get_UValue=info, /No_Copy  ; get our info structure

    Auto_clean_oneParticle_by_oneParticle,'H',info,AllOrKps,liqorice

    print,'Done H channel Cleaning but '+AllOrKps+'****'

    Auto_clean_oneParticle_by_oneParticle,'V',info,AllOrKps,Liceorice

    print,'Done V channel Cleaning but '+AllOrKps+'****'

    Widget_Control, event.top, Set_UValue=info, /No_Copy
end ; end of Auto_clean_one_by_one4_event, event



pro Auto_clean_oneParticle_by_oneParticle, HorV, info, AllOrKps, liqorice
    Common  DataBlock,alldataH,alldataV

    if strupcase(HorV) eq 'H' then alldata=alldataH else alldata=alldataV

    if n_elements(alldata) eq 0 then begin
        ;rrr=dialog_message('No data loaded, try again !',/information)
        print, 'No data loaded, try again !'
        return
    endif

    if AllOrKps eq 'NoClean' then return

    ;find out if a previous autoclean1H.2DS already exist, if exist
    ;confirm and use it to loaded the result; if not then, go to do the
    ;cleaning in the long time and lenthy codes.
    cleaned_filename=strmid(!currentHFname,0,strlen(!currentHFname)-4)+'_AutoClean1'+HorV+'.txt'

    IF  SPEC_TestForFile(cleaned_filename) eq 0 then begin;  the file exist;load it and the cleaning is done
        openr,1, cleaned_filename
        header1='aaa' & header2='aaa'
        readF,1,header1
        readF,1,header2
        mymessage=[['A Previous *AutoClean1'+HorV+'.txt file with Aspect_ratio and Clean1 Or clean4 header lines are:'],$,
        [Header1],[header2],$
            ['Use it to load the cleaned result ?']]

        if !autoarchive eq 0 and !autoarchive_png_only eq 0 then begin
            answer=dialog_message(mymessage,/question)
        endif  else begin
            answer='Yes'
            print,'A Previous *AutoClean1'+HorV+'.txt file with Aspect_ratio and Clean1 Or clean4 header lines are:'
            print,Header1,header2,' is loaded and used as the clean result.'
            outputfilename=strmid(!currentHFname,0,strlen(!currentHFname)-4)+'PopUpMessages.txt'; open it ready for write to it.
            openw,8,outputfilename,/append;    printf,8,mymessage;    close,8
            printf,8,'A Previous *AutoClean1'+HorV+'.txt file with Aspect_ratio and Clean1 Or clean4 header lines are:'
            printf,8,Header1,header2,' is loaded and used as the clean result. at ',systime()
            close,8
        endelse

        ;get the previous roundness aspect_ratio, and confirm that the same ration will be used for cleaning.
        ;************************************************
        if answer ne 'Yes' then begin
            close,1

            goto, Do_A_New_Hclean
        endif

        ;***********************************************
        ; -1 mean can not find the Autoclean1H.2dS file and can not Open_it.
        N_bad_particles=0LL

        readF,1,N_bad_particles

        data={index:0LL,reject:0,noisebyte:0}
        data1=replicate(data,N_bad_particles)

        readF,1,data1

        index1=data1.index
        reject=data1.reject
        noisebyte=data1.noisebyte

        for i=0LL,n_elements(index1)-1LL do begin
            (*alldata)(index1(i)).reject=reject(i)
            (*alldata)(index1(i)).noisebyte=noisebyte(i)
        endfor; (*alldata)(index1).reject=reject; this statement won't work.

        close,1

        ;*************************  Re-calculate w8_t_clean ***************************
        indexFinal=where((*alldata).reject eq 0, cont_nnnn);  loop through all not_yet_deterimined ones.
        ; also calculate the clean w8_t of all accepted particles.
        w8_t_clean=(*alldata).w8_t*0LL;  aasigned all to be 0; then assign good ones with good values.
        if cont_nnnn gt 1 then begin
            ;********************************************************************************
            Tick_array0=[(*alldata)(0).probecounter,  (*alldata)(indexFinal(0LL:cont_nnnn-2LL)).probecounter]
            Tick_arrayE=(*alldata)(indexFinal(0LL:cont_nnnn-1LL)).probecounter
            Delta_FullTicks=Tick_arrayE-Tick_array0; Real_time_between_two_particles.

            Tick_array0=[0LL, (*alldata)(indexFinal(0LL:cont_nnnn-2LL)).accDTTick]
            Tick_arrayE=(*alldata)(indexFinal(0LL:cont_nnnn-1LL)).accDTTick
            Delta_total_DT_Ticks=Tick_arrayE-Tick_array0; total_deadtTime_between_two_particles

            W8_t_clean(IndexFinal)=Delta_FullTicks-Delta_total_DT_Ticks
            ;********************************************************************************
            (*alldata).w8_t_clean=W8_t_clean
        endif

        ;******************************************************************************
        ; load the clean adj0 file which goes with the _autoclean1H.txt
        adj0_filename=strmid(!currentHFname,0,strlen(!currentHFname)-4)+'_AutoAdj0'+HorV+'.txt'

        IF  SPEC_TestForFile(adj0_filename) eq 0 then begin;  the file exist;load it and the cleaning is done
            if !autoarchive eq 0 and !autoarchive_png_only eq 0 then  begin
                rrr=dialog_message('A Previous *Autoadj0'+HorV+'.txt file will be used to load the adj0 result !',/information)
            endif else begin
                print, 'A Previous *Autoadj0'+HorV+'.txt file will be used to load the adj0 result !'
                outputfilename=strmid(!currentHFname,0,strlen(!currentHFname)-4)+'PopUpMessages.txt'; open it ready for write to it.
                openw,8,outputfilename,/append;    printf,8,mymessage;    close,8
                printf,8, 'A Previous *Autoadj0'+HorV+'.txt file will be used to load the adj0 result ! at',systime()
                close,8
            endelse

            openr,1, adj0_filename;   ; -1 mean can not find the Autoclean1H.2dS file and can not Open_it.
            N_particles=0LL
            readF,1,N_particles
            data={index:0LL,adj0:0.0}
            data1=replicate(data,N_particles)
            readF,1,data1
            index1=data1.index
            adj0=data1.adj0

            for i=0LL,n_elements(index1)-1LL do (*alldata)(index1(i)).adj0=adj0(i)

            close,1
        endif else begin
            if !autoarchive eq 0 then rrr=1;dialog_message('No previous adj0 file, alladj0=1.0 !!',/information)
        endelse
    ENDIF else begin


        print,systime(), " before Do_A_New_Hclean"

        Do_A_New_Hclean: begin
            indxrj2=where((*alldata).reject ne 2,contrj2);  need to keep the bad time stamps reject=2 particles.
            if contrj2 gt 0 then (*alldata)(indxrj2).reject=(*alldata)(indxrj2).reject*0; ;do nothing; just jump to here.
            ;need to reset the noise type new
            (*alldata).noisebyte =(*alldata).noisebyte*0
        end

        Re_calculate_roundness_N_Get_roundnessThresholds,liqOrice

        ; TAF 2013-09-30 these assignments are redundantly allocating HUGE amounts of variables
        ;find out how many particles
        Nslice=(*alldata).Nslice;    these are in unit pixels.
        L1n=(*alldata).L1n;    these are in unit pixels.
        L2=(*alldata).L2
        L4=(*alldata).L4
        L5=(*alldata).L5
        L7=(*alldata).L7
        PC1=(*alldata).PC1;  in unit pixels
        Area=(*alldata).Area
        Alexei1=(*alldata).alexei1
        reject=(*alldata).reject
        w8_t=(*alldata).w8_t
        roundness=(*alldata).roundness
        nanoseconds=(*alldata).nanoseconds
        w8t_cutoffa =Nslice*0.0;    for calculating adj0 of w8t cleanning particles.Added these on June 1, 2007.
        w8t_cutoffb =w8t_cutoffa
        true_ave_w8t=w8t_cutoffa+10000.0; which will be greater than cutoffa or b and replaced with true values.
        DDD=Nslice*0;  for keep track of roundness and BigSplashes.

        N_neighbour=2000LL;  use before 2000 and after 2000 particles for statistics.
        nnnn=n_elements(Nslice)
        nnnnm1=nnnn-1

        print,systime(),'nnn=',nnnn

        index=where(reject eq 2 ,contG)

        if contG GT 0 then begin
            DDD(index)=1
        endif

        index=where( float(Nslice )/float(L5 ) gt 10.0  Or  $; get rid of very long solid lines.
            ( Nslice  eq Area  and L2  eq 1 and Nslice  gt 4 )  or  $                      ; line and dot.
            ( Area  le 1.35*Nslice  and L4  eq L5  and Nslice  gt 4 and L2  eq 2) or $
            ( Nslice  gt 10 and Nslice  gt 0.75*area  and Nslice  le 1.5*area )  or $
            ( L4  eq L5  and Alexei1  gt 0.9*Nslice *L5  and L2  eq 2 and L2  ne L4 ) or $
            ( L4  eq L5  and Alexei1  gt 3.0*Area  and L2  eq 2) or $
            ( L4  eq L5  and Alexei1  gt 4.0*Area ) or  (roundness eq 0), ContGG0)
        if contGG0 gt 0 then begin
            DDD(index)=1
            (*alldata)(index).noisebyte=(*alldata)(index).noisebyte+2
            (*alldata)(index).reject=1

        endif


        ;  see  if particle are big splash------;step 4 to see if it is big splash.
        if AllOrKps eq 'All' then begin;   this block remove Big splashes.

            index=where(DDD ne 1 and ( ((L5 gt 10 or Nslice gt 10) and (Alexei1 gt 3.0*area)) or  $
                ((L5 gt 15 or Nslice gt 15) and (Alexei1 gt 2.5*area)) or  $
                ((L5 gt 20 or Nslice gt 20) and (Alexei1 gt 2.0*area)) or  $
                ((L5 gt 6.0*Nslice or Nslice gt 6.0*L5)              )    ), contGG0 )

            if contGG0 gt 0 then begin
                DDD(index)=1
                (*alldata)(index).noisebyte=(*alldata)(index).noisebyte+8
                (*alldata)(index).reject=1
            endif
        endif


        for i=0LL, nnnn-1LL do begin;  This will be the first loop of cleaning. there are two loops of cleaning. TAF 2013-09-30 but below talks about third loop?...

            if i mod 100 eq 0 then begin
                indexS0=(i-N_neighbour) > 0;  i is a long64 number
                indexE0=(i+N_neighbour) < nnnnm1; nnnnm1=nnnn-1
                Pc1_array=PC1(indexS0:indexE0)
                ;Find_allBad_pixels_in_thisPC1group,PC1_array,BadPixel_array
                Find_allBad_pixels_in_thisPC1group_brad, PC1_array, BadPixel_array
                ;print,'i=',i;   print,BadPixel_array;   ;stop
            endif

            if reject(i) eq 2 then begin
                DDD(i)=1;  treated it as dot_line or noise
                goto, nextI;  added january 28, 2008.
            endif

            if DDD(i) eq 1 then begin
                goto, nextI;  added january 28, 2008.
            endif

            junkindex=where(BadPixel_array eq PC1(i), YesCont)
            If Yescont eq 1 then  begin
                ; unless it meets on one of the three following criteria.
                Crit_a=Nslice(i) ge 4 and L5(i) ge 4 and L2(i) ge 3 and area(i) ge 0.5*alexei1(i) and Nslice(i) lt 10*L2(i)
                if Crit_a eq 0 then begin
                    DDD(i)=1
                    (*alldata)(i).noisebyte=(*alldata)(i).noisebyte+1
                    (*alldata)(i).reject=1
                    goto, NextI
                endif; else : this particle is still a good particle.
            endif


            ; added this to take away black spot rectangular images.
            if area(i) gt 0.8*Nslice(i)*126.0 and area((i+1)<nnnnm1) gt 0.8*Nslice((i+1)<nnnnm1)*126 then begin
                DDD(i)=1
                (*alldata)(i).noisebyte=(*alldata)(i).noisebyte+2
                (*alldata)(i).reject=1
                goto, nextI
            endif

            if area(i) gt 0.8*Nslice(i)*126.0 and area((i-1)>0) gt 0.8*Nslice((i-1)>0)*126 then begin
                DDD(i)=1
                (*alldata)(i).noisebyte=(*alldata)(i).noisebyte+2
                (*alldata)(i).reject=1
                goto, nextI
            endif

            nextI:   ; do nothing in here.

            if i mod 1000LL eq 0 then begin
                widget_control,info.statusID,DYNAMIC_RESIZE=1, Set_Value="Autoclean1...."+HorV+ strtrim(i)+' of '+string(nnnn)
            endif

        endfor;  This ends teh first loop of cleaning. take out big splashes, dotNline, statitistical noise. stuck bits.

        print,systime(), " after first for loop"

        ; TAF this is a HUGE copy operation!!!!
        ;reject = (*alldataH).reject; in teh next we will use only the first loop non-rejected particles for w8-t.

        if AllOrKps eq 'All' then begin;  this block remove small splashs using w8t method.
            ;**************************   Repeat the loop again to do W8_t  cleaning.   ****************************
            ; do another type of w8_t_temp2 calculation to see if it is faster.
            ; recalculate the w8_t of all not yet determined particles. w8_t_temp
            print,'Begin w8_t_temp calculation******',HorV,systime()
            w8_t_temp=w8_t*0LL
            indextemp=where(DDD eq 0,contemp); DDD=0 is reject=0 or reject=1 and (splash or not_round)

            if contemp gt 1 then begin;;array1=(*alldata)(indextemp2).probecounter
                array0=[(*alldata)(0).probecounter, (*alldata)(indextemp(0:contemp-2)).probecounter]
                array1   =(*alldata)(indextemp).probecounter
                array1_L1=(*alldata)(indextemp).Nslice
                subw8_t= array1-array0-array1_L1
                w8_t_temp(indextemp)=subw8_t
            endif

            w8_t_temp(0)=200000000LL
            print,'end w8_t_temp calculation******',HorV,systime()

            indexRep=where(DDD eq 0, cont_nnnn);  loop through all not_yet_deterimined ones.

            if cont_nnnn gt 1 then begin
                ;open a file to record skip100or1 changed history
                skip100or1_fileH=!currentHPname+HorV+'_skip100or1_log_file.txt'
                openw,19,skip100or1_fileH
                printf,19,'hh_mm_ss_ms_--seconds___conthowmany1__conthowmany2__0skip100or1__Nskip100or1'
                skip100or1=1 & skipCount=0LL
                skip_temp=skip100or1

                print,systime(), " before second for loop"

                for i=0LL,cont_nnnn -2LL do begin
                    this_index=indexRep(i);   ;find its averaged w8_time so far and if there is big particles.
                    Af_index=indexRep(i+1) ;  next "good" particle; before oct 3,2007: Af_index=(This_index+1LL) < (nnnn-1LL)

                    skipCount=skipCount+1LL

                    if skipCount eq skip100or1 then begin; changed skip100or1 to be a variable in Oct11, 2007.
                        skipcount=0LL
                        ;*********************************************************************************
                        ;**************  added ths on july 16, 2007 *************
                        ;find out how thick the cloud is, if too thin, we don't skip 100 particles
                        howmany=where(nanoseconds ge nanoseconds(this_index)-100000000LL and $; before 0.1 second
                            nanoseconds le nanoseconds(this_index) and DDD eq 0, conthowmany1); that is 0.1 seconds
                        howmany=where(nanoseconds le nanoseconds(this_index) +100000000LL and $; after 0.1 second
                            nanoseconds ge nanoseconds(this_index) and DDD eq 0, conthowmany2); that is 0.1 seconds
                        skip100or1=conthowmany1 < conthowmany2;  that will always GE 1.

                        if skip_temp ne skip100or1 then begin
                            timeHMS = spec_nano2HMS(nanoseconds(this_index))
                            hh = fix(strmid(timeHMS,0,2))
                            mm = fix(strmid(timeHMS,3,2))
                            ss = fix(strmid(timeHMS,6,2))
                            ms = fix(strmid(timeHMS,9,3))
                            sss = hh * 3600.0 + mm * 60.0 + ss * 1.0 + ms / 1000.0


                            printf,19,format='(I2,1x,I2,1x,I2,2x,I3,1x,I13.3,1x,I12,1x,I12,1x,I12,1x,I12)',hh,mm,ss,ms,sss,conthowmany1,conthowmany2,skip_temp,skip100or1
                            skip_temp=skip100or1
                        endif

                        start_time0=nanoseconds(this_index)-1000000000LL;   the next 1 seconds 95 particles will net get w8_t check.
                        end_time0  =nanoseconds(this_index)+1000000000LL
                        ; TAF 2013-11-15 apparently Mo reverted to using get_spec_ticks2 again with 168Mo -- does it work?
                        ;Get_spec_ticks,'H',start_time0,start_ticks0,St0_index
                        ;Get_spec_ticks,'H',End_time0,end_ticks0,Et0_index

                        get_spec_ticks2, HorV, start_time0, end_time0, start_ticks0, end_ticks0, ST0_index, ET0_index

                        ; first see if there are 5K particles in the B4 1 second period. if there is use the
                        ; the begin particle's time as start_ticks, if not, convert exact time to start_ticks.

                        indx1 = where(nanoseconds ge start_time0 and $  ;accepted "good" particles
                            nanoseconds le nanoseconds(this_index) and reject eq 0,contAve1 )

                        if contAVe1 eq 0 then begin
                            has_big1=0;  There is no big-precip particle in the 1 second period.
                            ; get_deadtime_between_tick1_and_tick2,'H',start_ticks0,(*alldata)(this_index).probecounter,deadtime1
                            ; First_index=ST0_index+1LL <This_index;  To get the sum of L1s in the period.
                            ; allL1s=total(Nslice(First_index:this_index));  sum of all Nslices in this Before 1 second period.

                            get_total_deadtime_by_ACCDT_between_Tick1tick2,HorV,Start_ticks0,St0_index,$
                                (*alldata)(this_index).probecounter,this_index,total_Deadtime




                            ; part1_ticks=(*alldata)(this_index).probecounter-start_ticks0-deadtime1-allL1s
                            part1_ticks=(*alldata)(this_index).probecounter-start_ticks0-total_deadtime
                            part1_conts=0
                            ;get_total_deadtime_by_ACCDT_between_Tick1tick2,'H',Start_ticks0,St0_index,$
                            ;            (*alldata)(this_index).probecounter,this_index,total_Deadtime
                            ;if deadtime1+allL1s ne total_deadtime then stop
                        endif

                        if contAVe1 ge 1 and contAve1 le 5000LL then begin
                            has_big1 = max(L7(indx1)) ge 7.0
                            ;get_deadtime_between_tick1_and_tick2,'H',start_ticks0,(*alldata)(this_index).probecounter,deadtime1

                            get_total_deadtime_by_ACCDT_between_Tick1tick2,HorV,Start_ticks0,St0_index,$
                                (*alldata)(this_index).probecounter,this_index,total_Deadtime


                            ;First_index=ST0_index+1LL <This_index
                            ; allL1s=total(Nslice(First_index:this_index))
                            ;part1_ticks=(*alldata)(this_index).probecounter-start_ticks0-deadtime1-allL1s
                            part1_ticks=(*alldata)(this_index).probecounter-start_ticks0-total_deadtime
                            part1_conts =contAve1
                            ;get_total_deadtime_by_ACCDT_between_Tick1tick2,'H',Start_ticks0,St0_index,$
                            ;            (*alldata)(this_index).probecounter,this_index,total_Deadtime
                            ;if deadtime1+allL1s ne total_deadtime then ;stop
                        endif

                        if contAVe1 gt 5000LL then begin
                            start_index=long64(contAVe1)-5000LL;  use the 5000 already accepted particles.
                            has_big1= max( L7(indx1(Start_index:contAVe1-1LL)) ) gt 7.0
                            ; First_index=indx1(start_index)+1LL
                            ; allL1s =total(Nslice(First_index:This_index))
                            ; get_deadtime_between_tick1_and_tick2,'H',(*alldata)(indx1(start_index)).probecounter,(*alldata)(this_index).probecounter,deadtime1

                            get_total_deadtime_by_ACCDT_between_Tick1tick2,HorV,(*alldata)(indx1(start_index)).probecounter,indx1(start_index),$
                                (*alldata)(this_index).probecounter,this_index,total_Deadtime

                            ; part1_ticks=(*alldata)(this_index).probecounter-(*alldata)(indx1(start_index)).probecounter-deadtime1-allL1s
                            part1_ticks=(*alldata)(this_index).probecounter-(*alldata)(indx1(start_index)).probecounter-total_deadtime
                            part1_conts=5000LL
                            ;get_total_deadtime_by_ACCDT_between_Tick1tick2,'H',(*alldata)(indx1(start_index)).probecounter,indx1(start_index),$
                            ;            (*alldata)(this_index).probecounter,this_index,total_Deadtime
                            ;if deadtime1+allL1s ne total_deadtime then stop
                        endif

                        ; second see if there are 5K particles in the  After 1 second period. if there is use the
                        ; the end particle's time as end_ticks, if not, convert exact time to start_ticks.

                        indx2 = where(nanoseconds ge nanoseconds(this_index) and $
                            nanoseconds le end_time0 and reject eq 0,contAve2 )

                        if contAVe2 eq 0 then begin
                            has_big2=0
                            get_total_deadtime_by_ACCDT_between_Tick1tick2,HorV,(*alldata)(this_index).probecounter,this_index,$
                                End_ticks0,ET0_index,total_Deadtime
                            part2_ticks=End_ticks0-(*alldata)(this_index).probecounter-total_deadtime
                            part2_conts=0
                        endif

                        if contAVe2 ge 1 and contAVe2 le 5000LL then begin ;There are good images in this last 1 second period.
                            has_big2 = max(L7(indx2)) ge 7.0;   ET0_index is the index After 1 seconds endTime End_time0.

                            get_total_deadtime_by_ACCDT_between_Tick1tick2,HorV,(*alldata)(this_index).probecounter,this_index,$
                                End_ticks0,ET0_index,total_Deadtime
                            part2_ticks=end_ticks0-(*alldata)(this_index).probecounter-total_deadtime
                            part2_conts =contAVe2;  This is only one good accepted particles in this period.
                        endif

                        if contAve2 gt 5000LL then begin
                            has_big2 =max(L7(indx2(0:4999))) ge 7.0;  use the first 5000 for sizes.
                            get_total_deadtime_by_ACCDT_between_Tick1tick2,HorV,(*alldata)(this_index).probecounter,This_index,$
                                (*alldata)(indx2(4999)).probecounter,indx2(4999),total_deadtime
                            part2_ticks= (*alldata)(indx2(4999)).probecounter-(*alldata)(this_index).probecounter-total_deadtime

                            part2_conts=5000LL
                        endif

                        has_big=has_big1 or has_big2
                        total_conts=float(Part1_conts + Part2_conts) > 1.0; Make sure total_counts not zero.
                        avew8t =float(part1_ticks+part2_ticks)/total_conts
                        ;*******************************************************************************************
                        W8_threshold1=0.05*avew8t < 2000;                         take the min of the two
                        w8_threshold2=0.2 *avew8t < 8000;*!w8_t_shatter_factor;   take the min of the two
                    endif; end if i mod 100 eq 0;  get the threshold values for every 100 particle

                    if !set_has_big_always_eq_1 eq 1 then has_big=1

                    if has_big eq 1 then begin; it is in rainshaft; need to check the w8_t
                        c_w8_t=w8_t_temp(this_index)
                        n_w8_t=w8_t_temp(Af_index)

                        c_size=Nslice(This_index)

                        ;if current w8t lt 10 and size gt 10 and previous_size  lt 10, then previous is satellite,
                        ; we need to ignore it and use the satellite's w8_t as teh current w8_T.
                        if c_w8_t lt 10 and c_size gt 10 and area(indexRep((i-1)>0)) lt 10 then $
                            c_w8_t=w8_t_temp(indexRep((i-1)>0))

                        ; if next w8t lt 10 and next_area lt 10, then it is a satellite, and we need to use
                        ; the one after the satellite as the adjacent w8-t for comparsion with the threshold c1.
                        if n_w8_t lt 10 and c_size gt 10 and area(Af_index) lt 10 then $
                            n_w8_t=w8_t_temp(indexRep(  (i+2)<(cont_nnnn-1)  ))

                        if c_w8_t Le w8_threshold1  or n_W8_t Le w8_threshold1 then begin
                            (*alldata)(This_index).reject=1
                            (*alldata)(this_index).noisebyte=(*alldata)(this_index).noisebyte+4
                        endif else begin
                            if c_w8_t Le w8_threshold2 and n_W8_t Le w8_threshold2 then begin
                                (*alldata)(This_index).reject=1
                                (*alldata)(this_index).noisebyte=(*alldata)(this_index).noisebyte+4
                            endif
                        endelse

                        ; if (*alldata)(this_index).nanoseconds gt 53344052000000LL and $
                        ;    (*alldata)(this_index).nanoseconds lt 53344269000000LL  then begin
                        ;     if w8_t(this_index) lt 20 then begin
                        ;      print,'time=',(*alldata)(this_index).nanoseconds
                        ;      print, w8_t(this_index),'   ',w8_t_temp(this_index)
                        ;      print, w8_t(Af_index),'   ',w8_t_temp(Af_index)
                        ;      print, w8_threshold1,'   ',w8_threshold2
                        ;      print, ' has_big=',has_big,' Reject=',(*alldata)(This_index).reject
                        ;      endif
                        ; endif
                        w8t_cutoffa(this_index)=w8_threshold1
                        w8t_cutoffb(this_index)=w8_threshold2
                        ; if nanoseconds(this_index) eq 51145356419005LL then stop
                        ; if nanoseconds(this_index) eq time2257 then stop

                    endif; endif of if has_big eq 1

                    ; if (*alldata)(this_index).nanoseconds gt 53344268571000LL and $
                    ;       (*alldata)(this_index).nanoseconds lt 53344269000000LL  then begin
                    ;  print, 'i=',i, ' this_index=',indexrep(i),' has_big=',has_big,' w8_t=',w8_t(this_index),' reject=',(*alldata)(this_index).reject
                    ;  print, 'W8_t(af)=',w8_t(Af_index),'  W8_t_temp=',w8_t_temp(Af_index)
                    ;  print, 'Threshold1=',w8_threshold1,'  Threshold2=',w8_threshold2

                    ; endif
                    ;if w8_t(this_index) eq 195 and Pc1(this_index) eq 44 then stop

                    if i mod 1000LL eq 0 then begin
                        widget_control,info.statusID,DYNAMIC_RESIZE=1, Set_Value="W8_t Autoclean1...."+HorV + strtrim(i)+' of '+string(cont_nnnn)
                    endif
                endfor; end of w8t clean;  for i=0, cont_nnnn do begin;  end of second loop of cleaning.
                close,19
            endif; end if cont_nnnn gt 1
        endif; end of if AllOrKps eq 'All' to remove small splashes using w8t. end of second loop of cleaning.

        ; recalculate true ave_w8t for each finally accepted particles and calculate each accepted particles adj0 values.
        ;******************************************************************************************************
        print,'start of third loop----true ave_w8_t calculation ',HorV,': ',systime(),  'File:', !currentHFname

        ;**************************   Repeat the loop again to do W8_t  cleaning.   ****************************

        ; TAF 2013-10-01 below does the where on the entire alldataH -- this should be subsetted to
        ; only look at the relevant sections of alldataH, which should greatly speed things up

        indexFinal=where((*alldata).reject eq 0, cont_nnnn);  loop through all not_yet_deterimined ones.
        ; also calculate the clean w8_t of all accepted particles.
        w8_t_clean=w8_t*0LL;  aasigned all to be 0; then assign good ones with good values.
        if cont_nnnn gt 1 then begin
            ;********************************************************************************
            Tick_array0=[(*alldata)(0).probecounter,  (*alldata)(indexFinal(0LL:cont_nnnn-2LL)).probecounter]
            Tick_arrayE=(*alldata)(indexFinal(0LL:cont_nnnn-1LL)).probecounter
            Delta_FullTicks=Tick_arrayE-Tick_array0; Real_time_between_two_particles.

            Tick_array0=[0LL, (*alldata)(indexFinal(0LL:cont_nnnn-2LL)).accDTTick]
            Tick_arrayE=(*alldata)(indexFinal(0LL:cont_nnnn-1LL)).accDTTick
            Delta_total_DT_Ticks=Tick_arrayE-Tick_array0; total_deadtTime_between_two_particles

            W8_t_clean(IndexFinal)=Delta_FullTicks-Delta_total_DT_Ticks
            ;********************************************************************************
        endif; endif of getiing teh w8_t_clean

        indexRep=where(DDD eq 0, cont_nnnn);  loop through all not_yet_deterimined ones.

        if cont_nnnn gt 0 then begin
            skip100or1=1LL & skipCount=0LL
            for i=0LL,cont_nnnn -2LL do begin
                this_index=indexRep(i);   ;find its averaged w8_time so far an dif there is big particles.

                skipCount=skipCount+1LL

                if skipCount eq skip100or1 then begin; changed skip100or1 to be a variable in Oct11, 2007.
                    skipcount=0LL
                    ;*********************************************************************************
                    ;**************  added ths on july 16, 2007 *************
                    ;find out how thick the cloud is, if too thin, we don't skip 100 particles
                    howmany=where(nanoseconds ge nanoseconds(this_index)-100000000LL and $; before 0.1 second
                        nanoseconds le nanoseconds(this_index) and DDD eq 0, conthowmany1); that is 0.1 seconds
                    howmany=where(nanoseconds le nanoseconds(this_index) +100000000LL and $; after 0.1 second
                        nanoseconds ge nanoseconds(this_index) and DDD eq 0, conthowmany2); that is 0.1 seconds
                    skip100or1=conthowmany1 < conthowmany2;  that will always GE 1.

                    ;*********************************************************************************
                    start_time0=nanoseconds(this_index)-1000000000LL
                    end_time0  =nanoseconds(this_index)+1000000000LL
                    Get_spec_ticks,HorV,start_time0,start_ticks0,St0_index
                    Get_spec_ticks,HorV,End_time0,end_ticks0,Et0_index

                    get_spec_ticks2, HorV, start_time0, end_time0, start_ticks0, end_ticks0, ST0_index, ET0_index

                    ; first see if there are 5K particles in the B4 1 second period. if there is use the
                    ; the beegin particle's time as start_ticks, if not, convert exact time to start_ticks.

                    indx1=where(nanoseconds ge start_time0 and $  ;Finally all accepted good particles
                        nanoseconds le nanoseconds(this_index) and (*alldata).reject eq 0,contAve1 )
                    ;*****************************************************************************************************
                    if contAVe1 eq 0 then begin
                        get_total_deadtime_by_ACCDT_between_Tick1tick2,HorV,Start_ticks0,St0_index,$
                            (*alldata)(this_index).probecounter,this_index,total_Deadtime
                        part1_ticks=(*alldata)(this_index).probecounter-start_ticks0-total_deadtime
                        part1_conts=0

                        if part1_ticks lt 0 then begin; stop
                            outputfilename=strmid(!currentHFname,0,strlen(!currentHFname)-4)+'PopUpMessages.txt'; open it ready for write to it.
                            openw,8,outputfilename,/append;    printf,8,mymessage;    close,8
                            printf,8, 'part1_ticks lt 0 for file:   '+!currentHFname
                            close,8
                        endif
                    endif

                    if contAVe1 ge 1 and contAve1 le 1000LL then begin
                        get_total_deadtime_by_ACCDT_between_Tick1tick2,HorV,Start_ticks0,St0_index,$
                            (*alldata)(this_index).probecounter,this_index,total_Deadtime
                        part1_ticks=(*alldata)(this_index).probecounter-start_ticks0-total_deadtime
                        part1_conts =contAve1
                        if part1_ticks lt 0 then begin
                            outputfilename=strmid(!currentHFname,0,strlen(!currentHFname)-4)+'PopUpMessages.txt'; open it ready for write to it.
                            openw,8,outputfilename,/append;    printf,8,mymessage;    close,8
                            printf,8, 'part1_ticks lt 0 for file:   '+!currentHFname
                            close,8
                        endif
                    endif

                    if contAVe1 gt 1000LL then begin
                        start_index=long64(contAVe1)-1000LL;  use the 1000 already accepted particles.
                        get_total_deadtime_by_ACCDT_between_Tick1tick2,HorV,(*alldata)(indx1(start_index)).probecounter,indx1(start_index),$
                            (*alldata)(this_index).probecounter,this_index,total_Deadtime
                        part1_ticks=(*alldata)(this_index).probecounter-(*alldata)(indx1(start_index)).probecounter-total_deadtime
                        part1_conts=1000LL
                        if part1_ticks lt 0 then begin
                            outputfilename=strmid(!currentHFname,0,strlen(!currentHFname)-4)+'PopUpMessages.txt'; open it ready for write to it.
                            openw,8,outputfilename,/append;    printf,8,mymessage;    close,8
                            printf,8, 'part1_ticks lt 0 for file:   '+!currentHFname
                            close,8;                             ;stop
                        endif
                    endif

                    ;*****************************************************************************************************
                    ; second see if there are 1K particles in the  After 1 second period. if there is use the
                    ; the end particle's time as end_ticks, if not, convert exact time to start_ticks.

                    indx2=where(nanoseconds ge nanoseconds(this_index) and $
                        nanoseconds le end_time0 and (*alldata).reject eq 0,contAve2 )

                    if contAVe2 eq 0 then begin
                        get_total_deadtime_by_ACCDT_between_Tick1tick2,HorV,(*alldata)(this_index).probecounter,this_index,$
                            End_ticks0,ET0_index,total_Deadtime
                        part2_ticks=End_ticks0-(*alldata)(this_index).probecounter-total_deadtime
                        part2_conts=0
                        if part2_ticks lt 0 then part2_ticks=End_ticks0-(*alldata)(this_index).probecounter; & stop
                    endif

                    if contAVe2 ge 1 and contAVe2 le 1000LL then begin ;There are good images in this last 1 second period.

                        get_total_deadtime_by_ACCDT_between_Tick1tick2,HorV,(*alldata)(this_index).probecounter,this_index,$
                            End_ticks0,ET0_index,total_Deadtime
                        part2_ticks=end_ticks0-(*alldata)(this_index).probecounter-total_deadtime
                        part2_conts =contAVe2;  This is only one good accepted particles in this period.
                        if part2_ticks lt 0 then part2_ticks=end_ticks0-(*alldata)(this_index).probecounter; & stop
                    endif

                    if contAve2 gt 1000LL then begin

                        get_total_deadtime_by_ACCDT_between_Tick1tick2,HorV,(*alldata)(this_index).probecounter,this_index,$
                            (*alldata)(indx2(999)).probecounter,indx2(999),total_Deadtime
                        part2_ticks=(*alldata)(indx2(999)).probecounter-(*alldata)(this_index).probecounter-total_deadtime
                        part2_conts=1000LL
                        if part2_ticks lt 0 then part2_ticks=(*alldata)(indx2(999)).probecounter-(*alldata)(this_index).probecounter; & stop
                    endif
                    total_conts=float(Part1_conts + Part2_conts) > 1.0; Make sure total_counts not zero.
                    avew8t =float(part1_ticks+part2_ticks)/total_conts
                endif; end if i mod 100 eq 0;  get the threshold values for every 100 particle

                true_ave_w8t(this_index)=avew8t

                if i mod 1000LL eq 0 then begin
                    widget_control,info.statusID,DYNAMIC_RESIZE=1, Set_Value="True ave_W8_t calculation. "+HorV + strtrim(i)+' of '+string(cont_nnnn)
                endif
            endfor; end of true_ave_w8t calculation;  for i=0, cont_nnnn do begin
        endif; end if cont_nnnn gt 1;     end of third loop to define all accepted particle ajd0 values..
        (*alldata).w8_t_clean=w8_t_clean
        print,'End of third loop----true ave_w8_t calculation:',HorV,systime()

        ; finally calculates K and adj0
        ;exp_part1=exp(-w8t_cutoffa/true_ave_w8t)
        ;exp_part2=exp(-w8t_cutoffb/true_ave_w8t)
        TaW =true_ave_w8t-W8t_cutoffa
        indexTaw=where(TaW le 0.0, contTaw)

        if contTaw gt 0 then begin
            ;rrr=dialog_message(' true_ave_w8t less than C1, It should not be that !, report to brad or Mo',/information)
            outputfilename=strmid(!currentHFname,0,strlen(!currentHFname)-4)+'PopUpMessages.txt'; open it ready for write to it.
            openw,8,outputfilename,/append;    printf,8,mymessage;    close,8
            printf,8, 'contTaw gt 0 for file:   '+!currentHFname
            close,8
        endif

        exp_part1=exp(-w8t_cutoffa/TaW)
        exp_part2=exp(-w8t_cutoffb/TaW)

        K_value  =(1.0+exp_part1)*(1.0-exp_part1)+exp_part1*exp_part1*(1.0-exp_part2)^2
        indexjj=where(k_value gt 0.90, contJJ)

        if contJJ gt 0 then begin
            K_value=K_value < 0.9
            outputfilename=strmid(!currentHFname,0,strlen(!currentHFname)-4)+'PopUpMessages.txt'; open it ready for write to it.
            openw,8,outputfilename,/append;    printf,8,mymessage;    close,8

            for ii=0LL,contJJ-1LL do begin
                printf,8, 'adj0: ',HorV,'  with K greater than 0.9  Changed to adj0=10.0'
            endfor

            close,8
        endif
        (*alldata).adj0=1.0/(1.0-K_value)

        ;****************************************************************************************************
        print,systime(),'nnn=',nnnn
        ;label the impossible particles with reject value equals 2.
        index=where(w8_t lt 0, contH)

        if contH gt 0 then (*alldata)(index).reject=2

        ;open a file to save all of the cleaning work for next time processing
        outputfilename=strmid(!currentHFname,0,strlen(!currentHFname)-4)+'_AutoClean1'+HorV+'.txt'
        index1=where((*alldata).reject eq 1, contg1)
        index2=where((*alldata).reject eq 2, contg2)
        noisebyte=(*alldata).noisebyte;   added oct 16,2007.
        data={index:0LL,reject:0}

        if (contG1+contG2) gt 0 then begin
            openw,1,outputfilename
            Nbad_particles=long64(contg1+contG2)
            Aspect_ratio=1.0/!roundness_threshold1
            printf,1,format='(F12.3,1x,A)',Aspect_ratio,' is_the_Aspect_Ratio_for_roundness_defintion'
            printf,1,format='(A,1x,A)','Clean_All_or_Keep_SPlash_option: ',AllOrKps
            printf,1,format='(I15)',Nbad_particles

            if contG1 gt 0 then begin
                reject1=(*alldata)(index1).reject
                noisebyte1=(*alldata)(index1).noisebyte
                for i=0LL,contg1-1LL do begin
                    printf,1,format='(I15,1x,I3,1x,I4)',index1(i),reject1(i),noisebyte1(i)
                endfor
            endif
            if contG2 gt 0 then begin
                reject2=(*alldata)(index2).reject
                noisebyte2=(*alldata)(index2).noisebyte
                for i=0LL,contg2-1LL do begin
                    printf,1,format='(I15,1x,I3,1x,I4)',index2(i),reject2(i),noisebyte2(i)
                endfor
            endif
            close,1
        endif
        ;************************************************
        ;************ output a file of adj0 values ********************
        ;open a file to save all of the cleaning work for next time processing
        outputfilename=strmid(!currentHFname,0,strlen(!currentHFname)-4)+'_AutoAdj0'+HorV+'.txt'
        index3=where((*alldata).adj0 ne 1.0, contg3)
        if (contG3) gt 0 then begin
            openw,1,outputfilename
            N_particles=long64(contg3)
            printf,1,format='(I15)',N_particles
            adj0=(*alldata)(index3).adj0
            for i=0LL,contg3-1LL do begin
                printf,1,format='(I15,1x,F6.3)',index3(i),adj0(i)
            endfor

            close,1
        endif; endif of if contG3 gt 0
        ;************************************************************************
    endelse
    if HorV eq 'V' then alldataV=alldata else alldataH=alldata
    print,systime(), "done auto clean"

end;  Auto_clean_One_by_Oneparticle, HorV,info,AllOrKps
;*********************************************************************

;************************************************************************

;*********************************************************************
pro Use_in_focus_particles_only, info
    Common  DataBlock,alldataH,alldataV

    ; Mo added this on June 28 2006 to select only the solid particles (in focus) for
    ; all of the processing
    percent=info.infocus.percent

    ;find out how many H particles
    Area=(*alldataH).Area
    Alexei1=(*alldataH).alexei1
    L1n=(*alldataH).L1n
    L5=(*alldataH).L5
    max_circle_area=!pi*(L1n+L5)^2/16.0
    nnnn=n_elements(Area)

    for i=0LL, nnnn-1LL do begin
        ;if Area(i) gt percent*Alexei1(i) and area(i) gt 0.9*max_circle_area(i) $
        ;then (*alldataH)(i).reject=0 else (*alldataH)(i).reject=1
        if ( Area(i) lt percent*Alexei1(i) or  area(i) lt 0.9*max_circle_area(i)) $
            then  (*alldataH)(i).reject=1
    endfor

    ;find out how many V particles
    Area=(*alldataV).Area
    Alexei1=(*alldataV).alexei1
    L1n=(*alldataV).L1n
    L5=(*alldataV).L5
    max_circle_area=!pi*(L1n+L5)^2/16.0
    nnnn=n_elements(Area)

    for i=0LL, nnnn-1LL do begin
        if (Area(i) gt percent*Alexei1(i) or  area(i) lt 0.9*max_circle_area(i)) $
            then (*alldataV)(i).reject=1
    endfor
end;  Use_in_focus_particle_only



pro Is_this_particle_falling_in_bad_pixel, this_PC1, PC1_array, YesOrNo

    done=0
    n_diodes=128.0

    while done eq 0 do begin

        mean1=float(n_elements(PC1_array))/n_diodes
        His=histogram(Pc1_array,binsize=1,min=0,max=127)
        meanHis=mean(His[where(His gt mean1-3.*sqrt(mean1))])
        Threshold= 5.0*sqrt(meanHis)+meanHis > 1.5;  from brad

        index=where(His gt Threshold,ContG)
        n_diodes=n_diodes-ContG

        if ContG gt 0 then begin;   There are bad pixels in the PC1_array.
            index_match=where(index eq This_PC1, contMatch)

            if contMatch eq 1 then  begin ; this particle is falling in the bad pixels.
                YesorNo=1
                done=1
            endif else begin; No match found in this current set of PC1, reduce the PC1 set and do it again.
                ;there are ContG groups of bad pixels. eliminate then all.
                for i=0, contG-1 do begin
                    indextemp=where(PC1_array ne index(i))
                    PC1_new=PC1_array(indextemp)
                    PC1_array=PC1_new
                endfor
            endelse
        endif else begin
            YesOrNO=0;  no Match found, this particle is good. not falling in bad pixels.
            done=1
        endelse
    endwhile

    ;for special need
    if 1 eq 2 then begin
        if YesOrNo eq 1 and contG le 5 then begin
            window,15,xs=720,ys=620

            whitecolor = GetColor("White", !D.Table_Size-2)
            bluecolor = GetColor("Navy", !D.Table_Size-2)
            REDcolor = GetColor("RED", !D.Table_Size-2)

            !P.multi=[0,3,2]
            !P.charsize=1.5

            xxx1=indgen(n_elements(H1))

            Yrange_AB=[0,1.05*max(H1)]
            PLOT,xxx1,H1, COLOR=redColor, XRANGE=xrange_AB,Xstyle = 1,$
                TITLE='Image Center Location Distribution ',YRANGE=yrange_AB,ytitle='Number of Occurrency',$
                pos=[0.07,0.68,0.47,0.97],xmargin=[3,1],xtitle='PC1 (pixel) ',YSTYLE=1,background= whitecolor
            oplot,xxx1,H1*0.0+threshold, color=bluecolor
        endif
    endif ; of if 1 eq 2 then begin.
end;Is_this_particle_falling_in_bad_pixel, this_PC1, PC1_array, YesOrNo




pro Find_allBad_pixels_in_thisPC1group,PC1_array,BadPixel_array
    done=0
    ;;stop
    BadPixel_array=[-9]
    N_diodes=128.0

    while done eq 0 do begin
        meanH=float(n_elements(PC1_array))/n_diodes
        Threshold= (5.0*sqrt(meanH)+meanH) > 1.5;  from brad
        H1=histogram(Pc1_array,binsize=1,min=0,max=128)
        index=where(H1 gt Threshold,ContG)
        n_diodes=n_diodes-ContG; n_diodes is the number of remaining pixels that could be not noisy.

        if ContG gt 0 then begin;   There are bad pixels in the PC1_array.
            BadPixel_array=[BadPixel_array,index]
            ;there are ContG groups of bad pixels. eliminate then all.

            for i=0, contG-1 do begin
                indextemp=where(PC1_array ne index(i),contDD)

                if contDD gt 0 then begin
                    PC1_new=PC1_array(indextemp)
                    PC1_array=PC1_new
                endif else done=1;if contDD=0 means all PC1_array are bad. we can ;stop now.
            endfor
        endif else begin
            done=1
        endelse

        if n_diodes eq 0 then done=1
    endwhile
end;Find_allBad_pixels_in_thisPC1group,PC1_array,BadPixel_array




pro Find_allBad_pixels_in_thisPC1group_brad, PC1_array, BadPixel_array
    ; This rountine finds all Bad particles in the vectors of PC1_array.
    ; output is the BadPixel_array, if any particle's PC1(i) values in this
    ; group matches one of the BadPixel_array elements, then that  particle i
    ; will be considered as noise. badPixel_array=[-9, 26, 105] will means
    ; that pixle 26, 105 is bad.

    done=0
    BadPixel_array=[-9]
    N_diodes=128.0

    while done eq 0 do begin
        mean1=float(n_elements(PC1_array))/n_diodes
        His=histogram(Pc1_array,binsize=1,min=0,max=128)
        indexBQ=where(His gt mean1-3.*sqrt(mean1),cont_Gt33)

        if cont_GT33 lt 32 then meanHis=mean1 else meanHis=mean(His(indexBQ))

        Threshold= (5.0*sqrt(meanhis)+meanhis) > 1.5;  from brad

        index=where(His gt Threshold,ContG)
        n_diodes=n_diodes-ContG; n_diodes is the number of remaining pixels that could be not noisy.

        if ContG gt 0 then begin;   There are bad pixels in the PC1_array.
            BadPixel_array=[BadPixel_array,index]
            ;there are ContG groups of bad pixels. eliminate then all.

            for i=0, contG-1 do begin
                indextemp=where(PC1_array ne index(i),contDD)

                if contDD gt 0 then begin
                    PC1_new=PC1_array(indextemp)
                    PC1_array=PC1_new
                endif else done=1;if contDD=0 means all PC1_array are bad. we can ;stop now.
            endfor
        endif else begin
            done=1
        endelse

        if n_diodes eq 0 then done=1
    endwhile
end ;Find_allBad_pixels_in_thisPC1group_brad,PC1_array,BadPixel_array




;looking for a examples for teh splash paper at where a good particle's Pc1 is teh same
;as the noisy pc1 particles---bad pixels.
pro look_for_a_good_particle_in_a_bad_pc1_array
    Common  DataBlock,alldataH,alldataV

    forward_function SPEC_Nano2HMS

    nnnn=n_elements((*alldataH).tas)

    Nslice=(*alldataH).Nslice
    L5=(*alldataH).L5
    Area=(*alldataH).area
    Alexei1=(*alldataH).alexei1
    roundness=(*alldataH).roundness
    Pc1=(*alldataH).pc1

    outfilename=strmid(!currentHFname,0,strlen(!currentHFname)-4)+'Good_pc1_in_bad_pixel.txt'
    openw, 77, outfilename

    for i=0LL,nnnn-1LL do begin
        ; first see if this particle is good or not,
        ; if it is good then form a pc1 array around it.

        ; lets define a good particle  to be such
        ;  L1 gt 4 and L5 gt 4 and area gt 0.6*alexei1 and roundness eq 1
        good = (Nslice(i) gt 4 and Nslice(i) lt 14 and L5(i) gt 4 and L5(i) lt 14 $
            and area(i) gt 0.75*alexei1(i) and roundness(i) eq 1 )

        if good eq 1 then begin
            start_index= (i -65LL) > 0LL
            end_index=(i+65LL) < nnnn-1LL
            PC1_array=PC1(start_index:end_index)
            ;call a function to see if this particles is falling in the bad pixels of this PC1_array part.
            ;this particle's center position is this_PC1
            This_PC1=PC1(i)
            Is_this_particle_falling_in_bad_pixel,this_PC1, PC1_array, yesOrNo

            If YesOrNo eq 1 then begin
                ; writes out the time stamp of the interval to a file for later plotting use.
                starttime=spec_nano2Hms((*alldataH)(start_index).nanoseconds)
                endtime  =spec_nano2hms((*alldataH)(end_index).nanoseconds)
                this_time=spec_nano2hms((*alldataH)(i).nanoseconds)
                printf,77,format='(A20,2x,A20,2x,A20)', starttime, endtime,this_time
            endif
        endif
    endfor

    close,77
    print,'Done search for good images pc1 falling in a bad pixel location !!!!!'
end ; look_for_a_good_particle_in_a_bad_pc1_array



pro print_out_pc1_array_between_T1_T2, ave_info
    Common  DataBlock,alldataH,alldataV

    forward_function SPEC_Nano2HMS

    START_STRING =  SPEC_Nano2HMS(ave_info.StartNanoSeconds)
    END_STRING =  SPEC_Nano2HMS(ave_info.EndNanoSeconds)
    SE_string = START_STRING +"-" + END_STRING

    index=where((*alldataH).nanoseconds gt ave_info.startnanoseconds and $
        (*alldataH).nanoseconds le ave_info.endnanoseconds,nnnn )

    nanoseconds=(*alldataH)(index).nanoseconds
    pc1=(*alldataH)(index).pc1
    Nslice=(*alldataH)(index).Nslice
    L1n=(*alldataH)(index).L1n
    L5=(*alldataH)(index).L5

    outfilename=strmid(!currentHFname,0,strlen(!currentHFname)-4)+'T1T2_pc1_distribution.txt'
    openw, 78, outfilename
    printf,78,'Pc1 distribution between Time1 and time2: '+start_string+'  '+end_string

    for j=0LL,nnnn-1LL do begin
        printf,78,format='(I15,2x,I3,2x,I5,2x,I5)', nanoseconds(j), Pc1(j),Nslice(j),L5(j)
    endfor

    close,78
    print,'Done search for printing pc1 array from1 Time 1 to time 2  !!!!!'
end ; print_out_pc1_array_between_T1_T2



pro Re_calculate_roundness_N_Get_roundnessThresholds, liqOrice
    Common  DataBlock,alldataH,alldataV

    if liqorice eq 'DontKnow' then begin
        done=0

        while done eq 0 do begin
            myinfo=[['please input your roundness aspect ratio definition:    '],$
                ['                                                        '],$
                [' For liquid:  The aspect ratio should be 2.0,'],$
                ['              which gives 1/2=0.5 and which meanes:     '],$
                ['        if  L1n GE 0.5*L5 and ( L5 GE 0.5*L1n or L5 gt 50 '],$
                ['        then roundness =1'],$
                ['                                                        '],$
                [' For ice: The aspect ration should be 100.0, which gives'],$
                ['          1/100=0.01 and which meanes'],$
                ['        if  L1n GE 0.01*L5 and (L5 GE 0.01*L1n or L5 gt 50)'],$
                ['        then roundness =1'],$
                ['                                                         '],$
                ['********************************************************:']]
            answer=moqixu_textbox(title=myinfo,label='L1_L5_Aspect_Ratio=')
            Aspect_ratio=answer(0)*1.0

            if Aspect_ratio ne 0.00 then begin
                done=1

                if Aspect_ratio lt 1.0 then begin
                    rrr=dialog_message('Ratio not valid, I changed it to be 1, is that OK ?',/question)
                    if rrr eq 'Yes' then Aspect_ratio=1.0 else done=0
                endif

                !roundness_threshold1=1.0/Aspect_ratio
                !roundNess_threshold2=50.0
            endif
        endwhile

        if Aspect_ratio ne 2.0 then begin; ;re-calculate the roundness of all H and V particles.
            Nslice=(*alldataH).Nslice
            L5=(*alldataH).L5
            ;roundness=(L1 gt 0.49*L5) and (L5 gt 0.49*L1 or L5  gt 50) ;  50 is 50 pixels.
            roundness=(Nslice ge !roundness_threshold1*L5) and $
                (L5 ge !roundness_threshold1*Nslice or L5  gt !roundness_threshold2)
            (*alldataH).roundness=roundness*1.0

            Nslice=(*alldataV).Nslice
            L5=(*alldataV).L5
            roundness=(Nslice ge !roundness_threshold1*L5) and $
                (L5 ge !roundness_threshold1*Nslice or L5  gt !roundness_threshold2)
            (*alldataV).roundness=roundness*1.0
        endif
    endif else begin;  This part is for automatic archive. else it never reach here.
        if liqOrice eq 'liq' then Aspect_ratio=2.0
        if liqOrice eq 'ice' then Aspect_ratio=100.0

        !roundness_threshold1=1.0/Aspect_ratio
        L1n=(*alldataH).L1n
        Nslice=(*alldataH).Nslice
        L5=(*alldataH).L5
        ;roundness=(L1 gt 0.49*L5) and (L5 gt 0.49*L1 or L5  gt 50) ;  50 is 50 pixels.
        roundness=(Nslice ge !roundness_threshold1*L5) and $
            (L5 ge !roundness_threshold1*Nslice or L5  gt !roundness_threshold2)
        (*alldataH).roundness=roundness*1.0

        L1n=(*alldataV).L1n
        Nslice=(*alldataV).Nslice
        L5=(*alldataV).L5
        roundness=(Nslice ge !roundness_threshold1*L5) and $
            (L5 ge !roundness_threshold1*Nslice or L5  gt !roundness_threshold2)
        (*alldataV).roundness=roundness*1.0
    endelse
end ; Re_calculate_roundness_N_Get_roundnessThresholds, liqOrice



pro get_total_deadtime_by_ACCDT_between_Tick1tick2,HorV,tick1,B4index1,tick2,B4index2,total_Deadtime
    Common  DataBlock,alldataH,alldataV

    if HorV eq 'H' then alldata = alldataH else alldata = alldataV

    case (*alldata)(B4index1).area of ; this deadT1 is extra deadtime.
        -100:  deadT1=tick1-(*alldata)(B4index1).probecounter
        -102:  deadT1=tick1-(*alldata)(B4index1).probecounter
        -105:  deadT1=tick1-(*alldata)(B4index1).probecounter
        -107:  deadT1=tick1-(*alldata)(B4index1).probecounter
        -109:  deadT1=tick1-(*alldata)(B4index1).probecounter
        else:  deadT1=0.0
    endcase

    case (*alldata)(B4index2).area of ; this deadT2 is what it should be added.
        -100:  deadT2=tick2-(*alldata)(B4index2).probecounter
        -102:  deadT2=tick2-(*alldata)(B4index2).probecounter
        -105:  deadT2=tick2-(*alldata)(B4index2).probecounter
        -107:  deadT2=tick2-(*alldata)(B4index2).probecounter
        -109:  deadT2=tick2-(*alldata)(B4index2).probecounter
        else:  deadT2=0.0
    endcase

    total_deadTime=long64((*alldata)(B4index2).accDTTick)-long64((*alldata)(B4index1).accDTTick)-deadT1+deadT2

end;get_total_deadtime_by_ACCDT_between_Tick1tick2,tick1,B4index1,tick2,B4index2,total_Deadtime
