Pro correct_L1_adj1_IF_TAS_GT_170_MPS;  on Nov 11, 2007
    Common  DataBlock,alldataH,alldataV
    ;this program takes input data files: DC8_xxaug_*navhskeep.txt or TAS tms files
    ; and compares 2dsview each particles time to see if (*alldataH)V.tas is over the limits
    ; of 170ms.  If it is, correct that L1 and adj1 values. if not leave it alone.

    pxs = 0.01;                pxs_in_microns = 10.0
    dww = !DWW_main; 63.0mm in 2D-S, 50.8 mm in 3V-CPI adjust in a3VCPIView.pro
    sa_default = 128.0 * pxs *  dww
    ;sa_actual = (127.0 + particle_in_microns/pxs_in_microns) * pxs * min([dww,dof])


    read_dc8_time_series,pathnm,DC8_TMS_data,filenameDC8

    HKseconds=DC8_TMS_data.seconds*1LL
    HKfactor    =(DC8_TMS_data.tas/170.0)> 1.0

    ; first for H-channel data

    index=where((*alldataH).TAS ge 170 and (*alldataH).area gt 0.0, contG)
    if contG gt 0 then begin; there is a need to correct the L1 and adj1 values.

        for i=0LL,contG-1LL do begin
            this_time=float((*alldataH)(index(i)).nanoseconds)/1000000000.0
            indx8=where(HKseconds ge this_time and HKseconds le this_time+1.0,contN)
            if contN gt 0 then begin; at the begining, L1n is assigned teh same as Nslice.

                factor= HKfactor(index8(0));    (HKtas(indx8(0))/170.0) > 1.0

                This_L1n=((*alldataH)(index(i)).Nslice+randomu(seed)-0.5)*factor

                (*alldataH)(index(i)).L1n    =This_L1n
                (*alldataH)(index(i)).area   =(*alldataH)(index(i)).area*factor
                (*alldataH)(index(i)).alexei1=(*alldataH)(index(i)).alexei1*factor

                ;now re-calculated adj1 values.
                particle_in_microns = This_L1n * 10
                dof = (5.13 * particle_in_microns * particle_in_microns) / 1000.0D ;; convert to mm
                sa_actual = (127.0 + This_L1n) * pxs * min([dww,dof])
                (*alldataH)(index(i)).adj1= sa_default/sa_actual
            endif
        endfor
        stop
    endif

    ;************************************************

    ; last for V-channel data

    index=where((*alldataV).TAS ge 170. and (*alldataV).area gt 0.0 , contG)
    if contG gt 0 then begin; there is a need to correct the L1 and adj1 values.
        for i=0LL,contG-1LL do begin
            this_time=float((*alldataV)(index(i)).nanoseconds)/1000000000.0
            indx8=where(HKseconds ge this_time and HKseconds le this_time+1.0,contN)
            if contN gt 0 then begin; at the begining,

                factor=HKfactor(index8(0)); ( HKtas(indx8(0))/170.0) > 1.0

                This_L1n=((*alldataV)(index(i)).Nslice+randomu(seed)-0.5)*factor

                (*alldataV)(index(i)).L1n    =This_L1n
                (*alldataV)(index(i)).area   =(*alldataV)(index(i)).area*factor
                (*alldataV)(index(i)).alexei1=(*alldataV)(index(i)).alexei1*factor

                ;now re-calculated adj1 values.
                particle_in_microns = This_L1n * 10
                dof = (5.13 * particle_in_microns * particle_in_microns) / 1000.0D ;; convert to mm
                sa_actual = (127.0 + This_L1n) * pxs * min([dww,dof])
                (*alldataV)(index(i)).adj1= sa_default/sa_actual
            endif
        endfor
        stop
    endif; ;end of V-channel L1 adj1 correction.

    ;print,'Done combine TC4_2d_caps_data !!!'
end; Correct_L1_adj1_by_TAS_GT_170_MPS.pro

;****************************************************************
;***********************************************************
;********************************************************************
pro read_in_WB57_navigation_data,pathnm, WB57_NAV_data
    filename=dialog_pickfile(filter='FT*.WB57',path=pathnm)
    ;find out how many line is in the file.
    data=read_ascii(filename,count=n_lines)
    nnnseconds=(n_lines-29)
    junk=strarr(29);  here are 29 header lines.
    openr,2,filename
    readf,2,junk
    Data={seconds:0LL,$
        Lat:0.0,$
        Lon:0.0,$
        Pressure:0.0,$; mb
        TmpPort:0.0,$
        TmpStar:0.0,$
        TAS:0.0,$; TAS m/s
        GPS_Alt:0.0,$
        WindSpd:0.0,$
        WindDir:0.0}

    WB57_Nav_Data=replicate(data,nnnseconds)
    readf,2,WB57_Nav_Data
    close,2
end
;********************************************************************

pro get_WB57_Nav_data_at_this_second,This_second,WB57_Nav_data,lat,lon,tempT,TAS,pressure
    seconds=WB57_Nav_data.seconds
    index=where(seconds eq this_second,contG)
    if contG gt 0 then begin
        lat=WB57_Nav_data.lat(index(0))
        lon=WB57_Nav_data.lon(index(0))
        tempT=WB57_Nav_data.tempT(index(0))
        TAS=WB57_Nav_data.Tas(index(0))
        Pressure=WB57_Nav_data.pressure(index(0))
    endif else begin
        lat=9999.9; WB57_Nav_data(index(0)).lat
        lon=9999.9;WB57_Nav_data(index(0)).lon
        tempT=9999.9; WB57_Nav_data(index(0)).tempPort
        TAS=9999.9;WB57_Nav_data(index(0)).Tas
        Pressure=9999.9; WB57_Nav_data(index(0)).presure
    endelse
end
;********************************************************************************
pro du_input_Crave_WB57_nav_data,pathnm,WB57_Nav_data

    filename=dialog_pickfile(filter='*ASC.txt',path=pathnm)
    ;find out how many line is in the file.
    data=read_ascii(filename,count=n_lines)
    nnnseconds=(n_lines-3LL)
    nnn=long(n_lines)-3L
    openR,1,filename
    dummy='ab'
    readF,1,format='(A//)',dummy; read a and then skip 3 lines.
    ;assign arrays for the readin parameters
    seconds =lonarr(nnn)
    lat     =fltarr(nnn)
    lon     =fltarr(nnn)
    pressure     =fltarr(nnn)
    tas     =fltarr(nnn)
    tempT    =fltarr(nnn)
    tempT1    =fltarr(nnn)
    tempT2    =fltarr(nnn)
    tempT3    =fltarr(nnn)


    for i=0L,long(nnn)-1L do begin
        ;read one line at a time.
        thisline='abcdefg'
        readF,1,format='(1A)',thisline;   ; the line conains following parameters.
        ;year,mmddhhmmss,roinumber,arrtime,ts,deadTime,length,width,areaA,perimP,$
        ;Rndness, Focus, Cutoff, Crystal, P1, Inten_Hole, HrmCnt, h1, h2, h3,$
        ;h4, h5, h6, SX, SX, EX, EY
        S = STRSPLIT(thisline,/EXTRACT)
        HHmmss=S[0]
        substrs=strsplit(HHMMSS,':',/extract)
        seconds(i)=substrs(1)*3600LL+substrs(2)*60LL + substrs(3)*1LL
        LatSign=S(1)
        LatV    =S(2)
        LonSign =S(3)
        LonV    =S(4)
        if LatSign eq 'S' then Lat(i)=LatV*(-1.0) else Lat(i)=LatV*1.0
        if LonSign eq 'W' then Lon(i)=LonV*(-1.0) else Lon(i)=LonV*1.0
        TempT(i)=S(28)*1.0
        Pressure(i)=S(29)*1.0
        tas(i)= S(31)*1.0
        ;TempT1(i)=S(27)*1.0
        ;TempT2(i)=S(26)*1.0
        ;TempT3(i)=S(25)*1.0

    endfor

    close,1
    window,/free,ysize=72*7.5,xsize=72*10
    !P.thick=1
    !P.CHARSIZE=1
    !P.multi=[0,1,1]
    loadct,0
    white=!D.N_COLORS-1
    !P.BACKGROUND=white
    plot,tempT,color=0,yrange=[-80, 50],title='Temperature'

    window,/free,ysize=72*7.5,xsize=72*10
    plot,Tas,color=0,yrange=[0, 220],title='TAS'

    window,/free,ysize=72*7.5,xsize=72*10
    plot,Pressure,color=0,yrange=[0, 20000],title='Pressure'


    window,/free,ysize=72*7.5,xsize=72*10
    plot,Lat,color=0,yrange=[-20, 20],title='Latitude'

    window,/free,ysize=72*7.5,xsize=72*10
    plot,Lon,color=0,yrange=[-90, -50],title='Longtitude'


    ;assign the data into WB57_Nav_data structure
    WB57_nav_data={seconds:seconds,Tas:tas,Pressure:pressure,lat:lat,lon:lon,tempT:tempT}
    print,'Done reading CRave WB57 NAV data  !!!!!'

end
;****************************************************************************
pro read_dc8_time_series,pathnm,DC8_TMS_data,filenameDC8
    ; if n_elements(pathnm) eq 1 then begin
    ; filenameDC8=dialog_pickfile(filter='DC8_TC4*.astxt',path=pathnm)
    ;endif else  filenameDC8=dialog_pickfile(filter='DC8_TC4*.astxt',get_path=pathnm)
    pos= STRPOS(!currentHPname,'\',2, /REVERSE_OFFSET,/REVERSE_SEARCH )
    sorted_Fpath=strmid(!currentHPname,0,pos); ;=c:\tc4_data\Flight1\2ds
    filenameDC8=dialog_pickfile(filter='DC8_TC4*.astxt',path=sorted_Fpath+'\')
    if n_elements(filenameDC8) eq 0 then begin
        rrr=dialog_message([['An TAS Time series file is needed for correcting the L1 size.'],$
            ['If there is no such a file, Then no L1 TAS correction will be done.'],$
            [' do you want to continue ?']],/question)
        if rrr eq 'Yes' then begin
            Data={day:0LL,time:0.0,$
                seconds:0LL,Lat:0.0,lon:0.0,TAS:0.0,Heading:0.0,Altitude:0.0,RadarAlt:0.0,DewPT1:0.0,$
                DewPT2:0.0,Temp:0.0,StaticTemp:0.0,Pressure:0.0,RHDice:0.0,RHDwater:0.0,$
                SVaporPwater:0.0,SVaporPice:0.0}
            return
        endif else begin
            print,' Get a TAS data file first, and then restart again !'
            stop
        endelse
    endif; end of if no DC8 TAS file is selected.


    ;find out how many line is in the file.
    data=read_ascii(filenameDC8,count=n_lines)
    nnnseconds=(n_lines-2)
    junk=strarr(2)
    openr,2,filenameDC8
    readf,2,junk
    Data={day:0LL,time:0.0,$
        seconds:0LL,Lat:0.0,lon:0.0,TAS:0.0,Heading:0.0,Altitude:0.0,RadarAlt:0.0,DewPT1:0.0,$
        DewPT2:0.0,Temp:0.0,StaticTemp:0.0,Pressure:0.0,RHDice:0.0,RHDwater:0.0,$
        SVaporPwater:0.0,SVaporPice:0.0}
    DC8_TMS_Data=replicate(data,nnnseconds)
    readf,2,DC8_TMS_Data
    close,2

    if 1 eq 1 then begin
        TempT=DC8_TMS_data.Temp
        pressure=DC8_TMS_data.Temp
        Lat=DC8_TMS_data.Lat
        Lon=DC8_TMS_data.Lon
        Tas=DC8_TMS_data.tas
        time=DC8_TMS_data.time/3600.0
        window,/free,ysize=72*7.5,xsize=72*10
        bluecolor =GetColor("Navy", !D.Table_Size-2)
        redcolor = GetColor("Red", !D.Table_Size-2)
        whitecolor =GetColor("White", !D.Table_Size-2)
        erase,color='ffffff'x  ; get background to white
        !P.thick=1
        !P.CHARSIZE=1
        !P.multi=[0,1,1]

        ;plot,tempT,color=0,yrange=[-80, 50],title='Temperature'

        ;window,/free,ysize=72*7.5,xsize=72*10
        plot,time,Tas,color=bluecolor,yrange=[0, 250],title='HK TAS'
        oplot,time,TAS*0.0+170,color=redcolor
        wait,2.0
        pathname=sorted_Fpath+'\'

        write_png,pathname+'HK_tas.png',tvrd(true=1)
        ;window,/free,ysize=72*7.5,xsize=72*10
        ;plot,Pressure,color=0,yrange=[0, 20000],title='Pressure'


        ;window,/free,ysize=72*7.5,xsize=72*10
        ;plot,Lat,color=0,yrange=[-20, 20],title='Latitude'

        ;window,/free,ysize=72*7.5,xsize=72*10
        ;plot,Lon,color=0,yrange=[-90, -50],title='Longtitude'
    endif

    print,'Done reading TC4_DC8 DC8 NAV data  !!!!!'

end



pro get_dc8_TAS_time_series, info, Kth, HKseconds, HKtas
    sorted_Fpath=info.currentPname;   ;='C:\DC8_Test_L1n\'
    whole_path_filter=sorted_Fpath+'*.astxt'
    filenameDC8=findfile(whole_path_filter,COUNT=File_count)

    if Kth eq 0 then begin
        DataKstr="Data\"
        FILE_MKDIR,sorted_Fpath + DataKstr
        TAS_filename=sorted_Fpath+'TasFile_Used_For_L1n.txt'
    endif else begin
        DataKstr="Data"+strtrim(string(Kth),2)+"\"
        FILE_MKDIR,sorted_Fpath + DataKstr
        TAS_filename=sorted_Fpath+ DataKstr +'TasFile_Used_For_L1n.txt'
    endelse

    if file_count ne 1 then begin
        ;rrr=dialog_message([['An TAS Time series file  for the whole flight day is needed for correcting the L1 size.'],$
        ;                    ['If there is no such a file, Then no L1 TAS correction will be done.'],$
        ;                    [' do you want to continue ?']],/question)
        rrr='Yes'

        if rrr eq 'Yes' then begin
            openw,5,TAS_filename
            printf,5,'NO TAS data file is used for L1n calculation'
            close,5
            HKseconds=[0LL, 0LL]
            HKtas=[100.0,100.0]
            return
        endif else begin
            print,' Get a TAS data file first, and then restart again !'
            stop
        endelse
    endif; end of if No DC8 TAS fiel is found or there are too many such files

    ;*****************************************************
    openw,5,TAS_filename
    printf,5,'The TAS data file used for L1n calculation is: '
    printf,5,format='(A)',filenameDC8
    close,5

    ;find out how many line is in the file.
    data=read_ascii(filenameDC8,count=n_lines)
    nnnseconds=(n_lines-2)
    junk=strarr(2)
    openr,2,filenameDC8
    readf,2,junk
    Data={day:0LL,time:0.0,$
        seconds:0LL,Lat:0.0,lon:0.0,TAS:0.0,Heading:0.0,Altitude:0.0,RadarAlt:0.0,DewPT1:0.0,$
        DewPT2:0.0,Temp:0.0,StaticTemp:0.0,Pressure:0.0,RHDice:0.0,RHDwater:0.0,$
        SVaporPwater:0.0,SVaporPice:0.0}
    DC8_TMS_Data=replicate(data,nnnseconds)
    readf,2,DC8_TMS_Data
    close,2

    HKTas=DC8_TMS_data.tas*1.0
    HKseconds=DC8_TMS_data.seconds*1LL
    index=where(HKTas gt 30.0,contG)
    if contG gt 0 then begin
        startindex=index(0)
        endindex  =index(contG-1)
    endif else begin
        startindex=0
        endindex=n_elements(HKtas)-1LL
    endelse

    HKtas_Use=HKtas(startindex:endindex)
    HKseconds_use=HKseconds(startindex:endindex)

    if Kth eq 0 or Kth eq 1 then begin
        window,/free,ysize=72*7.5,xsize=72*10
        bluecolor =GetColor("Navy", !D.Table_Size-2)
        redcolor = GetColor("Red", !D.Table_Size-2)
        whitecolor =GetColor("White", !D.Table_Size-2)
        erase,color='ffffff'x  ; get background to white
        !P.thick=1
        !P.CHARSIZE=1
        !P.multi=[0,1,1]
        fullrange =long64(max(HKseconds_use)-HKseconds_use(0))*1000000000LL
        binwidth = fullrange/8LL
        curbin = long64(HKseconds_Use(0))*1000000000LL
        tnames = StrArr(9)

        FOR i=0,8 DO BEGIN
            tnames(i) =  strtrim(strmid(SPEC_Nano2HMS(curbin),0,8),2)
            curbin += binwidth
        ENDFOR

        ;-------------------------------
        ;Set up X axis tick labels.
        ;-------------------------------
        !X.TICKNAME = tnames
        !X.TICKS = 8

        ;window,/free,ysize=72*7.5,xsize=72*10
        plot,HKTas_use,color=bluecolor,yrange=[0, 250],title='TAS Time Series From Aircraft',$
            background=whitecolor,xtitle='Time (hhmmss)',ytitle='TAS, m/s'
        oplot,HKTAS_use*0.0+170,color=redcolor
        wait,1.0
        write_png,info.currentPname+'Tas_time_series_from_aircraft.png',tvrd(true=1)
    endif

    print,'Done reading TC4_DC8 DC8 NAV data for L1n, Adj1, Area and Alexei1 correction !!!!!'

end;  get_dc8_TAS_TMS_data



pro  get_dc8_NAV_data_Values,DC8_TMS_data,startseconds,DC8_16values,$
    lat,lon,Tas,tempT,pressure,RHumD,altitude,dewPt1
indexdc8=where(DC8_TMS_data.seconds eq startseconds, contG); DC8_data for the second.
DC8_16values=fltarr(16)
if contG gt 0 then begin
    DC8_16Values(0)=DC8_TMS_data(indexdc8(0)).seconds
    DC8_16Values(1)=DC8_TMS_data(indexdc8(0)).lat
    DC8_16Values(2)=DC8_TMS_data(indexdc8(0)).lon
    DC8_16Values(3)=DC8_TMS_data(indexdc8(0)).TAS
    DC8_16Values(4)=DC8_TMS_data(indexdc8(0)).heading
    DC8_16Values(5)=DC8_TMS_data(indexdc8(0)).altitude
    DC8_16Values(6)=DC8_TMS_data(indexdc8(0)).radaralt
    DC8_16Values(7)=DC8_TMS_data(indexdc8(0)).dewPt1
    DC8_16Values(8)=DC8_TMS_data(indexdc8(0)).dewpT2
    DC8_16Values(9)=DC8_TMS_data(indexdc8(0)).temp
    DC8_16Values(10)=DC8_TMS_data(indexdc8(0)).staticTemp
    DC8_16Values(11)=DC8_TMS_data(indexdc8(0)).pressure
    DC8_16Values(12)=DC8_TMS_data(indexdc8(0)).RHDice
    DC8_16Values(13)=DC8_TMS_data(indexdc8(0)).RHDwater
    DC8_16Values(14)=DC8_TMS_data(indexdc8(0)).sVaporPwater
    DC8_16Values(15)=DC8_TMS_data(indexdc8(0)).sVaporPice
    lat=DC8_16Values(1)
    lon=DC8_16Values(2)
    Tas=DC8_16Values(3)
    tempT=DC8_16Values(9)
    pressure=DC8_16Values(11)
    RHumD=DC8_16Values(13)
    altitude=DC8_TMS_data(indexdc8(0)).altitude
    dewPt1=DC8_16Values(7);=DC8_TMS_data(indexdc8).dewPt1
endif else begin
    lat=DC8_16Values(1)
    lon=DC8_16Values(2)
    Tas=DC8_16Values(3)
    tempT=DC8_16Values(9)
    pressure=DC8_16Values(11)
    RHumD=DC8_16Values(13)
    altitude=DC8_16Values(5)
    dewPt1=DC8_16Values(7)
endelse
end

;************************************************************************************

;*********************************************************************
pro Find_how_many_lines_in_this_file,infilename,nlines
    ;infilename='C:\0namma\Combine_2ds_caps_April_2007\Namma_caps_20060823_2D_psd.txt'
    nlines=0LL
    S='abd'
    openr,1,infilename
    while ~ EOF(1) do begin
        readF,1,S
        nlines=nlines+1LL
    endwhile
    close,1
end;Find_how_many_lines_in_this_file,infilename,nlines

;*****************************************************

;*****************************************************
pro get_SV_Tas_correction_factor,starttime,endTime,Tas_factor
    Common  HKdatablock,HKseconds,HKtas,num_hrz_dect,num_vrt_dect,pHKtimefpos

    StartS=floor(startTime/1000000000.0)
    EndS  = ceil(  EndTime/1000000000.0)
    index=where(HKseconds ge startS and HKseconds Le EndS and HKtas gt 170.0,contG)
    if contG gt 0 then begin;  There is ContG seconds in which TAS is greater than 170 m/s.
        Tas_factor=(mean(HKtas(index))/170.0) >1.0
    endif else Tas_factor=1.0
end; get_SV_Tas_correction_factor,factor,starttime,endTime,HKTas,HKseconds
;*********************************************************************************

;*********************************************************************************
