;*****************************************************************
pro load_fssp_2dc_files, pstateinfo

    if (*pstateinfo).fsspdata.filename eq ' ' then begin
        ;get the preface name:
        str1='please pick a fssp data file'

        fsspfilename=dialog_pickfile(title=str1,filter='*fssp2dc1Hz.txt',path=(*pstateinfo).path)
        ;bail out if user clicked cancel
        if (fsspFileName[0] eq '') then begin
            r=dialog_message('Addfssp2dc canceled, do normal psd.',/information)
            return
        endif
        (*pstateinfo).fsspdata.filename =fsspfilename
        (*pstateinfo).twodcdata.filename=fsspfilename


        ;read in the fsspdata and 2dc bin numbers and bin centers and bin-widths
        data=read_ascii(fsspfilename,data_start=1,NUM_records=1)
        result=data.field1
        nfsspbins=result(0)

        data=read_ascii(fsspfilename,data_start=2,NUM_records=1)
        result=data.field1
        ntwodcbins=result(0)

        data=read_ascii(fsspfilename,data_start=3,NUM_records=1)
        ;thistag=tag_names(data)
        result=data.field001
        fsspbins=result(1:nfsspbins)
        twodcbins=result(nfsspbins+1:nfsspbins+ntwodcbins)

        data=read_ascii(fsspfilename,data_start=4,NUM_records=1)
        result=data.field001
        fsspbwds=result(1:nfsspbins)
        twodcbwds=result(nfsspbins+1:nfsspbins+ntwodcbins)

        ;readin the psd data and time
        ; data=read_ascii(fsspfilename,data_start=5)
        ; result=data.field001
        ; stop
        ; spp_secs_oyr=result(0,*)  ; this should be long integers  ajn 4th 2005
        ;above three line should be replace with read_ascii_template reading methods. Janueary4, 2005.
        ;*********************************************************************************
        fssp2dc_templi=ascii_template(fsspfilename)
        fssp2dcdata=read_ascii(fsspfilename,template=fssp2dc_templi)
        spp_secs_oyr=fssp2dcdata.(0)
        nnnseconds=n_elements(spp_secs_oyr)

        fieldnames=tag_names(fssp2dcdata)
        nnncolumns=n_elements(fieldnames)
        result=fltarr(nnncolumns,nnnseconds)

        for i=1,nnncolumns-1 do result(i,*)=fssp2dcdata.(i);    only assign the binhs. first column=0.0
        ;  stop
        ;**********************************************************************************
        ; nnnseconds=n_elements(spp_secs_oyr)

        fsspbinh=result[1:nfsspbins,*]
        twodcN   =result[nfsspbins+1:nfsspbins+ntwodcbins,*]
        twodcA =result[1+nfsspbins+ntwodcbins:nfsspbins+ntwodcbins+ntwodcbins,*]
        twodcM =result[1+nfsspbins+ntwodcbins+ntwodcbins:nfsspbins+ntwodcbins+ntwodcbins+ntwodcbins,*]

        ; now assign the values to the pstateinfo
        (*pstateinfo).fsspdata.time=ptr_new(Lonarr(nnnseconds))
        *(*pstateinfo).fsspdata.time=spp_secs_oyr
        (*pstateinfo).fsspdata.bwd =ptr_new(fltarr(nfsspbins))
        *(*pstateinfo).fsspdata.bwd =fsspbwds
        (*pstateinfo).fsspdata.bins=ptr_new(fltarr(nfsspbins))
        *(*pstateinfo).fsspdata.bins=fsspbins
        (*pstateinfo).fsspdata.binh=ptr_new(fltarr(nnnseconds,nfsspbins));   ???? float ? jan4, 2005.
        *(*pstateinfo).fsspdata.binh=fsspbinh

        ;  stop
        ;assign the twodc data to the pstateinfo.
        doub_bin_edges=fltarr(2*ntwodcbins)
        doub_bin_edges(0)=twodcbins(0)-twodcbwds(0)/2.0
        for i=1,ntwodcbins-1 do doub_bin_edges(2*i-1:2*i)=twodcbins(i)-twodcbwds(i)/2.0
        doub_bin_edges(2*ntwodcbins-1)=twodcbins(ntwodcbins-1)+twodcbwds(ntwodcbins-1)/2.0

        (*pstateinfo).twodcdata.time=ptr_new(Lonarr(nnnseconds))
        *(*pstateinfo).twodcdata.time=spp_secs_oyr
        (*pstateinfo).twodcdata.bwd=ptr_new(fltarr(ntwodcbins))
        *(*pstateinfo).twodcdata.bwd=twodcbwds
        (*pstateinfo).twodcdata.bins=ptr_new(fltarr(2*ntwodcbins))
        *(*pstateinfo).twodcdata.bins=doub_bin_edges   ;PMSbins
        (*pstateinfo).twodcdata.binh=ptr_new(fltarr(nnnseconds,ntwodcbins))
        *(*pstateinfo).twodcdata.binh=TWODCN
        (*pstateinfo).twodcdata.Abinh=ptr_new(fltarr(nnnseconds,ntwodcbins))
        *(*pstateinfo).twodcdata.Abinh=TWODCA
        (*pstateinfo).twodcdata.Mbinh=ptr_new(fltarr(nnnseconds,ntwodcbins))
        *(*pstateinfo).twodcdata.Mbinh=TWODCM

    endif; end of if  twodcfilename eq ' '

end;  end of load_fssp_2dc_files,localstate
;*************************************************************
pro du_input_SPP100log,filenm,SPPdata
    ;subroution to input the XF SPP data    July 6 2004
    ;filenm = dialog_pickfile(title='pls pick a Dir & Click a file',filter='*.txt',Get_path=pathnm)
    ;first generate a example data file of 2 lines that is the
    yyy=read_ascii(filenm,count=nnnp2)
    nnn=nnnp2-2
    a=lonarr(nnn)
    b=lonarr(nnn)
    data={field01:a,field02:b,field03:b,field04:b,field05:b,field06:b,field07:b,field08:b,field09:b,field10:b,$
        field11:b,field12:b,field13:b,field14:b,field15:b,field16:b,field17:b,field18:b,field19:b,field20:b,$
        field21:b,field22:b,field23:b,field24:b,field25:b,field26:b,field27:b,field28:b,field29:b,field30:b,$
        field31:b,field32:b,field33:b,field34:b,field35:b,field36:b}
    print,'Open and reading XF SPP100log.txt file, please wait ......about 1 minute '
    openR,1,filenm
    Thisline='abcd'
    readF,1,format='(1A)',thisline
    readF,1,format='(1A)',thisline; skip 2 lines of header lines.

    for i=0,nnn-1 do begin
        readF,1,format='(1A)',thisline
        S = STRSPLIT(thisline, ' ', /EXTRACT)
        for j=1,9 do begin
            numberstr='0'+strtrim(string(j),2)+'('+string(i)+')'
            namestr='data.field'+numberstr+'=S('+string(j-1)+')'
            Result = EXECUTE(namestr)
        endfor
        for j=10,36 do begin
            numberstr=strtrim(string(j),2)+'('+string(i)+')'
            namestr='data.field'+numberstr+'=S('+string(j-1)+')'
            Result = EXECUTE(namestr)
        endfor

    endfor;  endfor i
    close,1

    ;define sppdata.field01 structure
    sppdata={field01:lonarr(36,nnn)}
    for i=0,8 do begin
        numberstr=string(i)+',*)'
        namestr='sppdata.field01('+ numberstr +'=data.field0'+strtrim(string(i+1),2)
        Result = EXECUTE(namestr)
    endfor
    for i=9,35 do begin
        numberstr=string(i)+',*)'
        namestr='sppdata.field01('+ numberstr +'=data.field' +strtrim(string(i+1),2)
        Result = EXECUTE(namestr)
    endfor
end;   ;end of du_input_spp100log.pro
;**************************************************************************************
pro du_input_CAPSdata,filenm,CAPSdata
    ;subroution to CAPS data    June 30 2004
    ;CAPStempli=ascii_template(filenm)
    ;print,'please be patient, I will read the data now'
    ;CAPSdata=read_ascii(filenm,template=CAPStempli)
    ;secs_oyr=CAPSdata.(0)
    data=read_ascii(filenm,data_start=1)
    ncol=n_elements(data.field01(*,0))
    nrow=n_elements(data.field01(0,*))
    if ncol eq 93 then begin  ; that is XF  case
        a=lonarr(nrow)
        b=fltarr(nrow)
        CAPSdata={field01:a,field02:b,field03:b,field04:b,field05:b,field06:b,field07:b,field08:b,field09:b,field10:b,$
            field11:b,field12:b,field13:b,field14:b,field15:b,field16:b,field17:b,field18:b,field19:b,field20:b,$
            field21:b,field22:b,field23:b,field24:b,field25:b,field26:b,field27:b,field28:b,field29:b,field30:b,$
            field31:b,field32:b,field33:b,field34:b,field35:b,field36:b,field37:b,field38:b,field39:b,field40:b,$
            field41:b,field42:b,field43:b,field44:b,field45:b,field46:b,field47:b,field48:b,field49:b,field50:b,$
            field51:b,field52:b,field53:b,field54:b,field55:b,field56:b,field57:b,field58:b,field59:b,field60:b,$
            field61:b,field62:b,field63:b,field64:b,field65:b,field66:b,field67:b,field68:b,field69:b,field70:b,$
            field71:b,field72:b,field73:b,field74:b,field75:b,field76:b,field77:b,field78:b,field79:b,field80:b,$
            field81:b,field82:b,field83:b,field84:b,field85:b,field86:b,field87:b,field88:b,field89:b,field90:b,$
            field91:b,field92:b,field93:b}
        ;assign the numbers
        for j=2,9 do begin
            numberstr='0'+strtrim(string(j),2)
            namestr='CAPSdata.field'+numberstr+'=data.field01('+string(j-1)+',*)'
            Result = EXECUTE(namestr)
        endfor
        for j=10,93 do begin
            numberstr=strtrim(string(j),2)
            namestr='CAPSdata.field'+numberstr+'=data.field01('+string(j-1)+',*)'
            Result = EXECUTE(namestr)
        endfor
        openR,1,filenm
        Thisline='abcd';  skip teh first line
        readF,1,format='(1A)',thisline

        for i=0,nrow-1 do begin
            readF,1,format='(1A)',thisline
            S = STRSPLIT(thisline, ' ', /EXTRACT)
            CAPSdata.field01(i)=long(S(0))
        endfor;  endfor i
        close,1
    endif

    if ncol eq 71 then begin ; that is MidCIX case
        a=lonarr(nrow)
        b=fltarr(nrow)
        CAPSdata={field01:a,field02:b,field03:b,field04:b,field05:b,field06:b,field07:b,field08:b,field09:b,field10:b,$
            field11:b,field12:b,field13:b,field14:b,field15:b,field16:b,field17:b,field18:b,field19:b,field20:b,$
            field21:b,field22:b,field23:b,field24:b,field25:b,field26:b,field27:b,field28:b,field29:b,field30:b,$
            field31:b,field32:b,field33:b,field34:b,field35:b,field36:b,field37:b,field38:b,field39:b,field40:b,$
            field41:b,field42:b,field43:b,field44:b,field45:b,field46:b,field47:b,field48:b,field49:b,field50:b,$
            field51:b,field52:b,field53:b,field54:b,field55:b,field56:b,field57:b,field58:b,field59:b,field60:b,$
            field61:b,field62:b,field63:b,field64:b,field65:b,field66:b,field67:b,field68:b,field69:b,field70:b,$
            field71:b}

        ;assign the numbers
        for j=2,9 do begin
            numberstr='0'+strtrim(string(j),2)
            namestr='CAPSdata.field'+numberstr+'=data.field01('+string(j-1)+',*)'
            Result = EXECUTE(namestr)
        endfor
        for j=10,71 do begin
            numberstr=strtrim(string(j),2)
            namestr='CAPSdata.field'+numberstr+'=data.field01('+string(j-1)+',*)'
            Result = EXECUTE(namestr)
        endfor
        openR,1,filenm
        Thisline='abcd';  skip teh first line
        readF,1,format='(1A)',thisline

        for i=0,nrow-1 do begin
            readF,1,format='(1A)',thisline
            S = STRSPLIT(thisline, ' ', /EXTRACT)
            CAPSdata.field01(i)=long(S(0))
        endfor;  endfor i
        close,1
    endif

end;  ;end of du_input_capsdata
;*************************************************************************

;***************************************************************************
pro get_bin_edges,bwds,bins,binedges
    nbins=n_elements(bins)
    binedges=fltarr(2*nbins)
    binedges(0)=bins(0)-bwds(0)/2.0
    for i=0,nbins-2 do begin
        binedges(2*i+1)=bins(i)+bwds(i)/2.0
        binedges(2*i+2)=binedges(2*i+1)
    endfor
    binedges(2*nbins-1)=bins(nbins-1)+bwds(nbins-1)/2.0
end
;***************************************************************************

;*****************************************************************************
pro getfssp2dcdata,intEND,Tstep,Pstateinfo,fsspbinhs,twodcbinhs,twodcAbinhs,twodcMbinhs
    endtime=intEND
    startTime=endtime-Tstep
    fssptime=*(*Pstateinfo).fsspdata.time
    fsspbinh=*(*Pstateinfo).fsspdata.binh
    index=where(fssptime ge startTime,contF)
    if contF eq 0 then begin
        fsspT0_str='fssp2dc start_time is : '+strtrim(string(fssptime(0)),2)
        fsspTe_str='fssp2dc stop_time is : '+strtrim(string(fssptime(n_elements(fssptime)-1)),2)
        chosTs_str='your chosen start_time is: '+strtrim(string(startTime),2)
        str_final1='    '
        str_final2='Your start Time  > fssp2dc stop Time'
        str_final3='Re-choose your start Time Again !'
        rrrrrr=dialog_message([fsspT0_str,fsspTe_str,chosTs_str,str_final1,str_final2,str_final3],/information)
    end

    index=where(fssptime le startTime,contF)
    if contF eq 0 then begin
        fsspT0_str='fssp2dc start_time is : '+strtrim(string(fssptime(0)),2)
        fsspTe_str='fssp2dc stop_time is : '+strtrim(string(fssptime(n_elements(fssptime)-1)),2)
        chosTs_str='your chosen start_time is: '+strtrim(string(startTime),2)
        str_final1='    '
        str_final2='Your start Time  < fssp2dc start Time'
        str_final3='Re-choose your start Time Again !'
        rrrrrr=dialog_message([fsspT0_str,fsspTe_str,chosTs_str,str_final1,str_final2,str_final3],/information)
    end

    index=where(fssptime ge endTime,contF)
    if contF eq 0 then begin
        fsspT0_str='fssp2dc start_time is : '+strtrim(string(fssptime(0)),2)
        fsspTe_str='fssp2dc stop_time is : '+strtrim(string(fssptime(n_elements(fssptime)-1)),2)
        chosTe_str='your chosen stop_time is: '+strtrim(string(endTime),2)
        str_final1='    '
        str_final2='Your stop Time  > fssp2dc end Time'
        str_final3='Re-choose your stop Time Again !'
        rrrrrr=dialog_message([fsspT0_str,fsspTe_str,chosTe_str,str_final1,str_final2,str_final3],/information)
    end

    ;twodctime=*(*Pstateinfo).twodcdata.time
    index=where(fssptime ge startTime and fssptime lt endtime, contF)
    if contF eq 0 then begin
        rrrrrr=dialog_message('can not find the time in fssp or 2dc time, try again !',/information)
        return
    endif
    bin_sel=fsspbinh(*,index)
    ;get averaged binhs (PSD) for the time interval.
    nnn=n_elements(bin_sel(*,0))
    fsspbinhs=fltarr(nnn)
    ;stop
    for i=0, nnn-1 do fsspbinhs(i)=mean(bin_sel(i,*))

    ;stop
    ;==================================================================
    twodctime=*(*Pstateinfo).twodcdata.time
    twodcbinh=*(*Pstateinfo).twodcdata.binh
    twodcAbinh=*(*Pstateinfo).twodcdata.Abinh
    twodcMbinh=*(*Pstateinfo).twodcdata.Mbinh

    ;twodctime=*(*Pstateinfo).twodcdata.time
    index=where(twodctime ge startTime and twodctime lt endtime, contF)
    bin_sel=twodcbinh(*,index);   ;index is time index
    ;get averaged binhs (PSD) for the time interval.
    nnn=n_elements(bin_sel(*,0))
    twodcbinhs=fltarr(nnn)
    for i=0, nnn-1 do twodcbinhs(i)=mean(bin_sel(i,*))
    twodcbinhs=twodcbinhs;/(*(*pstateinfo).twodcdata.bwd)

    ;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    bin_sel=twodcAbinh(*,index)
    ;get averaged binhs (PSD) for the time interval.
    twodcAbinhs=fltarr(nnn)
    for i=0, nnn-1 do twodcAbinhs(i)=mean(bin_sel(i,*))
    twodcAbinhs=twodcAbinhs;/(*(*pstateinfo).twodcdata.bwd)


    bin_sel=twodcMbinh(*,index)
    ;get averaged binhs (PSD) for the time interval.
    twodcMbinhs=fltarr(nnn)
    for i=0, nnn-1 do twodcMbinhs(i)=mean(bin_sel(i,*))
    twodcMbinhs=twodcMbinhs;/(*(*pstateinfo).twodcdata.bwd)
end

;****************************************************************************
PRO du_input_SHEBA_2D,cdf_dy_st,cdf_hh_st,cdf_mm_st,cdf_ss_st,cdf_dy_e,$
    cdf_hh_end,cdf_mm_end,cdf_ss_end,TAS,$
    TWODCP_Max,TWODCP_Mean,TWODC_Median,TWODCP_conc,TWODC_SHWOR,bins,wids,data_out,area_out,mass_out

!p.multi = [0,1,1]   ; set it right from begin for plots 1 column 1 row of plot windows.
; to prevent confusion from former other sessions.

;Date of generation of this file:   Dec. 18, 2002   Qixu Mo
;by combining two files. du_input_SHEBA_2dc_2dc_test.pro and **_2dp_2dp_test.pro

;because of iy is limited to 32 pixels,  so area is not quite right in statistics
;when ix is greater than 32 (32*25)=800m  so does the mass_out.

;This program reads data from 2 data files generated from NCAR's xpms2d
; (1) 101rf092d.dat  (2) 101rf092dp.dat  of 2dc and 2dp instruments.

;and assign the particles obtained in 1 second into 64 bins.

;Prepare sheba-2d PSD data for Do_FFF  Nov. 14 2002--Qixu Mo

;the input by the program call is start-time, end-time, true air speed:
;    cdf_dy[0], cdf_hh[0],  cdf_mm[0],  cdf_ss[0],
;  cdf_dy[nnn], cdf_hh[nnn],cdf_mm[nnn],cdf_ss[nnn],TAS

cdft0=cdf_hh_st*3600+cdf_mm_st*60+cdf_ss_st; start time
cdftn=cdf_hh_end*3600+cdf_mm_end*60+cdf_ss_end

;the time string
cdft0str=strtrim(string(round(cdf_hh_st)),2)+strtrim(string(round(cdf_mm_st)),2)+strtrim(string(round(cdf_ss_st)),2)  
cdftnstr=strtrim(string(round(cdf_hh_end)),2)+strtrim(string(round(cdf_mm_end)),2)+strtrim(string(round(cdf_ss_end)),2)
cdf_time_str='stats time from '+cdft0str+'  to  '+cdftnstr 

; cdft0=23*3600.0+44.0*60.0+00.0             ; cdf start time
; cdftn=23*3600.0+48.0*60.0+00.0
; cdf_time_str='Stats time from 23:44:00 to 23:48:00'

;get the time in monotonous.
if (cdftn lt cdft0) then cdftn=cdftn+24*3600.0
nnn=floor(cdftn)-floor(cdft0)+1 

; TAS=150.0+fltarr(nnn)*0.0

;*****************************************************************
; first do the twoDC  stuff
;****************************************************************
; define an array to store nnn  curves of PSD destribution
; each distribution has 64 bins.

data_2DC=0*fltarr(64,nnn) ;  array of nnn row and 100 columns.
datapum_2DC=0.0*fltarr(64,nnn); for internal use to choose break point.
npbin_2dc=0.0*fltarr(64,nnn); for internal use to calculated the combined mean median.
TWODC_max=0*fltarr(nnn)
TWODC_mean=0*fltarr(nnn)
TWODC_median=0*fltarr(nnn)
TWODC_conc =0*fltarr(nnn)
TWODC_SHWOR=0*fltarr(nnn)
Area_2dc   =0.0*fltarr(64,nnn)
Mass_2dc   =0.0*fltarr(64,nnn)

;2DC_bins define the center of bin. wids define the width of a bin.
;we found in 101rf092d.dat that 131 is the maximum size of particle.
;there are a lot has 100.  some may have more that 131.
;I will let first 50 bins has binsize 1 pixel. from 51 to 55 has 2 pixel.
;from bin 56 to 64 will have 3, 4, 5, ...,10,11 pixels of bin width.

;************************************************************
wid_1to10=1+INDGEN(10)*0   ;that is wids=[1, 1,1, 1, ...,1].
wid_11to25=[2,2,2,2,2,4,4,4,4,4,8,8,8,8,8]
wids1to25=[wid_1to10, wid_11to25]*25.0;   in um unit.

wids26to64=[2,2,2,2+INDGEN(36)]*200;     in unit um

wids=[wids1to25, wids26to64]

;form bin_edges  let bin_edge(0)=0.
;and calculate bin_center (64 elements). bin_edge has 65 elements.

bin_edges=[0, 0.0*Indgen(64)]  ; 65 elements, first is 12.5 um
bins     =0.0*Indgen(64)         ; bin_centers
for i=1,n_elements(wids) do begin  ; wids ahs 64 elements, bin_edge has 65 elements.
    bin_edges[i]=(bin_edges[i-1]+wids[i-1])       ; in unit um
    bins[i-1]=(bin_edges[i-1]+bin_edges[i])/2.0   ; in unit um
endfor

bin_edgespixel2dc=round(bin_edges/25);    in pixels
binpixel2dc=round(bins/25);    in pixels. use it to assign # into bin and for DOF

bin_edgespixel2dp=bin_edges/200;    in pixels
binpixel2dp=bins/200;    in pixels. use it to assign # into bin and for DOF

; the bin edges are:
; 0.00     25.0   50.0000  75.0000  100.000 125.000  150.000  175.000 200.00 225.00 250.000  300.00 350.00 400.000 450.00
; 500.0    600.00 700.000  800.000  900.000 1000.00  1200.00  1400.00 1600.0 1800.0 2000.00  2400.0 2800.0 3200.00 3600.0
; 4200.0   5000.0 6000.00  7200.00  8600.00 10200.0  12000.0  14000.0 16200. 18600. 21200.0  24000. 27000. 30200.0 33600.
; 37200.0  41000. 45000.0  49200.0  53600.0 58200.0  63000.0  68000.0 73200. 78600. 84200.0  90000. 96000. 102200. 108600.
; 115200.  122000.129000.  136200.  143600.
;This way the bin_edgespixel2dc is
;1 2 3 4 5 6 7..10 11 13 ...........5744
; remember this number 5744 for DOF calculation for each pixel size of particle.

; and bin_edgepixel2dp is=0,0.125,0.25...1,1.125,1.5 1.75 2 2.25 2.5 3 3.5 4 4.5
;                         5, 6, 7 ......718.
; and remember this number 718 for DOF and bins assigments.



; sample Area for each bin; formulat is from SEA  2DC_SPEC.CHN
; SA = DOF*pixel_size*[number_of_diodes+particle_size/pixel_size)
; SA = DOF*0.025mm*[32 + D(mm)/0.025mm)
; where D is particle_size or bin_center in mm.
; DOF is depth_of_field=C*D*D/lamda, C is constant and lamda is laser wave length.
; DOF is the minimun of two number DOF=min([CD*D*D/lamda, 59mm]) where 59 is fixed
; length between the diode array.  Refer to SHEBA documents
;RAF Bulletin 24 of NCAR Rev. 1/89. in appendix A:  DOF=6R*R/lamda
; where lamda=laser wavelength=0.6328*10^(-3) mm;  R is Radius of the Particle (mm)

; first find out the depth of file DOF
; for 2dc we need to assign nn2dc bins for DOFc and SAc calculation.
nn2dc=bin_edgespixel2dc(n_elements(bin_edgespixel2dc)-1);5744 bins 5745 edges elements.
Dbins2dc=[0.5+INDGEN(nn2dc)]*25;  ; unit um

nn2dp=bin_edgespixel2dp(n_elements(bin_edgespixel2dp)-1);718 bins 719 edges elements.
Dbins2dp=[0.5+INDGEN(nn2dp)]*200;  ;unit  um

D2=Dbins2dc*Dbins2dc;    Note that here D is diameter, not Radius.
const_cl=6.0/(4*0.6328*0.001)   ; unit is 1/mm
DOF=0.000001*D2*const_cl;       ; unit should be mm
DOF2dc=fltarr(n_elements(DOF))
for i=0,n_elements(DOF)-1 do begin
    DOF2dc[i]=min([DOF[i],61])
end  ; end for

D2=Dbins2dp*Dbins2dp;    Note that here D is diameter, not Radius.
DOF=0.000001*D2*const_cl;       ; unit should be mm
DOF2dp=fltarr(n_elements(DOF))
for i=0,n_elements(DOF)-1 do begin
    DOF2dp[i]=min([DOF[i],261])
end  ; end for

; from document it said that: the maxi DOF for 2D-C is 61mm, corresponds to particle
; Radius of 80 micron. the 200Y has a maxi DOF of 261 for R=165.
SAc=DOF2dc*0.025*(32+Dbins2dc/25);  here Bins is in terms of microns, unit is mm^2.
SAc_shador=max(DOF2dc)*0.025*32   ; for calculating the sample volume of shadowOR

SAp=DOF2dp*0.2*(32+Dbins2dp/200.0);  here Bins is in terms of microns, unit is mm^2.
SAp_shador=max(DOF2dp)*0.2*32   ; for calculating the sample volume of shadowOR

str1='please pick a 2dc particle data file:(like 101rf092DC.dat)'
file2dc=dialog_pickfile(title=str1,filter='*2DC*.dat',Get_path=pathnm)
; the file format is like this:
; #     Time       timeWord  rj  iy  ix  ia    dt
;000 18 15 00.760       895  0   3   3   5    1409
;001 18 15 00.761       525  0   3   5  10    827

print,'reading data**************** '
pdat=read_ascii(file2dc,COMMENT_SYMBOL='#',COUNT=n,DATA_START=1)

;convert data from a structure into a array.
result=pdat.field01 ;result is a vector arry[10,n], one line has 10 values==>field01.
;if the string rj is 0, that means the particle is accepted.
timeh=result[1,0:n-1]   ; column 1     column zero is the ith particle of that buffer.
timem=result[2,0:n-1]   ; column 2
times=result[3,0:n-1]  ;timeWord=result[4,*]
rj   =result[5,0:n-1]
iy   =result[6,*]
ix   =result[7,0:n-1]
ia   =result[8,0:n-1]  ;dt=result[9,*]
conc =result[10,0:n-1]; ; concentration in the buffer.
time =timeh*3600.0+timem*60.0+times    ; time in seconds.
time0=time
nt=long(n_elements(time))

print,'xpms2d 2DC start time=',timeh[0],':',timem[0],':',times[0]
print,'xpms2d 2DC  end  time=',timeh[nt-1],':',timem[nt-1],':',times[nt-1]

; find out if time need to be fixed because of overnight in UCTime
print,'please wait, begin time correction.....'

;find out the index of maximum time in the time array
maxtime=max(time)
indxx=0l   ; set the index count.

for i=0l, n_elements(time)-1 do begin
    if (time(i) eq maxtime ) then indxx=i
end
; now we have found the index of the maxtime (usually 24:00:00 ).

; and now we correct the time if data pass 24:00:00 and starts from 0:0:0

time_difference=maxtime - time(n_elements(time)-1)  ; it should be 24hour- 10
if (time_difference gt 14.0*3600 ) then begin
    for iit=long(indxx+1), n_elements(time)-1 do begin
        if ( (maxtime-time[iit]) gt 14.0*3600 )  then begin
            time(iit)=time(iit)+86400.0   ; 86400=24.0*3600.0
        endif      ;end of if
    end  ; end of for
endif

; now sort the time
indxx=sort(time)
time=time(indxx)
start_time=time(0)
end_time=floor(time(n_elements(time)-1))  ; time is in seconds now.

; convert time to time string
hh=floor(time(0)/3600.0)
mm=floor((time(0)-hh*3600)/60.0)
ss=floor(time(0)-hh*3600-mm*60)
Stime_2dc_str=strtrim(string(hh),2)+':'+strtrim(string(mm),2)+':'+strtrim(string(ss),2)

hh=floor(end_time/3600.0)
mm=floor((end_time-hh*3600)/60.0)
ss=floor(end_time-hh*3600-mm*60)
Etime_2dc_str=strtrim(string(hh),2)+':'+strtrim(string(mm),2)+':'+strtrim(string(ss),2)

;*********************************************************
;**************************************************************
for k=0l,nnn-1 do begin
    binh=0*intarr(64)    ; initialized binheight
    binhPl=0.0*fltarr(64)
    binhPLpum=0.0*fltarr(64)
    bin_areah=0*fltarr(64)   ; initialized the area in each bin
    bin_massh=0*fltarr(64)   ; initialized teh mass in each bin

    t1=cdft0+k
    t2=t1+1
    ;   print, 'cdft0 cdftn  start_time   end_time,  kstart, t_start  kstart+t_start,nnn t_end '; fro debug
    ;   print, cdft0, cdftn, start_time,  end_time,  kstart, t_start, kstart+t_start,nnn,t_end

    if (t2 gt end_time) then break  ; break out of for loop. No need to do zero assignments.

    index=where( (time ge t1) and (time lt t2) ) ; index of data in 1 second interval.

    if (index[0] eq -1) then begin  ; that is if there is no data in this time interval.
        ; we will asign zero data to the parameters.
        ; data_2DC[*,k]=0.0*fltarr(1,64)
        ; datapum_2DC[*,k]=0.0*fltarr(1,64)
        ; TWODC_max(k)=0.0
        ; TWODC_mean(k)=0.0
        ; TWODC_median(k)=0.0
        ; TWODC_conc(k)=0
        ; TWODC_SHWOR(k)=0.0
        ; area_2dc(*,k)=0.0*fltarr(1,64)
        mass_2dc(*,k)=0.0*fltarr(1,64) ; infact , this is already assigned.
    end   ;end of if

    if (index(0) ne -1) then begin ; that is if there is data in this time interval.
        temp_rj=rj(index)  ;  rj vector in one second interval
        temp_time=time[index]
        temp_iy   =iy[index]
        temp_ix   =ix[index]  ; ix size vector in one second interval.
        temp_ia   =ia[index]  ; ia area vector in one second interval.
        temp_conc =conc[index]
        TWODC_SHWOR(k)=n_elements(index)/(SAc_shador*TAS(k)/1000.0)   ;shadow OR count in 1 second.
        ;sample_volume_shad=SA_shador*TAS(k)/1000.0   ;for shadow_or.  in unit Liter/s.

        temp_ratio=float(temp_ix)/float(temp_iy)
        index_accept=where(temp_rj eq 0 and temp_ratio lt 6.0 ); select those accepted particles.

        if (index_accept(0) eq -1)  then begin ; that means there no accepted particles.
            data_2DC[*,k]=0.0;     *fltarr(64,1)
            datapum_2DC[*,k]=0.0
            TWODC_max(k)=0.0
            TWODC_mean(k)=0.0
            TWODC_median(k)=0.0
            TWODC_conc(k)=0
            area_2dc(*,k)=0.0*fltarr(1,64)
            Mass_2dc(*,k)=0.0*fltarr(1,64)
        endif

        if (index_accept(0) ne -1)  then begin ; that means there are accepted particles.
            ix_accept=temp_ix(index_accept)    ; size vector of accepted particles.
            ia_accept=temp_ia(index_accept)
            conc_accept=temp_conc(index_accept)
            TWODC_max(k)=max(ix_accept)*25   ; in unit um
            TWODC_mean(k)=mean(ix_accept,/nan)*25 ;  in um
            true_conc=mean(conc_accept,/nan)

            nn=n_elements(index_accept)   ; there are nn particles in this one second interval.
            remainder= nn mod 2
            if (remainder eq 0) then  TWODC_median[k]=median(ix_accept,/even)*25  ; um
            if (remainder eq 1) then  TWODC_median[k]=median(ix_accept)*25        ;um

            ; befor assign particles into the actual bins used we need first to
            ; assign particle into teh raw 1 pixel bins first for calculating
            ; the #/Liter/big_bin which is the sum of (#/L/small_bin)
            ; now we need to calculated #/L/small_bin
            sbinh=fltarr(nn2DC);number_per_small_bin= #/bin
            sbinhpL=fltarr(nn2DC)   ;number_per-small_bin_per_Liter
            sbinpLpum=fltarr(nn2DC)   ;number_per-small_bin_per_Liter
            sbin_areah=fltarr(nn2dc)  
            sbin_massh=fltarr(nn2dc)  
            for i=0l, nn2DC-1 do begin
                index=where(ix_accept eq i+1)     ; index of ix_accept is the same as
                if (index[0] eq -1) then begin    ; that of ia_accept.
                    sbinh[i]=0.0                      ; ix_accept is all size of particles
                    sbin_areah[i]=0.0;                ; in one second.
                    sbin_massh[i]=0.0
                endif else begin
                    sbinh[i]=n_elements(index)  ; number of particles in this bin.
                    sbin_areah[i]=total(ia_accept(index));   in pixel-square. 1 pixel=0.025mm.
                    iamm2=sbin_areah[i]*0.000625;    ;area in unit mm2 of that bin.

                    ;modify according to brad's instruction March 18,2003
                    ;calculated each particle's mass within this smaller ith bin
                    sum_mass_a=0.0
                    for kki=0,sbinh[i]-1 do begin     ;do sbinh[i] times for sbinh[i] particles.
                        r_sphere=(i+1.0)*0.025/2.0;      unit is mm   1pixel=25micron=0.025
                        sphere_mass=0.917*(4*!pi/3.0)*(r_sphere)^3.0; mass assume sphere, unit mg.
                        particle_A=ia_accept(index(kki))*0.000625;   mm2
                        mass_area=0.1334*(particle_A)^1.25;  mass calculated according the area.   unit=mg
                        sum_mass_a=sum_mass_a+min([sphere_mass,mass_area]);  unit mg.
                    endfor
                    sbin_massh[i]=sum_mass_a;    unit mg.
                endelse
            endfor 

            sample_volume=SAc*TAS(k)/1000.0;   in unit Liter/s.
            sbinhpL=sbinh/sample_volume;          in unit #/L/small_pin

            ; calculate the correction factor for the concentration.
            under_conc=total(sbinhPL)
            factor=true_conc/under_conc
            ;TWODC_conc(k-1)=total(sbinhPL)  ; old way  unit #/Liter
            TWODC_conc(k)=true_conc
            sbinhPL=sbinhPL*factor
            ;calculate t1 time string
            t1hh=floor(t1/3600)
            t1mm=floor((t1-t1hh*3600)/60)
            t1ss=t1-t1hh*3600-t1mm*60

            ;  print, 'factor=',factor,'time=',t1hh,t1mm,t1ss

            ; begin the assign particles into the final bigger bins
            ;for the first 8 bins size is from 0 to 200=1 pixel of 2dp.
            ;binedges=0 25 50 75 100 125 150 175  200.
            ; all particles will be uniformly allocate among 8 bins.
            binh[0:7]=sbinh[0:7];    ;they are in pixel=[1,2,3,4,5,6,7,8]
            binhPL[0:7]=sbinhpL[0:7];   ;they are the same.
            binhPLpum[0:7]=sbinhpL[0:7]/25;   ;they are the same.
            bin_areah[0:7]=sbin_areah[0:7]
            bin_massh[0:7]=sbin_massh[0:7]

            for kk=8,63  do begin    ;ix is in pixels 1 pixel=25 um
                bk=bin_edgespixel2dc(kk)     ;bin_edges=[1 ,2,..,50,, 123??]
                bk1=bin_edgespixel2dc(kk+1)-1  ;bin_edges is 65 elements.
                ; if (kk lt 63) then index=where( (ix_accept gt bk) and (ix_accept le bk1) )
                ; if (kk eq 63) then index=where(  ix_accept ge bk) ;all bigger ones go into last bin
                ; if (index[0] eq -1) then binh[kk]=0.0 else binh[kk]=n_elements(index)
                binh[kk]=total(sbinh(bk:bk1));    ;if edges are 5 and 10.then we just want to sum up
                binhPL[kk]=total(sbinhPL(bk:bk1)); ; small bins of { 5,6,7,8,9}
                local_width=max([1, bk1-bk])*25
                binhPLpum[kk]=binhPL[kk]/local_width; one way, the result is same as following
                ; binhPLpum[kk]=mean([sbinPLpum(bk:bk1)]); other way  since piexel size is fixed.
                ; if (bk1-bk EQ 0) then print,'bk1 bk=',bk1,bk
                bin_areah[kk]=total(sbin_areah(bk:bk1))
                bin_massh[kk]=total(sbin_massh(bk:bk1))
            endfor   ;end for kk
            npbin_2dc[*,k]=binh;      ;in unit #/bin
            data_2dc[*,k]=binhPL     ;unit is #/L/bin
            datapum_2dc[*,k]=binhPLpum;  unit is #/L/um
            area_2dc[*,k] =factor*(bin_areah/sample_volume)*0.000625;  ; 1pixel=0.025mm
            mass_2dc[*,k] =factor*bin_massh/sample_volume;    in unit mg/L or g/m3

        endif    ; end of if there is accepted particles.

    endif ; end of if (index(0) ne -1)  there is data in the time interval.

end      ; end of  for k=1,nnn-2  and end of preocessing all data in the file.

print,'DONE xpms2d 2dc  processing !!!!!'
kstart_2dc=max([0,round( start_time -cdft0)]);   ;remeber this value for later data_out use.
kend_2dc=min([nnn-1, round(end_time -cdft0)])

;end of twoDC stuff
;***********************************************************************


;           leave blanks in here intentionally



;***********************************************************************
;***********************************************************************

;next do the twoDP stuff;  use the same names as for twoDC for twoDP

;************************************************************************
;************************************************************************

; define an array to store nnn  curves of PSD destribution
; each distribution has 64 bins.

data_2dp=0*fltarr(64,nnn) ;  array of nnn row and 100 columns.
datapum_2Dp=0.0*fltarr(64,nnn); for internal use to choose break point.
npbin_2dp=0.0*fltarr(64,nnn); for internal use to calculated the combined mean median.
TWODP_max=0*fltarr(nnn)
TWODP_mean=0*fltarr(nnn)
TWODP_median=0*fltarr(nnn)
TWODP_conc=0*fltarr(nnn)
TWODP_SHWOR=0*fltarr(nnn)
area_2dp   =0*fltarr(64,nnn)
mass_2dp   =0*fltarr(64,nnn)

;2DP_bins define has done in the 2DC part..

str1='please pick a 2dc particle data file:(like 101rf092dp.dat)'
file2dp=dialog_pickfile(title=str1,filter='*2dp*.dat',Get_path=pathnm)
; the file format is like this:
; #     Time       timeWord  rj  iy  ix  ia    dt
;000 18 15 00.760       895  0   3   3   5    1409

print,'reading data**************** '
pdat=read_ascii(file2dp,COMMENT_SYMBOL='#',COUNT=n,DATA_START=1)

;convert data from a structure into a array.
result=pdat.field01 ;result is a vector arry[10,n], one line has 10 values==>field01.
;if the string rj is 0, that means the particle is accepted.
timeh=result[1,0:n-1]   ; column 1     column zero is the ith particle of that buffer.
timem=result[2,0:n-1]   ; column 2
times=result[3,0:n-1]  ;timeWord=result[4,*]
rj   =result[5,0:n-1]  
iy   =result[6,*]
ix   =result[7,0:n-1]
ia   =result[8,0:n-1]  ;dt=result[9,*]
conc =result[10,0:n-1]
time =timeh*3600.0+timem*60.0+times    ; time in seconds.
time0=time
nt=long(n_elements(time))

print,'xpms2d 2dp start time=',timeh[0],':',timem[0],':',times[0]
print,'xpms2d 2dp  end  time=',timeh[nt-1],':',timem[nt-1],':',times[nt-1]

; find out if time need to be fixed because of overnight in UCTime
print,'please wait, begin time correction.....'

;find out the index of maximum time in the time array
maxtime=max(time)
indxx=0l   ; set the index count.

for i=0l, n_elements(time)-1 do begin
    if (time(i) eq maxtime ) then indxx=i
end
; now we have found the index of the maxtime (usually 24:00:00 ).

; and now we correct the time if data pass 24:00:00 and starts from 0:0:0

time_difference=maxtime - time(n_elements(time)-1)  ; it should be 24hour- 10
if (time_difference gt 14.0*3600 ) then begin
    for iit=long(indxx+1), n_elements(time)-1 do begin
        if ( (maxtime-time[iit]) gt 14.0*3600 )  then begin
            time(iit)=time(iit)+86400.0   ; 86400=24.0*3600.0
        endif      ;end of if
    end  ; end of for
endif

; now sort the time
indxx=sort(time)
time=time(indxx)
start_time=floor(time(0));    changed from time(0) on June 10 2003
end_time=floor(time(n_elements(time)-1))   ; time in seconds.
; convert time to time string
hh=floor(time(0)/3600.0)
mm=floor((time(0)-hh*3600)/60.0)
ss=floor(time(0)-hh*3600-mm*60)
Stime_2dp_str=strtrim(string(hh),2)+':'+strtrim(string(mm),2)+':'+strtrim(string(ss),2)

hh=floor(end_time/3600.0)
mm=floor((end_time-hh*3600)/60.0)
ss=floor(end_time-hh*3600-mm*60)
Etime_2dp_str=strtrim(string(hh),2)+':'+strtrim(string(mm),2)+':'+strtrim(string(ss),2)

;*********************************************************
for k=0l,nnn-1 do begin
    binh=0*intarr(64)    ; initialized binheight
    binhPl=0.0*fltarr(64)
    binhPLpum=0.0*fltarr(64)
    bin_areah=0.0*fltarr(64)
    bin_massh=0.0*fltarr(64)

    t1=cdft0+k
    t2=t1+1

    if (t2 gt end_time) then break  ; break out of for loop. No need to do zero assignments.

    index=where( (time ge t1) and (time lt t2) ) ; index of data in 1 second interval.

    if (index[0] eq -1) then begin  ; that is if there is no data in this time interval.
        ; we will asign zero data to the parameters.
        ; data_2dp[*,k]=0.0*fltarr(1,64)
        ; datapum_2dp[*,k]=0.0*fltarr(1,64)
        ; TWODP_max(k)=0.0
        ; TWODP_mean(k)=0.0
        ; TWODP_median(k)=0.0
        ; TWODP_conc(k)=0
        ; TWODP_SHWOR(k)=0.0
        ; area_2dp(*,k)=0.0*fltarr(1,64)
        Mass_2dp(*,k)=0.0*fltarr(1,64);   all above has already assigned.
    end   ;end of if

    if (index(0) ne -1) then begin ; that is if there is data in this time interval.
        temp_rj=rj(index)  ;  rj vector in one second interval
        temp_time=time[index]
        temp_iy   =iy[index]
        temp_ix   =ix[index]  ; ix size vector in one second interval.
        temp_ia   =ia[index]
        temp_conc =conc(index)
        TWODP_SHWOR(k)=n_elements(index)/(SAp_shador*TAS(k)/1000.0)   ;shadow OR count in 1 second.

        temp_ratio=float(temp_ix)/float(temp_iy)
        index_accept=where(temp_rj eq 0 and temp_ratio lt 6.0 ); select those accepted particles.


        if (index_accept(0) eq -1)  then begin ; that means there no accepted particles.
            data_2dp[*,k]=0.0;     *fltarr(64,1)
            datapum_2dp[*,k]=0.0
            TWODP_max(k)=0.0
            TWODP_mean(k)=0.0
            TWODP_median(k)=0.0
            TWODP_conc(k)=0
            area_2dc(*,k)=0.0*fltarr(1,64)
            Mass_2dc(*,k)=0.0*fltarr(1,64)
        endif

        if (index_accept(0) ne -1)  then begin ; that means there are accepted particles.
            ix_accept=temp_ix(index_accept)    ; size vector of accepted particles.
            iy_accept=temp_iy(index_accept)    
            ia_accept=temp_ia(index_accept)
            conc_accept =temp_conc(index_accept)
            TWODP_max(k)=max(ix_accept)*25*8   ; in unit um
            TWODP_mean(k)=mean(ix_accept,/nan)*25*8 ;  in um
            true_conc=mean(conc_accept,/nan)

            nn=n_elements(index_accept)   ; there are nn particles in this one second interval.
            remainder= nn mod 2
            if (remainder eq 0) then  TWODP_median[k]=median(ix_accept,/even)*25*8  ; um
            if (remainder eq 1) then  TWODP_median[k]=median(ix_accept)*25*8        ;um


            ;debugging where is the bigger artifical particles.
            big_ix=where(ix_accept gt 25.0, bigcount)
            if (bigcount gt 0)  then begin
                for ibb=0, n_elements(big_ix)-1 do begin
                    print, 'Warning: Check image, make sure the following particle'
                    print, 'is not artifact  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
                    print, 'OHHHH!!! BIG Particles ix=',ix_accept(big_ix(ibb))*200
                    print, 'Vertical size of it is iy=',iy_accept(big_ix(ibb))*200
                    ;calculate the time in hh:mm:ss format
                    tssss=temp_time(index_accept(0));  ;in seconds from midnight
                    hhhhh=floor(tssss/3600.0)
                    mmmmm=floor((tssss/3600.0- hhhhh)*60.0)
                    sssss=tssss-hhhhh*3600.0-mmmmm*60.0
                    ttttt=strtrim(string(hhhhh),2)+':'+strtrim(string(mmmmm),2)+':'+strtrim(string(sssss),2)
                    print, 'particle time is == ', ttttt
                    wait,4     ;wait 4 seconds.
                endfor

            endif



            ; befor assign particles into the actual bins used we need first to
            ; assign particle into teh raw 1 pixel bins first for calculating
            ; the #/Liter/big_bin which is the sum of (#/L/small_bin)
            ; now we need to calculated #/L/small_bin
            sbinh=fltarr(nn2dp);number_per_small_bin= #/bin
            sbinhpL=fltarr(nn2dp)   ;number_per-small_bin_per_Liter
            sbinpLpum=fltarr(nn2dp)   ;number_per-small_bin_per_Liter
            sbin_areah=fltarr(nn2dp)  
            sbin_massh=fltarr(nn2dp)  

            for i=0l, nn2dp-1 do begin
                index=where(ix_accept eq i+1)
                if (index[0] eq -1) then begin    ; that of ia_accept.
                    sbinh[i]=0.0                      ; ix_accept is all size of particles
                    sbin_areah[i]=0.0;                ; in one second.
                    sbin_massh[i]=0.0
                endif else begin
                    sbinh[i]=n_elements(index)
                    sbin_areah[i]=total(ia_accept(index));   in pixel-square. 1 pixel=0.2mm.
                    iamm2=sbin_areah[i]*0.04;    ;area in unit mm2 of that bin.

                    ;modify according to brad's instruction March 18,2003
                    ;calculated each particle's mass within this smaller ith bin
                    sum_mass_a=0.0
                    for kki=0,sbinh[i]-1 do begin     ;do sbinh[i] times for sbinh[i] particles.
                        r_sphere=(i+1.0)*0.2/2.0;      unit is mm   1pixel=25micron=0.025
                        sphere_mass=0.917*(4*!pi/3.0)*(r_sphere)^3.0; mass assume sphere, unit mg.
                        particle_A=ia_accept(index(kki))*0.04;   mm2
                        mass_area=0.1334*(particle_A)^1.25;  mass calculated according the area.   unit=mg
                        sum_mass_a=sum_mass_a+min([sphere_mass,mass_area]);  unit mg.
                    endfor
                    sbin_massh[i]=sum_mass_a;    unit mg.
                    ;old wrong calculation--- sbin_massh[i]=0.1334*(iamm2)^1.25 ; unit mg
                endelse
            endfor 

            sample_volume=SAp*TAS(k)/1000.0;   in unit Liter/s.
            sbinhpL=sbinh/sample_volume;          in unit #/L/small_pin
            ;calculate the correction factor for the concentration because of deatime.
            under_conc=total(sbinhPL)
            factor=true_conc/under_conc
            ; TWODP_conc(k)=total(sbinhPL)  ; unit #/Liter
            t1hh=floor(t1/3600)
            t1mm=floor((t1-t1hh*3600)/60)
            t1ss=t1-t1hh*3600-t1mm*60

            ; print, 'factor=',factor,'time=',t1hh,t1mm,t1ss



            TWODP_conc(k)=true_conc

            sbinhPL=sbinhPL*factor

            ; begin the assign particles into the final bigger bins
            ;for the first 8 bins size is from 0 to 200=1 pixel of 2dp.
            ;binedges=0 25 50 75 100 125 150 175  200.
            ; all particles will be uniformly allocate among 8 bins.
            binh[0:7]=sbinh(0)/8;    ;they are in pixel 1=[0 200]
            binhPL[0:7]=sbinhpL(0)/8;   ;they are the same.
            binhPLpum[0:7]=sbinhpL(0)/200;   ;they are the same.
            bin_areah[0:7]=sbin_areah(0)/8
            bin_massh[0:7]=sbin_massh(0)/8


            ;for bins of edges: 200 225 250 300 350 400. that is 5 bins.
            ;  the index=where(ix_accept eq 2)
            binh[10:12]=sbinh(1)/4.0; because binwids=50.
            binh[8:9]=sbinh(1)/8.0;   because binwids=25
            binhPL[8:9]=sbinhpL(1)/8;   ;they are the same.
            binhPL[10:12]=sbinhPL(1)/4.0;    in unit #/L/per_bin
            binhPLpum[8:12]=sbinhPL(1)/200;   in unit #/L/um
            bin_areah[10:12]=sbin_areah(2)/4
            bin_massh[10:12]=sbin_massh(2)/4
            bin_areah[8:9]=sbin_areah(2)/8
            bin_massh[8:9]=sbin_massh(2)/8

            ; for bins of edges 400 450 500 600  there are 3 bins.
            ;  the  index=where(ix_accept eq 3)
            binh[13:14]=sbinh[2]/4.0
            binh[15]   =sbinh[2]/2.0
            binhPL[13:14]=sbinhPL(2)/4;   ;they are the same.
            binhPL[15]   =sbinhPL(2)/2
            binhPLpum[13:15]=sbinhPL(2)/200; bin_width=200

            bin_areah[13:14]=sbin_areah(2)/4
            bin_massh[13:14]=sbin_massh(2)/4
            bin_areah[15]=sbin_areah(2)/2
            bin_massh[15]=sbin_massh(2)/2

            ;for bins of edges 600 700 800  there are bins
            ; the index=where(ix_accept eq 4)
            binh[16:17]=sbinh[3]/2.0
            binhPL[16:17]=sbinhPL(3)/2.0;   ;they are the same.
            binhPLpum[16:17]=sbinhPL(3)/200 ;bin_width=200
            bin_areah[16:17]=sbin_areah(3)/2
            bin_massh[16:17]=sbin_massh(3)/2

            ; for bins of   800 900 1000. the index=where(ix_accept eq 4)
            binh[18:19]=sbinh[4]/2.0
            binhPL[18:19]=sbinhpL(4)/2.0;     ;they are the same.
            binhPLpum[18:19]=sbinhPL(4)/200.0 ;bin_width=200
            bin_areah[18:19]=sbin_areah(4)/2
            bin_massh[18:19]=sbin_massh(4)/2

            ;for bins  of 1000, 1200, 1400, ....143600  bins 20 to 64.
            for kk=20,63  do begin    ;ix is in pixels 1 pixel=25 um
                bk=bin_edgespixel2dp(kk)     ;bin_edges=[1 ,2,..,50,, 123??]
                bk1=bin_edgespixel2dp(kk+1)-1  ;bin_edges is 65 elements.
                ; if (kk lt 63) then index=where( (ix_accept gt bk) and (ix_accept le bk1) )
                ; if (kk eq 63) then index=where(  ix_accept ge bk) ;all bigger ones go into last bin
                ; if (index[0] eq -1) then binh[kk]=0.0 else binh[kk]=n_elements(index)
                binh[kk]=total(sbinh(bk:bk1));    ;if edges are 5 and 10.then we just want to sum up
                binhPL[kk]=total(sbinhPL(bk:bk1)); ; small bins of { 5,6,7,8,9}
                local_width=max([1, bk1-bk])*200;  ; note that (bk1-bk may EQ 0 )
                binhPLpum[kk]=binhPL[kk]/local_width; one way, the result is same as following
                ; binhPLpum[kk]=mean([sbinPLpum(bk:bk1)]); other way  since piexel size is fixed.
                bin_areah[kk]=total(sbin_areah(bk:bk1))
                bin_massh[kk]=total(sbin_massh(bk:bk1))
            endfor   ;end for kk
            npbin_2dp[*,k]=binh;      ;in unit #/bin
            data_2dp[*,k]=binhPL     ;unit is #/L/bin
            datapum_2dp[*,k]=binhPLpum;  unit is #/L/um
            area_2dp[*,k] =factor*(bin_areah/sample_volume)*0.04 ; earlier unit is pixel square. 1 pixel=0.2mm=200um.
            mass_2dp[*,k] =factor*bin_massh/sample_volume     ;  in unit mg/L or g/m3

        endif    ; end of if there is accepted particles.

    endif ; end of if (index(0) ne -1)  there is data in the time interval.

end      ; end of  for k=1,nnn-2  and end of preocessing all data in the file.
print,'DONE xpms2d 2dp  processing !!!!!'

kstart_2dp=max([0,   round(start_time-cdft0)]); ;remeber this value for later data_out use.
kend_2dp=min([nnn-1, round(end_time  -cdft0)])
;**************************************************************************************
; end of 2dP stuff
;***************************************************************************************


;*********************************************************************************
;now come to the part of ploting out the 2dc and 2dp PSD in a graph for user to look
;and then choose what break point to use to get the combined PSD

; first calculate teh averaged PSD in the whole time period.  assume a breakpoint=1000
;****************************************
brkp=600.00
indexc=where(bin_edges le brkp)
indexp=where(bin_edges ge brkp)
binindexc=indexc[0:n_elements(indexc)-2]
binindexp=indexp[0:n_elements(indexp)-2]
;now assign the #/L/bin data into the output data and area_out, mass_out.
data_out=fltarr(64,nnn)*0.0
npbin_out=fltarr(64,nnn)*0.0
area_out =fltarr(64,nnn)*0.0
mass_out =fltarr(64,nnn)*0.0
; there are 4 time values to consider.
; ST_2dc    ET_2dc   or kstart_2dc  kend-2dc
; ST_2dp    ET_2dp   or kstart_2dp  kend_2dp

;first case of start_time order
if (kstart_2dc ge kstart_2dp)  then begin
    ;data_out from 1 to kstart_2dp will be zero, no need to filled in.
    ;dataOut from kstart_2dp to kstart_2dc  need to be filled with 2dp data.
    for i=long(kstart_2dp),kstart_2dc do begin
        data_out(*,i) =data_2dp(*,i)
        npbin_out(*,i)=npbin_2dp(*,i);   ; for internal calculation use.
        area_out(*,i) =area_2dp(*,i)
        mass_out(*,i) =mass_2dp(*,i)
    endfor   

    if (kend_2dc ge kend_2dp) then begin  ; then from kstart_2dc to kend_2dp is common
        for i=long(kstart_2dc-1), kend_2dp do begin
            data_out(*,i)=[ data_2dc[binindexc,i], data_2dp[binindexp,i] ]
            npbin_out(*,i)=[npbin_2dc[binindexc,i],  npbin_2dp[binindexp,i]]
            ; for internal calculation use.
            area_out(*,i) =[ area_2dc[binindexc,i], area_2dp[binindexp,i] ]
            mass_out(*,i) =[ mass_2dc[binindexc,i], mass_2dp[binindexp,i] ]
        endfor
        for i=long(kend_2dp-1), kend_2dc do begin ; from kend_2dp to kend_2dc we need filled 2dc
            data_out(*,i)=  data_2dc(*,i)
            npbin_out(*,i)=npbin_2dc(*,i);   ; for internal calculation use.
            area_out(*,i) =area_2dc(*,i)
            mass_out(*,i) =mass_2dc(*,i)
        endfor
        ; for i=kend_2dc-1, nnn-1 do begin ;   here after we filled in zeros
        ; data_out(*,i)=  data_2dcPL(*,i)
        ; endfor
    endif

    if (kend_2dc lt kend_2dp) then begin  ; then from kstart_2dc to kend_2dc is common
        for i=long(kstart_2dc-1), kend_2dc do begin
            data_out(*,i)=[ data_2dc[binindexc,i], data_2dp[binindexp,i] ]
            npbin_out(*,i)=[npbin_2dc[binindexc,i],  npbin_2dp[binindexp,i]]
            ; for internal calculation use.
            area_out(*,i) =[ area_2dc[binindexc,i], area_2dp[binindexp,i] ]
            mass_out(*,i) =[ mass_2dc[binindexc,i], mass_2dp[binindexp,i] ]
        endfor

        for i=long(kend_2dc-1), kend_2dp do begin  ; fill in 2dp data
            data_out(*,i)=data_2dp(*,i)
            npbin_out(*,i)=npbin_2dp(*,i);   ; for internal calculation use.
            area_out(*,i) =area_2dp(*,i)
            mass_out(*,i) =mass_2dp(*,i)
        endfor

        ; for i=kend_2dp-1, nnn-1 do begin ;   here after we filled in zeros
        ; data_out(*,i)=  data_2dpPL(*,i)
        ; endfor
    endif
endif ; endif of if kstart-2dc greater than kstart_2dp in time.

;second case of start_time order

if (kstart_2dp ge kstart_2dc)  then begin
    ;data_out from 1 to kstart_2dc will be zero, no need to filled in.
    ;dataOut from kstart_2dc to kstart_2dp  need to be filled with 2dc data.
    for i=long(kstart_2dc),kstart_2dp do begin
        data_out(*,i)=data_2dc(*,i)
        npbin_out(*,i)=npbin_2dc(*,i);   ; for internal calculation use.
        area_out(*,i) =area_2dc(*,i)
        mass_out(*,i) =mass_2dc(*,i)
    endfor   

    if (kend_2dp ge kend_2dc) then begin  ; then from kstart_2dp to kend_2dc is common
        for i=long(kstart_2dp-1), kend_2dc do begin
            data_out(*,i)=[ data_2dc[binindexc,i], data_2dp[binindexp,i] ]
            npbin_out(*,i)=[npbin_2dc[binindexc,i],  npbin_2dp[binindexp,i]]
            ; for internal calculation use.
            area_out(*,i) =[ area_2dc[binindexc,i], area_2dp[binindexp,i] ]
            mass_out(*,i) =[ mass_2dc[binindexc,i], mass_2dp[binindexp,i] ]
        endfor
        for i=long(kend_2dc-1), kend_2dp do begin ; from kend_2dC to kend_2dP we need filled 2dp
            data_out(*,i) =data_2dp(*,i)
            npbin_out(*,i)=npbin_2dp(*,i);   ; for internal calculation use.
            area_out(*,i) =area_2dp(*,i)
            mass_out(*,i) =mass_2dp(*,i)
        endfor
        ; for i=kend_2dp-1, nnn-1 do begin ;   here after we filled in zeros
        ; data_out(*,i)= 0.0;   data_2dcPL(*,i)
        ; endfor
    endif

    if (kend_2dp lt kend_2dc) then begin  ; then from kstart_2dp to kend_2dp is common
        for i=long(kstart_2dp-1), kend_2dp do begin
            data_out(*,i)=[ data_2dc[binindexc,i], data_2dp[binindexp,i] ]
            npbin_out(*,i)=[npbin_2dc[binindexc,i],  npbin_2dp[binindexp,i]]
            ; for internal calculation use.
            area_out(*,i) =[ area_2dc[binindexc,i], area_2dp[binindexp,i] ]
            mass_out(*,i) =[ mass_2dc[binindexc,i], mass_2dp[binindexp,i] ]
        endfor

        for i=long(kend_2dp-1), kend_2dc do begin  ; fill in 2dc data
            data_out(*,i)=data_2dc(*,i);     ;used for output
            npbin_out(*,i)=npbin_2dc(*,i);   ; for internal calculation use.
            area_out(*,i) =area_2dc(*,i)
            mass_out(*,i) =mass_2dc(*,i)
        endfor

        ; for i=kend_2dc-1, nnn-1 do begin ;   here after we filled in zeros
        ; data_out(*,i)= 0.0;  data_2dcPL(*,i)
        ; endfor
    endif
endif ; endif of if kstart-2dp greater than kstart_2dc in time.

;assign the max size of 2dc and 2dp;  mean size,  combined concentration
twodcp_max=fltarr(nnn)
twodcp_mean=fltarr(nnn)
twodcp_conc=fltarr(nnn)
twodcp_median=fltarr(nnn)
for i=0l, nnn-1 do begin
    twodcp_max(i)=max([twodc_max(i),twodp_max(i)])

    ;we have #/bin  of combined 1 Hz data from npbincmb so each bins has mm particles.
    if (total(npbin_out(*,i)) eq 0) then  begin   ; there is no particle in this second.
        twodcp_mean(i)=0.0
        twodcp_median(i)=0.0
    endif else begin
        twodcp_mean(i)=total(npbin_out(*,i)*bins)/total(npbin_out(*,i));   ;bins is the bin center.
        ;calculate the median within the second.                       ;bins=particle size.
        ;initialized the vector  of all particles size in this second.
        ixsize=[0]
        for ki=0,63 do begin
            mm=npbin_out(ki,i);  number of particle in bin ki
            if (mm gt 0) then  begin
                ixxx=bins(ki)+0*INDGEN(mm)  ; ixxx is a vector of mm elements.
                ixsize=[ixsize,ixxx];       ; put all particles sieze in a vector
            endif
        endfor
        if (n_elements(ixsize) ne 1) then begin
            ixsize=ixsize[1:n_elements(ixsize)-1]   ; take the 0 element out.
            nn=n_elements(ixsize)   ; there are nn particles in this one second interval.
            remainder= nn mod 2
            if (remainder eq 0) then  TWODCP_median[i]=median(ixsize,/even)  ; um
            if (remainder eq 1) then  TWODCP_median[i]=median(ixsize)        ;um
            ;twodcp_mean(i)=  is done in above.
        endif else begin
            Twodcp_median[i]=0.0
        endelse
    endelse

    ;concentration
    twodcp_conc(i)=total(data_out(*,i));      ; data_out(*,i) is #/L/bin
endfor  
;*****************************************************************************************
;*****************************************************************************
;end of first time assignment when break point is set to 600.default.
;teh above part will be re-done after a new break point is finally selected.
;***********************************************************************************

; now truely calculate the averaged 2dc and 2dp  #/L/um for the whole time period.
; first for 2dc and then 2dp
binh2dc=fltarr(64)
binh2dp=fltarr(64)
for i=0,63 do begin
    binh2dc[i]=mean(data_2dc[i,*],/nan)
    binh2dp[i]=mean(data_2dp[i,*],/nan)
endfor
binh2dc=binh2dc/wids
binh2dp=binh2dp/wids

;calculated the combined #/L/um
;just take out the points of 2dc which are less than breakpoint
;and take out the points of 2dp which are  ge  than breakpoint
;default break point brkpt=600.00
; it can be 600, 800, 1000, 1200, 1400, 1600
; indexc=where(bin_edges le brkp)
; indexp=where(bin_edges ge brkp)
; binindexc=indexc[0:n_elements(indexc)-2]
; binindexp=indexp[0:n_elements(indexp)-2]

combinh=fltarr(64)
combinh=[binh2dc[binindexc],binh2dp[binindexp]];     ;in unit  #/L/um

; now put the bins edges to the plots.
; with n bins and n+1 edges.
; we need 2n x_edges values and 2n ybin_high values.
nbins=n_elements(binh2dc)
nnnn=2*nbins
xedges=fltarr(nnnn);   ; 128 ELEMENTS
yh2dc=fltarr(nnnn)
yh2dp=fltarr(nnnn)
ycomb=fltarr(nnnn)

xedges[0]=bin_edges(0)
for i=1,nbins-1  do begin
    xedges[2*i-1:2*i]=bin_edges(i); ;note that bin_edges has nbins+1 elements.
endfor
xedges[nnnn-1]=bin_edges(nbins)

for i=1,nbins  do begin
    yh2dc[2*(i-1):2*i-1]=binh2dc[i-1]
    yh2dp[2*(i-1):2*I-1]=binH2DP[i-1]
    ycomb[2*(i-1):2*i-1]=combinh[i-1]
ENDFOR

; calculate the combined PSD of default break point brkpt
; brkp =600.00;  ; it can be 600, 800, 1000, 1200, 1400, 1600
;datacmb=fltarr(64,nnn)
; indexc=where(bin_edges le brkp)
; indexp=where(bin_edges ge brkp)
; binindexc=indexc[0:n_elements(indexc)-2]
; binindexp=indexp[0:n_elements(indexp)-2]
; for kkk=0,nnn-1  do begin
; datacmb[*,kkk]=[data_2dc[binindexc,kkk], data_2dp[binindexp, kkk]]; #/L/bin
; endfor

;calculate teh combined average.
; combinh=fltarr(64)
; for i=0,63 do begin
; combinh[i]=mean(datacmb[i,*]);     ;in unit  #/L/bin
; endfor
; combinh=combinh/wids  ;            in unit #/L/um
; ycomb=fltarr(nnnn)
; for i=1,nbins  do begin
;      ycomb[2*(i-1):2*i-1]=combinh[i-1]
; ENDFOR

; do  a plot in window 1.
window,/free, xs=500,ys=350,XPOS=510,YPOS=360,title='1  SHEBA 2dc and 2dp'
white=!D.N_COLORS-1
!P.BACKGROUND=white
indxxx=where(yh2dc gt 0.0)
min1=min(yh2dc(indxxx))
indxxx=where(yh2dp gt 0.0)
min2=min(yh2dp(indxxx))
ymin=0.01*min([min1, min2])
ymax=100.0*max([max(yh2dc),max(yh2dp)])
plot,xedges,yh2dc, COLOR=255,/Xlog,/Ylog,ystyle=1, $
    Xrange=[1, 100000.0],Yrange=[ymin, ymax],$
    title='SHEBA 2DC(red)/2DP(black) Particle Size Distribution',$
    xtitle='Size in Micrometer',$
    ytitle='Number/Liter/um'
;extract the string out from string filenames to out put to graphic
;take the first 5 characters of pathnm and last 40 characters of a filename
filenm1=strmid(pathnm,0,5)+'...'+strmid(file2dc,20,/reverse_offset)
filenm2=strmid(pathnm,0,5)+'...'+strmid(file2dp,20,/reverse_offset)
XYOUTS,1.5,0.3*ymax,filenm1,color=255
XYOUTS,1.5,0.09*ymax,filenm2,color=255
oplot,xedges,yh2dp,color=0 ; plot the original data from file
;output the start end time of the two files.
timestring1='2DC start from: '+Stime_2dc_str+'  to '+Etime_2dc_str
timestring2='2DP start from: '+Stime_2dp_str+'  to '+Etime_2dp_str
XYOUTS,1.5,100*ymin,timestring1,color=255
XYOUTS,1.5,30*ymin,timestring2,color=255
XYOUTS,1.5,9*ymin,cdf_time_str,color=255
outfilename='Sheba_2dc_2dp_A.png'
WRITE_png,pathnm+outfilename,tvrd(true=1)

Good=' ';    ;for good or bad
again='y'
while again eq 'y' do begin
    ;;;**********************************************************************
    ; do  a plot in window 2
    window,/free, xs=500,ys=350,XPOS=510,YPOS=360,title='2  SHEBA 2dc and 2dp'
    indxxx=where(ycomb gt 0.0)
    ymin=0.01*min(ycomb(indxxx))
    ymax=100.0*max(ycomb)
    plot,xedges,ycomb,color=255,/Xlog,/Ylog,ystyle=1,$
        Xrange=[1, 100000.0],Yrange=[ymin, ymax],$
        title='SHEBA combined 2dc and 2dp PSD',$
        xtitle='Size in Micrometer',$
        ytitle='Number/Liter/um'
    ;take the first 5 characters of pathnm and last 40 characters of a filename
    filenm1=strmid(pathnm,0,5)+'...'+strmid(file2dc,20,/reverse_offset)
    filenm2=strmid(pathnm,0,5)+'...'+strmid(file2dp,20,/reverse_offset)
    XYOUTS,1.5,0.3*ymax,filenm1,color=255
    XYOUTS,1.5,0.09*ymax,filenm2,color=255
    ;sort out the parts that xedges is greater than the break point.
    indexgtb=where(xedges ge brkp)
    oplot,xedges(indexgtb),ycomb(indexgtb),color=0  ; make it disctincive.
    ;output the start end time of the two files.
    timestring1='2DC start from: '+Stime_2dc_str+'  to '+Etime_2dc_str
    timestring2='2DP start from: '+Stime_2dp_str+'  to '+Etime_2dp_str
    XYOUTS,1.5,100*ymin,timestring1,color=255
    XYOUTS,1.5,30*ymin,timestring2,color=255
    XYOUTS,1.5,9*ymin,cdf_time_str,color=255

    print, 'Does the combined PSD distribution look good ? y/n'
    read, Good
    if ( Good ne 'y') then begin   ; that is it is no good.
        print,' enter a break point choose one of the [600, 800, 1000,1200,1400,1600] only:'
        dooo=1
        inputstr=['600','800','1000','1200','1400','1600']
        answer=' '
        while (dooo eq 1) do begin
            read, answer ;  first read teh break point as a string
            valid=strmatch(inputstr,answer);   ; see if answer matches one of the inputstr.
            if (total(valid) gt 0) then begin
                brkp=1*answer ;  answer is converted to  a number.
                dooo=0;  break out of the while loop
            endif else begin
                print, 'Your input is invalid,  input a digital number !!!!'
            endelse
        endwhile
        ; do recalculate combined average  now.

        indexc=where(bin_edges le brkp)
        indexp=where(bin_edges ge brkp)
        binindexc=indexc[0:n_elements(indexc)-2]
        binindexp=indexp[0:n_elements(indexp)-2]
        combinh=[binh2dc[binindexc],binh2dp[binindexp]];     ;in unit  #/L/um

        ; for kkk=0,nnn-1  do begin
        ; datacmb[*,kkk]=[datapum_2dc[binindexc,kkk], datapum_2dp[binindexp, kkk]]
        ; endfor
        ;calculate the combined average.
        ; combinh=fltarr(64)
        ; for i=0,63 do begin
        ;    combinh[i]=mean(datacmb[i,*])
        ; endfor
        for i=1,nbins  do begin    ;;  ycomb=fltarr(nnnn)
            ycomb[2*(i-1):2*i-1]=combinh[i-1]
        endfor
    endif;  endif of if combined plot is bad.

    if (Good eq 'y') then begin ; that means it is good, we will take teh good preak point
        again='n'                 ; and exit teh whiel loop and assign data and tehn exit this
        ; program.
        outfilename='Sheba_2dc_2dp_B.png'
        WRITE_png,pathnm+outfilename,tvrd(true=1)
        ;end of plotting an input data file filenames particle size distribution
    endif
    wdelete  ; delete the last (current) window. to  make screen having less windows.
endwhile; while of while

;*************************************************************************************
;now assign the #/L/bin data into the output data and area_out, mass_out.
data_out=fltarr(64,nnn)*0.0
npbin_out=fltarr(64,nnn)*0.0
area_out =fltarr(64,nnn)*0.0
mass_out =fltarr(64,nnn)*0.0
; there are 4 time values to consider.
; ST_2dc    ET_2dc   or kstart_2dc  kend-2dc
; ST_2dp    ET_2dp   or kstart_2dp  kend_2dp

;first case of start_time order
if (kstart_2dc ge kstart_2dp)  then begin
    ;data_out from 1 to kstart_2dp will be zero, no need to filled in.
    ;dataOut from kstart_2dp to kstart_2dc  need to be filled with 2dp data.
    for i=long(kstart_2dp),kstart_2dc do begin
        data_out(*,i)=data_2dp(*,i)
        npbin_out(*,i)=npbin_2dp(*,i);   ; for internal calculation use.
        area_out(*,i) =area_2dp(*,i)
        mass_out(*,i) =mass_2dp(*,i)
    endfor   

    if (kend_2dc ge kend_2dp) then begin  ; then from kstart_2dc to kend_2dp is common
        for i=long(kstart_2dc-1), kend_2dp do begin
            data_out(*,i)=[ data_2dc[binindexc,i], data_2dp[binindexp,i] ]
            npbin_out(*,i)=[npbin_2dc[binindexc,i],  npbin_2dp[binindexp,i]]
            ; for internal calculation use.
            area_out(*,i) =[ area_2dc[binindexc,i], area_2dp[binindexp,i] ]
            mass_out(*,i) =[ mass_2dc[binindexc,i], mass_2dp[binindexp,i] ]
        endfor
        for i=long(kend_2dp-1), kend_2dc do begin ; from kend_2dp to kend_2dc we need filled 2dc
            data_out(*,i)=  data_2dc(*,i)
            npbin_out(*,i)=npbin_2dc(*,i);   ; for internal calculation use.
            area_out(*,i) =area_2dc(*,i)
            mass_out(*,i) =mass_2dc(*,i)
        endfor
        ; for i=kend_2dc-1, nnn-1 do begin ;   here after we filled in zeros
        ; data_out(*,i)=  data_2dcPL(*,i)
        ; endfor
    endif

    if (kend_2dc lt kend_2dp) then begin  ; then from kstart_2dc to kend_2dc is common
        for i=long(kstart_2dc-1), kend_2dc do begin
            data_out(*,i)=[ data_2dc[binindexc,i], data_2dp[binindexp,i] ]
            npbin_out(*,i)=[npbin_2dc[binindexc,i],  npbin_2dp[binindexp,i]]
            ; for internal calculation use.
            area_out(*,i) =[ area_2dc[binindexc,i], area_2dp[binindexp,i] ]
            mass_out(*,i) =[ mass_2dc[binindexc,i], mass_2dp[binindexp,i] ]
        endfor

        for i=long(kend_2dc-1), kend_2dp do begin  ; fill in 2dp data
            data_out(*,i)=data_2dp(*,i)
            npbin_out(*,i)=npbin_2dp(*,i);   ; for internal calculation use.
            area_out(*,i) =area_2dp(*,i)
            mass_out(*,i) =mass_2dp(*,i)
        endfor

        ; for i=kend_2dp-1, nnn-1 do begin ;   here after we filled in zeros
        ; data_out(*,i)=  data_2dpPL(*,i)
        ; endfor
    endif
endif ; endif of if kstart-2dc greater than kstart_2dp in time.

;second case of start_time order

if (kstart_2dp ge kstart_2dc)  then begin
    ;data_out from 1 to kstart_2dc will be zero, no need to filled in.
    ;dataOut from kstart_2dc to kstart_2dp  need to be filled with 2dc data.
    for i=long(kstart_2dc),kstart_2dp do begin
        data_out(*,i)=data_2dc(*,i)
        npbin_out(*,i)=npbin_2dc(*,i);   ; for internal calculation use.
        area_out(*,i) =area_2dc(*,i)
        mass_out(*,i) =mass_2dc(*,i)
    endfor   

    if (kend_2dp ge kend_2dc) then begin  ; then from kstart_2dp to kend_2dc is common
        for i=long(kstart_2dp-1), kend_2dc do begin
            data_out(*,i)=[ data_2dc[binindexc,i], data_2dp[binindexp,i] ]
            npbin_out(*,i)=[npbin_2dc[binindexc,i],  npbin_2dp[binindexp,i]]
            ; for internal calculation use.
            area_out(*,i) =[ area_2dc[binindexc,i], area_2dp[binindexp,i] ]
            mass_out(*,i) =[ mass_2dc[binindexc,i], mass_2dp[binindexp,i] ]
        endfor
        for i=long(kend_2dc-1), kend_2dp do begin ; from kend_2dp to kend_2dc we need filled 2dp
            data_out(*,i)=  data_2dp(*,i)
            npbin_out(*,i)=npbin_2dp(*,i);   ; for internal calculation use.
            area_out(*,i) =area_2dp(*,i)
            mass_out(*,i) =mass_2dp(*,i)
        endfor
        ; for i=kend_2dp-1, nnn-1 do begin ;   here after we filled in zeros
        ; data_out(*,i)= 0.0;   data_2dcPL(*,i)
        ; endfor
    endif

    if (kend_2dp lt kend_2dc) then begin  ; then from kstart_2dp to kend_2dp is common
        for i=long(kstart_2dp-1), kend_2dp do begin
            data_out(*,i)=[ data_2dc[binindexc,i], data_2dp[binindexp,i] ]
            npbin_out(*,i)=[npbin_2dc[binindexc,i],  npbin_2dp[binindexp,i]]
            ; for internal calculation use.
            area_out(*,i) =[ area_2dc[binindexc,i], area_2dp[binindexp,i] ]
            mass_out(*,i) =[ mass_2dc[binindexc,i], mass_2dp[binindexp,i] ]
        endfor

        for i=long(kend_2dp-1), kend_2dc do begin  ; fill in 2dc data
            data_out(*,i)=data_2dc(*,i);     ;used for output
            npbin_out(*,i)=npbin_2dc(*,i);   ; for internal calculation use.
            area_out(*,i) =area_2dc(*,i)
            mass_out(*,i) =mass_2dc(*,i)
        endfor

        ; for i=kend_2dc-1, nnn-1 do begin ;   here after we filled in zeros
        ; data_out(*,i)= 0.0;  data_2dcPL(*,i)
        ; endfor
    endif
endif ; endif of if kstart-2dp greater than kstart_2dc in time.

;assign the max size of 2dc and 2dp;  mean size,  combined concentration
twodcp_max=fltarr(nnn)
twodcp_mean=fltarr(nnn)
twodcp_conc=fltarr(nnn)
twodcp_median=fltarr(nnn)
for i=0l, nnn-1 do begin
    twodcp_max(i)=max([twodc_max(i),twodp_max(i)])

    ;we have #/bin  of combined 1 Hz data from npbincmb so each bins has mm particles.
    if (total(npbin_out(*,i)) eq 0) then  begin   ; there is no particle in this second.
        twodcp_mean(i)=0.0
        twodcp_median(i)=0.0
    endif else begin
        twodcp_mean(i)=total(npbin_out(*,i)*bins)/total(npbin_out(*,i));   ;bins is the bin center.
        ;calculate the median within the second.                       ;bins=particle size.
        ;initialized the vector  of all particles size in this second.
        ixsize=[0]
        for ki=0,63 do begin
            mm=npbin_out(ki,i);  number of particle in bin ki
            if (mm gt 0) then  begin
                ixxx=bins(ki)+0*INDGEN(mm)  ; ixxx is a vector of mm elements.
                ixsize=[ixsize,ixxx];       ; put all particles sieze in a vector
            endif
        endfor
        if (n_elements(ixsize) ne 1) then begin
            ixsize=ixsize[1:n_elements(ixsize)-1]   ; take the 0 element out.
            nn=n_elements(ixsize)   ; there are nn particles in this one second interval.
            remainder= nn mod 2
            if (remainder eq 0) then  TWODCP_median[i]=median(ixsize,/even)  ; um
            if (remainder eq 1) then  TWODCP_median[i]=median(ixsize)        ;um
            ;twodcp_mean(i)=  is done in above.
        endif else begin
            Twodcp_median[i]=0.0
        endelse
    endelse

    ;concentration
    twodcp_conc(i)=total(data_out(*,i));      ; data_out(*,i) is #/L/bin
endfor  
;*****************************************************************************************

;added on march 14 2003 to get rid of the spikes from teh twodcp_conc
;***********************************************************************************
; take out the spike points from the twodcp_conc(i)
n555=n_elements(twodcp_conc)
mean555=mean(twodcp_conc,/nan)
std555=stddev(twodcp_conc,/nan)
index555=where(twodcp_conc gt 500.0); mean555+2.0*std555)
if (index555(0) ne -1) then begin
    nn66=n_elements(index555)
    for kk55=0,nn66-1 do begin
        jjj=index555(kk55)
        if (jjj ge 2) then twodcp_conc(jjj)=500;twodcp_conc(jjj-1)*2.0-twodcp_conc(jjj-2)
        if (jjj eq 1) then twodcp_conc(jjj)=500;mean555
        if (jjj eq 0) then twodcp_conc(jjj)=500;mean555
    endfor

endif
end;  end of the du_input+sheba.pro
;**********************************************************************************

;***********************************************************************************

