
; File: Do_DOF_calibration.pro    --2014-11-22
; Author:  Mo Qixu SPEC Inc. <mo@specinc.com>
; Purpose: load a glass bead slide data file and select one or several beads images  or all images to get the focus distribution
;          for different exposure.  a slide is fixed in a DOF position and images are takeing many times in a second.
;          They should be the same, but there is fluctations.   for next DOF posistion the same glass bead will
; have different focus values and appearant size.  we will need to plot out this to see how DOF changes the focus values and
; size obtained from cpiview processing.




PRO DOF_Calib_event, event
    ; this routine handle only motion and mouse button events on the draw area
    ;   XSection  true means draw cross section lines
    forward_function Get_mosaic_ROI

    err=0
    catch,err
    if(err ne 0)then begin
        return
    endif


    WIDGET_CONTROL, event.top, GET_UVALUE=localstate

    pstateinfo=localstate.pstateinfo

    if(size(*pStateInfo,/type) ne 8)then return ; avoid cases where this struture is not defined

    CASE event.TYPE OF

        0: BEGIN   ; Mouse button was pressed
            ; now handle which button was pressed

            case event.press of

                1: BEGIN ;left mouse button

                    x = event.x
                    y = event.y

                    ; the next call determines if the mouse pointer is in an ROI.  if so it returns the index of the particle, else -1
                    info = Get_mosaic_ROI(localstate, x, y)
                    if !addbyremoving eq 1 then begin
                        if info(0) ge 0 then begin
                            ith_roi=info(0)
                            accepted_rois=*!accepted_rois
                            accepted_rois(ith_roi)=0.0;  reject this roi
                            !accepted_rois=ptr_new(accepted_rois)

                            disp_this_frame, localstate
                        endif
                    endif

                    if !pick_a_image eq 1 then begin
                        if info(0) ge 0 then begin
                            ith_roi=info(0)
                            accepted_rois=*!accepted_rois
                            accepted_rois(ith_roi)=1.0;  reject this roi
                            !accepted_rois=ptr_new(accepted_rois)

                            disp_this_frame, localstate
                        endif
                    endif


                END   ;----------  end of right mouse press  case 4 ---------------------------------------------------------------
                4: BEGIN ;right mouse button
                    if localstate.sort_page eq 1 then begin
                        r=dialog_message([['Can not do habit correction in this mode !'],$
                            [' click all/sph/ice and fresh to continue !']],/information)
                        return
                    endif
                END   ;----------  end of right mouse press  case 4 ---------------------------------------------------------------

                else:   ;do nothing for event.press
            endcase  ; end of event.press case statement
        END; end of CASE  0

        1: ;button pressed no action

        2: BEGIN ; Mouse moving - no buttons clicked
            return
        END    ; ******************************************************************** END OF MOTION EVENT ******************
        ELSE:begin ; called for button press and exposure
        message = 'error in view_event... mising case type: '+ string(event.type)
        r=dialog_message(message)
    END
ENDCASE ;( event.type )

END





PRO Do_DOF_Calibration_event, event

    WIDGET_CONTROL, event.top, GET_UVALUE= LocalState,/no_copy
    sname = TAG_NAMES(event, /STRUCTURE_NAME)

    case sname of
        ; Handle a kill request.
        'WIDGET_KILL_REQUEST':begin
        ; I should clean up in here. and release it to go back to zoom window.
        WIDGET_CONTROL, event.top, /DESTROY
        RETURN
    END ;end of 'widget_kill_reguest':begin

    ; Handle a sizing request
    'WIDGET_BASE':begin
    ; WIDGET_CONTROL, event.top, XSIZE =1000, YSIZE =800  ; added by mo sept 9,2004
    ; WIDGET_CONTROL, LocalState.MViewID1, XSIZE = 780, YSIZE =560
    ;Plot_fast_fssp, LocalState
    WIDGET_CONTROL, event.top, SET_UVALUE=LocalState,/no_copy
    return
end

else: begin

    ; a normal event

    WIDGET_CONTROL, event.id, GET_UVALUE = eventval


    CASE eventval OF    ; Note that pos  is not equal Pos, it is case_senitive
        'Help_notes':begin
        messages=[['Note:by Spec Inc  Qixu Mo--moqixu@yahoo.com'],$
            ['                                         '],$
            ['                                         '],$
            ['1. There are 3 options to select images, (a)add by picking, '],$
            ['   it is convenient to do a single or a few images analysis.   '],$
            ['   (b) add by removing unwanted images, the usual way.'],$
            ['   (c) click all images button to select all images.            '],$
            ['                                                                '],$
            ['   To select a time period in which images to be used, you need '],$
            ['   first input Start Frame and End Frame numbers and then click update. '],$
            ['                                                                        '],$
            ['2. For option a) Go to main cpiview interface, click mosaic,and find '],$
            ['   an image frame, then clik startPick and move curve over a roi to pick.'],$
            ['                           '],$
            ['3  The picked roi will show up on left, repeat picking until you got enough.'],$
            ['                        '],$
            ['4. Then, click done_picking and show images, nextPage....................'],$
            ['                                     '],$
            ['5. Then you can click on "fcs/size" or fcs(xy) button to see the plots '],$
            ['                                         '],$
            ['6. Check "savepngs" will save the plots and images to the input roi file folder.'],$
            ['                                                              '],$
            ['7. Click "fcs/size plot" will make the focus/size distribution plots.'],$
            ['                                                              '],$
            ['8. Click "fcs(xy)" to plot focus value distribution on the CCD xy locations.'],$
            ['                                                                             '],$
            ['9. You can type notes in the "notes to label the plots" box to label the plots.'],$
            ['                                                                                  '],$
            ['10. Option b) is similar to a), you just click on images you don"t want, '],$
            ['    after done, simply click show-images check box, nextpage ............... '],$
            ['                                                              '],$
            ['11. To Start a new session, click startover, input StartFrame/EndFrame and'],$
            ['    Click Update, choose option a) or b) or c).....'],$
            ['                                              '],$
            ['12. The plots, Png Images and an ascii file are saved in the input roi file folder.'],$
            ['                                          ']]
        rrr=dialog_message(messages,/information)
    end

    ;*******************************

    'UpdateSEframe': begin
        widget_control, localstate.SframeID, get_value=SFrameNumber;   it is int number.
        widget_control, localstate.EframeID, get_value=EFrameNumber
        localstate.SframeNumber =SFrameNumber
        localstate.EframeNumber =EFrameNumber
        ;get startTime and EndTime str
        get_startTime_endTime_strings, localstate
    end



    'PickParts':begin
    rr=dialog_message('Go to CPI Main Window, Choose a frame for adding images, check "As mosaic" and then click start-picking !',/info)
    !pick_a_image =1
    !accepted_rois=ptr_new()
end

'AddParts':begin
; first time to add an image
Pstateinfo=localstate.Pstateinfo
ROIArray = *(*(*pStateInfo).pFrameData).pFrame
; How many ROIs?
n_imgs = n_elements(  ROIArray )
!accepted_rois=ptr_new(intarr(n_imgs)+0);    force them all are not accepted.
Disp_this_Frame, localstate
rrr=dialog_message('Now, click on the image you want to select on the left pane!',/info)
end; end of addparts:

'DoneAddParts': begin
    if ptr_valid(!accepted_rois) eq 1 then begin
        pstateinfo=localstate.pstateinfo
        ROIArray = *(*(*pStateInfo).pFrameData).pFrame
        ; How many ROIs?
        n_imgs = n_elements(  ROIArray )

        ;show this image in the window.
        ;get_all_ExEySxSy_frameRoinumbers, localstate
        Ex=*(localstate.PEx)
        Ey=*(localstate.PEy)
        Sx=*(localstate.PSx)
        Sy=*(localstate.PSy)
        Frames=*(localstate.PFRames)
        Roinums=*(localstate.PROINUMS)

        ;find indx of all image that macthed location of this image.
        dd=3
        accepted_rois=*!accepted_rois
        nnnn=n_elements(accepted_rois)
        for iiii=0,nnnn-1 do begin
            ;**************
            if accepted_rois(iiii) eq 1 then begin
                ThisEx=ROIArray[iiii].ImageHeader.ex
                ThisEy=ROIArray[iiii].ImageHeader.ey
                ThisSx=ROIArray[iiii].ImageHeader.sx
                ThisSy=ROIArray[iiii].ImageHeader.sy

                index_selected=where(Ex ge thisEx-dd and  Ex le thisEx+dd and $
                    Ey ge thisEy-dd and  Ey le thisEy+dd and $
                    Sx ge thisSx-dd and  Sx le thisSx+dd and $
                    Sy ge thisSy-dd and  Sy le thisSy+dd and $
                    Frames ge localstate.Sframenumber and  $
                    Frames le localstate.Eframenumber,contG)
                if (contG ge 1) then begin

                    if ptr_valid(localstate.PFrames_selected) then begin
                        index_added=[(*localstate.PFrames_selected), index_selected]
                        stored_Frame_index=index_added(uniq(index_added))
                    endif else begin
                        stored_Frame_index=[index_selected]
                    endelse
                    stored_frame_index=stored_frame_index(sort(stored_Frame_index))

                    localstate.PFrames_selected =ptr_new(stored_Frame_index)
                    localstate.PRoinums_selected=ptr_new(stored_Frame_index)
                endif

            endif
        endfor; endfor
        StartFrame_all=Frames(stored_Frame_index(0))
        localstate.StartFrameAll=StartFrame_all
        widget_control,localstate.StartFrameID, set_value=string(StartFrame_all)
        localstate.StartIndex =min(*(localstate.Pframes_selected))
        rrr=dialog_message('Now click show-image, nextpage, or the plots buttons.',/info)
    endif  else begin;   first time to add an image
        rrr=dialog_message(' Image not picked yet ',/info)
    endelse

end; end of Doneaddparts:


'AddbyRemove':  begin
    Pstateinfo=localstate.Pstateinfo
    ROIArray = *(*(*pStateInfo).pFrameData).pFrame
    ; How many ROIs?
    n_imgs = n_elements(  ROIArray )
    !accepted_rois=ptr_new(intarr(n_imgs)+1)
    !addbyremoving=1
    Disp_this_Frame, localstate

    current_frame_number=(*pStateInfo).ImgPos
    rrr=dialog_message('Current Frame you chose is '+strtrim(string(current_frame_number),2),/info)

end


'DoAllImages': begin
    Frames=*(localstate.PFRames)

    if 1 eq 1 then begin;  mo added ths on 2015-05-22 to do special things.
        localstate.Sframenumber=2
        localstate.Eframenumber=88
        stop
    endif

    index_selected=where(Frames ge localstate.Sframenumber and  $
        Frames le localstate.Eframenumber,contG)
    if (contG ge 1 ) then begin
        stored_frame_index=index_selected(sort(index_selected))

        localstate.PFrames_selected =ptr_new(stored_Frame_index)
        localstate.PRoinums_selected=ptr_new(stored_Frame_index)

        StartFrame_all=Frames(stored_Frame_index(0))
        localstate.StartFrameAll=StartFrame_all
        widget_control,localstate.StartFrameID, set_value=string(StartFrame_all)

        localstate.StartFrame=localstate.Sframenumber
        disp_Calibration_frame,LocalState
    endif

end

'showImage': begin

    localstate.StartFrame=1


    if !addbyremoving eq 1 then begin
        get_all_selected_index_from_addbyremoving,localstate
        !addbyremoving=0
    endif
    if ptr_valid(localstate.Pframes_selected) eq 0 then begin
        rrr=dialog_message('particles are not selected yet, select them first please !',/info)
        WIDGET_CONTROL, event.top, SET_UVALUE=LocalState,/no_copy
        return
    endif


    localstate.StartIndex =min(*(localstate.Pframes_selected));  ;minimum of the index_selected
    disp_Calibration_frame,LocalState
end


'Next_page': begin
    ;Change StartTime to be a new Time=last EndTime of the current page and then fill a new page.

    if ptr_valid(localstate.Pframes_selected) eq 0 then begin
        rrr=dialog_message('particles are not selected yet, select them first please !',/info)
        WIDGET_CONTROL, event.top, SET_UVALUE=LocalState,/no_copy
        return
    endif

    localstate.StartFrame=localstate.EndFrame
    localstate.Startindex=localstate.Endindex
    wset,localstate.MViewID1
    Erase
    disp_Calibration_frame,LocalState
end

'FCS_distribution': begin
    if ptr_valid(localstate.Pframes_selected) eq 0 then begin
        rrr=dialog_message('particles are not selected yet, select them first please !',/info)
        WIDGET_CONTROL, event.top, SET_UVALUE=LocalState,/no_copy
        return
    endif

    plot_focus_distribution, LocalState
end

'fcs_xy_distribution': begin

    if ptr_valid(localstate.Pframes_selected) eq 0 then begin
        rrr=dialog_message('particles are not selected yet, select them first please !',/info)
        WIDGET_CONTROL, event.top, SET_UVALUE=LocalState,/no_copy
        return
    endif




    plot_focus_XY_distribution, LocalState
end


'LabelNotes': begin
    widget_control, localstate.NotesID,get_value=cmd
    localstate.Notes = cmd[0]
end

'StartOverAgain':begin
LocalState.Pframes_selected=ptr_new();  to store selected particles' frame numbers.
LocalState.Proinums_selected=ptr_new(); to store selected particles' roi numbers.
LocalState.SFrameNumber     =0;     ; selected time period starting frame number.
widget_control,localstate.SFrameID,set_value=0
LocalState.EFrameNumber     =max(*(localstate.PFrames)); selected time period   ending frame number.
widget_control,localstate.EFrameID,set_value=localstate.EframeNumber
LocalState.CurrentFrame     =1
localstate.savepngs         =0
localstate.oX =0
localstate.maxdy=0
localstate.StartFrame=0; ; for current display particles  with the next_page button.
LocalState.EndFrame  =0
localstate.bounds=lonarr(1000,4)
localstate.ith_roi=0
!accepted_rois =ptr_new()
!addbyremoving=0
!addbyremoving_frame=0
!pick_a_image=0
get_startTime_endTime_strings, localstate
end
'Xmin': begin

end

'Xmax': begin

end

'QUITfile': BEGIN
    WIDGET_CONTROL, event.top, /DESTROY
    RETURN
END ;endof quit
ELSE:
ENDCASE ; end of event.id case
end
endcase ; end of sname case
WIDGET_CONTROL, event.top, SET_UVALUE=LocalState,/no_copy
END ; Do_DOF_calibration_event


pro disp_Calibration_frame, LocalState
    ;   This routine displays a set of ROI particle
    ;   Input
    ;     pStateInfo:   main structure holding all info

    ; Keyword
    ;   frameData     Input  structure of frame data, if not present, use currently stored frame

    ; results
    ;   the frame is drawn to the display taking into acount all GUI settings

    ;return
    ;   the bounds of each particle are returned in the bounds array

    Pstateinfo=localstate.Pstateinfo

    Frames=*(localstate.PFRames);     these are true frame numbers of the imglist.
    Roinums=*(localstate.PROINUMS)

    wset,localstate.MViewID1
    erase
    ;imgListIndx = where((*(*pStateInfo).pFileScan).imgtype ge 0);  and not (*(*pStateInfo).pFileScan).badframe )
    ;imgList = (*(*pStateInfo).pFileScan)[imgListIndx]
    imgList = (*(*pStateInfo).pFileScan)[*(*pStateInfo).pImgPosIndx];  pfilescan is pointer, to each file that has been scanned.

    nnnn=n_elements(imglist)

    frame_numbers= (*(*pStateInfo).pFileScan)[*(*pStateInfo).pImgPosIndx]
    ;frameTimes=frame_numbers.hour*3600.0 +frame_numbers.minute*60.0 +frame_numbers.sec*1.0+frame_numbers.msec/1000.0D
    frametimes=localstate.frametimes

    oX=0
    oY=localstate.scr_ysize
    maxdy =0
    if ptr_valid(localstate.Pframes_selected) eq 0 then begin
        rr=dialog_message('No image selected yet',/info)
        return
    endif

    index_selected=(*localstate.Pframes_selected) 

    Frames_selected=Frames( index_selected  )
    Roinums_selected=Roinums(index_selected ) 

    Frame_start_all=Frames_selected(0)
    Frame_end_all  =max(Frames_selected)

    ;index=where(Frames_selected ge localstate.StartFrame,contG)

    index=where(index_selected ge localstate.StartIndex,contG)


    ith_roi=0
    last_time=0.0D;  added this to compare with current Time so as not to show the same Time of a frame.
    bounds = intarr(1000,4)

    if contG ge 1 then start_K= frames(index_selected(index(0))) else return

    for jjj =0LL, contG-1LL do begin;   nnnn-1LL

        ; following works for
        ; index=where(Frames_selected ge localstate.StartFrame,contG)
        ;k       =frames_selected(this_index)
        ;roinum_k=Roinums_selected(this_index)

        ;following works for
        ;index=where(index_selected ge localstate.StartFrame,contG)

        this_index =index_selected(index(jjj))
        k       =Frames(this_index)
        roinum_k=Roinums(this_index)

        ; must read the image data if any roi display or output is required
        frameData = read_frame((*pStateInfo).InFileLun,(*pStateInfo).FileHead.Ver,imgList[k].fpos,date=(*pStateInfo).date, TSBlanked = imglist[k].TSBlanked)


        frameTime = frameData.FrameHeader.time  ;  This time should be  corrected to = Htime*16^8+ ArivelaT1*16^4 + ArriveT2  August 6, 2010.
        time = convertFromSeconds(frameTime , (*pStateInfo).FileHead.year) ;  Time={month, day, hh, mm, ss, msec} ; change to 4/19/19:20:00.00 format.
        ; added this Part on August 6, 2010 by mooooooooooooo
        Time.day   =framedata.FrameHeader.day   ; Time is uint of 6 numbers.
        Time.hour  =framedata.FrameHeader.hour
        Time.minute=framedata.FrameHeader.minute
        Time.sec   =framedata.FrameHeader.sec
        Time.msec  =framedata.FrameHeader.msec; ;   HOUR =   14;  MINUTE=0; SEC= 11;MSEC=  791  from frameHeader.
        frameTime = Time.hour*3600.0D + time.minute*60.0D + time.sec*1.0D + time.msec/1000.0D;  Changed to this August 6, 2010

        ;***************************************
        ;objData = get_obj_header((*pStateInfo).ObjLUN,(*(*pStateInfo).pObjList)[imgFrmCt].fPos); this line is for regular CPI data file.
        ; objData = get_obj_header((*pStateInfo).ObjLUN,imgList[k].fpos); this line is for regular CPI data file.


        ; need to get calcStrobe time working for 3V-CPI
        ;objTime = float(objData.frameHeader.time) + calcStrobeTime(objData.frameHeader.arrivalT1,objData.frameHeader.arrivalT2,framedata.frameHeader.Ver)/1000.0D
        ;roiTime = float(framedata.frameheader.time) + calcStrobeTime(framedata.frameheader.arrivalT1,framedata.frameheader.arrivalT2,framedata.frameHeader.Ver)/1000.0D
        ; objTime = float(objData.frameHeader.time)
        ; roiTime = float(framedata.frameheader.time)

        imgFrame = (not((frameData.Frameheader.ImgType and 2)/2) and frameData.Frameheader.ROIsCount ge 1 )
        ;ROIArray is an array of pointers for each particle in the frame; imgtype=2 is background.----here alway k=0 frame is bad, no know why.

        pROIArray = FrameData.pFrame

        if(size(frameData,/type) eq 8) and ptr_valid(Proiarray) then begin ; skip if this is not a valid frame


            ; if an Object file exists, then use it NOTE pROIArray is reassigned here to the OBJ data
            imgfrmct=0

            ;if imgframe then getObjData_mo,pStateInfo,framedata,pROIArray,imgFrmCt,objData
            ;if n_elements(!SPEC_3VCPI_DIR)  eq 1  and imgfrme then begin
            ;getObjData_mo,pStateInfo,framedata,pROIArray,imgFrmCt,objData;     ;in processTime_lib2.pro; objdata.pframe is the imagehdear31 of crsytal,cutoff
            ;endif else begin
            if imgframe then begin
                getObjData_mo,pStateInfo,framedata,pROIArray,imgFrmCt,objData;  ; change above of 3VI's to this regular CPI's.
                ;or use this one to get objdata.
                ;objData = get_obj_header((*pStateInfo).ObjLUN,imgList[k].fpos)
            endif
            ; endelse

            ;getobjdata input is imgframe and framedata, returned values is pRoiArray and objdata.
            if n_tags(objdata) lt 3 then goto, next_k
            if ptr_valid((objdata.pframe)) eq 0 then goto,next_k

            objheaders=(*(objdata.pframe))

            ; How many ROIs?
            n_imgs = n_elements( *pROIArray )
            ; loop through all the particles in the frame and accumulate into the histogram array by size

            ROIArray = *frameData.pFrame

            if n_imgs gt n_elements(RoiArray) then goto, next_K


            FOR RoiNum=Roinum_k, Roinum_k DO begin

                objheader = objheaders(roinum).imageheader
                crystal   = objheader.crystal
                cutoff    = objheader.cutoff
                focus     = objheader.focus
                len       = objheader.len
                wid       = objheader.wid
                area      = objheader.area
                perim     = objheader.perim

                dx = ROIArray[Roinum].ImageHeader.ex - ROIArray[Roinum].ImageHeader.sx + 1
                dy = ROIArray[Roinum].ImageHeader.ey - ROIArray[Roinum].ImageHeader.sy + 1
                if dx gt 500.0 or  dy gt 500.0 then begin
                    rrr=dialog_message('image too large, can not dislay, skip over!',/information)
                    goto,End_display
                endif

                ;if accepted(i) ne !true then begin
                ;goto,next_n_imgs;return,0
                ;endif

                if OY lt (dy+20) then begin
                    ;rrr=dialog_message('image too large, can not display, please change time to skip over !',/information)
                    goto,End_display
                endif
                ; need to see if image will be off the screen.
                if(oX + dx GT localstate.scr_xsize*.97)then begin ; image off screen
                    oX = 0
                    OY =Oy-maxdy-20
                    maxdy=dy
                    if OY lt (dy+20) then begin
                        ;rrr=dialog_message('image too large, can not display, please change time to skip over!',/information)
                        goto,End_display
                    endif
                endif

                maxdy = maxdy > dy
                img = *ROIArray[Roinum].pROI

                tv,congrid(bytscl(img,min = scaleMin,max = scaleMax,top=255),dx,dy,/interp),oX, oY-dy
                ; store bounding box coords for checking is mouse is in box

                Timestr1=strtrim(string(time.hour),2)+':'+strtrim(string(Time.minute),2)
                Timestr2=strtrim(string(time.sec),2)+':'+strtrim(string(Time.msec),2)

                xyouts,oX,Oy-dy-5,Timestr1,color=[255,255,255],/device
                xyouts,oX,Oy-dy-15,Timestr2,color=[255,255,255],/device

                objheaders=(*(objdata.pframe))
                objheader =objheaders(roinum).imageheader


                bounds(ith_roi,*)=[oX,oY-dy-1,oX+dx-1,oY];(bounds(0),bounds(1)+1 is the coordinate to tv-image.
                ;print, 'roinum=',Roinum, 'k=',k,'imgfrmct=',imgfrmct-1

                if(oX + dx GT localstate.scr_xsize*.9)then begin ; image off screen
                    oX = 0
                    oY =  oY - maxdy - 20
                    maxdy =0
                endif else begin
                    oX = oX + dx + 2
                    oY = oY
                endelse

                ith_roi=ith_roi+1LL

                next_n_imgs:

            endFOR
            ;localstate.oX=oX;  new furture location to put images.
            ;localstate.oY=oY
            delete_obj_header,objData
            next_k:
            ;*******************************************************************
            if(ptr_valid(FrameData.pFrame))then delete_frame,FrameData
        endif ; end of IF for valid frameData----if(size(frameData,/type) eq 8)then begin ; skip if this is not a valid frame

    endfor   ; end of k loop
    End_display:
    localstate.bounds=bounds
    update_Start_or_end_Frame, localstate, k,this_index;  even the page is not full, still update the frame number to teh text box.
    delete_obj_header,objData


    if localstate.savepngs eq 1 then begin
        basefile=file_basename(localstate.infilename)
        basefile_str=strmid(basefile,0,strlen(basefile)-4)
        outfilename=localstate.pathnm +'Images_'+basefile_str+'_'+strtrim(string(localstate.startframe),2)+'_to_'+strtrim(string(localstate.endframe),2)+'.png'
        write_png,outfilename,tvrd(true=1),/order
    endif
    ;mark the Time series
    wset,localstate.MviewId2
    erase
    CPI_conc=*(*Pstateinfo).pConc
    CPI_hour=localstate.CPI_Hour
    CPI_min =localstate.CPI_min
    CPI_sec =localstate.CPI_sec
    plot,CPI_conc,color=255,xstyle=1,ystyle=4,psym=10,xmargin=[0.3,0.3],ymargin=[2,0]
    nnnn=n_elements(CPI_conc)
    for i=1,10 do begin
        index=0L+(i-1)*nnnn/10L
        if CPI_hour(index) lt 10 then hh_str='0'+strtrim(string(CPI_hour(index)),2) else hh_str=strtrim(string(CPI_hour(index)),2)
        if CPI_min(index)  lt 10 then mm_str='0'+strtrim(string(CPI_min(index)),2)  else mm_str=strtrim(string(CPI_min(index)),2)
        if CPI_sec(index)  lt 10 then ss_str='0'+strtrim(string(CPI_sec(index)),2)  else ss_str=strtrim(string(CPI_sec(index)),2)
        time_str=hh_str+':'+mm_str+':'+ss_str
        xyouts,0+1220*(i-1)/10L,40,time_str,color=[240,255,255],/device
    endfor
    oplot,[start_K,start_K],[0,10],color=200
    oplot,[k,k],[0,10],color=200
    heap_gc
end

PRO Do_DOF_Calibration, PstateInfo, GROUP=GROUP

    if(ptr_valid((*pStateInfo).pFileScan) eq 0) then begin
        r = dialog_message('Error: No CPI ROI file data available. Open a CPI data file first.')
        ;stop

        return
    endif
    defsysv,'!Do_DOF_Calib', 1
    defsysv,'!addbyremoving',0
    defsysv,'!pick_a_image',0
    defsysv,'!addbyremoving_frame',0
    defsysv,'!accepted_rois',ptr_new()

    tlb = WIDGET_BASE(GROUP_LEADER=Group, /TLB_KILL_REQUEST_EVENTS, /TLB_SIZE_EVENTS, /col, TITLE='CPI DOF calibration program',mbar=menuBase)
    ;-----------------------------------------------------
    button_bar = widget_base(tlb,/row)
    ; Menu
    box_size = 3
    b311 = widget_base(button_bar,/row)
    SFrameID   = cw_field(b311,title='Do Frames:',value=1,/int,xsize=5,uvalue ='StartFrame',/all)
    EFrameID   = cw_field(b311,title='To',value=100,/int,xsize=5,uvalue ='EndFrame',/all)
    updateID = widget_button(b311, value = 'Update', uvalue = 'UpdateSEframe', TOOLTIP='Update Start Frame and EndFrame')

    label   = widget_label(b311,value='Frms showed:')
    startFrameID   = widget_text(b311,value='0',uvalue='XY',xsize =5)
    label   = widget_label(b311,value='-')
    endFrameID  = widget_text(b311,value='0',uvalue='XY',xsize =5)

    b312 =widget_base(b311,/row,/frame)
    pickID       = widget_button(b312, value = 'Option A: Add-by-picking', uvalue = 'PickParts')
    addID        = widget_button(b312, value = 'StartPicking',     uvalue = 'AddParts')
    Done_addID   = widget_button(b312, value = 'Done_Picking',     uvalue = 'DoneAddParts')



    addbyreject  = widget_button(b311, value = 'Option B: Add by Remove',  uvalue = 'AddbyRemove',TOOLTIP='Keep remained rois by cliking and removing unwanted ones')
    DoAllID      = widget_button(b311, value = 'Option C: use All-Images', uvalue = 'DoAllImages',TOOLTIP='Use all images, No need to select images.')
    showimgsID = widget_button(b311, value = 'ShowImage',uvalue = 'showImage',TOOLTIP='show images from the selected xy positions');)

    nextID = widget_button(b311, value = 'Next Page',       uvalue = 'Next_page')

    basefilter2=widget_base(b311,col=1,/nonexclusive)
    makepngID =widget_button(basefilter2,value= 'Save Pngs',uvalue ='SavePngs',event_pro='SavePngs_event')

    b313 = widget_base(tlb,/row)
    b34 = widget_base(b313,/col,/frame);, sensitive = (*pStateInfo).AUTOEXTRACT
    b35 = widget_base(b313,/col);, sensitive = (*pStateInfo).AUTOEXTRACT
    b36 = widget_base(b313,/col);,
    b37 = widget_base(b313,/col);,
    b38 = widget_base(b313,/col);,
    b39 = widget_base(b313,/col);,
    b40 = widget_base(b313,/col);,
    baccept2 = widget_base(b34,/row)
    label = widget_label(baccept2,value = 'Notes to label the plots',ysize = 25)
    NotesID = widget_text(baccept2,value='my label notes: DOF= ',/editable,/all,uvalue='LabelNotes',xsize = 90)
    startover =widget_button(b35, value = 'Start Over', uvalue = 'StartOverAgain',TOOLTIP='wipe off and/or then start a new period.')
    showFCS_size_ID = widget_button(b36, value = 'fcs/size plots',    uvalue = 'FCS_distribution')
    showxyfcsID     = widget_button(b37, value = 'fcs(x,y) plots',    uvalue = 'fcs_xy_distribution')
    helpID      = widget_button(b38, value = 'Help notes',      uvalue = 'Help_notes')
    XminID = cw_field(b39,title='Xmin:',value=3,/int,xsize=5,uvalue ='SizeXmin',/all)
    XmaxID = cw_field(b40,title='Xmax:',value=1000,/int,xsize=5,uvalue ='SizeXmax',/all)
    ;*****************************************************
    ; button bar   add options label
    pageX=1220
    pageY=570
    MAINBase = widget_base(tlb,/row)

    ; Image View and image-related labels
    ViewBase = WIDGET_BASE(MAINBase, /COL,TITLE='ImgView', UVALUE=' ',event_pro = 'DOF_calib_event')

    ;*****************************************************
    MainView1 = WIDGET_DRAW(viewBase, UVALUE='MAIN_VIEW1',/BUTTON_EVENTS, /FRAME, /MOTION_EVENTS, $$
        XSIZE=pageX, YSIZE=pageY); X_SCROLL_SIZE=800, Y_SCROLL_SIZE=800);  ; this is added by mo spet9, 2004

    ;*****************************************************
    MainView2 = WIDGET_DRAW(viewBase, UVALUE='MAIN_VIEW2', $
        XSIZE=pageX, YSIZE=50); X_SCROLL_SIZE=800, Y_SCROLL_SIZE=800);  ; this is added by mo spet9, 2004
    ;***************************************************************************************
    FileName =' ';Filenm

    WIDGET_CONTROL, MAINBase, /REALIZE
    ; Get drawable window index
    WIDGET_CONTROL, MainView1, GET_VALUE=MViewID1
    WIDGET_CONTROL, MainView2, GET_VALUE=MViewID2
    WIDGET_CONTROL, tlb,xoffset=500, yoffset=10, /REALIZE

    ;begin to fill in all the images in the mainview.
    ;****************************************************************
    ; first get the start Time and assume the crystal habits are water.
    ; choose to output only good frame images.

    frame_numbers= (*(*pStateInfo).pFileScan)[*(*pStateInfo).pImgPosIndx]
    frameTimes=frame_numbers.hour*3600.0 +frame_numbers.minute*60.0 +frame_numbers.sec*1.0+frame_numbers.msec/1000.0D
    ii=n_elements(frame_numbers)-1LL

    ;imgListIndx = where((*(*pStateInfo).pFileScan).imgtype ge 0);  and not (*(*pStateInfo).pFileScan).badframe )
    ;imgList = (*(*pStateInfo).pFileScan)[imgListIndx]
    imgList = (*(*pStateInfo).pFileScan)[*(*pStateInfo).pImgPosIndx];  pfilescan is pointer, to each file that has been scanned.




    ;find imglist Time in one time
    nnnn=n_elements(imglist)
    frametimes=fltarr(nnnn)+0.0D
    for k=0L,nnnn-1L do begin
        frameData = read_frame((*pStateInfo).InFileLun,(*pStateInfo).FileHead.Ver,imgList[k].fpos,date=(*pStateInfo).date, TSBlanked = imglist[k].TSBlanked)
        frameTime = frameData.FrameHeader.time  ;  This time should be  corrected to = Htime*16^8+ ArivelaT1*16^4 + ArriveT2  August 6, 2010.
        time = convertFromSeconds(frameTime , (*pStateInfo).FileHead.year) ;  Time={month, day, hh, mm, ss, msec} ; change to 4/19/19:20:00.00 format.
        Time.hour  =framedata.FrameHeader.hour
        Time.minute=framedata.FrameHeader.minute
        Time.sec   =framedata.FrameHeader.sec
        Time.msec  =framedata.FrameHeader.msec; ;   HOUR =   14;  MINUTE=0; SEC= 11;MSEC=  791  from frameHeader.
        frameTimes(k) = Time.hour*3600.0 + time.minute*60.0 + time.sec + time.msec/1000.0D;  Changed to this August 6, 2010
    endfor

    CPI_conc=*(*Pstateinfo).pConc
    CPI_hour=1*Frame_numbers.Hour
    CPI_min =1*Frame_numbers.minute
    CPI_sec =1*Frame_numbers.sec

    if (fstat((*Pstateinfo).objlun)).write eq 0 then begin
        close,(*Pstateinfo).objlun
        free_lun,(*Pstateinfo).objlun
        openu,(*Pstateinfo).objlun,(*Pstateinfo).objfile
    endif


    ;make 9 Time labels.
    wset,MViewID2
    plot,CPI_conc,color=255,xstyle=1,ystyle=4,psym=10,xmargin=[0.3,0.3],ymargin=[2,0]

    nnnn=n_elements(CPI_conc)
    for i=1,10 do begin
        index=0L+(i-1)*nnnn/10L
        if CPI_hour(index) lt 10 then hh_str='0'+strtrim(string(CPI_hour(index)),2) else hh_str=strtrim(string(CPI_hour(index)),2)
        if CPI_min(index)  lt 10 then mm_str='0'+strtrim(string(CPI_min(index)),2)  else mm_str=strtrim(string(CPI_min(index)),2)
        if CPI_sec(index)  lt 10 then ss_str='0'+strtrim(string(CPI_sec(index)),2)  else ss_str=strtrim(string(CPI_sec(index)),2)
        time_str=hh_str+':'+mm_str+':'+ss_str
        xyouts,0+1220*(i-1)/10L,40,time_str,color=[240,255,255],/device
    endfor

    Timeinfo={first_time:0,$
        last_time:0,$
        current_time:0,$
        next_time:0,$
        prev_time:0,$
        pcurrent_link: ptr_new()$
        }


    LocalState = {MViewID1:MViewID1,$
        MViewID2:MViewID2,$
        pstateinfo:pstateinfo,$
        Timeinfo:ptr_new(Time_info),$
        PEx:ptr_new(),$;  to store all particles'  x, Y coordinate position relatiov eto the CCD.
        PEy:ptr_new(),$
        PSx:ptr_new(),$;  to store all particles'  x, Y coordinate position relatiov eto the CCD.
        PSy:ptr_new(),$
        Pframes:ptr_new(),$;  to store all particles' frame numbers.
        Proinums:ptr_new(),$; to store all particles' roi numbers.
        pfcs:ptr_new(),$; store all particles focus values,
        plen:ptr_new(),$; store all particles length values,
        pwid:ptr_new(),$; store all particle width values
        pDia:ptr_new(),$; store all particles length values,
        pDapp:ptr_new(),$; store all particles length values,
        Pframes_selected:ptr_new(),$;  to store selected particles' frame numbers.
        Proinums_selected:ptr_new(),$; to store selected particles' roi numbers.
        StartFrameAll:0,$  ; for all particle
        EndFrameALL:0,$
        SFrameNumber:1,$  ; selected time period starting frame number.
        EFrameNumber:0,$  ; selected time period   ending frame number.
        startTime:' ',$   ;selected StartTime
        endtime:' ',$     ;selected EndTime
        CurrentFrame:0,$
        pathnm: (*pstateinfo).path,$
        infilename: (*pstateinfo).infilename, $
        makepngID:makePngId,$
        savepngs:0,$
        scr_xsize:pageX,$
        scr_ysize:pageY,$
        oX:0,$
        oY:pageY,$,
    maxdy:0,$
        StartFrameID:StartFRameID,$ ; for current display particles.
        EndFrameID:EndFrameID,$
        StartFrame:0,$ ; for current display particles  with the next_page button.
        EndFrame:0,$
        Startindex:0,$ ; for current display particles  with the next_page button.
        Endindex:0,$
        SFrameID:SFRameID,$ ; for selected Time period widgets..
        EFrameID:EFrameID,$
        frameTimes:frametimes,$;  valid frame's imglist time in seconds.xxx format.
        bounds:lonarr(1000,4),$
        bounds_sort:lonarr(1000,4),$
        ith_roi:0,$
        CPI_hour:CPI_hour,$
        CPI_min:CPI_min,$
        CPI_sec:CPI_sec,$
        XminID:XminID,$
        XmaxId:XmaxID,$
        Xmin:3,$
        Xmax:1000,$
        NotesID:notesID,$
        Notes:'my label notes DOF=' $
        };******added august 19,2005

    get_all_ExEySxSy_frameRoinumbers, localstate,objdata_generated;  it also check if objdata fiel are generated or not.
    if objdata_generated eq 0 then begin
        WIDGET_CONTROL, tlb, /DESTROY
        return
    endif

    localstate.Eframenumber=max(*(localstate.Pframes))
    get_startTime_endTime_strings, localstate
    widget_control,localstate.EframeID,set_value=localstate.Eframenumber

    ; Save state
    WIDGET_CONTROL, tlb, SET_UVALUE=LocalState,/no_copy

    ; Hand off control of the widget to the XMANAGER:
    XMANAGER, 'Do_DOF_calibration', tlb, /NO_BLOCK
    ;XMANAGER, 'Do_manual_habit_change', tlb, /JUST_REG;   change above to this on June 3,2005.
END ; Do_manual_habit_change

pro update_Start_or_end_Frame, localstate, Frame,this_index
    widget_control,localstate.StartFrameID,set_value=strtrim(string(localstate.StartFrame),2)
    widget_control,localstate.EndFrameID,set_value=strtrim(string(Frame),2)
    localstate.EndFrame=Frame
    localstate.Endindex=this_index+1
    heap_gc
end; update_Start_or_end_Frame, localstate

;===============================================================================
pro Disp_this_Frame, localstate
    ;pStateInfo, pBoundary=pBoundary, frameData = frameData, dispwindow = dispwindow, image_mean=image_mean, return_image=return_image
    ;   This routine displays a set of ROI particles in the Draw window
    ;   Input
    ;     pStateInfo:   main structure holding all info

    ; Keyword
    ;   pBoundary     Input  pointer array of perimeter pixels, if present display with perimeter
    ;   frameData     Input  structure of frame data, if not present, use currently stored frame

    ; results
    ;   the frame is drawn to the display taking into acount all GUI settings

    ;return
    ;   the bounds of each particle are returned in the bounds array


    Pstateinfo=localstate.Pstateinfo
    if  (*pStateInfo).settings.mosaic  eq 0 then begin
        rrr=dialog_message('AS Mosaic is not checked yet, check it before continue.',/info)
        return
    endif


    wset,localstate.MViewID1
    erase

    ROIArray = *(*(*pStateInfo).pFrameData).pFrame
    FrameData=*(*pStateInfo).pFrameData
    frameTime = frameData.FrameHeader.time  ;  This time should be  corrected to = Htime*16^8+ ArivelaT1*16^4 + ArriveT2  August 6, 2010.
    time = convertFromSeconds(frameTime , (*pStateInfo).FileHead.year) ;  Time={month, day, hh, mm, ss, msec} ; change to 4/19/19:20:00.00 format.
    ; added this Part on August 6, 2010 by mooooooooooooo
    Time.day   =framedata.FrameHeader.day   ; Time is uint of 6 numbers.
    Time.hour  =framedata.FrameHeader.hour
    Time.minute=framedata.FrameHeader.minute
    Time.sec   =framedata.FrameHeader.sec
    Time.msec  =framedata.FrameHeader.msec; ;   HOUR =   14;  MINUTE=0; SEC= 11;MSEC=  791  from frameHeader.
    if time.hour   le 9 then hh_str='0'+string(Time.hour,  format='(I1)') else hh_str=string(Time.hour,  format='(I2)')
    if time.minute le 9 then mm_str='0'+string(Time.minute,format='(I1)') else mm_str=string(Time.minute,format='(I2)')
    if time.sec    le 9 then ss_str='0'+string(Time.sec,   format='(I1)') else ss_str=string(Time.sec,   format='(I2)')
    if time.msec   le 9 then ms_str='00'+string(Time.msec,  format='(I1)')
    if time.msec   ge 10 and time.msec le 99 then ms_str='0'+string(Time.msec,  format='(I2)')
    if time.msec   ge 100                    then ms_str= string(Time.msec,  format='(I3)')
    Time_str=hh_str+mm_str+ss_str+'m'+ms_str



    ; How many ROIs?
    n_imgs = n_elements(  ROIArray )

    ; get zoom factor from gui
    ;widget_control,(*pStateInfo).ZoomID,get_value = zoom
    zoom = (*pStateInfo).zoom

    ; get aspect ratio from window
    widget_control,(*pStateInfo).AspectID,get_value = YXAspect

    mosaic = (*pStateInfo).settings.mosaic

    ;get scroll size in x
    geomInfo = widget_info((*pStateInfo).MainView,/geometry)

    ; get scale values
    ;WIDGET_CONTROL, (*pStateInfo).ScaleMinID,get_value = scaleMin
    ;WIDGET_CONTROL, (*pStateInfo).ScaleMaxID,get_value = scaleMax

    oX = 0
    oY = 0
    maxdy = 0
    bounds = intarr(1000,4)
    accepted_rois=*!accepted_rois

    if !addbyremoving eq 1 then begin

        FOR i=0, n_imgs - 1 DO begin

            ;determine size of image including zoom factor
            dx = ROIArray[i].ImageHeader.ex - ROIArray[i].ImageHeader.sx + 1
            dy = ROIArray[i].ImageHeader.ey - ROIArray[i].ImageHeader.sy + 1
            dx = round(zoom * YXAspect * dx)
            dy = round(zoom * dy)

            if( Mosaic )then begin
                oX = zoom * YXAspect * ROIArray[i].ImageHeader.sx
                oY = zoom * ((*pStateInfo).FileHead.DY - 1 - ROIArray[i].ImageHeader.ey)
                x = [0,round(zoom * ((*pStateInfo).FileHead.DX - 1)),round(zoom * ((*pStateInfo).FileHead.DX - 1)),0,0]
                y = [0,0,round(zoom * ((*pStateInfo).FileHead.DY - 1)),round(zoom * ((*pStateInfo).FileHead.DY - 1)),0]
                ;plots,x,y,color=200,/device
            endif

            maxdy = maxdy > dy

            img = *ROIArray[i].pROI
            ; display the image

            if accepted_rois(i) eq 1 then begin
                tv, congrid(bytscl(img, min = scaleMin, max = scaleMax, top=255), dx, dy, /interp), oX, oY
            endif

            ;bounds(ith_roi,*)=[oX,oY-dy-1,oX+dx-1,oY,Roinum,k,objheader.crystal];(bounds(0),bounds(1)+1 is the coordinate to tv-image.
            bounds[i,*] = [oX,oY,oX+dx-1,oY+dy-1]


        endFOR
    endif


    if !pick_a_image eq 1 then begin
        oX_offset =590; for displaying the pick images on the right side of the screen.
        ;display the separation line.
        line_image=bytarr(3,570)+255
        tv,line_image,OX_offset,0

        FOR i=0, n_imgs - 1 DO begin

            ;determine size of image including zoom factor
            dx = ROIArray[i].ImageHeader.ex - ROIArray[i].ImageHeader.sx + 1
            dy = ROIArray[i].ImageHeader.ey - ROIArray[i].ImageHeader.sy + 1
            dx = round(zoom * YXAspect * dx)
            dy = round(zoom * dy)

            if( Mosaic )then begin
                oX = zoom * YXAspect * ROIArray[i].ImageHeader.sx
                oY = zoom * ((*pStateInfo).FileHead.DY - 1 - ROIArray[i].ImageHeader.ey)
                x = [0,round(zoom * ((*pStateInfo).FileHead.DX - 1)),round(zoom * ((*pStateInfo).FileHead.DX - 1)),0,0]
                y = [0,0,round(zoom * ((*pStateInfo).FileHead.DY - 1)),round(zoom * ((*pStateInfo).FileHead.DY - 1)),0]
                ;plots,x,y,color=200,/device
            endif

            maxdy = maxdy > dy

            img = *ROIArray[i].pROI

            ; display the image
            if accepted_rois(i) eq 0 then begin
                tv, congrid(bytscl(img, min = scaleMin, max = scaleMax, top=255), dx, dy, /interp), oX, oY
            endif

            if accepted_rois(i) eq 1 then begin
                tv, congrid(bytscl(img, min = scaleMin, max = scaleMax, top=255), dx, dy, /interp), oX+OX_offset, oY
            endif

            ;bounds(ith_roi,*)=[oX,oY-dy-1,oX+dx-1,oY,Roinum,k,objheader.crystal];(bounds(0),bounds(1)+1 is the coordinate to tv-image.
            bounds[i,*] = [oX,oY,oX+dx-1,oY+dy-1]


        endFOR
    endif


    localstate.bounds=bounds

    ;save the mosaic images' frame
    basefile=file_basename(localstate.infilename)
    basefile_str=strmid(basefile,0,strlen(basefile)-4)
    outfilename=localstate.pathnm +'Images_mosaic_'+basefile_str+'_'+time_str+'.png'
    x0=0
    y0=0
    Nx=600
    Ny=530
    write_png,outfilename,tvrd(x0,y0,Nx,Ny,true=1),/order

    if !pick_a_image eq 1 then begin
        write_png,outfilename,tvrd(x0+OX_offset,y0,Nx,Ny,true=1),/order
    endif

end









pro get_all_ExEySxSy_frameRoinumbers, localstate,objdata_generated

    pStateInfo=localstate.pStateInfo

    objdata_generated=0;   if objdtata_generated=1,  this subroutine call is successiful, if it is zero, it is not sucess.

    ;imgListIndx = where((*(*pStateInfo).pFileScan).imgtype ge 0);  and not (*(*pStateInfo).pFileScan).badframe )
    ;imgList = (*(*pStateInfo).pFileScan)[imgListIndx]
    imgList = (*(*pStateInfo).pFileScan)[*(*pStateInfo).pImgPosIndx];  pfilescan is pointer, to each file that has been scanned.

    Ex=[0]
    Ey=[0]
    Sx=[0]
    Sy=[0]
    FrameS=[0]
    RoinumS=[0]
    FrameTimes=[0]
    fcss=[0]
    lens=[0]
    wids=[0]
    areas=[0]

    WIDGET_CONTROL, /HOURGLASS
    nnnn=n_elements(imglist)
    frametimes=fltarr(nnnn)+0.0D
    for k=0L,nnnn-1L do begin
        frameData = read_frame((*pStateInfo).InFileLun,(*pStateInfo).FileHead.Ver,imgList[k].fpos,date=(*pStateInfo).date, TSBlanked = imglist[k].TSBlanked)
        frameTime = frameData.FrameHeader.time  ;  This time should be  corrected to = Htime*16^8+ ArivelaT1*16^4 + ArriveT2  August 6, 2010.
        time = convertFromSeconds(frameTime , (*pStateInfo).FileHead.year) ;  Time={month, day, hh, mm, ss, msec} ; change to 4/19/19:20:00.00 format.
        Time.hour  =framedata.FrameHeader.hour
        Time.minute=framedata.FrameHeader.minute
        Time.sec   =framedata.FrameHeader.sec
        Time.msec  =framedata.FrameHeader.msec; ;   HOUR =   14;  MINUTE=0; SEC= 11;MSEC=  791  from frameHeader.
        frameTime = Time.hour*3600.0 + time.minute*60.0 + time.sec + time.msec/1000.0D;  Changed to this August 6, 2010

        imgFrame = (not((frameData.Frameheader.ImgType and 2)/2) and frameData.Frameheader.ROIsCount ge 1 )
        ;ROIArray is an array of pointers for each particle in the frame; imgtype=2 is background.----here alway k=0 frame is bad, no know why.

        pROIArray = FrameData.pFrame

        if(size(frameData,/type) eq 8) and ptr_valid(Proiarray) then begin ; skip if this is not a valid frame

            ; if an Object file exists, then use it NOTE pROIArray is reassigned here to the OBJ data
            imgfrmct=0

            if imgframe then begin
                getObjData_mo,pStateInfo,framedata,pROIArray,imgFrmCt,objData;  ; change above of 3VI's to this regular CPI's.
            endif

            if n_tags(objdata) lt 3 then begin
                goto, next_k
                rrr=dialog_message('It seems that the Obj data file has not been generated yet !!  Do that first and then begin again.',/info)
                objdata_generated=0
                return
            endif

            ;if ptr_valid((objdata.pframe)) eq 0 then goto,next_k

            objheaders=(*(objdata.pframe))
            n_imgs = n_elements( *pROIArray )
            ROIArray = *frameData.pFrame

            if n_elements(objheaders) ne n_imgs then goto, next_K

            FOR RoiNum=0, n_imgs-1 DO begin
                Ex=[Ex,ROIArray[Roinum].ImageHeader.ex]
                Ey=[Ey,ROIArray[Roinum].ImageHeader.ey]
                Sx=[Sx,ROIArray[Roinum].ImageHeader.sx]
                Sy=[Sy,ROIArray[Roinum].ImageHeader.sy]


                ; get the valuse of the obj fcs,wid and length.
                objheader = objheaders(roinum).imageheader
                crystal   = objheader.crystal
                cutoff    = objheader.cutoff
                focus     = objheader.focus
                len       = objheader.len
                wid       = objheader.wid
                area      = objheader.area
                perim     = objheader.perim

                Frames=[Frames,k]
                roinums=[roinums,roinum]
                fcss   =[fcss,focus]
                lens   =[lens,len]
                wids   =[wids,wid]
                areas  =[areas,area]
            endfor
        endif
        next_k:  ; do_nothing.
    endfor
    DDa =(lens+wids)/2.0

    Get_Dcor_Lcor_Wcor, Dcor,Lcor,Wcor,lens,wids,fcss,Dapp,areas;   here len wid are pixels in unit.

    nnnn=n_elements(Ex)
    localstate.PEx=ptr_new(Ex(1:nnnn-1))
    localstate.PEy=ptr_new(Ey(1:nnnn-1))
    localstate.PSx=ptr_new(Sx(1:nnnn-1))
    localstate.PSy=ptr_new(Sy(1:nnnn-1))
    localstate.Pframes =ptr_new(frames(1:nnnn-1))
    localstate.Proinums=ptr_new(roinums(1:nnnn-1))
    localstate.Pfcs =ptr_new(fcss(1:nnnn-1))
    localstate.PDia=ptr_new(Dcor(1:nnnn-1))
    localstate.Pwid=ptr_new(Wcor(1:nnnn-1))
    localstate.Plen=ptr_new(Lcor(1:nnnn-1))
    localstate.PDapp=ptr_new(Dapp(1:nnnn-1));   apparant size;  not focus corrected.
    objdata_generated=1

    Xmax=max(Dapp)

    indexkk=where(Dapp gt 0.0, contG)
    if contG gt 0 then begin
        vector =Dcor(indexkk)
        Xmin   =min(vector) > 3
    endif else Xmin=3

    localstate.Xmin=Xmin
    localstate.Xmax=Xmax

    widget_control, localstate.XminID, set_value=Xmin
    widget_control, localstate.XmaxID, set_value=Xmax

    heap_gc
end; get_all_ExEySxSy_frameRoinumbers, localstate,objdata_generated

pro SavePngs_event,event
    Widget_Control, event.top, Get_UValue=localstate, /No_Copy  ; get our info structure
    ;***********************************************************
    if localstate.savepngs eq 0 then begin
        localstate.savepngs =1
    endif  else begin
        localstate.savepngs =0
    endelse
    widget_control,localstate.makepngID,set_button=localstate.savepngs
    ;***********************************************************
    Widget_Control, event.top, Set_UValue=localstate, /No_Copy  ; get our info structure
    heap_gc
end


pro  plot_focus_distribution, localstate


    Ex=*(localstate.PEx)
    Ey=*(localstate.PEy)
    Sx=*(localstate.PSx)
    Sy=*(localstate.PSy)
    Xc=(Ex+Sx)/2.0
    Yc=(Ey+Sy)/2.0


    Frames=*(localstate.PFRames);     these are true frame numbers of the imglist.
    Roinums=*(localstate.PROINUMS)
    fcs    =*(localstate.pfcs)
    lens   =*(localstate.plen)
    wids   =*(localstate.pwid)
    dias   =*(localstate.pdia)
    dapps  =*(localstate.pdapp)

    if ptr_valid(localstate.Pframes_selected) eq 0 then return
    index_selected=(*localstate.Pframes_selected)

    fcs_selected  =fcs(index_selected)
    lens_selected =lens(index_selected)
    wids_selected =wids(index_selected)
    dias_selected =dias(index_selected)
    dapps_selected=dapps(index_selected)

    mean_len   =mean(lens_selected)
    mean_wid   =mean(wids_selected)
    mean_dia   =mean(dias_selected)
    mean_dapps =mean(dapps_selected)

    Xc_selected =Xc(index_selected)
    Yc_selected=Yc(index_selected)



    result=histogram(fcs_selected, binsize=2, min=0,max=100)


    wset,localstate.MViewID1
    erase

    !P.MULTI = [0, 2, 1, 0, 0]
    !X.OMARGIN = [1.5,0.0]  ;We need this because the Area plot X axis label extends off the left edge of the window
    ;-------------------------------------------------------------------
    ; Determine which particles we're plotting, H or V
    ;-------------------------------------------------------------------

    xbins=Indgen(50)*2.0
    ymin=0
    ymax=round(1.1*max(result))

    plot,xbins,result,color=0,xstyle=1,ystyle=1,xmargin=[9,3],ymargin=[6,6],charsize=1.2,xrange=[0,100], yrange=[ymin,ymax],$
        xtitle='focus(bin,%)', ytitle='number of images', title='focus distribution of selected images', background=255

    xyouts,0.02,0.06,'Frames: '+strtrim(string(localstate.SframeNumber),2)+'---'+strtrim(string(localstate.Eframenumber),2),color=200,/normal

    StartTime_EndTime_str='Time: '+strtrim(string(localstate.StartTime),2)+'--'+strtrim(string(localstate.EndTime),2)
    xyouts,0.45,0.06,StartTime_EndTime_str,color=200,/normal

    xyouts,0.5,0.02,localstate.notes,color=200,/normal,alignment=0.5
    ; do the size distribution plots
    ; xmin=440;(min([wids_selected,lens_selected])-5) >0.0
    ; xmax=530;  80; ;(max([wids_selected,lens_selected])+5) 
    widget_control, localstate.XminID, get_value=Xmin;   it is int number.
    widget_control, localstate.XmaxID, get_value=Xmax
    localstate.Xmax =Xmax
    localstate.Xmin =Xmin
    xrange=[xmin,xmax]
    binsize=2
    nbins = ceil( (xmax- xmin)/2.0)
    xbins =indgen(nbins)*2 + xmin


    yDapps =histogram(dapps_selected,binsize=binsize,min=xmin,max=xmax)

    ylens =histogram(dias_selected,binsize=binsize,min=xmin,max=xmax)
    ywids =histogram(wids_selected,binsize=binsize,min=xmin,max=xmax)
    ymax=round(1.1*max([ylens,ywids]))

    plot,xbins,ylens,color=0,xstyle=1,ystyle=1,xmargin=[9,3],ymargin=[6,6],charsize=1.2,xrange=[xmin,xmax], yrange=[0.0,ymax],$
        xtitle='size(bin,um)', ytitle='number of images', title='Apparent Size (Dapp) and focus corrected Size (Dia)',background=255
    oplot,xbins, yDapps, color=150

    indexgt0=where(ylens gt 0.0,contG)
    if contG gt 0 then begin
        oplot,xbins(indexgt0), ylens(indexgt0),psym=2, color=0
        index=where( ylens(indexgt0) eq max(ylens(indexgt0)))
        xbinsgt0=xbins(indexgt0)
        diapeak=xbinsgt0(index(0))
    endif else begin
        rrrr=dialog_message('No particles exist in the elected xmin Xmax range, try again !',/info)
        stop
        return
    endelse

    xyouts,0.80,0.78,'peak(Dia)='+strtrim(string(format='(F7.1)',diapeak),2),color=0,charsize=1.2,/normal

    indexgt0=where(yDapps gt 0.0,contG)

    if contG gt 0 then begin
        oplot,xbins(indexgt0), yDapps(indexgt0),psym=2, color=150
        index=where( yDapps(indexgt0) eq max(yDapps(indexgt0)))
        xbinsgt0=xbins(indexgt0)
        diapeak=xbinsgt0(index(0))
    endif


    xyouts,0.80,0.70,'peak(Dapp)='+strtrim(string(format='(F7.1)',diapeak),2),color=150,charsize=1.2,/normal


    xyouts,0.65,0.92,'Size (Diameter) distribution of selected images',color=255,charsize=1.2,/normal


    basefile=file_basename(localstate.infilename)
    basefile_str=strmid(basefile,0,strlen(basefile)-4)

    xyouts,0.85,0.06,'File:  '+basefile,color=200,/normal

    SE_frame_str=strtrim(string(localstate.Sframenumber),2)+'_'+strtrim(string(localstate.Eframenumber),2)

    filename=localstate.pathnm+'Fig2_FocusSize_'+basefile_str+'_'+SE_frame_str+'.png'
    WRITE_png,filename,tvrd(true=1),/order

    !P.MULTI = [0, 1, 1, 0, 0]
    heap_gc
end;  plot_focus_distribution, localstate


pro plot_focus_XY_distribution, LocalState

    Ex=*(localstate.PEx)
    Ey=*(localstate.PEy)
    Sx=*(localstate.PSx)
    Sy=*(localstate.PSy)
    Cx=round((Ex+Sx)/2.0)
    Cy=round((Ey+Sy)/2.0)


    WIDGET_CONTROL, /HOURGLASS

    fcs    =*(localstate.pfcs)

    if ptr_valid(localstate.Pframes_selected) eq 0 then return
    index_selected=(*localstate.Pframes_selected)

    dias   =*(localstate.pdia)
    dias_selected=dias(index_selected)*2.3

    dapps  =*(localstate.pdapp)
    dapps_selected=dapps(index_selected)*2.3

    fcs_selected =fcs(index_selected)

    fcsfn        =fcs_selected

    Cxf =Cx(index_selected)
    Cyf =Cy(index_selected)
    Cyf =abs(1024-Cyf);   reverse the dat so that the position is similar to CPIview mosaic plots positions.

    fcsmin=0;  min(fcsfn)
    fcsmax=max(fcsfn)
    N_colors=(fcsmax-fcsmin)+2
    !P.multi=[0,1,1]
    index=where(fcsfn ge 20,contgt20)

    fcsgt20_percent =round(100.0*contgt20/n_elements(fcsfn))

    ;plot of mean values at each location.

    ;make a new matrix of 1024x1280; and calculate teh mean value on each points.
    nnncx=max(Cxf)
    nnncy=max(cyf)
    cxn  =indgen(nnncx)+1
    cyn  =indgen(nnncy)+1
    cfn    =fltarr(nnncx,nnncy)
    ddn    =fltarr(nnncx,nnncy);    for diameter of each image at the point.
    dappn  =fltarr(nnncx,nnncy);    for diameter of each image at the point.

    ; a faster way to do the calculations.
    kkk=n_elements(cxf)
    for i=0L, kkk-1L do begin
        x =cxf(i)
        y =cyf(i)
        index=where(cxf eq x and cyf eq y,contG)
        cfn(x-1,y-1)=mean(fcsfn(index))
        ddn(x-1,y-1)=mean(dias_selected(index))
        dappn(x-1,y-1)=mean(dapps_selected(index))
    endfor

    basefile=file_basename(localstate.infilename)
    basefile_str=strmid(basefile,0,strlen(basefile)-4)

    ;finding uniq  points and print out the result in ascii file.
    SE_frame_str=strtrim(string(localstate.Sframenumber),2)+'_'+strtrim(string(localstate.Eframenumber),2)
    outfile_ascii=localstate.pathnm+'Fig1_meanFcsVSxy_'+basefile_str+'_'+SE_frame_str+'.txt'
    openw,out_lun,outfile_ascii,/get_lun
    printf, out_lun,' Note: Dia is size corrected with focus, Dapp is apparent Size'
    printf, out_lun,'   X       Y     focus Dia(um) Dapp(um) Images'
    printf, out_lun,'(pixel) (pixel) (mean)  (mean)  (mean)  (count)'
    Xsave=[0]
    Ysave=[0]
    fsave=[0]
    dsave=[0]
    psave=[0]
    nsave=[0]


    cxfn=cxf
    cyfn=cyf
    count_u=0
    while n_elements(cxfn) gt 1 do begin

        index_all=indgen(n_elements(cxfn))

        index=where(cxfn eq cxfn(0) and cyfn eq cyfn(0),contG)
        this_number=contG
        count_u=count_u+1
        Xsave=[Xsave,cxfn(0)];  : save these number for later to print them out in sorted order.
        Ysave=[Ysave,cyfn(0)]
        fsave=[fsave,cfn(cxfn(0)-1,cyfn(0)-1)]
        dsave=[dsave,ddn(cxfn(0)-1,cyfn(0)-1)]
        psave=[psave,dappn(cxfn(0)-1,cyfn(0)-1)]
        nsave=[nsave, this_number]
        ;printf, out_lun, format='(I7,1x,I7,1x,F6.1,1x,F7.1,1x,F8.1,1x,I6)', cxfn(0),cyfn(0), cfn(cxfn(0)-1,cyfn(0)-1), ddn(cxfn(0)-1,cyfn(0)-1),dappn(cxfn(0)-1,cyfn(0)-1),this_number
        ;now exclude the poinst already counted.
        for i=0,contG-1 do begin
            indice=where(index_all ne index(i),conti)
            if conti gt 0 then begin
                indexall_new=index_all(indice)
                index_all=indexall_new
            endif
        endfor
        cxf_new=cxfn(index_all)
        cyf_new=cyfn(index_all)

        cxfn=cxf_new
        cyfn=cyf_new
    endwhile
    ; now prit out the saved numbers.
    nnj=n_elements(nsave)
    Xsave=Xsave(sort(Xsave))
    Ysave=Ysave(sort(Xsave))
    Fsave=Fsave(sort(Xsave))
    Dsave=Dsave(sort(Xsave))
    Psave=Psave(sort(Xsave))
    Nsave=Nsave(sort(Xsave))
    for i=1,nnj-1 do begin
        printf, out_lun, format='(I7,1x,I7,1x,F6.1,1x,F7.1,1x,F8.1,1x,I6)', XSave(i),Ysave(i),Fsave(i), Dsave(i),Psave(i),Nsave(i)
    endfor

    close,out_lun
    uniq_points=count_u

    ;clip focus value to be maximum equal to 100.
    indx=where(cfn ge 100.0, contG)
    if contG gt 0 then cfn(indx)=100.0
    fcsmin=0
    fcsmax=100
    N_colors =fcsmax-fcsmin+2

    LOADCT,39, NCOLORS=N_colors, Bottom=0

    window,/free, xs=640+64,ys=round(640*1024.0/1280.0),XPOS=440,YPOS=5,title='Focus value VS Rois(x,y)'; ys=512

    plot,[Cxf(0),Cxf(0)],[Cyf(0),Cyf(0)], psym=2,color=0,xrange=[1, 1280],xstyle=1,ystyle=1,yrange=[1, 1024],$
        xmargin=[6,1],title='Mean Focus VS Roi(x,y) n='+strtrim(n_elements(CXf),2)+'  fcs>20 ='+ $
        strtrim(string(fcsgt20_percent),2)+'%, (x,y) selected:'+strtrim(string(uniq_points),2), $
        Yticks=6,Ytitle='pixel (y)',xtitle='pixel (x)',position=[0.1,0.1,0.8,0.94],/nodata,$
        background=[N_colors-1]


    for iii=0,nnncx-1 do begin
        for jjj =0,nnncy-1 do begin
            if cfn(iii, jjj) gt 0.0 then begin
                oplot,[Cxn(iii),Cxn(iii)],[Cyn(jjj),Cyn(jjj)],psym=2, color=N_colors-cfn(iii,jjj); ; because brightest color has highest value. so
            endif
        endfor
    endfor
    text_color=N_colors/2

    frame_str='Frame: '+strtrim(string(localstate.SframeNumber),2)+'-'+strtrim(string(localstate.Eframenumber),2)
    basefile=file_basename(localstate.infilename)

    StartTime_EndTime_str='Time: '+strtrim(string(localstate.StartTime),2)+'-'+strtrim(string(localstate.EndTime),2)
    xyouts,0.02,0.04,StartTime_EndTime_str,color=text_color,/normal
    xyouts,0.60,0.04,frame_str+'  File:  '+basefile,color=text_color,/normal
    xyouts,0.5,0.01,localstate.notes,color=text_color,/normal,Alignment=0.5


    ;COLORBAR,  NCOLORS=100, POSITION=[0.15, 0.85, 0.95, 0.90]
    COLORBAR,  NCOLORS=N_colors,/Vertical,COLOR=N_colors,Reverse=reverse

    filename=localstate.pathnm+'Fig1_meanFcsVSxy_'+basefile_str+'_'+SE_frame_str+'.png'
    WRITE_png,filename,tvrd(true=1),/order
    heap_gc
end

;+
; NAME:
;   COLORBAR

; PURPOSE:

;       The purpose of this routine is to add a color bar to the current
;       graphics window.

; AUTHOR:

;   FANNING SOFTWARE CONSULTING
;   David Fanning, Ph.D.
;   1645 Sheely Drive
;   Fort Collins, CO 80526 USA
;   Phone: 970-221-0438
;   E-mail: davidf@dfanning.com
;   Coyote's Guide to IDL Programming: http://www.dfanning.com/

; CATEGORY:

;       Graphics, Widgets.

; CALLING SEQUENCE:

;       COLORBAR

; INPUTS:

;       None.

; KEYWORD PARAMETERS:

;       BOTTOM:       The lowest color index of the colors to be loaded in
;                     the bar.

;       CHARSIZE:     The character size of the color bar annotations. Default is 1.0.

;       COLOR:        The color index of the bar outline and characters. Default
;                     is !P.Color..

;       DIVISIONS:     The number of divisions to divide the bar into. There will
;                     be (divisions + 1) annotations. The default is 6.

;       FONT:         Sets the font of the annotation. Hershey: -1, Hardware:0, True-Type: 1.

;       FORMAT:       The format of the bar annotations. Default is '(I5)'.

;       INVERTCOLORS: Setting this keyword inverts the colors in the color bar.

;       MAXRANGE:     The maximum data value for the bar annotation. Default is
;                     NCOLORS.

;       MINRANGE:     The minimum data value for the bar annotation. Default is 0.

;       MINOR:        The number of minor tick divisions. Default is 2.

;       NCOLORS:      This is the number of colors in the color bar.

;       POSITION:     A four-element array of normalized coordinates in the same
;                     form as the POSITION keyword on a plot. Default is
;                     [0.88, 0.10, 0.95, 0.90] for a vertical bar and
;                     [0.10, 0.88, 0.90, 0.95] for a horizontal bar.

;       RANGE:        A two-element vector of the form [min, max]. Provides an
;                     alternative way of setting the MINRANGE and MAXRANGE keywords.

;       REVERSE:      Setting this keyword reverses the colors in the colorbar.

;       RIGHT:        This puts the labels on the right-hand side of a vertical
;                     color bar. It applies only to vertical color bars.

;       TICKNAMES:    A string array of names or values for the tick marks.

;       TITLE:        This is title for the color bar. The default is to have
;                     no title.

;       TOP:          This puts the labels on top of the bar rather than under it.
;                     The keyword only applies if a horizontal color bar is rendered.

;       VERTICAL:     Setting this keyword give a vertical color bar. The default
;                     is a horizontal color bar.

; COMMON BLOCKS:

;       None.

; SIDE EFFECTS:

;       Color bar is drawn in the current graphics window.

; RESTRICTIONS:

;       The number of colors available on the display device (not the
;       PostScript device) is used unless the NCOLORS keyword is used.

; EXAMPLE:

;       To display a horizontal color bar above a contour plot, type:

;       LOADCT, 5, NCOLORS=100
;       CONTOUR, DIST(31,41), POSITION=[0.15, 0.15, 0.95, 0.75], $
;          C_COLORS=INDGEN(25)*4, NLEVELS=25
;       COLORBAR, NCOLORS=100, POSITION=[0.15, 0.85, 0.95, 0.90]

; MODIFICATION HISTORY:

;       Written by: David W. Fanning, 10 JUNE 96.
;       10/27/96: Added the ability to send output to PostScript. DWF
;       11/4/96: Substantially rewritten to go to screen or PostScript
;           file without having to know much about the PostScript device
;           or even what the current graphics device is. DWF
;       1/27/97: Added the RIGHT and TOP keywords. Also modified the
;            way the TITLE keyword works. DWF
;       7/15/97: Fixed a problem some machines have with plots that have
;            no valid data range in them. DWF
;       12/5/98: Fixed a problem in how the colorbar image is created that
;            seemed to tickle a bug in some versions of IDL. DWF.
;       1/12/99: Fixed a problem caused by RSI fixing a bug in IDL 5.2. Sigh... DWF.
;       3/30/99: Modified a few of the defaults. DWF.
;       3/30/99: Used NORMAL rather than DEVICE coords for positioning bar. DWF.
;       3/30/99: Added the RANGE keyword. DWF.
;       3/30/99: Added FONT keyword. DWF
;       5/6/99: Many modifications to defaults. DWF.
;       5/6/99: Removed PSCOLOR keyword. DWF.
;       5/6/99: Improved error handling on position coordinates. DWF.
;       5/6/99. Added MINOR keyword. DWF.
;       5/6/99: Set Device, Decomposed=0 if necessary. DWF.
;       2/9/99: Fixed a problem caused by setting BOTTOM keyword, but not NCOLORS. DWF.
;       8/17/99. Fixed a problem with ambiguous MIN and MINOR keywords. DWF
;       8/25/99. I think I *finally* got the BOTTOM/NCOLORS thing sorted out. :-( DWF.
;       10/10/99. Modified the program so that current plot and map coordinates are
;            saved and restored after the colorbar is drawn. DWF.
;       3/18/00. Moved a block of code to prevent a problem with color decomposition. DWF.
;       4/28/00. Made !P.Font default value for FONT keyword. DWF.
;       9/26/00. Made the code more general for scalable pixel devices. DWF.
;       1/16/01. Added INVERTCOLORS keyword. DWF.
;       5/11/04. Added TICKNAME keyword. DWF.
;       9/29/05. Added REVERSE keywords. DWF.
;-

;###########################################################################

; LICENSE

; This software is OSI Certified Open Source Software.
; OSI Certified is a certification mark of the Open Source Initiative.

; Copyright  2000-2005 Fanning Software Consulting.

; This software is provided "as-is", without any express or
; implied warranty. In no event will the authors be held liable
; for any damages arising from the use of this software.

; Permission is granted to anyone to use this software for any
; purpose, including commercial applications, and to alter it and
; redistribute it freely, subject to the following restrictions:

; 1. The origin of this software must not be misrepresented; you must
;    not claim you wrote the original software. If you use this software
;    in a product, an acknowledgment in the product documentation
;    would be appreciated, but is not required.

; 2. Altered source versions must be plainly marked as such, and must
;    not be misrepresented as being the original software.

; 3. This notice may not be removed or altered from any source distribution.

; For more information on Open Source Software, visit the Open Source
; web site: http://www.opensource.org.

;###########################################################################


PRO COLORBAR, BOTTOM=bottom, CHARSIZE=charsize, COLOR=color, DIVISIONS=divisions, $
    FORMAT=format, POSITION=position, MAXRANGE=maxrange, MINRANGE=minrange, NCOLORS=ncolors, $
    TITLE=title, VERTICAL=vertical, TOP=top, RIGHT=right, MINOR=minor, $
    RANGE=range, FONT=font, TICKLEN=ticklen, _EXTRA=extra, INVERTCOLORS=invertcolors, $
    TICKNAMES=ticknames, REVERSE=reverse

; Return to caller on error.

On_Error, 2

; Save the current plot state.

bang_p = !P
bang_x = !X
bang_Y = !Y
bang_Z = !Z
bang_Map = !Map

; Are scalable pixels available on the device?

IF (!D.Flags AND 1) NE 0 THEN scalablePixels = 1 ELSE scalablePixels = 0

; Which release of IDL is this?

thisRelease = Float(!Version.Release)

; Check and define keywords.

IF N_ELEMENTS(ncolors) EQ 0 THEN BEGIN

    ; Most display devices to not use the 256 colors available to
    ; the PostScript device. This presents a problem when writing
    ; general-purpose programs that can be output to the display or
    ; to the PostScript device. This problem is especially bothersome
    ; if you don't specify the number of colors you are using in the
    ; program. One way to work around this problem is to make the
    ; default number of colors the same for the display device and for
    ; the PostScript device. Then, the colors you see in PostScript are
    ; identical to the colors you see on your display. Here is one way to
    ; do it.

    IF scalablePixels THEN BEGIN
        oldDevice = !D.NAME

        ; What kind of computer are we using? SET_PLOT to appropriate
        ; display device.

        thisOS = !VERSION.OS_FAMILY
        thisOS = STRMID(thisOS, 0, 3)
        thisOS = STRUPCASE(thisOS)
        CASE thisOS of
            'MAC': SET_PLOT, thisOS
            'WIN': SET_PLOT, thisOS
            ELSE: SET_PLOT, 'X'
        ENDCASE

        ; Here is how many colors we should use.

        ncolors = !D.TABLE_SIZE
        SET_PLOT, oldDevice
    ENDIF ELSE ncolors = !D.TABLE_SIZE
ENDIF
IF N_ELEMENTS(bottom) EQ 0 THEN bottom = 0B
IF N_ELEMENTS(charsize) EQ 0 THEN charsize = 1.0
IF N_ELEMENTS(format) EQ 0 THEN format = '(I5)'
IF N_ELEMENTS(color) EQ 0 THEN color = !P.Color
IF N_ELEMENTS(minrange) EQ 0 THEN minrange = 0
IF N_ELEMENTS(maxrange) EQ 0 THEN maxrange = ncolors
IF N_ELEMENTS(ticklen) EQ 0 THEN ticklen = 0.2
IF N_ELEMENTS(minor) EQ 0 THEN minor = 2
IF N_ELEMENTS(range) NE 0 THEN BEGIN
    minrange = range[0]
    maxrange = range[1]
ENDIF
IF N_ELEMENTS(divisions) EQ 0 THEN divisions = 6
IF N_ELEMENTS(font) EQ 0 THEN font = !P.Font
IF N_ELEMENTS(title) EQ 0 THEN title = ''

; You can't have a format set *and* use ticknames.
IF N_ELEMENTS(ticknames) NE 0 THEN format = ""

IF KEYWORD_SET(vertical) THEN BEGIN
    bar = REPLICATE(1B,20) # BINDGEN(ncolors)
    IF Keyword_Set(invertcolors) THEN bar = Reverse(bar, 2)
    IF N_ELEMENTS(position) EQ 0 THEN BEGIN
        position = [0.88, 0.1, 0.95, 0.9]
    ENDIF ELSE BEGIN
        IF position[2]-position[0] GT position[3]-position[1] THEN BEGIN
            position = [position[1], position[0], position[3], position[2]]
        ENDIF
        IF position[0] GE position[2] THEN Message, "Position coordinates can't be reconciled."
        IF position[1] GE position[3] THEN Message, "Position coordinates can't be reconciled."
    ENDELSE
ENDIF ELSE BEGIN
    bar = BINDGEN(ncolors) # REPLICATE(1B, 20)
    IF Keyword_Set(invertcolors) THEN bar = Reverse(bar, 1)
    IF N_ELEMENTS(position) EQ 0 THEN BEGIN
        position = [0.1, 0.88, 0.9, 0.95]
    ENDIF ELSE BEGIN
        IF position[3]-position[1] GT position[2]-position[0] THEN BEGIN
            position = [position[1], position[0], position[3], position[2]]
        ENDIF
        IF position[0] GE position[2] THEN Message, "Position coordinates can't be reconciled."
        IF position[1] GE position[3] THEN Message, "Position coordinates can't be reconciled."
    ENDELSE
ENDELSE

; Scale the color bar.

bar = BYTSCL(bar, TOP=(ncolors-1 < (255-bottom))) + bottom
IF Keyword_Set(reverse) THEN BEGIN
    IF Keyword_Set(vertical) THEN bar = Reverse(bar,2) ELSE bar = Reverse(bar,1)
ENDIF

; Get starting locations in NORMAL coordinates.

xstart = position(0)
ystart = position(1)

; Get the size of the bar in NORMAL coordinates.

xsize = (position(2) - position(0))
ysize = (position(3) - position(1))

; Display the color bar in the window. Sizing is
; different for PostScript and regular display.

IF scalablePixels THEN BEGIN

    TV, bar, xstart, ystart, XSIZE=xsize, YSIZE=ysize, /Normal

ENDIF ELSE BEGIN

    bar = CONGRID(bar, CEIL(xsize*!D.X_VSize), CEIL(ysize*!D.Y_VSize), /INTERP)

    ; Decomposed color off if device supports it.

    CASE  StrUpCase(!D.NAME) OF
        'X': BEGIN
            IF thisRelease GE 5.2 THEN Device, Get_Decomposed=thisDecomposed
            Device, Decomposed=0
        ENDCASE
        'WIN': BEGIN
            IF thisRelease GE 5.2 THEN Device, Get_Decomposed=thisDecomposed
            Device, Decomposed=0
        ENDCASE
        'MAC': BEGIN
            IF thisRelease GE 5.2 THEN Device, Get_Decomposed=thisDecomposed
            Device, Decomposed=0
        ENDCASE
        ELSE:
    ENDCASE

    TV, bar, xstart, ystart, /Normal

    ; Restore Decomposed state if necessary.

    CASE StrUpCase(!D.NAME) OF
        'X': BEGIN
            IF thisRelease GE 5.2 THEN Device, Decomposed=thisDecomposed
        ENDCASE
        'WIN': BEGIN
            IF thisRelease GE 5.2 THEN Device, Decomposed=thisDecomposed
        ENDCASE
        'MAC': BEGIN
            IF thisRelease GE 5.2 THEN Device, Decomposed=thisDecomposed
        ENDCASE
        ELSE:
    ENDCASE

ENDELSE

; Annotate the color bar.

IF KEYWORD_SET(vertical) THEN BEGIN

    IF KEYWORD_SET(right) THEN BEGIN

        PLOT, [minrange,maxrange], [minrange,maxrange], /NODATA, XTICKS=1, $
            YTICKS=divisions, XSTYLE=1, YSTYLE=9, $
            POSITION=position, COLOR=color, CHARSIZE=charsize, /NOERASE, $
            YTICKFORMAT='(A1)', XTICKFORMAT='(A1)', YTICKLEN=ticklen , $
            YRANGE=[minrange, maxrange], FONT=font, _EXTRA=extra, YMINOR=minor

        AXIS, YAXIS=1, YRANGE=[minrange, maxrange], YTICKFORMAT=format, YTICKS=divisions, $
            YTICKLEN=ticklen, YSTYLE=1, COLOR=color, CHARSIZE=charsize, $
            FONT=font, YTITLE=title, _EXTRA=extra, YMINOR=minor, YTICKNAME=ticknames

    ENDIF ELSE BEGIN

        PLOT, [minrange,maxrange], [minrange,maxrange], /NODATA, XTICKS=1, $
            YTICKS=divisions, XSTYLE=1, YSTYLE=9, YMINOR=minor, $
            POSITION=position, COLOR=color, CHARSIZE=charsize, /NOERASE, $
            YTICKFORMAT=format, XTICKFORMAT='(A1)', YTICKLEN=ticklen , $
            YRANGE=[minrange, maxrange], FONT=font, YTITLE=title, _EXTRA=extra, $
            YTICKNAME=ticknames

        AXIS, YAXIS=1, YRANGE=[minrange, maxrange], YTICKFORMAT='(A1)', YTICKS=divisions, $
            YTICKLEN=ticklen, YSTYLE=1, COLOR=color, CHARSIZE=charsize, $
            FONT=font, _EXTRA=extra, YMINOR=minor

    ENDELSE

ENDIF ELSE BEGIN

    IF KEYWORD_SET(top) THEN BEGIN

        PLOT, [minrange,maxrange], [minrange,maxrange], /NODATA, XTICKS=divisions, $
            YTICKS=1, XSTYLE=9, YSTYLE=1, $
            POSITION=position, COLOR=color, CHARSIZE=charsize, /NOERASE, $
            YTICKFORMAT='(A1)', XTICKFORMAT='(A1)', XTICKLEN=ticklen, $
            XRANGE=[minrange, maxrange], FONT=font, _EXTRA=extra, XMINOR=minor

        AXIS, XTICKS=divisions, XSTYLE=1, COLOR=color, CHARSIZE=charsize, $
            XTICKFORMAT=format, XTICKLEN=ticklen, XRANGE=[minrange, maxrange], XAXIS=1, $
            FONT=font, XTITLE=title, _EXTRA=extra, XCHARSIZE=charsize, XMINOR=minor, $
            XTICKNAME=ticknames

    ENDIF ELSE BEGIN

        PLOT, [minrange,maxrange], [minrange,maxrange], /NODATA, XTICKS=divisions, $
            YTICKS=1, XSTYLE=1, YSTYLE=1, TITLE=title, $
            POSITION=position, COLOR=color, CHARSIZE=charsize, /NOERASE, $
            YTICKFORMAT='(A1)', XTICKFORMAT=format, XTICKLEN=ticklen, $
            XRANGE=[minrange, maxrange], FONT=font, XMinor=minor, _EXTRA=extra, $
            XTICKNAME=ticknames

    ENDELSE

ENDELSE

; Restore the previous plot and map system variables.

!P = bang_p
!X = bang_x
!Y = bang_y
!Z = bang_z
!Map = bang_map

END


;===============================================================================
FUNCTION Get_mosaic_ROI, localstate, x, y

    ; purpose:  this routine determine if the mouse is over a particle, and if so which one
    ;   PARAMETERs
    ;     pStateInfo:  main info structure
    ;     x:      x location of mouse in pixel coord
    ;     y:      y location of mouse in pixel coord

    ;   return
    ;     if over a particle , return index of particle and offset into particle in pixel-coords , else [-1,-1,-1]

    ; How many ROIs?
    pstateinfo=localstate.pstateinfo
    bounds=localstate.bounds
    sizes=size(bounds,/dimension);    ;bounds = *(*pStateInfo).pBounds

    FOR i=0,999 DO begin
        x0 = bounds[i,0];  x0 =OX,  y0=OY-dy-1
        y0 = bounds[i,1]
        x1 = bounds[i,2];  x1y1= oX+dx-1,oY
        y1 = bounds[i,3]
        if ( x gt x0-1 and x lt x1+1 and y gt y0-1 and y lt y1+1 )then return,[i]; that is oX,oY,dx,dy.
    endFOR

    ; Not inside any ROI
    return, [-1]
end


pro get_all_selected_index_from_addbyremoving,localstate


    Ex=*(localstate.PEx)
    Ey=*(localstate.PEy)
    Sx=*(localstate.PSx)
    Sy=*(localstate.PSy)
    Frames=*(localstate.PFRames)
    Roinums=*(localstate.PROINUMS)

    Pstateinfo=localstate.Pstateinfo
    ROIArray = *(*(*pStateInfo).pFrameData).pFrame
    ;How many ROIs?
    n_imgs = n_elements(  ROIArray )
    accepted_rois=*!accepted_rois

    FOR RoiNum=0, n_imgs-1 DO begin
        if accepted_rois(Roinum) eq 1 then begin

            thisEx=ROIArray[Roinum].ImageHeader.ex
            thisEy=ROIArray[Roinum].ImageHeader.ey
            thisSx=ROIArray[Roinum].ImageHeader.sx
            thisSy=ROIArray[Roinum].ImageHeader.sy

            ;find indx of all image that macthed location of this image.
            dd=3
            index_selected=where(Ex ge thisEx-dd and  Ex le thisEx+dd and $
                Ey ge thisEy-dd and  Ey le thisEy+dd and $
                Sx ge thisSx-dd and  Sx le thisSx+dd and $
                Sy ge thisSy-dd and  Sy le thisSy+dd and $
                Frames ge localstate.Sframenumber and  $
                Frames le localstate.Eframenumber,contG)

            if (contG ge 1) then begin

                if ptr_valid(localstate.PFrames_selected) then begin
                    index_added=[(*localstate.PFrames_selected), index_selected]
                    stored_Frame_index=index_added(uniq(index_added))
                endif else begin
                    stored_Frame_index=[index_selected]
                endelse

                stored_frame_index=stored_frame_index(sort(stored_Frame_index))

                localstate.PFrames_selected =ptr_new(stored_Frame_index)
                localstate.PRoinums_selected=ptr_new(stored_Frame_index)

            endif

        endif

    endfor
    StartFrame_all=Frames(stored_Frame_index(0))
    localstate.StartFrameAll=StartFrame_all
    widget_control,localstate.StartFrameID, set_value=string(StartFrame_all)

end;get_all_selected_index_from_addbyremoving,localstate



;get the corrected size ogf the glass beads.
pro Get_Dcor_Lcor_Wcor, Dcor,Lcor,Wcor,len,wid,fcs, Dapp,areas

    Dapp=fltarr(n_elements(len))
    Dcor=Dapp
    Lcor=Dapp
    Wcor=Dapp
    Acor=Dapp
    ;print,'starting mean or max size assignment loop now'
    for i = 0l,n_elements(len)-1 do Dapp[i]=2.3*(len[i] + wid[i])/2.;     ; here we assume all particle are water that is, they are round particles.

    ;pos=(1.57547 -0.0614464 *fcs + 0.000838895 *fcs^2d -3.82540e-006 *fcs^3d)
    ;Dratio=1.1031377 + 1.2314287 *pos - 0.34444972 *pos^2d
    ;Dcor=Dapp/Dratio

    ;Lcor=len/Dratio
    ;Wcor=wid/Dratio
    ; MO modified above to following on 2015-05-26:	 from spectral_lib.pro
    ;input is pRoiArray, RoiNum,  output are derived parameters, Lcor, Wcor .......; June 9, 2009.
    ;rrr=dialog_message('Continue_in_calculate_derived_pa;;;;Specrtal_lib.pro ',/information)
    pixsize =2.3;  !CPI_MICRONS_PER_PIXEL
    for i=0L, n_elements(len)-1L do begin
        fcsi =fcs(i) < 100.0;  caps fcs to be 100 at maximum
        Lob=len(i)  * pixsize           ; in microns   ob = observed size.
        Wob=wid(i)  * pixsize           ; in microns
        ;print,Lob, ' ', Wob
        ;stop
        if lob gt 0.0 or wob gt 0.0 then begin
            ; There are case of la and lob  less than zero !!!!!!!   even Wob pop is negative.
            La=Lob-0.25*(100.0-fcsi)
            Wa=Wob-0.25*(100.0-fcsi)

            count=0LL

            while La  le 0.0 do begin; if La gt 140.0 then stop
                La=(La+Lob)/2.0
                count=count+1LL
                ; if count gt 100LL then stop
            endwhile
            Kcor_l=Kcorrection_factor(La); ==(-2.32*La*La*0.00001+0.00153*La+0.241)

            count=0LL
            while Wa  le 0.0 do begin
                Wa=(Wa+Wob)/2.0
                count=count+1LL
                ;if count gt 100LL then stop
            endwhile
            Kcor_w=Kcorrection_factor(Wa); ==(-2.32*Wa*Wa*0.00001+0.00153*Wa+0.241)

            if La gt 140.0 then begin
                Lcor(i)=La
            endif else begin
                Lcor(i)=La+fcsi*Kcor_l;             microns
                if Lcor(i) le 0.0 then Lcor(i)=La
            endelse

            if Wa gt 140.0 then begin
                Wcor(i)=Wa
            endif else begin
                Wcor(i)=Wa+fcsi*Kcor_w;   microns
                if Wcor(i) le 0.0 then Wcor(i)=Wa
            endelse

            Dcor(i)=(Wcor(i)+Lcor(i))/2.0
            Acor(i)=0.25*!pi*(Lcor(i)*(Wob-Wcor(i))+Wcor(i)*(Lob-Lcor(i)));   ; microns^2



        endif

    endfor;   % calculation of Dcor and Acor is finished in for loop.

    if 1 eq 2 then begin;  plot out size VS area in loglog plot to see what the relationship it is.
        Dcori=indgen(9990)+10.0
        Acori=!pi*(Dcori/2000.0)^2
        index=where(fcs gt 40)
        Dcork=Dcor(index)
        Acork=Acor(index)
        lenk=len(index)
        areask=areas(index)

        window,1,xs=800,ys=800
        !P.MULTI = [0, 1, 1, 0, 0]
        plot,Dcork,Acork/1000000.0,psym=2,/Xlog,/Ylog,color=0,xstyle=1,ystyle=1,xmargin=[9,3],ymargin=[6,6],charsize=1.2,$
            xrange=[10,10000], yrange=[0.0001,10.0], xtitle='size(um)', ytitle='Area', title='CPI Area VS Size',$
            background=255
        oplot,Dcori,Acori,color=100
        oplot,lenk*2.3,areask*5.29/1000000.0,psym=4,color=160
        xyouts,0.15,0.85,' solid line:  Ideal Area=3.14*(Size/2000)^2 of spherical drops ',color=100,/normal
        ;xyouts,0.25,0.82,' of spherical drops',color=100,/normal
        xyouts,0.23,0.75,' square: CPI observed Area vs observed Len',color=160,/normal
        xyouts,0.63,0.45,' *: CPI focus corrected Area Vs Size',color=0,/normal

        stop
    endif

end; Get_Dcor_Lcor_Wcor, Dcor,Lcor,Wcor,len,wid,fcs,Dapp

pro get_startTime_endTime_strings, localstate

    pStateInfo=localstate.pStateInfo

    imgList = (*(*pStateInfo).pFileScan)[*(*pStateInfo).pImgPosIndx];  pfilescan is pointer, to each file that has been scanned.

    ;get StartTime
    k=localstate.SframeNumber
    ; must read the image data if any roi display or output is required
    frameData = read_frame((*pStateInfo).InFileLun,(*pStateInfo).FileHead.Ver,imgList[k].fpos,date=(*pStateInfo).date, TSBlanked = imglist[k].TSBlanked)


    frameTime = frameData.FrameHeader.time  ;  This time should be  corrected to = Htime*16^8+ ArivelaT1*16^4 + ArriveT2  August 6, 2010.
    time = convertFromSeconds(frameTime , (*pStateInfo).FileHead.year) ;  Time={month, day, hh, mm, ss, msec} ; change to 4/19/19:20:00.00 format.
    ; added this Part on August 6, 2010 by mooooooooooooo
    Time.day   =framedata.FrameHeader.day   ; Time is uint of 6 numbers.
    Time.hour  =framedata.FrameHeader.hour
    Time.minute=framedata.FrameHeader.minute
    Time.sec   =framedata.FrameHeader.sec
    Time.msec  =framedata.FrameHeader.msec; ;   HOUR =   14;  MINUTE=0; SEC= 11;MSEC=  791  from frameHeader.
    frameTime = Time.hour*3600.0D + time.minute*60.0D + time.sec*1.0D + time.msec/1000.0D;  Changed to this August 6, 2010

    if time.hour   le 9 then hh_str='0'+string(Time.hour,  format='(I1)') else hh_str=string(Time.hour,  format='(I2)')
    if time.minute le 9 then mm_str='0'+string(Time.minute,format='(I1)') else mm_str=string(Time.minute,format='(I2)')
    if time.sec    le 9 then ss_str='0'+string(Time.sec,   format='(I1)') else ss_str=string(Time.sec,   format='(I2)')
    if time.msec   le 9 then ms_str='00'+string(Time.msec,  format='(I1)')
    if time.msec   ge 10 and time.msec le 99 then ms_str='0'+string(Time.msec,  format='(I2)')
    if time.msec   ge 100                    then ms_str= string(Time.msec,  format='(I3)')
    startTime_str =hh_str+':'+mm_str+':'+ss_str+'.'+ms_str

    ;get EndTime
    k=localstate.EframeNumber
    ; must read the image data if any roi display or output is required
    frameData = read_frame((*pStateInfo).InFileLun,(*pStateInfo).FileHead.Ver,imgList[k].fpos,date=(*pStateInfo).date, TSBlanked = imglist[k].TSBlanked)


    frameTime = frameData.FrameHeader.time  ;  This time should be  corrected to = Htime*16^8+ ArivelaT1*16^4 + ArriveT2  August 6, 2010.
    time = convertFromSeconds(frameTime , (*pStateInfo).FileHead.year) ;  Time={month, day, hh, mm, ss, msec} ; change to 4/19/19:20:00.00 format.
    ; added this Part on August 6, 2010 by mooooooooooooo
    Time.day   =framedata.FrameHeader.day   ; Time is uint of 6 numbers.
    Time.hour  =framedata.FrameHeader.hour
    Time.minute=framedata.FrameHeader.minute
    Time.sec   =framedata.FrameHeader.sec
    Time.msec  =framedata.FrameHeader.msec; ;   HOUR =   14;  MINUTE=0; SEC= 11;MSEC=  791  from frameHeader.
    frameTime = Time.hour*3600.0D + time.minute*60.0D + time.sec*1.0D + time.msec/1000.0D;  Changed to this August 6, 2010

    if time.hour   le 9 then hh_str='0'+string(Time.hour,  format='(I1)') else hh_str=string(Time.hour,  format='(I2)')
    if time.minute le 9 then mm_str='0'+string(Time.minute,format='(I1)') else mm_str=string(Time.minute,format='(I2)')
    if time.sec    le 9 then ss_str='0'+string(Time.sec,   format='(I1)') else ss_str=string(Time.sec,   format='(I2)')
    if time.msec   le 9 then ms_str='00'+string(Time.msec,  format='(I1)')
    if time.msec   ge 10 and time.msec le 99 then ms_str='0'+string(Time.msec,  format='(I2)')
    if time.msec   ge 100                    then ms_str= string(Time.msec,  format='(I3)')
    EndTime_str =hh_str+':'+mm_str+':'+ss_str+'.'+ms_str

    localstate.StartTime =StartTime_str
    localstate.EndTime   =EndTime_str

end; get_startTime_endTime_strings, localstate




