function open_ascii,pStateInfo, fileformat, select, criteria

    ;To reinstate the curvature feature (if curvature is ever calculated) uncomment all lines that contain the number 49.

    ;Purpose: To open an ASCII log file and write a file header

    ; Parameter
    ;   pStateInfo       I uses fields minFile for file name and ObjFile for Logical unit number
    ;   FileFormat       I flag to choose header
    ;   select      I   array of 1's and 0's indicating which fields to choose
    ;   criteria       I string containing acceptance criteria


    ;get selected fields formats
    fieldIndex = where(select and 1,fieldCnt)
    if(fieldCnt eq 0 and fileformat eq 'new' and ptr_valid((*pStateInfo).pObjList))then return,-1

    case fileformat of
        'new':begin
        ; eliminated question to facilitate unattended processing JS 11/2001
        ;r = dialog_message('Select yes to use a comma separated value format (.csv).',/question)
        r = 'Yes'
        if(r eq 'Yes')then begin
            ext = 'csv'
            seperator = ','
        endif else begin
            ext = 'txt'
            seperator = ' '
        endelse

        ; use existing file name with new extention
        (*pStateInfo).asciiLogFile = strmid((*pStateInfo).InFileName, 0,rstrpos((*pStateInfo).InFileName,'.')) + '_'+strtrim(!project,2)+'_'+strtrim(!platform,2)+ '_stats.' + ext
        openw,lun1,(*pStateInfo).asciiLogFile,/get,bufsize = 131072L
        (*pStateInfo).LogLUN1 = lun1

        if(ptr_valid((*pStateInfo).pObjList))then begin
            (*pStateInfo).asciiLogFile = strmid((*pStateInfo).InFileName, 0,rstrpos((*pStateInfo).InFileName,'.')) + '_'+strtrim(!project,2)+'_'+strtrim(!platform,2)+ '_features.' + ext
            openw,lun2,(*pStateInfo).asciiLogFile,/get,bufsize = 131072L
            (*pStateInfo).LogLUN2 = lun2
        endif

        if(ptr_valid((*pStateInfo).pObjList))then begin

            if(ext eq 'csv')then begin
                header1 = 'year,mm:dd:hh:mm:ss,ROI #,ArrTime,TS,DeadTime,Length,Width,Dark,Area,Perim,Centroid,,Roundness1,X_mnt,'+$
                    'Y_mnt,Rub_bnd,Fract_dim,SampPer,Focus,Fmin,Fmax,FStDv,Fgd,Cutoff,Crystal,P1,'+$
                    'Roundness2,Roundness3,P4,CurvWin,Focus_Stats,,,,,,,,,Intensity_Stats,,,,,,,,,Inten_HoleLess_Stats,,,,,,,,,Gradient_Stats,,,,,,,,,Radii_Stats,,,,,,,,,'+$
                    'Curvature_Stats,,,,,,,,,HoleCnt,Hole_Area_Stats,,,,,,,,,Hole_Intensity_Stats,,,,,,,,,Hole_Other_Stats,,,,,,,,,Hole1_Area,Hole1_Intensity_Stats,,,,,,,,,'+$
                    'Hole1_Prm,Hole1_Other_Stats,,,,,,,,,Hole2_Area,'+$
                    'Hole2_Intensity_Stats,,,,,,,,,Hole2_Prm,Hole2_Other_Stats,,,,,,,,,Hole3_Area,Hole3_Intensity_Stats,,,,,,,,,Hole3_Prm,Hole3_Other_Stats,,,,,,,,,'
                header2 = 'HrmCnt,Harmonics,BndCnt,Boundary,RadCnt,Radii';    ,CurvCnt,Curvature'
            endif else begin
                header1 = 'year mm:dd:hh:mm:ss ROI # ArrTime TS DeadTime Length Width Dark Area Perim Centroid  Roundness1 X_mnt '+$
                    'Y_mnt Rub_bnd Fract_dim SampPer Focus Fmin Fmax FStDv Fgd Cutoff Crystal P1 '+$
                    'Roundness2 Roundness3 P4 CurvWin Focus_Stats         Intensity_Stats         Inten_HoleLess_Stats         Gradient_Stats         Radii_Stats         '+$
                    'Curvature_Stats         HoleCnt Hole_Area_Stats         Hole_Intensity_Stats         Hole_Other_Stats         Hole1_Area Hole1_Intensity_Stats         '+$
                    'Hole1_Prm Hole1_Other_Stats         Hole2_Area '+$
                    'Hole2_Intensity_Stats         Hole2_Prm Hole2_Other_Stats         Hole3_Area Hole3_Intensity_Stats         Hole3_Prm Hole3_Other_Stats         '
                header2 = 'HrmCnt Harmonics BndCnt Boundary RadCnt Radii CurvCnt Curvature'
            endelse
            printf,lun1,'Acceptance Criteria:','if('+ criteria +')then accept    and Time are original Times'
            printf,lun1,'FileName:',(*pStateInfo).InFileName
            printf,lun1,header1
            if(ptr_valid((*pStateInfo).pObjList))then begin
                printf,lun2,'FileName:',(*pStateInfo).InFileName
                printf,lun2,'Acceptance Criteria:','if('+ criteria +')then accept    and Time are original Times'
                printf,lun2, 'year,mm:dd:hh:mm:ss,#,ArrTime,' + header2
            endif
        endif else begin
            printf,lun1,'FileName:',(*pStateInfo).InFileName + ' Time are riginal times'
            header1 = 'frame year  mm:dd:hh:mm:ss       #  ArrTime  TS    dead    focus  cut-off  crystal'
            printf,lun1,header1
        endelse

        ; define possible format fields
        if(ext eq 'csv')then begin

            Format=[ ',2(",",f8.2)',',",",I3',',2(",",f10.2)', ',2(",",I4)', ',6(",",f8.2)',$
                ',3(",",I3)',',",",f8.2', ',3(",",I3)',',4(",",f8.2)',',",",I4,','",",6(9(f8.2,","))',$ ; curvature_window
                ',I3,","',',3(9(f8.2,","))',',6(9(f8.2,","))']
            formatStr='(I4,",",a18,",", I4, ",",I7,",",I4,",",f7.3,2(",",f8.2),",",I3,2(",",f10.2),2(",",I4),6(",",f8.2),3(",",I3),",",f8.2,3(",",I3),4(",",f8.2),",",I4,",",54(f8.2,","),I3,",",87(f8.2,",")'
        endif else begin
            Format=[ ',2(" ",f8.2)','," ",I3',',2(" ",f10.2)', ',2(" ",I4)', ',6(" ",f8.2)',$
                ',3(" ",I3)','," ",f8.2', ',3(" ",I3)',',4(" ",f8.2)','," ",I4,','" ",6(9(f8.2," "))',$ ; curvature_window
                ',I3," "',',3(9(f8.2," "))',',6(9(f8.2," "))']
            formatStr='(I4," ",a18," ", I4, " ",I7," ",I4," ",f7.3,2(" ",f8.2)," ",I3,2(" ",f10.2),2(" ",I4),6(" ",f8.2),3(" ",I3)," ",f8.2,3(" ",I3),4(" ",f8.2)," ",I4," ",54(f8.2," "),I3," ",87(f8.2," ")'
        endelse

        ; define output variable names and types
        DataType=[    ',"len",0.0',',"Wid",0.0',',"dark",0',$
            ',"area",0.0' , ',"perim",0.0' , ',"centroid",[0,0]' , ',"Roundness1",0.0' ,$
            ',"x_moment",0.0',',"y_moment",0.0',',"rubber_band",0.0',',"fractal_dim",0.0',',"sample_period",0.0',$;',x,I4',',x,I4',
            ',"focus",0B' , ',"focusmin",0B' , ',"focusmax",0B' , ',"focusStdDev",0.0' , ',"focusgoodsamples",0B' ,$
            ',"cutoff",0B' , ',"crystal",0B' , ',"P1",0.0', ',"Roundness2",0.0', ',"Roundness3",0.0', ',"P4",0.0',$
            ',"Curvature_Window",0U',',"Focus_Stats",fltarr(9)',',"Intensity_Stats",fltarr(9)',',"Intensity_HoleLess_Stats",fltarr(9)',$
            ',"Gradient_Stats",fltarr(9)',',"Radii_Stats",fltarr(9)',',"Curvature_Stats",fltarr(9)',',"Hole_Count",0U',$
            ',"Hole_Area_Stats",fltarr(9)',',"Hole_Intensity_Stats",fltarr(9)',',"Hole_Other_Stats",fltarr(9)',$
            ',"Hole1_Area",0.0',',"Hole1_Intensity_Stats",fltarr(9)',',"Hole1_Perim",0.0',',"Hole1_Other_Stats",fltarr(9)',$
            ',"Hole2_Area",0.0',',"Hole2_Intensity_Stats",fltarr(9)',',"Hole2_Perim",0.0',',"Hole2_Other_Stats",fltarr(9)',$
            ',"Hole3_Area",0.0',',"Hole3_Intensity_Stats",fltarr(9)',',"Hole3_Perim",0.0',',"Hole3_Other_Stats",fltarr(9)']

        ; construct command for next routine
        cmd1 = 'variables = create_struct(variables'
        cmd2 = 'variables2 = create_struct("Focus_Stats",fltarr(9)'

        for i = 0,23 do cmd1 = cmd1 + DataType[i]
        cmd1 = cmd1 + ')'
        for i = 25,45 do cmd2 = cmd2 + DataType[i]
        cmd2 = cmd2 + ')'

        return,{formatStr:formatStr, dataCmd1:cmd1, dataCmd2:cmd2}

    end

    'frame':begin

    ; use existing file name with new extention
    (*pStateInfo).asciiLogFile = strmid((*pStateInfo).InFileName, 0,rstrpos((*pStateInfo).InFileName,'.')) + '_'+strtrim(!project,2)+'_'+strtrim(!platform,2)+'_frame.txt'
    openw,lun1,(*pStateInfo).asciiLogFile,/get,bufsize = 131072L
    (*pStateInfo).LogLUN1 = lun1

    header='SZE VER ROICNT ROISZE  DATE            IMGTYPE SX   SY   EX   EY    BGRATE BKGPDSTHR FRMSPROC ITHR '$
        + 'ROIERR ROIMINSZE ROIASPECT ROIFILL ROIFCNT IMGMN BKGMN SPR1 XPAD YPAD STRBCNT FRMSSVD IMGMINVAL IMGMAXVAL '$
        + 'ROISSVD CHKSUM PDSHD1 PDSHD2 PDSHD3 TIME     ARRVLT1 ARRVLT2 TRANSIT MISSED  PHGHT1 PHGHT2 PDSCHKSUM PRBMODE'

    printf,lun1,'FileName:',(*pStateInfo).InFileName,'Acceptance Criteria:'+ criteria +' Then accepted  and Time are original Times'
    printf,lun1,header
    return,1
end

'hertz':begin
; use existing file name with new extention
;(*pStateInfo).asciiLogFile = strmid((*pStateInfo).InFileName, 0,rstrpos((*pStateInfo).InFileName,'.')) + '_HK.txt'
;openw,lun1,(*pStateInfo).asciiLogFile,/get,bufsize = 131072L
;(*pStateInfo).LogLUN1 = lun1
;header='hertz header goes here'
;(*pStateInfo).asciiHKFile = strmid((*pStateInfo).InFileName, 0,rstrpos((*pStateInfo).InFileName,'.')) + '.hk'
;openw,lun,(*pStateInfo).asciiHKFile,/get
;(*pStateInfo).HKLUN = lun
;printf,lun1,header
;return,1
end

else: return,0   ;print,'OK, Brad put this in'

endcase
return,0
end

pro write_line,pStateInfo, request, select, imageheader, roinum, year, time, arrivTime, missed,deadtime, pixsize,fileformat,frameNum,PDSThresh45,PDSThresh90
    ;Purpose - to write a line of requested data to the output files

    ;Parameters
    ;   pStateInfo
    ;   request     I    structure with two fields, {dataCmd:dataCmd, formatStr:formatStr} created in open_ascii above
    ;     where
    ;          dataCmd is string input into the "execute" command to create a data structure
    ;          formatStr is string containing the format
    ;   roinum       I     number of roi being written
    ;   year   I   year of data file
    ;   time   I   structure with time
    ;   arrvtime  I    arrival time
    ;   missed       I missed particle count
    ;   deadtime  I    deadtime in msec
    ;   pixsize     I  pixels size in microns
    ;   fileformat  I   term specifing if this is a custom of new format

    ; mod by JS 11/2001 to turn on harmonic spectra etc
    select[46] = 1 ; turns on harmonic output
    select[47] = 1 ;boundary
    select[48] = 1 ;radaii
    ;select[49] = 1 ;curvature           !!!Curvature is not calculated now.


    if( strmid((*pStateInfo).asciiLogFile,rstrpos((*pStateInfo).asciiLogFile,'.')+1,3) eq 'csv')then ext = 'csv' else ext='txt'

    if(ptr_valid((*pStateInfo).pObjList))then begin
        ; write to the log file
        formatStr = request.formatStr
        formatStr1 = request.formatStr
        formatStrF = '(I4,",",a18,",", I4, ",",I7,",",'

        if(ptr_valid((*pStateInfo).pObjList))then begin
            ; modifiy format for variable length fields
            ; add last Variable length arrays if available and requested
            if(ext eq 'csv')then begin
                if(select[46])then if(imageheader.harmonic_len gt 0)then formatStrF = formatStrF + ' I3,",",' + strtrim(imageheader.harmonic_len,2)+'(f8.4,",")' else formatStrF =  formatStrF + ' I3'
                if(select[47])then if(imageheader.bound_len gt 0)then formatStrF = formatStrF + ',I3,",",' + strtrim(imageheader.bound_len,2)+'(I4,",")' else formatStrF = formatStrF + ',",",I3'
                if(select[48])then if(imageheader.radii_len gt 0)then formatStrF =  formatStrF + ',I3,",",' + strtrim(imageheader.radii_len,2)+'(f8.4,",")' else formatStrF = formatStrF + ',",",I3'
                ;          if(select[49])then if(imageheader.curvature_len gt 0)then formatStrF = formatStrF + ',I3,",",' + strtrim(imageheader.curvature_len,2)+'(f8.4,",")' else formatStrF = formatStrF + ',",",I3'
            endif else begin
                if(select[46])then if(imageheader.harmonic_len gt 0)then formatStrF1 = formatStrF + ' I3," ",' + strtrim(imageheader.harmonic_len,2)+'(f8.4," "))' else formatStrF1 = '(I3)'
                if(select[47])then if(imageheader.bound_len gt 0)then formatStrF2 = formatStrF + ' I3," ",' + strtrim(imageheader.bound_len,2)+'(I4," "))' else formatStrF2 = '(I3)'
                if(select[48])then if(imageheader.radii_len gt 0)then formatStrF3 =  formatStrF +' I3,"," ' + strtrim(imageheader.radii_len,2)+'(f8.4," "))' else formatStrF3 = '(I3)'
                ;          if(select[49])then if(imageheader.curvature_len gt 0)then formatStrF4 = '(I3," ",' + strtrim(imageheader.curvature_len,2)+'(f8.4," "))' else formatStrF4 ='(I3)'
            endelse
        endif

        ; place final closing parenthesis
        formatStr = formatStr + ')'
        formatStr1 = formatStr1 + ')'
        formatStrF = formatStrF + ')'

        ; define a structure with the data to output
        date = ''
        variables = create_struct('year',1999, 'date', date, 'number',0,'arrvTime',0UL,'missed',0U,'deadtime',0.0)
        ;create the output structure
        cmdLen = strlen(request.datacmd1)
        success = execute(request.Datacmd1)
        success2 = execute(request.Datacmd2)
        variables = create_struct(variables,variables2)

        ;fill the structure with data
        if success then begin
            if(ptr_valid((*pStateInfo).pObjList))then begin
                Firstvariables = variables

                variablesF = create_struct('year',1999, 'date', date, 'number',0,'arrvTime',0UL)
                variablesF.year = year
                seconds = string(fix(time.sec),'.',fix(time.msec),format='(i2,a1,i3)')
                variablesF.date = strtrim(fix(time.month),2)+':'+strtrim(fix(time.day),2)+':'+strtrim(fix(time.hour),2)+':'+strtrim(fix(time.minute),2)+':'+seconds
                variablesF.number = roinum
                variablesF.arrvTime = arrivTime

                if(select[46])then begin
                    if(imageheader.harmonic_len gt 0 )then begin
                        variablesF = create_struct(variablesF,'harmonic_len',imageheader.harmonic_len,'harmonics',fltarr(imageheader.harmonic_len))
                        lastVariablesF = create_struct('harmonic_len',imageheader.harmonic_len,'harmonics',fltarr(imageheader.harmonic_len))
                    endif else variablesF = create_struct(variablesF,'harmonic_len',0U)
                endif
                if(select[47])then begin
                    if(imageheader.bound_len gt 0 )then begin
                        variablesF = create_struct(variablesF,'bound_len',imageheader.bound_len,'Boundary',fltarr(imageheader.bound_len))
                    endif else variablesF = create_struct(variablesF,'bound_len',0U)
                endif
                if(select[48])then begin
                    if(imageheader.radii_len gt 0 )then begin
                        variablesF = create_struct(variablesF,'radii_len',imageheader.radii_len,'radii',fltarr(imageheader.radii_len))
                        lastVariablesF = create_struct(lastVariablesF,'radii_len',imageheader.radii_len,'radii',fltarr(imageheader.radii_len))
                    endif else variablesF = create_struct(variablesF,'radii_len',0U)
                endif
                ;          uncomment the line with 49 and the rest of the nested if statements for curvature numbers.
                ;       if(select[49])then begin
                ;          if(imageheader.curvature_len gt 0 )then begin
                ;            variablesF = create_struct(variablesF,'curvature_len',imageheader.curvature_len,'curvature',fltarr(imageheader.curvature_len))
                ;            lastVariablesF = create_struct(lastVariablesF,'curvature_len',imageheader.curvature_len,'curvature',fltarr(imageheader.curvature_len))
                ;          endif else variablesF = create_struct(variablesF,'curvature_len',0U)
                ;       endif
            endif else begin
                focus = 100-imageHeader.Flags AND '00FF'X
                crystal = ISHFT(imageHeader.Flags, -8) AND '001F'X
                cutoff = fix(100 * (ISHFT(imageHeader.Dark,-8) AND '1F'X)/31.0)
            endelse

            struct_assign,imageheader,variables
            variables.year = year
            seconds = string(fix(time.sec),'.',fix(time.msec),format='(i2,a1,i3)')
            variables.date = strtrim(fix(time.month),2)+':'+strtrim(fix(time.day),2)+':'+strtrim(fix(time.hour),2)+':'+strtrim(fix(time.minute),2)+':'+seconds
            variables.number = roinum
            variables.arrvTime = arrivTime
            variables.missed = missed
            variables.deadtime = deadTime*1000.0
            if(ptr_valid((*pStateInfo).pObjList))then begin
                if(imageheader.harmonic_len gt 0 and select[46])then variablesF.harmonics = *(imageheader.harmonics)
                if(imageheader.bound_len gt 0 and select[47])then variablesF.boundary = *(imageheader.boundary)
                if(imageheader.radii_len gt 0 and select[48])then variablesF.radii = *(imageheader.radii)

                ;          if(imageheader.Curvature_len gt 0 and select[49])then variablesF.curvature = *(imageheader.curvature)
                ; convert values in pixels to microns
                fields = tag_names(variables)
                ind = where(fields eq 'LEN',cnt)
                if(Cnt eq 1)then variables.len = variables.len * pixsize
                ind = where(fields eq 'WID',cnt)
                if(Cnt eq 1)then variables.wid = variables.wid * pixsize
                ind = where(fields eq 'AREA',cnt)
                if(Cnt eq 1)then variables.area = variables.area * (pixsize^2)
                ind = where(fields eq 'PERIM',cnt)
                if(Cnt eq 1)then variables.perim = variables.perim * pixsize

                ; this corrects crystal type in old obj files
                ; TAF attempting to comment out this forcing of crystal = 1
                ;if(variables.crystal eq 0 and variables.area gt 0)then variable.crystal = 1
            endif else begin
                variables.focus = focus
                variables.cutoff = cutoff
                variables.crystal = crystal
            endelse

        endif


        ; write the line
        on_ioerror,overflow
        errorCond = !true
        ;flush,(*pStateInfo).logLUN1
        printf,(*pStateInfo).logLUN1,variables,format=formatStr
        ;flush,(*pStateInfo).logLUN2
        printf,(*pStateInfo).logLUN2,variablesF,format=formatStrF
        errorCond = !false
        overflow:
        if errorCond then begin
            ; write in long fields on next line
            struct_assign,imageheader,Firstvariables
            Firstvariables.year = year
            seconds = string(fix(time.sec),'.',fix(time.msec),format='(i2,a1,i3)')
            Firstvariables.date = strtrim(fix(time.month),2)+':'+strtrim(fix(time.day),2)+':'+strtrim(fix(time.hour),2)+':'+strtrim(fix(time.minute),2)+':'+seconds
            Firstvariables.number = roinum
            Firstvariables.arrvTime = arrivTime
            Firstvariables.missed = missed
            Firstvariables.deadtime = deadTime*1000.0
            if(ptr_valid((*pStateInfo).pObjList))then begin
                ; convert values in pixels to microns
                fields = tag_names(Firstvariables)
                ind = where(fields eq 'LEN',cnt)
                if(Cnt eq 1)then Firstvariables.len = Firstvariables.len * pixsize
                ind = where(fields eq 'WID',cnt)
                if(Cnt eq 1)then Firstvariables.wid = Firstvariables.wid * pixsize
                ind = where(fields eq 'AREA',cnt)
                if(Cnt eq 1)then Firstvariables.area = Firstvariables.area * (pixsize^2)
                ind = where(fields eq 'PERIM',cnt)
                if(Cnt eq 1)then Firstvariables.perim = Firstvariables.perim * pixsize
            endif else begin
                Firstvariables.focus = focus
                Firstvariables.cutoff = cutoff
                Firstvariables.crystal = crystal
            endelse
            printf,(*pStateInfo).logLUN1,Firstvariables,format=formatStr1
            ;      printf,(*pStateInfo).logLUN2,variablesF.harmonic_len,variablesF.harmonics,format=formatStrF1
            ;      printf,(*pStateInfo).logLUN2,variablesF.bound_len,variablesF.boundary,format=formatStrF2
            ;      printf,(*pStateInfo).logLUN2,variablesF.radii_len,variablesF.radii,format=formatStrF3
            ;      printf,(*pStateInfo).logLUN2,variablesF.curvature_len,variablesF.curvature,format=formatStrF4
        endif

    endif else begin
        ;write a simple output
        date = ''
        variables = create_struct('year',1999, 'date', date, 'number',0,'arrvTime',0UL,'missed',0U,'deadtime',0.0)
        variables.year = year
        seconds = string(fix(time.sec),'.',fix(time.msec),format='(i2,a1,i3)')
        variables.date = strtrim(fix(time.month),2)+':'+strtrim(fix(time.day),2)+':'+strtrim(fix(time.hour),2)+':'+strtrim(fix(time.minute),2)+':'+seconds
        variables.number = roinum
        variables.arrvTime = arrivTime
        variables.missed = missed
        variables.deadtime = deadTime*1000.0
        focus = strtrim(100-(imageHeader.Flags AND '00FF'X),2)
        crystal = ISHFT(imageHeader.Flags, -8) AND '001F'X
        cutoff = strtrim(fix(100 * (ISHFT(imageHeader.Dark,-8) AND '1F'X)/31.0),2)
        printf,(*pStateInfo).logLUN1,frameNum,variables,focus,cutoff,crystal,format='(I5,x,I4,x,a18,x, I4, x,I7,x,I4,x,f7.3,x,2(f8.2,x),i8)';888888

    endelse

end

pro write_line_old,pStateInfo, frameNum, frameheader, imageHeader,time ,airspeed,deadtime,PDSThresh45,PDSThresh90

    TimeStamp = (long(frameHeader.hour) * 10000) + (frameHeader.minute * 100) + frameHeader.sec
    ProbeTime = 1000*CalcStrobeTime(frameHeader.ArrivalT1, frameHeader.ArrivalT2,frameHeader.Ver)

    widget_control,(*pStateInfo).PixSizeID, get_value=pix_size
    meanSize = round(sqrt(imageheader.len*imageheader.wid)* pix_size)
    area = -1

    focus = 100-(imageHeader.Flags AND '00FF'X)
    crystal = ISHFT(imageHeader.Flags, -8) AND '001F'X
    cutoff = fix(100 * (ISHFT(imageHeader.Dark,-8) AND '1F'X)/31.0)

    PRINTF, (*pStateInfo).logLUN, frameNum+1, (frameHeader.ImgType AND 2)/2, TimeStamp, time.msec, $
        frameHeader.Time, ProbeTime, deadtime*1000.0, meanSize, round(imageheader.len*pix_size), round(imageheader.wid*pix_size), $
        imageheader.Area*pix_size*pix_size, imageheader.perim*pix_size, focus, crystal, cutoff, imageHeader.Flags, frameHeader.Missed-1, frameHeader.BGRate, -1, -1, $
        frameHeader.ROIMinSize, frameHeader.ROIAspect, frameHeader.ROIFill, frameHeader.IThresh, $
        frameHeader.ROIXPad, frameHeader.ROIYPad, frameHeader.ROIErr, frameHeader.ROIFCount, frameHeader.ImgMean, $
        -1, frameHeader.TransitT, PDSThresh45, PDSThresh90, frameHeader.ProbeMode, AirSpeed,$
        FORMAT='(I6, I4, I9, I6, 2I11, f8.2,3I7, 2I8, 3I8, I6, I6, I6, 3I10, 2F11.2, 4I8, I12, 2I8, I10, x, I8, I8 ,2I10)';f8.5, f8.5 ,2I10)'
end

pro close_ascii,pStateInfo
    ;Purpose : to close an open log and HK file

    if((*pStateInfo).LogLUN1 gt 0)then begin
        print,'Closing file ',(fstat((*pStateInfo).LogLUN1)).name
        free_lun,(*pStateInfo).LogLUN1
        close,(*pStateInfo).LogLUN1
        (*pStateInfo).LogLUN1 = -1
    endif

    if((*pStateInfo).LogLUN2 gt 0)then begin
        print,'Closing file ',(fstat((*pStateInfo).LogLUN2)).name
        free_lun,(*pStateInfo).LogLUN2
        close,(*pStateInfo).LogLUN2
        (*pStateInfo).LogLUN2 = -1
    endif

    (*pStateInfo).asciiLogFile = ''

    if((*pStateInfo).HKLUN gt 0)then begin
        print,'Closing file ',(fstat((*pStateInfo).hkLUN)).name
        free_lun,(*pStateInfo).HKLUN
        close,(*pStateInfo).HKLUN
        (*pStateInfo).HKLUN = -1
    endif
    ;free_lun,(*pStateInfo).HKLUN
    ;(*pStateInfo).ASCIILogFile = ''

end


pro writeFrameHeader,Frmhdr,pStateInfo

    ; writes a line of info about the frame

    ; form time as ascii string
    date = strtrim(fix(Frmhdr.day),2) + ':' + strtrim(fix(Frmhdr.hour),2) + ':' + strtrim(fix(Frmhdr.minute),2) + ':' + strtrim(fix(Frmhdr.sec),2) + '.' + strtrim(Frmhdr.msec,2)

    printf,(*pStateInfo).LogLUN1,Frmhdr.(1),Frmhdr.(2),Frmhdr.(3),Frmhdr.(4),date,Frmhdr.(10),Frmhdr.(11),Frmhdr.(12),Frmhdr.(13),Frmhdr.(14),Frmhdr.(15),Frmhdr.(16),Frmhdr.(17),$
        Frmhdr.(18),Frmhdr.(19),Frmhdr.(20),Frmhdr.(21),Frmhdr.(22),Frmhdr.(23),Frmhdr.(24),Frmhdr.(25),Frmhdr.(26),Frmhdr.(27),Frmhdr.(28),Frmhdr.(29),Frmhdr.(30),Frmhdr.(31),$
        Frmhdr.(32),Frmhdr.(33),Frmhdr.(34),Frmhdr.(35),Frmhdr.(36),Frmhdr.(37),Frmhdr.(38),Frmhdr.(39),Frmhdr.(40),Frmhdr.(41),Frmhdr.(42),Frmhdr.(43),Frmhdr.(44),$
        format='(i3,x,i2,x,i3,4x,i7,x,a16,x,i5,3x,4(i4,x),i2,5x,i3,8x,i5,4x,i2,2x,i2,4x,i3,8x,f7.2,4x,e8.1,x,i4,3x,i3,3x,i3,2x,i3,3x,i2,3x,i2,3x,i6,2x,i5,3x,i4,5x,i4,7x,i5,2x,i4,5x,i5,4x,i2,3x,i5,x,i9,2x,i4,3x,i6,x,i6,2x,i5,3x,i5,2x,i5,3x,i5,3x,i5)'
    ;=================================================================================================================================ypad====================maxval==============================tim=================
end
function open_ascii_spec1,pStateInfo,criteria


    ;Purpose: To open an ASCII log file and write a file header

    ; Parameter
    ;   pStateInfo       I uses fields minFile for file name and ObjFile for Logical unit number
    ;   FileFormat       I flag to choose header
    ;   select      I   array of 1's and 0's indicating which fields to choose
    ;   criteria       I string containing acceptance criteria
    (*pStateInfo).asciiLogFile = strmid((*pStateInfo).InFileName, 0,rstrpos((*pStateInfo).InFileName,'.')) +'_'+strtrim(!project_name,2)+'_'+strtrim(!platform,2)+'_3VCPI_combined.csv'
    openw,lun2,(*pStateInfo).asciiLogFile,/get,bufsize = 131072L
    (*pStateInfo).LogLUN2 = lun2

    header2 = 'year,mm:dd:hh:mm:ss,ROI #,ArrTime,TS,DeadTime,Length,Width,Area,Perim,Roundness1,Focus,Cutoff,Crystal,P1,'+$
        'Inten_HoleLess_Stats,HrmCnt,h1,h2,h3,h4,h5,h6,SX,SY,EX,EY'

    printf,lun2,'FileName:',(*pStateInfo).InFileName
    printf,lun2,'Acceptance Criteria:','if('+ criteria +')then accept    and Time are original Times.'
    printf,lun2, header2

    formatStr='(I4,",",a18,",", I4, ",",I7,",",I4,",",f7.3,6(",",f10.2),3(",",I3),2(",",f10.2),6(",",f10.8),4(",",i4))'

    outStruct = {year:0, date: '',number:0,arrvTime:0UL,missed:0U,deadtime:0.0,len:0.0,Wid:0.0,area:0.0,perim:0.0,Roundness1:0.0, $
        focus:0B,cutoff:0B ,crystal:0B,P1:0.0,Intensity_HoleLess_Stats:0.0,hrmCnt:0,h1:0.0,h2:0.0,h3:0.0,h4:0.0,h5:0.0,h6:0.0,sx:0,sy:0,ex:0,ey:0}

    return,{formatStr:formatStr, outStruct:outStruct}

end



pro write_line_spec1, pStateInfo, request,  imageheader, roinum, year, time, arrivTime, missed,deadtime, pixsize,fileformat,frameNum,PDSThresh45,PDSThresh90
    ;Purpose - to write a line of requested data to the output files

    ;Parameters
    ;   pStateInfo
    ;   request     I    structure with two fields, {dataCmd:dataCmd, formatStr:formatStr} created in open_ascii above
    ;     where
    ;          dataCmd is string input into the "execute" command to create a data structure
    ;          formatStr is string containing the format
    ;   roinum       I     number of roi being written
    ;   year   I   year of data file
    ;   time   I   structure with time
    ;   arrvtime  I    arrival time
    ;   missed       I missed particle count
    ;   deadtime  I    deadtime in msec
    ;   pixsize     I  pixels size in microns
    ;   fileformat  I   term specifing if this is a custom of new format


    ; define a structure with the data to output
    variables = request.outstruct
    focus = 100-imageHeader.Flags AND '00FF'X
    ;crystal = ISHFT(imageHeader.Flags, -8) AND '001F'X
    ;    cutoff = fix(100 * (ISHFT(imageHeader.Dark,-8) AND '1F'X)/31.0)
    struct_assign,imageheader,variables
    variables.year = year
    seconds = string(fix(time.sec),'.',fix(time.msec),format='(i2,a1,i3)')
    variables.date = strtrim(fix(time.month),2)+':'+strtrim(fix(time.day),2)+':'+strtrim(fix(time.hour),2)+':'+strtrim(fix(time.minute),2)+':'+seconds
    variables.number = roinum
    variables.arrvTime = arrivTime
    variables.missed = missed
    variables.deadtime = deadTime*1000.0
    if (imageheader.ROIVer GE 30) THEN variables.hrmcnt=imageheader.harmonic_len $
        ELSE variables.hrmcnt=0
    variables.len = variables.len * pixsize
    variables.wid = variables.wid * pixsize
    variables.area = variables.area * (pixsize^2)
    variables.perim = variables.perim * pixsize
    variables.sx = imageheader.sx
    variables.ex = imageheader.ex
    variables.sy = imageheader.sy
    variables.ey = imageheader.ey

    ; TAF attempting to comment out this forcing of crystal = 1
    ;if(variables.crystal eq 0 and variables.area gt 0)then variables.crystal = 1

    if (variables.hrmcnt gt 6) then begin
        variables.h1=(*(imageheader.harmonics))(1)
        variables.h2=(*(imageheader.harmonics))(2)
        variables.h3=(*(imageheader.harmonics))(3)
        variables.h4=(*(imageheader.harmonics))(4)
        variables.h5=(*(imageheader.harmonics))(5)
        variables.h6=(*(imageheader.harmonics))(6)
    endif
    ; write the line
    printf,(*pStateInfo).logLUN2,variables,format=request.formatStr


end

pro write_line_spec1_3VCPI, pStateInfo, request,  imageheader, roinum, year, time, arrivTime,framedata,deadtime, pixsize,fileformat,frameNum,PDSThresh45,PDSThresh90
    ;Purpose - to write a line of requested data to the output files

    ;Parameters
    ;   pStateInfo
    ;   request     I    structure with two fields, {dataCmd:dataCmd, formatStr:formatStr} created in open_ascii above
    ;     where
    ;          dataCmd is string input into the "execute" command to create a data structure
    ;          formatStr is string containing the format
    ;   roinum       I     number of roi being written
    ;   year   I   year of data file
    ;   time   I   structure with time
    ;   arrvtime  I    arrival time
    ;   missed       I missed particle count
    ;   deadtime  I    deadtime in msec
    ;   pixsize     I  pixels size in microns
    ;   fileformat  I   term specifing if this is a custom of new format


    ; define a structure with the data to output
    variables = request.outstruct
    focus = 100-imageHeader.Flags AND '00FF'X
    ;crystal = ISHFT(imageHeader.Flags, -8) AND '001F'X
    ;    cutoff = fix(100 * (ISHFT(imageHeader.Dark,-8) AND '1F'X)/31.0)
    struct_assign,imageheader,variables
    variables.year = year
    seconds = string(fix(time.sec),'.',fix(time.msec),format='(i2,a1,i3)')
    variables.date = strtrim(fix(time.month),2)+':'+strtrim(fix(time.day),2)+':'+strtrim(fix(time.hour),2)+':'+strtrim(fix(time.minute),2)+':'+seconds
    variables.number = roinum
    variables.arrvTime = arrivTime
    variables.missed = framedata.frameheader.missed
    variables.deadtime = deadTime*1000.0
    if (imageheader.ROIVer GE 30) THEN variables.hrmcnt=imageheader.harmonic_len $
        ELSE variables.hrmcnt=0
    variables.len = variables.len * pixsize
    variables.wid = variables.wid * pixsize
    variables.area = variables.area * (pixsize^2)
    variables.perim = variables.perim * pixsize
    variables.sx = imageheader.sx
    variables.ex = imageheader.ex
    variables.sy = imageheader.sy
    variables.ey = imageheader.ey

    ; TAF attempting to comment out this forcing of crystal = 1
    ; if(variables.crystal eq 0 and variables.area gt 0)then variable.crystal = 1

    if (variables.hrmcnt gt 6) then begin
        variables.h1=(*(imageheader.harmonics))(1)
        variables.h2=(*(imageheader.harmonics))(2)
        variables.h3=(*(imageheader.harmonics))(3)
        variables.h4=(*(imageheader.harmonics))(4)
        variables.h5=(*(imageheader.harmonics))(5)
        variables.h6=(*(imageheader.harmonics))(6)
    endif

    Thismonth = (*Pstateinfo).date.month;    ; This is int.    the date  {2011 10  31}
    this_day0 = (*Pstateinfo).date.day
    Thisday   = framedata.FrameHeader.day

    if ThisDay lt This_day0 then Thismonth = Thismonth+1

    Thishour  = framedata.FrameHeader.hour
    Thisminute= framedata.FrameHeader.minute
    Thissec   = framedata.FrameHeader.sec
    Thismsec  = framedata.FrameHeader.msec

    seconds = string(fix(Thissec), '.', fix(Thismsec), format='(i2,a1,i3)')
    variables.date = strtrim(fix(Thismonth),2) + ':' + strtrim(fix(Thisday),2) + ':' + strtrim(fix(Thishour),2) + ':'+strtrim(fix(Thisminute),2) + ':' + seconds
    variables.arrvTime = 0
    variables.missed   = 0

    printf,(*pStateInfo).logLUN2, variables, format=request.formatStr
end   ; write  3vCPI combined.csv  file.
