pro custom_log_event,event

    widget_control,event.top, get_uvalue = pInfo
    widget_control,event.ID, get_uvalue = uval

    case uval of
        'len':(*pInfo).select[0] = not (*pInfo).select[0]
        'wid':(*pInfo).select[1] = not (*pInfo).select[1]
        'dark':(*pInfo).select[2] = not (*pInfo).select[2]
        'area':(*pInfo).select[3] = not (*pInfo).select[3]
        'perim':(*pInfo).select[4] = not (*pInfo).select[4]
        'centroid':(*pInfo).select[5] = not (*pInfo).select[5]
        'round':(*pInfo).select[6] = not (*pInfo).select[6]
        'xmom':(*pInfo).select[7] = not (*pInfo).select[7]
        'ymom':(*pInfo).select[8] = not (*pInfo).select[8]
        'rband':(*pInfo).select[9] = not (*pInfo).select[9]
        'fractal':(*pInfo).select[10] = not (*pInfo).select[10]
        'period':(*pInfo).select[11] = not (*pInfo).select[11]
        'focus':(*pInfo).select[12] = not (*pInfo).select[12]
        'fmin':(*pInfo).select[13] = not (*pInfo).select[13]
        'fmax':(*pInfo).select[14] = not (*pInfo).select[14]
        'fsdev':(*pInfo).select[15] = not (*pInfo).select[15]
        'fgood':(*pInfo).select[16] = not (*pInfo).select[16]
        'cutoff':(*pInfo).select[17] = not (*pInfo).select[17]
        'crystal':(*pInfo).select[18] = not (*pInfo).select[18]
        ;'confidence'
        'p1':(*pInfo).select[19] = not (*pInfo).select[19]
        'Roundness2':(*pInfo).select[20] = not (*pInfo).select[20]
        'Roundness3':(*pInfo).select[21] = not (*pInfo).select[21]
        'p4':(*pInfo).select[22] = not (*pInfo).select[22]

        'cwind':(*pInfo).select[23] = not (*pInfo).select[23]
        'focusS':(*pInfo).select[24] = not (*pInfo).select[24]
        'intenS':(*pInfo).select[25] = not (*pInfo).select[25]
        'intenHS':(*pInfo).select[26] = not (*pInfo).select[26]
        'gradS':(*pInfo).select[27] = not (*pInfo).select[27]
        'radiiS':(*pInfo).select[28] = not (*pInfo).select[28]
        'CurveS':(*pInfo).select[29] = not (*pInfo).select[29]
        'HoleCnt':(*pInfo).select[30] = not (*pInfo).select[30]
        'holeAS':(*pInfo).select[31] = not (*pInfo).select[31]
        'holeIS':(*pInfo).select[32] = not (*pInfo).select[32]
        'holeOS':(*pInfo).select[33] = not (*pInfo).select[33]
        'hole1A':(*pInfo).select[34] = not (*pInfo).select[34]
        'hole1IS':(*pInfo).select[35] = not (*pInfo).select[35]
        'hole1P':(*pInfo).select[36] = not (*pInfo).select[36]
        'hole1OS':(*pInfo).select[37] = not (*pInfo).select[37]
        'hole2A':(*pInfo).select[38] = not (*pInfo).select[38]
        'hole2IS':(*pInfo).select[39] = not (*pInfo).select[39]
        'hole2P':(*pInfo).select[40] = not (*pInfo).select[40]
        'hole2OS':(*pInfo).select[41] = not (*pInfo).select[41]
        'hole3A':(*pInfo).select[42] = not (*pInfo).select[42]
        'hole3IS':(*pInfo).select[43] = not (*pInfo).select[43]
        'hole3P':(*pInfo).select[44] = not (*pInfo).select[44]
        'hole3OS':(*pInfo).select[45] = not (*pInfo).select[45]

        'harm':(*pInfo).select[46] = not (*pInfo).select[46]
        'bound':(*pInfo).select[47] = not (*pInfo).select[47]
        'radii':(*pInfo).select[48] = not (*pInfo).select[48]
        'curve':(*pInfo).select[49] = not (*pInfo).select[49]
        'cont':begin
        (*pInfo).ok = !true
        widget_control,event.top,/destroy
    end
    'cancel':begin
    ;(*pInfo).ok = !false
    widget_control,event.top,/destroy
end
else:
endcase

(*pInfo).select = (*pInfo).select and 1
end



function custom_log, pSelect, mainID
    ; Purpose: to allow the user the option to define the fields in the ascii output

    ; Parameters
    ;   pSelect     I/O   pointer to array of 1/0's indicating what parameters are selected
    ;   mainID   I     widget ID of leader

    ;Returns true or false depending on users selection


    ; Initialize structure if needed
    if(not arg_present(select))then message,'Error in custom_log'

    ; create GUI to query the user
    tlb1 = widget_base(title='Set ASCII Log file Parameters',/col,/modal,group_leader=mainID)

    label1 = widget_label(tlb1,value='Select the fields to be included in the ASCII Log file')

    but = lonarr(50)
    base1 = widget_base(tlb1,col = 5,/nonexclusive)

    but[0] = widget_button(base1,value='Length',uvalue='len')
    but[1] = widget_button(base1,value='Width',uvalue='wid')
    but[2] = widget_button(base1,value='Dark',uvalue='dark')
    but[3] = widget_button(base1,value='Area',uvalue='area')
    but[4] = widget_button(base1,value='Perimeter',uvalue='perim')
    but[5] = widget_button(base1,value='Centroid',uvalue='centroid')
    but[6] = widget_button(base1,value='Roundness1',uvalue='round')
    but[7] = widget_button(base1,value='X Moment',uvalue='xmom')
    but[8] = widget_button(base1,value='Y Moment',uvalue='ymom')
    but[9] = widget_button(base1,value='Rubber Band',uvalue='rband')
    but[10] = widget_button(base1,value='Fractal Dim.',uvalue='fractal')
    but[11] = widget_button(base1,value='Sample Period',uvalue='period')
    but[12] = widget_button(base1,value='Focus',uvalue='focus')
    but[13] = widget_button(base1,value='Focus Min',uvalue='fmin')
    but[14] = widget_button(base1,value='Focus Max',uvalue='fmax')
    but[15] = widget_button(base1,value='Focus STDDEV',uvalue='fsdev')
    but[16] = widget_button(base1,value='Focus Good',uvalue='fgood')
    but[17] = widget_button(base1,value='Cut-off',uvalue='cutoff')
    but[18] = widget_button(base1,value='Crystal',uvalue='crystal')
    but[19] = widget_button(base1,value='P1',uvalue='p1')
    but[20] = widget_button(base1,value='Roundness2',uvalue='Roundness2')
    but[21] = widget_button(base1,value='Roundness3',uvalue='Roundness3')
    but[22] = widget_button(base1,value='P4',uvalue='p4')

    ;but[23] = widget_button(base1,value='Harmonic_len',uvalue='Hlen')
    ;but[24] = widget_button(base1,value='Boundary_len',uvalue='Blen')
    ;but[25] = widget_button(base1,value='Radii_len',uvalue='Rlen')
    ;but[26] = widget_button(base1,value='Curvature_len',uvalue='Clen')
    but[23] = widget_button(base1,value='Curvature_Window',uvalue='cwind')
    but[24] = widget_button(base1,value='Focus_Stats',uvalue='FocusS')
    but[25] = widget_button(base1,value='Intensity_Stats',uvalue='intenS')
    but[26] = widget_button(base1,value='Intensity_HoleLess_Stats',uvalue='intenHS')
    but[27] = widget_button(base1,value='Gradient_Stats',uvalue='gradS')
    but[28] = widget_button(base1,value='Radii_Stats',uvalue='radiiS')
    but[29] = widget_button(base1,value='Curvature_Stats',uvalue='CurveS')
    but[30] = widget_button(base1,value='Hole_Count',uvalue='HoleCnt')
    but[31] = widget_button(base1,value='Hole_Area_Stats',uvalue='holeAS')
    but[32] = widget_button(base1,value='Hole_Intensity_Stats',uvalue='holeIS')
    but[33] = widget_button(base1,value='Hole_Other_Stats',uvalue='holeOS')
    but[34] = widget_button(base1,value='Hole1_Area',uvalue='hole1A')
    but[35] = widget_button(base1,value='Hole1_Intensity_Stats',uvalue='hole1IS')
    but[36] = widget_button(base1,value='Hole1_Perim',uvalue='hole1P')
    but[37] = widget_button(base1,value='Hole1_Other_Stats',uvalue='hole1OS')
    but[38] = widget_button(base1,value='Hole2_Area',uvalue='hole2A')
    but[39] = widget_button(base1,value='Hole2_Intensity_Stats',uvalue='hole2IS')
    but[40] = widget_button(base1,value='Hole2_Perim',uvalue='hole2P')
    but[41] = widget_button(base1,value='Hole2_Other_Stats',uvalue='hole2OS')
    but[42] = widget_button(base1,value='Hole3_Area',uvalue='hole3A')
    but[43] = widget_button(base1,value='Hole3_Intensity_Stats',uvalue='hole3IS')
    but[44] = widget_button(base1,value='Hole3_Perim',uvalue='hole3P')
    but[45] = widget_button(base1,value='Hole3_Other_Stats',uvalue='hole3OS')
    but[46] = widget_button(base1,value='Harmonics',uvalue='harm')
    but[47] = widget_button(base1,value='Boundary',uvalue='bound')
    but[48] = widget_button(base1,value='Radii',uvalue='radii')
    but[49] = widget_button(base1,value='Curvature',uvalue='curve')

    base2 = widget_base(tlb1,/row)
    ok = widget_button(base2,value='Continue',uvalue='cont')
    cancel = widget_button(base2,value='Cancel',uvalue='cancel')

    ; update gui with data in pSelect
    for i = 0,n_elements(*pSelect)-1 do widget_control,but[i],set_button = (*pSelect)[i]


    widget_control,tlb1,/realize
    pInfo = ptr_new({select:*pSelect, ok:!false})
    widget_control,tlb1,set_uvalue = pInfo

    ; pass to Xmanager
    xmanager,'custom_log',tlb1,group_leader=mainID

    ; return data
    *pSelect = (*pInfo).select
    ok = (*pInfo).ok
    ptr_free,pInfo
    return,ok

end


