function help

    message = [['CPIView Help File'],$
        [''],$
        ['Steps to use CPIView'],$
        [''],$
        ['1. Load desired data:'],$
        [' a. Click on the file button or select Open from the File menu'],$
        [' b. Select the desired file. CPIView only recongizes files of extension .roi.'],$
        [' c. The file, and an associate .obj file if available, are automatically loaded.'],$
        [''],$
        ['2. View data'],$
        [' a. Use the frame slider to move to any frame.'],$
        [' b. Left click on an image to display information about the particle.'],$
        [''],$
        ['3. Plotting Options'],$
        ['  a. Click on Tools:Generate/View Plots'],$
        [' A dialog of options is presented.  From this dialog box you can:'],$
        ['   i.   Select start and stop times for multiple time periods'],$
        ['   ii.  Choose acceptance criteria'],$
        ['   iii. Select Particle Size Distribution plots'],$
        ['   iv.  Generate TIFF files of images with various labels and ASCII log files'],$
        ['   v.   Generate Time series plots'],$
        [' For more information, consult the manual on Generate/View Plots'],$
        ['3. Other options'],$
        [' a. Right click on a particle to modify the parameters manually.  If the Update button is checked, the information'],$
        ['    will be written to the current file when the frame is moved to another frame or REDO is clicked.'],$
        [' b. Select the cross section button and left click twice to define a line for the profile.'],$
        [''],$
        ['Revision Information'],$
        [''],$
        ['vers 2.0 : Initial Release'],$
        ['vers 3.0 : New version'],$
        ['vers 3.03: Changed min file output for seaview.'],$
        ['vers 3.04: Added TS-Correct keyword to command line to subtract 256 if needed from missed.'],$
        ['vers 3.05: Corrected concentration and scaling of histograms based on Total strobes.  Added scale to output pngs.'],$
        ['vers 3.06: Corrected min file output bug'],$
        ['vers 3.07: Fixed cancel probelm with manual featuring'],$
        ['vers 3.08: removed TS-Correct keyword, now automatic based on date, fixed make_min bug for no particles, corrected custom min'],$
        ['                  to handle no crystal value, changed format of time series output for more precision, corrected TS for backgrounds'],$
        ['                  corrected format of HKLog.. . mow minTT in microseconds, modified MIN file format'],$
        ['vers 3.09: Corrected file flag when adding background to a file'],$
        ['vers 3.10: Modified min file writter for compatibility with SEAVIEW'],$
        ['vers 3.11: Fixed bug in time series code wrt current_file and wrong number of points'],$
        ['vers 3.12: Bug fixes for Fire Data'],$
        ['vers 3.13: Added new output log types, added memory releasing code, added autoscan for BlockMark'],$
        ['vers 3.14: Changed format of ascii log file'],$
        ['vers 3.15: Changed processing code to use nearest background frame and added space delimited option for ASCII file'],$
        ['vers 3.16: Fixed Frame ASCII output, added file name and criteria to ASCII output'],$
        ['vers 3.17: Added per Hz ASCII output option code'],$
        ['vers 3.18: Corrected multiple file processing code'],$
        ['vers 3.19: Changed TS correction to use current file date, blanked TS count for 3 seconds after a background'],$
        ['vers 3.20: modifications to allow seaview to process min file'],$
        ['vers 3.21: Corrected concTS calculation when no acceptance criteria.  Corrected TS blanking after background'],$
        ['vers MQ-04:for UAV HKdata.ver eq 40, corrected the old_version that if reading(31)gt 1464 change to 1464'],$
        ['           here  if gt 2928 then changed to 2928 so that Dtime is < 1.0sec. Dec11/2004']]


    return,message

end
;  Auguts 19, 2009: Ver10 added ROIout2=obj_new('IDLgrROi',X,Y,color=[255,255,255]) to faster calculate teh mean_brightness.
;                   the addition is in Processparticle.pro  on ethe very end of the file.

;  May 4, 2009: change 009 to 010 use AAron's boundary points and carlos image and subroutine to re-calculate the focus.
;   ['vers 1.004 : added support for multiple file processing in Auto Extraction.  Select multiple file button and'],$
;   ['  choose the file to process. After processing, a file must be selected to view in the window, or just exit '],$
;   ['  the application. Added progess bar to GUI. Valid for current file. 06/14/99'],$
;   [''],$
;   ['vers 1.005: added harmonics_flag keyword to see plots of harmoonics'],$
;   ['left click to bring up harmonics plot window, click again to dismiss.'],$
;   [' '],$
;   ['vers 1.006: Temp fix for memory leaks, added Icw/Water labels, Changed display of Harmonics plot'],$
;   [' '],$
;   ['vers 1.007: ReDesign of Histogtram calculations and plot module'],$
;   [' '],$
;   ['vers 1.008: Continued ReDesign of Histogtram calculations and plot module. Modified Manual feature. Added HASP code'],$
;   [' '],$
;   ['vers 1.009: Added TIFF/ASCII/PRINT to Histogtram plot module. Bug fixes'],$
;   [' '],$
;   ['vers 1.010: Added Time Series plot module. Min. Shadow Depth missing'],$
;   [' '],$
;   ['vers 1.011: Bug Fixes in Time Series plot module. Min. Shadow Depth missing'],$
;   [' '],$
;   ['vers 1.012: Reworked Concentrations to use tot flashes'],$
;   [' '],$
;   ['vers 1.014: Corrected concentrations'],$
;   [' '],$
;   ['vers 1.015: Modified structure definitions for Unsigned data types, corrected format of ASCII output'],$
;   [' '],$
;   ['vers 1.016: Corrected flash cnt method'],$
;   [' '],$
;   ['vers 1.017: Bug fixes in Time series and Histograms'],$
;   [' '],$
;   ['vers 1.018: Bug fixes in Time series and Histograms 7/8/99'],$
;   [' '],$
;   ['vers 1.019: Bug fixes in TIFF output 7/8/99'],$
;   [' '],$
;   ['vers 2.01: fixed obj time selection, changed deadtime value to correct frame time, fixed number of ROI in ASCII file'],$
;   ['vers 2.02: Modified process time to skip frames with non-increasing times'],$
;   ['vers 2.04: Changed writing and reading of OBJ files;ALL OBJS BEFORE NOW ARE OBSOLETE!'],$
;   ['vers 2.05: Fixed autoscale bug in histogramviewer; changed area calc for concentrations to sqrt(area/pi), added'],$
;   ['                LWC and IWC calculations; modified gui for conc plot'],$
;   ['vers 2.06: Added new extraction code, resultings in larger OBJ files, currently these parameters are NOT'],$
;   ['                written to the ASCII out file.  Also, fixed a bug in deadtime value assignment and fixed multiple'],$
;   ['                file extraction code.  Fixed error when background is added to file, changed time of frame.'],$
;   ['vers 2.07: Changed all size parameters to maximum length in microns for all calculations.  Fixed small bugs in'],$
;   ['                histogram viewer for less than 2 particles per period, corrected interpretation of focus'],$
;   ['                parameter between real-time code and extractor code ( all now refer to In Focus % not Out of Focus).'],$
;   ['vers 2.08: Added customized output for ASCII log file and support for full obj output to log.  Added user selection'],$
;   ['                of size type for histogram and TIFF output'],$
;   ['vers 2.09: Fixed problem in reading header from obj files that caused the info from the pervious ROI to be used when a'],$
;   ['                 invalid objheader is read.'],$
;   ['vers 2.10: Fixed bug in output order of max length and mean length in plots and ASCII file'],$
;   ['vers 2.11: Changed formula for calculation of mean length to round(pixsize*sqrt(len*wid))'],$
;   ['vers 2.12: Added ability to write .min file, added frame number to log file format'],$
;   ['vers 2.13: Added ave max length and changed method of calc max len'],$
;   ['vers 2.14: Modified to automatically scan for background files during auto extraction of multiple files'],$
;   ['vers 2.15: Fixed path problem and imageheader type for OBJ file input and mean length sum.'],$
;   ['vers 2.16: Changed LWC/IWC TS scaling, fixed problems with transition to new file in time series,'],$
;   ['                  corrected deadtime accumulator error, moved TAS field.'],$
;   ['vers 2.17: Added keyword for output of HKLog.'],$
;   ['vers 2.18: modifications to multifile processing for robustness, minor changes to manual reject code.'],$
;   ['vers 2.19: changed technique for reading HK blocks.'],$
;   ['vers 2.21: Added two new plot variables WYSIWYG, and IVCTS'],$
;   ['vers 2.22: fixed problem with loop variable overrun in obj_lib and process_features_lib. Also'],$
;   ['                  fixed problem with adding backgrounds and deltion of objects when doing png output. Changed output type'],$
;   ['                  for images to png file.'],$
;   ['vers 2.23: Changed ymin,max in histogram viewer'],$
;   ['vers 2.24: Numerous fixes: added PDS to log format 2, changed how histograms count particles, changed plot method of histograms'],$
;   ['                  changed axis control in histogram viewer, made pngs fit to page, other gui fixes'],$
;   ['vers 2.25: Mean len only uses valid particles, fixed bug in time viewer min/max'],$
;   ['vers 2.26: Changed mean len average to time period basis, other small gui fixes'],$
;   ['vers 2.27: Changed PDS values to non-scaled,fixed mosaic memory, disabled LWC,IWC in QL'],$
;   ['vers 2.28: Changed LWC calcs to mean length, change HK log file and PDS to non-scaledfixed viewer gui bugs'],$
;   ['vers 2.29: Modified handling of start times in processing'],$
;   ['vers 2.30: Debugged start and stop time processing in procesing, fixed hist plot max,min, fixed background addition'],$
;   ['vers 2.31: Fixed IWC and TSConc values'],$
;   ['vers 2.32: Corrected bugs in QL version'],$
;   ['vers 2.33: Fixed ASCII output in QL, changed name of HKLog file, correct AP number in size distributions.'],$
;   ['vers 2.34: Corrected max size and mean size in QL version'],$
;   ['vers 2.35: Fixed update of roi for manual processing, fixed histogram ascii write/reader, added round to WYSIWYG'],$
;   ['vers 2.36: Modified IWC Mass calc for d Gt 200  and LT 200, changed init of imgfrmct for multi-file processing'],$
;   ['vers 2.37: Changed time series values to doubles, corrected reject all and read/write hist in XL, corrected IWC equation'],$
;   ['vers 2.38: New version of extraction algorithm'],$
;   ['vers 2.39: Fixed read/write process in histogram'],$
;   ['vers 2.40: Modified to avoid repeating times, fixed histogram viewer, and profiler'],$
;   ['vers 2.43: changed init of time values for IWC and LWC, added WYSIWYG scaling to Hist'],$
;   ['vers 2.44: Corrected WYSIWYG scaling value, added WYSIWYG to hist read/write'],$
;   ['vers 2.45: Added Auto/man option for LWC,IWC, fixed mean length calc'],$


pro display_help,group_leader = leader

tlb = widget_base(title='CPIView Help File',group_leader = leader)

message = help()

test = widget_text(tlb,value=message,xsize=100,ysize=30,/scroll)

widget_control,tlb,/realize

end

