pro hist, sizearray,SampleVolume,PixSize


    sumsecs = 60
    binSize = 10.0
    binMin = 0;5.0

    spectraCnt = ceil(500.0/binSize)
    indx = where(ptr_valid(sizearray),cnt)
    numIntls = fix(cnt/sumsecs)>1
    bins = findgen(spectraCnt)*binsize + binMin
    window,/free

    ;scale = BinSize*PixSize*SampleVolume * sumSecs
    ;print,scale

    ; finally normalize with correct concentration info
    ; take each spectra * concentration / (# of particles * bin width)
    ; where # of particles = total(spectra) and concentration is the total concentration in this interval

    dx = 1024.0
    dy = 1022.0
    TAS = 15000 ; cm/sec
    volume = pixsize^2*(1.e-8)*(dx*dy)*(sqrt(2.0)/2.0) * TAS / 1000.0 	; L/sec here pixsize in microns, dx and dy in pixels
    ;  ( 1.e-8 sq. cm / sq microns) and 1000 cc/Liter

    volume = volume * sumsecs  ; L/interval
    !p.multi=[0,numIntls,1]

    for j = 0,numIntls-1 do begin
        spectra = lonarr(spectraCnt)
        ;spectra are in #/(bin*Interval)
        ;for i=0,(sumsecs<cnt)-1 do begin
        for i=0,26 do begin
            if(ptr_valid(sizearray[i + j*sumsecs]))then begin
                spectra = histogram(*sizearray[i + j*sumsecs],binsize=binSize,input = spectra,min=binMin,max = binsize*(spectraCnt-1))
                ptr_free,sizearray[i + j*sumsecs]
            endif
        endfor

        Conc = total(spectra)/volume
        ; then take spectra/volume/binsize -> #/(bin*sec) x sec/liter x bin/micron - > #/Liter/micron
        spectra = spectra /( volume * binsize)

        title = 'Particle Spectra. Total count/Liter=' + strmid(conc,2)
        plot,bins[0:20],spectra[0:20],/ylog,psym=10,yrange=[.01,100],xtitle='particle sizes',ytitle='#/L/um',title=title

    endfor
    !p.multi=0
end

; older method from sea view

;spec_cpi = fltarr(spectraCnt,numIntls)
;		if(ptr_valid(sizearray[i + j*sumsecs]))then begin
;			; this array holds the bin index for each meansize
;			bins1 = fix(*sizearray[i + j*sumsecs]/binsize)
;			ptr_free,sizearray[i + j*sumsecs]

;			; force long particles into the largest bin (saturate data)
;			bins1 = bins1 < ( spectraCnt-1)

;			; fill the spec_cpi array with a count of the particles in each bin
;			num = n_elements(bins)
;			if(num gt 1)then begin
;				for k=0, n_elements(bins1)-1 do spec_cpi[bins1[k],j] = spec_cpi[bins1[k],j] + 1
;			endif else begin
;				spec_cpi[bins1,j] = spec_cpi[bins1,j] + 1
;			endelse
;		endif

;window,/free
;plot,bins[0:20],spec_cpi[0:20,j]/scale,psym=10,/ylog,yrange=[.001,100]
;oplot,bins[0:20],spec_cpi[0:20,j]/scale,psym=10,color=128
