; Code used in the procesing of time periods
pro groupLink__define
    ; structure used in Histogram calculations

    group = {groupLink,$
        missed:0L,$            ; missed strobes per group
        deadtime:0.0,$          ; deadtime of group
        startTime:0L,$          ; time of the start of this group in seconds of year less than actual
        totFrmCnt:0L,$          ; total number of frames considered in this group
        ROIFrmCnt:0L,$          ; number of frames with images
        totImgPart:0L,$          ; total number of particles in this group
        wysiwyg:0.0,$          ; wysiwyg scale factor
        nonRejPart:0L,$          ; total number of non-rejected particles due to auto extraction process
        acceptPart:0L,$          ; total number of accpeted particles due to auto extraction process
        spec_accumpartcnt:0L,$   ; tot_count of particles in this time period.
        pData:ptr_new(),$         ; the actual data to be evaluated, in microns acrose diagaonal, average
        pDataA:ptr_new(),$        ; added for Area PSD
        pDataM:ptr_new(),$        ; added for Mass PSD
        pDataH:ptr_new(),$        ;added for Habits.
        next_link:ptr_new(),$       ; next link
        prev_link:ptr_new(),$     ; previous link
        pAdj: ptr_new(),$      ;     added august 24, 2004.
        Nbinedges:ptr_new(),$;   added august 24, 2004.
        Nbinheights: ptr_new(),$
        Lbinheights: ptr_new(),$
        Abinheights: ptr_new(),$
        Mbinheights: ptr_new(),$  ;added august 24, 2004.
        pDataC:ptr_new(),$         ; added for dfj wysiwyg1  october 5, 2004
        pDataCA:ptr_new(),$        ; added for Area PSD
        pDataCM:ptr_new(),$
        pdfj: ptr_new(),$
        pDataW:ptr_new(),$         ; added for wfj wysiwyg_r  october 5, 2004
        pDataWA:ptr_new(),$        ; added for Area PSD
        pDataWM:ptr_new(),$
        pdatawH:ptr_new(),$        ;added dec 7 2004 for habits.
        pwfj: ptr_new(),$          ;  added for wfj wysiwyg_r  october 5, 2004
        pZFrmcont:ptr_new(),$  ; for conditional frame0_conts
        pDvect:ptr_new(),$   ;   for storing Dcor values
        pWvect:ptr_new(),$   ;   for storing WFJ values
        pNvect:ptr_new(),$   ;}    ;   for storing N_imgs values.
        pfssp:ptr_new(),$   ;       added nov 5 2004.
        ptwoDC:ptr_new(),$
        ptwoDCA:ptr_new(),$,
    ptwoDCM:ptr_new()}

end  ; end of group_define

pro deleteGroup, pGroup
    ptr_free,(*pGroup).pData
    ptr_free,(*pgroup).pAdj;  added august 24, 2004
    ptr_free,(*pGroup).pDataA
    ptr_free,(*pGroup).pDataM
    ptr_free,pGroup

end

pro doLogFile, plink,imglist,frame, framedata, pROIArray,request,pStateInfo,imgfrmct,roiNum,time
    case (*pLink).format of
        'old':begin
        if(ROINum eq 0)then begin
            deadtime = imgList[frame].deadtime
            PDSThresh45 = imgList[frame].PDSThresh45
            PDSThresh90 = imgList[frame].PDSThresh90
        endif else begin
            deadtime = 0.0
            PDSThresh45 = 0.0
            PDSThresh90 = 0.0
        endelse
        write_line_old,pStateInfo, frame, frameData.frameheader, (*pROIArray)[ROINum].imageHeader,time,(*pLink).TAS,deadtime,PDSThresh45,PDSThresh90
    end
    'frame':begin

end
'hertz':begin
end
'spec1':begin
ProbeTime = 1000UL*CalcStrobeTime(framedata.frameHeader.ArrivalT1, framedata.frameHeader.ArrivalT2,framedata.frameHeader.Ver)
if(ROINum eq 0)then begin
    deadtime = imgList[frame].deadtime
    PDSThresh45 = imgList[frame].PDSThresh45
    PDSThresh90 = imgList[frame].PDSThresh90
endif else begin
    deadtime = 0.0
    PDSThresh45 = 0.0
    PDSThresh90 = 0.0
endelse
write_line_spec1,pStateInfo, Request,(*pROIArray)[ROINum].imageHeader,ROINum,(*pStateInfo).FileHead.year,time,ProbeTime,$
    framedata.frameheader.missed,deadtime,(*pStateInfo).Settings.pixsize,(*pLink).format,imgFrmCt,PDSThresh45,PDSThresh90
end


else:begin
ProbeTime = 1000UL*CalcStrobeTime(framedata.frameHeader.ArrivalT1, framedata.frameHeader.ArrivalT2,framedata.frameHeader.Ver)
if(ROINum eq 0)then begin
    deadtime = imgList[frame].deadtime
    PDSThresh45 = imgList[frame].PDSThresh45
    PDSThresh90 = imgList[frame].PDSThresh90
endif else begin
    deadtime = 0.0
    PDSThresh45 = 0.0
    PDSThresh90 = 0.0
endelse
;Brad comments next line out to try and stop pngs c not ascii bug, but that causes stats and combined not to be written properly.
write_line,pStateInfo, Request,*(*pLink).pSelect,(*pROIArray)[ROINum].imageHeader,ROINum,(*pStateInfo).FileHead.year,time,ProbeTime,$
    framedata.frameheader.missed,deadtime,(*pStateInfo).Settings.pixsize,(*pLink).format,imgFrmCt,PDSThresh45,PDSThresh90
end
endcase
end

function AcceptanceCriteria,pROIArray,pStateInfo,len,wid,area,perim,roundness,focus,focusMin,focusMax,$;**********
    focusSTD,CutOff,Crystal,P1,corrected,reject,ROINum,pLink,pState

;valuecarl = (*pROIArray)[ROINum].ImageHeader.intensity_holeless_stats[0]
;print,valuecarl
; look in header from frame
headerType = tag_names((*pROIArray)[ROINum].ImageHeader,/structure_name)
if(headerType eq 'IMAGEHEADER30' or headerType eq 'IMAGEHEADER31')then begin

    len       = (*pROIArray)[ROINum].ImageHeader.len   * !CPI_MICRONS_PER_PIXEL
    wid       = (*pROIArray)[ROINum].ImageHeader.wid   * !CPI_MICRONS_PER_PIXEL
    area      = (*pROIArray)[ROINum].ImageHeader.area  * !CPI_MICRONS_PER_PIXEL * !CPI_MICRONS_PER_PIXEL
    perim     = (*pROIArray)[ROINum].ImageHeader.perim * !CPI_MICRONS_PER_PIXEL
    roundness = (*pROIArray)[ROINum].ImageHeader.roundness
    focus = (*pROIArray)[ROINum].ImageHeader.focus
    ;if(focus eq 255)then focus = -1
    focusMin = (*pROIArray)[ROINum].ImageHeader.focusMin
    focusMax = (*pROIArray)[ROINum].ImageHeader.focusMax
    focusSTD = (*pROIArray)[ROINum].ImageHeader.focusSTDDEV
    CutOff = (*pROIArray)[ROINum].ImageHeader.CutOff
    Crystal = (*pROIArray)[ROINum].ImageHeader.Crystal
    ; if(Crystal eq 0 and len gt 0)then Crystal = 1
    P1 = (*pROIArray)[ROINum].ImageHeader.P1
    ;the following code calculates the holearea for each particle as a percentage of size. CS
    holearea = (area - ((*pROIArray)[ROINum].ImageHeader.intensity_holeless_stats[0])*5.29)/area
    if (holearea eq 1.0) then holearea = 0
    holearea=holearea*100
    ;the following is used to make a focus value adjusted length: len2
    pos=(1.57547 -0.0614464 *focus + 0.000838895 *focus^2d -3.82540e-006 *focus^3d)
    ratio=1.1031377 + 1.2314287 *pos - 0.34444972 *pos^2d
    len2=len/ratio
    ;The following is how I set up the harmonics for acceptance criteria use.
    if ((*pROIArray)[ROINum].imageheader.harmonic_len gt 7) then begin
        h1 = (*(*pROIArray)[ROINum].imageheader.harmonics)[1]
        h2 = (*(*pROIArray)[ROINum].imageheader.harmonics)[2]
        h3 = (*(*pROIArray)[ROINum].imageheader.harmonics)[3]
        h4 = (*(*pROIArray)[ROINum].imageheader.harmonics)[4]
        h5 = (*(*pROIArray)[ROINum].imageheader.harmonics)[5]
        h6 = (*(*pROIArray)[ROINum].imageheader.harmonics)[6]
        HH1 = (*(*pROIArray)[ROINum].imageheader.harmonics)[(*pROIArray)[ROINum].imageheader.harmonic_len-1]
        HH2 = (*(*pROIArray)[ROINum].imageheader.harmonics)[(*pROIArray)[ROINum].imageheader.harmonic_len-2]
        HH3 = (*(*pROIArray)[ROINum].imageheader.harmonics)[(*pROIArray)[ROINum].imageheader.harmonic_len-3]
        HH4 = (*(*pROIArray)[ROINum].imageheader.harmonics)[(*pROIArray)[ROINum].imageheader.harmonic_len-4]
        HH5 = (*(*pROIArray)[ROINum].imageheader.harmonics)[(*pROIArray)[ROINum].imageheader.harmonic_len-5]
        HH6 = (*(*pROIArray)[ROINum].imageheader.harmonics)[(*pROIArray)[ROINum].imageheader.harmonic_len-6]
        middleharmonic=(*pROIArray)[ROINum].imageheader.harmonic_len/2-3
        mh1 = (*(*pROIArray)[ROINum].imageheader.harmonics)[middleharmonic]
        mh2 = (*(*pROIArray)[ROINum].imageheader.harmonics)[middleharmonic+1]
        mh3 = (*(*pROIArray)[ROINum].imageheader.harmonics)[middleharmonic+2]
        mh4 = (*(*pROIArray)[ROINum].imageheader.harmonics)[middleharmonic+3]
        mh5 = (*(*pROIArray)[ROINum].imageheader.harmonics)[middleharmonic+4]
        mh6 = (*(*pROIArray)[ROINum].imageheader.harmonics)[middleharmonic+5]
    endif else begin
        h1=0
        h2=0
        h3=0
        h4=0
        h5=0
        h6=0
        HH1=0
        HH2=0
        HH3=0
        HH4=0
        HH5=0
        HH6=0
        mh1=0
        mh2=0
        mh3=0
        mh4=0
        mh5=0
        mh6=0
    endelse

endif else begin

    len = (*pROIArray)[ROINum].imageHeader.len*(*pStateInfo).Settings.PixSize
    wid = (*pROIArray)[ROINum].imageHeader.wid*(*pStateInfo).Settings.PixSize

    ;  out of focus is in imageheader.flags (bits 0-7 of flags)
    focus = 100 - ((*pROIArray)[ROINum].imageHeader.Flags AND '00FF'X)  ; convert to in Focus

    ; cutoff is in imageheader.dark ( bits 8 - 12)
    cutoff = fix(100 * (ISHFT((*pROIArray)[ROINum].imageHeader.Dark,-8) AND '1F'X)/31.0)

    ; crystal is in imageheader.flags (bits 8 - 12)
    crystal = ISHFT((*pROIArray)[ROINum].imageHeader.Flags, -8) AND '001F'X

    ; manually corrected is in imageheader.flags (bit 14)
    corrected =((*pROIArray)[ROINum].imageheader.flags and '2000'X)/'2000'X

    ;manual reject is in imageheader.flags (bit 15)
    reject = ((*pROIArray)[ROINum].imageheader.flags and '4000'X)/'4000'X
endelse

; Determine if this ROI should be accepted?
if((*pLink).accept and (*pLink).criteria ne '') THEN begin     ; this flag means "Are we looking for accepted particles?"
    cmd = 'if('+(*pLink).criteria+')then acceptflag = !true else acceptFlag = !false'
    compile = execute(cmd)

    if(not compile)then begin
        r = dialog_message('Error in acceptance string, aborting',/info)
        return,-1
    endif
endif else acceptFlag = !true ;if((*pROIArray)[ROINum].imageHeader.len ne 0)then acceptFlag = !true else acceptFlag = !false
; note: if the obj files exist and a particle is not processed, then len = 0 and was rejected.  now all are accepted
return,acceptFlag

end

pro DoFirstPass,pLink,frameStart,start_time,IntEnd,spectraComplete,timeFlag,SumSecs,AvgIntEnd,$
    Stop_time,tComplete,IntEnd2,frameTime,TframeStart,pGroup,MaxTGroup

if((*pLink).spectra)then begin
    ;note mods force start time to be from the gui
    frameStart = start_time ;frameTime 
    ; end of first interval
    ;IntEnd = (*pLink).SumInt + floor(frameStart)  ;changed to 1 group only DEc7 2004 moqixu

    IntEnd = floor(stop_time)  ;changed to 1 group only

    ;print,'first interval end',IntEnd
    rem = 0.0;      float(stop_time-start_time) mod (*pLink).SumInt ;changed Dec 7; 2004
    if(rem eq 0)then spectraComplete = !true

    (*pGroup).startTime = frameStart
endif

if(timeFlag)then begin
    ;note mods force start time to be from the gui
    TframeStart =  start_time ;frameTime
    SumSecs = (*pLink).sample
    AvgIntEnd = SumSecs + floor(TframeStart)
    rem = float(stop_time-start_time) mod SumSecs
    if(rem eq 0)then begin
        tcomplete=!true
        MaxTGroup = fix(float(stop_time-start_time) / sumSecs)
    endif else MaxTGroup = (stop_time-start_time)/SumSecs
    ;print,maxTgroup
endif
IntEnd2 = floor(frameTime) + 1

end

pro getObjData,pStateInfo,framedata,pROIArray,imgFrmCt,objData

    objData = get_obj_header((*pStateInfo).ObjLUN,(*(*pStateInfo).pObjList)[imgFrmCt].fPos)
    objTime = float(objData.frameHeader.time) + calcStrobeTime(objData.frameHeader.arrivalT1,objData.frameHeader.arrivalT2,framedata.frameHeader.Ver)/1000.0D
    roiTime = float(framedata.frameheader.time) + calcStrobeTime(framedata.frameheader.arrivalT1,framedata.frameheader.arrivalT2,framedata.frameHeader.Ver)/1000.0D

    if(objTime ne roiTime)then begin
        indexOBJ = where(roiTime eq (*(*pStateInfo).pObjList).time, cntOBJ)
        if(cntOBJ gt 0)then begin
            ; read a frame of info from the obj file
            objData = get_obj_header((*pStateInfo).ObjLUN,(*(*pStateInfo).pObjList)[indexOBJ[0]].fPos)
            ; store obj info
            pROIArray = objData.pFrame
        endif else begin
            r = dialog_message('Error: obj frame not found')
        endelse
    endif else pROIArray = objData.pFrame
end





FUNCTION Process_timeSeries, pStateInfo, volume = volume
; Purpose To accumulate the sizes of particles into CPI bins
; this routines assumes that an obj header exists


Forward_function printROIs, find_first_link

;make sure an obj file is exist, then people can continue process time series
my_message=['No obj file is found,please use EXTRACTION TOOLS to make an obj file first,then you can continue.']
if (*pstateInfo).objlun eq -1 then begin
    abcdefgh=dialog_message(my_message)
    return,0
endif
;**********************************************************************************************************
widget_control,/hourglass

; get linked list info
pLink = (*(*pStateInfo).pTimeInfo).pCurrent_link

if((*(*pStateInfo).pTimeInfo).cur_per ne 1)then    pLink = find_first_link(pLink)
num_time_periods = 1;(*(*pStateInfo).pTimeInfo).periods

;imgList = (*((*pStateInfo).pFileScan))[*((*pStateInfo).pImgPosIndx)]
; Note: badframes have a time stamp that is wrong. It was not monotonically increasing
imgListIndx = where((*(*pStateInfo).pFileScan).imgtype ge 0 and not (*(*pStateInfo).pFileScan).badframe)
imgList = (*(*pStateInfo).pFileScan)[imgListIndx]
HKListIndx = where((*(*pStateInfo).pFileScan).imgtype eq -1)
HKList = (*(*pStateInfo).pFileScan)[HKListIndx]


;open an ascii file if requested
sendASCII = !false
if((*pLink).sendASCII gt 0  and (*pLink).sendASCII lt 4 and (*pLink).output)then begin
    if((*pLink).accept) THEN criteria = (*pLink).criteria else criteria = 'none'
    request = open_ascii(pStateInfo,(*pLink).format,*((*pLink).pSelect),criteria)
    sendASCII = !true
endif

if((*pLink).sendASCII eq 4 and (*pLink).output)then begin
    if((*pLink).accept) THEN criteria = (*pLink).criteria else criteria = 'none'
    request = open_ascii_spec1(pStateInfo,criteria)
    sendASCII = !true
endif


(*pStateInfo).PrintROI.pageNo = 0


for k = 0,num_time_periods-1 do begin

    firstPass = !true
    newInt = !false
    spectra=!false

    if((*pLink).spectra)then begin ; flag from GUI
        ; initialize for histogram
        groupCnt = 1
        partCnt = 0
        intMax = 40   ; initial size of array

        (*pStateInfo).spectra.pGroup = ptr_new({groupLink})
        pGroup = (*pStateInfo).spectra.pGroup
        ;print,'Group #',groupCnt, ' pointer#',pGroup
        (*pGroup).pData = ptr_new(fltarr(intMax))
        (*pgroup).pAdj  = ptr_new(fltarr(intMax)) ;  added august 24, 2004.
        (*pGroup).pDataA = ptr_new(fltarr(intMax))
        (*pGroup).pDataM = ptr_new(fltarr(intMax))
        (*pGroup).pDataH = ptr_new(fltarr(intMax))
        spectra=!true
        SumInt = (*pLink).SumInt
        roiFrmCnt = 0L
        TotFrmCnt = 0L
        totImgPart = 0L
        acceptPart = 0L
        nonRejPart = 0L
        spectTotSav2 = 0L
        earlier_frdeadtime=0.0D ;added sept 24.0
        fcs_max=0.0;   added august 24, 2004
        meanlenarr_sav=0.0; added august 24, 2004.
        meanadjarr_sav=0.0
        meanAcorarr_sav=0.0
        meanMcorarr_sav=0.0
        meanHcorarr_sav=0.0;    Dec 7 2004 ---moqixu
        spec_accumpartcnt_mo=0.0
        spec_particle_cnt_msav=0.0

        wmeanLenarr=0.0; added october 7, 2004
        wmeanAcorarr=0.0; added october 7, 2004
        wmeanMcorarr=0.0; added october 7, 2004
        wmeanHcorarr=0.0; added Dec 7, 2004
        wmeanadjarr=0.0; added october 7, 2004

        dmeanLenarr=0.0; added october 7, 2004
        dmeanAcorarr=0.0; added october 7, 2004
        dmeanMcorarr=0.0; added october 7, 2004
        dmeanadjarr=0.0; added october 7, 2004

    endif

    if (*plink).condspectra then begin
        Zfrmcont=0;    added oct 25 for condictional spectra.
        Dvect =fltarr(1);   its size will increase as particles is added more and more
        Wvect =fltarr(1)
        Nvect =fltarr(1);   its size will increase as particles is added more and more
        cond_wmeanlenarr=0.0
        cond_wmeanadjarr=0.0
        (*plink).addfssp2dc=!false
    endif

    if (*plink).addfssp2dc then begin
        load_fssp_2dc_files,pstateinfo     ; store the data in the pstateinfo one time.
        ;(*pLink).HspectraType = 'adj'      ;make adj option true.  (*pLink).HspectraType = 'adj'
        (*plink).condspectra=!false
        ;bail out if user cancel doing addfssp2dc
        if (*pstateinfo).fsspdata.filename eq ' ' then (*plink).addfssp2dc=!false
    end

    timeFlag = !false
    if( (*pLink).time)then begin
        ; count requested plots
        numPlots = 0
        tOperation = bytarr(18)

        for i = 0,17 do begin
            if((*pLink).(i))then begin
                tOperation[i] = !true;(*pLink).(i)
                numPlots = numPlots + 1   ; number of plot. Maximum is 17, 17 curves of time series.
            endif
        endfor

        if(numPlots gt 0)then begin
            ; ArrayArea in cm^2 ( with tilt factor from instument ) ( 1.e-8 for microns^2 -> cm^2 )
            ArrayArea = DOUBLE((*pStateInfo).FileHead.DX)*(*pStateInfo).FileHead.DY*((*pStateInfo).Settings.PixSize)^2*(1.e-8)*(sqrt(2.0)/2.0)

            ; Airspeed is in m/sec, (1.e2 for m -> cm and 1.e-3 for cc -> Liter)
            SampleVolume = ArrayArea * ((*pLink).TAS * 1.0e-1)  ; Liters/sec
            ;it only stop here one time.  and tas is 10.00m/s of user defined value in here.

            tGroupCnt = 200
            timePlot = dblarr(numPlots,tGroupCnt) ;+ !values.f_nan
            ;assigned those radar values to be -99.0
            ;****************************************************************
            mooo_plots=0
            for i = 0,17 do begin
                if((*pLink).(i))then begin
                    tOperation[i] = !true;(*pLink).(i)
                    mooo_Plots = mooo_Plots + 1
                    if(((*pLink).(i)) eq (*plink).Tmean) and (*plink).Tmean then timeplot(mooo_plots-1,*)=-99.0
                    if(((*pLink).(i)) eq (*plink).Tpaul) and (*plink).Tpaul then timeplot(mooo_plots-1,*)=-99.0
                    if(((*pLink).(i)) eq (*plink).tRate3) and (*plink).tRate3 then timeplot(mooo_plots-1,*)=-99.0
                endif
            endfor     ; thsi has to be in the finishgroup also.
            ;******************************************************************
            tGroup = 0
            plotNum = 0
            timeFlag = (*pLink).time

            ; init accumulators
            totSav = 0L
            totSav2 = 0L
            totSav3 = 0L
            totFrm = 0L
            missed = 0L
            AccumConc = 0L
            AccumCubicSize = 0.0D
            AccumMass = 0.0D
            accumAcor_area=0.0D; added by mo July 27, 2004
            Accumsphmass=0.0D;   added by mo August18/04
            Accumicemass=0.0D

            ParticleCnt = 0L
            deadtime = 0.0D
            earlier_frdeadtime=0.0D;  added by mo 8/8/04 asumme first interval, frdeadtime=0.0
            TMean = 0.0D
            TmeanCnt = 0L
            TMax = 0.0D
            AccMeanLen = 0.0D

            maxLength = 0.0D
            max_to_Save = 0.0D
            allParticles = 0UL
            ParticleCntPerInterval = 0L
            specialCase = !false
            newROI = !true

            AccMaxLen = 0.0D
            cubicSize = 0.0D
            mass = 0.0D
            Acor_area=0.0;  added by mo July 27 2004.
            Acor_area_sav=0.0;  added by mo August 4, 2004.
            accumpartcnt_mo=0.0
            particle_cnt_msav=0.0
            sphmass_sav=0.0D;  added August 18/04.
            icemass_sav=0.0D

            ; added this for wysiwyg
            Waccumpartcnt_mo=0.0
            WaccumAcor_area=0.0D
            WAccumsphmass=0.0D
            WAccumicemass=0.0D
            WAcor_area_sav=0.0;  added by mo oct11, 2004.
            Wparticle_cnt_msav=0.0
            Wsphmass_sav=0.0D;  added oct11/04.
            Wicemass_sav=0.0D

            AccumradarvolD6I=0.0
            radarvolD6_savI =0.0
            WAccumradarvolD6I=0.0
            WradarvolD6_savI=0.0 ; added oct 22 for dBz
            AccumradarvolD6L=0.0
            radarvolD6_savL =0.0
            WAccumradarvolD6L=0.0
            WradarvolD6_savL=0.0 ; added oct 22 for dBz

            fcs_max=0.0
            ImgMean = 0L
        endif else (*pLink).time = !false

    endif

    output = !false

    ; get the first frame based on start time from GUI
    start_time = convertToseconds((*pLink).start,(*pStateInfo).FileHead.year)
    stop_time = convertToseconds((*pLink).stop,(*pStateInfo).FileHead.year)
    ;print,'Requested start time=',start_time
    ;print,'Requested stop time=',stop_time
    ;stop
    if(stop_time le start_time)then begin
        r = dialog_message('Error: Stop time before Start time ...time period skipped')
        (*pLink).spectra = !false
        timeFlag = !false
        (*pLink).sendASCII = !false
        spectra = !false
        timeFlag = !false
        sendASCII = !false
        StartFrm = -1
        StopFrm = -1
        (*pLink).spectra = !false
        (*pLink).time = !false
        ;stop
        goto,skip
    endif
    ;stop
    StartFrm = GetFrameByTime(pStateInfo, (*pLink).start,/absolute, type='start')
    if(StartFrm eq -1)then begin
        r = dialog_message('Error: start frame not found...time period skipped')
        (*pLink).spectra = !false
        (*pLink).timeFlag = !false
        (*pLink).sendASCII = !false
        spectra = !false
        timeFlag = !false
        sendASCII = !false
        StartFrm = -1
        StopFrm = -1
        (*pLink).spectra = !false
        (*pLink).time = !false
        goto,skip
    endif
    ; stop
    ; check to see if end time is beyond this file
    add_files = 0
    guiTime = convertToSeconds((*pLink).stop,(*pStateInfo).filehead.year)
    ;stop
    dumIndx = where((*(*pStateInfo).pFileScan).imgtype eq 1 and not (*(*pStateInfo).pFileScan).badframe ,ImgCnt)
    lastTime = (*(*pStateInfo).pFileScan)[dumIndx[ImgCnt-1]].HTime
    if(guiTime gt lastTime)then begin
        ; stop
        ; construct file name
        ;filename = strtrim(time.month,2)+strtrim(time.day,2)+strtrim(time.hr,2)+strtrim(time.minute,2)
        files = findFile((*pStateInfo).path+'*.roi',count=count)
        ; put in order
        files = files[sort(files)]
        ; convert filenames into time ( seconds of year )
        filetimesSTR = replicate({times},count)
        for i=0,count-1 do begin
            ; parse names
            filetimesSTR[i].month =  strmid(files[i],rstrpos(files[i],'\')+1  ,2)
            filetimesSTR[i].day =    strmid(files[i],rstrpos(files[i],'\')+3,2)
            filetimesSTR[i].hour =   strmid(files[i],rstrpos(files[i],'\')+5,2)
            filetimesSTR[i].minute = strmid(files[i],rstrpos(files[i],'\')+7,2)
        endfor
        ;create numerical list of times
        filetimes = convertToseconds(filetimesSTR,(*pStateInfo).filehead.year)
        tIndex = where(filetimes lt guiTime ,cnt)
        if(cnt gt 0)then begin
            currentFile = where(strlowcase(files) eq strlowcase((*pStateInfo).inFileName))
            filesToProcess = files[currentFile[0]:tIndex[cnt-1]]
            add_files=n_elements(filesToProcess)-1
            StopFrm= n_elements(imglist) - 1 ; use last frame in image list
            ; stop
        endif else begin
            print,'Error in file name retrieval'
            stopfrm = startfrm
        endelse

    endif else begin
        ; get last frame based on time
        StopFrm = GetFrameByTime(pStateInfo, (*pLink).stop,/absolute, type='stop')
        ; stop
        if(StopFrm eq -1)then StopFrm= n_elements(imglist) - 1 ; use last frame in image list
        if(StopFrm le StartFrm)then begin
            r = dialog_message('Error: Stop frame less than or equal Start frame ...time period skipped')
            spectra = !false
            timeFlag = !false
            sendASCII = !false
            StartFrm = -1
            StopFrm = -1
            (*pLink).spectra = !false
            (*pLink).time = !false
            return,1
        endif
    endelse
    ; stop
    ; open file for per HZ output
    if (sendASCII and (*pLink).Format eq 'hertz') then begin
        hkFileName = strmid((*pStateInfo).InFileName, 0,rstrpos((*pStateInfo).InFileName,'.'))+'_HzLog.txt'
        openw,HKLUN,hkFileName,/get_lun
        (*pStateInfo).HKLUN = HKLUN
        hdr = '    Time ver    sync     length   type  fwdtubeTemp  upOptBlkT  lowOptBlkT centOptBlkT  aftOptBlkT    noseTemp   PylonTemp  draintubeT  APDAmpTemp outsideairT    DSPcardT  HKCardTemp  APCardTemp   inAirTemp  ' + $
            'CCDCameraT ImLaserTemp PDS45LaserT PDS90LaserT PDS45LaserP    PDS45Ldc PDS90LaserP    PDS90Ldc ImgLasCurnt    ImgLasPW   28Vsupply 5voltsupply   12vsupply  -12vsupply probemode heaterstat detPrt deadtime '+$
            'P45PSET  P45TSet  P90PSet  P90Tset  ILasSET ILASPWset minTTime checksum'
        printf,HKLUN,hdr

        ;Open a file for AirCraft data, just in case we need it
        PlaneLogFileName = strmid((*pStateInfo).InFileName, 0,rstrpos((*pStateInfo).InFileName,'.'))+'_Airplanelog.txt'
        openw,PlaneLUN,PlaneLogFileName,/get_lun

        ;Open a file for SPP100 data, just in case we need it
        SPP100LogFileName = strmid((*pStateInfo).InFileName, 0,rstrpos((*pStateInfo).InFileName,'.'))+'_SPP100log.txt'
        openw,SPP100LUN,SPP100LogFileName,/get_lun

        ;Open a file for Watchdog SBC data, just in case we need it
        SBCLogFileName = strmid((*pStateInfo).InFileName, 0,rstrpos((*pStateInfo).InFileName,'.'))+'_WatchDogSBClog.txt'
        openw,SBCLUN,SBCLogFileName,/get_lun
    endif


    ; loop through the frames
    imgFrmCt = 0L
    tComplete = !false
    spectraComplete = !false
    spectraAccept = !false
    TlastFrameSec = 0UL
    SlastFrameSec = 0UL
    SlastFrameSec2 = 0UL
    objheader_start = 0UL

    print,'Processing file ',(*pStateInfo).infilename, ' additional files to process',add_files

    current_file = (*pStateInfo).infilename
    first_file = (*pStateInfo).infilename
    ;stop
    if((*pStateInfo).productNum eq 3)then begin
        netpath = 'H:\SPECFiles\cpiview\Nshell2.dll'
        ;r = call_external(netpath,'opennet')
    endif


    for fileNum = 0, add_files do begin
        ; first pass uses the file currently loaded
        if(fileNum gt 0)then begin
            print,'Processing file #',filenum, ' named ',filesToProcess[fileNum]
            ;open next file if needed
            LoadFile, pStateInfo , filename = filesToProcess[fileNum]
            current_file = filesToProcess[fileNum]
            ; get last frame based on time
            StopFrm = GetFrameByTime(pStateInfo, (*pLink).stop,/absolute, type='stop')
            StartFrm = 0UL
            if(StopFrm eq -1)then StopFrm= n_elements(imglist) - 1 ; use last frame in image list
            imgListIndx = where((*(*pStateInfo).pFileScan).imgtype ge 0)
            imgList = (*(*pStateInfo).pFileScan)[imgListIndx]
            imgFrmCt = 0L
        endif
        ; following line added by mo sept 17, 2004.
        frametime_mooo=imglist.htime+imglist.msec/1000.0; ;all frame times; more than those in *combined.csv
        frametime_moooR=floor(frametime_mooo)

        for frame = StartFrm, StopFrm do begin

            ; if per second HK info is requested
            if(sendASCII and (*pLink).Format eq 'hertz')then begin
                ; need to file in variables, and determine when to call this ( FPOS!!!)
                IF frame LT StopFrm THEN $
                    hkblocks = where(HKList.htime ge imgList[frame].htime and HKList.htime lt imgList[frame+1].htime, HKcnt) $
                    ELSE $
                    hkblocks = where(HKList.htime ge imgList[frame].htime, HKcnt)

                if(HKCnt gt 0)then begin
                    for k = 0, HKCnt-1 do begin
                        point_lun,(*pStateInfo).InFileLun, HKList[hkblocks[k]].fPos+2
                        dummy = read_Htime((*pStateInfo).InFileLun,HKList[hkblocks[k]].fPos,(*pStateInfo).FileHead.Ver, (*pstateINFo).roi_frameheader_version,HKlun, PlaneLUN, SBCLUN, SPP100LUN, !true,DTError,0)
                        ;dummy returns: HTIME=9486887,FPOS=5859,HOUSESIZE=439,DEADTIME= 45, PDSTHRESH45=350,PDSTHRESH90=350
                    endfor
                endif
            endif

            ; skip bad frames
            if(not imgList[frame].badframe)then begin
                ; track frames for spectra
                ; must read the image data if any roi display or output is required
                frameData = read_frame((*pStateInfo).InFileLun,(*pStateInfo).FileHead.Ver,imgList[frame].fpos,date=(*pStateInfo).date, TSBlanked = imglist[frame].TSBlanked)

                imgFrame = (not((frameData.Frameheader.ImgType and 2)/2) and frameData.Frameheader.ROIsCount ge 1 )

                ; output frame info to ASCII file if requested
                if(sendASCII and (*pLink).Format eq'frame')then $
                    writeFrameHeader,frameData.Frameheader,pStateInfo

                if(size(frameData,/type) eq 8)then begin ; skip if this is not a valid frame

                    ;if(frame eq startFrm)then print,'Actual Start Frame time =',framedata.frameheader.time
                    ;if(frame eq stopFrm)then print,'Actual Stop Frame time =',framedata.frameheader.time

                    frameTime = frameData.FrameHeader.time

                    time = convertFromSeconds(frameTime , (*pStateInfo).FileHead.year) ; change to 4/19/19:20:00.00 format.
                    time.msec  = ROUND(CalcStrobeTime(frameData.frameHeader.ArrivalT1, frameData.frameHeader.ArrivalT2,framedata.frameHeader.Ver))

                    ; time of frame in seconds
                    frameTime = frameTime + time.msec/1000.0D

                    ; ROIArray is an array of pointers for each particle in the frame
                    pROIArray = FrameData.pFrame

                    ; if an Object file exists, then use it NOTE pROIArray is reassigned here to the OBJ data
                    if (imgframe and ptr_valid((*pStateInfo).pObjList)) then $
                        getObjData,pStateInfo,framedata,pROIArray,imgFrmCt,objData


                    if(imgFrame)then imgFrmCt = imgFrmCt + 1

                    ; How many ROIs?
                    if(ptr_valid(pROIArray) and imgFrame)then n_imgs = n_elements( *pROIArray ) else n_imgs = 0
                    if(imgframe)then if( n_imgs gt n_elements(*pROIArray))then print,'Error, obj data out of sync with frame'

                    if(FirstPass)then begin
                        DoFirstPass,pLink,frameStart,start_time,IntEnd,spectraComplete,timeFlag,SumSecs,AvgIntEnd,$
                            Stop_time,tComplete,IntEnd2,frameTime,TframeStart,pGroup,MaxTGroup
                        firstPass = !false
                    endif

                    if(frame eq startFrm and (*pLink).time and fileNum eq 0)then begin
                        (*pLink).timeStr =strtrim(fix((*pLink).start.hour),2) + ':' + strtrim(fix((*pLink).start.minute),2) + ':'+  strtrim(fix((*pLink).start.sec),2); + ':'+  strtrim(fix(time.msec),2)
                        if(ceil(frameTime) - avgIntEnd gt SumSecs)then tgroup = (ceil(frameTime) - avgIntEnd)/SumSecs
                        deadtime0=0.0
                    endif

                    ; create array for tracking confidence
                    if(n_imgs gt 0) THEN confidence = bytarr(n_imgs) ;(*pLink).accept and

                    if(n_imgs gt 0)then begin
                        meanLenArr = fltarr(n_imgs)
                        mnSizes = fltarr(n_imgs)
                        mxSizes = fltarr(n_imgs)
                        ; create accepted array for min file output
                        accepted = bytarr(n_imgs)
                    endif
                    acceptedParticles = 0L
                    nonRejectCnt = 0L
                    AllReject = !true

                    ; loop through all the particles in the frame and accumulate into the histogram array by size
                    FOR ROINum=0, n_imgs-1 DO begin

                        acceptFlag = AcceptanceCriteria(pROIArray,pStateInfo,len,wid,area,perim,roundness,focus,focusMin,$
                            focusMax,focusSTD,CutOff,Crystal,P1,corrected,reject,ROINum,plink)

                        ;help,*(*(*pStateInfo).ptimeInfo).pcurrent_link,/struct
                        if  (*(*(*pStateInfo).ptimeInfo).pcurrent_link).habit ge 1 and acceptFlag then begin
                            ; Update new habit number into our OBJ data structure
                            (*pROIArray)[ROINum].imageHeader.crystal = (*(*(*pStateInfo).ptimeInfo).pcurrent_link).habit
                            ; write new habit number to obj file
                            update_obj_header, (*pStateInfo).ObjLUN,(*(objdata).pimhdfpos)[ROINum], "crystal", (*(*(*pStateInfo).ptimeInfo).pcurrent_link).habit

                        endif


                        if(acceptFlag eq -1)then return,0 ; bail on error

                        if((*pROIArray)[ROINum].imageHeader.len gt 0 and AllReject)then AllReject = !false

                        if((*pROIArray)[ROINum].imageHeader.len ne 0)then nonRejectCnt = nonRejectCnt + 1

                        ; Need to handle skipping of seconds here Not sure if this is not already being done!
                        if(acceptFlag)then begin

                            ; mark roi image as accepted
                            accepted[roiNum] = !true

                            if(n_imgs gt 0)then confidence[ROINum] = 10  ;10 means accept,0 means reject(*pLink).accept and
                            acceptedParticles = acceptedParticles + 1

                            ; check each processing option for this time period
                            ;if((*pLink).spectra)then begin
                            if((*plink).Hmissed or (*pLink).Hwysiwyg) then begin
                                makeSpectValues, pROIArray, pStateInfo, pLink, ROINum, frameData.frameheader.ver,$
                                    spectraAccept, meanLenArr,meanAdjarr,fcs_max,meanlenarr_sav,meanadjarr_sav,$
                                    spec_particle_cnt_msav,meanAcorarr,meanAcorarr_sav, meanMcorarr,meanMcorarr_sav,$
                                    wmeanLenArr,wmeanadjarr,wmeanAcorarr,wmeanMcorarr,$;;for wysisyg_r all particles. Octoner7, 2004
                                    dmeanLenArr,dmeanadjarr,dmeanAcorarr,dmeanMcorarr,$;; for wysisyg_com particles. Octoner7, 2004
                                    meanHcorArr,meanHcorarr_sav,wmeanHcorArr;            ; for crytsal type info I or Liquid.

                            endif

                            if ((*plink).condspectra) then begin
                                make_cond_SpectValues, pROIArray, pStateInfo, pLink, ROINum, ver,cond_wmeanLenArr,cond_wmeanadjarr
                            endif;    added on oct 25 2004.


                            if((*pLink).time) then begin
                                ;print,roinum,max_to_save
                                doTimeSums,    pLink,pROIArray, pStateInfo, frameTime, avgIntEnd, crystal, $
                                    frameData.FrameHeader.ver, roiNum, max_to_Save, newROI, specialCase, $
                                    ParticleCntPerInterval, MaxLength, AccmeanLen, AccmaxLen, cubicSize, mass, $
                                    ParticleCnt,Acor_area,Acor_area_sav,fcs_max,particle_cnt_msav,$
                                    sphmass_sav,icemass_sav,$;before sept, 2004
                                    WAcor_area_sav,Wparticle_cnt_msav,Wsphmass_sav,Wicemass_sav,$; added fow wysiwyg_r on oct11 2004
                                    radarvolD6_savI,wradarvolD6_savI,radarvolD6_savL,wradarvolD6_savL; added this for radar dbz time serices.

                            endif


                            ; output to an ascii file if requested and acceptance criteria applied
                            if(sendASCII and imgFrame and (*pLink).output)then $
                                doLogFile, plink,imglist,frame, framedata, pROIArray,request,pStateInfo,imgFrmCt,roiNum,time

                        endif ; end of acceptFlag block

                    endFOR ; end of roi loop, This finish for 1 frame. roinum=0, 1, 2,,3, 4,if there are many rois in one frame.

                    ;**********************oct 23 2004 add this block for condition spectro calculations.
                    ;see pro sum_condtional_spectra_values
                    ;************************************************************************************

                    framesec = ulong(frametime)

                    ; accumulate spectral data
                    ;if((*pLink).spectra)then begin
                    if ((*plink).Hmissed or (*pLink).Hwysiwyg) then begin
                        if(frameTime lt IntEnd)then begin

                            SumSpectraValues,acceptedParticles, meanLenArr, n_imgs, FrameData.frameheader.Missed, nonRejectCnt, acceptedParticles, $
                                imgList[frame].Deadtime, partCnt, intMax, pGroup, roiFrmCnt, TotFrmCnt, $
                                SlastFrameSec, frameSec, totImgPart,acceptPart,nonRejPart,spectTotSav2,meanAdjarr,fcs_max,meanlenarr_sav,meanadjarr_sav,$
                                spec_accumpartcnt_mo,spec_particle_cnt_msav,meanAcorarr,meanAcorarr_sav, meanMcorarr,meanMcorarr_sav, $
                                wmeanLenArr,wmeanadjarr,wmeanAcorarr,wmeanMcorarr,$;;for wysisyg_r all particles. Octoner7, 2004
                                dmeanLenArr,dmeanadjarr,dmeanAcorarr,dmeanMcorarr,$;; for wysisyg_com particles. Octoner7, 2004
                                meanHcorArr,meanHcorarr_sav,wmeanHcorArr;            ; for crytsal type info I or Liquid.
                        endif else begin

                            ; get the correct deadtime for the first time interval

                            Tspec=(*pLink).SumInt 
                            if frametime-Tspec gt start_time and frametime-(1.0+Tspec) lt start_time then begin
                                index_mmm=where(frametime_mooo ge start_time-1.0+Tspec and frametime_mooo lt start_time+Tspec,cntmo)
                                if cntmo gt 0 then begin
                                    imglist_frame_deadtime=imglist[index_mmm(0)].deadtime
                                    earlier_frdeadtime=imglist_frame_deadTime
                                endif else imglist_frame_deadtime=imglist[frame].deadtime
                            endif; end of if frametime-Tspec gt start_time and frametime-(1.0+Tspec) lt start_time then begin
                            timeA=floor(frametime-Tspec-1.0)
                            timeB=ceil(frametime-2.0);  ; note that -1.0 is 1sec offset, another -1 is frametime has passed the second
                            get_deadtime_btwAB,timeA,timeB,frametime_mooo,frametime_moooR,imglist,deadtime_new
                            (*pgroup).deadtime=deadtime_new

                            if (*plink).addfssp2dc then begin
                                ;getfssp2dcdata and assign them into the pgroup pointer.
                                getfssp2dcdata,intEND,(*plink).sumint,Pstateinfo,fsspbinhs,twodcbinhs,twodcAbinhs,twodcMbinhs
                                nnn=n_elements(fsspbinhs)
                                if nnn eq 0 then return,1
                                (*pgroup).pfssp=ptr_new(fltarr(nnn))
                                *(*pgroup).pfssp=fsspbinhs
                                nnn=n_elements(twodcbinhs)
                                (*pgroup).ptwodc=ptr_new(fltarr(nnn))
                                *(*pgroup).ptwodc=twodcbinhs
                                (*pgroup).ptwodcA=ptr_new(fltarr(nnn))
                                *(*pgroup).ptwodcA=twodcAbinhs
                                (*pgroup).ptwodcM=ptr_new(fltarr(nnn))
                                *(*pgroup).ptwodcM=twodcMbinhs
                            end

                            ; stop
                            ; finish current group
                            finishSpectra,spectraAccept, roiFrmCnt, totImgPart, nonRejPart, acceptPart, TotFrmCnt, partCnt, spectTotSav2,$
                                spec_accumpartcnt_mo, pGroup, groupCnt
                            ;frameI_cont,Dcormatrix,ADj_matrix; added this part for conditional spectra




                            ; determine if there are time gaps to fill
                            if((ceil(frametime)-intEnd) gt (*pLink).SumInt)then begin
                                ; skipped intervals
                                ;determine how many intervals were skipped, create empty groups with the correct times
                                PadFrmCnt = (ceil(frametime)-intEnd)/(*pLink).SumInt
                                PadSpectralGroups,PadFrmCnt,pGroup,groupCnt,(*pLink).SumInt
                                intEnd = intEnd + PadFrmCnt * (*pLink).SumInt
                            endif
                            if frametime gt start_time+1.0+Tspec then imglist_frame_deadtime=imglist[frame].deadtime; ;added sept4, 2004

                            ;InitSpectraGroup,frameTime, TotFrmCnt, n_imgs, meanLenArr, imgList[frame].deadtime, nonRejectCnt, $
                            InitSpectraGroup,frameTime, TotFrmCnt, n_imgs, meanLenArr, imgList_frame_deadtime, nonRejectCnt, $
                                frameData.frameheader.missed, pLink, acceptedParticles, pGroup, intMax, roiFrmCnt, totImgPart, $
                                acceptPart, spectraAccept, SlastFrameSec,spec_accumpartcnt_mo,partCnt, IntEnd ,spectTotSav2,nonRejPart,$
                                meanAdjarr,fcs_max,meanlenarr_sav,meanadjarr_sav,earlier_frdeadtime,spec_particle_cnt_msav,$
                                meanAcorarr,meanAcorarr_sav, meanMcorarr,meanMcorarr_sav,$
                                wmeanLenArr,wmeanadjarr,wmeanAcorarr,wmeanMcorarr,$;;for wysisyg_r all particles. Octoner7, 2004
                                dmeanLenArr,dmeanadjarr,dmeanAcorarr,dmeanMcorarr,$;; for wysisyg_com particles. Octoner7, 2004
                                meanHcorArr,meanHcorarr_sav,wmeanHcorArr;            ; for crytsal type info I or Liquid.
                        endelse
                    endif ; end of if (*plink).spectra Spectra processing

                    if ((*plink).condspectra) then begin  ;added this part on oct 25 , 2004
                        if(frameTime lt IntEnd)then begin
                            sum_conditional_Spectra_values,n_imgs,cond_wMeanLenarr,cond_wmeanAdjarr,Pgroup,Zfrmcont,Dvect,Wvect,Nvect
                        endif else begin
                            finish_cond_Spectra,pGroup, groupCnt 
                            Init_cond_SpectraGroup,frameTime, n_imgs, pLink, pGroup, SlastFrameSec,$
                                IntEnd, cond_wmeanLenarr,cond_wmeanAdjarr,Zfrmcont,Dvect,Wvect,Nvect

                        endelse
                    endif;    added on oct 25 2004.

                    ; accumulate time series data
                    if( (*pLink).time)then begin
                        if(frameTime lt AvgIntEnd)then begin
                            SumTimeValues, n_imgs, acceptedParticles, AllReject,nonRejectCnt, Framedata.frameheader.Missed, frameSec, imglist[frame], imgMean,$
                                frameData.frameHeader.ImgMean,crystal, totSav,totSav2,totSav3,totFrm,allParticles,missed,AccumConc,ParticleCnt,$
                                AccumCubicSize, cubicSize,AccumMass, mass, TlastFrameSec, deadtime, tMean, AccMeanLen,$
                                TmeanCnt,Tmax,AccMaxLen,Acor_area,Acor_area_sav, AccumAcor_area,fcs_max,accumpartcnt_mo,particle_cnt_msav,$
                                Accumsphmass,sphmass_sav,Accumicemass,icemass_sav,$;   this line added August 18/04
                                WAcor_area_sav,Wparticle_cnt_msav,Wsphmass_sav,Wicemass_sav,$; added fow wysiwyg_r on oct11 2004
                                WAccumsphmass,WAccumicemass,Waccumpartcnt_mo,WAccumAcor_area,$;added fow wysiwyg_r on oct11 2004
                                AccumradarvolD6I,radarvolD6_savI,WaccumradarvolD6I,WradarvolD6_savI,$; added oct 21 2004.
                                AccumradarvolD6L,radarvolD6_savL,WaccumradarvolD6L,WradarvolD6_savL; added oct 21 2004.

                            ;print,allparticles,accumconc, frame, avgintENd,frameTime, n_imgs;  these are not the same.allparticles is always smaller than accumconc.
                            ;stop
                        endif else begin

                            ; get the correct deadtime for the first time interval  note that there is 1second different
                            ; in the do_aloneTime and combined.csv time offset.   use (1.0+sumsecs) instead of 2.0*sumsecs
                            if frametime-sumsecs gt start_time and frametime-(1.0+sumsecs) lt start_time then begin
                                index_mmm=where(frametime_mooo ge start_time-1.0+Sumsecs and frametime_mooo lt start_time+sumsecs,cntmo)
                                if cntmo gt 0 then begin
                                    imglist_frame_deadtime=imglist[index_mmm(0)].deadtime
                                    earlier_frdeadtime=imglist_frame_deadTime
                                endif else imglist_frame_deadtime=imglist[frame].deadtime
                            endif;endof if frametime-sumsecs gt start_time and frametime-(1.0+sumsecs) lt start_time then begin

                            ; use subroutint to get the deadtime_new

                            timeA=floor(frametime-sumsecs-1.0)
                            timeB=ceil(frametime-2.0);  ; note that -1.0 is 1sec offset, another -1 is frametime has passed the second
                            get_deadtime_btwAB,timeA,timeB,frametime_mooo,frametime_moooR,imglist,deadtime_new
                            ; print,'deadtime deadtime_new'
                            ; print, deadtime, '   ', deadtime_new
                            ; for sumsecs=1.0; above two method give same results.
                            ; but for sumsecs=2.0; deadtime_new is correct, deadtime is wrong.
                            deadtime=deadtime_new

                            ; interval complete find start a new interval
                            FinishTimeGroup,frameTime, AvgIntEnd, SumSecs, numPlots, missed, SampleVolume, AccumConc, $
                                acceptedParticles, pLink, deadtime, totFrm, tMeanCnt, Tmax, tgroup, AccumCubicSize, AccumMass,AccumAcor_area, $
                                accumpartcnt_mo, Tmean,totsav, totsav2, totsav3, ImgMean, accumsphmass,accumicemass, indexStep, timePlot, $
                                tGroupCnt, allParticles, tstep, $
                                ParticleCntPerInterval, specialCase, max_to_save,MaxLength ,nonRejectCnt,$
                                WAccumsphmass,WAccumicemass,Waccumpartcnt_mo,WAccumAcor_area,$;added fow wysiwyg_r on oct11 2004
                                AccumradarvolD6I,WAccumradarvolD6I,AccumradarvolD6L,WAccumradarvolD6L; added oct 22 2004.
                            ;print,'finished time group #',tgroup
                            ;stop
                            ;print,'Starting new interval'
                            ; InitTimeGroup, tStep, indexStep, Framedata.frameheader.Missed, frameTime, acceptedParticles,n_imgs,AllReject, $
                            ;    cubicSize, mass,Acor_area,Acor_area_sav, imglist[frame].deadtime, Framedata.frameheader.ImgMean, sumSecs,$
                            ;   MaxTGroup, crystal, missed, deadtime, TLastFrameSec, totsav, totsav2, totsav3, totFrm, AccumConc, $
                            ;   AccumCubicSize, AccumMass,AccumAcor_area, TMean, TMeanCnt, TMax, ImgMean, AvgIntEnd, tGroup, $
                            ;    ParticleCnt, AccMaxLen, AccMeanLen,fcs_max,earlier_frdeadtime
                            ;changed above to this  by mo  august 9, 2004
                            if frametime gt start_time+1.0+sumsecs then imglist_frame_deadtime=imglist[frame].deadtime

                            InitTimeGroup, tStep, indexStep, Framedata.frameheader.Missed, frameTime, acceptedParticles,n_imgs,AllReject, $
                                cubicSize, mass,Acor_area,Acor_area_sav, imglist_frame_deadtime, Framedata.frameheader.ImgMean, sumSecs,$
                                MaxTGroup, crystal, missed, deadtime, TLastFrameSec, totsav, totsav2, totsav3, totFrm, AccumConc, $
                                AccumCubicSize, AccumMass,AccumAcor_area, TMean, TMeanCnt, TMax, ImgMean,accumpartcnt_mo,$
                                accumsphmass,accumicemass, AvgIntEnd, tGroup, $
                                ParticleCnt, AccMaxLen, AccMeanLen,fcs_max,earlier_frdeadtime,particle_cnt_msav,$
                                sphmass_sav,icemass_sav,$;   before sept 2004
                                WAcor_area_sav,Wparticle_cnt_msav,Wsphmass_sav,Wicemass_sav,$; added fow wysiwyg_r on oct11 2004
                                WAccumsphmass,WAccumicemass,Waccumpartcnt_mo,WAccumAcor_area,$;added fow wysiwyg_r on oct11 2004
                                AccumradarvolD6I,radarvolD6_savI, WAccumradarvolD6I,WradarvolD6_savI,$; added oct 22 for dBz
                                AccumradarvolD6L,radarvolD6_savL, WAccumradarvolD6L,WradarvolD6_savL; added oct 22 for dBz
                            earlier_frdeadtime=imglist[frame].deadtime; deadtime
                        endelse
                    endif ; end of time series processing

                    ; Are we printing images?
                    if((*pLink).addSize1)then sizeType = 'max'
                    if((*pLink).addSize2)then sizeType = 'mean'

                    if((*pStateInfo).PrintROI.DoIt and imgFrame and (*pLink).output) THEN begin
                        if(n_elements(confidence) le n_elements(*frameData.pFrame))then begin
                            Ret = PrintROIs(pStateInfo, accepted, frameData, OutPutFlags=(*pStateInfo).PrintROI.Flags, $
                                objData=objData, confidence=confidence, criteria = (*pLink).criteria,time=time,sizeType = sizeType)
                        endif

                    endif
                    if(ptr_valid(FrameData.pFrame))then delete_frame,FrameData
                    if(ptr_valid((*pStateInfo).pObjList) and imgFrame)then delete_obj_header,objData

                endif ; end of IF for valid frameData

            endif ; end of good frame condition

        endfor   ; end of Frame loop

        ; let this time period be displayed!
        (*pLink).process = !true

    endfor ; end of multiple file loop

    skip:

    ; advance to next time period
    ;pLastLink = pLink
    ;pLink = (*pLink).next_link

endfor ; end time periods loop

;pLink = pLastLink

; complete all calculations
if(spectra)then begin
    ;**************added by mo on september 16, 2004  -----
    ; frametime_mooo=double(imglist.htime)+double(imglist.msec/1000.0);    This is all of the frame time in combines.csv file.
    timeA=floor(frametime-(*pLink).SumInt-1.0)+1LL
    timeB=ceil(frametime-2.0)+1LL;  ; note that -1.0 is 1sec offset, another -1 is frametime has passed the second
    get_deadtime_btwAB,timeA,timeB,frametime_mooo,frametime_moooR,imglist,deadtime_new
    (*pgroup).deadtime=deadtime_new
    ;************************************************************************
    ;***********************************************************************
    if (*plink).addfssp2dc then begin
        ;getfssp2dcdata and assign them into the pgroup pointer.
        getfssp2dcdata,intEND,(*plink).sumint,Pstateinfo,fsspbinhs,twodcbinhs,twodcAbinhs,twodcMbinhs
        nnn=n_elements(fsspbinhs)
        (*pgroup).pfssp=ptr_new(fltarr(nnn))
        *(*pgroup).pfssp=fsspbinhs
        nnn=n_elements(twodcbinhs)
        (*pgroup).ptwodc=ptr_new(fltarr(nnn))
        *(*pgroup).ptwodc=twodcbinhs
        (*pgroup).ptwodcA=ptr_new(fltarr(nnn))
        *(*pgroup).ptwodcA=twodcAbinhs
        (*pgroup).ptwodcM=ptr_new(fltarr(nnn))
        *(*pgroup).ptwodcM=twodcMbinhs
    end

    ;**************************************************************************
    ;print,frame,floor(frametime)-start_time,intend-start_time
    ; finish current group
    finishSpectra,spectraAccept, roiFrmCnt, totImgPart, nonRejPart, acceptPart, TotFrmCnt, partCnt,$
        spectTotSav2,spec_accumpartcnt_mo, pGroup, groupCnt 

    ; determine if there are time gaps to fill
    if((stop_time-intEnd) gt SumInt)then begin
        ; skipped intervals
        ;determine how many intervals were skipped, create empty groups with the correct times
        PadFrmCnt = (stop_time-intEnd)/SumInt - 1
        PadSpectralGroups,PadFrmCnt,pGroup,groupCnt,SumInt
        ; set start of current time group
        (*pGroup).startTime = (*(*pGroup).prev_link).startTime + SumInt
        (*pStateInfo).spectra.groupCnt = groupCnt

    endif else begin

        if(not spectraComplete)then begin
            pPrevGroup = (*pGroup).prev_link
            if(ptr_valid(pPrevGroup))then begin
                ; remove an incomplete group
                (*pPrevGroup).next_link = ptr_new()
                deleteGroup,pGroup
                groupCnt = groupCnt-1
                pGroup = pPrevGroup
            endif
        endif

        pPrevGroup = (*pGroup).prev_link
        if(ptr_valid(pPrevGroup))then begin
            ; remove the last group
            (*pPrevGroup).next_link = ptr_new()
            deleteGroup,pGroup
            ;update spectra info
            (*pStateInfo).spectra.groupCnt = groupCnt-1
        endif else begin
            ; no valid data at all
            (*pStateInfo).spectra.groupCnt = 0
            deleteGroup,pGroup
        endelse
    endelse

endif   ;end of if(spectra) the begin

if(timeFlag)then begin
    ;**************added by mo on september 16, 2004  -----
    ;frametime_mooo=double(imglist.htime)+double(imglist.msec/1000.0);    This is all of the frame time in combines.csv file.
    timeA=floor(frametime-sumsecs-1.0)+1LL
    timeB=ceil(frametime-2.0)+1LL;  ; note that -1.0 is 1sec offset, another -1 is frametime has passed the second

    get_deadtime_btwAB,timeA,timeB,frametime_mooo,frametime_moooR,imglist,deadtime_new

    deadtime=deadtime_new
    ;************************************************************************
    ; complete last group ( skip last data point because it is not a complete interval)
    FinishTimeGroup,frameTime, AvgIntEnd, SumSecs, numPlots, missed, SampleVolume, AccumConc, $
        acceptedParticles, pLink, deadtime, totFrm, tMeanCnt, Tmax, tgroup, AccumCubicSize, AccumMass,AccumAcor_area, $
        Accumpartcnt_mo,Tmean, totsav,totSav2, totSav3, ImgMean, accumsphmass,accumicemass,indexStep, timePlot,$
        tGroupCnt, allParticles, tstep, $
        ParticleCntPerInterval, specialCase, max_to_save,MaxLength,nonRejectCnt,$ ;before sept 2004
        WAccumsphmass,WAccumicemass,Waccumpartcnt_mo,WAccumAcor_area,$;added fow wysiwyg_r on oct11 2004
        AccumradarvolD6I,WAccumradarvolD6I,AccumradarvolD6L,WAccumradarvolD6L; added oct 22 2004.

    if((stop_time-AvgintEnd) ge SumSecs)then tGroup = (tGroup + (stop_time-AvgIntEnd)/SumSecs + 1) < maxTGroup
    plotNum = 0
    labels = strarr(numplots)
    for i = 0,n_elements(tOperation)-1LL do begin
        if(tOperation[i])then begin
            case i of
                0: labels[plotNum] = 'Concntratn:#/L'
                1: labels[plotNum] = 'Extinction:1/km'
                2: labels[plotNum] = 'Radar(all) dBz'
                3: labels[plotNum] = 'Ave. Max Length um'
                4: labels[plotNum] = 'Max length um'
                5: labels[plotNum] = 'Total Frms'
                6: labels[plotNum] = 'Saved Frms'
                7: labels[plotNum] = 'Liq.dBz'    ;done in oct 22, 2004
                8: labels[plotNum] = 'Total Strobes'
                9: labels[plotNum] = 'Imaged Particles'
                10: labels[plotNum] = 'ImgdParts/TotStrbs'
                11: labels[plotNum] = 'ImgMean dn'
                12: labels[plotNum] = 'LWC:g/cu.m'   ;as nglib
                13: labels[plotNum] = 'TWC:g/cu.m';   as nglib
                14: labels[plotNum] = 'IWC:g/cu.m';   as nglib is the sum of above two.oct 21,2004.
                15: labels[plotNum] = 'IWC (TS) g/cu. m'
                16: labels[plotNum] = 'Ice.dBz' ;done oct 22 2004.
                17: labels[plotNum] = 'WYSIWYG #/L'
                else:
            endcase
            plotNum = plotNum + 1
        endif

    endfor

    if(Stop_time eq AvgIntEnd)then tGroup = tGroup + 1

    if(tgroup gt 0)then begin
        length = n_elements(timePlot[0,*])
        if(tGroup lt length)then begin
            (*pStateInfo).pTimeSeries = ptr_new({timeData:timePlot[*,0:tGroup-1],labels:labels,StartTime:TframeStart})
        endif else begin
            temp = timePlot
            timePlot = fltarr(numPlots,tGroup)
            timePlot[*,0:length-1] = temp
            (*pStateInfo).pTimeSeries = ptr_new({timeData:timePlot,labels:labels,StartTime:TframeStart})
        endelse
    endif else r = dialog_message('Error: no data in time series plots')
endif


IF ((sendASCII and (*pLink).Format eq 'hertz')) THEN BEGIN
    FREE_LUN, hklun

    ;Erase other log files if no data was stored into them
    SPP100FileSize = (fstat(SPP100LUN)).SIZE
    SBCFileSize = (fstat(SBCLUN)).SIZE
    PlaneFileSize = (fstat(PlaneLUN)).SIZE
    FREE_LUN, SPP100LUN
    FREE_LUN, SBCLUN
    FREE_LUN, PlaneLUN

    ; IDL versions less than 5.4 don't support FILE_DELETE
    IDLVersion = FLOAT(!VERSION.Release)
    IF IDLVersion GT 5.35 THEN BEGIN
        IF SPP100FileSize LT 10 THEN FILE_DELETE, SPP100LogFileName, /QUIET
        IF SBCFileSize LT 10 THEN FILE_DELETE, SBCLogFileName, /QUIET
        IF PlaneFileSize LT 10 THEN FILE_DELETE, PlaneLogFileName, /QUIET
    ENDIF
ENDIF


if(current_file ne first_file)then LoadFile, pStateInfo , filename = first_file
(*(*(*pStateInfo).ptimeInfo).pcurrent_link).habit=0
heap_gc
RETURN,[StartFrm,StopFrm]
end;   end of function  process_time_series
;*************************************************

pro display_Histograms, pStateInfo, pLink

    ; ArrayArea in cm^2 ( with tilt factor from instument ) ( 1.e-8 for microns^2 -> cm^2 )
    ArrayArea = DOUBLE((*pStateInfo).FileHead.DX)*(*pStateInfo).FileHead.DY*((*pStateInfo).Settings.PixSize)^2*(1.e-8)*(sqrt(2.0)/2.0)

    ; Airspeed is in m/sec, (1.e2 for m -> cm and 1.e-3 for cc -> Liter)
    SampleVolume = ArrayArea * ((*pLink).TAS * 1.0e-1) ; Liters/sec
    ; stop

    ; convert to Liters/ avg interval
    SampleVolume = SampleVolume * (*pLink).SumInt  ; Liters/interval

    ; added this for conditional spectra display. oct 24 2004.
    if( (*pLink).condspectra)then begin

        Flags = 0
        IF (*pLink).Hprint THEN Flags = Flags OR 1
        IF (*pLink).HTiff THEN Flags = Flags OR 2
        IF (*pLink).HASCII THEN Flags = Flags OR 4
        heap_gc
        if((*pLink).Hmissed)then typescaling = 1
        if((*pLink).Hdeadtime)then typescaling = 2
        if((*pLink).Hwysiwyg)then typescaling = 3
        ShowHistograms_condspectra, pStateInfo, (*pLink).SumInt, GROUP=(*pStateInfo).widgets.tlb, $
            OutPutFlags=Flags, SAMPLEVOLUME=SampleVolume, typeSCALING=typescaling,sizeType=(*pLink).HSPECTRATYPE
        heap_gc

    ENDIF

    ; Show Histogram Plots

    if( (*pLink).addfssp2dc)then begin

        Flags = 0
        IF (*pLink).Hprint THEN Flags = Flags OR 1
        IF (*pLink).HTiff THEN Flags = Flags OR 2
        IF (*pLink).HASCII THEN Flags = Flags OR 4

        heap_gc
        if((*pLink).Hmissed)then typescaling = 1
        if((*pLink).Hdeadtime)then typescaling = 2
        if((*pLink).Hwysiwyg)then typescaling = 3
        if n_elements(typescaling) eq 0 then typescaling=3;  added this on Dec 29, 2004.
        ShowHistograms_addfssp2dc, pStateInfo, (*pLink).SumInt, GROUP=(*pStateInfo).widgets.tlb, $
            OutPutFlags=Flags, SAMPLEVOLUME=SampleVolume, typeSCALING=typescaling,sizeType=(*pLink).HSPECTRATYPE
        heap_gc
    endif

    ; if( (*pLink).spectra)then begin    ; replace this with following on oct 25, 2004
    if( (*plink).Hwysiwyg or (*plink).Hmissed ) and not((*pLink).addfssp2dc) then begin

        Flags = 0
        IF (*pLink).Hprint THEN Flags = Flags OR 1
        IF (*pLink).HTiff THEN Flags = Flags OR 2
        IF (*pLink).HASCII THEN Flags = Flags OR 4

        heap_gc
        if((*pLink).Hmissed)then typescaling = 1
        if((*pLink).Hdeadtime)then typescaling = 2
        if((*pLink).Hwysiwyg)then typescaling = 3
        ShowHistograms, pStateInfo, (*pLink).SumInt, GROUP=(*pStateInfo).widgets.tlb, $
            OutPutFlags=Flags, SAMPLEVOLUME=SampleVolume, typeSCALING=typescaling,sizeType=(*pLink).HSPECTRATYPE
        heap_gc

    ENDIF


end

pro display_timeSeries, pStateInfo, pLink
    ; Show Time Series Plots
    ; Time series process options

    ; ArrayArea in cm^2 ( with tilt factor from instument ) ( 1.e-8 for microns^2 -> cm^2 )
    ;ArrayArea = DOUBLE((*pStateInfo).FileHead.DX)*(*pStateInfo).FileHead.DY*((*pStateInfo).Settings.PixSize)^2*(1.e-8)*(sqrt(2.0)/2.0)

    ; Airspeed is in m/sec, (1.e2 for m -> cm and 1.e-3 for cc -> Liter)
    ;SampleVolume = ArrayArea * ((*pLink).TAS * 1.0e-1)    ; Liters/sec

    ; convert to Liters/ avg interval
    ;SampleVolume = SampleVolume * (*pLink).sample ; Liters/interval

    pLink =(*(*pStateInfo).pTimeInfo).pCurrent_Link

    ; Output options
    Flags = 0
    IF((*pLink).TPlotPrint)THEN Flags = Flags OR 1
    IF((*pLink).TplotTiff )THEN Flags = Flags OR 2
    IF((*pLink).TplotASCII)THEN Flags = Flags OR 4

    ;heap_gc
    TimeSeriesWidget, pStateInfo, pLink, OutPutFlags=Flags
    ;heap_gc
    (*plink).time=0;    resett it to be zero after the a time-series is processed.
end



;************************************************************
pro get_deadtime_btwAB,timeA,timeB,frametime_mooo,frametime_moooR,imglist,deadtime
    ; input: timeA, timeB, frametime_mooo,Frametime_moooR,imglist
    ; ouput: deadtime
    deadtime=0.0

    for i=timeA,timeB-1LL do begin
        indxT=where(imglist.Htime eq i,contG)
        if contG gt 0 then thisDT=max((imglist.deadtime)(indxT)) else thisDT=0.0
        deadtime=deadtime+thisDT
    endfor
    ; print,timeA, deadtime

end
;************************************************************

;added this following in July 31, 2007.
FUNCTION Process_time_Series_png_pages_only, pStateInfo, volume = volume

Forward_function printROIs, find_first_link

;*******it is assume that obj is always exist  *********************************************
widget_control,/hourglass

; get linked list info
pLink = (*(*pStateInfo).pTimeInfo).pCurrent_link

if((*(*pStateInfo).pTimeInfo).cur_per ne 1)then    pLink = find_first_link(pLink)
num_time_periods = 1;(*(*pStateInfo).pTimeInfo).periods

;imgList = (*((*pStateInfo).pFileScan))[*((*pStateInfo).pImgPosIndx)]
; Note: badframes have a time stamp that is wrong. It was not monotonically increasing
imgListIndx = where((*(*pStateInfo).pFileScan).imgtype ge 0 and not (*(*pStateInfo).pFileScan).badframe)
imgList = (*(*pStateInfo).pFileScan)[imgListIndx]
HKListIndx = where((*(*pStateInfo).pFileScan).imgtype eq -1)
HKList = (*(*pStateInfo).pFileScan)[HKListIndx]

(*pStateInfo).PrintROI.pageNo = 0


for k = 0,num_time_periods-1 do begin

    firstPass = !true
    timeFlag = !false
    output = !false

    ; get the first frame based on start time from GUI
    start_time = convertToseconds((*pLink).start,(*pStateInfo).FileHead.year)
    stop_time = convertToseconds((*pLink).stop,(*pStateInfo).FileHead.year)
    ;print,'Requested start time=',start_time
    ;print,'Requested stop time=',stop_time

    StartFrm = GetFrameByTime(pStateInfo, (*pLink).start,/absolute, type='start')

    ; check to see if end time is beyond this file
    add_files = 0
    guiTime = convertToSeconds((*pLink).stop,(*pStateInfo).filehead.year)
    ;stop
    dumIndx = where((*(*pStateInfo).pFileScan).imgtype eq 1 and not (*(*pStateInfo).pFileScan).badframe ,ImgCnt)
    lastTime = (*(*pStateInfo).pFileScan)[dumIndx[ImgCnt-1]].HTime

    StopFrm = GetFrameByTime(pStateInfo, (*pLink).stop,/absolute, type='stop')

    ; loop through the frames
    imgFrmCt = 0L
    tComplete = !false
    spectraComplete = !false
    spectraAccept = !false
    TlastFrameSec = 0UL
    SlastFrameSec = 0UL
    SlastFrameSec2 = 0UL
    objheader_start = 0UL

    print,'Processing file ',(*pStateInfo).infilename, ' additional files to process',add_files

    current_file = (*pStateInfo).infilename
    first_file = (*pStateInfo).infilename

    for fileNum = 0, add_files do begin
        ; first pass uses the file currently loaded
        if(fileNum gt 0)then begin
            print,'Processing file #',filenum, ' named ',filesToProcess[fileNum]
            ;open next file if needed
            LoadFile, pStateInfo , filename = filesToProcess[fileNum]
            current_file = filesToProcess[fileNum]
            ; get last frame based on time
            StopFrm = GetFrameByTime(pStateInfo, (*pLink).stop,/absolute, type='stop')
            StartFrm = 0UL
            if(StopFrm eq -1)then StopFrm= n_elements(imglist) - 1 ; use last frame in image list
            imgListIndx = where((*(*pStateInfo).pFileScan).imgtype ge 0)
            imgList = (*(*pStateInfo).pFileScan)[imgListIndx]
            imgFrmCt = 0L
        endif
        ; following line added by mo sept 17, 2004.
        frametime_mooo=imglist.htime+imglist.msec/1000.0; ;all frame times; more than those in *combined.csv
        frametime_moooR=floor(frametime_mooo)
        ;last_frametime=ulong(frametime_mooo(0)); added this on july31, for archive png page. to cout 5 images for
        ; each second.
        ;this_secs_frame_count=0LL
        last_frametime=frametime_mooo(0)

        for frame = StartFrm, StopFrm do begin

            ; skip bad frames
            if(not imgList[frame].badframe)then begin
                ; track frames for spectra
                ; must read the image data if any roi display or output is required
                frameData = read_frame((*pStateInfo).InFileLun,(*pStateInfo).FileHead.Ver,imgList[frame].fpos,date=(*pStateInfo).date, TSBlanked = imglist[frame].TSBlanked)

                imgFrame = (not((frameData.Frameheader.ImgType and 2)/2) and frameData.Frameheader.ROIsCount ge 1 )

                if(size(frameData,/type) eq 8)then begin ; skip if this is not a valid frame

                    ;if(frame eq startFrm)then print,'Actual Start Frame time =',framedata.frameheader.time
                    ;if(frame eq stopFrm)then print,'Actual Stop Frame time =',framedata.frameheader.time

                    frameTime = frameData.FrameHeader.time

                    time = convertFromSeconds(frameTime , (*pStateInfo).FileHead.year) ; change to 4/19/19:20:00.00 format.
                    time.msec  = ROUND(CalcStrobeTime(frameData.frameHeader.ArrivalT1, frameData.frameHeader.ArrivalT2,framedata.frameHeader.Ver))

                    ; time of frame in seconds
                    frameTime = frameTime + time.msec/1000.0D

                    ; ROIArray is an array of pointers for each particle in the frame
                    pROIArray = FrameData.pFrame

                    ; if an Object file exists, then use it NOTE pROIArray is reassigned here to the OBJ data
                    if (imgframe and ptr_valid((*pStateInfo).pObjList)) then $
                        getObjData,pStateInfo,framedata,pROIArray,imgFrmCt,objData


                    if(imgFrame)then imgFrmCt = imgFrmCt + 1

                    ; How many ROIs?
                    if(ptr_valid(pROIArray) and imgFrame)then n_imgs = n_elements( *pROIArray ) else n_imgs = 0
                    if(imgframe)then if( n_imgs gt n_elements(*pROIArray))then print,'Error, obj data out of sync with frame'

                    if(FirstPass)then begin
                        DoFirstPass,pLink,frameStart,start_time,IntEnd,spectraComplete,timeFlag,SumSecs,AvgIntEnd,$
                            Stop_time,tComplete,IntEnd2,frameTime,TframeStart,pGroup,MaxTGroup
                        firstPass = !false
                    endif

                    if(frame eq startFrm and (*pLink).time and fileNum eq 0)then begin
                        (*pLink).timeStr =strtrim(fix((*pLink).start.hour),2) + ':' + strtrim(fix((*pLink).start.minute),2) + ':'+  strtrim(fix((*pLink).start.sec),2); + ':'+  strtrim(fix(time.msec),2)
                        if(ceil(frameTime) - avgIntEnd gt SumSecs)then tgroup = (ceil(frameTime) - avgIntEnd)/SumSecs
                        deadtime0=0.0
                    endif

                    ; create array for tracking confidence
                    if(n_imgs gt 0) THEN confidence = bytarr(n_imgs) ;(*pLink).accept and

                    if(n_imgs gt 0)then begin
                        meanLenArr = fltarr(n_imgs)
                        mnSizes = fltarr(n_imgs)
                        mxSizes = fltarr(n_imgs)
                        ; create accepted array for min file output
                        accepted = bytarr(n_imgs)
                    endif
                    acceptedParticles = 0L
                    nonRejectCnt = 0L
                    AllReject = !true

                    ; loop through all the particles in the frame and accumulate into the histogram array by size
                    FOR ROINum=0, n_imgs-1 DO begin

                        acceptFlag = AcceptanceCriteria(pROIArray,pStateInfo,len,wid,area,perim,roundness,focus,focusMin,$
                            focusMax,focusSTD,CutOff,Crystal,P1,corrected,reject,ROINum,plink)

                        ;help,*(*(*pStateInfo).ptimeInfo).pcurrent_link,/struct
                        if  (*(*(*pStateInfo).ptimeInfo).pcurrent_link).habit ge 1 and acceptFlag then begin
                            ; Update new habit number into our OBJ data structure
                            (*pROIArray)[ROINum].imageHeader.crystal = (*(*(*pStateInfo).ptimeInfo).pcurrent_link).habit
                            ; write new habit number to obj file
                            update_obj_header, (*pStateInfo).ObjLUN,(*(objdata).pimhdfpos)[ROINum], "crystal", (*(*(*pStateInfo).ptimeInfo).pcurrent_link).habit

                        endif


                        if(acceptFlag eq -1)then return,0 ; bail on error

                        if((*pROIArray)[ROINum].imageHeader.len gt 0 and AllReject)then AllReject = !false

                        if((*pROIArray)[ROINum].imageHeader.len ne 0)then nonRejectCnt = nonRejectCnt + 1

                        ; Need to handle skipping of seconds here Not sure if this is not already being done!
                        if(acceptFlag)then begin

                            ; mark roi image as accepted
                            accepted[roiNum] = !true

                            if(n_imgs gt 0)then confidence[ROINum] = 10  ;10 means accept,0 means reject(*pLink).accept and
                            acceptedParticles = acceptedParticles + 1
                        endif ; end of acceptFlag block

                    endFOR ; end of roi loop, This finish for 1 frame. roinum=0, 1, 2,,3, 4,if there are many rois in one frame.

                    ;**********************oct 23 2004 add this block for condition spectro calculations.
                    ;see pro sum_condtional_spectra_values
                    ;************************************************************************************

                    framesec = ulong(frametime)

                    ; accumulate spectral data
                    ;if((*pLink).spectra)then begin

                    ; Are we printing images?
                    if((*pStateInfo).PrintROI.DoIt and imgFrame and (*pLink).output) THEN begin
                        if(n_elements(confidence) le n_elements(*frameData.pFrame))then begin

                            ; added this part on july 31 2007 to limit archive output iamges counts.
                            ; every second we just output 5 frames of images at most.
                            ;******************************************************************
                            ;if framesec eq last_frametime then begin
                            ;this_secs_frame_count=this_secs_frame_count+1LL
                            ; endif else begin
                            ;     this_secs_frame_count=0LL
                            ;     last_frametime=framesec
                            ;     endelse

                            ;******************************************************************
                            ;if frametime -last_frametime gt 0.4 then begin
                            Ret = PrintROIs(pStateInfo, accepted, frameData, OutPutFlags=(*pStateInfo).PrintROI.Flags, $
                                objData=objData, confidence=confidence, criteria = (*pLink).criteria,time=time,sizeType = sizeType)
                            last_frametime=frametime
                            ;endif
                            ;*********************************************************************
                        endif

                    endif
                    if(ptr_valid(FrameData.pFrame))then delete_frame,FrameData
                    if(ptr_valid((*pStateInfo).pObjList) and imgFrame)then delete_obj_header,objData

                endif ; end of IF for valid frameData

            endif ; end of good frame condition
            ; print,'frame loop: ',frame

        endfor   ; end of Frame loop

        ; let this time period be displayed!
        (*pLink).process = !true

    endfor ; end of multiple file loop
endfor ; end time periods loop

if(current_file ne first_file)then LoadFile, pStateInfo , filename = first_file
(*(*(*pStateInfo).ptimeInfo).pcurrent_link).habit=0
heap_gc
RETURN,[StartFrm,StopFrm]
end;   end of function  process_time_series
;*************************************************
