pro doTimeSums,$
    ; Inputs
    pLink, pROIArray, pStateInfo, frameTime, avgIntEnd, crystal, ver, roiNum, $
    ; Outputs
    max_to_Save, $
    ; In/Out
    newROI, specialCase, ParticleCntPerInterval, MaxLength, AccmeanLen, AccmaxLen,$
    cubicSize, mass, ParticleCnt,Acor_area,Acor_area_sav,fcs_max,particle_cnt_msav,$
    sphmass_sav,icemass_sav, $; before september 2004
    WAcor_area_sav,Wparticle_cnt_msav,Wsphmass_sav,Wicemass_sav,$; added fow wysiwyg_r on oct11 2004
    radarvolD6_savI,wradarvolD6_savI,radarvolD6_savL,wradarvolD6_savL;added this for radar dbz time serices.
; all sizes are in microns

;modified this on June 9, 2009.
calculate_derived_parameters,pROIArray,ROINum,Lcor,Wcor,Dcor,Pcor,Acor,Mice,Mliq,adj,wfj,accepted,fcs
dfj=1.0

Length =  DCor ; microns
; mean size
if(ver ge 30)then begin
    meanLen = 2.0*round(sqrt(Acor/!dpi))
endif else begin
    meanLen =sqrt(Dcor * Wcor) ; microns round
endelse

if(frameTime ge AvgIntEnd and (newROI or roiNum eq 0))then begin
    ; this will happen only if this is the first roi of a new interval

    ; first save the current max of the last interval
    specialCase = !true
    max_to_save = maxLength
    ;print,'In doTimeSums:',maxlength,newROI,roiNum

    ; now initialize
    MaxLength = Length
    ParticleCntPerInterval = 1L
    newROI = !false

endif else begin
    ; all other rois contribute to accumulations of max comparisons
    ; compare current length to the running maxlength
    MaxLength = max([Length,maxLength])

    ParticleCntPerInterval = ParticleCntPerInterval + 1L
    newROI = !false
    ;print,'not special case'

endelse

; accumulate lengths FOR FRAME AVERAGES
AccmeanLen = AccmeanLen + meanLen
AccmaxLen = AccmaxLen + Length

cubicSize = cubicSize + (meanLen/2.0)^3 ; units are cubic microns meanLen in radius

ParticleCnt = ParticleCnt + 1L


;pixsize=(*pStateInfo).Settings.pixsize; in mm
;Lob=(*pROIArray)[ROINum].imageHeader.len*pixsize;    in microns
Qk=(0.24/0.9)*(min([(0.917^2.0), (0.07^2.0)*(Dcor/1000.)^(-2.2)])); for radar volume calculation.
CPIiwc=Mliq < Mice

fcs_max=max([fcs_max,fcs]);    fcs_max is input and output.  it saves teh max fcs in current frame.
if fcs_max eq fcs and accepted eq 1 then  begin
    Acor_area_sav=Acor*adj ; Acor_area_sav is the only output and always save one time.
    particle_cnt_msav=1.0*adj
    ;calculate radar volume.Qk=(0.24/0.9)*(min([(0.917^2.0), (0.07^2.0)*(Dcor/1000.)^(-2.2)]))
    ;radarvolD6_sav=adj*Qk*(Dcor/1000.0)^6
    if ((*pROIArray)[ROINum].imageHeader.crystal eq 1) then begin ;if crystal is liquid water.
        sphmass_sav=Mliq*adj
        icemass_sav=icemass_sav
        radarvolD6_savL=adj*(Dcor/1000.0)^6
    endif  else begin
        sphmass_sav=sphmass_sav
        icemass_sav=cpiiwc*adj
        radarvolD6_savI=adj*Qk*(Dcor/1000.0)^6
    endelse
endif else begin
    Acor_area_sav=Acor_area_sav
    particle_cnt_msav=particle_cnt_msav
    sphmass_sav=sphmass_sav;    only save one particle's mass for one frame. one frame has many rois.
    icemass_sav=icemass_sav
    radarvolD6_savI=radarvolD6_savI
    radarvolD6_savL=radarvolD6_savL
endelse
;get the wysiwyg_r values  added october 11, 2004.
if accepted eq 1 then begin
    Wparticle_cnt_msav=Wparticle_cnt_msav+wfj
    WAcor_area_sav=WAcor_area_sav+Acor_area*wfj

    if ((*pROIArray)[ROINum].imageHeader.crystal eq 1) then begin ;if crystal is liquid water.
        Wsphmass_sav=Wsphmass_sav+Mliq*wfj
        Wicemass_sav =Wicemass_sav
        WradarvolD6_savL=WradarvolD6_savL+wfj*(Dcor/1000.0)^6;;cal. this P's radar volume.
    endif else begin
        Wsphmass_sav=Wsphmass_sav
        Wicemass_sav=Wicemass_sav+cpiiwc*wfj
        WradarvolD6_savI=WradarvolD6_savI+wfj*Qk*(Dcor/1000.0)^6;;cal. this P's radar volume.
    endelse
endif

end

pro SumTimeValues,$
    ;Inputs
    n_imgs,validParticles,AllReject,nonRejectCnt,FrMissed,frameSec,imglist,imgMean,frImgMean, crystal,$
    ; In/Out
    totSav,totSav2,totSav3,totFrm,allParticles,missed,AccumConc,ParticleCnt,AccumCubicSize, cubicSize,$
    AccumMass, mass, TlastFrameSec, deadtime, tMean, AccMeanLen,TmeanCnt,Tmax,AccMaxLen,$
    Acor_area, Acor_area_sav, AccumAcor_area,fcs_max,accumpartcnt_mo,particle_cnt_msav,$;  ;this added by mo on JUly 27, 2004
    Accumsphmass,sphmass_sav,Accumicemass,icemass_sav,$;   this line added August 18/04
    WAcor_area_sav,Wparticle_cnt_msav,Wsphmass_sav,Wicemass_sav,$; added fow wysiwyg_r on oct11 2004
    WAccumsphmass,WAccumicemass,Waccumpartcnt_mo,WAccumAcor_area,$;added fow wysiwyg_r on oct11 2004
    AccumradarvolD6I,radarvolD6_savI,WaccumradarvolD6I,WradarvolD6_savI,$; added oct 21 2004.
    AccumradarvolD6L,radarvolD6_savL,WaccumradarvolD6L,WradarvolD6_savL; added oct 21 2004
; accumulate for this interval
if(n_imgs gt 0)then totsav = totSav + 1
if(validParticles gt 0)then totsav2 = totSav2 + 1
if(not AllReject)then totsav3 = totSav3 + 1
totFrm = totFrm + 1
allParticles = allParticles + nonRejectCnt;validParticles
;print,allParticles,nonRejectCnt
missed = missed + FrMissed
; print,AccumConc,ParticleCnt
AccumConc = AccumConc + ParticleCnt

AccumCubicSize = AccumCubicSize + cubicSize*1.e-12  ; convert to cc
AccumMass = AccumMass + mass
AccumAcor_area = AccumAcor_area+Acor_area_sav;    Acor_area
accumpartcnt_mo= accumpartcnt_mo+particle_cnt_msav
accumsphmass=accumsphmass+sphmass_sav
accumicemass=accumicemass+icemass_sav

; accumulate teh values for wysiwyg_r ;added fow wysiwyg_r on oct11 2004
WAccumsphmass=WAccumsphmass+Wsphmass_sav
WAccumicemass=WAccumicemass+Wicemass_sav
Waccumpartcnt_mo= Waccumpartcnt_mo+Wparticle_cnt_msav
WAccumAcor_area = WAccumAcor_area +WAcor_area_sav
WAcor_area_sav=0.0
Wparticle_cnt_msav=0.0
Wsphmass_sav =0.0
Wicemass_sav =0.0; added fow wysiwyg_r on oct11 2004

AccumradarvolD6I = AccumradarvolD6I+ radarvolD6_savI; added oct 22 2004.
WaccumradarvolD6I=WAccumradarvolD6I+WradarvolD6_savI
radarvolD6_savI=0.0
WradarvolD6_savI=0.0
AccumradarvolD6L = AccumradarvolD6L+ radarvolD6_savL; added oct 22 2004.
WaccumradarvolD6L=WAccumradarvolD6L+WradarvolD6_savL
radarvolD6_savL=0.0
WradarvolD6_savL=0.0

;stop
if(frameSec ne TlastFrameSec)then begin
    deadtime = deadtime + imgList.deadtime
    TlastFrameSec = frameSec

endif

;if(ParticleCnt gt 0)then Tmean = Tmean + (AccMeanLen / ParticleCnt) ; first average over the frame
Tmean = Tmean + AccMeanLen ; average over the time period
TmeanCnt = TmeanCnt + ParticleCnt

Tmax = Tmax + AccMaxLen
ImgMean = ImgMean + frImgMean
; reset frame accumulators
ParticleCnt = 0L
cubicSize = 0.0
mass = 0.0
AccMeanLen = 0.0
AccMaxLen = 0.0

Acor_area=0.0
Acor_area_sav=0.0
fcs_max=0.0; added by mo JAugust 4, 2004.  ???
particle_cnt_msav=0.0
sphmass_sav=0.0D
icemass_sav=0.0D

end

PRO FinishTimeGroup,$
    ;Inputs
    frameTime, AvgIntEnd, SumSecs, numPlots, missed, SampleVolume, AccumConc, validParticles, pLink, deadtime, totFrm, $
    tMeanCnt, Tmax, tgroup, AccumCubicSize, AccumMass,AccumAcor_area,accumpartcnt_mo, Tmean, totsav, totsav2, totsav3,$
    ImgMean,accumsphmass,accumicemass,$
    ; In/Out
    indexStep, timePlot, tGroupCnt, allParticles, tstep, ParticleCntPerInterval, specialCase,$
    max_to_save,MaxLength, nonRejectCnt,$
    WAccumsphmass,WAccumicemass,Waccumpartcnt_mo,WAccumAcor_area,$;added fow wysiwyg_r on oct11 2004
    AccumradarvolD6I,WAccumradarvolD6I,AccumradarvolD6L,WAccumradarvolD6L; added oct 22 2004.
tstep = ceil(frameTime - AvgIntEnd)
if(tstep lt SumSecs)then tstep = sumSecs
if(tstep mod sumsecs ne 0)then tstep = (tstep/sumsecs +1)*sumsecs
indexStep = tStep / sumSecs

;increase size of array if needed; be careful about radar reflectivity assign then to be -99 first.
if(tgroup + indexStep gt tgroupCnt-1)then begin
    temp = timePlot  ;holding nxm matrix, n-cuvers, each curve has m data points.
    tGroupCnt = tGroupCnt + 200 + indexStep
    timePlot = fltarr(numPlots,tGroupCnt) ;+ !values.f_nan
    ;assigned those radar values to be -99.0
    ;****************************************************************
    mooo_plots=0
    for i = 0,17 do begin
        if((*pLink).(i))then begin
            mooo_Plots = mooo_Plots + 1
            if(((*pLink).(i)) eq (*plink).Tmean) and (*plink).Tmean then timeplot(mooo_plots-1,*)=-99.0
            if(((*pLink).(i)) eq (*plink).Tpaul) and (*plink).Tpaul then timeplot(mooo_plots-1,*)=-99.0
            if(((*pLink).(i)) eq (*plink).tRate3) and (*plink).tRate3 then timeplot(mooo_plots-1,*)=-99.0
        endif
    endfor     ; thsi has to be in the finishgroup also.
    ;******************************************************************
    timePlot[*,0:tGroupCnt-(200 + indexStep + 1)] = temp
endif
;stop
if (*plink).adj_sel eq 2 then begin ;  replace values with wysisyg_r values
    accumpartcnt_mo=Waccumpartcnt_mo    ; (*Plink).adj_sel=0 is no_adj
    AccumAcor_area=WAccumAcor_area      ; (*Plink).adj_sel=1 is adj
    accumsphmass=Waccumsphmass
    accumicemass=Waccumicemass
    accumradarvolD6I=WaccumradarvolD6I
    accumradarvolD6L=WaccumradarvolD6L
endif;   added oct 11 2004 for wysiwyg_r
Tot_accumradarvolD6=accumradarvolD6I+accumradarvolD6L

;the following ***********block is modified by mo on july 28 2004
;********************************************************************************************
if((*pLink).accept eq !true and allParticles gt 0)then TSConc = (missed/(SampleVolume*SumSecs)) * (double(AccumConc)/allParticles) ;else TSConc = 0
; The following line corrects an error in Total strobes concentration when there is no acceptance criteria.
if((*pLink).accept eq !false and allParticles gt 0)then TSConc = (missed/(SampleVolume*SumSecs))
if((*pLink).accept eq !false and allParticles eq 0) then TSConc = (missed/(SampleVolume*SumSecs))
if((*pLink).accept eq !true and allParticles eq 0) then TSConc =0
;print,double(AccumConc),allParticles
;following line should be put to the end of this subroutine.
; allParticles = nonRejectCnt;validParticles; nonrejectcnt equal 0 or 1 in here, but allparticle is usuall gt 1.
;**********************************************************************************************

;********************************************************************************************
; if((*pLink).accept eq !true and allParticles gt 0)then  begin
; volume_mo=(SumSecs-deadtime)*SampleVolume
; noadj_no_empty_frame_Conc =allparticles/(volume_mo)
; endif

;print,double(AccumConc),allParticles
; allParticles = nonRejectCnt;validParticles
;********************************************************************************************

;**************************************Note on august 11 2004 *******************************
; so far I have got adj_sel = 0 or 1 reach here.  It cal be used to decide
; what type of calculation can be done in the finish time group.
;*********************************************************************************************

DOFmax=1.411*2.54
totfrm=1> totfrm;   take the bigger values.
IMG_SV=DOFmax*1024d*0.00023*1024d*0.00023*(totfrm)/1000d   ;liters
; fill in plot values as requested
plotNum = 0   ;plotnum is the number of curvers to be plotted.
if((*pLink).Tconc1) then begin
    volume_mo=(SumSecs-deadtime)*SampleVolume
    ; if volume_mo lt 0.0 then volume_mo=0.0
    if (*plink).adj_sel eq 2 then begin
        volume_mo=IMG_SV
    endif
    if volume_mo lt 0.0 then volume_mo=0.0
    ; apply Total strobes scaling
    if (Volume_mo ne 0.0) then conc_mo = accumpartcnt_mo/volume_mo else conc_mo=0.0; no_adj_no_emepty_frame
    timePlot[plotNum,tGroup] = conc_mo ;   articles/volume_mo
    ; Alternate method not ready yet!
    ; divide by estimated sample volume
    ;timePlot[plotNum,tGroup] = (SumSecs*missed)/(SumSecs-(pdsd1*totFrm +pdsd2*(missed-totFrm))
    plotnum = plotnum + 1
    ; print, 'conc_mo = ',conc_mo
    ; stop
endif

DTVolume = (SumSecs-deadtime)*SampleVolume    ;+ .0002*totFrm  take this away so that it is the same as do_alone.
if DTvolume lt 0.0 then DTvolume=1.0e+60

if (*plink).adj_sel eq 2 then begin
    DTvolume=IMG_SV
endif
if(DTVolume ne 0)then DTConc = 2.0*double(AccumAcor_area)/DTvolume/1000000.0;  This is extinction now.
if((*pLink).Tconc2) then begin
    ; apply deadtime scaling
    timePlot[plotNum,tGroup] = DTConc
    plotnum = plotnum + 1
    ;   print,'DTconc=',DTconc
endif

if((*pLink).Tmean) then begin ; for radar reflectivity dBz time series.
    if(Tot_AccumradarvolD6 gt 0) then dBz=10.0*Alog10(Tot_AccumradarvolD6) else dBz=-99.0
    timePlot[plotNum,tGroup] = dBz
    plotnum = plotnum + 1
endif

if((*pLink).Tmax) then begin ; AVERAGE   max length / group
    if(AccumConc gt 0)then timePlot[plotNum,tGroup] = Tmax/double(AccumConc)
    plotnum = plotnum + 1
endif

if((*pLink).TmaxLen) then begin ; max length

    ; this is true if there have been no accepted ROI's in this interval
    if(ParticleCntPerInterval eq 0)then MaxLength = 0.0

    if(specialCase)then begin
        ; this is true if the last accepted particle belongs to the next interval, not the current
        timePlot[plotNum,tGroup] = max_to_save
        ;if(timePlot[plotNum-1,tGroup] gt timePlot[plotNum,tGroup])then print,'mean length ',timePlot[plotNum-1,tGroup] ,' Max length',timePlot[plotNum,tGroup],tGroup,ParticleCntPerInterval,maxlength
        max_to_save = 0.0D
        specialCase = !false
        ParticleCntPerInterval = 1L
    endif else begin
        timePlot[plotNum,tGroup] = double(MaxLength)
        MaxLength = 0.0
        ParticleCntPerInterval = 0L
    endelse


    plotnum = plotnum + 1
    newROI = !true
endif

if((*pLink).Trate1) then begin ;total frames
    timePlot[plotNum,tGroup] = double(totFrm)
    plotnum = plotnum + 1
endif

if((*pLink).Trate2) then begin ;saved frames
    timePlot[plotNum,tGroup] = double(totsav)
    plotnum = plotnum + 1
endif
if((*pLink).Trate3) then begin  ;saved frames / total frames
    if(AccumradarvolD6L gt 0) then dBz=10.0*Alog10(AccumradarvolD6L) else dBz=-99.0
    timePlot[plotNum,tGroup] = dBz
    plotnum = plotnum + 1
endif

if((*pLink).Trate4) then begin ; total strobes
    timePlot[plotNum,tGroup] = double(missed)
    plotnum = plotnum + 1
endif
if((*pLink).Trate5) then begin  ; imaged particles
    timePlot[plotNum,tGroup] = double(AccumConc)
    plotnum = plotnum + 1
endif
if((*pLink).Trate6) then begin  ; imaged particles / total strobes
    if(missed ne 0)then timePlot[plotNum,tGroup] = double(AccumConc)/missed
    plotnum = plotnum + 1
endif

if((*pLink).Timgmn) then begin  ; image mean
    if(totFrm ne 0)then timePlot[plotNum,tGroup] = double(ImgMean)/totFrm
    plotnum = plotnum + 1
endif

;if(DTVolume ne 0)then LWC_DT = (4.D*!dpi/3.D)*AccumCubicSize / (DTvolume * .001D) else LWC_DT = 0.0D  ; grams / cubic meter
if(DTVolume ne 0)then begin
    LWC_sph = accumsphmass/DTvolume
    IWC_ice = accumicemass/DTvolume
    TWC     =LWC_sph+IWC_ice
endif  else begin
    LWC_sph=0.0
    IWC_ice=0.0
endelse

if((*pLink).TLWC1) then begin
    ; divide by estimated sample volume
    ;Volume = ( (SumSecs-deadtime)*SampleVolume + .0002*totFrm ) * .001 ; im cubic meters
    ;timePlot[plotNum,tGroup] = LWC_DT
    timePlot[plotNum,tGroup] = LWC_sph; or zero.
    ;stop
    plotnum = plotnum + 1
endif

if((*pLink).TIWC1) then begin
    ; divide by estimated sample volume
    ;Volume = SampleVolume * .001 ; im cubic meters
    ;timePlot[plotNum,tGroup] = (4.*!dpi/3.)*AccumCubicSize / volume   ; grams / cubic meter
    ;if(DTConc ne 0)then timePlot[plotNum,tGroup] = (TSConc/DTConc) * LWC_DT
    timePlot[plotNum,tGroup]=IWC_ice
    plotnum = plotnum + 1

endif

if((*pLink).TLWC2) then begin
    timePlot[plotNum,tGroup] = TWC;  see above equation TWC=LWC_sph +IWC_ice
    plotnum = plotnum + 1
endif

if((*pLink).TIWC2) then begin
    ; divide by estimated sample volume
    ;Volume =SampleVolume  * .001 ; im cubic meters
    ;timePlot[plotNum,tGroup] = AccumMass / volume   ; grams / cubic meter
    if(DTConc ne 0)then timePlot[plotNum,tGroup] = (TSConc/DTConc)*IWC_DT else timePlot[plotNum,tGroup] = 0
    plotnum = plotnum + 1
endif

if((*pLink).TPaul) then begin  ; Liquid radar dBz
    if(AccumradarvolD6I gt 0) then dBz=10.0*Alog10(AccumradarvolD6I) else dBz=-99.0
    timePlot[plotNum,tGroup] = dBz
    plotnum = plotnum + 1
endif

if((*pLink).TBrad) then begin ;WYSIWYG
    ;print,double(AccumConc)/(double(totsav)*.0002)
    if(totSav2 ne 0)then timePlot[plotNum,tGroup] = (double(AccumConc)/(double(totsav2)*.0002) - 5000.0) ; note  -5000 removes expected particle
    plotnum = plotnum + 1
endif

allParticles = nonRejectCnt;   this line is move dfrom above to here.
end   ; end of finishTimeGroup.pro

pro InitTimeGroup,$
    ; In
    tStep, indexStep, FrMissed, frameTime, validParticles, n_imgs, AllReject, cubicSize, mass,Acor_area,Acor_area_sav,$
    frDeadtime, FrImgMean, sumSecs, MaxTGroup, crystal,$
    ;Out
    missed, deadtime, TLastFrameSec, totsav, totsav2, totsav3, totFrm, AccumConc, AccumCubicSize, AccumMass,AccumAcor_area, $
    TMean, TMeanCnt, TMax, ImgMean,accumpartcnt_mo, accumsphmass,accumicemass, $
    ; In/Out
    AvgIntEnd, tGroup, ParticleCnt, AccMaxLen, AccMeanLen, fcs_max,earlier_frdeadTime,particle_cnt_msav,$
    sphmass_sav,icemass_sav,$
    WAcor_area_sav,Wparticle_cnt_msav,Wsphmass_sav,Wicemass_sav,$; added fow wysiwyg_r on oct11 2004
    WAccumsphmass,WAccumicemass,Waccumpartcnt_mo,WAccumAcor_area,$ ;added fow wysiwyg_r on oct11 2004
    AccumradarvolD6I,radarvolD6_savI,WAccumradarvolD6I,WradarvolD6_savI,$; added oct 22 for dBz
    AccumradarvolD6L,radarvolD6_savL,WAccumradarvolD6L,WradarvolD6_savL; added oct 22 for dBz

AvgIntEnd = AvgIntEnd + SumSecs*indexStep ;tstep
tGroup = (tGroup + indexStep) < MaxTGroup

;inits for next group
missed = long(FrMissed)
if n_elements(frdeadtime) eq 0 then frdeadtime=0.0
deadtime= EarLier_frdeadTime;   used last saved frame deadtime as teh current deadtime.
EarLier_frdeadTime=frdeadtime;  save current frme datatime for next Time interval.
;deadtime= frdeadtime    ; original code. chnage to above two lines on august 8, 2004.


TlastFrameSec = ulong(frametime)

if(n_imgs gt 0)then totsav = 1L else   totsav = 0L
if(validParticles gt 0)then totsav2 = 1L else totsav2 = 0L
if(not AllReject)then totsav3 = 1L else totsav3 = 0L

totFrm = 1

; init interval accumulators for next interval
;print,'Init',ParticleCnt
AccumConc = ParticleCnt
AccumCubicSize = cubicSize * 1.e-12
AccumMass = mass
AccumAcor_area=Acor_area_sav   ;;    added by mo
accumpartcnt_mo=particle_cnt_msav;   added by mo note that the current saved cnt is still valid
; as that of Acor_area_sav the first particle.
accumsphmass=sphmass_sav; added august 18/2004
accumicemass=icemass_sav

mass = 0.0
cubicSize = 0.0
Acor_area=0.0;    added by mo
Acor_area_sav=0.0; added by mo
fcs_max=0.0
particle_cnt_msav=0.0; added by mo   august 9 , 2004
sphmass_sav=0.0D;               added august 18/2004
icemass_sav=0.0D

;added this for wysiwyg_r
; accumulate teh values for wysiwyg_r ;added fow wysiwyg_r on oct11 2004
WAccumsphmass=Wsphmass_sav
WAccumicemass=Wicemass_sav
Waccumpartcnt_mo= Wparticle_cnt_msav
WAccumAcor_area = WAcor_area_sav
WAcor_area_sav=0.0
Wparticle_cnt_msav=0.0
Wsphmass_sav =0.0
Wicemass_sav =0.0; added fow wysiwyg_r on oct11 2004

AccumradarvolD6I=RadarvolD6_savI;      added oct 22 2004.
WAccumradarvolD6I=WradarvolD6_savI
WradarvolD6_savI=0.0
radarvolD6_savI=0.0
AccumradarvolD6L=RadarvolD6_savL;      added oct 22 2004.
WAccumradarvolD6L=WradarvolD6_savL
WradarvolD6_savL=0.0
radarvolD6_savL=0.0

if(ParticleCnt gt 0)then begin
    Tmean = AccMeanLen
    TmeanCnt = ParticleCnt
    Tmax = AccMaxLen
endif else begin
    Tmean = 0L
    TmeanCnt = 0L
    Tmax = 0L
endelse

ParticleCnt = 0L

AccMeanLen = 0.0
AccMaxLen = 0.0
ImgMean = long(FrImgMean)
end
