
PRO TextBox_CenterTLB, tlb

    Device, Get_Screen_Size=screenSize
    IF screenSize[0] GT 2000 THEN screenSize[0] = screenSize[0]/2 ; Dual monitors.
    xCenter = screenSize(0) / 2
    yCenter = screenSize(1) / 2

    geom = Widget_Info(tlb, /Geometry)
    xHalfSize = geom.Scr_XSize / 2
    yHalfSize = geom.Scr_YSize / 2

    Widget_Control, tlb, XOffset = xCenter-xHalfSize, $
        YOffset = yCenter-yHalfSize

END ;-----------------------------------------------------



PRO moqixu_TextBox_Event, event

    Widget_Control, event.top, Get_UValue=info
    CASE event.ID OF
        info.cancelID: Widget_Control, event.top, /Destroy
        ELSE: BEGIN

            Widget_Control, info.textID, Get_Value=theText
            (*info.ptr).text = theText[0]
            (*info.ptr).cancel = 0
            Widget_Control, event.top, /Destroy
        ENDCASE
    ENDCASE
END ;-----------------------------------------------------



FUNCTION moqixu_TextBox, Title=title, Label=label, Cancel=cancel, $
    Group_Leader=groupleader, XSize=xsize, Value=value
Catch, theError
IF theError NE 0 THEN BEGIN
    Catch, /Cancel
    ok = Dialog_Message(!Error_State.Msg)
    IF destroy_groupleader THEN Widget_Control, groupleader, /Destroy
    cancel = 1
    RETURN, ""
ENDIF

IF N_Elements(title) EQ 0 THEN title='Provide input:'
IF N_Elements(label) EQ 0 THEN label = ""
IF N_Elements(value) EQ 0 THEN value = ""
IF N_Elements(xsize) EQ 0 THEN xsize = 600

IF N_Elements(groupleader) EQ 0 THEN BEGIN
    groupleader = Widget_Base(Map=0)
    Widget_Control, groupleader, /Realize
    destroy_groupleader = 1
ENDIF ELSE destroy_groupleader = 0
tlb = Widget_Base(Title='moqixu_textbox', /col, $
    /Base_Align_Center, Group_Leader=groupleader,xsize=800)
myinfo=title
myysize=n_elements(myinfo)
infobase=widget_text(tlb, value=myinfo,ysize=myysize,xsize=120,/Frame)

labelbase = Widget_Base(tlb, row=1)
IF label NE "" THEN label = Widget_Label(labelbase, Value=label)
textID = Widget_Text(labelbase, /Editable, Scr_XSize=xsize, Value=value)
buttonBase0 = Widget_Base(tlb, /col)
buttonBase1 = Widget_Base(buttonbase0, /row)
cancelID = 1; Widget_Button(buttonBase1, Value='Cancel')
acceptID = Widget_Button(buttonBase1, Value='Accept')

TextBox_CenterTLB, tlb
Widget_Control, tlb, /Realize

ptr = Ptr_New({text:"", cancel:1})

info = {ptr:ptr, textID:textID, cancelID:cancelID}
Widget_Control, tlb, Set_UValue=info, /No_Copy

XManager, 'moqixu_textbox', tlb

theText = (*ptr).text
cancel = (*ptr).cancel
Ptr_Free, ptr
IF destroy_groupleader THEN Widget_Control, groupleader, /Destroy

RETURN, theText
END ;-----------------------------------------------------


