pro plot_2ds_1Hz_mean_psd

    read_in_2ds_data_from_1Hz_archive,TDsData,pathnm
    ; read_caps_data,caps_data,xcaps,caps_binwidths
    ;stop
    ;select time period.
    time1='20:09:19';    this matched ave_start=10, end=13 data.
    time2='20:09:39'
    ;stop
    Get_2ds_time1totime2_TMS_mean_psd,time1,time2,TDsdata,$
        time,Hconc,Hextn,Hiwc,Hmnsz,Vconc,Vextn,VIWC,Vmnsz,xpts,Hypts,Vypts
    ;stop

    ;get 2dsview saved.txt psds
    get_2dsview_psd_cmp_psd,x2ds,y2ds


    window,1,xs=400,ys=400
    loadct,0
    !P.thick=1
    !P.CHARSIZE=1
    !P.multi=[0,1,1]
    white=!D.N_COLORS-1
    !P.BACKGROUND=white

    index=where(hypts gt 0.0,contG)
    if contG gt 0 then begin
        hymin=min(hypts(index))
    endif else hymin=0.0001

    index=where(Vypts gt 0.0,contG)
    if contG gt 0 then begin
        vymin=min(vypts(index))
    endif else vymin=0.0001

    index=where(y2ds gt 0.0,contG)
    if contG gt 0 then begin
        ymin2ds=min(y2ds(index))
    endif else ymin2ds=0.0001

    ymin=min([hymin,vymin,ymin2ds])
    ymax=max([max(hypts),max(vypts),max(y2ds)])
    ymin=10.0^floor(Alog10(ymin))
    ymax=10.0^ceil(Alog10(ymax))



    PLOT, xpts-5, Hypts, COLOR=0, XRANGE=[10,1000], /Xlog,$
        Xstyle = 1, YLOG=1,xtitle='Particle Size(um)',TITLE='2ds 1Hz mean psd ',$
        THICK=1, YRANGE=[ymin, ymax],ystyle=1, charsize=1.0,$
        YTITLE='#/L/um';  Yticks=ytikn,Ytickn=myticknames
    oplot,x2ds,y2ds,color=255

    ;get caps data
    ;get_mean_psd_of_caps,time1,time2,Caps_data,caps_binwidths,xcaps,ycaps
    ;oplot,xcaps,ycaps,color=0

    ;stop
    ;Ok, SO far the Hconc, Hypts Hextn, Hmass agrees with 2dsview comp_psd results.
end; end of plot_2ds_1Hz_mean_psd
;*************************************************
pro read_in_2ds_data_from_1Hz_archive,TDsData,pathnm
    filename=dialog_pickfile(filter='TD*.WB57',get_path=pathnm)
    ;find out how many line is in the file.
    data=read_ascii(filename,count=n_lines)
    nnnseconds=(n_lines-88)/8
    junk=strarr(88)
    openr,2,filename
    readf,2,junk
    Data={seconds:0LL,$
        Hconc:0.0,Hextn:0.0,HIWC:0.0,Hmnsz:0.0,Vconc:0.0,Vextn:0.0,VIWC:0.0,Vmnsz:0.0,$
        Hbin1:0.0,Hbin2:0.0,Hbin3:0.0,Hbin4:0.0,Hbin5:0.0,Hbin6:0.0,Hbin7:0.0,Hbin8:0.0,$
        Hbin9:0.0,Hbin10:0.0,Hbin11:0.0,Hbin12:0.0,Hbin13:0.0,Hbin14:0.0,Hbin15:0.0,Hbin16:0.0,$
        Hbin17:0.0,Hbin18:0.0,Hbin19:0.0,Hbin20:0.0,Hbin21:0.0,Hbin22:0.0,Hbin23:0.0,Hbin24:0.0,$
        Vbin1:0.0,Vbin2:0.0,Vbin3:0.0,Vbin4:0.0,Vbin5:0.0,Vbin6:0.0,Vbin7:0.0,Vbin8:0.0,$
        Vbin9:0.0,Vbin10:0.0,Vbin11:0.0,Vbin12:0.0,Vbin13:0.0,Vbin14:0.0,Vbin15:0.0,Vbin16:0.0,$
        Vbin17:0.0,Vbin18:0.0,Vbin19:0.0,Vbin20:0.0,Vbin21:0.0,Vbin22:0.0,Vbin23:0.0,Vbin24:0.0 $
        }
    TDsData=replicate(data,nnnseconds)
    readf,2,TDsData
    close,2
end; end of read_in_2ds_data_from_1Hz_archive.

pro Get_2ds_time1totime2_TMS_mean_psd,time1,time2,TDsdata,$
    time,Hconc,Hextn,Hiwc,Hmnsz,Vconc,Vextn,VIWC,Vmnsz,xpts,Hypts,Vypts

;request times
starttime=time1;   for this periods, caps don't see anything bigger than 10um.
endtime  =time2;  is string format hh:mm:ss

substr=strsplit(starttime,':',/extract)
startseconds=substr(0)*3600LL+substr(1)*60LL+substr(2)*1LL

substr=strsplit(endtime,':',/extract)
endseconds=substr(0)*3600LL+substr(1)*60LL+substr(2)*1LL
nseconds=(endseconds-startseconds)

hypts=fltarr(24)
vypts=fltarr(24)
;bins edges and widths
nbins=24
nedges=2*nbins
xpts=dblarr(2*nbins)
ptr = 0
for i =0, 8  DO BEGIN
    xpts[ptr] = double((i+1)*10)
    xpts[ptr + 1] = double((i+2) * 10)
    ptr += 2
endfor
xpts[18:47]=[10,12,12,15,15,20,20,25,25,32,32,40,40,50,50,60,60,70,70,80,80,90,90,100,100,120,120,140,140,1001]*10
widths=xpts(1:47)-xpts(0:46)
indexw=where(widths ne 0.0)
widths=widths(indexw)*0+1.0


;original data.
seconds=Tdsdata.seconds
index=where(seconds ge startseconds and seconds lt endseconds,contG)
if contG gt 0 then begin
    time=seconds(index)
    Hconc=TDsData(index).Hconc
    Hextn=TDsdata(index).Hextn
    HIWC =TDsdata(index).Hiwc
    Hmnsz=TDsdata(index).Hmnsz;    sample volumes of each second.
    Vconc=TDsData(index).Vconc
    Vextn=TDsdata(index).Vextn
    VIWC =TDsdata(index).Viwc
    Vmnsz=TDsdata(index).Vmnsz
    sv=total(Hmnsz)

    ; note that TDSdata.Bin is #/L/um

    Hypts(0)=total(widths(0)*Hmnsz*TDsdata(index).Hbin1)/Sv
    Hypts(1)=total(widths(1)*Hmnsz*TDsdata(index).Hbin2)/Sv
    Hypts(2)=total(widths(2)*Hmnsz*TDsdata(index).Hbin3)/Sv
    Hypts(3)=total(widths(3)*Hmnsz*TDsdata(index).Hbin4)/Sv
    Hypts(4)=total(widths(4)*Hmnsz*TDsdata(index).Hbin5)/Sv
    Hypts(5)=total(widths(5)*Hmnsz*TDsdata(index).Hbin6)/Sv
    Hypts(6)=total(widths(6)*Hmnsz*TDsdata(index).Hbin7)/Sv
    Hypts(7)=total(widths(7)*Hmnsz*TDsdata(index).Hbin8)/Sv
    Hypts(8)=total(widths(8)*Hmnsz*TDsdata(index).Hbin9)/Sv
    Hypts(9)=total(widths(9)*Hmnsz*TDsdata(index).Hbin10)/Sv
    Hypts(10)=total(widths(10)*Hmnsz*TDsdata(index).Hbin11)/Sv
    Hypts(11)=total(widths(11)*Hmnsz*TDsdata(index).Hbin12)/Sv
    Hypts(12)=total(widths(12)*Hmnsz*TDsdata(index).Hbin13)/Sv
    Hypts(13)=total(widths(13)*Hmnsz*TDsdata(index).Hbin14)/Sv
    Hypts(14)=total(widths(14)*Hmnsz*TDsdata(index).Hbin15)/Sv
    Hypts(15)=total(widths(15)*Hmnsz*TDsdata(index).Hbin16)/Sv
    Hypts(16)=total(widths(16)*Hmnsz*TDsdata(index).Hbin17)/Sv
    Hypts(17)=total(widths(17)*Hmnsz*TDsdata(index).Hbin18)/Sv
    Hypts(18)=total(widths(18)*Hmnsz*TDsdata(index).Hbin19)/Sv
    Hypts(19)=total(widths(19)*Hmnsz*TDsdata(index).Hbin21)/Sv
    Hypts(20)=total(widths(19)*Hmnsz*TDsdata(index).Hbin20)/Sv
    Hypts(21)=total(widths(21)*Hmnsz*TDsdata(index).Hbin22)/Sv
    Hypts(22)=total(widths(22)*Hmnsz*TDsdata(index).Hbin23)/Sv
    Hypts(23)=total(widths(23)*Hmnsz*TDsdata(index).Hbin24)/Sv
    Vypts(0)=total(widths(0)*Hmnsz*TDsdata(index).Vbin1)/Sv
    Vypts(1)=total(widths(0)*Hmnsz*TDsdata(index).Vbin2)/Sv
    Vypts(2)=total(widths(0)*Hmnsz*TDsdata(index).Vbin3)/Sv
    Vypts(3)=total(widths(0)*Hmnsz*TDsdata(index).Vbin4)/Sv
    Vypts(4)=total(widths(0)*Hmnsz*TDsdata(index).Vbin5)/Sv
    Vypts(5)=total(widths(0)*Hmnsz*TDsdata(index).Vbin6)/Sv
    Vypts(6)=total(widths(0)*Hmnsz*TDsdata(index).Vbin7)/Sv
    Vypts(7)=total(widths(0)*Hmnsz*TDsdata(index).Vbin8)/Sv
    Vypts(8)=total(widths(0)*Hmnsz*TDsdata(index).Vbin9)/Sv
    Vypts(9)=total(widths(0)*Hmnsz*TDsdata(index).Vbin10)/Sv
    Vypts(10)=total(widths(0)*Hmnsz*TDsdata(index).Vbin11)/Sv
    Vypts(11)=total(widths(0)*Hmnsz*TDsdata(index).Vbin12)/Sv
    Vypts(12)=total(widths(0)*Hmnsz*TDsdata(index).Vbin13)/Sv
    Vypts(13)=total(widths(0)*Hmnsz*TDsdata(index).Vbin14)/Sv
    Vypts(14)=total(widths(0)*Hmnsz*TDsdata(index).Vbin15)/Sv
    Vypts(15)=total(widths(0)*Hmnsz*TDsdata(index).Vbin16)/Sv
    Vypts(16)=total(widths(0)*Hmnsz*TDsdata(index).Vbin17)/Sv
    Vypts(17)=total(widths(0)*Hmnsz*TDsdata(index).Vbin18)/Sv
    Vypts(18)=total(widths(0)*Hmnsz*TDsdata(index).Vbin19)/Sv
    Vypts(19)=total(widths(0)*Hmnsz*TDsdata(index).Vbin20)/Sv
    Vypts(20)=total(widths(0)*Hmnsz*TDsdata(index).Vbin21)/Sv
    Vypts(21)=total(widths(0)*Hmnsz*TDsdata(index).Vbin22)/Sv
    Vypts(22)=total(widths(0)*Hmnsz*TDsdata(index).Vbin23)/Sv
    Vypts(23)=total(widths(0)*Hmnsz*TDsdata(index).Vbin24)/sv
endif else begin
    time=seconds(index)
    ;Hypts=0.0
    ;Vypts=0.0; all other values are zero.
    rrr=dialog_message(' No 2DS data from this time period', /information)
endelse

;make Hypts and Vypts into horizontal and verticals.
hyptsn=fltarr(48)
vyptsn=fltarr(48)
for i=0,23 do begin
    hyptsn(2*i:2*i+1)=hypts(i)
    vyptsn(2*i:2*i+1)=vypts(i)
endfor
hypts=hyptsn
vypts=vyptsn
;stop
end; end of get_2ds_time1totime2_total_psd_from_1Hz_archive,filename,time1,time2,xpts,ypts
;*********************************************************************

pro get_2dsview_psd_cmp_psd,x2ds,y2ds
    ;read 2ds psd data file
    filter_str='PSD_CMP*.txt'
    filename2=dialog_pickfile(filter=filter_str,path=pathnm,title='Pick a 2ds psd PSD_CMP*.txt file')

    combined_string='xbin_edges'
    find_string_pos,filename2,combined_string,pos; get the first header line position.
    ;read in the 2ds binedges and bin heights data
    records_c=400
    data=read_ascii(filename2,data_start=pos,Num_records=records_c)
    data=data.field1
    x2ds=data[0,0:records_c-1]
    y2ds=data[3,0:records_c-1]
end
;***************************************************

pro find_string_pos,filename,search_string,pos
    ;search_string='PDs =';'WYSIWYG:'
    ;filename='abcdefg.ascii'
    ; Note: the input search_tsring can be someting like this: 'abcd egfhj hhhh'
    result=read_ascii(filename,count=n_lines);   ;find out how many lines in the file.

    for i=2,n_lines-1 do begin
        result=read_ascii(filename,data_start=i-1,header=readed_line,num_records=1)
        ;skip i-1 lines, read in readed_line as header, and read 1 records.
        aa=readed_line(*,0)
        nn=n_elements(aa)
        last_line=readed_line(nn-1,*)
        last_line=strtrim(last_line,2);   ; take teh leading and tailing balnks away.

        ;print,readed_line; ;print,'aaaaaaaaaaaaa';;print,last_line;print,'*************'

        find = STRCMP(last_line, search_String, strlen(search_string), /FOLD_CASE)
        if (find eq 1) then begin
            pos=i-1
            break;   ;breakout of the for loop.
        endif else begin
            pos=0
        endelse
    endfor

    if pos eq 0 then begin
        print, 'Data line with ',search_string,' not found in file: ',filename
        ;stop
    endif;  print, pos
end; ;end of function find_string_pos.

;***********************************************************
;reading in CAPS data
pro read_caps_data,caps_data,xcaps,caps_binwidths
    ;read CAPS data file
    filter_str='MS*.txt'
    filename3=dialog_pickfile(filter=filter_str,path=pathnm,title='Pick a Caps psd MS*.txt file')
    data=read_ascii(filename3,count=n_lines)
    nnnseconds=(n_lines-51)/4
    junk=strarr(51)

    ;first get the bin edges and binwidths
    ;now reading in the xcaps values.
    combined_string='ice Water Content'
    find_string_pos,filename3,combined_string,pos; get the first header line position.
    data=read_ascii(filename3,header=headlines,data_start=pos,Num_records=1)
    ;there are 24 lines for bin_edges.
    xcaps=fltarr(48);  bin-edges
    widcaps=fltarr(24)
    for i=0,23 do begin
        n=(pos-25)+i
        line_N=headlines(n)
        substr1=strsplit(line_n,'(',/extract)
        substr2=strsplit(substr1(1),'um',/extract)
        substr3=strsplit(substr2(0),'-',/extract)
        xcaps(2*i)=substr3(0)*1.0
        xcaps(2*i+1)=substr3(1)*1.0
        widcaps(i)=substr3(1)*1.0-substr3(0)*1.0
    endfor
    caps_binwidths=widcaps

    ;now get the datas psd and time.
    openr,2,filename3
    readf,2,junk
    Data={seconds:0LL,$
        Hbin1:0.0,Hbin2:0.0,Hbin3:0.0,Hbin4:0.0,Hbin5:0.0,Hbin6:0.0,Hbin7:0.0,Hbin8:0.0,$
        Hbin9:0.0,Hbin10:0.0,Hbin11:0.0,Hbin12:0.0,Hbin13:0.0,Hbin14:0.0,Hbin15:0.0,Hbin16:0.0,$
        Hbin17:0.0,Hbin18:0.0,Hbin19:0.0,Hbin20:0.0,Hbin21:0.0,Hbin22:0.0,Hbin23:0.0,Hbin24:0.0,$
        iwc:0.0,area:0.0,extn:0.0,medVD:0.0 $
        }
    CAPs_Data=replicate(data,nnnseconds)
    readf,2,Caps_Data
    close,2
end; read_caps_data
;*******************************************************************

pro get_mean_psd_of_caps,time1,time2,Caps_data,caps_binwidths,xcaps,ycaps

    ;request times
    starttime=time1;   for this periods, caps don't see anything bigger than 10um.
    endtime  =time2;  is string format hh:mm:ss

    substr=strsplit(starttime,':',/extract)
    startseconds=substr(0)*3600LL+substr(1)*60LL+substr(2)*1LL

    substr=strsplit(endtime,':',/extract)
    endseconds=substr(0)*3600LL+substr(1)*60LL+substr(2)*1LL

    ;original data.
    seconds=caps_data.seconds
    index=where(seconds ge startseconds and seconds lt endseconds,contG)

    nnn=n_elements(index)
    ycaps=fltarr(24)
    time=lon64arr(nnn)
    caps_iwc=fltarr(nnn)
    caps_extn=fltarr(nnn)
    caps_area=fltarr(nnn)
    caps_medVD=fltarr(nnn)

    if contG gt 0 then begin
        time=seconds(index)
        Caps_iwc=Caps_data(index).iwc
        caps_extn=Caps_data(index).extn
        caps_area =Caps_data(index).area
        Caps_medVD=Caps_data(index).medVD

        ycaps(0)=mean(Caps_data(index).Hbin1)
        ycaps(1)=mean(Caps_data(index).Hbin2) 
        ycaps(2)=mean(Caps_data(index).Hbin3) 
        ycaps(3)=mean(Caps_data(index).Hbin4) 
        ycaps(4)=mean(Caps_data(index).Hbin5) 
        ycaps(5)=mean(Caps_data(index).Hbin6) 
        ycaps(6)=mean(Caps_data(index).Hbin7) 
        ycaps(7)=mean(Caps_data(index).Hbin8) 
        ycaps(8)=mean(Caps_data(index).Hbin9) 
        ycaps(9)=mean(Caps_data(index).Hbin10)
        ycaps(10)=mean(Caps_data(index).Hbin11)
        ycaps(11)=mean(Caps_data(index).Hbin12)
        ycaps(12)=mean(Caps_data(index).Hbin13)
        ycaps(13)=mean(Caps_data(index).Hbin14)
        ycaps(14)=mean(Caps_data(index).Hbin15)
        ycaps(15)=mean(Caps_data(index).Hbin16)
        ycaps(16)=mean(Caps_data(index).Hbin17)
        ycaps(17)=mean(Caps_data(index).Hbin18)
        ycaps(18)=mean(Caps_data(index).Hbin19)
        ycaps(19)=mean(Caps_data(index).Hbin21)
        ycaps(20)=mean(Caps_data(index).Hbin20)
        ycaps(21)=mean(Caps_data(index).Hbin22)
        ycaps(22)=mean(Caps_data(index).Hbin23)
        ycaps(23)=mean(Caps_data(index).Hbin24)
    endif else begin
        rrr=dialog_message('No caps data in this time interval',/information)
    endelse
    ycaps=ycaps/caps_binwidths
    ;make the ycaps to be double edgesvalues
    ycapsn=fltarr(48)
    for i=0,23 do begin
        ycapsn(2*i:2*i+1)=ycaps(i)
    endfor
    ycaps=ycapsn
end; get_mean_psd_of_caps,starttime,endtime,Caps_data,widcaps,xcaps,ycaps
;*****************************************************************************
