pro plot_2dsview_M1_psd_with_CAPS_psd

    ;select time period.
    time1='19:20:38';    this matched ave_start=10, end=13 data.
    time2='19:22:38'

    ;request times
    starttime=time1;   for this periods, caps don't see anything bigger than 10um.
    endtime  =time2;  is string format hh:mm:ss

    substr=strsplit(starttime,':',/extract)
    startseconds=substr(0)*3600LL+substr(1)*60LL+substr(2)*1LL

    substr=strsplit(endtime,':',/extract)
    endseconds=substr(0)*3600LL+substr(1)*60LL+substr(2)*1LL

    ;read in the whole data files:
    read_in_2ds_data_from_1Hz_archive,TDsData,pathnm
    read_caps_data,pathnm,caps_data,xcaps,caps_binwidths
    ;file1_end_time=max(TDsdata.seconds)
    file2_end_time=max(Caps_data.seconds)
    file1_end_time=file2_end_time
    max_seconds_of_the_2files=file1_end_time < file2_end_time

    ;get CPI psd from the selectled time period only.
    ;********************************************************************
    ;get_CPI_psd_from_selected_file,xcpi,ycpi
    ;*********************************************************************

    ;get the 2dsview M1 tethod psd from the saved.txt of PSD_cmp button.

    get_2dsview_M1_time1totime2_mean_psd,xpts,hypts,Vypts;  read it from 2dsview sav.txt file

    done=0

    while done eq 0 do begin

        ;get the 2ds data from time 1 to time 2 and Caps data from time 1 to time 2
        ;Get_2ds_time1totime2_TMS_mean_psd,startseconds,endseconds,TDsdata,$
        ;     time,Hconc,Hextn,Hiwc,Hmnsz,Hsv,Vconc,Vextn,VIWC,Vmnsz,Vsv,xpts,Hypts,Vypts
        ;get_2dsview_M1_time1totime2_mean_psd,xpts,hypts,Vypts;  readed from the 2dsview save.txt file.


        if max(hypts) ne 0.0 or max(vypts) ne 0.0 then Has_2ds=1 else Has_2ds=0

        ;get caps data
        get_mean_psd_of_caps,startseconds+30,endseconds+30,Caps_data,caps_binwidths,xcaps,ycaps
        if max(ycaps) ne 0.0 then has_caps=1 else has_caps=0

        ;get 2dsview saved.txt psds
        ;get_2dsview_psd_cmp_psd,x2ds,y2ds

        if has_caps eq 1 or has_2ds eq 1 then begin;  make the plot if there is data
            window,1,xs=300,ys=300;  300; 300
            loadct,0
            !P.thick=1
            !P.CHARSIZE=0.8
            !P.multi=[0,1,1]
            white=!D.N_COLORS-1
            !P.BACKGROUND=white

            index=where(hypts gt 0.0,contG)
            if contG gt 0 then begin
                hymin=min(hypts(index))
            endif else hymin=0.1

            index=where(Vypts gt 0.0,contG)
            if contG gt 0 then begin
                vymin=min(vypts(index))
            endif else vymin=0.1

            index=where(ycaps gt 0.0,contG)
            if contG gt 0 then begin
                ymincaps=min(ycaps(index))
            endif else ymincaps=0.1


            ymin=min([hymin,vymin,ymincaps])
            ymax=max([max(hypts),max(vypts),max(ycaps)])
            ymin=10.0^floor(Alog10(ymin))
            ymax=10.0^ceil(Alog10(ymax))

            PLOT, xpts, Hypts, COLOR=0, XRANGE=[1,1000], /Xlog,$
                Xstyle = 1, YLOG=1,xtitle='Particle Size(um)',$
                TITLE='PSD from CAPS & 2DS.1Hz Archive Data',$
                THICK=1, YRANGE=[ymin, ymax],ystyle=1, charsize=0.8,$
                YTITLE='#/L/um';  Yticks=ytikn,Ytickn=myticknames
            oplot,xcaps,ycaps,color=255
            oplot,xpts,Vypts,color=100,thick=1.3
            ;oplot,x2ds,y2ds,color=255
            xyouts,210,210,'Red Caps',color=255,/device
            xyouts,210,185,'Blck 2ds.H',color=0,/device
            xyouts,210,160,'Grey 2ds.V',color=100,/device
            ; oplot,xcpi,ycpi,color=160,thick=2.0

            ;label teh times
            Secs_To_Times,startseconds,Stime ; Stime is string
            Secs_To_Times,endseconds,Etime
            xyouts,125,265,Stime+' to '+Etime,color=0,/device
            str1=strjoin(strsplit(Stime,':',/extract))
            str2=strjoin(strsplit(Etime,':',/extract))
            outfilename=pathnm+'Caps_2ds_'+str1+'_'+str2+'_psd.png'
            write_png, outfilename,tvrd(true=1)

            ;doing the 2ds overlay plots of each second
            if 1 eq 2 then begin
                window,2,xs=300,ys=300,xpos=300,ypos=20

                index=where(hypts gt 0.0,contG)
                if contG gt 0 then begin
                    hymin=min(hypts(index))
                endif else hymin=0.1

                index=where(Vypts gt 0.0,contG)
                if contG gt 0 then begin
                    vymin=min(vypts(index))
                endif else vymin=0.1

                index=where(ycaps gt 0.0,contG)
                if contG gt 0 then begin
                    ymincaps=min(ycaps(index))
                endif else ymincaps=0.1


                ymin=min([hymin,vymin,ymincaps])
                ymax=max([max(hypts),max(vypts),max(ycaps)])
                ymin=10.0^floor(Alog10(ymin))
                ymax=10.0^ceil(Alog10(ymax))

                PLOT, xpts-5, Hypts, COLOR=0, XRANGE=[1,1000], /Xlog,$
                    Xstyle = 1, YLOG=1,xtitle='Particle Size(um)',$
                    TITLE='PSD from CAPS & 2DS.1Hz Archive Data',thick=2.3,$
                    YRANGE=[ymin, ymax],ystyle=1, charsize=0.8,$
                    YTITLE='#/L/um';  Yticks=ytikn,Ytickn=myticknames
                oplot,xcaps,ycaps,color=255,thick=2.3
                oplot,xpts-5,Vypts,color=100,thick=2.3
                ;oplot,x2ds,y2ds,color=255
                xyouts,210,210,'Red Caps',color=255,/device
                xyouts,210,185,'Blck 2ds.H',color=0,/device
                xyouts,210,160,'Grey 2ds.V',color=100,/device
                for i=0,29 do begin
                    Stime=startseconds+i
                    Etime=Stime+1
                    get_2ds_time1totime2_TMS_mean_psd,Stime,Etime,TDsdata,$
                        time,Hconc,Hextn,Hiwc,Hmnsz,Hsv,Vconc,Vextn,VIWC,Vmnsz,Vsv,xpts,Hypts,Vypts
                    oplot,xpts-5,Hypts,color=0
                endfor

                ;label the times
                Secs_To_Times,startseconds,Stime ; Stime is string
                Secs_To_Times,endseconds,Etime
                xyouts,125,265,Stime+' to '+Etime,color=0,/device
                str1=strjoin(strsplit(Stime,':',/extract))
                str2=strjoin(strsplit(Etime,':',/extract))
                outfilename=pathnm+'Caps_2ds_'+str1+'_'+str2+'_psd_Overlay.png'
                write_png, outfilename,tvrd(true=1)
            endif 
            if (startseconds gt 59109 and endseconds le 60309 ) or $
                (startseconds gt 65949 and endseconds le 67398 ) or $
                (startseconds gt 67929 and endseconds le 69549 ) or $
                (startseconds gt 61209 and endseconds le 61689 )  then begin
                wait_time=0.1
            endif else wait_time=2

            wait,wait_time

            ;if startseconds  eq 58929LL then stop
        endif; end of if there is data; has_caps=1 or has_2ds=1

        ; startseconds=endseconds
        ; endseconds=startseconds+30LL
        ; if endseconds gt max_seconds_of_the_2files then done=1
        done=1
    endwhile


    ;Ok, SO far the Hconc, Hypts Hextn, Hmass agrees with 2dsview comp_psd results.
end; end of plot_2ds_1Hz_mean_psd
;*************************************************
pro read_in_2ds_data_from_1Hz_archive,TDsData,pathnm
    filename=dialog_pickfile(filter='TD*.WB57',get_path=pathnm)
    ;find out how many line is in the file.
    data=read_ascii(filename,count=n_lines)
    nnnseconds=(n_lines-91)/8
    junk=strarr(91)
    openr,2,filename
    readf,2,junk
    Data={seconds:0LL,$
        Hconc:0.0,Hextn:0.0,HIWC:0.0,Hmnsz:0.0,Hsv:0.0,Vconc:0.0,Vextn:0.0,VIWC:0.0,Vmnsz:0.0,Vsv:0.0,$
        Hbin1:0.0,Hbin2:0.0,Hbin3:0.0,Hbin4:0.0,Hbin5:0.0,Hbin6:0.0,Hbin7:0.0,Hbin8:0.0,$
        Hbin9:0.0,Hbin10:0.0,Hbin11:0.0,Hbin12:0.0,Hbin13:0.0,Hbin14:0.0,Hbin15:0.0,Hbin16:0.0,$
        Hbin17:0.0,Hbin18:0.0,Hbin19:0.0,Hbin20:0.0,Hbin21:0.0,Hbin22:0.0,Hbin23:0.0,Hbin24:0.0,$
        Vbin1:0.0,Vbin2:0.0,Vbin3:0.0,Vbin4:0.0,Vbin5:0.0,Vbin6:0.0,Vbin7:0.0,Vbin8:0.0,$
        Vbin9:0.0,Vbin10:0.0,Vbin11:0.0,Vbin12:0.0,Vbin13:0.0,Vbin14:0.0,Vbin15:0.0,Vbin16:0.0,$
        Vbin17:0.0,Vbin18:0.0,Vbin19:0.0,Vbin20:0.0,Vbin21:0.0,Vbin22:0.0,Vbin23:0.0,Vbin24:0.0 $
        }
    TDsData=replicate(data,nnnseconds)
    readf,2,TDsData
    close,2
end; end of read_in_2ds_data_from_1Hz_archive.

pro Get_2ds_time1totime2_TMS_mean_psd,startseconds,endseconds,TDsdata,$
    time,Hconc,Hextn,Hiwc,Hmnsz,Hsv,Vconc,Vextn,VIWC,Vmnsz,Vsv,xpts,Hypts,Vypts

nseconds=(endseconds-startseconds)

hypts=fltarr(24)
vypts=fltarr(24)
;bins edges and widths
nbins=24
nedges=2*nbins
xpts=dblarr(2*nbins)
ptr = 0
for i =0, 8  DO BEGIN
    xpts[ptr] = double((i+1)*10)
    xpts[ptr + 1] = double((i+2) * 10)
    ptr += 2
endfor
xpts[18:47]=[10,12,12,15,15,20,20,25,25,32,32,40,40,50,50,60,60,70,70,80,80,90,90,100,100,120,120,140,140,1001]*10
widths=xpts(1:47)-xpts(0:46)
indexw=where(widths ne 0.0)
widths=widths(indexw)*0+1.0


;original data.
seconds=Tdsdata.seconds
index=where(seconds ge startseconds and seconds lt endseconds,contG)
if contG gt 0 then begin
    time=seconds(index)
    Hconc=TDsData(index).Hconc
    Hextn=TDsdata(index).Hextn
    HIWC =TDsdata(index).Hiwc
    Hmnsz=TDsdata(index).Hmnsz
    Hsv  =TDsdata(index).Hsv;    sample volumes of each second.
    Vconc=TDsData(index).Vconc
    Vextn=TDsdata(index).Vextn
    VIWC =TDsdata(index).Viwc
    Vmnsz=TDsdata(index).Vmnsz
    Vsv  =TDsdata(index).Vsv;    sample volumes of each second.

    indexgt0=where(Hconc gt 0.0, contG)
    if contG gt 0 then  svH=total(Hsv(indexgt0)) else svH=total(Hsv)
    indexgt0=where(Vconc gt 0.0, contG)
    if contG gt 0 then  svV=total(Vsv(indexgt0)) else svV=total(Vsv)

    ; note that TDSdata.Bin is #/L/um

    Hypts(0)=total(Hsv*TDsdata(index).Hbin1)/svH
    Hypts(1)=total(Hsv*TDsdata(index).Hbin2)/svH
    Hypts(2)=total(Hsv*TDsdata(index).Hbin3)/svH
    Hypts(3)=total(Hsv*TDsdata(index).Hbin4)/svH
    Hypts(4)=total(Hsv*TDsdata(index).Hbin5)/svH
    Hypts(5)=total(Hsv*TDsdata(index).Hbin6)/svH
    Hypts(6)=total(Hsv*TDsdata(index).Hbin7)/svH
    Hypts(7)=total(Hsv*TDsdata(index).Hbin8)/svH
    Hypts(8)=total(Hsv*TDsdata(index).Hbin9)/svH
    Hypts(9)=total(Hsv*TDsdata(index).Hbin10)/svH
    Hypts(10)=total(Hsv*TDsdata(index).Hbin11)/svH
    Hypts(11)=total(Hsv*TDsdata(index).Hbin12)/svH
    Hypts(12)=total(Hsv*TDsdata(index).Hbin13)/svH
    Hypts(13)=total(Hsv*TDsdata(index).Hbin14)/svH
    Hypts(14)=total(Hsv*TDsdata(index).Hbin15)/svH
    Hypts(15)=total(Hsv*TDsdata(index).Hbin16)/svH
    Hypts(16)=total(Hsv*TDsdata(index).Hbin17)/svH
    Hypts(17)=total(Hsv*TDsdata(index).Hbin18)/svH
    Hypts(18)=total(Hsv*TDsdata(index).Hbin19)/svH
    Hypts(19)=total(Hsv*TDsdata(index).Hbin21)/svH
    Hypts(20)=total(Hsv*TDsdata(index).Hbin20)/svH
    Hypts(21)=total(Hsv*TDsdata(index).Hbin22)/svH
    Hypts(22)=total(Hsv*TDsdata(index).Hbin23)/svH
    Hypts(23)=total(Hsv*TDsdata(index).Hbin24)/svH
    Vypts(0)=total(Vsv*TDsdata(index).Vbin1)/svV
    Vypts(1)=total(Vsv*TDsdata(index).Vbin2)/svV
    Vypts(2)=total(Vsv*TDsdata(index).Vbin3)/svV
    Vypts(3)=total(Vsv*TDsdata(index).Vbin4)/svV
    Vypts(4)=total(Vsv*TDsdata(index).Vbin5)/svV
    Vypts(5)=total(Vsv*TDsdata(index).Vbin6)/svV
    Vypts(6)=total(Vsv*TDsdata(index).Vbin7)/svV
    Vypts(7)=total(Vsv*TDsdata(index).Vbin8)/svV
    Vypts(8)=total(Vsv*TDsdata(index).Vbin9)/svV
    Vypts(9)=total(Vsv*TDsdata(index).Vbin10)/svV
    Vypts(10)=total(Vsv*TDsdata(index).Vbin11)/svV
    Vypts(11)=total(Vsv*TDsdata(index).Vbin12)/svV
    Vypts(12)=total(Vsv*TDsdata(index).Vbin13)/svV
    Vypts(13)=total(Vsv*TDsdata(index).Vbin14)/svV
    Vypts(14)=total(Vsv*TDsdata(index).Vbin15)/svV
    Vypts(15)=total(Vsv*TDsdata(index).Vbin16)/svV
    Vypts(16)=total(Vsv*TDsdata(index).Vbin17)/svV
    Vypts(17)=total(Vsv*TDsdata(index).Vbin18)/svV
    Vypts(18)=total(Vsv*TDsdata(index).Vbin19)/svV
    Vypts(19)=total(Vsv*TDsdata(index).Vbin20)/svV
    Vypts(20)=total(Vsv*TDsdata(index).Vbin21)/svV
    Vypts(21)=total(Vsv*TDsdata(index).Vbin22)/svV
    Vypts(22)=total(Vsv*TDsdata(index).Vbin23)/svV
    Vypts(23)=total(Vsv*TDsdata(index).Vbin24)/svV
endif else begin
    time=0
    ;Hypts=0.0
    ;Vypts=0.0; all other values are zero.
    rrr=dialog_message(' No 2DS data from this time period', /information)
endelse

;make Hypts and Vypts into horizontal and verticals.
hyptsn=fltarr(48)
vyptsn=fltarr(48)
for i=0,23 do begin
    hyptsn(2*i:2*i+1)=hypts(i)
    vyptsn(2*i:2*i+1)=vypts(i)
endfor
hypts=hyptsn
vypts=vyptsn

end; end of get_2ds_time1totime2_total_psd_from_1Hz_archive,filename,time1,time2,xpts,ypts
;*********************************************************************

pro get_2dsview_psd_cmp_psd,x2ds,y2ds
    ;read 2ds psd data file
    filter_str='PSD_CMP*.txt'
    filename2=dialog_pickfile(filter=filter_str,path=pathnm,title='Pick a 2ds psd PSD_CMP*.txt file')

    combined_string='xbin_edges'
    find_string_pos,filename2,combined_string,pos; get the first header line position.
    ;read in the 2ds binedges and bin heights data
    records_c=400
    data=read_ascii(filename2,data_start=pos,Num_records=records_c)
    data=data.field1
    x2ds=data[0,0:records_c-1]
    y2ds=data[3,0:records_c-1]
end
;***************************************************

pro find_string_pos,filename,search_string,pos
    ;search_string='PDs =';'WYSIWYG:'
    ;filename='abcdefg.ascii'
    ; Note: the input search_tsring can be someting like this: 'abcd egfhj hhhh'
    result=read_ascii(filename,count=n_lines);   ;find out how many lines in the file.

    for i=2,n_lines-1 do begin
        result=read_ascii(filename,data_start=i-1,header=readed_line,num_records=1)
        ;skip i-1 lines, read in readed_line as header, and read 1 records.
        aa=readed_line(*,0)
        nn=n_elements(aa)
        last_line=readed_line(nn-1,*)
        last_line=strtrim(last_line,2);   ; take teh leading and tailing balnks away.

        ;print,readed_line; ;print,'aaaaaaaaaaaaa';;print,last_line;print,'*************'

        find = STRCMP(last_line, search_String, strlen(search_string), /FOLD_CASE)
        if (find eq 1) then begin
            pos=i-1
            break;   ;breakout of the for loop.
        endif else begin
            pos=0
        endelse
    endfor

    if pos eq 0 then begin
        print, 'Data line with ',search_string,' not found in file: ',filename
        ;stop
    endif;  print, pos
end; ;end of function find_string_pos.

;***********************************************************
;reading in CAPS data
pro read_caps_data,pathnm,caps_data,xcaps,caps_binwidths
    ;read CAPS data file
    filter_str='MS*.WB57'
    filename3=dialog_pickfile(filter=filter_str,path=pathnm,title='Pick a Caps psd MS*.WB57 file')
    data=read_ascii(filename3,count=n_lines)
    nnnseconds=(n_lines-56)/5
    junk=strarr(56)

    ;first get the bin edges and binwidths
    ;now reading in the xcaps values.
    combined_string='ice Water Content'
    find_string_pos,filename3,combined_string,pos; get the first header line position.
    data=read_ascii(filename3,header=headlines,data_start=pos,Num_records=1)
    ;there are 24 lines for bin_edges.
    xcaps=fltarr(58);  bin-edges
    widcaps=fltarr(29)
    for i=0,28 do begin
        n=(pos-30)+i
        line_N=headlines(n)
        substr1=strsplit(line_n,'(',/extract)
        substr2=strsplit(substr1(1),'um',/extract)
        substr3=strsplit(substr2(0),'-',/extract)
        xcaps(2*i)=substr3(0)*1.0
        xcaps(2*i+1)=substr3(1)*1.0
        widcaps(i)=substr3(1)*1.0-substr3(0)*1.0
    endfor
    caps_binwidths=widcaps

    ;now get the datas psd and time.
    openr,2,filename3
    readf,2,junk
    Data={seconds:0LL,$
        Hbin1:0.0,Hbin2:0.0,Hbin3:0.0,Hbin4:0.0,Hbin5:0.0,Hbin6:0.0,Hbin7:0.0,Hbin8:0.0,$
        Hbin9:0.0,Hbin10:0.0,Hbin11:0.0,Hbin12:0.0,Hbin13:0.0,Hbin14:0.0,Hbin15:0.0,Hbin16:0.0,$
        Hbin17:0.0,Hbin18:0.0,Hbin19:0.0,Hbin20:0.0,Hbin21:0.0,Hbin22:0.0,Hbin23:0.0,Hbin24:0.0,$
        Hbin25:0.0,Hbin26:0.0,Hbin27:0.0,Hbin28:0.0,Hbin29:0.0,$
        iwc:0.0,area:0.0,extn:0.0,medVD:0.0 $
        }
    CAPs_Data=replicate(data,nnnseconds)
    readf,2,Caps_Data
    close,2
end; read_caps_data
;*******************************************************************

pro get_mean_psd_of_caps,startseconds,endseconds,Caps_data,caps_binwidths,xcaps,ycaps

    ;original data.
    seconds=caps_data.seconds
    index=where(seconds ge startseconds and seconds lt endseconds,contG)

    nnn=n_elements(index)
    ycaps=fltarr(29)
    time=lon64arr(nnn)
    caps_iwc=fltarr(nnn)
    caps_extn=fltarr(nnn)
    caps_area=fltarr(nnn)
    caps_medVD=fltarr(nnn)

    if contG gt 0 then begin
        time=seconds(index)
        Caps_iwc=Caps_data(index).iwc
        caps_extn=Caps_data(index).extn
        caps_area =Caps_data(index).area
        Caps_medVD=Caps_data(index).medVD

        ycaps(0)=mean(Caps_data(index).Hbin1)
        ycaps(1)=mean(Caps_data(index).Hbin2) 
        ycaps(2)=mean(Caps_data(index).Hbin3) 
        ycaps(3)=mean(Caps_data(index).Hbin4) 
        ycaps(4)=mean(Caps_data(index).Hbin5) 
        ycaps(5)=mean(Caps_data(index).Hbin6) 
        ycaps(6)=mean(Caps_data(index).Hbin7) 
        ycaps(7)=mean(Caps_data(index).Hbin8) 
        ycaps(8)=mean(Caps_data(index).Hbin9) 
        ycaps(9)=mean(Caps_data(index).Hbin10)
        ycaps(10)=mean(Caps_data(index).Hbin11)
        ycaps(11)=mean(Caps_data(index).Hbin12)
        ycaps(12)=mean(Caps_data(index).Hbin13)
        ycaps(13)=mean(Caps_data(index).Hbin14)
        ycaps(14)=mean(Caps_data(index).Hbin15)
        ycaps(15)=mean(Caps_data(index).Hbin16)
        ycaps(16)=mean(Caps_data(index).Hbin17)
        ycaps(17)=mean(Caps_data(index).Hbin18)
        ycaps(18)=mean(Caps_data(index).Hbin19)
        ycaps(19)=mean(Caps_data(index).Hbin21)
        ycaps(20)=mean(Caps_data(index).Hbin20)
        ycaps(21)=mean(Caps_data(index).Hbin22)
        ycaps(22)=mean(Caps_data(index).Hbin23)
        ycaps(23)=mean(Caps_data(index).Hbin24)
        ycaps(24)=mean(Caps_data(index).Hbin25)
        ycaps(25)=mean(Caps_data(index).Hbin26)
        ycaps(26)=mean(Caps_data(index).Hbin27)
        ycaps(27)=mean(Caps_data(index).Hbin28)
        ycaps(28)=mean(Caps_data(index).Hbin29)
    endif else begin
        rrr=dialog_message('No caps data in this time interval',/information)
    endelse
    ycaps=ycaps/caps_binwidths
    ;make the ycaps to be double edgesvalues
    ycapsn=fltarr(58)
    for i=0,28 do begin
        ycapsn(2*i:2*i+1)=ycaps(i)
    endfor
    ycaps=ycapsn
end; get_mean_psd_of_caps,starttime,endtime,Caps_data,widcaps,xcaps,ycaps
;*****************************************************************************
pro Secs_To_Times,secs,time

    temp=floor( long(secs)/(24l*3600l) )
    temp=long(secs)-temp*(24l*3600l)
    tempHH=floor( temp/3600l )
    temp=temp-tempHH*3600L
    tempMM=floor( temp/60l )
    tempSS=temp-tempMM*60L
    time=strtrim(long(tempHH),2)+':'+strtrim(long(tempMM),2)+':'+strtrim(long(tempSS),2)
end;******************

;**************************************************************************
pro get_CPI_psd_from_selected_file,xcpi,ycpi
    ;this subrountine get the cpi psd for the file only.

    filter_str='*psd*.txt'
    CPIfile=dialog_pickfile(filter=filter_str,get_path=pathnm,title='Pick a CPI psd *.txt file')
    filename1=CPIfile

    ;combined_string='CPI bin edges      CPI bin heights'
    combined_string="bin_edges #/Liter/um"
    find_string_pos,filename1,combined_string,pos; get the first header line position.
    data=read_ascii(filename1,data_start=pos, NUM_records=1) ;skip pos+1 line and reads in 1 line of data
    ;nline_comb=data.field1  ; convert data structure in to a vector result only one elements
    ;records_c=round(nline_comb(0))
    ;read in the fssp binedges and bin heights data
    ;data=read_ascii(filename1,data_start=pos+2,Num_records=records_c)
    records_c=8
    data=read_ascii(filename1,data_start=pos,Num_records=8)
    data=data.field1
    xcpi=data[0,0:records_c-1]
    ycpi=data[1,0:records_c-1]
    ;stop
end; get_CPI_psd_from_selected_file,xcpi,ycpi
;***************************************************************************
pro get_2dsview_M1_time1totime2_mean_psd,xpts,hypts,Vypts;  read it from 2dsview sav.txt file
    ;read 2ds psd data file
    filter_str='M125_PSD_CMP*.txt'
    filename2=dialog_pickfile(filter=filter_str,path=pathnm,title='Pick a 2ds psd PSD_CMP*.txt file')

    combined_string='xbin_edges'
    find_string_pos,filename2,combined_string,pos; get the first header line position.
    ;read in the 2ds binedges and bin heights data
    records_c=400
    data=read_ascii(filename2,data_start=pos,Num_records=records_c)
    data=data.field1
    xpts=data[0,0:records_c-1]
    Hypts=data[3,0:records_c-1]
    Vypts=data[4,0:records_c-1]
end; get_2dsview_M1_time1totime2_mean_psd,xpts,hypts,Vypts
;*********************************************************************************************
