; File:  read_HTime.pro
; Purpose:  scanspec.pro calls read_HTime3VCPI during main file read, for handling reading the HK data





pro write_HKLog, roi_frameheader_version, HKLUN, PlaneLUN, SBCLUN, SPP100LUN, hkData, extraData, WatchDogSBC, SPP100Set, SPP100Data

    ;scale data according to table 3
    c0= [1.8775,1.8775,1.8775,1.8775,1.8775,1.8775,1.8775,1.8775,1.8775,1.8775,1.8775,1.8775,1.8775,1.8775,-4.3326,-4.3326,-4.3326,-4.3326,$
        0.0,0.0,0.0,0.0,35.0,35.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0]

    c1 = [.02935559,.02935559,.02935559,.02935559,.02935559,.02935559,.02935559,.02935559,.02935559,.02935559,.02935559,.02935559,.02935559,.02935559,$
        .01493675,.01493675,.01493675,.01493675,.0177557,.00439451,.0177557,.00439451,.02050781,.02050781,.01478027,.002929269,.00735352,.00735352,$
        ;1.0,1.0,1.0,.000682667,.0073982,.000610352,.0073982,.000610352,.006427,.007995605,83.88e-9,1.0]
        1.0,1.0,1.0,.000682667,.0073982,1.0,.0073982,1.0,.006427,.007995605,83.88e-3,1.0]
    ;above c1 is the other version's c1  following c1 is for UAV with frameheader.version=40
    if roi_frameheader_version eq 40 then begin
        c1 = [.02935559,.02935559,.02935559,.02935559,.02935559,.02935559,.02935559,.02935559,.02935559,.02935559,.02935559,.02935559,.02935559,.02935559,$
            .01493675,.01493675,.01493675,.01493675,.0177557,.00439451,.0177557,.00439451,.02050781,.02050781,.01478027,.002929269,.00735352,.00735352,$
            1.0,1.0,1.0,.000341333,.0073982,1.0,.0073982,1.0,.006427,.007995605,83.88e-3,1.0]
    endif



    ;Note minimum transit time is output in units of microseconds

    ;perform scaling and combining
    readings = HKData.readings*c1 + c0

    ; write out data in columns
    formatStr = '(i8,x,i2,x,3(i8,x),28(f11.2,x), 3(i8,x),2(f8.4,x),i8,x,f8.4,x,i8,x,f8.4,x,f8.3,x,f9.3,2x,i8)'
    OutputString = STRING(hkData.time, hkData.ver,hkData.head,readings, format=formatStr)

    printf, HKLUN, OutputString

    IF (hkData.xtraSize gt 0) THEN BEGIN
        indx = WHERE(extraData EQ 1 OR extraData EQ 0 OR extraData EQ 10 OR extraData EQ 13, countFound)
        IF countFound GT 0 THEN extraData[indx] = 32

        PRINTF, PlaneLUN, STRING(FORMAT='(i15)', hkData.time) + " " + STRING(extraData)
    ENDIF

    IF N_TAGS(WatchDogSBC) GT 2 THEN BEGIN
        IF TAG_NAMES(WatchDogSBC, /STRUCT) EQ 'WATCHDOG_SBC_T' THEN BEGIN
            IF (fstat(SBCLUN)).SIZE LT 10 THEN PRINTF, SBCLUN,'Seconds of Year  SBC Version Name     Temp1    Temp2    Temp3    Temp4    Temp5 Pressure1 Pressure2'
            PRINTF, SBCLUN, FORMAT='(i15,2x,a16,2x,5(f8.4,x),2(f9.4,x))', hkData.time, STRING(WatchDogSBC.szVerName), WatchDogSBC.faTemps, WatchDogSBC.faPressures

        ENDIF ELSE IF TAG_NAMES(WatchDogSBC, /STRUCT) EQ 'WATCHDOG_SBC2_T' THEN BEGIN
            IF (fstat(SBCLUN)).SIZE LT 10 THEN PRINTF, SBCLUN,'Seconds of Year  SBC Version Name     Temp1    Temp2    Temp3    Temp4    Temp5 Pressure1 Pressure2   Volts1   Volts2   Volts3   Volts4'
            PRINTF, SBCLUN, FORMAT='(i15,2x,a16,2x,5(f8.4,x),2(f9.4,x),4(f8.4,x))', hkData.time, STRING(WatchDogSBC.szVerName), WatchDogSBC.faTemps, WatchDogSBC.faPressures, WatchDogSBC.faVolts
        ENDIF
    ENDIF

    IF N_TAGS(SPP100Data) GT 2 THEN BEGIN
        SPP100STRName = TAG_NAMES(SPP100Data, /STRUCT)
        IF (SPP100STRName EQ 'SPP100DATA_10CHAN_T') OR (SPP100STRName EQ 'SPP100DATA_20CHAN_T') OR $
            (SPP100STRName EQ 'SPP100DATA_30CHAN_T') OR (SPP100STRName EQ 'SPP100DATA_40CHAN_T') THEN BEGIN

            OPCChannels = (SIZE(SPP100Data.ulaOPCChan))[1]
            bSetPresent = !false
            IF N_TAGS(SPP100Set) GT 2 THEN IF TAG_NAMES(SPP100Set, /STRUCT) EQ 'SPP100SET_T' THEN bSetPresent = !true

            IF (fstat(SPP100LUN)).SIZE LT 10 THEN BEGIN
                Titles = 'Seconds of Year   CabinChan1  CabinChan2  CabinChan3  CabinChan4  CabinChan5  CabinChan6  CabinChan7  CabinChan8      RejDOF RejAvgTrans  AvgTransit    FIFOFull   ResetFlag ADCOverFlow'
                FOR i=1,OPCChannels DO BEGIN
                    ChannelTitle = STRING(FORMAT='(" OPCChannel",i2.2)', i)
                    Titles = Titles + ChannelTitle
                ENDFOR
                Titles = Titles + '    CheckSum'

                IF !true THEN BEGIN
                    Titles = Titles + '  Threshold  TransRej ChanCount    DOFRej     Range AvgTransW AttAccept   DivFlag CT_Method'
                    FOR i=1,40 DO BEGIN
                        ChannelTitle = STRING(FORMAT='(" OPCThresh",i2.2)', i)
                        Titles = Titles + ChannelTitle
                    ENDFOR
                    Titles = Titles + '  CheckSum'
                ENDIF

                PRINTF, SPP100LUN, Titles
            ENDIF

            FormatStr = '(i15,2x,14(i11,x),'
            IF NOT bSetPresent THEN BEGIN
                FormatStr = FormatStr + STRING(FORMAT='(i0,"(i12,x),i11)")', OPCChannels)
                PRINTF, SPP100LUN, FORMAT=FormatStr, hkData.time, SPP100Data.usaCabinChan, SPP100Data.ulRejDOF, SPP100Data.ulRejAvgTrans, SPP100Data.usAvgTransit, $
                    SPP100Data.usFIFOfull, SPP100Data.usResetFlag, SPP100Data.ulADCoverFlow, SPP100Data.ulaOPCChan, SPP100Data.cksum
            ENDIF ELSE BEGIN
                FormatStr = FormatStr + STRING(FORMAT='(i0,"(i12,x),i11,2x,9(i9,x),40(i11,x),i9)")', OPCChannels)
                PRINTF, SPP100LUN, FORMAT=FormatStr, hkData.time, SPP100Data.usaCabinChan, SPP100Data.ulRejDOF, SPP100Data.ulRejAvgTrans, SPP100Data.usAvgTransit, $
                    SPP100Data.usFIFOfull, SPP100Data.usResetFlag, SPP100Data.ulADCoverFlow, SPP100Data.ulaOPCChan, SPP100Data.cksum, $
                    SPP100Set.usThreshold, SPP100Set.usTransRej, SPP100Set.usChanCnt, SPP100Set.usDofRej, SPP100Set.usRange, SPP100Set.usAvgTransWeight, $
                    SPP100Set.usAttAccept, SPP100Set.usDivisorFlag, SPP100Set.usCtMethod, SPP100Set.usaOPCThreshold, SPP100Set.cksum
            ENDELSE
        ENDIF
    ENDIF
end



function read_Htime,fileUnit,filePos,vers, roi_frameheader_version, HKlun, PlaneLUN, SBCLUN, SPP100LUN, HKLOG_request,DTError,labelID

    ; assume we are at the start of a header block + 2
    ; and filePos contains the location of the start of the block ( i.e. 2 bytes back from current location )

    ; returns the housekeeping time as a long integer
    ; Note also that the filePos is updated to point to the next element in the file


    ; file pointer is pointing to the first field (the block mark), save the beginning file pointer

    case vers of
        30:HKData = {HKver30}
        25:HKData = {HKver25}
        20:HKData = {HKver20}
        else: begin
            ;r = dialog_message('Error...HK block version not supported',/error)
            if(labelID ne 0)then ShowMsg, labelID,'Error...HK block version not supported'
        end
    endcase

    ; position file pointer at beginning of block ( blockMark was read in calling function to get here
    point_lun,fileunit,filepos

    ; store beginning of block position
    begFpos = filepos

    ; read HK Block
    err = 1
    on_ioerror, skipit1
    READU, fileUnit, HKData

    err = 0
    skipit1:
    if(err)then begin
        print, 'Warning: read past end of file'
    endif

    ; Get the deadtime
    if HKData.Ver GE 25 then begin
        ; deadpos = 31     ; this is meant to be the 0-based index of the deadcnt value The first 5 fields of table 3 are stripped off by Carlos
        ; so advance pointer from beginning of block by 31*2 + 26 = 88
        deadtime = HKData.readings[31]

        if(deadtime gt 1464) and roi_frameheader_version ne 40 then begin
            msg='Deadtime Violation at time '+strtrim(HKData.time,2)+':' +strtrim(deadtime,2)+' changed to 1464'
            if(labelID ne 0) then ShowMsg, labelID,msg
            deadtime = 1464
            DTError = !true
        endif

        if(deadtime gt 2928) and roi_frameheader_version eq 40 then begin
            msg='Deadtime Violation at time '+strtrim(HKData.time,2)+':' +strtrim(deadtime,2)+' changed to 2928'
            if(labelID ne 0) then ShowMsg, labelID,msg
            deadtime = 2928
            DTError = !true
        endif

        PDSThresh45 = HKData.readings[33]
        PDSThresh90 = HKData.readings[35]
    endif else begin               ;older version
        print,'Not reading deadtime in this version'
        deadtime=0
        PDSThresh45 = 0
        PDSThresh90 = 0
    endelse

    ; read extra data if it is there
    if(HKData.XtraSize gt 0)then begin
        ; to make this usable, need format of the extra data as to type ( integer, float, string etc)
        ; then make a structure to match that format and read data into structure in place of extraData byte array
        extraData =bytarr(HKData.XtraSize)
        err = 1
        on_ioerror, skipit2
        readU,fileUnit,extraData
        err = 0
        skipit2:
        if(err)then begin
            print, 'Warning: read past end of file'
        endif

    endif

    ; place pointer at end of block
    if(vers gt 20)then FilePos = begFpos + HKData.itemSize + HKData.XtraSize else FilePos = begFpos + HKData.itemSize

    if(HKLOG_request)then BEGIN
        SPP100SetMark = FIX('B1B6'X)
        SPP100DataMark = FIX('C1C6'X)
        SBCDataMark = FIX('D1D6'X)
        BlockMark = 0
        ulBlockSize = 0L
        bDone = !false

        on_ioerror, skipit3
        ; Read SPP100, SBC, if present
        WHILE (NOT EOF(fileUnit) AND NOT bDone) DO BEGIN
            readU, fileUnit, BlockMark, ulBlockSize

            CASE 1 OF
                (BlockMark EQ SPP100SetMark): BEGIN
                    IF ulBlockSize EQ 110 THEN BEGIN
                        SPP100Set = {SPP100SET_t}
                        POINT_LUN, fileUnit, FilePos
                        readU, fileUnit, SPP100Set
                        FilePos = FilePos + ulBlockSize

                    ENDIF ELSE bDone = !true
                END

                (BlockMark eq SPP100DataMark): BEGIN
                    CASE 1 OF
                        (ulBlockSize EQ 84): SPP100Data = {SPP100DATA_10CHAN_t}
                        (ulBlockSize EQ 124): SPP100Data = {SPP100DATA_20CHAN_t}
                        (ulBlockSize EQ 164): SPP100Data = {SPP100DATA_30CHAN_t}
                        (ulBlockSize EQ 204): SPP100Data = {SPP100DATA_40CHAN_t}
                        ELSE: BEGIN
                            PRINT, 'Warning: unexpected block size while trying to read SPP100 DATA', ulBlockSize
                            bDone = !true
                        END
                    ENDCASE

                    IF (NOT bDone) THEN BEGIN
                        POINT_LUN, fileUnit, FilePos
                        readU, fileUnit, SPP100Data
                        FilePos = FilePos + ulBlockSize
                    ENDIF
                END

                (BlockMark eq SBCDataMark): BEGIN
                    IF ulBlockSize EQ 52 OR ulBlockSize EQ 68 THEN BEGIN
                        IF ulBlockSize EQ 52 THEN WatchDogSBC = {WATCHDOG_SBC_t} $
                            ELSE WatchDogSBC = {WATCHDOG_SBC2_t}

                        POINT_LUN, fileUnit, FilePos
                        readU, fileUnit, WatchDogSBC
                        FilePos = FilePos + ulBlockSize

                    ENDIF ELSE bDone = !true
                END

                ELSE: BEGIN
                    ;PRINT, BlockMark, FORM='("Warning: unexpected block mark while trying to read SPP100, and SBC Data: ", Z10.4)'
                    bDone = !true
                END
            ENDCASE
        ENDWHILE
        goto, HKLogLine

        skipit3:
        print, 'Warning: read past end of file trying to read SPP100, and SBC Data'

        HKLogLine:
        write_HKLog,roi_frameheader_version,HKLUN, PlaneLUN, SBCLUN, SPP100LUN, HKData, extraData, WatchDogSBC, SPP100Set, SPP100Data
    ENDIF

    ; NOTE: under normal conditions this step should not be needed.  In some cases, the HKblock read exceeds the length of the block
    Actualfilepos = (fstat(fileUnit)).cur_ptr
    if(filePos ne ActualFilePos)then begin
        ;print,(ActualFilePos-filePos)/2
        POINT_LUN, fileUnit, FilePos
        ;print,' Warning reading past end of HK block'
    endif

    return,{htime:HKData.time,fPos:begFPos,HouseSize:HKData.ItemSize + HKData.XtraSize,deadtime:deadtime,PDSThresh45:PDSThresh45,PDSThresh90:PDSThresh90}

end


function read_Htime3VCPI, fileUnit, filePos, vers, roi_frameheader_version, HKlun, PlaneLUN, SBCLUN, SPP100LUN, HKLOG_request, DTError, labelID

    ; assume we are at the start of a header block + 2
    ; and filePos contains the location of the start of the block ( i.e. 2 bytes back from current location )

    ; returns the housekeeping time as a long integer
    ; Note also that the filePos is updated to point to the next element in the file

    ; file pointer is pointing to the first field (the block mark), save the beginning file pointer

    HKData = {HKver3VCPI}  ; for 3vCPI ; only.
    ; position file pointer at beginning of block ( blockMark was read in calling function to get here
    point_lun, fileunit, filepos - 4

    ; store beginning of block position
    begFpos = filepos - 4

    ; read HK Block
    err = 1
    on_ioerror, skipit1
    READU, fileUnit, HKData

    err = 0
    skipit1:

    if(err)then begin
        print, 'Warning: read past end of file'
    endif

    ; Get the deadtime
    ; deadpos = 31     ; this is meant to be the 0-based index of the deadcnt value The first 5 fields of table 3 are stripped off by Carlos
    ; so advance pointer from beginning of block by 31*2 + 26 = 88
    deadtime = HKData.readings1[66]; Number of vertical overload Periods.

    if(deadtime gt 1464) and roi_frameheader_version ne 40 then begin
        msg='Deadtime Violation at time '+strtrim(HKData.time,2)+':' +strtrim(deadtime,2)+' changed to 1464'
        if(labelID ne 0) then ShowMsg, labelID,msg
        deadtime = 1464
        DTError = !true
    endif

    ;HKtime=HKdata.TimeMSW*16LL^8+HKdata.TimeISW*16LL^4+HKdata.TimeLSW
    ; slightly quicker way of doing the above statement, lacking the multiplication, note for some reason oring does not work correctly below
    HKtime = ishft(ulong64(HKdata.TimeMSW), 32) + ishft(ulong64(HKdata.TimeISW), 16) + ulong64(HKdata.TimeLSW)

    PDSThresh45 = HKData.readings1[33]
    PDSThresh90 = HKData.readings1[35]

    ; place pointer at end of block
    ;FilePos = begFpos + 2*HKData.itemSize;   there are 83 words. 166 Items in the block.

    if(HKLOG_request)then BEGIN
        SBCDataMark = FIX('D1D6'X)
        BlockMark = 0
        ulBlockSize = 0L
        bDone = !false

        on_ioerror, skipit3
        ; Read SPP100, SBC, if present
        WHILE (NOT EOF(fileUnit) AND NOT bDone) DO BEGIN
            readU, fileUnit, BlockMark, ulBlockSize

            CASE 1 OF
                (BlockMark eq SBCDataMark): BEGIN
                    IF ulBlockSize EQ 52 OR ulBlockSize EQ 68 THEN BEGIN
                        IF ulBlockSize EQ 52 THEN WatchDogSBC = {WATCHDOG_SBC_t} $
                            ELSE WatchDogSBC = {WATCHDOG_SBC2_t}

                        POINT_LUN, fileUnit, FilePos
                        readU, fileUnit, WatchDogSBC
                        FilePos = FilePos + ulBlockSize

                    ENDIF ELSE bDone = !true
                END

                ELSE: BEGIN
                    ;PRINT, BlockMark, FORM='("Warning: unexpected block mark while trying to read SPP100, and SBC Data: ", Z10.4)'
                    bDone = !true
                END
            ENDCASE
        ENDWHILE
        goto, HKLogLine

        skipit3:
        print, 'Warning: read past end of file trying to read SPP100, and SBC Data'

        HKLogLine:
        write_HKLog,roi_frameheader_version,HKLUN, PlaneLUN, SBCLUN, SPP100LUN, HKData, extraData, WatchDogSBC, SPP100Set, SPP100Data
    ENDIF

    ; NOTE: under normal conditions this step should not be needed.  In some cases, the HKblock read exceeds the length of the block
    ;    Actualfilepos = (fstat(fileUnit)).cur_ptr

    ;    if(filePos ne ActualFilePos)then begin

    ;        ;        print, actualfilepos
    ;        ;        print, filepos
    ;        ;        print, HKData.itemSize

    ;        ;        stop
    ;        ;print,(ActualFilePos-filePos)/2
    ;        POINT_LUN, fileUnit, FilePos
    ;        ;print,' Warning reading past end of HK block'

    ;    endif

    return,{htime:HKtime,fPos:begFPos+2,HouseSize:HKData.ItemSize,deadtime:deadtime,PDSThresh45:PDSThresh45,PDSThresh90:PDSThresh90}

end ; read_Htime3VCPI
