; define the frame header format for various file versions
pro frameheader25__define

    d = {frameheader25, BlockNum:0U,         $;Header Block Marker
        ItemSize:0UL,       $;Total bytes in this frame, including header
        Ver:0U,                $;Version number of this frame
        ROIsCount:0U,         $;number of ROI's in this frame
        TotROIsSize:0UL,     $;total bytes of IMAGE data including headers
        day:0B,            $;time of frame 1-31
        hour:0B,          $;time of frame 0-23
        minute:0B,          $;time of frame 0-59
        sec:0B,            $;time of frame 0-59
        msec:0U,          $;time of frame 0-999
        ImgType:0U,         $;bit array with data information
        sx:0U,             $;upper left X corner of image
        sy:0U,             $;upper left Y corner of image
        ex:0U,             $;lower right X corner of image
        ey:0U,             $;lower right Y corner of image
        BGRate:0U,          $;time between backgrounds in tenths of a second, 0 means no backgrounds
        BkgPDSThresh:0U,     $;number of machine strobes before a background can be collected
        FrmsProc:0UL,       $;total number of frames processed so far
        IThresh:0B,          $;image threshold 0-255, 0 means no thresholding done.
        ROIErr:0B,          $;ROI Rejection/Failure code
        ROIMinSize:0U,      $;min particle rejection size
        ROIAspect:0.0,      $;particle aspect criteria
        ROIFill:0.0,       $;min value for (#pixels within ROI threshold)/# pixels in ROI)
        ROIFCount:0UL,      $;# pixels within ROI above threshold
        ImgMean:0B,          $;image mean value
        BkgMean:0B,          $;background mean value
        Spare1:0,          $;unused
        ROIXPad:0U,          $;width of border around sides of particle in pixels
        ROIYPad:0U,          $;width of border around top/bottom of particle in pixels
        StrobeCount:0UL,     $;Probe's strobe count per image
        FrmsSaved:0UL,        $;number of frames saved to disk so far
        ImgMinVal:0B,         $;min image mean for an acceptable frame
        ImgMaxVal:0B,         $;max image mean for an acceptable frame
        ROIsSaved:0UL,      $;total number of ROI's saved so far
        ChkSum:0U,          $;checksum
        PDSHead:UINTARR(3),   $;PDS data block; Time:0UL
        Time:0UL,             $;seconds of year
        ArrivalT1:0U,         $;arrival time ???
        ArrivalT2:0U,         $;arrival time ???  These are the 3 words of the new 3VCPI
        TransitT:0U,        $;transit time ???  /;  Change to be particle Number on april 2
        Missed:0U,          $;number of particles missed while processor is busy
        PHeight1:0U,        $;??
        PHeight2:0U,        $;?? Note: header file only has one of these listed!!
        PDSChkSum:0U,         $;check sum
        ProbeMode:0U}          ;probe mode
end

pro frameheader23__define

    d = {frameheader23, BlockNum:0U,         $;Header Block Marker
        ItemSize:0UL,       $;Total bytes in this frame, including header
        Ver:0U,           $;Version number of this frame
        ROIsCount:0U,         $;number of ROI's in this frame
        TotROIsSize:0UL,     $;total bytes of IMAGE data
        day:0B,            $;time of frame 1-31
        hour:0B,          $;time of frame 0-23
        minute:0B,          $;time of frame 0-59
        sec:0B,            $;time of frame 0-59
        msec:0U,          $;time of frame 0-999
        ImgType:0U,         $;bit array with data information
        sx:0U,             $;upper left X corner of image
        sy:0U,             $;upper left Y corner of image
        ex:0U,             $;lower right X corner of image
        ey:0U,             $;lower right Y corner of image
        BGRate:0U,          $;time between backgrounds in tenths of a second, 0 means no backgrounds
        UpdateRate:0U,        $
        XFerRate:0U,        $
        HouseRate:0U,         $
        IThresh:0B,          $;image threshold 0-255, 0 means no thresholding done.
        ROIErr:0B,          $;ROI Rejection/Failure code
        ROIMinSize:0U,      $;min particle rejection size
        ROIAspect:0.0,      $;particle aspect criteria
        ROIFill:0.0,       $;min value for (#pixels within ROI threshold)/# pixels in ROI)
        ROIFCount:0UL,      $;# pixels within ROI above threshold
        ImgMean:0B,          $;image mean value
        ImgDelta:0U,        $
        ROIXPad:0U,          $;width of border around sides of particle in pixels
        ROIYPad:0U,          $;width of border around top/bottom of particle in pixels
        FRLine:0U,          $
        FROffset:0U,        $
        FRSkip:0B,          $
        ADCGain:0B,          $
        ImgMinVal:0U,         $
        ImgMaxVal:0U,         $
        Aspect:0.0,          $
        ChkSum:0U,          $;checksum
        PDSHead:UINTARR(3),   $;PDS data block
        ArrivalT1:0U,         $;arrival time ???
        ArrivalT2:0U,         $;arrival time ???
        TransitT:0U,        $;transit time ???
        Missed:0U,          $;number of particles missed while processor is busy
        PHeight1:0U,        $;??
        PHeight2:0U,        $;?? Note: header file only has one of these listed!!
        PDSChkSum:0U,         $;check sum
        ProbeMode:0U}          ;probe mod
end

pro frameheader21__define

    d = {frameheader21, BlockNum:0U,         $;Header Block Marker
        ItemSize:0UL,       $;Total bytes in this frame, including header
        Ver:0U,           $;Version number of this frame
        ROIsCount:0U,         $;number of ROI's in this frame
        TotROIsSize:0UL,     $;total bytes of IMAGE data
        day:0B,            $;time of frame 1-31
        hour:0B,          $;time of frame 0-23
        minute:0B,          $;time of frame 0-59
        sec:0B,            $;time of frame 0-59
        msec:0U,          $;time of frame 0-999
        ImgType:0U,         $;bit array with data information
        sx:0U,             $;upper left X corner of image
        sy:0U,             $;upper left Y corner of image
        ex:0U,             $;lower right X corner of image
        ey:0U,             $;lower right Y corner of image
        BGRate:0U,          $;time between backgrounds in tenths of a second, 0 means no backgrounds
        UpdateRate:0U,        $
        XFerRate:0U,        $
        HouseRate:0U,         $
        IThresh:0B,          $;image threshold 0-255, 0 means no thresholding done.
        ROIErr:0B,          $;ROI Rejection/Failure code
        ROIMinSize:0U,      $;min particle rejection size
        ROIAspect:0.0,      $;particle aspect criteria
        ROIFill:0.0,          $;min value for (#pixels within ROI threshold)/# pixels in ROI)
        ROIFCount:0UL,      $;# pixels within ROI above threshold
        ImgMean:0B,          $;image mean value
        ImgDelta:0U,      $
        ROIXPad:0U,          $;width of border around sides of particle in pixels
        ROIYPad:0U,          $;width of border around top/bottom of particle in pixels
        FRLine:0U,          $
        FROffset:0U,        $
        FRSkip:0B,          $
        ADCGain:0B,          $
        ADCMax:0U,          $
        ADCMin:0U,          $
        TransitT:0U,        $
        ArrivalT1:0U,         $;arrival time ???
        ArrivalT2:0U,         $;arrival time ???
        PHeight1:0U,        $;??
        PHeight2:0U,        $;?? Note: header file only has one of these listed!!
        Scatter:UINTARR(28),  $
        P:0B,           $
        Missed:0U,          $;number of particles missed while processor is busy
        PDSChkSum:0U,         $;check sum
        Aspect:0.0,        $
        ProbeMode:0U,         $;probe mode}
        ProbeSetts:UINTARR(25)}
end

pro imageheader21_Define

    d = {imageheader21, BlockMark:0U,   $
        ROIInfoSize:0UL,   $
        ROIVer:21U,       $
        sx:0U,        $
        sy:0U,        $
        ex:0U,        $
        ey:0U,        $
        PixBytes:0,    $
        Flags:0U,   $
        Len:0.0,     $
        SLen:0UL,   $
        ELen:0UL,   $
        Wid:0.0,     $
        SWid:0UL,   $
        EWid:0UL,   $
        Dark:0U}; this field is called usROIDepth in header

end

pro imageheader25__Define

    d = {imageheader25, BlockMark:0U,   $
        ROIInfoSize:0UL,$
        ROIVer:25U,       $
        sx:0U,        $
        sy:0U,        $
        ex:0U,        $
        ey:0U,        $
        PixBytes:0,    $
        Flags:0U,   $
        Len:0.0,     $
        SLen:0UL,   $
        ELen:0UL,   $
        Wid:0.0,     $
        SWid:0UL,   $
        EWid:0UL,   $
        Dark:0U,     $; this field is called usROIDepth in header
        Area:0.0,   $
        Perim:0.0}
end

pro imageheader30__Define

    d = {imageheader30, BlockMark:0U,   $
        ROIInfoSize:0UL,$  ; this is variable because of the last two fields in the header and the data size
        ROIVer:30U,       $ ; should be 30
        sx:0U,        $ ; upper left corner X of image in full frame co-ords
        sy:0U,        $ ; upper left corner Y of image in full frame co-ords
        ex:0U,        $ ; lower right corner X of image in full frame co-ords
        ey:0U,        $ ; lower right corner Y of image in full frame co-ords
        PixBytes:0U,   $    ; if this is zero, no image data is included!
        Flags:0U,   $   ; contains info about crstal type, focus, reject and manual parameters
        Len:0.0,     $    ; length of major axis in pixels
        SLen:0UL,   $   ; 1D index of length vector start point in Sub-array coords
        ELen:0UL,   $   ; 1D index of length vector stop point in Sub-array coords
        Wid:0.0,     $    ; lenght of axis perpendicular to major axis in pixels
        SWid:0UL,   $   ; 1D index of width vector start point in Sub-array coords
        EWid:0UL,   $   ; 1D index of width vector start point in Sub-array coords
        Dark:0U,     $    ; this field is called usROIDepth in header, contains depth and cutoff info
        Area:0.0,   $   ; computed area   in pixels
        Perim:0.0,     $  ; computed perimeter in pixels
        Centroid:[0.,0.],$ ; Centroid of particle ( 2 elements )
        Roundness1:0.0, $   ; Measure of particle roundness using the area vs circle area
        X_Moment:0.0,  $    ; 1/2 area on each side of vert line
        Y_moment:0.0,  $    ; 1/2 area on each side of horiz line
        Rubber_Band:0.0,$  ; Measure of boundary roughness
        Fractal_dim:0.0,$  ; Fractal dimension
        Harmonic_len:0UL,$ ; Number of elements in Harmonic array
        Bound_len:0UL, $   ; Number of elements in Boundary array
        Sample_period:0.0,$    ; Sample period of harmonic array in pixels
        Focus:0B,   $   ; % focus 0-100. This is the average focus value for multiple samples along the particle boundary
        FocusMin:0B,   $ ; Min % focus of samples taken
        FocusMax:0B,   $ ; Max % focus of samples taken
        FocusStdDev:0.0,$  ; Standard deviation of focus samples taken
        FocusGoodSamples:0B,$; Percent of samples which yielded valid focus values: 0 - 100
        CutOff:0B,     $  ; % particle is cut-off 0 - 100
        Crystal:0B,       $ ; Scalar type index meaning TBD
        Confidence:0B, $   ; Factor assessing confidence in particle use 0-10
        P1:0.0,         $     ; used in manualFeature as input of status of manual setting, sent by view_event
        Roundness2:0.0,         $   ; Roundness 2, stddev of distances to centroid
        Roundness3:0.0,         $   ; Roundness 3, ratio of perimeter angles total to expected
        P4:0.0,         $    ; Place holder
        Harmonics:ptr_new(),$  ; Circular harmonics of boundary(var. len)
        Boundary:ptr_new()}    ; Location of boundary pixels in ROI array ( 1D indicies) (var. len)

end



;*******************************************************************************************************************

; Assumed overall file structure
; {HouseKeeping}{HouseKeeping}{HouseKeeping}{ImageData}{ROIIMG}{ROIIMG}{ROIIMG}{ROIIMG}{HouseKeeping}{HouseKeeping}{HouseKeeping}{HouseKeeping}...{HouseKeeping}...
; where the number of HK blocks varies, each ImageData block specidfies how many ROIIMG blocks will follow, each holding and ROI image.

; a frame is defineds as an ImageData header block, and its associated ROIIMG blocks


function read_frame,FileUnit,ImgDataVer,fPos, get_obj= get_obj, nodata = nodata, date=date, TSBlanked=TSBlanked

; routine to read image frames
; Parameters
;   fileunit: Input      open and valid logical file unit to read from
;   ImgDataVer:   Input        file version number from PIFileheader
;   fPos:     Input       position of image in file

;Keywords
;   noData       Input Flag       if defined, do not read ROI data
;   TSBlanked Input flag   if true, set missed = 1

;   Return value
;     structure of form {FrameHeader:FrameHeader,pFrame:pFrame}
;     where
;      FrameHeader is a structure containing the frame header information. See above definitions
;      pFrame is a pointer to a array of structures containing the particle information.  the form is
;      {ImageHeader:ImageHeader, pROI:PTR_NEW(/allocate)}
;      where
;          ImageHeader is described above
;          pROI points to an array containing the actual particle data

if(fpos lt 80)then BEGIN
    print,'Error in fpos'
    return,-1
endif

; set file pointer to the correct location from the info in scanList for the first frame
point_lun,FileUnit,fPos
; stop
;create data structure for roi image
CASE ImgDataVer OF
    25:frameheader = {frameheader25}
    23:frameheader = {frameheader23}
    21:frameheader = {frameheader21}
    else: BEGIN
        stop
        IF ImgDataVer GT 30 THEN frameheader = {frameheader25} $
            ELSE r = dialog_message('Frame version not supported',/error)
    END
endcase

; read the frame header
; readu,FileUnit,FrameHeader;  for 3V cpi.  The number to read is only valid until Roisaved and Checksum.
; to read the Htime, ArrivalT1 and ArrivalT2,  This 3 numbers has to be moved to
; other places;  see following block of code.
;added this on Setember 1m, 2009.
HTime = 0U;  Now here come the 3 words of the Time since the probe was turned on.
ArrivalT1 = 0U;   one word is 2 byte.   (AF,CD)
ArrivalT2 = 0U;   0U is one word.
point_lun,FileUnit,fPos+84
readu,FileUnit,Htime,ArrivalT1,arrivalT2

word1=strtrim(string(format='(Z4)',HTime),2)
if strlen(word1) eq 3 then word1='0'+word1
if strlen(word1) eq 2 then word1='00'+word1
if strlen(word1) eq 1 then word1='000'+word1


word1_a=strmid(word1,0,2)
word1_b=strmid(word1,2,2)
timeLsW=word1_a+word1_b


; add this to read teh Particle ID number on April 18, 2010.
; read the Number of particles first.
Particles_numbers=0U
HTrigParticleNumbers=0U
VtrigParticleNumbers=0U
readu,FileUnit,Particles_numbers, HtrigParticleNumbers,VtrigParticleNumbers

;if timeLsW eq 'FEA3' then begin

;         word4=strtrim(string(format='(Z4)',HtrigParticleNumbers),2)
;         if strlen(word4) eq 3 then word4='0'+word4
;         if strlen(word4) eq 2 then word4='00'+word4
;         if strlen(word4) eq 1 then word4='000'+word4

;      print, TimeLSW, ' ',word4

;      stop

;    end


; return to original file positiion
point_lun,FileUnit,fPos

readu,FileUnit,FrameHeader
; assigned the readed values 3 newtime words to frame_header
frameHeader.time=Htime
frameHeader.ArrivalT1=ArrivalT1
frameHeader.ArrivalT2=ArrivalT2
frameHeader.Pheight1=HtrigParticleNumbers;  added on April 18th 2010.
frameHeader.Pheight2=VtrigParticleNumbers;  added on April 18th 2010.

h2ds_partID = string(format='(%"0x%04x")', string(HtrigParticleNumbers))
v2ds_partID = string(format='(%"0x%04x")', string(VtrigParticleNumbers))

; print, ""
; print, "(read_frame) h2ds_partID ", h2ds_partID
; print, "(read_frame) v2ds_partID ", v2ds_partID

;**********************************  end modifying the reading 3VCPI  **********************

; corrects problem with background frames total strobe reading
if(frameHeader.Missed eq 0)then frameHeader.Missed = 1

if(not keyword_set(date))then r = dialog_message('error in read_frame ... no date',/error)
;print, frameheader.missed
; corrects error in missed for early version of data
if(date.year le 1999 and date.month le 11 and date.day le 30 and frameHeader.missed gt 200)then begin
    frameHeader.missed = frameHeader.missed - 256

endif

; correct missed after a background
if(keyword_set(TSBlanked))then begin
    if(TSBlanked )then frameHeader.missed =1
endif

if(FrameHeader.Ver eq 26) then FrameHeader.Ver = 30

case FrameHeader.Ver of
    21:ImageHeader = {imageheader21}
    23:ImageHeader = {imageheader21} ;??? are there changes in this version???
    25:ImageHeader = {imageheader25}
    30:ImageHeader = {imageheader30}
    else: BEGIN
        ;stop
        IF FrameHeader.Ver GT 30 THEN begin
            ImageHeader = {imageheader25}
            ;ELSE r = dialog_message('Frame version not supported',/error)
        endif ELSE begin
            ;r = dialog_message('Frame version not supported , return -1 to skip the frame (mo temporary fix)',/error)
            print, "Frame version not supported or frame corrupted, return empty frame to temporary fix it by Mo on 2014-02-18--Attrex)"
            ImageHeader = {imageheader25}
            FrameHeader.ROIsCount = 0
            Frame = {ImageHeader:ImageHeader, pROI:PTR_NEW()}
            pFrame = ptr_new()
            return, {FrameHeader:FrameHeader,pFrame:pFrame}
        endelse
    ENDelse
endcase

; Create a pointer to an array of structures to hold the data for this frame
Frame = {ImageHeader:ImageHeader, pROI:PTR_NEW()}
if(FrameHeader.ROIsCount gt 0)then begin

    catch, error_status

    if(error_status ne 0) then begin ; free memory and try again
        print, "Freeing Heap Memory....."
        heap_gc
        print, "Done Freeing Memory, processing resumed"
    endif

    pFrame = ptr_new(replicate(Frame, FrameHeader.ROIsCount)) ; TAF crashed here on file ICET23_very_small_subset\07231436.roi, out of memory to allocate array
    ptr_free,frame.pROI
    Pad = [FrameHeader.ROIXPad,FrameHeader.ROIYPad]

    ; read all the roi images, return data in pointer to array of structures
    read_rois, FileUnit, Pad, pFrame, nodata = nodata

endif else pFrame = ptr_new()


; we return the full frame header directly and the image header plus roi data in a pointer to an array
return,{FrameHeader:FrameHeader,pFrame:pFrame}
end

