PRO DecompressImageMo, image_data, image, WordCount, Slices, area, L2, L4, L5, Midpoint,alexei1
    image = BytArr(128L, Slices)

    ; TAF found an odd size for an image array, which should always be even, putting in a ;stop
    ; the odd size was caused by a bad copy into my test program, and should not be encountered
    ; in normal operation.  Still, this ;stop should be left in to help debug if an odd Image is
    ; ever encountered.

    if(Slices eq 0) then begin
        print, "Slices equals 0, stopping in ProcessParticle in a2DSView.pro"
        help, Wordcount, Slices
        stop
    endif

    ; decompress image
    ; image should be wordcount words long

    image_data_size = 2L * long(wordcount)
    image_size = long(!PIXELS) * long(slices)

    current_wordcount = 0L
    current_slices    = 0L

    current_slice = -1L
    current_pixel =  0L

    dptr = 0L

    max_shaded_bits = 0 ; L2, most shaded bits in a slice
    max_slice_width = 0 ; L4, the widest single slice

    ; used for the entire particle, can calculate L5, the max width of the particle across all slices
    first_shaded_bit = !PIXELS
    last_shaded_bit = -1

    total_shaded_pixels = 0L

    edges = 0

    total_bits = 0L
    shaded_bits = 0L
    clear_bits = 0L

    image[*] = byte(255) ; for now, at this point, 255 is clear, 0 is shaded
    image2 = bytarr(!PIXELS, slices)

    retval = 0
    done   = 0

    this_slice_width = 0 ; TAF had a crash where this wasn't defined

    ; image decompression loop
    while(~done) do begin
        if((current_wordcount ge wordcount) or (current_slices ge slices)) then begin
            done = 1
            break
        endif

        ; reorder the bytes in the word
        ;t = ishft(fix(image_data[dptr + 1]), 8) or fix(image_data[dptr]); this combines the 160 and 64 to get  (Word1 16544) =64*2^8 +160
        t =image_data(dptr)
        ;So from here , it is obiview that there is no need to break the words into two byets and then combine it again.
        dptr += 1L
        current_wordcount++

        if((t and '4000'X) ne 0) then begin ; 0x4000 start of a slice
            current_slices++
            total_bits = 0L

            this_slice_width = 0
            this_slice_first_shaded_bit = !PIXELS

            current_slice++ ; TAF why two current_slice++ in here???
            current_pixel = 0L

            if(current_slices ge slices) then begin
                if slices eq 1 then begin
                    ;uncompresss the image.
                    clear_bits = t and '7F'X  ; '7F'X=0111,1111
                    shaded_bits = ishft(t, -7) and '7F'X
                    total_bits += clear_bits + shaded_bits
                    total_shaded_pixels += shaded_bits
                    if(shaded_bits gt 0) then begin
                        this_slice_first_shaded_bit = clear_bits
                        this_slice_width = shaded_bits
                        max_slice_width = this_slice_width;  ; for L4, the widest slice
                        first_shaded_bit = this_slice_first_shaded_bit       ; for L5, total width of particle
                    endif
                    ; add to image
                    current_pixel += clear_bits
                    start_shade = current_pixel
                    end_shade = start_shade + shaded_bits - 1

                    if(start_shade lt !PIXELS and end_shade ge start_shade and end_shade lt !PIXELS) then begin ; color the image pixels
                        if(start_shade eq end_shade) then begin
                            image[ start_shade, current_slice] = byte(0)
                            image2[start_shade, current_slice] = byte(1)
                        endif else begin
                            image[ start_shade:end_shade, current_slice] = byte(0)
                            image2[start_shade:end_shade, current_slice] = byte(1) ; used to fill Bimage below
                        endelse
                    endif

                    if(end_shade gt last_shaded_bit) then begin ; for L5, total width of particle
                        last_shaded_bit = end_shade
                    endif

                    if(shaded_bits gt max_shaded_bits) then begin ; for L2, the most shaded bits in a slice
                        max_shaded_bits = shaded_bits

                        midpoint = (end_shade - start_shade) / 2 + start_shade ; for PC1, the L2 midpoint, note that this will be the center of the longest section of shaded bits
                    endif

                    if(start_shade eq 0) then begin ; touching first edge
                        edges or= '2'X ; image touching first edge flag (pixel 0 shaded)
                    endif

                    if(end_shade eq !PIXELS - 1) then begin ; touching last edge
                        edges or= '1'X ; image touching last edge flag (pixel 127 shaded)
                    endif
                    current_pixel += shaded_bits
                endif
                break ; exit while loop to avoid accessing outside allocated image
            endif

            if(t eq '7FFF'X) then begin ; 0x7FFF is the flag for 128 clear bits in 2D-S, should never see this
                clear_bits = long(!PIXELS)
                shaded_bits = 0L

                uncompress   = 0
                add_to_image = 0

                ;stop
            endif else if(t eq '4000'X) then begin ; 0x4000 is defined as 128 shaded bits
                clear_bits = 0L
                shaded_bits = long(!PIXELS)

                uncompress   = 0
                add_to_image = 1
            endif else begin
                shaded_bits = 0L
                clear_bits = 0L

                uncompress   = 1
                add_to_image = 1
            endelse
        endif else begin ; continue decompressing a slice
            if(current_slice eq -1) then begin
                print, "no start of slice detected, trying to advance...."
                current_slice++

                uncompress   = 0
                add_to_image = 0

                ;stop
            endif else begin
                uncompress   = 1
                add_to_image = 1
            endelse
        endelse

        if(uncompress) then begin
            clear_bits = t and '7F'X
            shaded_bits = ishft(t, -7) and '7F'X
        endif

        total_bits += clear_bits + shaded_bits

        if(total_bits gt !PIXELS) then begin ; slice size exceeded error, skip to next slice
            ;print, "slice size exceeded error, truncating slice"

            if(clear_bits gt !PIXELS) then begin
                clear_bits = !PIXELS
                shaded_bits = 0
            endif else begin
                shaded_bits = !PIXELS - clear_bits
            endelse

            total_bits = !PIXELS
        endif

        total_shaded_pixels += shaded_bits

        if(shaded_bits gt 0) then begin
            if(this_slice_width eq 0) then begin ; store the first bit this slice, also could use current_pixel eq 0L
                this_slice_first_shaded_bit = clear_bits
                this_slice_width = shaded_bits
            endif else begin
                this_slice_width += clear_bits + shaded_bits
            endelse

            if(this_slice_width gt max_slice_width) then begin ; for L4, the widest slice
                max_slice_width = this_slice_width
            endif

            if(clear_bits eq 0 and current_pixel ne 0L) then begin
                ; would have to handle adding shaded bits to the equivalent of potential_contiguous_shaded_bits

                print, "clear_bits eq 0 and current_pixel =", current_pixel ; can be first edge pixel, are there other cases?
                ;stop
            endif

            if(this_slice_first_shaded_bit lt first_shaded_bit) then begin ; for L5, total width of particle
                first_shaded_bit = this_slice_first_shaded_bit
            endif
        endif

        if(add_to_image) then begin
            current_pixel += clear_bits

            start_shade = current_pixel
            end_shade = start_shade + shaded_bits - 1

            if(start_shade lt !PIXELS and end_shade ge start_shade and end_shade lt !PIXELS) then begin ; color the image pixels
                if(start_shade eq end_shade) then begin
                    image[ start_shade, current_slice] = byte(0)
                    image2[start_shade, current_slice] = byte(1)
                endif else begin
                    image[ start_shade:end_shade, current_slice] = byte(0)
                    image2[start_shade:end_shade, current_slice] = byte(1) ; used to fill Bimage below
                endelse
            endif

            if(end_shade gt last_shaded_bit) then begin ; for L5, total width of particle
                last_shaded_bit = end_shade
            endif

            if(shaded_bits gt max_shaded_bits) then begin ; for L2, the most shaded bits in a slice
                max_shaded_bits = shaded_bits
                midpoint = (end_shade - start_shade) / 2 + start_shade ; for PC1, the L2 midpoint, note that this will be the center of the longest section of shaded bits
            endif

            if(start_shade eq 0) then begin ; touching first edge
                edges or= '2'X ; image touching first edge flag (pixel 0 shaded)
            endif

            if(end_shade eq !PIXELS - 1) then begin ; touching last edge
                edges or= '1'X ; image touching last edge flag (pixel 127 shaded)
            endif

            current_pixel += shaded_bits
        endif
    endwhile ; image decompression loop

    area = total_shaded_pixels;       use index=where(out_byet_array eq 0, Area) to get  total_shade_pixels

    L2 = max_shaded_bits ; L2, most shaded bits in a slice
    L4 = max_slice_width ; L4, the widest single slice
    L5 = last_shaded_bit - first_shaded_bit + 1 ; L5, the max width of the particle across all slices

    ;*************************************************************
    ;find Dmax, Dspot Dring
    AreaContour=0;       % area inside the contour
    for ni=0,127 do begin
        index=where(image(ni,*) eq 0,contG); %find the numbers of all ones in the column "ni"
        if contG gt 0 then AreaContour=AreaContour+index(contG-1)-index(0)+1 ;else Dmaxi(ni)=0
    endfor

    ;rotate the image 90 degree and repeat above
    AreaContour90=0;       % area inside the contour
    for ni=0,Slices-1 do begin
        index=where(image(*,ni) eq 0,contG); %find the numbers of all zeros in the column "ni"
        if contG gt 0 then AreaContour90=AreaContour90+ index(contG-1)-index(0)+1; else Dmaxi(ni)=0
    endfor
    alexei1=areacontour90 > areaContour;   max([areacontour90,areaContour])
    ;**********************************************************************

End;  End of DecompressImage














;@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
pro Spec_GraphClick_browse, event
    forward_function SPEC_seconds2HMS
    Widget_Control, event.top, Get_UValue=ptr, /No_Copy  ; get our info structure

    if ptr_valid(ptr) eq 0 then begin
        Widget_Control, event.top, Set_UValue=ptr, /No_Copy
        return
    endif

    if (*ptr).click_a_point eq 1 then begin

        (*ptr).click_a_point=0;   prevent clikcing and motion event forever. Do it just one  time.
        (*ptr).next =0
        cursor,x,y,/data,/down

        if n_elements(x) eq 1 then begin
            (*ptr).StartTime=round(x)*1LL
            (*ptr).nanoseconds =(*ptr).startTime*1000000000LL

            hh=  (*ptr).StartTime/3600
            mm=((*ptr).StartTime mod 3600)/60
            ss=round( (*ptr).StartTime mod 60  )
            widget_control,(*ptr).StartHoursID,set_value=hh
            widget_control,(*ptr).StartminutesID,set_value=mm
            widget_control,(*ptr).StartsecondsID,set_value=ss

            HKdata=*((*ptr).pHKdata)
            seconds=max( HKdata.Nanoseconds/1000000000LL)
            hh= seconds/3600LL
            mm=(seconds mod 3600)/60LL
            ss=(seconds mod 60  )
            widget_control,(*ptr).EndHoursID,set_value=hh
            widget_control,(*ptr).EndminutesID,set_value=mm
            widget_control,(*ptr).EndsecondsID,set_value=ss
            marknumber=1
            plot_HK_data_to_the_mainbrowse_window,ptr,marknumber
        endif

    endif


    if !zoom_state eq 1 then begin
        cursor,x,y,/data,/down
        if n_elements(x) eq 1 then begin
            (*ptr).EndTime=round(x)*1LL
            hhmmss=spec_seconds2HMS((*ptr).EndTime)
            hh=strmid(hhmmss,0,2)*1
            mm=strmid(hhmmss,3,2)*1
            ss=strmid(hhmmss,6,2)*1
            widget_control,(*ptr).EndHoursID,set_value=hh
            widget_control,(*ptr).EndminutesID,set_value=mm
            widget_control,(*ptr).EndsecondsID,set_value=ss
            marknumber=2
            plot_HK_data_to_the_mainbrowse_window, ptr,marknumber
            !zoom_state=0
        endif

    endif;!Zoom_State eq 1

    if !Zoom_State eq 2 then begin
        cursor,x,y,/data,/down
        if n_elements(x) eq 1 then begin
            (*ptr).StartTime=round(x)*1LL
            hhmmss=spec_seconds2HMS((*ptr).StartTime)
            hh=strmid(hhmmss,0,2)*1
            mm=strmid(hhmmss,3,2)*1
            ss=strmid(hhmmss,6,2)*1
            widget_control,(*ptr).StartHoursID,set_value=hh
            widget_control,(*ptr).StartminutesID,set_value=mm
            widget_control,(*ptr).StartsecondsID,set_value=ss
            marknumber=1
            plot_HK_data_to_the_mainbrowse_window, ptr,marknumber
            !zoom_state=1

        endif
    endif; !Zoom_State eq 2

    Widget_Control, event.top, Set_UValue=ptr, /No_Copy

end ;== PSD_graphicclick====================================================================

pro get_N_bit12_bit14_and_bit15,NH,NV,HorV,Nwords,bit12_timingword_found,bit14_next_particle_cutoff,bit15_over_load
    ;bit0to11:      is number of words including timeing words if present.
    ;bit12: 1 if timeword not found.
    ;bit14: 1 Fifo empty meaning next particle was cut off.
    ;bit15: 1 the last two words are overload timing words.

    if NH eq 0 then begin
        Ninput=NV & HorV='V'
    endif

    if NV eq 0 then begin
        Ninput =NH & HorV='H'
    endif

    if NH ne 0 and NV ne 0 then  begin;  problem here , because one of them must be 0.  it does happen.
        Nwords=2
        bit12_timingword_found       = -1
        bit14_next_particle_cutoff   = -1
        Bit15_over_load              = -1
    endif else begin
        Nwords                       = Ninput and ('0FFF'X); ;=0000,1111, 1111, 1111. if Ninput=32=100000,  ishft(32,5)=1,00000,00000=2^10=1024.
        bit12_timingword_found       = Ninput and ('1000'X);  =0001,0000, 0000, 0000.
        bit14_next_particle_cutoff   = Ninput and ('4000'X);  =0100,0000, 0000, 0000.
        Bit15_over_load              = Ninput and ('8000'X);  =1000,0000, 0000, 0000.
    endelse
end;  get_N_bit12_bit14_and_bit15,NV,N,bit12_timingword_found,bit14_next_particle_cutoff,bit15_over_load

;*****************************************************
pro  Process_1Hz_and_images_from_T1on,info
    Common  DataBlock,alldataH,alldataV,ADataH,ADataV,FirstData,LastData,StripData,FirstDataV,LastDataV,StripDataV,OneHzH,OneHzV
    Common  HKdatablock,HKseconds,HKtas,num_hrz_dect,num_vrt_dect,pHKtimefpos,H50micron
    Common  DataBlock3,PHdata,PVdata,Hpc,Vpc

    infile=info.currentFname
    basefile=file_basename(infile)
    pathnm  =info.Pathname

    this_year=strmid(basefile,4,2)*1
    this_year=round(2000+this_year)
    next_year=this_year+1

    openr,lun,infile,/get_lun

    Timestamp0={year:0,month:0,dw:0,day:0,hour:0,minute:0,second:0,milisec:0};  ; that is alos a word.
    datablock=intarr(2049);   ; int is a word.

    remaining_data=0

    ;find the bfpos and efpos and then start reading the file and processin.
    seconds=(*pHKtimefpos).seconds
    filepos=(*pHKtimefpos).fpos

    index=where( seconds ge (5+info.nanoseconds/1000000LL),contG)
    if contG ge 1 then begin
        bfpos=filepos(index(0))
    endif else begin
        return
    endelse


    point_lun,lun,bfpos


    WHILE  (info.full eq 0 ) and ~Eof(lun) DO BEGIN

        ReadU, lun, Timestamp0,Datablock;  Timestamp can be the same for adjecnet blocks.
        point_lun,-lun,pos;  pos is double times the datablock length.  after reading Timestamp0 datablock, pos=4114.

        ;looking for image frames.  18507 is HK marker.  12883 is Images Marker.  20044 is "NULL" Marker. 19787 is "Mask"
        ;%19787 = "MK", 20044 = "NL", 12883 = "2S"   HKPossible=find(data(1:2057)==18507); %18507 is ascii 'HK'
        ;for example a datablock may look like this:
        ;12883 0   4         13           2       16588 16716  296    20476        12883  4   0   1   2  16677 16549     296   20496   18507     706
        ; 2S   NH  NV   13th-Vparticle  Nslice    word1 word2  time1  time2           2S                                                HK
        ; word1 and word2 tells how that slice is made.   bit15=0 indicates that is is an images word. bit14=1 indicates the start of a slice.
        ;                                                                                              bit14=0 indicates the continue of a slice.
        ;                                                 bit7to bit13 are number of shaded pixles. (bit 13 is most significal Bit MSB)
        ;                                                 bit0 to 6 is number of clear pixles. (bit 6 is msb).
        ;                                                 0x7fff=128 clear bits.   0x4000 =128 set bits.
        ; word1  bits of 16-31 of the clock counter.  word2  bits 0 to 15 of the counter.   negatiive number -16723 is block end-mark. =datablock(2048).

        ; if data has been maksed
        ; datablock will be like:  0 19787 0  1 -1 -1 -1 .....19410 11968 19410 11968  12883 0 5046=NV.  NV is too Big.  Not Good.
        if remaining_data(0) eq 12883 then begin
            pos=pos-2
            special_set=[remaining_data,datablock]
            process_next_image_data,Timestamp0,special_set,0,next_i,remaining_data,info
            remaining_data=0
            Start_index=1
        endif else Start_index=0


        if remaining_data(0) eq 0 then begin
            for i=Start_index, n_elements(datablock)-2 do begin

                if datablock(i) eq 12883 then begin;     TwoDS_marker then begin
                    process_next_image_data,Timestamp0,datablock,i,next_i,remaining_data,info
                    i=next_i
                    if remaining_data(0) ne 0  then break;  % break this for loop to read in new data.
                    goto, nextI
                endif

                if datablock(i) eq 18507 then begin; HK_marker then begin
                    i=i+52;   next_i=(i+52+1)  is either a MK, or NL or 2S marker.  House Keeping data block is 52 words long.
                    if i gt n_elements(datablock)-1LL then break;  % brek out this for loop.
                    goto, nextI
                endif

                if datablock(i) eq 19787 and (datablock(i+1) eq -1 or datablock(i+1) eq 0 )then begin;  MK_marker then begin
                    i=i+16;     there 8 0s or -1s for H-channel and 8 0s or -1s for V-channel.
                    if i gt n_elements(datablock)-1LL then break
                    goto, nextI
                endif

                if datablock(i) eq 20044 then begin; NULL_marker then begin
                    break;  if it is a NL marker, all of the data in the rest of the blcok are 0s, skip and read and process next datablock.
                endif
                nextI:  ; do nothing.
            endfor
        endif

    ENDWHILE

    Close ,lun
    Free_Lun, lun

end; end of mainprogram.

;******************************************************************************

pro  process_next_image_data,Timestamp0,datablock,i,next_i,remaining_data,info
    this_index=i
    remaining_data=0

    if this_index+1 eq n_elements(datablock)-1  then begin
        Next_i=0
        remaining_data=datablock(This_index:n_elements(datablock)-2)
        return
    endif


    NH            =datablock(this_index+1)

    if this_index+2 eq n_elements(datablock)-1  then begin
        Next_i=0
        remaining_data=datablock(This_index:n_elements(datablock)-2)
        return
    endif


    NV            =datablock(this_index+2);   this_index+3 is total_nuber of detected particle count. No imprtance in here.
    if NV eq 0  and NH  eq 0      then begin
        next_i=i+2
        return
    endif



    if NV ne 0  and NH  ne 0 then begin
        next_i=i+2
        return
    endif

    if NH lt 0 or NV lt 0 then  begin
        Next_i=i+4
        return
    endif


    if this_index + 4LL ge n_elements(datablock)-1 then begin
        Next_i=i+4
        remaining_data=datablock(This_index:n_elements(datablock)-2)
        return
    endif

    ;Particle_count=datablock(this_index+3)
    Slices        =datablock(this_index+4);  number of slice in this particle.

    get_N_bit12_bit14_and_bit15,NH,NV,HorV,N,bit12_timingword_found,bit14_next_particle_cutoff,bit15_over_load

    if this_index + N +4 ge n_elements(datablock)-1 then begin
        Next_i=i+N+4
        ;save the leftover array and return it to the main call.
        remaining_data=datablock(This_index:n_elements(datablock)-2)
        return
    endif

    word1_index=this_index+N+3
    word2_index=this_index+N+4

    word1=datablock(word1_index)
    word2=datablock(word2_index);  65536=2LL^16
    if word2 lt 0 then begin
        word2=65536+word2
    endif
    probecounter=long64(word1)*2LL^16+long64(word2)

    if word1 lt 0 then begin
        probecounter =probecounter +long64(2LL^32)
    endif


    if bit15_over_load eq 32768 then begin
        ;it is overload, N=2, overload Time.
        return
    endif

    wordcount=N-2;        ; N includs two timing words.

    if wordcount eq 0 then begin;   slices=0
        next_i=i+N+4
        return
    endif

    image_words=datablock((this_index+5):(this_index+5+wordcount-1));  old way: Vimage=bytarr(wordcounts*2); Vimage=imagewords.
    ; it is found that if pos=8228, and this_index=0;  it should be point_lun, lun, 8228-4114 + 2*6 +2*5 to read the image words correctly.

    ; note that slices should be equal or less than number of words ?


    if Slices le 0 or slices ge 1000 then begin
        next_I=i+N+4
        return;   do process particles, of 0 slices.
    endif

    next_I=i+N+4

    DecompressImageMo, Image_words, out_byte_array, WordCount, Slices, area, L2, L4, L5,midpoint,alexei1

    dimg=rotate(out_byte_array,1)
    my_text_string=strtrim(string(timestamp0.hour),2)+':'+strtrim(string(timestamp0.minute),2)+':'+strtrim(string(timestamp0.second),2)+'.'+strtrim(string(timestamp0.milisec),2);  +SPEC_Nano2HMS(OD.nanoseconds)
    dispsize=size(dimg,/dimension)
    nanoseconds=1000000000LL*(3600LL*timestamp0.hour +60LL*timestamp0.minute +timestamp0.second)+1000000LL*timestamp0.milisec

    disp_images_to_my_image_window, info,HorV,dimg,dispsize,my_text_string,nanoseconds,Timestamp0


end;  process_next_image_data,pos,Timestamp0,datablock,i,image_data,next_i

;******************************************************************************
;******************************************************************************
pro disp_images_to_my_image_window,info,HorV,dimg,dispsize,my_text_string,nanoseconds,timestamp

    year=strtrim(string(timestamp.year),2);      ;'20'+strmid(plot_string2,5,2)
    if timestamp.month lt 10 then begin
        month='0'+strtrim(string(timestamp.month),2);;     strmid(plot_string2,7,2)
    endif else begin
        month=strtrim(string(timestamp.month),2);;     strmid(plot_string2,7,2)
    endelse
    ;day=strtrim(string(timestamp.day),2);;       strmid(plot_string2,9,2)
    if timestamp.day lt 10 then begin
        day='0'+strtrim(string(timestamp.day),2);;     strmid(plot_string2,7,2)
    endif else begin
        day=strtrim(string(timestamp.day),2);;     strmid(plot_string2,7,2)
    endelse
    date_time_string=year+'/'+month+'/'+day; '2006/02/01 '

    This_nano_second=nanoseconds
    TimeText_1 = my_text_string
    TimeText_1_time =This_nano_second

    info.StartTimeH=This_nano_second
    info.TimeText_1H=TimeText_1

    info.EndTime =This_nano_second/1000000000LL
    info.nanoseconds =This_nano_second

    time0=timetext_1
    info.Time0H=Time0; This keep a record of the first particle time of the new page ? or line.


    if HorV eq 'H' then begin
        widget_control,info.drawIDH,get_value=wid
        wset, wid

        blacK_rect=bytarr(300,20);  ; this black rectangular to show the time stamp of the last image.
        tv,black_rect,100,0
        xyouts,0.2,0.012,'H  '+date_time_string+'---'+TimeText_1,color=[255,255,255],/normal

        if info.currentXH+dispsize(0) lt 600 and info.currentYH ge 150 then begin; fill in the image.
            ;!strip_height=128; pixels

            TV,dimg,info.currentXH +2, info.currentYH-128
            info.currentXH=info.currentXH + dispsize(0)+2
            if info.currentXH ge 600 and info.currentYH le 130 then begin
                info.full=1
            endif else info.full=0
            return
        endif


        if info.currentXH+dispsize(0) ge 600 and info.currentYH gt 156 then begin; start a new line of images..
            ;!strip_height=128; pixels
            info.currentXH=0;  start a new line of images.
            TV,dimg,info.currentXH +1, info.currentYH-128*2
            info.currentXH=info.currentXH + dispsize(0)+2
            info.currentYH=info.currentYH -128
            if info.currentXH ge 600 and info.currentYH le 156 then begin
                info.full=1
            endif else info.full=0
            return
        endif


        if info.currentYH le 156 and info.currentXH+dispsize(0) ge 600 then begin; screen is full  start a new scree=n.
            info.full=1
            return
        endif


        if info.currentYH lt 40  then begin; screen is full  start a new scree=n.
            info.full=1
            return

        endif

        if info.full eq 1  then begin; screen is full  start a new scree=n.
            stop

            info.currentXH=0
            info.currentYH=550;  6*128  six ines =768.   52 pixl left after 6 lines of images.
            TV,dimg,info.currentXH +2, info.currentYH-128
            info.currentXH=info.currentXH + dispsize(0)+2
            return
        endif
    endif;  end of if HorV eq 'H'


    if HorV eq 'V' then begin
        widget_control,info.drawIDV,get_value=wid
        wset, wid

        blacK_rect=bytarr(300,20)
        tv,black_rect,100,0
        xyouts,0.2,0.01,'V  '+date_time_string+'---'+TimeText_1,color=[255,255,255],/normal

        if info.currentXV+dispsize(0) lt 600 and info.currentYV ge 150 then begin; fill in the image.
            ;!strip_height=128; pixels

            TV,dimg,info.currentXV +2, info.currentYV-128
            info.currentXV=info.currentXV + dispsize(0)+2
            if info.currentXV ge 600 and info.currentYV le 156 then begin
                info.full=1
            endif else info.full=0
            return
        endif


        if info.currentXV+dispsize(0) ge 600 and info.currentYV gt 156 then begin; start a new line of images..
            ;!strip_height=128; pixels
            info.currentXV=0;  start a new line of images.
            TV,dimg,info.currentXV +1, info.currentYV-128*2
            info.currentXV=info.currentXV + dispsize(0)+2
            info.currentYV=info.currentYV -128
            if info.currentXV ge 600 and info.currentYV le 156 then begin
                info.full=1
            endif else info.full=0
            return
        endif


        if info.currentYV le 156 and info.currentXV+dispsize(0) ge 600 then begin; screen is full  start a new scree=n.

            info.full=1
            return
        endif


        if info.currentYV lt 40  then begin; screen is full  start a new scree=n.
            info.full=1
            return

        endif

        if info.full eq 1  then begin; screen is full  start a new scree=n.
            stop
            erase
            info.currentXV=0
            info.currentYV=550;  6*128  six ines =768.   52 pixl left after 6 lines of images.
            TV,dimg,info.currentXV +2, info.currentYV-128
            info.currentXV=info.currentXV + dispsize(0)+2
            return
        endif
    endif;  end of if HorV eq 'V'


end; end of output_pngs_images_pages
;*****************************************************

;***********************************************************
pro a3vcpiview_browse_image_event,event
    Common  DataBlock,alldataH,alldataV,ADataH,ADataV,FirstData,LastData,StripData,FirstDataV,LastDataV,StripDataV,OneHzH,OneHzV
    Common  HKdatablock,HKseconds,HKtas,num_hrz_dect,num_vrt_dect,pHKtimefpos,H50micron
    Common  DataBlock3,PHdata,PVdata,Hpc,Vpc

    forward_function archive_ice_pop_up

    widget_control,event.top,get_uvalue=ptr,/no_copy
    widget_control, event.id,get_uvalue=uval


    sname = TAG_NAMES(event, /STRUCTURE_NAME)

    case sname of

        'WIDGET_KILL_REQUEST':begin
        widget_control, event.top,set_uvalue=ptr,/no_copy
        widget_control, event.top, /destroy
        return
    end
    else:
endcase

case uval of
    'Next_page':begin ; reset the traces to be default traces.
    ;!startTime=(*ptr).nanoseconds/1000000LL;   this is milisecond  to compare with HK time stamp.
    (*ptr).next=1
    (*ptr).full=0
    widget_control, (*ptr).DrawIDH,get_value=wid
    wset,wid
    erase,color='ffffff'x ;    ; get background to white

    widget_control, (*ptr).DrawIDV,get_value=wid
    wset,wid
    erase,color='ffffff'x ;    ; get background to white
    ;Display_images_from_T1_on,*ptr
    Process_1Hz_and_images_from_T1on,*ptr
    marknumber=2
    plot_HK_data_to_the_mainbrowse_window,ptr,marknumber

    (*ptr).full=1
    (*ptr).currentXH=0
    (*ptr).currentXV=0
    (*ptr).currentYH=540
    (*ptr).currentYV=540
    widget_control, (*ptr).DrawID,get_value=wid;  must set this  window again so that the click a point will work.
    wset,wid
end

'Click_a_point': begin
    (*ptr).click_a_point=1
    (*ptr).full=0
    widget_control, (*ptr).DrawIDbrowse,get_value=wid;  Mo has to set this draw_widget ID to front for it to work.
    wset,wid
end

'zoom': begin
    !ZOOM_STATE = 2  ; once activate, user must select 2 point to go into a zoom for the Start Time and End Time.
    widget_control, (*ptr).DrawIDbrowse,get_value=wid;  Mo has to set this draw_widget ID to front for it to work.
    wset,wid
    marknumber=0
    plot_HK_data_to_the_mainbrowse_window, ptr,marknumber
end

'zoomout': begin
    (*ptr).EndTime=max(HKseconds)
    hhmmss=spec_seconds2HMS((*ptr).EndTime)
    hh=strmid(hhmmss,0,2)*1
    mm=strmid(hhmmss,3,2)*1
    ss=strmid(hhmmss,6,2)*1
    widget_control,(*ptr).EndHoursID,set_value=hh
    widget_control,(*ptr).EndminutesID,set_value=mm
    widget_control,(*ptr).EndsecondsID,set_value=ss

    (*ptr).StartTime=min(HKseconds)
    hhmmss=spec_seconds2HMS((*ptr).StartTime)
    hh=strmid(hhmmss,0,2)*1
    mm=strmid(hhmmss,3,2)*1
    ss=strmid(hhmmss,6,2)*1
    widget_control,(*ptr).StartHoursID,set_value=hh
    widget_control,(*ptr).StartminutesID,set_value=mm
    widget_control,(*ptr).StartsecondsID,set_value=ss
    marknumber=0
    plot_HK_data_to_the_mainbrowse_window, ptr,marknumber
    widget_control, (*ptr).DrawIDbrowse,get_value=wid;  Mo has to set this draw_widget ID to front for it to work.
    wset,wid
end


'T1T2': begin
    (*ptr).T1T2=1
    (*ptr).AllTimes=0
end


'ALL-Times': begin
    (*ptr).T1T2=0
    (*ptr).AllTimes=1
end


'ice':begin
(*ptr).ice=1
(*ptr).liq=0
end


'liq':begin
(*ptr).ice=0
(*ptr).liq=1
end

'1Hz': begin
    if  (*ptr).OneHz eq 1 then (*ptr).oneHz=0 else (*ptr).oneHz=1
end

'pngs': begin
    if (*ptr).png  eq 1 then (*ptr).png=0 else (*ptr).png=1
end

'DoIt': begin
    DoBasescan1StepForall,ptr ; pressing DoIt without having mouse selected an end time exits prematurely
end
'ShowImg': begin
    if !showImg eq 0 then !showImg=1 else  !showImg=0
end

'showHK': begin
    currentFname =(*ptr).currentFname
    pHKdata=(*ptr).PHKdata
    a3vcpiview_showHKdata_of_the_basefile,pHKdata,currentFname
end


else:
endcase
widget_control,event.top,set_uvalue=ptr,/no_copy;  put the info back to xmanager; must use no_copy so that the call9ng subroutine will work right away.
end;  ;end of event handler
;****************************************************

pro a3vcpiview_browse_image,info

    ; this is to browse 2DS images at any tim epoints to get a feel of the clouse passes.
    ; when cursor is click at a point, images at that point are show, click next will show images
    ; after that point.
    defsysv,'!showimg',0;   let user choose if the to display or not display teh images when playing back the base fie. not display will be faster.

    title_str='Browsing images at different points and batch processing all data files in selected time interval with option.'
    ;*********************** do oFFhand_no_button_programs;************************
    ; ;stop;  Do_Alexeis_Zd_distribution_plots, ave_info,HorV
    ;*********************************************************************************
    ;create top level base
    tlb=widget_base(title=title_str,/column,xsize=800,ysize=11*72+40,xoffset=200,/TLB_KILL_REQUEST_EVENTS); 780 changed to 800.
    ;the above tiltle_str can be changed later in the plots.
    L1base=widget_base(tlb,/row);   ;xoffset to place in offset the computer screen.
    ;timetext=widget_text(L1base,xsize=25,ysize=1,value=time_periods); time_period='aaa'
    helpnote=widget_button(L1base,value='Help',uvalue='Help')
    imagebase=widget_base(L1base,/row,/frame)

    Click_a_point  =widget_button(imagebase,value='Click a Point To browse Images',$
        TOOLTIP="Click on the data area to browse images from that point on.", $
        uvalue='Click_a_point')



    Next_page  = WIDGET_BUTTON( imagebase, $
        FONT='9x15', $
        UVALUE='Next_page', $
        XSIZE=35, $
        TOOLTIP="Single Step Forward", $
        VALUE= 'SingleF.bmp', /BITMAP)

    ;FastForward = WIDGET_BUTTON(imagebase, $
    ;                            FONT='9x15', $
    ;                            UVALUE='FastForward', $
    ;                            XSIZE=40, $
    ;                            TOOLTIP="Play fast Forwards", $
    ;                            VALUE=  'FF.bmp', /BITMAP)

    label1=   widget_label(L1base,value='Options:')

    sortbase=widget_base(L1base,/row,/frame)
    label1=widget_label(sortbase,value='T1: Day',FONT = 'ARIEL*BOLD*14')
    SStrDay             = cw_field(sortbase,title='',value=0,/int,xsize=2,uvalue ='startDay',/all)
    StartHoursID        = cw_field(sortbase,title=':',value=0,/int,xsize=2,uvalue ='starthh',/all)
    StartMinutesID      = cw_field(sortbase,title=':',value=0,/int,xsize=2,uvalue ='startmm',/all)
    StartSecondsID      = cw_field(sortbase,title=':',value=0,/int,xsize=2,uvalue ='startss',/all)

    ;sbutton=widget_button(b311,value='|',uvalue='ST0')
    label2=widget_label(sortbase,value='T2: Day',FONT = 'ARIEL*BOLD*14')
    EStrDay            = cw_field(sortbase,title='',value=0,/int,xsize=2,uvalue ='EndDay',/all)
    EndHoursID         = cw_field(sortbase,title=':',value=0,/int,xsize=2,uvalue ='etarthh',/all)
    EndMinutesID       = cw_field(sortbase,title=':',value=0,/int,xsize=2,uvalue ='etartmm',/all)
    EndSecondsID       = cw_field(sortbase,title=':',value=0,/int,xsize=2,uvalue ='etartss',/all)

    BUTTON_Plot_Zoom = WIDGET_BUTTON(sortbase, $
        FONT='9x15', $
        UVALUE='zoom', $
        XSIZE=35, $
        YSIZE=29, $
        TOOLTIP="select T1 and T2 by 2 clicks on the data area.", $aaaaaaaaaaa
    VALUE=!spec_3VCPI_dir+'/Zoom.bmp',/bitmap)

    BUTTON_Plot_Zoomout = WIDGET_BUTTON(sortbase, $
        FONT='9x15', $
        UVALUE='zoomout', $
        XSIZE=35, $
        YSIZE=29, $
        TOOLTIP="click to reset to Start/EndTime of the base file.", $aaaaaaaaaaa
    VALUE=!spec_3VCPI_dir+'/Zoomout.bmp',/bitmap);)

    optbase1 = widget_base(L1base,/row,/frame,/exclusive)
    ;lb1b = widget_base(lb1, /row)
    ;           butns = ['All-Times','T1-to-T2'];    reserved for future use 'WYSIWYG Scaled']
    ;           allorT1T2ID = CW_BGroup(optbase1,butns,/row,/exclusive,button_uvalue=[0,1],uvalue='AllorT1T2',/no_release,ysize=10)
    ;           widget_control,allorT1T2ID,set_value=0
    ALLTimeID=widget_button(optbase1,value='ProcessAll',Uvalue='All-Times')
    T1T2ID=widget_button(optbase1,value='ProcessT1-T2',Uvalue='T1T2')
    widget_control,alltimeID,set_button=1

    optbase2 = widget_base(L1base,/row,/frame)
    lb1a = widget_base(optbase2, /row,/nonEXCLUSIVE)
    processH = widget_button(lb1a, value = 'H', UVALUE='do_H')
    processV = widget_button(lb1a, value = 'V', UVALUE='do_V')

    widget_control, processH,set_button=1
    widget_control, processV,set_button=1

    pro_ascii = widget_button(lb1a, value ='1Hz_archive', UVALUE='1Hz')
    pro_png   = widget_button(lb1a, value ='Pngs', UVALUE='pngs')
    imgshow   = widget_button(lb1a, value ='showImg', UVALUE='ShowImg',tooltip="check to display images when playing back base file(slower process).")

    lb1b = widget_base(optbase2,/row,/frame,/exclusive)
    ;butns = ['Ice','Liq'];    reserved for future use 'WYSIWYG Scaled']
    ;iceorLiqID = CW_BGroup(lb1b,butns,/row,/exclusive,button_uvalue=[0,1],uvalue='IceorLiq',/no_release,ysize=10)
    ;widget_control,iceorliqID,set_value=0
    iceID=widget_button(lb1b,value='ice',Uvalue='ice')
    liqID=widget_button(lb1b,value='liq',Uvalue='liq')
    widget_control,iceID,set_button=1

    doItID   =widget_button(L1base, value='DoIt',uvalue='DoIt', TOOLTIP="click to Process 1Hz/Png pages for the selected time interval.")
    showHK   =widget_button(L1base, value='showHK',uvalue='showHK', TOOLTIP="click to display the House Keeping Data.")
    ;***********************************************************************************************************

    starting_window_x = 1400
    starting_window_y = 730

    drawIDbrowse = Widget_Draw(tlb,XSize=starting_window_x, YSize=150, Event_Pro='SPEC_GraphClick_browse', /BUTTON_EVENTS, /MOTION_EVENTS)
    image_base=widget_base(tlb,col=2)
    drawIDH = Widget_Draw(image_base,XSize=starting_window_x/2, YSize=550)
    drawIDV = Widget_Draw(image_base,XSize=starting_window_x/2, YSize=550)

    Widget_Control, tlb,XSize=starting_window_x, YSize=starting_window_y,/Realize

    Widget_Control, drawIDbrowse, Get_Value=wid
    WSet,  wid
    WShow, wid

    ; Create the info structure with the information
    ; required to run the program.
    pHKdata=info.pHKdata

    PAGEdX=600
    PAGEdY=550

    info = {pHKData:pHKdata, $          ; A pointer to the image data.
        Drawidbrowse:Drawidbrowse,$
        DrawidH:DrawidH,$
        DrawidV:DrawidV,$
        PAGEdX:pageDx,$
        PAGEdY:pageDy,$
        mywindowHID:drawIDH,$
        full:0,$
        CurrentXH:0,$
        currentYH:pagedy-10,$
        startTimeH:0LL,$
        EndTimeH:0LL,$
        Time0H:'',$
        TimeText_1H:'', $
        mywindowVID:drawIDV,$
        CurrentXV:0,$
        currentYV:pagedy-10,$
        fpos:0LL,$
        startTimeV:0LL,$
        EndTimeV:0LL,$
        Time0V:'',$
        TimeText_1V:'',$
        click_a_point:0,$
        next:0,$
        StartTime:0L,$
        EndTime:0L,$
        nanoseconds:0LL,$;  to record the last image time.
        SStrDay: SStrDay,$
        StartHoursID: StartHoursID,$
        StartMinutesID :StartMinutesID,$
        StartSecondsID :StartSecondsID,$
        EStrDay: EStrDay,$
        EndHoursID:   EndHoursID,$
        EndMinutesID :EndMinutesID,$
        EndSecondsID :EndSecondsID,$
        allTimes:1,$
        T1T2:0,$
        ice:1,$
        liq:0,$
        oneHz:0,$
        png:0,$
        DateStamp:info.Datestamp,$
        Pathname:info.Pathname,$
        currentFname:info.currentFname,$
        currentPname:info.currentPname,$
        currentFnameV:info.currentFnameV,$
        currentPnameV:info.currentPnameV,$
        statusID:info.statusID,$
        totalparticles:0L,$
        DrawID:info.drawID}
    ;************************************************************************************************************
    ;use a pointer to pass teh data
    ptr=ptr_new(info,/no_copy); no extra copy is made.
    widget_control,/hourglass
    marknumber=1
    plot_HK_data_to_the_mainbrowse_window, ptr,marknumber
    widget_control,tlb,set_uvalue=ptr,/no_copy;    info;  this replace above ***=info

    xmanager,'a3vcpiview_browse_image',tlb,/just_reg,/no_block, event_handler='a3vcpiview_browse_image_event'
    return
    ;*****************************************************
end;   ;end of main program
;***********************************************************

;****************************************************************************

pro Find_particle_parameters,image, WordCount, Slices, area, Midpoint, Edges, Err,$
    L3, PC3x, PC3y, PC4x, PC4y, A3, Roundness1, Roundness2, Roundness3, L1r, maxLength, maxWidth, num_perimeter_points, crystal_type, perimeterum, csp, $
    ml_p1x=ml_p1x, ml_p1y=ml_p1y, ml_p2x=ml_p2x, ml_p2y=ml_p2y, mw_p1x=mw_p1x, mw_p1y=mw_p1y, mw_p2x=mw_p2x, mw_p2y=mw_p2y, $
    perimeter_points_x=perimeter_points_x, perimeter_points_y=perimeter_points_y
;forward_function modpi, getangle

; PLEASE STOP USING FORWARD_FUNCTION AND NAME/ORDER PROGRAMS CORRECTLY!  FORWARD FUNCTION SHOULD NEVER EVER BE USED!!!

;all length unit are in pixles.

;microns_per_pixel = 10.0; !MICRONS_PER_PIXEL ; temporary for 2D-S, need to rework for HVPS, Hawkeye
alexei1=0
Edges = 0
L3 = 0.0
L4 = 0
L5 = 0
PC3x = 0.0
PC3y = 0.0
PC4x = 0.0
PC4y = 0.0
A3 = 0.0
Roundness1 = 0.0
Roundness2 = 0.0
Roundness3 = 0.0
L1r = 0.0
maxLength = 0.0
maxWidth  = 0.0
perimeter = 0UL
perimeterum = 0.
csp = 0.
Err=0;              ;need to counter NV-2 words in 2*(NV-2) byte
image2=image*0;  convert image 2 to be 0 as 1 and 255 as 0.
index=where(image eq 0,contG)
if contG gt 0 then image2(index)=byte(1) else image2=image2+byte(1)

; TAF found an odd size for an image array, which should always be even, putting in a ;stop
; the odd size was caused by a bad copy into my test program, and should not be encountered
; in normal operation.  Still, this ;stop should be left in to help debug if an odd Image is
; ever encountered.
ml_p1x = 0
ml_p1y = 0
ml_p2x = 0
ml_p2y = 0
mw_p1x = 0
mw_p1y = 0
mw_p2x = 0
mw_p2y = 0


;     The perimeter length is initially calculated in pixels.  This can be scaled linearly for a different pixel resolution.

;     The algorithm is based on the "Improved Algorithm for Calculating the Perimeter of Raster Polygons" by Steve Prashker
;     from http://www.geocomputation.org/1999/076/gc_076.htm

;     based on the following tables:

;       P1 P2 P3           1    2    4         0x01    0x02    0x04
;       P0  P P4           8    0   16         0x08    0x00    0x10
;       P7 P6 P5          32   64  128         0x20    0x40    0x80
;    //

neighbor_codes = [8, 1, 2, 4, 16, 32, 64, 128]

; these lengths are in pixels, multiply by 10 microns/pixel for microns for regular 2D-S
length_table = $
    [4.,     4.,     3.,     1.414,  4.,     4.,     1.414,  2.828,  3.,     1.414,  2.,     2.,     3.,     1.414,  1.414,  1.414, $
    3.,     3.,     2.,     1.414,  1.414,  1.414,  2.,     1.414,  2.,     2.,     1.,     1.,     2.,     2.,     1.,     1.,    $
    4.,     4.,     3.,     1.414,  4.,     4.,     3.,     3.,     1.414,  2.828,  1.414,  1.414,  3.,     3.,     1.414,  1.414, $
    3.,     3.,     2.,     2.,     3.,     3.,     2.,     2.,     2.,     2.,     1.,     1.414,  2.,     2.,     1.,     1.,    $
    3.,     3.,     2.,     2.,     3.,     3.,     2.,     2.,     2.,     1.414,  1.,     1.,     2.,     2.,     1.,     1.414, $
    2.,     2.,     1.,     1.,     1.414,  2.,     1.,     1.414,  1.,     1.,     0.,     0.,     1.,     2.,     0.,     0.,    $
    1.414,  1.414,  2.,     2.,     3.,     3.,     2.,     2.,     2.,     1.414,  1.,     1.,     2.,     2.,     1.,     1.,    $
    1.414,  2.,     1.,     2.,     1.414,  1.414,  1.,     1.,     1.,     1.414,  0.,     0.,     1.,     1.,     0.,     0.,    $
    4.,     4.,     3.,     3.,     4.,     4.,     1.414,  3.,     3.,     3.,     2.,     2.,     3.,     3.,     2.,     2.,    $
    1.414,  3.,     1.414,  1.414,  2.828,  3.,     1.414,  1.414,  2.,     2.,     1.,     1.,     2.,     2.,     1.414,  1.,    $
    4.,     4.,     3.,     3.,     4.,     4.,     3.,     3.,     1.414,  3.,     2.,     2.,     3.,     3.,     1.414,  1.414, $
    1.414,  3.,     2.,     1.414,  3.,     3.,     2.,     1.414,  2.,     2.,     2.,     1.,     2.,     1.414,  1.,     1.,    $
    1.414,  3.,     2.,     2.,     1.414,  3.,     2.,     2.,     1.414,  1.414,  1.,     1.,     2.,     1.414,  2.,     1.,    $
    2.,     2.,     1.,     1.,     1.414,  2.,     1.,     1.,     1.,     1.,     0.,     0.,     1.414,  1.,     0.,     0.,    $
    2.828,  3.,     2.,     2.,     3.,     3.,     2.,     1.414,  1.414,  1.414,  1.414,  1.,     2.,     1.414,  1.,     1.,    $
    1.414,  2.,     1.414,  2.,     1.414,  1.414,  1.,     1.,     1.,     1.,     0.,     0.,     1.,     1.,     0.,     0.     ]

; edges, also known as F1 is used as a set of binary flags with the following values:

; 0x01 - "right edge", pixel 127 is shaded
; 0x02 - "left  edge", pixel   0 is shaded
; 0x04 - Roundness calculated for an edge particle
; 0x08 - center of centroid is on array
; 0x10 - Roundness calculated for a dual edge particle
; 0x20 - perimeter vs area criteria not met
; 0x40 - image contains satellites (shaded regions are disjoint

if(area lt 1) then begin ; calculate particle parameters, Roundness, perimeter, etc
    ;print, "no shaded pixels this particle, should reject"


    ;stop
endif else if(area eq 1) then begin ; set defaults for single shaded pixel event
    ; note no need to set the perimeter x, y, or the Length and Width endpoints

    maxLength = 1.0
    maxWidth  = 1.0
    num_perimeter_points = 1L
    perimeterum      = float(4.) ; TAF check with people on this one, should it be pi or 4?
    perimeter_length =1.0

    Roundness1 = -1.
    Roundness2 = -1.
    Roundness3 = -1.
endif else begin; at least two shaded pixels
    ; save the edge pixel counts
    edge_index_0   = where(image[  0, *] eq 0, edge_pixel_count_0)
    edge_index_127 = where(image[127, *] eq 0, edge_pixel_count_127)

    ; centroid of on-array image, note this is distinct from the centroid for off-edge circle fit

    Centroid = fltarr(2)

    index = where(image eq 0, count)

    index2xy, !PIXELS, index, x_index, y_index

    Centroid[0] = total(x_index) / Area
    Centroid[1] = total(y_index) / Area

    ; perimeter trace

    ;neighbor            = [-1, -131, -130, -129,   1, 131, 130, 129] ; for linear array
    neighbor = [[-1,0],[-1,1],[0,1],[1,1],[1,0],[1,-1],[0,-1],[-1,-1]] ; for 2D array [2, 8]
    next_neighbor_index = [5, 6, 7, 0, 1, 2, 3, 4]

    OneHalfPI = !pi/2.

    still_looking = 1

    pixel1_index  = [-1, -1]
    pixel2_index  = [-1, -1]
    pixel3_index  = [-1, -1]
    seen_pixel1_again = 0
    angle_ratio = 0.0

    Bimage_width = !PIXELS + 2
    pixel_map_size = (slices+2L) * Bimage_width

    ; Bounded image, the image array, with a one pixel boundary around all sides
    Bimage = bytarr(!PIXELS + 2, slices + 2) ; i.e. width+2 * height+2 to have the blank edge pixels

    code_array = intarr(!PIXELS + 2, slices + 2)

    ; max possible size is all the points. It will likely be less since it is the perimeter
    ; but we are allocating space for maximum # pixels

    Bimage_index   = [-1, -1]
    FirstPixel   = 0L
    neighbor_ptr = 0

    pixel_location = 0

    Bimage[0:!PIXELS-1, 0:slices-1] = image2
    Bimage = shift(Bimage, 1, 1)
    image_array = Bimage

    ; trace around the perimeter
    ; start by finding the topmost, leftmost set pixel. This will be our starting point.

    ; if the perimeter vs area criteria are not met, start with a fresh starting point,
    ; track the longest perimeter, and return it regardless of perimeter criteria being met
    ; set edges |= 0x20 if perimeter vs area criteria are not met
    ; set edges |= 0x40 if there are satellite images (particle image is disjoint)

    ; set the edges flag for perimeter criteria not set,
    ; the flag will be unset below in the perimeter loop iff the criteria are set
    edges or= '20'X

    Bimage_start_index = 0L
    num_longest_perimeter_points = 0L
    longest_perimeter_start_index = 0L

    satellite_search_done = 0

    start_slice = 0L

    while(~satellite_search_done) do begin ; continue tracing perimeters around satellite images, finding the longest perimeter
        pixel1_index  = [-1, -1]
        pixel2_index  = [-1, -1]
        pixel3_index  = [-1, -1]
        seen_pixel1_again = 0
        num_perimeter_points = 0L
        perimeter_points = dblarr(2, area)

        start_slice++

        if(start_slice eq slices+1) then begin ; note we're working with Bimage[!PIXELS+2, slices+2]
            satellite_search_done = 1
            break
        endif

        ; identify a boundary pixel, just the first pixel to touch on each slice
        ; might have to come in from another side in rare cases, but should get most..

        index = long(where(Bimage[*, start_slice] eq 1, count))

        ; safety check to make sure we've seen at least a single set pixel
        if(count gt 0) then begin
            ; go from index to x y coordinates, likely a better way to do this by identifying the index in x y to begin with...

            linear_index = index[0] + start_slice * long(Bimage_width)

            Bimage_index[0] = linear_index mod Bimage_width
            Bimage_index[1] = linear_index / Bimage_width

            FirstPixel = Bimage_index
            pixel1_index = Bimage_index
            Bimage_start_index = Bimage_index

            perimeter_points[0, num_perimeter_points] = double(Bimage_index[0] - 1)
            perimeter_points[1, num_perimeter_points] = double(Bimage_index[1] - 1)
            num_perimeter_points = 1L ; or num_perimeter_points++? though this is the first point...

            Bimage[Bimage_index[0], Bimage_index[1]]++ ; flag that we've seen this point as our starting position
            neighbor_ptr = 0 ; start neighbor search in position #1 (i.e. neighbor[0])

            ;  to make the perimeter routine avoid some odd configurations that result in missing
            ;  some of the perimeter points, you need to continue to cycle around the perimeter
            ;  until you have seen the "starting point" and then the 2nd point a second time.
            ;  Below is an example of a particle
            ;  where you would see the "starting point" (indicated by the S) two times in this algorithm
            ;  and would not have accounted for all the points. Thus you need to see the 2nd pixel again
            ;  to be sure you are really done.

            ;      SX
            ;    XX
            ;    XX

            ; TAF note, the above explanation is insufficient and the code was still missing pixels

            still_looking = 1
            while(still_looking) do begin ; Main perimeter tracking loop
                ; cycle around the neighbor locations looking for the next potential perimeter pixel

                found_neighbor = 0

                ; might IDLize the for below with something like:
                ; index = where(Bimage[Bimage_index[0] + neighbor[0, neighbor_ptr], $
                ;               Bimage_index[1] + neighbor[1, neighbor_ptr]] eq 0, count)
                ; if count gt 0 then begin
                ;    Bimage_index[0] += neighbor[0, neighbor_ptr??? how does this work again??

                for i=0, 7 do begin ; set up next neighbor
                    ; If no pixel in this direction, try again in next clockwise position
                    if(Bimage[Bimage_index[0] + neighbor[0, neighbor_ptr], $
                        Bimage_index[1] + neighbor[1, neighbor_ptr]] eq 0) then begin
                        neighbor_ptr = (neighbor_ptr + 1) mod 8
                    endif else begin
                        found_neighbor = 1 ; found a non-zero neighbor
                        ;break??? or do we let neighbor_ptr wrap the whole way?
                    endelse
                endfor

                if(found_neighbor) then begin ; meaning we found a neighbor pixel that is set
                    ; set Bimage_ptr to new pixel position
                    Bimage_index[0] += neighbor[0, neighbor_ptr]
                    Bimage_index[1] += neighbor[1, neighbor_ptr]

                    if(Bimage_index[0] eq pixel1_index[0] and Bimage_index[1] eq pixel1_index[1]) then begin
                        seen_pixel1_again = 1
                    endif

                    ; are we back at the location of pixel #2, after having stepped on #1 again?
                    if(Bimage_index[0] eq pixel2_index[0] and Bimage_index[1] eq pixel2_index[1] and seen_pixel1_again eq 1) then begin
                        still_looking = 0
                    endif else begin
                        if(num_perimeter_points eq area) then begin ; TAF horizontal lines kept tracing around, crashing IDL from the dll implementation
                            still_looking = 0
                        endif else begin
                            if(Bimage[Bimage_index[0], Bimage_index[1]] eq 1) then begin
                                ; we have an unflagged pixel for the perimeter, add it to our list
                                perimeter_points[0, num_perimeter_points] = double(Bimage_index[0] - 1)
                                perimeter_points[1, num_perimeter_points] = double(Bimage_index[1] - 1)
                                num_perimeter_points++

                                if(num_perimeter_points gt area) then begin
                                    ;return -7; // TAF num_perimeter_points >= NumPoints
                                    print, "num_perimeter_points > area"
                                    stop
                                endif
                            endif

                            Bimage[Bimage_index[0], Bimage_index[1]]++ ; flag that this perimeter point as being seen (possibly again)

                            neighbor_ptr = next_neighbor_index[neighbor_ptr];  // select our next starting location for the neighbor search

                            if((num_perimeter_points eq 2L) and (pixel2_index[0] eq -1L)) then begin
                                pixel2_index = Bimage_index ; when we hit the 2nd point save its index. when we see it again, we're done
                            endif
                        endelse
                    endelse
                endif else begin ; we didn't find a neighbor
                    still_looking = 0 ; then we're done
                endelse
            endwhile ; Main perimeter tracking loop

            ; TAF need to 1) detect when particle is disjoint,
            ;             2) preserve the longest perimeter points
            if(num_perimeter_points gt num_longest_perimeter_points) then begin ; preserve longest perimeter points, also set the disjoint image flag
                if(num_longest_perimeter_points ne 0L) then begin ; only if a second perimeter search ends up in here
                    ; set the disjoint image flag, as there have been more than one non connected perimeter
                    edges or= '40'X
                endif

                num_longest_perimeter_points  = num_perimeter_points
                longest_perimeter_start_index = Bimage_start_index

                longest_perimeter_points = perimeter_points
            endif

            ; test to see if the perimeter is long enough
            ; 4*pi*A <= P^2 implies A<<P^2 for a circle
            ; thus if P^2 < 2*A, we traced a small satellite particle
            if(num_longest_perimeter_points^2. ge 2.*area) then begin
                satellite_search_done = 1

                ; unset the perimeter area flag 0x20
                edges xor= '20'X

                break
            endif
        endif
    endwhile ; satellite search loop

    ; TAF could be a way to get rid of these two assignments by using the longest_ variables below this point

    if(num_longest_perimeter_points eq 0 ) then begin
        print, "error finding any perimeter"
        ;stop
    endif

    perimeter_points     = longest_perimeter_points
    num_perimeter_points = num_longest_perimeter_points

    perimeter_points_x = reform(perimeter_points[0,0:num_perimeter_points-1]) ; This step could be skipped by changing the proceedure arguments to match the 2D array
    perimeter_points_y = reform(perimeter_points[1,0:num_perimeter_points-1])

    maxLength = -1.
    maxWidth  = -2.
    angle_tolerance = .075 ; radians, 4.3 degrees
    size_adjust = 5.5 ; pixels below this length, we ease the angle_tolerance by a factor of 2
    ; this works reasonably well, but should do an analysis on actual angle distributions with size/geometery

    if(num_perimeter_points ge 2L) then begin
        ; get max length chord
        ; get max  width chord

        distance_chords = abs(distance_measure(perimeter_points[*,0:num_perimeter_points-1L], /matrix)) + 1.

        max_distance_index = where(distance_chords eq max(distance_chords), count)

        if(count gt 0) then begin

            index2xy, num_perimeter_points, max_distance_index[0], ml_p1, ml_p2

            ; the x and y are then the indices into perimeter_points of the two points with the longest distance

            maxLength = distance_chords[max_distance_index[0]]

            ml_p1x = perimeter_points[0,ml_p1]
            ml_p1y = perimeter_points[1,ml_p1]

            ml_p2x = perimeter_points[0,ml_p2]
            ml_p2y = perimeter_points[1,ml_p2]

            if(num_perimeter_points eq 2L) then begin ; just assign a 1 for the width
                maxWidth = 1.

                mw_p1x = perimeter_points[0,0]
                mw_p1y = perimeter_points[1,0]
                mw_p2x = perimeter_points[0,0]
                mw_p2y = perimeter_points[1,0]
            endif else begin ; we have 3 or more perimeter points, find the width chord
                ; find the widest chord of the event in pixels, at 90 degrees (+-.075 radians, 4.3 degrees) to the longest chord (maxLength)
                ; first find the angle of the max Length line from the two endpoints, ml_p1, and ml_p2

                if(ml_p1 lt ml_p2) then begin
                    first  = ml_p1
                    second = ml_p2
                endif else if(ml_p1 gt ml_p2) then begin
                    first  = ml_p2
                    second = ml_p1
                endif else begin ; points the same, assume 1 pixel width, but should never get here
                    print, "width chord finding error, points the same
                    stop
                endelse

                p1x = perimeter_points[0,first]
                p1y = perimeter_points[1,first]
                p2x = perimeter_points[0,second]
                p2y = perimeter_points[1,second]

                dx = p2x - p1x
                dy = p2y - p1y

                angle = atan(dy, dx) ; IDL atan returns OneHalfPI for dx == 0

                ; TAF should be an easier way, add 2.5 pi, mod pi -- but no mod for doubles in c++
                ; mod pi seems to work in IDL, but need to change algorithm for negative numbers

                angle = fix(modpi(angle + OneHalfPI) * 1000.)/1000. ; rotate by 90 degrees, constrain sig figs to avoid floating errors

                ; search along chords with this orientation for the largest distance at a right angle to Length (ie. the width)

                ; calculate the angles from each perimeter point on one side of the Length chord to all other perimeter points
                ; on the other side of the Length chord
                ; then find the max length chord within some tolerance (.1) to perpendicular to the maxLength chord

                ; NOTE: the perimeter is not necessarily well ordered, so tracing either side of the Length is not sufficient to search

                ; the Width for loop below is based on the CPI View Width

                ; default to the first pixel and with width = 1
                maxWidth = 1.
                mw_p1x = perimeter_points[0,0]
                mw_p1y = perimeter_points[1,0]
                mw_p2x = perimeter_points[0,0]
                mw_p2y = perimeter_points[1,0]

                ; adjust the angle tolerance for small particles
                if(L5 lt size_adjust or slices lt size_adjust) then begin
                    angle_tolerance = .15
                endif else begin
                    angle_tolerance = .075
                endelse

                for i=0L, num_perimeter_points-2 do begin
                    dx = long(perimeter_points[0, i+1:num_perimeter_points-1] - perimeter_points[0, i])
                    dy = long(perimeter_points[1, i+1:num_perimeter_points-1] - perimeter_points[1, i])

                    angle_now = atan(dy, dx)

                    index = where(angle_now lt 0, count)
                    if(count gt 0) then angle_now[index] += !PI

                    index = where(angle_now gt !PI, count)
                    if(count gt 0) then stop ;angle_now[index] -= !PI

                    ;index = where(abs(angle_now - angle) lt angle_tolerance, count) ; did not take all cases into account, and could suffer subtraction errors

                    ; get rid of small errors in floating point calculations
                    mod_angle     = fix(modpi(angle     + angle_tolerance) * 1000.)/1000.
                    mod_angle_now = fix(modpi(angle_now + angle_tolerance) * 1000.)/1000.

                    index = where(((angle_now lt angle) and (angle_now + angle_tolerance ge angle    ))   or  $  ; angle - tol > angle_now
                        ((angle lt angle_now) and (angle     + angle_tolerance ge angle_now))   or  $  ; angle + tol < angle_now
                        ((angle_now le angle_tolerance) and (mod_angle     le angle_tolerance)) or  $  ; angle_now close to   0, angle close to 180
                        ((angle     le angle_tolerance) and (mod_angle_now le angle_tolerance)) or  $  ; angle_now close to 180, angle close to   0
                        ((angle le angle_tolerance)     and (angle_now     le angle_tolerance)) or  $  ; angle_now close to   0, angle close to   0
                        ((mod_angle le angle_tolerance) and (mod_angle_now le angle_tolerance)), count); angle_now close to 180, angle close to 180

                    if(count gt 0) then begin
                        len = distance_chords[i, i + 1 + index]

                        maxWidth = max(len) > maxWidth

                        subindex = where(len eq maxWidth, count)

                        if(count gt 0) then begin
                            mw_p1x = perimeter_points[0,i]
                            mw_p1y = perimeter_points[1,i]
                            mw_p2x = perimeter_points[0,i+1+index[subindex[0]]]
                            mw_p2y = perimeter_points[1,i+1+index[subindex[0]]]
                        endif
                    endif
                endfor
            endelse
        endif

        ; calculate perimeter length in microns using lookup table

        ; Calculate the length of the perimeter in microns, using the lookup table method

        perimeter_length = 0.

        image_index = 0L

        ; certainly a way to make this more IDL like to speed it up

        for ii=0L, num_perimeter_points-1L do begin
            image_index_x = long(perimeter_points[0,ii])
            image_index_y = long(perimeter_points[1,ii])

            for j=0, 7 do begin
                search_index_x = image_index_x + neighbor[0,j]
                search_index_y = image_index_y + neighbor[1,j]

                ; TAF these checks might be excessively conservative here
                if(search_index_x gt 0 and search_index_x lt !PIXELS+2 and $
                    search_index_y gt 0 and search_index_y lt slices+2) then begin
                    if(image_array[search_index_x, search_index_y] eq 1) then begin
                        code_array[image_index_x, image_index_y] += neighbor_codes[j]
                    endif
                endif
            endfor

            if(code_array[image_index] ge 256) then begin
                ;return -8; // TAF code_array[image_index] >= 256
                print, "perimeter length calculation error code_array[image_index] >= 256"
                break
            endif

            perimeter_length += length_table[code_array[image_index_x, image_index_y]]
        endfor

        perimeterum = float(perimeter_length); // convert for 10 microns per pixel

    endif else begin ; TAF should actually never get in here as single pixel events are handled above?
        ; copy over the Length and Width end points for a single pixel event
        ml_p1x = perimeter_points[0,0]
        ml_p1y = perimeter_points[1,0]

        ml_p2x = perimeter_points[0,0]
        ml_p2y = perimeter_points[1,0]

        mw_p1x = perimeter_points[0,0]
        mw_p1y = perimeter_points[1,0]

        mw_p2x = perimeter_points[0,0]
        mw_p2y = perimeter_points[1,0]

        maxLength = 1.
        maxWidth  = 1.
    endelse

    ; Roundness1
    ; Roundness2
    ; Roundness3

    ; ========= Roundness1 ================
    if(maxLength ne -1.) then begin
        Roundness1 = (4.*Area)/(!PI*maxLength^2.)
    endif else begin
        Roundness1 = -1.
    endelse

    if(num_perimeter_points gt 2L) then begin
        ;radii = fltarr(num_perimeter_points)

        ;for i=0, num_perimeter_points-1 do begin
        ;    radii[i] = sqrt((float(Centroid[0]) - float(BoundaryPtsX[i]))^2. + (float(Centroid[1]) - float(BoundaryPtsY[i]))^2.)
        ;endfor

        radii = sqrt((float(Centroid[0]) - float(reform(perimeter_points[0,0:num_perimeter_points-1])))^2. + $
            (float(Centroid[1]) - float(reform(perimeter_points[1,0:num_perimeter_points-1])))^2.)
    endif

    Roundness2 = -1.
    Roundness3 = -1.

    if(num_perimeter_points gt 4L) then begin
        estimated_radius = 0.5 * maxLength

        dist_variance = 0.

        ;for i=0, num_perimeter_points-1 do begin ; TAF should be able to IDLize this for loop, transfer/merge with CPI
        ;    diff = radii[i] - estimated_radius
        ;    dist_variance = dist_variance + diff^2.
        ;endfor

        diff = radii - estimated_radius
        dist_variance = total(diff^2.) / (num_perimeter_points-1)

        Roundness2 = sqrt(dist_variance) / estimated_radius ; convert to SD and scale to the presumed radius

        ; ========= Roundness3 ================
        ; Algorithm based on Chris Wieland's June 2012 Roundness 3 implemented for the 2D-S Process Particles dll

        ; calculates the ratio of the average angles of the perimeter pixels with respect to the centroid, and compares
        ; to the expected angles for a circle

        one = 0
        two = 1

        ; TAF catch the NaN on larger particles, div by zero???

        angles = fltarr(num_perimeter_points)

        estimated_angle  = 360. / num_perimeter_points
        angle_variance   = 0.
        mean_angle       = 0.

        for i=0, num_perimeter_points-1 do begin ; TAF might be able to IDLize this loop as well, could be dependent on getangle?
            angles[i] = getangle(perimeter_points[0,one], perimeter_points[1,one], Centroid[0], Centroid[1], perimeter_points[0,two], perimeter_points[1,two])

            one = (one+1) mod num_perimeter_points
            two = (two+1) mod num_perimeter_points

            mean_angle = mean_angle + angles[i]
        endfor

        mean_angle /= num_perimeter_points

        diff = angles - estimated_angle
        angle_variance = total(diff^2.) / (num_perimeter_points-1)

        Roundness3 = sqrt(angle_variance) / estimated_angle ; convert to SD and scale to the presumed angle
    endif ; (num_perimeter_points gt 4)
endelse ; NumPoints in image >= 2

; if round, or single pixel, set crystal type to 1, sphere, else set to 15, ice
if((Roundness1 gt !Roundness1_min and $
    Roundness1 lt !Roundness1_max and $
    Roundness2 gt !Roundness2_min and $
    Roundness2 lt !Roundness2_max and $
    Roundness3 gt !Roundness3_min and $
    Roundness3 lt !Roundness3_max) or $
    (Area eq 1)) then begin
    crystal_type = 1   ; sphere
endif else begin
    crystal_type = 15  ; ice
endelse

; calculate the Combined Single Parameter CSP in um^3
; Area, maxWidth, and maxLength are in pixels
; perimeterum is in microns

if(perimeterum eq 0.) then begin
    csp = -1.
endif else begin
    ; csp = ((Area*microns_per_pixel*microns_per_pixel) * maxWidth*microns_per_pixel * (2.*maxLength*microns_per_pixel + 2.*maxWidth*microns_per_pixel)) / perimeterum
    csp = 2.0*((Area) * maxWidth* (maxLength + maxWidth)) / perimeter_length
endelse


END ; Find_Particle_parameters

