; File:  bit_reverse_16.pro
; Author:  Ted Fisher <ted@specinc.com> <fishnuke@gmail.com>
; Purpose:  binary reverses a 16 bit input such as an IDL unsigned integer


function bit_reverse_16, input
    ; binary reverse the 16 bit uint input
    ; 1010b -> 0101b
    ; 1000b -> 0001b
    ; 0x0A00 ->  0x0050
    ; 0x8000 ->  0x0001

    ; some c sample codes
    ;bit twiddle 32

    ;uint32_t reverse(uint32_t x)
    ;{
    ;    x = ((x >>  1) & 0x55555555u) | ((x & 0x55555555u) <<  1)
    ;    x = ((x >>  2) & 0x33333333u) | ((x & 0x33333333u) <<  2)
    ;    x = ((x >>  4) & 0x0F0F0F0Fu) | ((x & 0x0F0F0F0Fu) <<  4)
    ;    x = ((x >>  8) & 0x00FF00FFu) | ((x & 0x00FF00FFu) <<  8)
    ;    x = ((x >> 16) & 0xFFFFu)     | ((x & 0xFFFFu)     << 16)
    ;    return x
    ;}

    ; simpler but not as cool as above
    ;unsigned int rev_bits(unsigned int input)
    ;{
    ;    unsigned int output = 0
    ;    unsigned int n = sizeof(input) << 3
    ;    unsigned int i = 0

    ;    for (i = 0; i < n; i++)
    ;        if ((input >> i) & 0x1)
    ;            output |=  (0x1 << (n - 1 - i))

    ;    return output
    ;}


    x = input

    x = ishft(x, -1) and '5555'X or ishft(x and '5555'X, 1)
    x = ishft(x, -2) and '3333'X or ishft(x and '3333'X, 2)
    x = ishft(x, -4) and '0F0F'X or ishft(x and '0F0F'X, 4)
    x = ishft(x, -8) and '00FF'X or ishft(x and '00FF'X, 8)

    return, x
end ; bit_reverse_16


