pro compare_small_archived_1Hz_HVave_matlab_espo_with_a3vcpiview_cmp_psd
    ; the matlab espo_archive do not have last 5 zeros spare1 spare2 to spare5 values.
    read_in_2ds_data_from_HV_ave_archived_1Hz_archive,TDsData,pathnm
    ;stop
    ;select time period.
    if 1 eq 2 then begin
        time1='20:09:25';    this matched ave_start=10, end=13 data.
        time2='20:09:26'
    end
    hh1=17 & hh2=17
    mm1=08 & mm2=10
    ss1=20 & ss2=20


    Time1=hh1*3600LL+mm1*60LL+ss1
    Time2=hh2*3600LL+mm2*60LL+ss2
    ;stop

    Get_2DS_MEAN_PSDs_from_time1_to_Time2,Time1,time2,TDSdata,NPts,EPts,MPts

    make_61_bins,nbins,nedges,xpts,dbl_binwidths
    bin_edges=fltarr(62)
    index=indgen(61)*2
    bin_edges=xpts(index);  size is from 0.001, 15, 25,35,  to 3005.
    single_binwidths=dbl_binwidths(index)
    stop
    xpts(0)=5
    ;make Npsd double values array.
    hypts=fltarr(122)
    for i=0LL,60LL do begin
        hypts(2*i:2*i+1)=NPts(i)
    endfor
    ;stop

    ;get 2dsview saved.txt psds
    get_2dsview_psd_cmp_psd,pathnm,x2ds,y2ds


    window,1,xs=400,ys=400
    loadct,0
    !P.thick=1
    !P.CHARSIZE=1
    !P.multi=[0,1,1]
    white=!D.N_COLORS-1
    !P.BACKGROUND=white

    index=where(hypts gt 0.0,contG)
    if contG gt 0 then begin
        hymin=min(hypts(index))
    endif else hymin=0.0001

    index=where(y2ds gt 0.0,contG)
    if contG gt 0 then begin
        ymin2ds=min(y2ds(index))
    endif else ymin2ds=0.0001

    ymin=min([hymin,ymin2ds])
    ymax=max([max(hypts),max(y2ds)])
    ymin=10.0^floor(Alog10(ymin))
    ymax=10.0^ceil(Alog10(ymax))



    PLOT, xpts, Hypts, COLOR=0, XRANGE=[10,1000], /Xlog,$
        Xstyle = 1, YLOG=1,xtitle='Particle Size(um)',TITLE='2ds 1Hz mean psd ',$
        THICK=1, YRANGE=[ymin, ymax],ystyle=1, charsize=1.0,$
        YTITLE='#/L/um';  Yticks=ytikn,Ytickn=myticknames
    oplot,x2ds,y2ds,color=255
    xyouts,0.55,0.90,'a3vcpiview_cmp_psd',color=255,/normal
    xyouts,0.55,0.80,'1Hz archive mean',color=0,/normal

    time1_str=strtrim(string(hh1),2)+'-'+strtrim(string(mm1),2)+'-'+strtrim(string(ss1),2)
    time2_str=strtrim(string(hh2),2)+'-'+strtrim(string(mm2),2)+'-'+strtrim(string(ss2),2)

    xyouts, 0.55,0.75,'Time:'+time1_str+'-'+time2_str,color=155,/normal

    outfile=pathnm+'Compare_1HzArchivePsd_with_a3vcpiview_PSD_for_'+time1_str+'_'+time2_str+'.jpg'
    write_jpeg,outfile,tvrd(true=1),true=1

    ;get caps data
    ;get_mean_psd_of_caps,time1,time2,Caps_data,caps_binwidths,xcaps,ycaps
    ;oplot,xcaps,ycaps,color=0

    stop
    ;Ok, SO far the Hconc, Hypts Hextn, Hmass agrees with 2dsview comp_psd results.
end; end of plot_2ds_1Hz_mean_psd
;*************************************************
pro read_in_2ds_data_from_HV_ave_archived_1Hz_archive,TDsData,pathnm
    filename=dialog_pickfile(filter='*Lear_HVave*.txt',get_path=pathnm)
    ;find out how many line is in the file.
    data=read_ascii(filename,count=n_lines)
    nnnseconds=(n_lines-5)
    junk=strarr(5)
    openr,2,filename
    readf,2,junk
    Data={seconds:0LL,Hconc:0.0,Hextn:0.0,HIWC:0.0,$
        Hbin1:0.0,Hbin2:0.0,Hbin3:0.0,Hbin4:0.0,Hbin5:0.0,Hbin6:0.0,Hbin7:0.0,Hbin8:0.0,$
        Hbin9:0.0,Hbin10:0.0,Hbin11:0.0,Hbin12:0.0,Hbin13:0.0,Hbin14:0.0,Hbin15:0.0,Hbin16:0.0,$
        Hbin17:0.0,Hbin18:0.0,Hbin19:0.0,Hbin20:0.0,Hbin21:0.0,Hbin22:0.0,Hbin23:0.0,Hbin24:0.0,$
        Hbin25:0.0,Hbin26:0.0,Hbin27:0.0,Hbin28:0.0,Hbin29:0.0,Hbin30:0.0,Hbin31:0.0,Hbin32:0.0,$
        Hbin33:0.0,Hbin34:0.0,Hbin35:0.0,Hbin36:0.0,Hbin37:0.0,Hbin38:0.0,Hbin39:0.0,Hbin40:0.0,$
        Hbin41:0.0,Hbin42:0.0,Hbin43:0.0,Hbin44:0.0,Hbin45:0.0,Hbin46:0.0,Hbin47:0.0,Hbin48:0.0,$
        Hbin49:0.0,Hbin50:0.0,Hbin51:0.0,Hbin52:0.0,Hbin53:0.0,Hbin54:0.0,Hbin55:0.0,Hbin56:0.0,$
        Hbin57:0.0,Hbin58:0.0,Hbin59:0.0,Hbin60:0.0,Hbin61:0.0,$

        Hebin1:0.0,Hebin2:0.0,Hebin3:0.0,Hebin4:0.0,Hebin5:0.0,Hebin6:0.0,Hebin7:0.0,Hebin8:0.0,$
        Hebin9:0.0,Hebin10:0.0,Hebin11:0.0,Hebin12:0.0,Hebin13:0.0,Hebin14:0.0,Hebin15:0.0,Hebin16:0.0,$
        Hebin17:0.0,Hebin18:0.0,Hebin19:0.0,Hebin20:0.0,Hebin21:0.0,Hebin22:0.0,Hebin23:0.0,Hebin24:0.0,$
        Hebin25:0.0,Hebin26:0.0,Hebin27:0.0,Hebin28:0.0,Hebin29:0.0,Hebin30:0.0,Hebin31:0.0,Hebin32:0.0,$
        Hebin33:0.0,Hebin34:0.0,Hebin35:0.0,Hebin36:0.0,Hebin37:0.0,Hebin38:0.0,Hebin39:0.0,Hebin40:0.0,$
        Hebin41:0.0,Hebin42:0.0,Hebin43:0.0,Hebin44:0.0,Hebin45:0.0,Hebin46:0.0,Hebin47:0.0,Hebin48:0.0,$
        Hebin49:0.0,Hebin50:0.0,Hebin51:0.0,Hebin52:0.0,Hebin53:0.0,Hebin54:0.0,Hebin55:0.0,Hebin56:0.0,$
        Hebin57:0.0,Hebin58:0.0,Hebin59:0.0,Hebin60:0.0,Hebin61:0.0,$

        Hmbin1:0.0,Hmbin2:0.0,Hmbin3:0.0,Hmbin4:0.0,Hmbin5:0.0,Hmbin6:0.0,Hmbin7:0.0,Hmbin8:0.0,$
        Hmbin9:0.0,Hmbin10:0.0,Hmbin11:0.0,Hmbin12:0.0,Hmbin13:0.0,Hmbin14:0.0,Hmbin15:0.0,Hmbin16:0.0,$
        Hmbin17:0.0,Hmbin18:0.0,Hmbin19:0.0,Hmbin20:0.0,Hmbin21:0.0,Hmbin22:0.0,Hmbin23:0.0,Hmbin24:0.0,$
        Hmbin25:0.0,Hmbin26:0.0,Hmbin27:0.0,Hmbin28:0.0,Hmbin29:0.0,Hmbin30:0.0,Hmbin31:0.0,Hmbin32:0.0,$
        Hmbin33:0.0,Hmbin34:0.0,Hmbin35:0.0,Hmbin36:0.0,Hmbin37:0.0,Hmbin38:0.0,Hmbin39:0.0,Hmbin40:0.0,$
        Hmbin41:0.0,Hmbin42:0.0,Hmbin43:0.0,Hmbin44:0.0,Hmbin45:0.0,Hmbin46:0.0,Hmbin47:0.0,Hmbin48:0.0,$
        Hmbin49:0.0,Hmbin50:0.0,Hmbin51:0.0,Hmbin52:0.0,Hmbin53:0.0,Hmbin54:0.0,Hmbin55:0.0,Hmbin56:0.0,$
        Hmbin57:0.0,Hmbin58:0.0,Hmbin59:0.0,Hmbin60:0.0,Hmbin61:0.0}

    TDsData=replicate(data,nnnseconds)
    readf,2,TDsData
    close,2
    stop
    ;assign teh last bin to be zero.
    TDSdata.Hbin61=fltarr(nnnseconds)
    TDSdata.Hebin61=fltarr(nnnseconds)
    TDSdata.Hmbin61=fltarr(nnnseconds)

    substrs=strsplit(filename,'\',/extract)
    filename=substrs(n_elements(substrs)-1)

end; end of read_in_2ds_data_from_1Hz_archive.

pro Get_2ds_time1totime2_TMS_mean_psd,time1,time2,TDsdata,$
    time,Hconc,Hextn,Hiwc,Hmnsz,Vconc,Vextn,VIWC,Vmnsz,xpts,Hypts,Vypts

;request times
starttime=time1;   for this periods, caps don't see anything bigger than 10um.
endtime  =time2;  is string format hh:mm:ss

substr=strsplit(starttime,':',/extract)
startseconds=substr(0)*3600LL+substr(1)*60LL+substr(2)*1LL

substr=strsplit(endtime,':',/extract)
endseconds=substr(0)*3600LL+substr(1)*60LL+substr(2)*1LL
nseconds=(endseconds-startseconds)

hypts=fltarr(24)
vypts=fltarr(24)
;bins edges and widths
nbins=24
nedges=2*nbins
xpts=dblarr(2*nbins)
ptr = 0
for i =0, 8  DO BEGIN
    xpts[ptr] = double((i+1)*10)
    xpts[ptr + 1] = double((i+2) * 10)
    ptr += 2
endfor
xpts[18:47]=[10,12,12,15,15,20,20,25,25,32,32,40,40,50,50,60,60,70,70,80,80,90,90,100,100,120,120,140,140,1001]*10
widths=xpts(1:47)-xpts(0:46)
indexw=where(widths ne 0.0)
widths=widths(indexw)*0+1.0


;original data.
seconds=Tdsdata.seconds
index=where(seconds ge startseconds and seconds lt endseconds,contG)
if contG gt 0 then begin
    time=seconds(index)
    Hconc=TDsData(index).Hconc
    Hextn=TDsdata(index).Hextn
    HIWC =TDsdata(index).Hiwc
    Hmnsz=TDsdata(index).Hmnsz;    sample volumes of each second.
    Vconc=TDsData(index).Vconc
    Vextn=TDsdata(index).Vextn
    VIWC =TDsdata(index).Viwc
    Vmnsz=TDsdata(index).Vmnsz
    sv=total(Hmnsz)

    ; note that TDSdata.Bin is #/L/um

    Hypts(0)=total(widths(0)*Hmnsz*TDsdata(index).Hbin1)/Sv
    Hypts(1)=total(widths(1)*Hmnsz*TDsdata(index).Hbin2)/Sv
    Hypts(2)=total(widths(2)*Hmnsz*TDsdata(index).Hbin3)/Sv
    Hypts(3)=total(widths(3)*Hmnsz*TDsdata(index).Hbin4)/Sv
    Hypts(4)=total(widths(4)*Hmnsz*TDsdata(index).Hbin5)/Sv
    Hypts(5)=total(widths(5)*Hmnsz*TDsdata(index).Hbin6)/Sv
    Hypts(6)=total(widths(6)*Hmnsz*TDsdata(index).Hbin7)/Sv
    Hypts(7)=total(widths(7)*Hmnsz*TDsdata(index).Hbin8)/Sv
    Hypts(8)=total(widths(8)*Hmnsz*TDsdata(index).Hbin9)/Sv
    Hypts(9)=total(widths(9)*Hmnsz*TDsdata(index).Hbin10)/Sv
    Hypts(10)=total(widths(10)*Hmnsz*TDsdata(index).Hbin11)/Sv
    Hypts(11)=total(widths(11)*Hmnsz*TDsdata(index).Hbin12)/Sv
    Hypts(12)=total(widths(12)*Hmnsz*TDsdata(index).Hbin13)/Sv
    Hypts(13)=total(widths(13)*Hmnsz*TDsdata(index).Hbin14)/Sv
    Hypts(14)=total(widths(14)*Hmnsz*TDsdata(index).Hbin15)/Sv
    Hypts(15)=total(widths(15)*Hmnsz*TDsdata(index).Hbin16)/Sv
    Hypts(16)=total(widths(16)*Hmnsz*TDsdata(index).Hbin17)/Sv
    Hypts(17)=total(widths(17)*Hmnsz*TDsdata(index).Hbin18)/Sv
    Hypts(18)=total(widths(18)*Hmnsz*TDsdata(index).Hbin19)/Sv
    Hypts(19)=total(widths(19)*Hmnsz*TDsdata(index).Hbin21)/Sv
    Hypts(20)=total(widths(19)*Hmnsz*TDsdata(index).Hbin20)/Sv
    Hypts(21)=total(widths(21)*Hmnsz*TDsdata(index).Hbin22)/Sv
    Hypts(22)=total(widths(22)*Hmnsz*TDsdata(index).Hbin23)/Sv
    Hypts(23)=total(widths(23)*Hmnsz*TDsdata(index).Hbin24)/Sv
    Vypts(0)=total(widths(0)*Hmnsz*TDsdata(index).Vbin1)/Sv
    Vypts(1)=total(widths(0)*Hmnsz*TDsdata(index).Vbin2)/Sv
    Vypts(2)=total(widths(0)*Hmnsz*TDsdata(index).Vbin3)/Sv
    Vypts(3)=total(widths(0)*Hmnsz*TDsdata(index).Vbin4)/Sv
    Vypts(4)=total(widths(0)*Hmnsz*TDsdata(index).Vbin5)/Sv
    Vypts(5)=total(widths(0)*Hmnsz*TDsdata(index).Vbin6)/Sv
    Vypts(6)=total(widths(0)*Hmnsz*TDsdata(index).Vbin7)/Sv
    Vypts(7)=total(widths(0)*Hmnsz*TDsdata(index).Vbin8)/Sv
    Vypts(8)=total(widths(0)*Hmnsz*TDsdata(index).Vbin9)/Sv
    Vypts(9)=total(widths(0)*Hmnsz*TDsdata(index).Vbin10)/Sv
    Vypts(10)=total(widths(0)*Hmnsz*TDsdata(index).Vbin11)/Sv
    Vypts(11)=total(widths(0)*Hmnsz*TDsdata(index).Vbin12)/Sv
    Vypts(12)=total(widths(0)*Hmnsz*TDsdata(index).Vbin13)/Sv
    Vypts(13)=total(widths(0)*Hmnsz*TDsdata(index).Vbin14)/Sv
    Vypts(14)=total(widths(0)*Hmnsz*TDsdata(index).Vbin15)/Sv
    Vypts(15)=total(widths(0)*Hmnsz*TDsdata(index).Vbin16)/Sv
    Vypts(16)=total(widths(0)*Hmnsz*TDsdata(index).Vbin17)/Sv
    Vypts(17)=total(widths(0)*Hmnsz*TDsdata(index).Vbin18)/Sv
    Vypts(18)=total(widths(0)*Hmnsz*TDsdata(index).Vbin19)/Sv
    Vypts(19)=total(widths(0)*Hmnsz*TDsdata(index).Vbin20)/Sv
    Vypts(20)=total(widths(0)*Hmnsz*TDsdata(index).Vbin21)/Sv
    Vypts(21)=total(widths(0)*Hmnsz*TDsdata(index).Vbin22)/Sv
    Vypts(22)=total(widths(0)*Hmnsz*TDsdata(index).Vbin23)/Sv
    Vypts(23)=total(widths(0)*Hmnsz*TDsdata(index).Vbin24)/sv
endif else begin
    time=seconds(index)
    ;Hypts=0.0
    ;Vypts=0.0; all other values are zero.
    rrr=dialog_message(' No 2DS data from this time period', /information)
endelse

;make Hypts and Vypts into horizontal and verticals.
hyptsn=fltarr(48)
vyptsn=fltarr(48)
for i=0,23 do begin
    hyptsn(2*i:2*i+1)=hypts(i)
    vyptsn(2*i:2*i+1)=vypts(i)
endfor
hypts=hyptsn
vypts=vyptsn
stop
end; end of get_2ds_time1totime2_total_psd_from_1Hz_archive,filename,time1,time2,xpts,ypts
;*********************************************************************

pro get_2dsview_psd_cmp_psd,pathnm,x2ds,y2ds
    ;read 2ds psd data file
    filter_str='*PSD_CMP_*.txt'
    filename2=dialog_pickfile(filter=filter_str,path=pathnm,title='Pick a a2dscview *PSD_CMP*.txt file')

    combined_string='xbin_edges'
    find_string_pos,filename2,combined_string,pos; get the first header line position.
    ;read in the 2ds binedges and bin heights data

    data=read_ascii(filename2,count=n_lines)
    nnn_rows=(n_lines-pos);  ; pos is the number of header lines.
    junk=strarr(pos)
    openr,2,filename2
    readf,2,junk


    data={Edges:0.0,col1:0.0,col2:0.0,col3:0.0,col4:0.0,col5:0.0,col6:0.0,col7:0.0,col8:0.0}
    comp_psd_data=replicate(data,nnn_rows)
    readf,2,comp_psd_data
    close,2

    x2ds=comp_psd_data.Edges
    y2ds=(comp_psd_data.col3 +comp_psd_data.col4)/2.0

end
;***************************************************

pro find_string_pos,filename,search_string,pos
    ;search_string='PDs =';'WYSIWYG:'
    ;filename='abcdefg.ascii'
    ; Note: the input search_tsring can be someting like this: 'abcd egfhj hhhh'
    result=read_ascii(filename,count=n_lines);   ;find out how many lines in the file.

    for i=2,n_lines-1 do begin
        result=read_ascii(filename,data_start=i-1,header=readed_line,num_records=1)
        ;skip i-1 lines, read in readed_line as header, and read 1 records.
        aa=readed_line(*,0)
        nn=n_elements(aa)
        last_line=readed_line(nn-1,*)
        last_line=strtrim(last_line,2);   ; take teh leading and tailing balnks away.

        ;print,readed_line; ;print,'aaaaaaaaaaaaa';;print,last_line;print,'*************'

        find = STRCMP(last_line, search_String, strlen(search_string), /FOLD_CASE)
        if (find eq 1) then begin
            pos=i-1
            break;   ;breakout of the for loop.
        endif else begin
            pos=0
        endelse
    endfor

    if pos eq 0 then begin
        print, 'Data line with ',search_string,' not found in file: ',filename
        stop
    endif;  print, pos
end; ;end of function find_string_pos.

;***********************************************************
;reading in CAPS data
pro read_caps_data,caps_data,xcaps,caps_binwidths
    ;read CAPS data file
    filter_str='MS*.txt'
    filename3=dialog_pickfile(filter=filter_str,path=pathnm,title='Pick a Caps psd MS*.txt file')
    data=read_ascii(filename3,count=n_lines)
    nnnseconds=(n_lines-51)/4
    junk=strarr(51)

    ;first get the bin edges and binwidths
    ;now reading in the xcaps values.
    combined_string='ice Water Content'
    find_string_pos,filename3,combined_string,pos; get the first header line position.
    data=read_ascii(filename3,header=headlines,data_start=pos,Num_records=1)
    ;there are 24 lines for bin_edges.
    xcaps=fltarr(48);  bin-edges
    widcaps=fltarr(24)
    for i=0,23 do begin
        n=(pos-25)+i
        line_N=headlines(n)
        substr1=strsplit(line_n,'(',/extract)
        substr2=strsplit(substr1(1),'um',/extract)
        substr3=strsplit(substr2(0),'-',/extract)
        xcaps(2*i)=substr3(0)*1.0
        xcaps(2*i+1)=substr3(1)*1.0
        widcaps(i)=substr3(1)*1.0-substr3(0)*1.0
    endfor
    caps_binwidths=widcaps

    ;now get the datas psd and time.
    openr,2,filename3
    readf,2,junk
    Data={seconds:0LL,$
        Hbin1:0.0,Hbin2:0.0,Hbin3:0.0,Hbin4:0.0,Hbin5:0.0,Hbin6:0.0,Hbin7:0.0,Hbin8:0.0,$
        Hbin9:0.0,Hbin10:0.0,Hbin11:0.0,Hbin12:0.0,Hbin13:0.0,Hbin14:0.0,Hbin15:0.0,Hbin16:0.0,$
        Hbin17:0.0,Hbin18:0.0,Hbin19:0.0,Hbin20:0.0,Hbin21:0.0,Hbin22:0.0,Hbin23:0.0,Hbin24:0.0,$
        iwc:0.0,area:0.0,extn:0.0,medVD:0.0 $
        }
    CAPs_Data=replicate(data,nnnseconds)
    readf,2,Caps_Data
    close,2
end; read_caps_data
;*******************************************************************

pro get_mean_psd_of_caps,time1,time2,Caps_data,caps_binwidths,xcaps,ycaps

    ;request times
    starttime=time1;   for this periods, caps don't see anything bigger than 10um.
    endtime  =time2;  is string format hh:mm:ss

    substr=strsplit(starttime,':',/extract)
    startseconds=substr(0)*3600LL+substr(1)*60LL+substr(2)*1LL

    substr=strsplit(endtime,':',/extract)
    endseconds=substr(0)*3600LL+substr(1)*60LL+substr(2)*1LL

    ;original data.
    seconds=caps_data.seconds
    index=where(seconds ge startseconds and seconds lt endseconds,contG)

    nnn=n_elements(index)
    ycaps=fltarr(24)
    time=lon64arr(nnn)
    caps_iwc=fltarr(nnn)
    caps_extn=fltarr(nnn)
    caps_area=fltarr(nnn)
    caps_medVD=fltarr(nnn)

    if contG gt 0 then begin
        time=seconds(index)
        Caps_iwc=Caps_data(index).iwc
        caps_extn=Caps_data(index).extn
        caps_area =Caps_data(index).area
        Caps_medVD=Caps_data(index).medVD

        ycaps(0)=mean(Caps_data(index).Hbin1)
        ycaps(1)=mean(Caps_data(index).Hbin2) 
        ycaps(2)=mean(Caps_data(index).Hbin3) 
        ycaps(3)=mean(Caps_data(index).Hbin4) 
        ycaps(4)=mean(Caps_data(index).Hbin5) 
        ycaps(5)=mean(Caps_data(index).Hbin6) 
        ycaps(6)=mean(Caps_data(index).Hbin7) 
        ycaps(7)=mean(Caps_data(index).Hbin8) 
        ycaps(8)=mean(Caps_data(index).Hbin9) 
        ycaps(9)=mean(Caps_data(index).Hbin10)
        ycaps(10)=mean(Caps_data(index).Hbin11)
        ycaps(11)=mean(Caps_data(index).Hbin12)
        ycaps(12)=mean(Caps_data(index).Hbin13)
        ycaps(13)=mean(Caps_data(index).Hbin14)
        ycaps(14)=mean(Caps_data(index).Hbin15)
        ycaps(15)=mean(Caps_data(index).Hbin16)
        ycaps(16)=mean(Caps_data(index).Hbin17)
        ycaps(17)=mean(Caps_data(index).Hbin18)
        ycaps(18)=mean(Caps_data(index).Hbin19)
        ycaps(19)=mean(Caps_data(index).Hbin21)
        ycaps(20)=mean(Caps_data(index).Hbin20)
        ycaps(21)=mean(Caps_data(index).Hbin22)
        ycaps(22)=mean(Caps_data(index).Hbin23)
        ycaps(23)=mean(Caps_data(index).Hbin24)
    endif else begin
        rrr=dialog_message('No caps data in this time interval',/information)
    endelse
    ycaps=ycaps/caps_binwidths
    ;make the ycaps to be double edgesvalues
    ycapsn=fltarr(48)
    for i=0,23 do begin
        ycapsn(2*i:2*i+1)=ycaps(i)
    endfor
    ycaps=ycapsn
end; get_mean_psd_of_caps,starttime,endtime,Caps_data,widcaps,xcaps,ycaps
;*****************************************************************************

pro Get_2DS_MEAN_PSDs_from_time1_to_Time2,Time1,time2,TDSdata,NPts,EPts,MPts

    Npts=fltarr(61)
    Epts=fltarr(61)
    Mpts=fltarr(61)
    TSDdata0=TDSdata

    ;zeros those missing values of 9.9E+9 to zero before getting mean values.
    myvalues=TDSdata.Hbin1
    indexmiss=where(myvalues eq 9.999E+30,contmiss)
    if contMiss gt 0 then begin
        TDSdata(indexmiss).Hbin1=0.0
        TDSdata(indexmiss).Hbin2=0.0
        TDSdata(indexmiss).Hbin3=0.0
        TDSdata(indexmiss).Hbin4=0.0
        TDSdata(indexmiss).Hbin5=0.0
        TDSdata(indexmiss).Hbin6=0.0
        TDSdata(indexmiss).Hbin7=0.0
        TDSdata(indexmiss).Hbin8=0.0
        TDSdata(indexmiss).Hbin9=0.0
        TDSdata(indexmiss).Hbin10=0.0
        TDSdata(indexmiss).Hbin11=0.0
        TDSdata(indexmiss).Hbin12=0.0
        TDSdata(indexmiss).Hbin13=0.0
        TDSdata(indexmiss).Hbin14=0.0
        TDSdata(indexmiss).Hbin15=0.0
        TDSdata(indexmiss).Hbin16=0.0
        TDSdata(indexmiss).Hbin17=0.0
        TDSdata(indexmiss).Hbin18=0.0
        TDSdata(indexmiss).Hbin19=0.0
        TDSdata(indexmiss).Hbin20=0.0
        TDSdata(indexmiss).Hbin21=0.0
        TDSdata(indexmiss).Hbin22=0.0
        TDSdata(indexmiss).Hbin23=0.0
        TDSdata(indexmiss).Hbin24=0.0
        TDSdata(indexmiss).Hbin25=0.0
        TDSdata(indexmiss).Hbin26=0.0
        TDSdata(indexmiss).Hbin27=0.0
        TDSdata(indexmiss).Hbin28=0.0
        TDSdata(indexmiss).Hbin29=0.0
        TDSdata(indexmiss).Hbin30=0.0
        TDSdata(indexmiss).Hbin31=0.0
        TDSdata(indexmiss).Hbin32=0.0
        TDSdata(indexmiss).Hbin33=0.0
        TDSdata(indexmiss).Hbin34=0.0
        TDSdata(indexmiss).Hbin35=0.0
        TDSdata(indexmiss).Hbin36=0.0
        TDSdata(indexmiss).Hbin37=0.0
        TDSdata(indexmiss).Hbin38=0.0
        TDSdata(indexmiss).Hbin39=0.0
        TDSdata(indexmiss).Hbin40=0.0
        TDSdata(indexmiss).Hbin41=0.0
        TDSdata(indexmiss).Hbin42=0.0
        TDSdata(indexmiss).Hbin43=0.0
        TDSdata(indexmiss).Hbin44=0.0
        TDSdata(indexmiss).Hbin45=0.0
        TDSdata(indexmiss).Hbin46=0.0
        TDSdata(indexmiss).Hbin47=0.0
        TDSdata(indexmiss).Hbin48=0.0
        TDSdata(indexmiss).Hbin49=0.0
        TDSdata(indexmiss).Hbin50=0.0
        TDSdata(indexmiss).Hbin51=0.0
        TDSdata(indexmiss).Hbin52=0.0
        TDSdata(indexmiss).Hbin53=0.0
        TDSdata(indexmiss).Hbin54=0.0
        TDSdata(indexmiss).Hbin55=0.0
        TDSdata(indexmiss).Hbin56=0.0
        TDSdata(indexmiss).Hbin57=0.0
        TDSdata(indexmiss).Hbin58=0.0
        TDSdata(indexmiss).Hbin59=0.0
        TDSdata(indexmiss).Hbin60=0.0
        TDSdata(indexmiss).Hbin61=0.0

        TDSdata(indexmiss).Hebin1=0.0
        TDSdata(indexmiss).Hebin2=0.0
        TDSdata(indexmiss).Hebin3=0.0
        TDSdata(indexmiss).Hebin4=0.0
        TDSdata(indexmiss).Hebin5=0.0
        TDSdata(indexmiss).Hebin6=0.0
        TDSdata(indexmiss).Hebin7=0.0
        TDSdata(indexmiss).Hebin8=0.0
        TDSdata(indexmiss).Hebin9=0.0
        TDSdata(indexmiss).Hebin10=0.0
        TDSdata(indexmiss).Hebin11=0.0
        TDSdata(indexmiss).Hebin12=0.0
        TDSdata(indexmiss).Hebin13=0.0
        TDSdata(indexmiss).Hebin14=0.0
        TDSdata(indexmiss).Hebin15=0.0
        TDSdata(indexmiss).Hebin16=0.0
        TDSdata(indexmiss).Hebin17=0.0
        TDSdata(indexmiss).Hebin18=0.0
        TDSdata(indexmiss).Hebin19=0.0
        TDSdata(indexmiss).Hebin20=0.0
        TDSdata(indexmiss).Hebin21=0.0
        TDSdata(indexmiss).Hebin22=0.0
        TDSdata(indexmiss).Hebin23=0.0
        TDSdata(indexmiss).Hebin24=0.0
        TDSdata(indexmiss).Hebin25=0.0
        TDSdata(indexmiss).Hebin26=0.0
        TDSdata(indexmiss).Hebin27=0.0
        TDSdata(indexmiss).Hebin28=0.0
        TDSdata(indexmiss).Hebin29=0.0
        TDSdata(indexmiss).Hebin30=0.0
        TDSdata(indexmiss).Hebin31=0.0
        TDSdata(indexmiss).Hebin32=0.0
        TDSdata(indexmiss).Hebin33=0.0
        TDSdata(indexmiss).Hebin34=0.0
        TDSdata(indexmiss).Hebin35=0.0
        TDSdata(indexmiss).Hebin36=0.0
        TDSdata(indexmiss).Hebin37=0.0
        TDSdata(indexmiss).Hebin38=0.0
        TDSdata(indexmiss).Hebin39=0.0
        TDSdata(indexmiss).Hebin40=0.0
        TDSdata(indexmiss).Hebin41=0.0
        TDSdata(indexmiss).Hebin42=0.0
        TDSdata(indexmiss).Hebin43=0.0
        TDSdata(indexmiss).Hebin44=0.0
        TDSdata(indexmiss).Hebin45=0.0
        TDSdata(indexmiss).Hebin46=0.0
        TDSdata(indexmiss).Hebin47=0.0
        TDSdata(indexmiss).Hebin48=0.0
        TDSdata(indexmiss).Hebin49=0.0
        TDSdata(indexmiss).Hebin50=0.0
        TDSdata(indexmiss).Hebin51=0.0
        TDSdata(indexmiss).Hebin52=0.0
        TDSdata(indexmiss).Hebin53=0.0
        TDSdata(indexmiss).Hebin54=0.0
        TDSdata(indexmiss).Hebin55=0.0
        TDSdata(indexmiss).Hebin56=0.0
        TDSdata(indexmiss).Hebin57=0.0
        TDSdata(indexmiss).Hebin58=0.0
        TDSdata(indexmiss).Hebin59=0.0
        TDSdata(indexmiss).Hebin60=0.0
        TDSdata(indexmiss).Hebin61=0.0

        TDSdata(indexmiss).Hmbin1=0.0
        TDSdata(indexmiss).Hmbin2=0.0
        TDSdata(indexmiss).Hmbin3=0.0
        TDSdata(indexmiss).Hmbin4=0.0
        TDSdata(indexmiss).Hmbin5=0.0
        TDSdata(indexmiss).Hmbin6=0.0
        TDSdata(indexmiss).Hmbin7=0.0
        TDSdata(indexmiss).Hmbin8=0.0
        TDSdata(indexmiss).Hmbin9=0.0
        TDSdata(indexmiss).Hmbin10=0.0
        TDSdata(indexmiss).Hmbin11=0.0
        TDSdata(indexmiss).Hmbin12=0.0
        TDSdata(indexmiss).Hmbin13=0.0
        TDSdata(indexmiss).Hmbin14=0.0
        TDSdata(indexmiss).Hmbin15=0.0
        TDSdata(indexmiss).Hmbin16=0.0
        TDSdata(indexmiss).Hmbin17=0.0
        TDSdata(indexmiss).Hmbin18=0.0
        TDSdata(indexmiss).Hmbin19=0.0
        TDSdata(indexmiss).Hmbin20=0.0
        TDSdata(indexmiss).Hmbin21=0.0
        TDSdata(indexmiss).Hmbin22=0.0
        TDSdata(indexmiss).Hmbin23=0.0
        TDSdata(indexmiss).Hmbin24=0.0
        TDSdata(indexmiss).Hmbin25=0.0
        TDSdata(indexmiss).Hmbin26=0.0
        TDSdata(indexmiss).Hmbin27=0.0
        TDSdata(indexmiss).Hmbin28=0.0
        TDSdata(indexmiss).Hmbin29=0.0
        TDSdata(indexmiss).Hmbin30=0.0
        TDSdata(indexmiss).Hmbin31=0.0
        TDSdata(indexmiss).Hmbin32=0.0
        TDSdata(indexmiss).Hmbin33=0.0
        TDSdata(indexmiss).Hmbin34=0.0
        TDSdata(indexmiss).Hmbin35=0.0
        TDSdata(indexmiss).Hmbin36=0.0
        TDSdata(indexmiss).Hmbin37=0.0
        TDSdata(indexmiss).Hmbin38=0.0
        TDSdata(indexmiss).Hmbin39=0.0
        TDSdata(indexmiss).Hmbin40=0.0
        TDSdata(indexmiss).Hmbin41=0.0
        TDSdata(indexmiss).Hmbin42=0.0
        TDSdata(indexmiss).Hmbin43=0.0
        TDSdata(indexmiss).Hmbin44=0.0
        TDSdata(indexmiss).Hmbin45=0.0
        TDSdata(indexmiss).Hmbin46=0.0
        TDSdata(indexmiss).Hmbin47=0.0
        TDSdata(indexmiss).Hmbin48=0.0
        TDSdata(indexmiss).Hmbin49=0.0
        TDSdata(indexmiss).Hmbin50=0.0
        TDSdata(indexmiss).Hmbin51=0.0
        TDSdata(indexmiss).Hmbin52=0.0
        TDSdata(indexmiss).Hmbin53=0.0
        TDSdata(indexmiss).Hmbin54=0.0
        TDSdata(indexmiss).Hmbin55=0.0
        TDSdata(indexmiss).Hmbin56=0.0
        TDSdata(indexmiss).Hmbin57=0.0
        TDSdata(indexmiss).Hmbin58=0.0
        TDSdata(indexmiss).Hmbin59=0.0
        TDSdata(indexmiss).Hmbin60=0.0
        TDSdata(indexmiss).Hmbin61=0.0
    endif;  end if tehre is missing data .

    ;original data.
    seconds=Tdsdata.seconds
    index=where(seconds  ge time1 and seconds lt time2,contG)
    if contG gt 0 then begin
        Npts(0)=mean(TDSdata(index).Hbin1>0.0)
        Npts(1)=mean(TDSdata(index).Hbin2>0.0)
        Npts(2)=mean(TDSdata(index).Hbin3>0.0)
        Npts(3)=mean(TDSdata(index).Hbin4>0.0)
        Npts(4)=mean(TDSdata(index).Hbin5>0.0)
        Npts(5)=mean(TDSdata(index).Hbin6>0.0)
        Npts(6)=mean(TDSdata(index).Hbin7>0.0)
        Npts(7)=mean(TDSdata(index).Hbin8>0.0)
        Npts(8)=mean(TDSdata(index).Hbin9>0.0)
        Npts(9)=mean(TDSdata(index).Hbin10>0.0)
        Npts(10)=mean(TDSdata(index).Hbin11>0.0)
        Npts(11)=mean(TDSdata(index).Hbin12>0.0)
        Npts(12)=mean(TDSdata(index).Hbin13>0.0)
        Npts(13)=mean(TDSdata(index).Hbin14>0.0)
        Npts(14)=mean(TDSdata(index).Hbin15>0.0)
        Npts(15)=mean(TDSdata(index).Hbin16>0.0)
        Npts(16)=mean(TDSdata(index).Hbin17>0.0)
        Npts(17)=mean(TDSdata(index).Hbin18>0.0)
        Npts(18)=mean(TDSdata(index).Hbin19>0.0)
        Npts(19)=mean(TDSdata(index).Hbin21>0.0)
        Npts(20)=mean(TDSdata(index).Hbin20>0.0)
        Npts(21)=mean(TDSdata(index).Hbin22>0.0)
        Npts(22)=mean(TDSdata(index).Hbin23>0.0)
        Npts(23)=mean(TDSdata(index).Hbin24>0.0)
        Npts(24)=mean(TDSdata(index).Hbin25>0.0)
        Npts(25)=mean(TDSdata(index).Hbin26>0.0)
        Npts(26)=mean(TDSdata(index).Hbin27>0.0)
        Npts(27)=mean(TDSdata(index).Hbin28>0.0)
        Npts(28)=mean(TDSdata(index).Hbin29>0.0)
        Npts(29)=mean(TDSdata(index).Hbin30>0.0)
        Npts(30)=mean(TDSdata(index).Hbin31>0.0)
        Npts(31)=mean(TDSdata(index).Hbin32>0.0)
        Npts(32)=mean(TDSdata(index).Hbin33>0.0)
        Npts(33)=mean(TDSdata(index).Hbin34>0.0)
        Npts(34)=mean(TDSdata(index).Hbin35>0.0)
        Npts(35)=mean(TDSdata(index).Hbin36>0.0)
        Npts(36)=mean(TDSdata(index).Hbin37>0.0)
        Npts(37)=mean(TDSdata(index).Hbin38>0.0)
        Npts(38)=mean(TDSdata(index).Hbin39>0.0)
        Npts(39)=mean(TDSdata(index).Hbin40>0.0)
        Npts(40)=mean(TDSdata(index).Hbin41>0.0)
        Npts(41)=mean(TDSdata(index).Hbin42>0.0)
        Npts(42)=mean(TDSdata(index).Hbin43>0.0)
        Npts(43)=mean(TDSdata(index).Hbin44>0.0)
        Npts(44)=mean(TDSdata(index).Hbin45>0.0)
        Npts(45)=mean(TDSdata(index).Hbin46>0.0)
        Npts(46)=mean(TDSdata(index).Hbin47>0.0)
        Npts(47)=mean(TDSdata(index).Hbin48>0.0)
        Npts(48)=mean(TDSdata(index).Hbin49>0.0)
        Npts(49)=mean(TDSdata(index).Hbin50>0.0)
        Npts(50)=mean(TDSdata(index).Hbin51>0.0)
        Npts(51)=mean(TDSdata(index).Hbin52>0.0)
        Npts(52)=mean(TDSdata(index).Hbin53>0.0)
        Npts(53)=mean(TDSdata(index).Hbin54>0.0)
        Npts(54)=mean(TDSdata(index).Hbin55>0.0)
        Npts(55)=mean(TDSdata(index).Hbin56>0.0)
        Npts(56)=mean(TDSdata(index).Hbin57>0.0)
        Npts(57)=mean(TDSdata(index).Hbin58>0.0)
        Npts(58)=mean(TDSdata(index).Hbin59>0.0)
        Npts(59)=mean(TDSdata(index).Hbin60>0.0)
        Npts(60)=mean(TDSdata(index).Hbin61>0.0)

        Epts(0)=mean(TDsdata(index).Hebin1>0.0)
        Epts(1)=mean(TDSdata(index).Hebin2>0.0)
        Epts(2)=mean(TDSdata(index).Hebin3>0.0)
        Epts(3)=mean(TDSdata(index).Hebin4>0.0)
        Epts(4)=mean(TDSdata(index).Hebin5>0.0)
        Epts(5)=mean(TDSdata(index).Hebin6>0.0)
        Epts(6)=mean(TDSdata(index).Hebin7>0.0)
        Epts(7)=mean(TDSdata(index).Hebin8>0.0)
        Epts(8)=mean(TDSdata(index).Hebin9>0.0)
        Epts(9)=mean(TDSdata(index).Hebin10>0.0)
        Epts(10)=mean(TDSdata(index).Hebin11>0.0)
        Epts(11)=mean(TDSdata(index).Hebin12>0.0)
        Epts(12)=mean(TDSdata(index).Hebin13>0.0)
        Epts(13)=mean(TDSdata(index).Hebin14>0.0)
        Epts(14)=mean(TDSdata(index).Hebin15>0.0)
        Epts(15)=mean(TDSdata(index).Hebin16>0.0)
        Epts(16)=mean(TDSdata(index).Hebin17>0.0)
        Epts(17)=mean(TDSdata(index).Hebin18>0.0)
        Epts(18)=mean(TDSdata(index).Hebin19>0.0)
        Epts(19)=mean(TDSdata(index).Hebin21>0.0)
        Epts(20)=mean(TDSdata(index).Hebin20>0.0)
        Epts(21)=mean(TDSdata(index).Hebin22>0.0)
        Epts(22)=mean(TDSdata(index).Hebin23>0.0)
        Epts(23)=mean(TDSdata(index).Hebin24>0.0)
        Epts(24)=mean(TDSdata(index).Hebin25>0.0)
        Epts(25)=mean(TDSdata(index).Hebin26>0.0)
        Epts(26)=mean(TDSdata(index).Hebin27>0.0)
        Epts(27)=mean(TDSdata(index).Hebin28>0.0)
        Epts(28)=mean(TDSdata(index).Hebin29>0.0)
        Epts(29)=mean(TDSdata(index).Hebin30>0.0)
        Epts(30)=mean(TDSdata(index).Hebin31>0.0)
        Epts(31)=mean(TDSdata(index).Hebin32>0.0)
        Epts(32)=mean(TDSdata(index).Hebin33>0.0)
        Epts(33)=mean(TDSdata(index).Hebin34>0.0)
        Epts(34)=mean(TDSdata(index).Hebin35>0.0)
        Epts(35)=mean(TDSdata(index).Hebin36>0.0)
        Epts(36)=mean(TDSdata(index).Hebin37>0.0)
        Epts(37)=mean(TDSdata(index).Hebin38>0.0)
        Epts(38)=mean(TDSdata(index).Hebin39>0.0)
        Epts(39)=mean(TDSdata(index).Hebin40>0.0)
        Epts(40)=mean(TDSdata(index).Hebin41>0.0)
        Epts(41)=mean(TDSdata(index).Hebin42>0.0)
        Epts(42)=mean(TDSdata(index).Hebin43>0.0)
        Epts(43)=mean(TDSdata(index).Hebin44>0.0)
        Epts(44)=mean(TDSdata(index).Hebin45>0.0)
        Epts(45)=mean(TDSdata(index).Hebin46>0.0)
        Epts(46)=mean(TDSdata(index).Hebin47>0.0)
        Epts(47)=mean(TDSdata(index).Hebin48>0.0)
        Epts(48)=mean(TDSdata(index).Hebin49>0.0)
        Epts(49)=mean(TDSdata(index).Hebin50>0.0)
        Epts(50)=mean(TDSdata(index).Hebin51>0.0)
        Epts(51)=mean(TDSdata(index).Hebin52>0.0)
        Epts(52)=mean(TDSdata(index).Hebin53>0.0)
        Epts(53)=mean(TDSdata(index).Hebin54>0.0)
        Epts(54)=mean(TDSdata(index).Hebin55>0.0)
        Epts(55)=mean(TDSdata(index).Hebin56>0.0)
        Epts(56)=mean(TDSdata(index).Hebin57>0.0)
        Epts(57)=mean(TDSdata(index).Hebin58>0.0)
        Epts(58)=mean(TDSdata(index).Hebin59>0.0)
        Epts(59)=mean(TDSdata(index).Hebin60>0.0)
        Epts(60)=mean(TDSdata(index).Hebin61>0.0)

        Mpts(0)=mean(TDsdata(index).Hmbin1>0.0)
        Mpts(1)=mean(TDSdata(index).Hmbin2>0.0)
        Mpts(2)=mean(TDSdata(index).Hmbin3>0.0)
        Mpts(3)=mean(TDSdata(index).Hmbin4>0.0)
        Mpts(4)=mean(TDSdata(index).Hmbin5>0.0)
        Mpts(5)=mean(TDSdata(index).Hmbin6>0.0)
        Mpts(6)=mean(TDSdata(index).Hmbin7>0.0)
        Mpts(7)=mean(TDSdata(index).Hmbin8>0.0)
        Mpts(8)=mean(TDSdata(index).Hmbin9>0.0)
        Mpts(9)=mean(TDSdata(index).Hmbin10>0.0)
        Mpts(10)=mean(TDSdata(index).Hmbin11>0.0)
        Mpts(11)=mean(TDSdata(index).Hmbin12>0.0)
        Mpts(12)=mean(TDSdata(index).Hmbin13>0.0)
        Mpts(13)=mean(TDSdata(index).Hmbin14>0.0)
        Mpts(14)=mean(TDSdata(index).Hmbin15>0.0)
        Mpts(15)=mean(TDSdata(index).Hmbin16>0.0)
        Mpts(16)=mean(TDSdata(index).Hmbin17>0.0)
        Mpts(17)=mean(TDSdata(index).Hmbin18>0.0)
        Mpts(18)=mean(TDSdata(index).Hmbin19>0.0)
        Mpts(19)=mean(TDSdata(index).Hmbin21>0.0)
        Mpts(20)=mean(TDSdata(index).Hmbin20>0.0)
        Mpts(21)=mean(TDSdata(index).Hmbin22>0.0)
        Mpts(22)=mean(TDSdata(index).Hmbin23>0.0)
        Mpts(23)=mean(TDSdata(index).Hmbin24>0.0)
        Mpts(24)=mean(TDSdata(index).Hmbin25>0.0)
        Mpts(25)=mean(TDSdata(index).Hmbin26>0.0)
        Mpts(26)=mean(TDSdata(index).Hmbin27>0.0)
        Mpts(27)=mean(TDSdata(index).Hmbin28>0.0)
        Mpts(28)=mean(TDSdata(index).Hmbin29>0.0)
        Mpts(29)=mean(TDSdata(index).Hmbin30>0.0)
        Mpts(30)=mean(TDSdata(index).Hmbin31>0.0)
        Mpts(31)=mean(TDSdata(index).Hmbin32>0.0)
        Mpts(32)=mean(TDSdata(index).Hmbin33>0.0)
        Mpts(33)=mean(TDSdata(index).Hmbin34>0.0)
        Mpts(34)=mean(TDSdata(index).Hmbin35>0.0)
        Mpts(35)=mean(TDSdata(index).Hmbin36>0.0)
        Mpts(36)=mean(TDSdata(index).Hmbin37>0.0)
        Mpts(37)=mean(TDSdata(index).Hmbin38>0.0)
        Mpts(38)=mean(TDSdata(index).Hmbin39>0.0)
        Mpts(39)=mean(TDSdata(index).Hmbin40>0.0)
        Mpts(40)=mean(TDSdata(index).Hmbin41>0.0)
        Mpts(41)=mean(TDSdata(index).Hmbin42>0.0)
        Mpts(42)=mean(TDSdata(index).Hmbin43>0.0)
        Mpts(43)=mean(TDSdata(index).Hmbin44>0.0)
        Mpts(44)=mean(TDSdata(index).Hmbin45>0.0)
        Mpts(45)=mean(TDSdata(index).Hmbin46>0.0)
        Mpts(46)=mean(TDSdata(index).Hmbin47>0.0)
        Mpts(47)=mean(TDSdata(index).Hmbin48>0.0)
        Mpts(48)=mean(TDSdata(index).Hmbin49>0.0)
        Mpts(49)=mean(TDSdata(index).Hmbin50>0.0)
        Mpts(50)=mean(TDSdata(index).Hmbin51>0.0)
        Mpts(51)=mean(TDSdata(index).Hmbin52>0.0)
        Mpts(52)=mean(TDSdata(index).Hmbin53>0.0)
        Mpts(53)=mean(TDSdata(index).Hmbin54>0.0)
        Mpts(54)=mean(TDSdata(index).Hmbin55>0.0)
        Mpts(55)=mean(TDSdata(index).Hmbin56>0.0)
        Mpts(56)=mean(TDSdata(index).Hmbin57>0.0)
        Mpts(57)=mean(TDSdata(index).Hmbin58>0.0)
        Mpts(58)=mean(TDSdata(index).Hmbin59>0.0)
        Mpts(59)=mean(TDSdata(index).Hmbin60>0.0)
        Mpts(60)=mean(TDSdata(index).Hmbin61>0.0)
    endif
    TDSdata=TSDdata0

end;  end of Get_2DS_MEAN_PSDs_from_time1_to_Time2,Time1,time2,TDSdat,NPts,EPts,MPts

pro make_61_bins,nbins,nedges,xpts,dbl_binwidths
    nbins=61
    nedges=2*nbins
    xpts=dblarr(2*nbins)
    xpts(0)=5.0
    for i =0, 19  DO BEGIN ; from 15, 15,25,25, ******205,205.
        xpts[2*i+1:2*i+2] =5.0+(i+1)*10.0
    endfor
    for i =20,34  DO BEGIN ; from 205 225, 245,265,285, *****485,485,505,505
        xpts[2*i+1:2*i+2] =205.0+(i-19)*20.0
    endfor

    for i =35,44  DO BEGIN ; from 555,555,605,606,*******1005,1005
        xpts[2*i+1:2*i+2] =505.0+(i-34)*50.0
    endfor

    for i =45,54  DO BEGIN ; from 1105,1105,*******2005,2005
        xpts[2*i+1:2*i+2] =1005.0+(i-44)*100.0
    endfor

    for i =55,59  DO BEGIN ; from 2205,2205,*******3005,3005
        xpts[2*i+1:2*i+2] =2005.0+(i-54)*200.0
    endfor
    xpts(121)=xpts(120)+200.0; to make last bin-width=200.0um
    dbl_binwidths=xpts(1:*)-xpts(0:120)
    dbl_binwidths=[dbl_binwidths,0.0]
    xpts(121)=100000.0;    but hin here group anything greater that 3005 to be the last bin.
    xpts(0) =0.001
end; end of make_61_bins
;***********************************************************************
