pro correct_HV_particle_nanoseconds
    Common  DataBlock,alldataH,alldataV,ADataH,ADataV,FirstData,LastData,StripData,FirstDataV,$
        LastDataV

    ;stop;  ;here we need to make sure there is a common start nanoseconds for both channels if
    ;H and V channel have a common tick values.
    ; it is assume that both channel's tick values are correct.
    ; say if  a ith_V-particle   has a tick_value Vi_ticks=12345678
    ;     and a jth_H_particle   has a tick_value Hj_ticks=12345678
    ; then ith_v-particle and jth_H_particle should have the same nanoseconds.

    ; note that (*alldataH), and (*alldataV) have been sorted by the probecounter tag before this
    ; subroutine is called. (*alldataH).probecounter and (*alldataV).probecounter are monotonic.

    ;*************************************************************************************
    ;first valid particle's ticks
    index0=where((*alldataV).probecounter eq firstdataV.probecounter); there must be one in there.
    ticks0=(*alldataV)(index0).probecounter;   this tick is the first valid particle's tick.
    nanos0=(*alldataV)(index0).nanoseconds;    this nano is not rounded to the whole second.
    tas0  =(*alldataV)(index0).tas
    ; save this nanos0 and ticks0 for later compare with H-channels
    ticks0v=ticks0
    nanos0v=nanos0
    tas0v=tas0
    ;**************************************************************************************
    nanos=(*alldataV).nanoseconds
    nanos_old=nanos
    ticks=(*alldataV).probecounter
    tas  =(*alldataV).tas;   note that even teh fake particles has none zero tas values now.
    nnn=n_elements(tas)
    delta_tas=tas(1:*)-tas(0:nnn-2)
    index=where(delta_tas ne 0.0,contG)+1LL; see if there are TAs changes

    ;case 1:
    if contG eq 0 then begin;     there is no air speed change
        nanoPerTick=long64(10000.0/tas(0)); ; so nano_second is uniformly proportional to the count ticks.
        nanos=long64(nanos0)+( long64(ticks)-long64(ticks0) )*nanoPertick
        (*alldataV).nanoseconds=nanos
    endif

    ;case 2:
    if contG gt 0 then begin; contG can be as large as nnn-1;  usually it will be very small.
        nanoPerTick=long64(10000.0/tas(0));  first segments' nanoPerTick
        start_ticks=ticks0
        start_nanos=nanos0
        start_index=0LL
        for i=0LL, contG-1LL do begin;  for each point where tas changes value, we need to calculate the new nanos.
            this_index =index(i)
            delta_ticks=long64(ticks(start_index:this_index))-long64(start_ticks);;can be positive and nagtive values.
            delta_nanos=delta_ticks*nanoPerTick
            nanos(start_index:this_index)=start_nanos+delta_nanos
            nanoPertick=long64(10000.0/tas(This_index));  for next segment nanoPerTick
            start_index=this_index
            start_ticks=ticks(start_index)
            start_nanos=nanos(start_index)
        endfor
        (*alldataV).nanoseconds=nanos
    endif

    ; do that for the H channel

    ;first valid particle's ticks
    index0=where((*alldataH).probecounter eq firstdata.probecounter); there must be one in there.
    ticks0=(*alldataH)(index0).probecounter;   this tick is the first valid particle's tick.
    nanos0=(*alldataH)(index0).nanoseconds;    this nano  is not rounded to the whole second.
    tas0  =(*alldataH)(index0).tas
    ticks0H=ticks0;  for compare with ticks0V, and nanos0V
    nanos0H=nanos0
    ;**************************************************************************************

    nanos=(*alldataH).nanoseconds
    nanos_old=nanos
    ticks=(*alldataH).probecounter
    tas  =(*alldataH).tas
    nnn=n_elements(tas)
    delta_tas=tas(1:*)-tas(0:nnn-2)
    index=where(delta_tas ne 0.0,contG)+1LL; see if there are TAs changes
    if contG eq 0 then begin;     there is no air speed change
        nanoPerTick=long64(10000.0/tas(0)); ; so nano_second is uniformly proportional to the count ticks.
        nanos=long64(nanos0)+( long64(ticks)-long64(ticks0) )*nanoPertick
        (*alldataH).nanoseconds=nanos
    endif

    if contG gt 0 then begin; contG can be as large as nnn-1;  usually it will be very small.
        nanoPerTick=long64(10000.0/tas(0));  first segments' nanoPerTick
        start_ticks=ticks0
        start_nanos=nanos0
        start_index=0LL
        for i=0LL, contG-1LL do begin;  for each point where tas changes value, we need to calculate the new nanos.
            this_index =index(i)
            delta_ticks=long64(ticks(start_index:this_index))-long64(start_ticks)
            delta_nanos=delta_ticks*nanoPerTick
            nanos(start_index:this_index)=start_nanos+delta_nanos
            nanoPertick=long64(10000.0/tas(This_index));  for next segment nanoPerTick
            start_index=this_index
            start_ticks=ticks(start_index)
            start_nanos=nanos(start_index)
        endfor
        (*alldataH).nanoseconds=nanos
    endif

    ; subroutine ends in here; following is just for debuging.
    ;now compare the new nanos sceond with the old nano seconds
    debug=0
    if debug eq 1 then begin
        window,1,xs=600,ys=600
        erase,color='ffffff'x  ; get background to white

        plot,nanos_old/1000000000.0,nanos/1000000000.0,color=bluecolor,background=whitecolor,/ynozero,$
            title='Compare-H-Particle_nanoseconds new and old ',ytitle='Nano_old',xtitle='Nano_new',charsize=1.0
        DeltaNanos=nanos/1000000000.0-nanos_old/1000000000.0
        indexm=where(nanos ne nanos_old, contNomatch)
        print,'max_Delta=',max(deltaNanos),'  min_delta=', min(deltaNanos),'     No_Match_count=',contNomatch,'     total_cont=',nnn
        outputfilename=!currentHPname+'H_particle_new_oldtime_compare.png'
        write_png,outputfilename,tvrd(true=1)
        wdelete,!D.window
    endif;  end if of if debug eq 1

end;  correct_HV_particles_nanotimes
