function counts2temp, in_array
    ; convert raw data counts to temperature using the following conversion

    ; rt = 6.5536e9 * (1.-double(in_array/65536.) / (5. * double(in_array))
    ; temp_fst = -273.15 + (1.1117024e-3 + 237.02702e-6 * alog(rt) + 75.78814e-9 * (alog(rt))^3.)^(-1.)

    ; translated from the matlab HK read code in t2vcpi_hk.m

    ; rt = 6.5536e9 *  (1-data(HKDataIDX+1)/65536)/(5*data(HKDataIDX+1))
    ; temp_fst = [temp_fst, -273.15 + (1.1117024e-3 + 237.02702e-6*log(rt)+75.78814e-9*(log(rt))^3)^(-1)]; %Forward Sample Tube

    rt = 6.5536e9 * (1.-double(in_array)/65536.) / (5. * double(in_array))
    temp_array = -273.15 + (1.1117024e-3 + 237.02702e-6 * alog(rt) + 75.78814e-9 * (alog(rt))^3.)^(-1.)

    return, temp_array
end ; counts2temp
