; File: cpiview.pro
; SPEC Inc.  3V-CPI main CPI processing program


;Mo found that  combine.csv and displayed len, width is the same.
;the len/2.3 equals objlen obtained from boundary calcalutions of shapelen function.
;Dcor is the Length corrected after the the focus value are considered in the do_alone and in PSDs calculations.

;===============================================================================
PRO cpiview, DX, DY, GROUP=GROUP, harmonics_flag = harmonics_flag, HKLOG_request=HKLOG_request,TS_correct=TS_correct

; keywords
;   harmonics_flag    if set the harmoinc spectrum and radial distance plots will be seen when the boundaries are seen
;   oldDeadtime   when set an older scale factor for the deadtime is used

version = !SPEC_VERSION


; dx and dy are inputs to specify size of draw widget, default to 740x540 if not supplied
;resolve_All,/continue

; define system variables for true and false
defsysv,'!TRUE', exists=exists
if(not exists) then defsysv,'!TRUE',1B,1

defsysv,'!FALSE', exists=exists
if(not exists) then defsysv,'!FALSE',0B,1

defsysv, '!Do_DOF_Calib', 0;  ; for DOF calibration use.
defsysv, '!selected_frame_and_roinum',[0,0,0,0,0,0,0,0];  for DOF calibration use. frame #, roi#, Ex,Ey,Sx, Sy,Roisizex, roisizey

version_name=' --Version-- ' + Version

appname = '3V CPI View (CPI Viewer)'
title =appname

; this parameter is true for DEMO version
demo = !false

; keyword to control subtraction of 256 from missed
if(not keyword_set(TS_correct))then TS_correct = !false

; keyword for display of harmonic plots
if( not keyword_set(harmonics_flag))then harmonics_flag = !false

if( not keyword_Set(HKLOG_request))then HKLOG_request = !false

if(demo)then begin
    notice = [['Thank you for trying CPIView from SPEC Inc.'],$
        ['This is a limited version providing 10 minutes of use.'],$
        ['Contact SPEC Inc for information about purchasing'],$
        ['the full version at 303-449-1105']]

    r = dialog_message(notice,/info)
endif else begin

    ; get the location of the HOOK directory where the hasp dll will be stored
    ; find location of the word HOOK in the path
    ;hookloc = strpos(!path,'hook')
    ;colonloc = rstrpos(!path,';',hookloc)
    ;hookPath = strmid(!path,colonloc+1,hookloc-colonloc+3)
    ;haspFile = hookpath + '\HASPMS32.dll'
    ;haspFile = !SPEC_3VCPI_DIR + '\HASPMS32.dll'

    ;    case checkhasp(haspFile) of
    ;    0:begin
    ;       ; no HASP
    ;       r = dialog_message('CPIView requires a SPEC, Inc HASP key to be present. Please install a valid HASP key')
    ;       return
    ;    end
    ;    1:begin
    ;       ; quick look
    ;       ;print,'Valid HASP Present'
    ;       print,'AutoExtract Features Disabled'
    ;       r = dialog_message('This version does not support AutoExtraction, Contact SPEC, Inc for upgrade information',/info)
    ;       ; this parameter controls access to auto extraction tools
    ;       AUTOEXTRACT = !False
    ;       productNum = 1
    ;    end
    ;    2:begin
    ;       ; eXtractor
    ;       ;print,'Valid HASP Present'
    ;       print,'AutoExtract Features Enabled'
    AUTOEXTRACT = !True
    productNum = 2
    ;    end
    ;    3: begin
    ;       ; Classifier
    ;       ;print,'Valid HASP Present'
    ;       print,'AutoExtract and Classifier Features Enabled'
    ;       AUTOEXTRACT = !True
    ;       productNum = 3
    ;    end
    ;    else: begin
    ;       ; error
    ;       print, 'HASP error'
    ;       return
    ;    end
    ;    endcase

endelse

if(!version.release lt 5.2)then begin
    r = dialog_message('This requires IDL version 5.2 or greater... exiting',/info)
    wait,2
    return
endif

if(!d.table_size ge 256)then device,decomposed=0

!order = 1
IF N_ELEMENTS(Group) EQ 0 THEN GROUP=0

tlb = widget_base(GROUP_LEADER=Group, MBAR=bar_base,  TITLE=Title+version_Name,/col, /TLB_KILL_REQUEST_EVENTS)

button_bar = widget_base(tlb,/row)
bb1 = widget_base(button_bar,/row)
open = widget_button(bb1,value = 'open.bmp',/bitmap,uvalue='NEWFILE')
;printSU= widget_button(bb1,value = 'print1_setup.bmp',/bitmap,uvalue='PRINTSETUP')
;quitb= widget_button(bb1,value = 'quit.bmp',/bitmap,Uvalue='QUIT')
quitb= widget_button(bb1,value = 'Quit',Uvalue='QUIT')

bb2 = widget_base(button_bar,/row)
bmpath = FILEPATH('redo.bmp', SUBDIRECTORY=['resource', 'bitmaps'])
redo= widget_button(bb2,value = bmpath,/bitmap,uvalue='Redo')
;reject= widget_button(bb2,value = 'reject.bmp',/bitmap,uvalue='Reject')

bb3 = widget_base(button_bar,/row)
bmpath = FILEPATH('hist.bmp', SUBDIRECTORY=['resource', 'bitmaps'])
hist= widget_button(bb3,value = bmpath,/bitmap,uvalue='DOTIMEPERIOD'); was histcompute.bmp
;histview= widget_button(bb3,value = 'hist.bmp',/bitmap,uvalue='SHOWHISTOGRAMS')
;output= widget_button(bb3,value = 'print.bmp',/bitmap, uvalue = 'PRINTNOW')
bmpath = FILEPATH('importd.bmp', SUBDIRECTORY=['resource', 'bitmaps'])
color= widget_button(bb3,value = bmpath,/bitmap, uvalue = 'XLOADCT')

bb4 = widget_base(button_bar,/row,sensitive = autoextract)
bmpath = FILEPATH('find.bmp', SUBDIRECTORY=['resource', 'bitmaps'])
extract= widget_button(bb4,value = bmpath,/bitmap,uvalue='autoextract')
;export= widget_button(bb4,value = 'importf.bmp',/bitmap, uvalue = 'read_objects')

bb5 = widget_base(button_bar,/row)
;about= widget_button(bb5,value = 'insight.bmp',/bitmap,uvalue='about'); was histcompute.bmp
about= widget_button(bb5,value = 'About',uvalue='about'); was histcompute.bmp
bmpath = FILEPATH('help.bmp', SUBDIRECTORY=['resource', 'bitmaps'])
help= widget_button(bb5,value = bmpath,/bitmap, uvalue = 'rev')

bb6 = widget_base(button_bar,/row)
manualClassify = widget_button(bb6,TOOLTIP="For Manually changing the crystal habit.", value = 'Manual Classifier',uvalue='ManualClass'); was histcompute.bmp

;bb7 = widget_base(button_bar,/row)
;   threeViewer = widget_button(bb7, value = '3 Viewer',uvalue='3 Viewer')

bb7a = widget_base(button_bar,/row)
threeViewer = widget_button(bb7a, value = '3 Viewer',uvalue='3 Viewer')

bb8 = widget_base(button_bar,/row)
DOFCalib= widget_button(bb8,TOOLTIP="For calibration using glass beads slide only",value = 'DofCalib',uvalue='DOFCalib'); for Dof_calibration

text_bar =widget_base(tlb,/row)
fileLabel = widget_label(text_bar,value='',xsize = 930,font='Arial*bold*20')

MAINBase1 = WIDGET_BASE(tlb,/row,uvalue='Timer')

;-----------------------------------------------------
; Menu
file_menu = WIDGET_BUTTON(bar_base, Value='File', /Menu)
file_bttn1 = WIDGET_BUTTON(file_menu, Value='Open', Uvalue='NEWFILE')
file_bttn3 = WIDGET_BUTTON(file_menu, Value='Batch ROI Processing', Uvalue='BatchROI',/sep)
file_bttn4 = WIDGET_BUTTON(file_menu, Value='Quit', Uvalue='QUIT',/sep)

edit_menu = WIDGET_BUTTON(bar_base, Value='Edit', /Menu)
Proc_bttn = WIDGET_BUTTON(edit_menu, Value='Redo Frame', Uvalue='Redo')
;tools_bttn2 = WIDGET_BUTTON(edit_menu, Value='Reject ROIs', Uvalue='Reject')

tools_menu = WIDGET_BUTTON(bar_base, Value='Tools', /Menu)
tools_bttn1 = WIDGET_BUTTON(tools_menu, Value='Generate/View Plots', Uvalue='DOTIMEPERIOD')
;tools_bttn2 = WIDGET_BUTTON(tools_menu, Value='Histogram Viewer', Uvalue='SHOWHISTOGRAMS')
;file_bttn3 = WIDGET_BUTTON(tools_menu, Value='Output Page So Far', Uvalue='PRINTNOW')
tools_bttn4 = WIDGET_BUTTON(tools_menu, Value='Color Table', Uvalue='XLOADCT')

tools2_menu = WIDGET_BUTTON(bar_base, Value='Extraction Tools', /Menu)
tools2_bttn0 = WIDGET_BUTTON(tools2_menu, Value='Auto Extract Features', Uvalue='autoextract',sensitive = autoextract)
;tools2_bttn3 = WIDGET_BUTTON(tools2_menu, Value='Import Object File', Uvalue='read_objects')

about_menu = WIDGET_BUTTON(bar_base, Value='Help', /Menu)
aboutCPIVIEW = WIDGET_BUTTON(about_menu, Value='About CPIView', Uvalue='about')
revisions = WIDGET_BUTTON(about_menu, Value='Help/Rev Notes', Uvalue='rev')

;****  In MainBase 1 ***************************************************************************************************
;-----------------------------------------------------
; Base for all buttons and radio buttons on the left side
LeftButtonsBase = WIDGET_BASE(MAINBase1, /COL, TITLE='AllButtons', UVALUE='AllButtons',event_pro = 'left_event');SPACE=5, XSIZE=95,/BASE_ALIGN_CENTER,

;-----------------------------------------------------
lb1 = widget_base(LeftButtonsBase,/frame,/col)
label = widget_label(lb1,value='Display Options')

lb1a = widget_base(lb1, /col,/nonEXCLUSIVE,/frame)
filtered = widget_button(lb1a, value = 'Filtered', UVALUE='Filtered')
gradient = widget_button(lb1a, value = 'Gradient', UVALUE='Gradient')

xsctbase = widget_base(lb1,/nonexclusive)
MosaicBtn = widget_button(xsctbase,value='As Mosaic', UVALUE='MOSAIC')
BUTTON77 = WIDGET_BUTTON(xsctbase, UVALUE='Xsection', VALUE='Cross Section')

PixSizeWID = CW_FIELD(lb1, /FLOATING, /COL, /ALL_EVENTS, TITLE='Pixel Size (um)', VALUE = !CPI_MICRONS_PER_PIXEL, UVALUE='PixSize',XSIZE=8)
AspectWID = CW_FIELD(lb1, /FLOATING, /COL, /ALL_EVENTS, TITLE='Y/X Aspect', VALUE = 1.0, UVALUE='ASPECT',XSIZE=8)

; Background Processing options
lb2 = widget_base(leftButtonsBase,/col,/frame)
backlabel = widget_label(lb2,value='Background Optns.')
bkgnBase = widget_base(lb2, /nonexclusive, /col)
subBack = widget_button(bkgnBase,value = 'Sub. Bckgrnd',uvalue='SubBkgrnd')
skipBack = widget_button(bkgnBase,value ='Skip Bckgrnd',uvalue='SkipBkgrnd')
widget_control,subBack, set_button = !true
widget_control,skipBack, set_button = !true
BUTTON = WIDGET_BUTTON(lb2,   UVALUE='UseAsBkg', VALUE='Use As Bkg', FONT=baseFont1)

lb3 = widget_base(leftButtonsBase,/col,/frame)
ImgNumSlider = WIDGET_SLIDER(lb3, MIN=1, MAX=50000,VALUE=1,title='Frame Number', UVALUE='IMGNUMSLIDER')
time1  = widget_label(lb3,value = 'CPI: 00:00:00:000',uvalue='time1',/ALIGN_LEFT)
time2  = widget_label(lb3,value = 'DAS: 00:00:00:000',uvalue='time2',/ALIGN_LEFT)

;add this for search on Jan 2004 --moqixu
;****************************************************************************************
b312 = widget_base(lb3,/row)
SchtimeID  =widget_text(b312,/Editable,Scr_Xsize=70,Value='00:00:00:000'); size 70 is good.
;SchtimeID=0
search = widget_button(b312,value='Go',uvalue='search')
;******************************************************************************************
ZoomBase = widget_base(lb3,/col)
zoomlabel = widget_label(ZoomBase,value='1.0')
ZoomSlider = widget_SLIDER(ZoomBase, MIN=1, MAX=50, TITLE='Zoom',VALUE=10, UVALUE='ZOOMSLIDER',/suppress_value)

lb4 = widget_base(leftButtonsBase,/frame,/col)
label = widget_label(lb4,value='Progress...')
progress = widget_draw(lb4,xsize = 120, ysize=10)

widget_control,lb4,map = 0


;****  In MainBase 1 **************************************************************************************************
; Image View and image-related labels
ViewBase = WIDGET_BASE(MAINBase1, /COL,TITLE='ImgView', UVALUE=' ',event_pro = 'view_event')

;-----------------------------------------------------
; Labels and controls at bottom of image view
IF N_ELEMENTS(DX) NE 1 THEN DX = 700
IF N_ELEMENTS(DY) NE 1 THEN DY = 470;512
MainView = WIDGET_DRAW(ViewBase, /BUTTON_EVENTS, /FRAME, /MOTION_EVENTS, UVALUE='MAIN_VIEW', $
    XSIZE=1024, YSIZE=1024, X_SCROLL_SIZE=DX, Y_SCROLL_SIZE=DY);/RETAIN;XSIZE=2048, YSIZE=2048,
time_info_ID =widget_label(viewbase,value='Warning !!! Time displayed in this window is raw file Time.',font='Times-Bold')


;****  In MainBase 2 **********************************************************************************************

plotarea = widget_draw(tlb,ysize = 80,xsize = 950);,event_pro='plot_event',/BUTTON_EVENTS)
; Bottom Base
MAINbase2 = widget_base(tlb,/row)
BottomBase = widget_base(MAINbase2,/col,event_pro='bottom_event')
;-----------------------------------------------------

;-----------------------------------------------------
; Zoom and Scaling controls
ScaleZoomBase = WIDGET_BASE(BottomBase, /ROW, SPACE=8, /BASE_ALIGN_CENTER,TITLE='Scaling', UVALUE='Scaling')

ScalingBase = WIDGET_BASE(ScaleZoomBase, /ROW, SPACE=8, /FRAME, /BASE_ALIGN_CENTER, TITLE='Scaling',UVALUE='Scaling')
MinSlider  = WIDGET_SLIDER(ScalingBase, FONT=baseFont2, MIN=0,  MAX=245, TITLE='Scaling Min', VALUE = 0,   UVALUE='MINSLIDER'); XSIZE=80, YSIZE=35,
MaxSlider  = WIDGET_SLIDER(ScalingBase, FONT=baseFont2, MIN=10, MAX=255, TITLE='    Max',     VALUE = 255, UVALUE='MAXSLIDER'); XSIZE=80, YSIZE=35,

; TAF 2014-03-28 for some reason the set_min_max in gui_lib.pro uses 1 as the min and 254 as the max on the sliders
;MinSlider  = WIDGET_SLIDER(ScalingBase, FONT=baseFont2, MIN=-1,  MAX=245, TITLE='Scaling Min', VALUE = 0,   UVALUE='MINSLIDER'); XSIZE=80, YSIZE=35,
;MaxSlider  = WIDGET_SLIDER(ScalingBase, FONT=baseFont2, MIN=10,  MAX=256, TITLE='    Max',     VALUE = 255, UVALUE='MAXSLIDER'); XSIZE=80, YSIZE=35,

ToggleBase = WIDGET_BASE(ScalingBase, /COLUMN, /FRAME, /NONEXCLUSIVE)
AutoScale  = WIDGET_BUTTON(ToggleBase, FONT=baseFont2, VALUE='Auto Scale', UVALUE='autoscale')
InstrLab   = WIDGET_TEXT(ScaleZoomBase, /SCROLL, /WRAP, UVALUE='Instr', FONT=baseFont1, XSIZE=65, YSIZE=2)

; Base for all buttons and radio buttons on the left side
RightButtonsBase = WIDGET_BASE(MAINBase1, /COL, TITLE='RightButtons', UVALUE='RightButtons',event_pro = 'right_event');SPACE=5, XSIZE=95,/BASE_ALIGN_CENTER,

; Line1 Text labels at bottom of image view
ImgInfoBase = WIDGET_BASE(RightButtonsBase, /col, TITLE='ImgInfo', UVALUE='ImgInfoBase')

label = widget_label(ImgInfoBase,value='Particle Information')
infoBase1 = widget_base(ImgInfoBase,/row)
pixelID = CW_field(infoBase1,/col,title = 'Pixel location',value = '',xsize=8)
ValueID = CW_field(infoBase1,/col,title='Value',value = '',xsize=5)

infoBase2 = widget_base(ImgInfoBase,/row)
minID = CW_field(infoBase2,/col,title = 'Min/Max',value = '',xsize=5)
maxID= CW_field(infoBase2,/col,title='Max',value = '', xsize=5)

infoBase3 = widget_base(ImgInfoBase,/row)
meanID = CW_field(infoBase3,/col,title = 'Mean',value = '',xsize=5)
sigmaID = CW_field(infoBase3,/col,title='Variance',value = '',xsize=5)

infoBase4 = widget_base(ImgInfoBase,/row)
cutOffID = CW_field(infoBase4,/col,title = 'Cut-Off%',value = '',xsize=3)
focusID = CW_field(infoBase4,/col,title='Focus%',value = '',xsize=3)

infoBase5 = widget_base(ImgInfoBase,/row)
HabitID = CW_field(infoBase5,/col,title = 'Crystal',value = '',xsize=6)
roundnessID = CW_field(infoBase5,/col,title = 'Roundess',value = '',xsize=14)

infoBase8 = widget_base(ImgInfoBase,/row)
rejectID = CW_field(infoBase8,/col,title = 'Reject',value = '',xsize=3)
iwcID    = CW_field(infoBase8,/col,title = 'Iwc',   value = '',xsize=8); added May 22,2008.

infoBase0 = widget_base(ImgInfoBase,/row)
ROIsizeID = CW_field(infoBase0,/col,title = 'ROI-Size(micron)',font = baseFont3,value='',xsize = 12)
;LocationID = CW_field(ImgInfoBase,/col,title='Frame Location',value='',xsize=19,font = baseFont3)

infoBase6 = widget_base(ImgInfoBase,/row)
perimeterID = CW_field(infoBase6,/col,title = 'Perimeter',value = '',xsize=5)
areaID = CW_field(infoBase6,/col,title = 'Area',value = '',xsize=6)

infoBase7 = widget_base(ImgInfoBase,/row)
lengthID = CW_field(infoBase7,/col,title = 'Length',value = '',xsize=4)
widthID = CW_field(infoBase7,/col,title = 'Width',value = '',xsize=4)

infoBase8 = widget_base(ImgInfoBase, /row)
h2dsID = CW_field(infoBase8, /col, title = '2DS ID H', value = '', xsize = 6)
v2dsID = CW_field(infoBase8, /col, title = '2DS ID V', value = '', xsize = 6)


WIDGET_CONTROL, tlb, CANCEL_BUTTON=BUTTONQUIT
WIDGET_CONTROL, tlb, /REALIZE

; Get drawable window index
WIDGET_CONTROL, MainView, GET_VALUE=MainViewID
WIDGET_CONTROL, MainView, SET_DRAW_VIEW=[0, 0]

widget_control,plotarea,get_value = plotID
xyouts,.5,.5,'Concentration series display',size=2.0,align=.5,/normal,font=0

widget_control, progress,get_value=progressWID

wset,MainViewID

; IDL version greater than 5.3 don't support GIF any more
IDLVersion = FLOAT(!VERSION.Release)
IF IDLVersion GT 5.3 THEN BEGIN
    case productNum of
        1: logofile = !SPEC_3VCPI_DIR + '/QLlogo.jpg' ; quicklook logo
        2: logofile = !SPEC_3VCPI_DIR + '/eXlogo.jpg' ; eXtractor Logo
        3: logofile = !SPEC_3VCPI_DIR + '/CLlogo.jpg' ; Classifier Logo
        else: print,'Error in product Number'
    endcase

    read_jpeg,logofile,logo,coltable
    tvlct,coltable
ENDIF ELSE BEGIN
    case productNum of
        1: logofile = !SPEC_3VCPI_DIR + '\QLlogo.gif'   ;quicklook logo
        2: logofile = !SPEC_3VCPI_DIR + '\eXLogo.gif' ; eXtractor Logo
        3: logofile = !SPEC_3VCPI_DIR + '\CLLogo.gif' ; Classifier Logo
        else: print,'Error in product Number'
    endcase

    read_gif,logofile,logo,r,g,b
    tvlct,r,g,b
ENDELSE

tv,rotate(logo,7);   ;rotate 270 degrees; maybe use read_jpeg,***,/order to eliminate this line.

Tmp2 = {SPECHead, Ver:0, Year:0, Month:0, DX:0, DY:0, Text:BYTARR(70)}

types = strmid(indgen(32),2)
crystalName = ["rej","sph","n2","n3","n4","n5","n6","n7","n8","n9","n10",$
    "n11","n12","col","plt","ice","sir","bir","ros","shx",$
    "bud","den","grp","agg","n24","n25","n26","n27","n28","n29","n30","n31"]


;types[1] = 'Water Drop'
;types[15]= 'ice'

printROI = {   DoIt:!false,$
    Flags:0,$
    printer:!false,$
    PageDX:-1,$
    PageDY:-1,$
    PageX:0, $
    PageY:0, $
    MaxDY:0, $
    PageNo:0,$
    PageZoom:1.0,$
    LeftMargin:[10,10],$
    View:OBJ_NEW(), $
    Model:OBJ_NEW(), $
    Model1:OBJ_NEW(), $
    Font1:OBJ_NEW(), $
    TimeText:OBJ_NEW(),$
    TimeText2:OBJ_NEW(),$
    TimeText3:OBJ_NEW(),$; added this in sept2, 2009 for 3VCPI
    TimeText4:OBJ_NEW(),$
    TimeText5:OBJ_NEW(),$; added this in April19, 2010 for 3VCPI
    ValueText:OBJ_NEW(),$
    Model2:OBJ_NEW(), $
    frameText:OBJ_NEW(),$
    timeline:'',$
    oldpageno:-1,$
    oldhour:0,$
    dayflag:0}

widgets = {    tlb:tlb,$
    filtered:filtered,$
    gradient:gradient,$
    plotarea:plotarea,$
    TIME1:TIME1,$
    TIME2:TIME2,$
    progress:lb4}

infoID = { ROIsizeID:ROIsizeID, pixelID:pixelID, minID:minID, meanID:meanID, cutOffID:cutOffID,HabitID:HabitID,$
    ;LocationID:LocationID, ValueID:ValueID, maxID:maxID, sigmaID:sigmaID, focusID:focusID, $;infoID:infoID}
    ValueID:ValueID, maxID:maxID, sigmaID:sigmaID, focusID:focusID, rejectID:rejectID,IwcID:IwcID,$
    areaID:areaID, perimeterID:perimeterID, roundnessID:roundnessID,lengthID:lengthID,widthID:widthID,h2dsID:h2dsID,v2dsID:v2dsID}

settings = {   YXAspect:1.0,$
    PixSize:1.0, $
    Mosaic:!false, $
    Pause:0.0, $
    DoStatFilt:1,$
    ArtifactReject:0, $
    OutofFocus:0, $
    PercCutOff:0, $
    ForceAllArtifact:0,$
    crystal:0}

spectra = { groupCnt:0L,$   ; number of groups of data, hence number of plots, this depends on the averaging period
    pGroup:ptr_new()}   ; points to first group in linked list

fsspdata={filename:' ',time:ptr_new(),binh:ptr_new(),bwd:ptr_new(),bins:ptr_new()}
TwoDCdata={filename:' ',time:ptr_new(),binh:ptr_new(),bwd:ptr_new(),bins:ptr_new(),Abinh:ptr_new(),Mbinh:ptr_new()}

StateInfo = { $
    InFileLun:-1,$              ; Input file logical unit number
    path:'',$                   ; main file path
    pFileScan:PTR_NEW(),$       ; points to the scan of the input file
    BkgPos:-1L, $               ; location of the background
    ImgPos:-1L, $               ; location of the frame displayed
    pImgPosIndx:ptr_new(),$     ; array indexing *pFilescan for images only
    pFrameData:ptr_new(),$      ; changed to structure of form {FrameHeader:FrameHeader,pFrame:pFrame} with pFrame a pointer array
    BackFrame:ptr_new(),$       ; pointer to the background frame structure
    backRemoved:!false,$        ; tracks if the background has been subtracted from the images
    pBackPosIndx:ptr_new(),$    ; array indexing *pFilescan for backgrounds only
    pBounds:ptr_new(),$         ; pointer to the bounds array containing the bounding box for each displayed particle
    TotImgCount:0L, $           ; number of frames in the file
    Widgets:widgets,$           ; some widget ID's
    Title:Title, $              ; title of the main base
    InFileName: '',$            ; name of input file
    roi_frameheader_version:25,$ ; version number for calcStrobeTime used by scanobj function. added by mo
    FileHead:Tmp2, $            ; main file header
    SubBkgd:!true,$             ; controls if a background is subtracted from the roi
    SkipBkgd:!true,$            ; controls if backgrounds are skipped during frame advances
    DispMode:0, $               ; tracks mode for doing gradient opertions etc.
    MainView:MainView, $        ; widget for top level base
    MViewID:MainViewID, $       ; window ID for main draw area
    PlotID:plotID,$             ; window ID for concentration plot in GUI
    ProfID:-1,$                 ; window ID for profile window
    oldZoom:1.0,$               ; save old zoom value during mosaic
    zoom:-1.0, $                ; current zoom setting
    ApplyZoom:0,$               ; flag for use of zooming
    SchtimeID:SchtimeID,$       ; for search images by time added by mo Dec 2004
    zoomsliderID:ZoomSlider, $  ; widget ID of slider
    ZoomLabelID:zoomlabel, $    ; widget ID of zoom label
    sizeArray:ptrarr(1000),$    ; this pointer array must be large enough for the total number of seconds in the file
    scaleFactor:.000682667,$    ; deadtime count to seconds conversion factor, default=0.000682667
    PixSizeID:PixSizeWID,$      ; widget ID for pixel size field
    MosaicID:MosaicBtn, $       ; widget ID for mosaic button
    pLaserFlashCnt:ptr_new(),$  ; number of laser flashes per second and start time of array
    fileLabel:fileLabel,$       ; label at top of gui showing filename
    HKLOG_request:HKLOG_request,$ ; flag to output HK ASCII log file
    autoscale: 1, $
    ScaleMinID:MinSlider,$
    ScaleMaxID:MaxSlider, $
    ImgSliderID:ImgNumSlider,$
    AspectID:AspectWID, $
    MouseCount: 0, $            ; tracks steps in mouse button clicks
    harmonics_flag:harmonics_flag,$ ; flag to indicate if harmonic plot should be displayed
    harmonicWinID:0,$           ; window ID for harmonics plot
    distanceWinID:0,$           ; window ID for distance plot
    progressWID:progressWID,$   ; window ID for progress bar
    XSection:0, $               ; flag for cross section use
    InstLabel:InstrLab,$        ; widget ID for text widget for information in bottom of GUI
    FirstImgPos:0L, $           ; first image position
    LastImgPos:0L, $            ; last frame number
    tiffpath:'',$               ; pathname for tiff files
    pConc:ptr_new(),$           ; pointer to the concentration array
    manual:!false,$             ; flag to block access to right mouse clicks if manul dialog is up
    types:types,$               ; labels for crystal habits see above
    PrintROI:printROI,$         ; see structure above
    Settings:settings,$         ; see structure above
    spectra:spectra,$           ; structure for computing spectra
    pTimeSeries:ptr_new(),$     ; pointer to time series data
    ObjFile:'',$                ; name holder for OBJ file
    ObjLUN:-1,$                 ; LUN for OBJ file
    displayPerim:!false,$       ; flag for display of perimeter
    pObjList:ptr_new(),$        ; array that marks a frame as having obj information ( if true)
    pObjData:ptr_new(),$        ; obj info for current frame, updated with frame
    ASCIIFile:'',$              ; ascii file name for the output of extracted parameters
    AsciiLUN:-1,$               ; FIELD TO HOLD lun OF OUTPUT ascii FILE
    logLUN1:-1,$                ; LUN of output CSV file
    logLUN2:-1,$                ; LUN of output CSV file
    asciiLOGfile:'',$           ; name of log file
    asciiHKFile:'',$            ; name of HK log file
    HKLUN:-1,$                  ; LUN of HK log file
    Bkgs_exist:!false,$         ; flag to true if backgrounds exist in this file
    updateFile:!true,$          ; flag for file updating
    pTimeInfo:ptr_new(),$       ; pointer to structure with process time period info
    infoID:infoID,$             ; holds all the widgetID's of the lower info fields
    XS_1:[0,0],$                ; holds the coords for first mouse click for cross sections in device coords
    Xarr_1:[0,0],$              ; holds the coords for first click for cross sections in array coords
    XS_particle:0,$             ; holds the index into the particle for cross section
    ReDrawn:!false,$            ; boolean for a frame redraw
    XS_coords:[-1,-1,-1,-1],$   ; [xs,xe,ys,ye] coords of last profile line drawn
    XStep:0,$                   ; tracks what step of the cross sectioning process we are in possible values 0,1
    CurrentROIIndex:-1,$        ; index to the current ROI that is under the mouse pointer
    ROI:!false,$                ; flag to indicate if the mouse pointer is over a valid roi
    demo:demo,$                 ; flag for demo mode
    appname:appname,$           ; application name
    version:version,$           ; app version number
    date:{year:0,month:0,day:0}, $ ; date from file name (determined in Loadfile)
    seperator:'',$              ; OS dependant file sepearator (determined in Loadfile)
    haspFile:'',$               ; full path and file name for HASP dll
    TS_correct:TS_correct,$     ; command line flag to subtract 256 from missed value
    productNum:productNum,$     ; indicates which version is enabled 1=QuickLook, 2=eXtractor, 3=Classifier, ...
    waittime:1,$                ; duration (in seconds) that the gifs stay of the screen when flashed.
    AUTOEXTRACT:AUTOEXTRACT,$   ; flag to indicate if the  autoextraction feature is enabled
    acceptFlag:!false,$         ; Test to see if acceptance criteria is turned on.  CS
    skipPage:!false,$           ;added to allow skipping output pages JS
    pageCount:0,$               ; keeps track of how many pages to print JS
    crystalName:crystalName,$   ;}   ; string array with crystal names JS 11/2001
    fsspdata:fsspdata,$
    twodcdata:twodcdata,$
    p3ViewState:ptr_new(),$     ;; pointer to event structure for 3 view widget
    batch_png_criteria:''$   ; for batch png page processing.
    }


WIDGET_CONTROL, AutoScale, SET_BUTTON=1
WIDGET_CONTROL, tlb, SET_UVALUE=ptr_new(StateInfo,/no_copy)


if(demo)then widget_control,MAINBase1,timer = 600  ; timer mode provides 7 minutes of use

; Load blue color table
loadct, !ct_CPI, /silent
tvlct,255,255,0,255
; Hand off control of the widget to the XMANAGER:
XMANAGER, appname, tlb, /NO_BLOCK, event_handler = 'main_event'

END

