

pro DoBasescan1StepForall_allbasefiles,ptr
    Common  DataBlock,alldataH,alldataV,ADataH,ADataV,FirstData,LastData,StripData,FirstDataV,LastDataV,StripDataV,OneHzH,OneHzV
    Common  HKdatablock,HKseconds,HKtas,num_hrz_dect,num_vrt_dect,pHKtimefpos,H50micron
    Common  DataBlock3,PHdata,PVdata,Hpc,Vpc

    device, CURSOR_STANDARD= !ARROW_CURSOR  ; show hourglass while we process the data

    ;get the output options first for later to use.
    ice_archive_options_ptr=archive_ice_pop_up(value=1);   pop_up is in creatzoom.pro

    kkk = create_output_png_criteria(value=1)
    criteria_text = (*(*kkk).localstate).text
    ; get all data files and start a for loop.

    get_all_data_files

    for i=0,file_counts-1 do begin

        ThisFile=filenames(i)
        (*ptr).currentFname=ThisFile

        ; scan the hK data of this file.

        seconds=(*pHKtimefpos).seconds;    ;this is miliseconds since midnight.
        filepos=(*pHKtimefpos).fpos

        startfpos=filepos(0)
        endfpos=max(filepos)

        basefilename=(*ptr).currentFname

        ;get the starttime end time string to make a direct for the processd time period.
        (*ptr).StartTime=1
        (*ptr).EndTime=1

        StartTimestring=SPEC_seconds2HHMMSS((*ptr).StartTime)
        EndTimeString  =SPEC_seconds2HHMMSS((*ptr).EndTime); CURRENTFNAME    STRING    'C:\bjwmo_playback\3V_2DS\base140714040900.2DSCPI'


        basefile=file_basename((*ptr).currentFname)
        substrs=strsplit(basefile,'.',/extract)
        extension=substrs(n_elements(substrs)-1);   the extension can be 2DS, 2DSCPI, 2D128 and HVPS.

        folder_name=strmid((*ptr).currentFname,0,strlen((*ptr).currentFname)-7)+'_'+StartTimestring+'_'+endtimestring+'\'

        ;find if there are any sorted file already genenerated in the directory for the same time period.
        results=file_search(folder_name+'Sorted*.'+extension,count=contG)

        if contG gt 0 then begin

            sortfile1=file_basename(results(0))
            if ContG ge 2 then sortfilen=file_basename(results(ContG-1)) else sortfilen='   '

            message=[['There are '+strtrim(string(contG),2)+ ' sorted file(s) already generated for this time period,'],$
                ['   '],$
                ['They are: '+sortfile1],$
                ['......    '+sortfilen],$
                ['      '],$
                ['Do you want to regenerate these SORTED files, or skip ahead ?'],$
                ['    '],$
                ['To skip ahead without redoing playback, Answer: Yes !'],$
                ['To regenerate the SORTED files,         Answer:  No !']]

            rrrr=dialog_message(message,/question)

        endif else rrrr='No'

        if rrrr eq 'No' then begin;  The folder is made in this call.
            basescan, basefilename, (*ptr).StartTime,(*ptr).EndTime,Startfpos, Endfpos
        endif


        ; above will finish generating all of the wanted sorted files.
        basescanfiles=file_search(folder_name,'Sorted*.'+extension)
        allOrKps='All'
        liqorice=(*ptr).ice
        info=(*ptr)

        ;now see if 1Hz files are needed to be generated.
        !autoarchive=1
        !autoarchive_png_only=0
        Do_overnight_auto_archiving_works_tc4,info,AllOrKps,liqorice,basescanfiles=basescanfiles,options=ice_archive_options_ptr,criteria_text=criteria_text

        !autoarchive=0
        !autoarchive_png_only=1
        Do_overnight_auto_archiving_works_tc4,info,AllOrKps,liqorice,basescanfiles=basescanfiles,options=ice_archive_options_ptr,criteria_text=criteria_text

        ; Please stop putting in popup messages!  Instead here is a printout and a stauts bar update
        print, 'SORTED File Generation Complete.'
        Widget_Control, info.statusID, DYNAMIC_RESIZE=1, Set_Value='SORTED File Generation Complete.'
        ;rrr=dialog_message('Processing Done !',/info)
    endfor;  end of for i=0, filecounts-1:

end;  DoBasescan1StepForall_allbaseFiles,ptr
;******************************************************************
