;*************************************************************************
PRO DrawAverageChart_SpecifyRange, ave_info, first_point, last_point

    Common  DataBlock,alldataH,alldataV,ADataH,ADataV,FirstData,LastData,StripData,FirstDataV,$
        LastDataV,StripDataV,OneHzH,OneHzV

    Widget_Control, ave_info.ZoomWindowDrawID, Get_Value=wid

    forward_function  SPEC_Nano2HMS_struct, strrepl
    ;---------------------------------------------------------
    ; The first time we plot this data, we're entering because
    ;  the user clicked two points for a zoom. So use those points.
    ;  (this will be indicated by zeros in the ave_info.Start/EndNanoSeconds)
    ; If we came here bacause the user clicked the UPDATE button, then
    ;  we're going to use the time settings from the plotting window
    ;  to select what time range we're going to show.
    ;----------------------------------------------------------
    ;Widget_Control, ave_info.statusID, DYNAMIC_RESIZE=1, Set_Value= "Calculating PSD Data"

    if (ave_info.StartNanoSeconds gt 0ULL OR ave_info.EndNanoSeconds gt 0ULL) then begin

        ts  = { _time_struct, $
            Hours: 0, $
            Minutes: 0, $
            Seconds: 0, $
            Milliseconds: 0, $
            Microseconds: 0, $
            Nanoseconds: 0 }

        starting_time_struct = ({_time_struct})
        ending_time_struct = ({_time_struct})

        a = where((*alldataH)[*].Nanoseconds gt ave_info.StartNanoSeconds, count)
        ; print, a(0), (*alldataH)[a[0]].NanoSeconds,ave_info.StartNanoSeconds
        b = where((*alldataH)[*].Nanoseconds le ave_info.EndNanoSeconds, count)
        if (count ge a(0) ) then begin
            first_point = a(0) >0
            last_point = count
        endif



        a = where((*alldataV)[*].Nanoseconds ge ave_info.StartNanoSeconds, count)
        print, a(0), (*alldataV)[a[0]].NanoSeconds,ave_info.StartNanoSeconds
        b = where((*alldataV)[*].Nanoseconds le ave_info.EndNanoSeconds, count)
        if (count ge a(0)) then begin
            print, count, (*alldataV)[a[0]].NanoSeconds,ave_info.EndNanoSeconds
            print, "Index range = ", a(0),count
            first_point_v = a(0)
            last_point_v = count
        endif else begin
            r = dialog_message(['Cannot Update!','Start Time later than End Time.','Please correct Start/End values.'],TITLE = 'Update Error')
            return
        endelse
        ; Regenerate the start/end time strings because they'll be slightly different
        ;   from the numbers shown with the double click zooming approach
        !ZOOM_START_STRING = SPEC_Nano2HMS(ave_info.StartNanoSeconds)
        !ZOOM_END_STRING = SPEC_Nano2HMS(ave_info.EndNanoSeconds)
    ENDIF ELSE BEGIN
        ; Regenerate the start/end time strings because they'll be slightly different
        ;   from the numbers shown with the double click zooming approach

        ave_info.StartNanoSeconds = !ZOOM_START_NS
        ave_info.EndNanoSeconds = !ZOOM_END_NS
        !ZOOM_START_STRING  = SPEC_Nano2HMS_struct(!ZOOM_START_NS,starting_time_struct)
        !ZOOM_END_STRING =  SPEC_Nano2HMS_struct(!ZOOM_END_NS, ending_time_struct)

        ;added this by mo nov 15, 2005 for boolean logic.
        ;************************************************************
        Get_allindexs_and_boolean_subsetindexs,ave_info,Hallindex,Hsubindex,Hfactor,Vallindex,VsubIndex,Vfactor

        starttime=ave_info.startnanoseconds
        endtime  =ave_info.endnanoseconds

        Get_JustDeadtime_between_time1_time2,'H',starttime,endtime,Fullticks,SampleVolume,ThisTAS,ovldcnts,$
            StartTicks,EndTicks,DT_mask,DT_ovfl,DT_L1,DT_bad1,DT_bad2,DT_bad3,total_AccDeadtime
        ave_info.Hdeadtime=total_accdeadtime;HDT_ovfl+HDT_mask+HDT_L1+HDT_bad1+HDT_bad2; Hdeadtimemo
        ave_info.HDT_ovfl=DT_ovfl
        ave_info.HDT_mask=DT_mask; seconds_per_tick
        ave_info.HDT_L1=DT_L1;*seconds_per_tick
        ave_info.HliveV=sampleVolume
        ave_info.HDT_bad1=DT_bad1;*seconds_per_tick
        ave_info.HDT_bad2=DT_bad2;*seconds_per_tick


        Get_JustDeadtime_between_time1_time2,'H',starttime,endtime,Fullticks,SampleVolume,ThisTAS,ovldcnts,$
            StartTicks,EndTicks,DT_mask,DT_ovfl,DT_L1,DT_bad1,DT_bad2,DT_bad3,total_AccDeadtime

        ave_info.Vdeadtime=total_AccDeadtime; VDT_ovfl+VDT_mask+VDT_L1+VDT_bad1+VDT_bad2;Vdeadtimemo
        ave_info.VDT_ovfl=DT_ovfl;*seconds_per_tick
        ave_info.VDT_mask=DT_mask;*seconds_per_tick
        ave_info.VDT_L1=DT_L1;*seconds_per_tick
        ave_info.VliveV=SampleVolume
        ave_info.VDT_bad1=DT_bad1;*seconds_per_tick
        ave_info.VDT_bad2=DT_bad2;*seconds_per_tick


        ;***************************************************************

        IF (!CURRENT_CHANNEL EQ !H_CHART) THEN begin
            totn=n_elements((*alldataV))
            a = where((*alldataV)[*].Nanoseconds ge !ZOOM_START_NS, count1)
            first_point_v = (totn-count1-1LL) >0LL; takes teh bigger one.index should be 0 or greatere than 0.
            b = where((*alldataV)[*].Nanoseconds le !ZOOM_END_NS, count2)
            last_point_v = count2-1LL
        ENDIF ELSE BEGIN
            ;Calculate the first/last_points for the horizontal channel based on the time range
            ;the user clicked from the vertical graph.
            first_point_v = first_point
            last_point_v = last_point

            totn=n_elements((*alldataH))
            a = where((*alldataH)[*].Nanoseconds ge !ZOOM_START_NS, count1)
            first_point=(totn-count1-1LL) >0LL
            b = where((*alldataH)[*].Nanoseconds le !ZOOM_END_NS, count2)
            last_point=count2-1LL
        ENDELSE
    ENDELSE ; endelse for if ave_info_startnanoseconds gt 0LL

    ;-------------------------------------------------------------------------
    ; Save the index values for the range of data we're zoomed into
    ;  so that it can also be used for the plotting of the time series plots.
    ;-------------------------------------------------------------------------
    ave_info.H_First_Index = first_point
    ave_info.H_Last_Index = last_point
    ave_info.V_First_Index = first_point_v
    ave_info.V_Last_Index = last_point_v

    ;add this to fix the bug for cases of bead test data files
    last_point =last_point < (n_elements((*alldataH))-1LL);  take the smaller value.
    last_point =last_point > (first_point+1LL)  ; above first_point could be greater than last_point, chris code.

    ;---------------------------------------------------------------------------------------
    ; Fill in the start/end time text boxes
    ;---------------------------------------------------------------------------------------

    !ZOOM_START_STRING  = SPEC_Nano2HMS_struct(ave_info.StartNanoSeconds ,starting_time_struct)
    !ZOOM_END_STRING =  SPEC_Nano2HMS_struct(ave_info.EndNanoSeconds, ending_time_struct)

    ;a = SPEC_Nano2HMS_struct((*alldataH)[first_point].Nanoseconds,starting_time_struct)

    Widget_Control, ave_info.StartHoursID, SET_VALUE = string(starting_time_struct.Hours)
    Widget_Control, ave_info.StartMinutesID, SET_VALUE = string(starting_time_struct.Minutes)
    Widget_Control, ave_info.StartSecondsID, SET_VALUE = string(starting_time_struct.Seconds)
    Widget_Control, ave_info.StartMillisecondsID, SET_VALUE = string(starting_time_struct.Milliseconds)

    ;a = SPEC_Nano2HMS_struct((*alldataH)[last_point].Nanoseconds, ending_time_struct)
    Widget_Control, ave_info.EndHoursID, SET_VALUE = string(ending_time_struct.Hours)
    Widget_Control, ave_info.EndMinutesID, SET_VALUE = string(ending_time_struct.Minutes)
    Widget_Control, ave_info.EndSecondsID, SET_VALUE = string(ending_time_struct.Seconds)
    Widget_Control, ave_info.EndMillisecondsID, SET_VALUE = string(ending_time_struct.Milliseconds)



    plot_string =  !ZOOM_START_STRING +  $
        "--" + !ZOOM_END_STRING
    plot_string2 =  strtrim(string(last_point - first_point + 1),2) + ' H , ' + $
        strtrim(string(last_point_v - first_point_v + 1),2) +  ' V Data Points'
    HpartCont='H='+strtrim(string(last_point - first_point + 1),2)
    VpartCont='V='+strtrim(string(last_point_v - first_point_v + 1),2)

    delta_s =(ave_info.endnanoseconds-ave_info.startnanoseconds)/1000000000.0
    if delta_s lt 10000.0 then  $
        delta_s ='dT='+string(delta_s,format='(F6.1)')+'s'  $
        else delta_s ='dT='+string(delta_s,format='(I6)')+'s'

    message_string = 'Zoomed data from ' + !ZOOM_START_STRING +  $
        " to " + !ZOOM_END_STRING + ' , ' + plot_string2

    ; stop
    Widget_Control, ave_info.ZoomWindowID, TLB_SET_TITLE = message_string

    widget_control, /hourglass;  show hourglass while following is processing. june 18, 2005

    ;    GetTasChanges, curr_data,0,num_data_points,changes
    ;  ENDIF
    ;  IF (!CURRENT_CHANNEL EQ !V_CHART) THEN  BEGIN

    last_point_v =last_point_v < (n_elements((*alldataV))-1LL);  take the smaller value.
    if first_point_v ge last_point_v then first_point_V =last_point_V-1

    ;---------------------------------------------------------
    ; Now calculate the total air volume for this data file (SVdefault)
    ;  Include the TAS changes in the calculation
    ;---------------------------------------------------------
    NanosecondsPerSecond = 1000000000.0D
    pxs = 0.01D
    dww = !DWW_main; 63.0mm in 2D-S, 50.8 mm in 3V-CPI adjust in a3VCPIView.pro
    SAdefault = 128.0D * pxs * dww
    SVdefault = 0.0D
    time_sum = 0L
    chart_name = ""
    IF (!CURRENT_CHANNEL EQ !H_CHART) THEN chart_name = 'Horizontal'
    IF (!CURRENT_CHANNEL EQ !V_CHART) THEN chart_name = 'Vertical'

    ;Qixu Mo re-selected the particles within the user selected start--endtimes of ave_info.startnanoseconds, ave_info.endnanoseconds
    ;for first time to zoom, ave_inf has no ave_info.startNanosecond
    if ave_info.startNanoseconds eq 0 and ave_info.endnanoseconds eq 0 then begin
        ave_info.startnanoseconds=(*alldataH)[first_point].Nanoseconds
        ave_info.endnanoseconds=(*alldataH)[last_point].Nanoseconds
    endif

    index=where( (*alldataH).Nanoseconds gt ave_info.StartNanoSeconds and (*alldataH).Nanoseconds le ave_info.endNanoSeconds, count)
    if count gt 0 then begin
        Svdefault=ave_info.HliveV;   svdefault=livetime_volumeh
        has_Hdata=1
    endif else begin
        curr_data=[0]
        deadtimeh=0.0
        livetime_volumeh=99999.0
        total_volumeh=99999.0
        SVdefault_h =livetime_volumeh
        has_Hdata=0
    endelse

    index=where( (*alldataV).Nanoseconds gt ave_info.StartNanoSeconds and (*alldataV).Nanoseconds le ave_info.endNanoSeconds, count)
    if count gt 0 then begin
        SVdefault_v = ave_info.VliveV;             ;livetime_volumev
        has_Vdata=1
    endif else  begin
        curr_data_v=[0]
        deadtimev=0.0
        livetime_volumev=99999.0
        total_volumev=99999.0
        SVdefault_v =livetime_volumev
        has_Vdata=0
    endelse

    WSet, wid
    bluecolor = GetColor("Navy", !D.Table_Size-2)
    redcolor = GetColor("Red", !D.Table_Size-2)
    whitecolor = GetColor("White", !D.Table_Size-2)

    erase,color='ffffff'x  ; get background to white

    XYOUTS,240,290,"REDRAWING ",color=bluecolor, size=4 , /device
    FOR i=0,5 DO BEGIN  ; seems to be needed to get the "REDRAW" to fully appear
        PRINT, " "
    ENDFOR

    pxs=0.01D ; in mm
    strbsz = 0.01D ; in mm
    alpha = 0.115D
    beta = 1.218D
    microns_per_pixel = 10


    current_multi = !P.MULTI
    num_plots_per_row = 2
    num_plots_per_column = 2
    current_plot_position = 0
    !P.MULTI = [current_plot_position, num_plots_per_row, num_plots_per_column, 0, 0]
    !X.OMARGIN = [1.5,0.0]  ; We need this because the Area plot X axis label extends off the left edge of the window


    ;-------------------------------------------------------------------
    ; Determine which particles we're plotting, H or V
    ;-------------------------------------------------------------------

    mincntsperbin = ave_info.AveMinCountPerBin
    minbinwid = ave_info.AveMinBinSize
    xmin = ave_info.AveXMin
    xmax = ave_info.AveXMax
    xlog_setting = ave_info.AveXLog
    ylog_setting = ave_info.AveYLog


    ;***************************************** replace following with the new plots.
    Draw_default_averaged_psd,ave_info,'M1'
    ;********************************************************************************************

end ; end of plot the 4 psd  frames
;*****************************************************************************

pro ZoomChartASCII_event, event

    ;r = dialog_message(['Not yet implemented','ASCII File Created:','XXXX'],TITLE = 'ASCII file generation')
    ;return

    Widget_Control, event.top, Get_UValue=ave_info, /No_Copy  ; get our info structure
    Widget_Control, event.handler, Get_UValue=info, /No_Copy  ; get our info structure
    ;r = dialog_message(['Not yet implemented','ASCII File Created:','XXXX'],TITLE = 'ASCII file generation')
    ;stop
    generate_zoomed_ascii, info, ave_info


    Widget_Control, event.handler, Set_UValue=info, /No_Copy  ; release our info structure
    Widget_Control, event.top, Set_UValue=ave_info, /No_Copy  ; release our info structure
end

;*****************************************************************************
pro ZoomChartPNG_event, event
    Widget_Control, event.top, Get_UValue=ave_info, /No_Copy  ; get our info structure

    ;--------------------
    ; Save the PSD chart
    ;--------------------
    Widget_Control, ave_info.ZoomWindowDrawID, Get_Value=wid
    wset, wid

    fname = "PSD-" + ave_info.BaseFilenameString + '-' +ave_info.StartTimeString + ' TO ' + ave_info.EndTimeString

    ;----------------------------------------------------------
    ; Lets store the PNG files in their own subdirectory under the
    ;   directory where the .BIN files used for their creation are located.


    PUSHD, !currentHPname    ; change our path to the directory where the .BIN files we're using are located
    valid = 0
    ON_IOERROR, file_problem
    file_mkdir, 'PNG'   ; create (if it's not already there) the directory to store PNG's in
    cd,'PNG'            ; make this our current directory
    I = TVRead(wid=wid, /PNG, Filename= fname, DialogString = "Saving PSD Chart")
    valid = 1
    file_problem: if valid eq 0 then begin
        r = dialog_message('Error, cannot create directory PNG, or cannot create the PNG file!',TITLE = 'Update Error')
    endif
    POPD
    ON_IOERROR, NULL


    ;--------------------
    ; Save the TIME SERIES chart
    ;--------------------
    Widget_Control, ave_info.ZoomWindowSeriesDrawID, Get_Value=wid
    wset, wid

    ; Variables that can be used to generate the filename

    ;ave_info.StartTimeString = !ZOOM_START_STRING
    ;ave_info.EndTimeString = !ZOOM_END_STRING
    ;ave_info.BaseFilenameString = strmid(!CurrentHFname,strlen(!CurrentHPname)-5)
    ;ave_info.NumDataPointsH = last_point - first_point + 1
    ;ave_info.NumDataPointsV = last_point_v - first_point_v + 1

    fname_tms = "TMS-" + ave_info.BaseFilenameString + '-' +ave_info.StartTimeString + ' TO ' + ave_info.EndTimeString


    ;----------------------------------------------------------
    ; Lets store the Time series files in their own subdirectory under the
    ;   directory where the .BIN files used for their creation are located.


    PUSHD, !currentHPname    ; change our path to the directory where the .BIN files we're using are located
    valid = 0
    ON_IOERROR, file_problem2
    file_mkdir, 'PNG'   ; create (if it's not already there) the directory to store PNG's in
    cd,'PNG'            ; make this our current directory
    I = TVRead(wid=wid, /PNG, Filename= fname_tms, DialogString = "Saving Time Series Chart")
    valid=1
    file_problem2: if valid eq 0 then begin
        r = dialog_message('Error, cannot create directory PNG, or cannot create the PNG file!',TITLE = 'Update Error')
    endif
    POPD
    ON_IOERROR, NULL



    Widget_Control, event.top, Set_UValue=ave_info, /No_Copy  ; release our info structure
end
;*****************************************************************************

pro ZoomChartTimeshift_event, event


    Common DataBlock, alldataH, alldataV, ADataH, ADataV, FirstData, LastData, StripData, FirstDataV, LastDataV, StripDataV, OneHzH, OneHzV


    Widget_Control, event.top, Get_UValue=ave_info, /No_Copy  ; get our info structure
    ;Widget_Control, event.handler, Get_UValue=info, /No_Copy ; get our info structure

    ; But the (*alldataH)/V also contains dummy particles that have .area = -100 or -101
    ; as indicators that it is a dead time start/stop indicator. So we have to
    ; remove the deadtime entries in the (*alldataH)/V before we generate the arrays
    ; that will be used for the timeshift processing.



    dt0=(ave_info.endnanoseconds-ave_info.startnanoseconds)/1000000000.0

    if dt0 gt 120.0 then begin
        my_message=[['The time period is too long, it may take hours '],$
            ['to process. Limit time to be less than 120 seconds.']]
        rr=dialog_message(my_message,/information)
        Widget_Control, event.top, Set_UValue=ave_info, /No_Copy  ; release our info structure
        return
    endif

    Widget_Control, /hourglass;    ;show hour glass while following line are running.

    bead_size=!beadsize

    Do_n_by_n_time_shift_correlation_plots,1,ave_info,bead_size
    wait,3
    Do_n_by_n_time_shift_correlation_plots,3,ave_info,bead_size
    wait,3
    Do_n_by_n_time_shift_correlation_plots,7,ave_info,bead_size
    ;get_stereo_pairs,curr_data,curr_data_V,Toffset,deltaT,LPercent,Hindex,Vindex
    ; stop
    ;display_stereo_particle_pairs,curr_data,curr_data_V,Hindex,Vindex
    ;************************************************************************************************
    Widget_Control, event.top, Set_UValue=ave_info, /No_Copy  ; release our info structure

end ; ZoomChartTimeshift_event

pro  Do_n_by_n_time_shift_correlation_plots,ngrid,ave_info,bead_size
    Common DataBlock, AllDataH, AllDataV, ADataH, ADataV, FirstData, LastData, StripData, FirstDataV, LastDataV, StripDataV, OneHzH, OneHzV


    gridvals = intarr(ngrid, ngrid) ; array to hold the timeshift offsets

    if ngrid eq 7 then begin
        delta_n =18;  for 3 x3  ; 18 for 7x7 regions.  18;42
    endif
    if ngrid eq 3 then begin
        delta_n =42;  for 3 x3  regions ;  42
    endif

    if ngrid eq 1 then begin
        delta_n=128
    endif

    ;*****************************************************************************************
    index=where((*alldataV).nanoseconds gt ave_info.startnanoseconds and $
        (*alldataV).nanoseconds le ave_info.endnanoseconds, contG)

    if contG gt 0 then begin
        V_area0 = (*alldataV)[index].area
        V_time0 = (*alldataV)[index].probecounter
        V_length0 = (*alldataV)[index].Nslice
        V_pc10    = (*alldataV)[index].PC1;   ;particle image center for stere-particles-timeshift.
    endif else  begin
        rr=dialog_message('NO V particles, can not do cross co-relation',/information)
        Widget_Control, event.top, Set_UValue=ave_info, /No_Copy  ; release our info structure
        return
    endelse

    ;******************************************************************************************
    ;  replace the above with the criteria subset data.

    if !calibration eq 1 then begin
        if (*ave_info.Vsubindex)(0) ne -1 then begin
            V_area0   = (*alldataV)[*ave_info.Vsubindex].area
            V_time0   = (*alldataV)[*ave_info.Vsubindex].probecounter
            V_length0 = (*alldataV)[*ave_info.Vsubindex].Nslice
            V_pc10    = (*alldataV)[*ave_info.Vsubindex].PC1;   ;particle image center for stere-particles-timeshift.
            V_focus0  = (*alldataV)[*ave_info.Vsubindex].focus
        endif else begin
            rr=dialog_message('NO V particles, can not do cross co-relation',/information)
            Widget_Control, event.top, Set_UValue=ave_info, /No_Copy  ; release our info structure
            return
        endelse
    endif

    ;******************************************************************************************
    bluecolor = GetColor("Navy", !D.Table_Size-2)
    redcolor = GetColor("Red", !D.Table_Size-2)
    whitecolor = GetColor("White", !D.Table_Size-2)
    ;erase,color='ffffff'x  ; get background to white

    !P.CHARSIZE=1.0
    !P.multi=[0,1,1]



    Vresult=histogram(V_pc10,binsize=1,min=0,max=128)
    xxx=indgen(n_elements(Vresult))
    ymin=min(Vresult,max=ymax)
    !X.tickname=['0','16','32','48','64','80','96','112','128']
    !X.ticks=8

    window,/free,xsize=72*8,ysize=72*5,title='V-channel particle center location distribution'

    plot,xxx,Vresult,color=redcolor,xrange=[0,128],xstyle=1,yrange=[ymin,ymax],$
        title=' V-Particle Histogram ' ,psym=2,$
        xtitle='Particle"s Center location, Pixels',ytitle='Counts',$
        subtitle=my_subtitle,background= whitecolor

    xyouts, 2,0.8*ymax,ave_info.criteria.label,color=bluecolor,charsize=0.8

    WRITE_png,!currentHPname+'png\Timeshift_all_V_particles_histogram.png',tvrd(true=1)


    ;****************************************************************************************
    N40=80LL
    index=where((*alldataH).nanoseconds gt ave_info.startnanoseconds - N40*200LL and $
        (*alldataH).nanoseconds le ave_info.endnanoseconds   + N40*200LL, contG)

    if contG gt 0 then begin
        H_area0   = (*alldataH)[index].area
        H_time0   = (*alldataH)[index].probecounter
        H_length0 = (*alldataH)[index].Nslice
        H_pc10    = (*alldataH)[index].PC1;   ;particle image center for stere-particles-timeshift.
    endif else  begin
        rr=dialog_message('NO H particles, can not do cross co-relation',/information)
        Widget_Control, event.top, Set_UValue=ave_info, /No_Copy  ; release our info structure
        return
    endelse

    ;*********************************************************************************************
    ;replace above part with following criteria part
    ;****************************************************************************************
    if !calibration eq 1 then begin
        saved_ave_info=ave_info
        ave_info.startnanoseconds=ave_info.startnanoseconds-N40*200LL
        ave_info.endnanoseconds=ave_info.endnanoseconds+N40*200LL

        Get_allindexs_and_boolean_subsetindexs,ave_info,Hallindex,Hsubindex,Hfactor,Vallindex,VsubIndex,Vfactor

        if(*ave_info.Hsubindex)(0) ne -1 then begin
            H_area0   = (*alldataH)[*ave_info.Hsubindex].area
            H_time0   = (*alldataH)[*ave_info.Hsubindex].probecounter
            H_length0 = (*alldataH)[*ave_info.Hsubindex].Nslice
            H_pc10    = (*alldataH)[*ave_info.Hsubindex].PC1;   ;particle image center for stere-particles-timeshift.
            H_focus0  = (*alldataH)[*ave_info.Hsubindex].focus
            ave_info=saved_ave_info
        endif else begin
            rr=dialog_message('NO H particles, can not do cross co-relation',/information)
            ave_info=saved_ave_info
            Widget_Control, event.top, Set_UValue=ave_info, /No_Copy  ; release our info structure
            return
        endelse
    endif

    ; plot out all H particle center location distribution


    Hresult=histogram(H_pc10,binsize=1,min=0,max=128)
    xxx=indgen(n_elements(Hresult))
    ymin=min(Hresult,max=ymax)
    !X.tickname=['0','16','32','48','64','80','96','112','128']
    !X.ticks=8

    window,/free,xsize=72*8,ysize=72*5,title='H-channel particle center location distribution'

    plot,xxx,Hresult,color=redcolor,xrange=[0,128],xstyle=1,yrange=[ymin,ymax],$
        title=' H-Particle Histogram  ',psym=2,$
        xtitle='Particle"s Center location, Pixels',ytitle='Counts',$
        subtitle=my_subtitle,background= whitecolor

    xyouts, 2,0.8*ymax,ave_info.criteria.label,color=bluecolor,charsize=0.8

    WRITE_png,!currentHPname+'png\Timeshift_all_H_particles_histogram.png',tvrd(true=1)

    ;sorted the data
    indexsort=sort(H_time0)
    H_time0=H_time0(indexsort)
    H_area0=H_area0(indexsort)
    H_length0=H_length0(indexsort)
    H_pc10   =H_pc10(indexsort)

    indexsort=sort(V_time0)
    V_time0=V_time0(indexsort)
    V_area0=V_area0(indexsort)
    V_length0=V_length0(indexsort)
    V_pc10   =V_pc10(indexsort)

    ;******************************************************************************************

    for row_n = 1, ngrid do begin;  change 7 to 3
        for col_n = 1, ngrid do begin;  change 7 to 3

            hindex=where(H_pc10 ge (row_n-1)*delta_n  and H_pc10 le row_n*delta_n,contG)

            if contG eq 0 then begin
                rrr=dialog_message('No H particles centered at 42 to 80 pixels, try again',/information)

                goto, end_timeshift;;return
            endif else begin
                H_pc1=H_pc10(Hindex)
                H_time=H_time0(Hindex)
                H_area=H_area0(Hindex)
                H_length=H_length0(Hindex)
            endelse

            ;select V-particles with center at 48 to 80 pixel location.

            Vindex=where(V_pc10 ge (col_n-1)*delta_n and V_pc10 le col_n*delta_n,contG)

            if contG eq 0 then begin
                rrr=dialog_message('No V particles centered at 48 to 80 pixels, try again',/information)

                goto, end_timeshift;;return;return
            endif else begin
                V_pc1=V_pc10(Vindex)
                V_time=V_time0(Vindex)
                V_area=V_area0(Vindex)
                V_length=V_length0(Vindex)
            endelse

            ;*******************************************************************
            ; see what is the beginning time and end_time

            my_subtitle='File:'+ave_info.basefilenamestring+'.2DSCPI  Time: '+ave_info.starttimestring+'--'+ave_info.endtimestring
            ;------------------------------------------------
            ;***********************************************************************************************
            ;take out all bad particles
            index=where(H_length gt 0 and H_area gt 0.0, contG)

            if contG gt 0 then begin
                HLo1=H_length(index)
                Hnotime=H_time(index)
            endif else begin
                rr=dialog_message('NO Good H particles, can not do cross co-relation',/information)
                goto, end_timeshift;;return;return
            endelse

            H_count = n_elements(Hnotime)

            index=where(V_length gt 0 and V_area gt 0.0,contG)

            if contG gt 0 then begin
                VLo1=V_length(index)
                Vnotime=V_time(index)
            endif else begin
                rr=dialog_message('NO Good V particles,can not do cross co-relation',/information)
                Widget_Control, event.top, Set_UValue=ave_info, /No_Copy  ; release our info structure
                goto, end_timeshift;;return;return
            endelse

            V_count = n_elements(Vnotime)

            ;**************************************************************
            sumcoef=fltarr(2*N40+1); sumcoef=fltarr(2001)
            ;-------------------------------
            sumcoef3=fltarr(2*N40+1); sumcoef3=fltarr(2001)
            shift_val=indgen(2*N40+1)-N40;  shift_val=indgen(2001)-1000
            ;-------------------------------
            ;note we always let H-channel has at least 40 ticks more in the beginning and 40 ticks more at the end
            Hfirst_tick_num = Hnotime(0)-HLo1(0)+1LL;   begining of the H's first slice
            Vfirst_tick_num = Vnotime(0)-VLo1(0)+1LL;   begining of the V's first slice
            Hlast_tick_num  = Hnotime(n_elements(Hnotime)-1)
            Vlast_tick_num  = Vnotime(n_elements(Vnotime)-1)

            ; TAF not sure this is correct, V and Hlast_tick_num should have the beginning offset removed above
            ; also below doesn't make sense unless H and V are offset normalized

            if Hlast_tick_num gt Vlast_tick_num + N40 then begin
                max_tick_number=Hlast_tick_num
            endif else begin
                max_tick_number=Vlast_tick_num+ N40
            endelse

            if (Vfirst_tick_num ge (Hfirst_tick_num + N40)) then begin
                min_tick_num=Hfirst_tick_num
            endif else begin
                min_tick_num=(Vfirst_tick_num-N40) >0
            endelse

            nnn = max_tick_number - min_tick_num + 1LL

            HL1 = HLo1
            VL1 = Vlo1

            HV = bytarr(nnn)
            VV = bytarr(nnn)

            total_HV_particle_ticks = total(HL1) + total(VL1)

            ;offset the index of Hnotime and Vnotime tick numbers
            Htime=Hnotime-min_tick_num
            Vtime=Vnotime-min_tick_num

            ; Fill HV and VV arrays for time sync correllation
            ; These arrays are in ticks. The commented out code fills in particles with 1's,
            ; however we are now using only the leading edge of the particle for the correllation

            ;for i=0LL,n_elements(Htime)-1LL do begin
            ;    endindex = Htime(i)
            ;    startdex = endindex-HL1(i)+1LL
            ;    HV(startdex:endindex)=1
            ;endfor

            ;for i=0LL,n_elements(Vtime)-1LL do begin
            ;    endindex=Vtime(i)
            ;    startdex=endindex-VL1(i)+1LL
            ;    VV(startdex:endindex)=1
            ;endfor;  ;actually we only need the indexs of VV which is not zero; that may save a lot of memory.

            ;fill_flag = 0

            for i=0LL, n_elements(Htime)-1LL do begin
                endindex = Htime(i)
                startdex = endindex - HL1(i) + 1LL
                HV(startdex:endindex) = 1
            endfor

            for i=0LL, n_elements(Vtime)-1LL do begin
                endindex=Vtime(i)
                startdex=endindex - VL1(i) + 1LL
                VV(startdex:endindex) = 1
            endfor;  ;actually we only need the indexs of VV which is not zero; that may save a lot of memory.



            ;VV=HV; make them the same, all particles are stereo particles.
            ;short10=bytarr(10);    these are for debugging. It is good.
            ;VV=[short10,VV(0:n_elements(VV)-11)];  make VV lag behind HV 10 ticks.  This mean deltaT=-10
            ;VV=[VV(10:n_elements(VV)-1),short10]; make VV ahead of  HV 10 ticks.   this mean deltaT=10

            ; stop
            Time_shift_HV_VV_old, HV, VV, corr_max3, delta_T3, shift_val, cor_coef3
            sumcoef3=cor_coef3

            corr_max3=max(sumcoef3)
            index=where(sumcoef3 eq corr_max3)
            delta_Tp3=shift_val(index(0))

            gridvals[row_n-1, col_n-1] = delta_Tp3

            ;***************************************************************************
            ;stop
            ;normalized the sumcoef3
            sumcoef3=(sumcoef3/total_HV_particle_ticks)*200.0
            index=where(sumcoef3 gt 0.0,contG)

            if contG gt 0 then gt0sumcoef3=sumcoef3(index) else gt0sumcoef3=[0.1,0.1]
            miny=min(gt0sumcoef3)
            maxy=1.1*max(sumcoef3) < 100.0;   10.0^ceil(alog10(max(sumcoef3)))

            !X.tickname=['-40','-30','-20','-10','0','10','20','30','40']
            !X.ticks=8
            pathnm=strmid(!currentHpname,0,strlen(!currentHpname)-1)

            window,/free,xsize=72*8,ysize=72*5,title='H-V-correlation-coef_VS_time-shift, +ve delt_T means V-channel comes before H-channel'
            plot,shift_val,sumcoef3,color=redcolor,yrange=[miny,maxy],$
                ;title='DT='+strtrim(delta_Tp3,2)+' (+ve means V ahead) Particle Counts: H='+strtrim(H_count,2)+' V='+strtrim(V_count,2),$
                title='H' + strtrim(string(row_n),2) + 'V'+strtrim(string(col_n),2) + ' DT='+strtrim(delta_Tp3,2)+' (+ve means V ahead) Particle Counts: H='+strtrim(H_count,2)+' V='+strtrim(V_count,2),$
                xtitle='Time shift,ticks, (one tick is time for particle pass 10 microns)',ytitle='H-V "Correlation"',$
                subtitle=my_subtitle,background= whitecolor
            xyouts, -38,0.8*maxy,ave_info.criteria.label,color=bluecolor,charsize=0.8

            junk=findfile(!currentHPname+'png\*.*')

            if strlen(junk(0)) eq 0 then FILE_MKDIR,!currentHPname + "png\"
            WRITE_png,!currentHPname+'png\Time_shift_'+strtrim(string(ngrid),2)+'_H'+strtrim(string(row_n),2)+'V'+strtrim(string(col_n),2)+'.png',tvrd(true=1)

            Hresult=histogram(H_pc1,binsize=1,min=0,max=128)
            xxx=indgen(n_elements(Hresult))
            ymin=min(Hresult,max=ymax)

            !X.tickname=['0','16','32','48','64','80','96','112','128']
            !X.ticks=8

            window,/free,xsize=72*8,ysize=72*5,title='H-channel particle center location distribution'

            plot,xxx,Hresult,color=redcolor,xrange=[0,128],xstyle=1,yrange=[ymin,ymax],$
                title='DT='+strtrim(delta_Tp3,2)+' H-Particle Histogram  H='+strtrim(H_count,2),$
                xtitle='Particle"s Center location, Pixels',ytitle='Counts',$
                subtitle=my_subtitle,background= whitecolor

            xyouts, 2,0.8*ymax,ave_info.criteria.label,color=bluecolor,charsize=0.8

            WRITE_png,!currentHPname+'png\Timeshift_'+strtrim(string(ngrid),2)+'_H_'+strtrim(string(row_n),2)+'_histogram.png',tvrd(true=1)
            wait,1
            wdelete, !D.window

            Vresult=histogram(V_pc1,binsize=1,min=0,max=128)
            xxx=indgen(n_elements(Vresult))
            ymin=min(Vresult,max=ymax)
            !X.tickname=['0','16','32','48','64','80','96','112','128']
            !X.ticks=8

            window,/free,xsize=72*8,ysize=72*5,title='V-channel particle center location distribution'

            plot,xxx,Vresult,color=redcolor,xrange=[0,128],xstyle=1,yrange=[ymin,ymax],$
                title='DT='+strtrim(delta_Tp3,2)+' V-Particle Histogram  V='+strtrim(V_count,2),$
                xtitle='Particle"s Center location, Pixels',ytitle='Counts',$
                subtitle=my_subtitle,background= whitecolor

            xyouts, 2,0.8*ymax,ave_info.criteria.label,color=bluecolor,charsize=0.8

            WRITE_png,!currentHPname+'png\Timeshift_V_'+strtrim(string(col_n),2)+'_histogram.png',tvrd(true=1)

            wait,1
            wdelete, !D.window

            ;find the steoro pairs of the particles
            index=where( (*AllDataH).Nanoseconds gt ave_info.StartNanoSeconds and (*AllDataH).Nanoseconds le ave_info.endNanoSeconds, count)

            if count gt 0 then begin
                curr_data=(*alldataH)(index)
                curr_data = curr_data(sort(curr_data[*].Nanoseconds))
            endif else begin
                curr_data=[0]
            endelse

            index=where( (*alldataV).Nanoseconds gt ave_info.StartNanoSeconds and (*alldataV).Nanoseconds le ave_info.endNanoSeconds, count)

            if count gt 0 then begin
                curr_data_v=(*alldataV)(index)
                curr_data_v = curr_data_v(sort(curr_data_v[*].Nanoseconds))
            endif else  begin
                curr_data_v=[0]
            endelse

            Lpercent=0.0
            deltaT=1.0
            wait,1
            end_timeshift: ;do-nothing


        endfor; end for row_n
    endfor;  end for col_n

    ; stop;   we can insert the plots of the overlap in here.
    HV_2ds_over_lap_9or49_regions,bead_size,gridvals;  gridvals=input_matrix

end ; end of ZoomChartTimeshift_event

;*****************************************************************************

pro ZoomChartMoRoutine_event, event

    ;r = dialog_message(['Not yet implemented','Mos new routine:','XXXX'],TITLE = 'Mos new routine')
    ;return
    Widget_Control, event.top, Get_UValue=ave_info, /No_Copy  ; get our info structure
    ;Widget_Control, event.handler, Get_UValue=info, /No_Copy  ; get our info structure
    do_a2ds_fishing,ave_info;   only after zoom window is killed it comes back to next stop
    Widget_Control, event.handler, Set_UValue=info, /No_Copy  ; release our info structure
    Widget_Control, event.top, Set_UValue=ave_info, /No_Copy  ; release our info structure

end ;end of ZoomchartMoRoutine_event,venet
;********************************************************************************
pro Clean_spurious_event, event
    Widget_Control, event.top, Get_UValue=ave_info, /No_Copy  ; get our info structure
    a3vcpiview_cleaning_spurious_particlesn,ave_info
    Widget_Control, event.handler, Set_UValue=info, /No_Copy  ; release our info structure
    Widget_Control, event.top, Set_UValue=ave_info, /No_Copy  ; release our info structure
end ;end of ZoomchartMoRoutine_event,venet
;********************************************************************************

;*********************************************************************************
;***********************************************************************************

pro ZoomchartPrint_event, event
    Widget_Control, event.top, Get_UValue=ave_info, /No_Copy  ; get our info structure
    Widget_Control, ave_info.ZoomWindowDrawID, Get_Value=wid
    wset, wid
    rrr=dialog_message('Print the zoomed psd ?',/information)
    if rrr eq 'OK' then begin
        printwindow,wid,/landscape
    endif
    ;--------------------
    Widget_Control, ave_info.ZoomWindowSeriesDrawID, Get_Value=wid
    wset, wid
    rrr=dialog_message('Print the zoomed Time series ?',/information)
    if rrr eq 'OK' then begin
        printwindow,wid,/landscape
    endif

    Widget_Control, event.top, Set_UValue=ave_info, /No_Copy  ; release our info structure
end ; end of ZoomChartPrint_event
;****************************************************************************************
;***********************************************************************************

pro ZoomedHstrip_event, event

    Common DataBlock,AllDataH,AllDataV,ADataH,ADataV,FirstData,LastData,StripData,$
        FirstDataV,LastDataV,StripDataV,OneHzH,OneHzV,avestripdata,avestripdataV

    Widget_Control, event.top, Get_UValue=ave_info, /No_Copy  ; get our info structure
    ;Widget_Control, event.handler, Get_UValue=info, /No_Copy  ; get our info structure
    ;a3vcpiview_psd_methods,ave_info;   only after zoom window is killed it comes back to next stop
    ; rrr=dialog_message('Not implemented  yet.',/information)
    ; from a3vcpiview_zoomedHstrip.pro; show up the zoomedHstrip_widdget window.
    ;**********************************************************************************
    Hsubindex=*(ave_info.Hsubindex)
    if Hsubindex(0) eq -1 then begin
        rrr=dialog_message('No subset data for the time period !!!',/information)
        Widget_Control, event.handler, Set_UValue=info, /No_Copy  ; release our info structure
        Widget_Control, event.top, Set_UValue=ave_info, /No_Copy  ; release our info structure
        return
    endif
    Hsub_foffset=(*alldataH)(Hsubindex).imageoffset
    nnnn=n_elements(Hsubindex)
    firstimg_foffset=Hsub_foffset(0)
    lastimg_foffset =Hsub_foffset(nnnn-1)
    ;*****************************
    strip_info={STRIPID:0,$
        VSTRIPID:0,$;                 0
        ZOOMID  :0,$;               147
        STRIPBASE :0,$;               135
        STRIPLABEL:0,$;               139
        VSTRIPBASE:0,$;                 0
        VSTRIPLABEL:0,$;                 0
        FR_BUTTON :0,$;               140
        SSR_BUTTON:0,$;               141
        SSF_BUTTON:0,$;               142
        FF_BUTTON :0,$;               143
        ave_info:ave_info,$
        firstimg_foffset:firstimg_foffset,$
        lastimg_foffset:lastimg_foffset}
    ZoomedHParticleStrip, strip_info;  ;zoominfo
    ;*****************************************************************
    Widget_Control, event.handler, Set_UValue=info, /No_Copy  ; release our info structure
    Widget_Control, event.top, Set_UValue=ave_info, /No_Copy  ; release our info structure

end  ;end of ZoomedHstrip_event
;************************************************************************************************
;***********************************************************************************

pro ZoomedVstrip_event, event

    Common  DataBlock,alldataH,alldataV,ADataH,ADataV,FirstData,LastData,StripData,$
        FirstDataV,LastDataV,StripDataV,OneHzH,OneHzV,avestripdata,avestripdataV

    Widget_Control, event.top, Get_UValue=ave_info, /No_Copy  ; get our info structure
    ;Widget_Control, event.handler, Get_UValue=info, /No_Copy  ; get our info structure
    ;a3vcpiview_psd_methods,ave_info;   only after zoom window is killed it comes back to next stop
    ; rrr=dialog_message('Not implemented  yet.',/information)
    ; from a3vcpiview_zoomedHstrip.pro; show up the zoomedHstrip_widdget window.
    ;**********************************************************************************
    Vsubindex=*(ave_info.Vsubindex)
    if Vsubindex(0) eq -1 then begin
        rrr=dialog_message('No subset data for the time period !!!',/information)
        Widget_Control, event.handler, Set_UValue=info, /No_Copy  ; release our info structure
        Widget_Control, event.top, Set_UValue=ave_info, /No_Copy  ; release our info structure
        return
    endif
    Vsub_foffset=(*alldataV)(Vsubindex).imageoffset
    nnnn=n_elements(Vsubindex)
    firstimg_foffset=Vsub_foffset(0)
    lastimg_foffset =Vsub_foffset(nnnn-1)
    ;*****************************
    strip_info={STRIPID:0,$
        VSTRIPID:0,$;                 0
        ZOOMID  :0,$;               147
        STRIPBASE :0,$;               135
        STRIPLABEL:0,$;               139
        VSTRIPBASE:0,$;                 0
        VSTRIPLABEL:0,$;                 0
        FR_BUTTON :0,$;               140
        SSR_BUTTON:0,$;               141
        SSF_BUTTON:0,$;               142
        FF_BUTTON :0,$;               143
        ave_info:ave_info,$
        firstimg_foffset:firstimg_foffset,$
        lastimg_foffset:lastimg_foffset}
    ZoomedVParticleStrip, strip_info;  ;zoominfo
    ;*****************************************************************
    Widget_Control, event.handler, Set_UValue=info, /No_Copy  ; release our info structure
    Widget_Control, event.top, Set_UValue=ave_info, /No_Copy  ; release our info structure
end ; end of ZoomedVstrip_event
;**********************************************************************************************

;************************************************************************
pro ZoomChartHK_event, event
    Widget_Control, event.top, Get_UValue=ave_info, /No_Copy  ; get our info structure
    a3vcpiview_HK_plots,ave_info
    Widget_Control, event.top, Set_UValue=ave_info, /No_Copy  ; release our info structure
end ; end of ZoomedVstrip_event
;**********************************************************************************************
;********************************************************************************************
;************************************************************************
pro ZoomChartStereo_event, event
    Common  DataBlock,alldataH,alldataV,ADataH,ADataV,FirstData,LastData,StripData,FirstDataV,$
        LastDataV,StripDataV,OneHzH,OneHzV
    Widget_Control, event.top, Get_UValue=ave_info, /No_Copy  ; get our info structure
    ;stop
    Toffset=0
    deltaT=10
    Lpercent=0.5
    get_stereo_pairs,ave_info,Toffset,deltaT,LPercent,Hindex,Vindex

    ;**********************************************************************************
    Hsub_foffset=(*alldataH)(Hindex).imageoffset
    nnnn=n_elements(Hindex)
    Hfirstimg_foffset=Hsub_foffset(0)
    Hlastimg_foffset =Hsub_foffset(nnnn-1)

    Vsub_foffset=(*alldataV)(Vindex).imageoffset
    nnnn=n_elements(Vindex)
    Vfirstimg_foffset=Vsub_foffset(0)
    Vlastimg_foffset =Vsub_foffset(nnnn-1)
    ;*****************************
    strip_info={STRIPID:0,$
        VSTRIPID:0,$;                 0
        ZOOMID  :0,$;               147
        STRIPBASE :0,$;               135
        STRIPLABEL:0,$;               139
        VSTRIPBASE:0,$;                 0
        VSTRIPLABEL:0,$;                 0
        FR_BUTTON :0,$;               140
        SSR_BUTTON:0,$;               141
        SSF_BUTTON:0,$;               142
        FF_BUTTON :0,$;               143
        ave_info:ave_info,$
        Hfirstimg_foffset:Hfirstimg_foffset,$
        Hlastimg_foffset:Hlastimg_foffset,$
        Vfirstimg_foffset:Vfirstimg_foffset,$
        Vlastimg_foffset:Vlastimg_foffset $
        }
    ZoomedStereoParticleStrip,Hindex,Vindex,strip_info;  ;zoominfo
    ;a3vcpiview_HK_plots,ave_info
    Widget_Control, event.top, Set_UValue=ave_info, /No_Copy  ; release our info structure
end ; end of ZoomedVstrip_event
;**********************************************************************************************

;***********************************************************************************

pro compare_psd_methods_event, event

    ;r = dialog_message(['Not yet implemented','Mos new routine:','XXXX'],TITLE = 'Mos new routine')
    ;return
    Widget_Control, event.top, Get_UValue=ave_info, /No_Copy  ; get our info structure
    ;Widget_Control, event.handler, Get_UValue=info, /No_Copy  ; get our info structure
    a3vcpiview_psd_methods,ave_info;   only after zoom window is killed it comes back to next stop

    Widget_Control, event.handler, Set_UValue=info, /No_Copy  ; release our info structure
    Widget_Control, event.top, Set_UValue=ave_info, /No_Copy  ; release our info structure

end

;********************************************************************************

;***********************************************************************************

pro compare_tms_methods_event, event

    Widget_Control, event.top, Get_UValue=ave_info, /No_Copy  ; get our info structure

    a3vcpiview_tms_methods,ave_info;   only after zoom window is killed it comes back to next stop
    Widget_Control, event.handler, Set_UValue=info, /No_Copy  ; release our info structure
    Widget_Control, event.top, Set_UValue=ave_info, /No_Copy  ; release our info structure

end

;*********************************************************************************
pro SPEC_Nano2HMS,ns,a,hours,minutes,seconds,milli,micro,nano
    ; accepts ULL values of nanoseconds
    ; returns string of HH:MM:SS.mmm.mmm.nnn

    NanosecondsPerMicro  = 1000ULL
    NanosecondsPerMilli  = 1000000ULL
    NanosecondsPerSecond = 1000000000ULL
    NanosecondsPerMinute = NanosecondsPerSecond * 60ULL
    NanosecondsPerHour   = NanosecondsPerMinute * 60ULL

    hours=ns/NanosecondsPerHour
    if hours GT 0 then  ns = ns - (hours * NanosecondsPerHour)
    minutes=ns/NanosecondsPerMinute
    if minutes GT 0 then  ns = ns - (minutes * NanosecondsPerMinute)
    seconds=ns/NanosecondsPerSecond
    if seconds GT 0 then  ns = ns - (seconds * NanosecondsPerSecond)
    milli=ns/NanosecondsPerMilli
    if milli GT 0 then  ns = ns - (milli * NanosecondsPerMilli)
    micro=ns/NanosecondsPerMicro
    if micro GT 0 then  ns = ns - (micro * NanosecondsPerMicro)
    a = string(format = '(%"%2.2d:%2.2d:%2.2d.%3.3d.%3.3d.%3.3d")',hours,minutes,seconds,milli,micro,ns)
    nano=ns
end
;********************************************************************************
;***********************************************************************************************
PRO Time_shift_HV_VV_old,HV,VV,corr_max,delta_T,shift_val,cor_coef
    Widget_Control, /hourglass;    ;show hour glass while following line are running.
    nnn=n_elements(VV)
    N40=80
    y1=[bytarr(N40),HV,bytarr(N40)];  extended HV vectors; bytarr(40)*0
    cor_coef=fltarr(2*N40+1);fltarr(81)
    shift_val=indgen(2*N40+1)-N40;  indgen(81)-40;  ;[-100, -99,  ..., 0, 1,2, 99, 100]
    for i=0,2*N40 do begin
        ;HVn=y1(i:nnn-1+i); take this away to save for memory
        cor_coef(i)=total(y1(i:nnn-1+i)*VV,/double); ;total(HVn*VV,/double)
    endfor
    corr_max=max(cor_coef)
    index=where(cor_coef eq corr_max)
    delta_T=shift_val(index(0))
END
;********************************************************

;*****************************************************************
;use a subrountine to calculated 200 bin data
pro calculated_200bin_psd,curr_data,has_data,svdefault,xpts,plot_numbers,plot_size,plot_area,plot_mass

    ;the 200bins is fixed 10,20,20,30,30, ********, 1990,1990,2000
    nbins=83
    make_83_bins,nbins,nedges,xpts

    Plot_Numbers = fltarr(nedges)
    Plot_Size = fltarr(nedges)
    Plot_Area = fltarr(nedges)
    Plot_Mass = fltarr(nedges)

    if has_data eq 1 then begin
        sizes = curr_data.L1n*10.0; unit is pixels. microns_per_pixel=0.01 ; length of particles in microns
        adj   = curr_data.adj1*curr_data.adj0
        alpha = 0.115D
        beta = 1.218D
        microns_per_pixel = 10
        for j=0,nedges-2,2 do begin
            binwidth=(xpts[j+1]-xpts[j])
            LiterTum=binwidth*SVdefault
            somarr=where(sizes lt xpts[j+1] and sizes ge xpts[j],contG) ; Handle all but last bins
            if contG gt 0 then begin;  if there is no particles, area and mass should be zero
                this_adj1=curr_data(somarr(0)).adj1
                Plot_Numbers[j:j+1] = contG;  # only
                Plot_Size[j:j+1] =this_adj1*contG /LiterTum
                aa = curr_data.Area   ; aa in unit pixel_squares  1 pixel=10um=0.01mm; 1pixel^2=0.0001 mm^2
                aa = temporary(aa(somarr)) *0.0001; mm^2
                total_area=total(aa); mm^2; every particles has the same adj value, but area may differ.
                Plot_Area[j:j+1] = this_adj1 * total_area /LiterTum;  Area: mm^2/Liter/um
                Plot_Mass[j:j+1] = 0.917*this_adj1*alpha*total(aa^beta)/LiterTum;   Mass: mg/Liter/um
                ;get_IWC_from_adj_n_sizes,total_IWC,alpha,beta,this_adj1,sizes,aa
                ;plot_mass[j:j+1]=total_IWC/LiterTum

            endif else begin
                plot_area[j:j+1]=0.0
                plot_Mass[j:j+1]=0.0
                plot_numbers[j:j+1]=0.0
                plot_size[j:j+1]=0.0
            endelse
        endfor
        ;handle last bin;  save a lot of if statement in the for loop
        j=nedges-2
        somarr=where(sizes ge max(xpts),contG)
        binwidth=(xpts[j+1]-xpts[j])
        LiterTum=binwidth*SVdefault
        somarr=where(sizes lt xpts[j+1] and sizes ge xpts[j],contG) ; Handle all but last bins
        Plot_Numbers[j:j+1] = contG;  # only
        Plot_Size[j:j+1] = contG /LiterTum
        if contG eq 0 then begin;  there is no particles, area and mass should be zero
            plot_area[j:j+1]=0.0
            plot_Mass[j:j+1]=0.0
        endif else begin
            aa = curr_data.Area
            aa = temporary(aa(somarr)) *0.0001; mm2
            total_area=total(aa);  every particles has the same adj value, but area may differ.
            this_adj1=curr_data(somarr(0)).adj1
            Plot_Area[j:j+1] = this_adj1 * total_area/LiterTum;  Area/Liter/um
            Plot_Mass[j:j+1] = 0.917*this_adj1*alpha*total(aa^beta)/LiterTum; Mass/Liter/um
        endelse
    endif else begin
        Plot_Numbers = fltarr(nedges)*0.0
        Plot_Size = fltarr(nedges)*0.0
        Plot_Area = fltarr(nedges)*0.0
        Plot_Mass = fltarr(nedges)*0.0
    endelse
end; end of pro calculate_200bin_psd
;*********end of calculate_200bin_psd,curr_data,plot_number, plot_size ******
;*****************************************************
pro convert_thisValue_to_string, this_value, mystring
    if this_value eq 0.0 then this_value=1.0
    if this_value ge 1 then begin
        mystring=strtrim(round(this_value),2)
    endif else begin
        mystring='0.'
        k=abs(floor(Alog10(this_value)) )
        for kk=1,k-1 do begin
            mystring=mystring+'0'
        endfor
        mystring=mystring+'1'
    endelse
end; end of convert_this_value_to_string
;*******************************************************
pro write_psd_to_ascii_file,out_filename,xpts,plot_numbers,plot_numbers_V,$ ; numbers is #/bin
    plot_size,plot_size_V,plot_area,plot_area_V,plot_mass,plot_Lmass,plot_mass_V,plot_Lmass_V,$  ; size is #/L/um
    binfilename,plot_string,delta_s,Hpartcont,Vpartcont
openw,66,out_filename
printf,66,'2DS psd ascii output generated on: '+systime(/UTC)
printf,66, binfilename;'input data file is: '+binfilename
printf,66,'time interval is: '+ delta_s +' '+plot_string
printf,66,'Number of particles: '+ Hpartcont+'  '+Vpartcont
printf,66,'bin_edge   H:#/bin  #/Liter/um   mm2/L/um (ice: g/m3/um) (liq: g/m3/um)  V:#/bin   #/Liter/um   (mm2/L/um) (ICE: g/m3/um) (liq: g/m3/um)  '
nnn=n_elements(xpts)
format_str='(I8,1x,I9,1x,E12.5,1x,E12.5,2x,F11.4,1x,F11.4,I9,1x,E11.4,2x,E11.4,2x,E11.4.1x,E11.4)'
for i=0,nnn-1 do begin
    printf,66, format=format_str,xpts(i)-5,$
        plot_numbers(i),plot_size(i),plot_area(i),plot_mass(i),plot_Lmass(i),$
        plot_numbers_v(i),plot_size_v(i),plot_area_v(i),plot_mass_v(i),plot_Lmass_v(i)

endfor
close,66

end;   ;end of write+psd_to_ascii_file
;***************************************************************************************
;*********************************************************************************************
pro calculate_sv_deadtime,ave_info,Hallindex,Vallindex
    Common DataBlock,alldataH,alldataV
    ;when update button is pressed, it calcuated all values of the ave_info time period.
    ;ave_info={Hdeadtime,HtotV,HdeadV,HliveV,Vdeadtime,VtotV,VdeadV,VliveV}
    ;*******************************************************************************
    starttime=ave_info.startnanoseconds
    endtime=ave_info.endnanoseconds

    Get_Justdeadtime_between_time1_time2,'H',starttime,endtime,$  ;inputs.
        StartTicks,EndTicks,HDT_mask,HDT_ovfl,HDT_L1,HDT_bad1,HDT_bad2,HDT_bad3,total_HaccDeadtime

    seconds_per_tick=(endtime-starttime)*10.0^(-9)/(endTicks-startTicks)
    Hdeadtime=(HDT_mask+HDT_ovfl+HDT_L1+HDT_bad1+HDT_bad2+HDT_bad3)
    if Hdeadtime ne total_Haccdeadtime then begin
        print, 'Tow ways of Deadtime calculation is different !!!!!!!!!--use new_acc'
        print, 'Old=',Hdeadtime, '   new_accDT=',total_HaccDeadtime,'   ticks'
        Hdeadtime=total_Haccdeadtime

    endif

    ;!DWW_main is 63.0mm in 2D-S, 50.8 mm in 3V-CPI adjust in a3VCPIView.pro
    HliveVmo=(endTicks-startTicks-Hdeadtime)*1.28*!DWW_main*10.0^(-8); Liter
    Hdeadtimemo=Hdeadtime*seconds_per_tick

    Get_Justdeadtime_between_time1_time2,'V',starttime,endtime,$  ;inputs.
        StartTicks,EndTicks,VDT_mask,VDT_ovfl,VDT_L1,VDT_bad1,VDT_bad2,VDT_bad3,total_VaccDeadtime

    Vdeadtime=(VDT_mask+VDT_ovfl+VDT_L1+VDT_bad1+VDT_bad2+VDT_bad3)
    if Vdeadtime ne total_Vaccdeadtime then begin
        print, 'Tow ways of Deadtime calculation is different !!!!!!!!!--use new_acc'
        print, 'Old=',Vdeadtime, '   new_accDT=',total_VaccDeadtime,'   ticks'
        Vdeadtime=total_Vaccdeadtime

    endif

    ;!DWW_main; 63.0mm in 2D-S, 50.8 mm in 3V-CPI adjust in a3VCPIView.pro
    VliveVmo=(endTicks-startTicks-Vdeadtime)*1.28*!DWW_main*10.0^(-8); Liter
    Vdeadtimemo=Vdeadtime*seconds_per_tick
    ;Get_Hsv_deadtime_between_time1_time2,starttime,endtime,HliveVmo,Hdeadtimemo
    ;Get_Vsv_deadtime_between_time1_time2,starttime,endtime,VliveVmo,Vdeadtimemo


    ;*******************************************************************************
    ave_info.Hdeadtime=Hdeadtimemo;HDT_ovfl+HDT_mask+HDT_L1+HDT_bad1+HDT_bad2; Hdeadtimemo
    ave_info.HDT_ovfl=HDT_ovfl*seconds_per_tick
    ave_info.HDT_mask=HDT_mask*seconds_per_tick
    ave_info.HDT_L1=HDT_L1*seconds_per_tick
    ave_info.HliveV=HliveVmo
    ave_info.HDT_bad1=HDT_bad1*seconds_per_tick
    ave_info.HDT_bad2=HDT_bad2*seconds_per_tick

    ave_info.Vdeadtime=Vdeadtimemo; VDT_ovfl+VDT_mask+VDT_L1+VDT_bad1+VDT_bad2;Vdeadtimemo
    ave_info.VDT_ovfl=VDT_ovfl*seconds_per_tick
    ave_info.VDT_mask=VDT_mask*seconds_per_tick
    ave_info.VDT_L1=VDT_L1*seconds_per_tick
    ave_info.VliveV=VliveVmo
    ave_info.VDT_bad1=VDT_bad1*seconds_per_tick
    ave_info.VDT_bad2=VDT_bad2*seconds_per_tick

end; end of calculate_sv_deatime,ave_info;Hallindex,Vallindex



pro  get_stereo_pairs,ave_info,Toffset,deltaT,LPercent,Hstereoindex,Vstereoindex
    Common  DataBlock,alldataH,alldataV,ADataH,ADataV,FirstData,LastData,StripData,FirstDataV,$
        LastDataV,StripDataV,OneHzH,OneHzV

    Hsubindex= *(ave_info.Hsubindex)
    Vsubindex= *(ave_info.Vsubindex)
    if Vsubindex(0) eq -1 or Hsubindex(0) eq -1 then begin
        rrr=dialog_message('At least one Channel has no particles, so no stereo-pairs',/information)
        return
    endif

    HL1=(*alldataH)(Hsubindex).Nslice
    Htime=(*alldataH)(Hsubindex).probecounter-HL1/2

    VL1=(*alldataV)(Vsubindex).Nslice
    Vtime=(*alldataV)(Vsubindex).probecounter-VL1/2
    ;stop

    ;Toffset=0;  in unit of tick

    ;find_center_time of each particle
    ;Htime=curr_data.nanoseconds/min_dt-curr_data.L1/2-Toffset;   in nanoseconds
    ;Htime=curr_data.probecounter-curr_data.L1/2
    ; HL1  =curr_data.L1

    ;Vtime=curr_data_V.nanoseconds/min_dt-curr_data_V.L1/2;        in nanoseconds
    ; Vtime=curr_data_V.probecounter-curr_data_V.L1/2-Toffset
    ; VL1  =curr_data_V.L1
    nh=n_elements(Htime)
    nv=n_elements(Vtime)
    if nh le nv then begin ; search pairs start with H
        find_stereo_pairs,Htime,HL1,nh,Vtime,VL1,deltaT,Lpercent,Hindex, Vindex
    endif else begin  ; search pairs start with V
        find_stereo_pairs,Vtime,VL1,nv,Htime,HL1,deltaT,Lpercent,Vindex, Hindex
    endelse
    ;note that Hindex Vindex is the index in the vector Hime and Vtime.
    Hstereoindex=Hsubindex(Hindex)
    Vstereoindex=Vsubindex(Vindex)

    ;aaaa
    mmmm=n_elements(Hstereoindex)
    outfile='C:/stereo_particles_ascii.txt'
    openw,1,outfile
    printf,1,'Htime           pc1  fcs   Nslice   L2  Vtime        pc1  fcs   Nslice   L2'
    for i=0LL,mmmm-1LL do begin
        Hk=Hstereoindex(i)
        Vk=Vstereoindex(i)
        printf,1, format='(I14,1x,I3,1x,F5.2,1x,I5,1x,I5,2x,I14,1x,I3,1x,F5.2,1x,I5,1x,I5)',$
            (*alldataH)(Hk).nanoseconds,(*alldataH)(Hk).pc1,(*alldataH)(Hk).focus,(*alldataH)(Hk).Nslice,(*alldataH)(HK).L2,$
            (*alldataV)(Vk).nanoseconds,(*alldataV)(Vk).pc1,(*alldataV)(Vk).focus,(*alldataV)(Vk).Nslice,(*alldataV)(VK).L2
    endfor
    close,1

end
;**************************************************************************************
pro find_stereo_pairs,timeA,AL1,na,timeB,BL1,deltaT,Lpercent,Aindex, Bindex
    ; stop
    ;********************************************
    ;first make the number smaller;  TimeA and time B is in unit tick
    min_num=min([min(timeA),min(timeB)])
    timeA=double(timeA-min_num)
    timeB=double(timeB-min_num);    TimeA and Time B is particle center time in unit tick.
    ;********************************************

    ;it is assumed that timeA has less elements
    Aindex=[0]
    Bindex=[0]
    ;DeltaT=2;    2 ticks
    ;Lpercent=0.5
    for i=0LL,na-1LL do begin  ;compare each timeA with all of the timeB
        Dt=abs(timeA(i)-timeB)
        minDt=min(Dt)
        index=where(DT eq minDt,contG);   ;get the closest B-particle with A(i)
        ;stop
        CBindex=index(0)
        if minDt lt deltaT then begin ; the H and V particles is matched. we will see if
            sizeA=AL1(i);                 ; the size matches
            sizeB=BL1(index(0))
            if (sizeA le sizeB and sizeA ge Lpercent*sizeB) or (sizeB le sizeA and sizeB ge Lpercent*sizeA) then begin
                Aindex=[Aindex,i];                    ;the pair is found
                Bindex=[Bindex,index(0)]
            endif
            print,i,mindt,index(0)
        endif
    endfor
    ; stop
    ;note that Hindex Vindex has been stuffed with the first particle index 0; we need to take that off our list.
    nnnn=n_elements(Aindex)
    if nnnn eq 1 then begin
        rrrr=dialog_message('No stereo_pairs found, I just return the first image of H and V channel.',/information)
    endif else begin
        Aindex=Aindex(1:nnnn-1)
        Bindex=Bindex(1:nnnn-1)
    endelse

    ;note that Aindex and Bindex is the index of timeA and TimeB vector.
end;  end of Finding_the_steroe_pairs
;***********************************************************************
;**********************************************
pro display_stereo_particle_pairs,curr_data,curr_data_V,Toffset,deltaT,Lpercent,Hindex,Vindex
    Common  DataBlock,alldataH,alldataV,ADataH,ADataV,FirstData,LastData,StripData,FirstDataV,$
        LastDataV,StripDataV,OneHzH,OneHzV


    ;first the get the offset index
    timeH0=curr_data(0).nanoseconds
    timeV0=curr_data_v(0).nanoseconds

    mytitle='Criteria:  H-V-Tick-offset='+strtrim(Toffset,2)+' Center-Tol='+strtrim(deltaT)+$
        '-tick'+'  size_Tol='+strtrim(Lpercent,2)
    window,11,xs=800,ys=400,title=mytitle
    erase,color='ffffff'x  ; get background to white

    for i= 0, n_elements(Hindex)-1 do begin

        ;first get the two imags
        this_OD=curr_data(Hindex(i))
        get_an_image,this_OD,my_image1,Wordcount1,Slices1, HSums1, HMax1,Area1,Midpoint1,Edges1,Err1
        this_OD=curr_data_V(Vindex(i))
        get_an_image,this_OD,my_image2,Wordcount2,Slices2, HSums2, HMax2,Area2,Midpoint2,Edges2,Err2
        ;display_the_iamges with just balck and white
        ;tv,my_image1,i*20,0
        ;tv,my_image2,i*20,200

        ;display_the_iamges with just black and some color, because images are m by n, need to convert to 3 by n by m
        nm=size(my_image1,/dimension)
        n1=nm(0)
        m1=nm(1)
        nm=size(my_image2,/dimension)
        n2=nm(0)
        m2=nm(1)
        my_imagen1=intarr(3,n1,m1)
        my_imagen2=intarr(3,n2,m2)
        my_imagen1(0,*,*)=my_image1
        my_imagen1(1,*,*)=my_image1;+20; add color to it by adding 20
        my_imagen1(2,*,*)=my_image1;+80; add another color to it by adding 80
        my_imagen2(0,*,*)=my_image2
        my_imagen2(1,*,*)=my_image2
        my_imagen2(2,*,*)=my_image2
        imod=i mod 40
        if imod eq 0 then begin ; start a new window to display the images.
            ; stop
            window,11,xs=800,ys=400,title=mytitle
            erase,color='ffffff'x  ; get background to white
        endif

        tvscl,my_imagen1,imod*20,0,true=1
        tvscl,my_imagen2,imod*20,200,true=1;   ;usage  tvscl, image, x, y, true=1; x y is lower left corner position.
        ;so for an image of array(11,128) all elements are 255 except the black pixels
        ;we need to clip the part that is image



        max_row=0
        min_row=128
        for i1=0,n1-1 do begin
            index=where(my_image1(i1,*) ne 255,contG)
            if contG gt 0 then begin
                max_row=max([max_row,index])
                min_row=min([min_row,index])
            endif
        endfor
        if max_row eq 127 then max_row=126;  dealing with too big images that touchs the edges.
        if min_row eq 0 then min_row=1
        roi1=intarr(n1,max_row-min_row+1+2)
        roi1=my_image1(*,min_row-1:max_row+1)

        ; do the other image
        max_row=0
        min_row=128
        for i2=0,n2-1 do begin
            index=where(my_image2(i2,*) ne 255,contG)
            if contG gt 0 then begin
                max_row=max([max_row,index])
                min_row=min([min_row,index])
            endif
        endfor
        if max_row eq 127 then max_row=126;  dealing with too big images that touchs the edges.
        if min_row eq 0 then min_row=1
        roi2=intarr(n2,max_row-min_row+1+2)
        roi2=my_image2(*,min_row-1:max_row+1)

        ;combined roi1 and roi2 together

        if imod eq 10 then begin
            rrr=dialog_message('see next stereo_pair image ?',/information)
        endif
    endfor

end;  ;end of display_stereo_images

;**********************************************
;get the images of the stereo_particle
;*******************************************************************************
pro get_an_image,this_OD,my_image,Wordcount,Slices, HSums, HMax,Area,Midpoint,Edges,Err

    ;input this_OD; output: all others

    Slices    = this_OD.Nslice
    WordCount = this_OD.ImageWords

    Image = BytArr(WordCount * 2)
    out_byte_array = BytArr(128L, Slices)

    fname = strmid(!currentHPname,0,strlen(!currentHPname)-5) + $
        'SORTED' + strmid(!currentHFname,strpos(!currentHFname,"horiz")+5,12) + '.2DSCPI'


    OpenR, lun, fname, /Get_Lun

    POINT_LUN, lun, this_OD.ImageOffset
    ReadU, lun, Image

    Close ,lun
    Free_Lun,lun

    HSums = IntArr(Slices)
    HMax  = 0
    Area = 0UL
    Midpoint = 0
    Edges = 0

    Err=0

    L3 = 0.0
    L4 = 0
    L5 = 0
    PC3x = 0.0
    PC3y = 0.0
    PC4x = 0.0
    PC4y = 0.0
    A3 = 0.0
    Roundness1 = 0.0
    Roundness2 = 0.0
    Roundness3 = 0.0
    L1r = 0.0
    maxLength = 0.0
    maxWidth  = 0.0
    perimeter = 0UL
    perimeterum = 0.
    csp = 0.
    num_satellites = 0.
    HorV = 'H'


    ProcessParticle, Image, out_byte_array, Wordcount,Slices, HSums, HMax, Area, Midpoint, Edges,Err , $
        L3,L4,L5,PC3x,PC3y,PC4x,PC4y,A3, Roundness1, Roundness2, Roundness3, L1r, maxLength, maxWidth, perimeter, crystal_type, perimeterum, csp, $
        ml_p1x=ml_p1x, ml_p1y=ml_p1y, ml_p2x=ml_p2x, ml_p2y=ml_p2y, mw_p1x=mw_p1x, mw_p1y=mw_p1y, mw_p2x=mw_p2x, mw_p2y=mw_p2y, $
        perimeter_points_x=perimeter_points_x, perimeter_points_y=perimeter_points_y, HorV=HorV

    my_image = rotate(out_byte_array, !IMAGE_ROTATION)

end;  end of get_stereo_image
;*************************************************************************************

pro HV_2ds_over_lap_9or49_regions,bead_size,input_matrix
    ;by Mo:   this program plots the overlap regions of  9 region sor 49 regions.
    ;         depending on the input matrix.


    bluecolor = GetColor("Navy", !D.Table_Size-2)
    redcolor = GetColor("Red", !D.Table_Size-2)
    whitecolor = GetColor("White", !D.Table_Size-2)
    ;erase,color='ffffff'x  ; get background to white
    window,1, xs=750,ys=750

    !P.thick=1
    !P.CHARSIZE=3.0
    !P.multi=[0,1,1]
    !P.BACKGROUND=whitecolor
    Xsize=128
    Ysize=128
    x=[-128,-128,128,128,-128]
    y=[-128,128,128,-128,-128]
    plot,x,y,color=bluecolor,position=[0.2,0.2,0.8,0.8],xrange=[-140,140],yrange=[-140,140],$
        xticks=2,xtickname=[' ',' ',' '],yticks=2,ytickname=[' ',' ',' ']

    if 1 eq 2 then begin;   for debug.
        A=[[1,1,1],$
            [1,1,1],$
            [1,1,1]]
        A=[[1,1,1,1,1,0,0],$
            [1,1,1,1,0,0,0],$
            [1,1,1,1,1,0,0],$
            [1,1,1,1,1,1,1],$
            [1,1,1,1,1,1,0],$
            [1,1,1,1,1,1,0],$
            [1,1,1,1,1,1,1]]
        input_matrix=A
        bead_size=50
    endif

    nm=size(input_matrix,/dimensions)

    if n_elements(nm) eq 1 then return

    m=nm(1)

    if m eq 7 then begin
        square_size=256/7;   % (top 128 + bottome128)do 7 x 7 quares.
        mbym_str='7x7'
        start_x0=0
        ; the 7 x 7 Matrix numbers.
        A=[[1,1,1,1,1,0,0],$
            [1,1,1,1,0,0,0],$
            [1,1,1,1,1,0,0],$
            [1,1,1,1,1,1,1],$
            [1,1,1,1,1,1,0],$
            [1,1,1,1,1,1,0],$
            [1,1,1,1,1,1,1]]
        A=input_matrix
    endif

    if m eq 3 then begin
        square_size=256/m;   % (top 128 + bottome128)do 7 x 7 quares.
        mbym_str='3x3'
        start_x0=45
        ; the 3 x 3 Matrix numbers.
        A=[[1,1,1],$
            [1,1,1],$
            [1,1,1]]
        A=input_matrix
    endif

    for j=1,m do begin
        for i=1,m do begin
            top_y=128-square_size*(j-1) -3
            bot_y=top_y -square_size+2
            The_squares_4_points_y =[bot_y,top_y,top_y,bot_y]

            left_x=-128+3+(i-1)*square_size;  ; add 3 to adjsut the space between box.
            right_x=left_x+square_size-2

            The_squares_4_points_x =[left_x, left_x, right_x, right_x]

            polyfill, The_squares_4_points_x,The_squares_4_points_y ,  color=redcolor
            xyouts,start_x0+left_x-5-square_size/2,(top_y + bot_y)/2,string(A(i-1,j-1)),color=bluecolor,charsize=1.0
        end; end for i;  from, i1, i2, i3, i4, i5, i6, i7 in a row
    end; end of j=1, to 7.

    xyouts,195,548,'2DS-'+mbym_str+' Section H-V Beam Offset',color=redcolor,charthick=2,charsize=1.7,/device
    xyouts,220,200,' Using '+strtrim(string(bead_size),2)+'um bead test',color=redcolor,charthick=2,charsize=2.0,/device
    ;file=dialog_pickfile(filter='*.2DSCPI',get_path=pathname)
    outputfilename=!currentHPname+'2DS_'+mbym_str+'_region_overlap_'+strtrim(string(bead_size),2)+'um.png'
    write_png,outputfilename,tvrd(180,180,385,395,true=1)

end
