pro redo,data=pStateinfo

    if(ptr_valid((*pStateInfo).pFrameData))then begin  ; this needs to be a defined structure to continue
        WIDGET_CONTROL, /HOURGLASS
        ; set min/max to gui
        set_min_max, pStateInfo

        ; Show main info line
        disp_frame_info, pStateInfo, 0

        ; now display frame
        bounds = DispFrame(pStateInfo)
    endif
end



PRO main_event,event

    err=0
    ;catch,err
    if(err ne 0)then begin
        PRINT, 'Error message:', !ERR_STRING
        help,/trace
        ;widget_control,event.top,set_uvalue=StateInfo,/no_copy
        return
    endif

    s_name = TAG_NAMES(event, /STRUCTURE_NAME)
    widget_control,event.top,get_uvalue=pStateInfo

    if(checkhasp((*pStateInfo).HaspFile) eq 0)then begin
        ; no hasp dongle
        r = dialog_message('Install a valid HASP key')
        return
    endif


    case s_name of
        ; Handle destroy of top-level base.
        'WIDGET_KILL_REQUEST':begin

        ; Update ROI params to file?
        IF(ptr_valid((*pStateInfo).pFrameData) and (*pStateInfo).UpdateFile) THEN UpdateBlock, pStateInfo

        clean_up,pStateInfo
        WIDGET_CONTROL, event.top, /DESTROY
        return
    end

    else: begin
        ; handle all menu items
        widget_control,event.id,get_uvalue = uvalue
        case uvalue of

            'Timer': begin
                if((*pStateInfo).demo)then begin
                    r = dialog_message('Demo version timed out... quitting',/info)
                    clean_up,pStateInfo
                    heap_gc;,/verbose
                    WIDGET_CONTROL, event.top, /DESTROY
                    return
                endif else print,'Error in timer code'
            end

            'NEWFILE': begin

                LoadFile, pStateInfo
                fdata=fstat((*pstateinfo).infilelun)
                if fdata.size le 2000000 then begin
                    rrr=dialog_message(' File less than 2M, probably no images in it, it may crash, do another file !',/info)
                end

                ; mo modified this on April 25  to added change Time  to the png pages to sync with 2DS images and other images.
                ;if !DT_CPI eq (-99999L) then begin

                if(!disable_time_popups eq 1) then begin
                    !Time_synced = 1
                endif else begin
                    !Time_synced=(moqixu_input_single_number_pop_up(title='If Time is synced enter 1 else 0: ',label='Time synced:',value='0'))*1L

                    if !Time_synced gt 0 then begin
                        !DT_CPI=(moqixu_input_single_number_pop_up(title='For relabeling CPI png page image only',label='CPI_Time_offset:',value='0'))*1L
                    endif else begin
                        !DT_CPI=0
                    endelse
                endelse
            end

            'BatchROI': begin; for doing overnight job. load all roi files and make all objs and ascii files.
                Do_overnight_works, pStateInfo
            end

            'ManualClass': begin
                Do_manual_habit_change, pStateInfo, GROUP=GROUP
            end


            ; TAF adding 3-View here temporarily

            '3 Viewer': begin
                a3vcpiview_3_view_widget, pStateInfo
            end
            '3 Viewer(temp)': begin
                a3vcpiview_3_view_widget_temp, pStateInfo
            end


            'DOFCalib': begin
                Do_DOF_Calibration,PstateInfo, GROUP=GROUP
            end
            'Redo': begin
                if(ptr_valid((*pStateInfo).pFrameData))then begin  ; this needs to be a defined structure to continue
                    WIDGET_CONTROL, /HOURGLASS
                    stop
                    Do_manual_habit_change, PstateInfo, GROUP=GROUP
                    stop


                    ; set min/max to gui
                    set_min_max, pStateInfo

                    ; Show main info line
                    disp_frame_info, pStateInfo, 0

                    ; now display frame
                    if((*pStateInfo).displayPerim)then begin
                        ; if an object file exist toggle perimeter
                        if(ptr_valid((*pStateInfo).pObjList))then begin

                            objData = get_obj_header((*pStateInfo).ObjLUN,(*(*pStateInfo).pObjList)[(*pStateInfo).ImgPos-1].fPos)
                            ROI_Count = objData.Frameheader.ROIsCount
                            pBoundary = ptrarr(ROI_count)

                            for index = 0,ROI_count-1 do begin
                                header = (*objData.pFrame)[index].imageheader
                                if(header.bound_len ne 0)then pBoundary[index] = header.boundary
                            endfor

                            delete_obj_header,objData

                            ; redraw frame
                            ; tvlct,255,255,0,255
                            bounds = DispFrame(pStateInfo,pBoundary=pBoundary)

                        endif
                    endif else begin
                        ; redraw frame
                        ;tvlct,255,255,255,255
                        bounds = DispFrame(pStateInfo)
                    endelse

                endif
            end

            ;'Reject': reject_all,pStateInfo

            'PRINTSETUP': IF(DIALOG_PRINTERSETUP()) THEN (*pStateInfo).PrintROI.PageDX = 0

            'PRINTNOW':if(ptr_valid((*pStateInfo).pTimeInfo))then sendToPrinter,pStateInfo

            'QUIT': begin

                ; Update ROI params to file?
                IF(ptr_valid((*pStateInfo).pFrameData) and (*pStateInfo).UpdateFile) THEN UpdateBlock, pStateInfo

                clean_up,pStateInfo
                WIDGET_CONTROL, event.top, /DESTROY
                ptr_free,pStateInfo
                return
            end

            'DOTIMEPERIOD': begin


                if(ptr_valid((*pStateInfo).pFrameData))then begin

                    ; temporary fix
                    ;print,'Heap_gc in to time period'
                    heap_gc;,/verbose

                    TimePeriodGUI, pStateInfo
                    if((*(*pStateInfo).pTimeInfo).process)then begin
                        ; for compatibility with other code
                        pLink = find_first_link( (*(*pStateInfo).pTimeInfo).pCurrent_link )

                        ; Image process options
                        if( (*pLink).display1 OR (*pLink).sendPrint OR (*pLink).sendTiff ) THEN begin

                            (*pStateInfo).PrintROI.Flags = 0
                            (*pStateInfo).printroi.dayflag=0
                            (*pStateInfo).printroi.timeline=''


                            if((*pLink).sendPrint)then (*pStateInfo).PrintROI.Flags = 1

                            if((*plink).sendTiff )then begin
                                (*pStateInfo).PrintROI.Flags = (*pStateInfo).PrintROI.Flags OR 2
                                ; set tiff file path
                                ;file = dialog_pickfile(get_path=tiffpath,title='Select folder for TIFF files')
                                ;if(file eq '')then begin
                                ;   r = dialog_message('You cancelled the path selection dialog, do you wish to cancel the TIFF output?',/question)
                                ;   if(r eq 'Yes')then (*pLink).sendTiff = !false
                                ;   dataPath = strmid((*pStateInfo).inFilename,0,rstrpos((*pStateInfo).inFilename,'\')+1)
                                ;   msg = 'Tiff file will be send to '+ dataPath
                                ;   r = dialog_message(msg,/info)
                                ;   (*pStateInfo).TIFFpath = dataPath
                                ;endif else (*pStateInfo).TIFFpath = tiffpath
                                (*pStateInfo).TIFFpath = (*pStateInfo).path
                            endif

                            if((*plink).display1  )then (*pStateInfo).PrintROI.Flags = (*pStateInfo).PrintROI.Flags OR 4

                            if((*plink).addsize1 or (*plink).addsize2)then (*pStateInfo).PrintROI.Flags = (*pStateInfo).PrintROI.Flags OR 8
                            if((*plink).addfocus )then (*pStateInfo).PrintROI.Flags = (*pStateInfo).PrintROI.Flags OR 16
                            if((*plink).addcutoff)then (*pStateInfo).PrintROI.Flags = (*pStateInfo).PrintROI.Flags OR 32
                            if((*plink).addround )then (*pStateInfo).PrintROI.Flags = (*pStateInfo).PrintROI.Flags OR 64
                            if((*plink).addtype  )then (*pStateInfo).PrintROI.Flags = (*pStateInfo).PrintROI.Flags OR 128
                            if((*plink).addtime  )then (*pStateInfo).PrintROI.Flags = (*pStateInfo).PrintROI.Flags OR 256 ;added on 4/13/04
                            if((*plink).addHextime  )then (*pStateInfo).PrintROI.Flags = (*pStateInfo).PrintROI.Flags OR 512 ;added on 08/06/2010


                            if((*pStateInfo).PrintROI.Flags ne 0)then (*pStateInfo).PrintROI.DoIt = !true
                        endif  ; image process option

                        ; png page option
                        if  (*plink).sendprint eq 1 or  (*plink).sendTiff eq 1 or  (*plink).display1 eq 1 then begin
                            index =Process_timeSeries_png_pages_only_3VCPI(pStateInfo)
                        endif

                        ;combined csv option.
                        if  (*pLink).Format eq 'spec1' and  (*pLink).sendascii eq 4 and  (*pLink).output eq 1 then begin;   for making combined.csv file.
                            index=Make_combined_dot_csv_file(pStateInfo)
                            close_ascii,pStateInfo
                        endif

                        if (*pLink).spectra then begin
                            r=Process_3VCPI_spectral_only(pStateInfo, volume = volume)
                            display_Histograms, pStateInfo, pLink
                        endif

                        if (*pLink).time then begin
                            r=Process_N_timeSeries_only(pStateInfo, volume = volume)
                            display_timeSeries, pStateInfo, pLink
                        endif



                    endif

                ENDIF ELSE  Ret = DIALOG_MESSAGE("A file needs to be open before specifying time periods.")

            end  ; end of doTimeseries


            'SHOWHISTOGRAMS':begin

            if(ptr_valid((*pStateInfo).pTimeInfo))then begin
                if((*(*pStateInfo).pTimeInfo).process)then begin
                    pLink = find_first_link( (*(*pStateInfo).pTimeInfo).pCurrent_link )
                    ; look at histogram(s)
                    if((*pLink).spectra)then display_Histograms, pStateInfo,pLink
                    if ((*pLink).time) then display_timeSeries, pStateInfo, pLink
                endif
            endif else r = dialog_message('Must compute histogram first')
        end


        'autoextract':begin

        if(ptr_valid((*pStateInfo).pFrameData))then begin

            ; get process parameters from pop-up
            parameters = extractgui(pStateInfo)
            ; return value
            ;paramters ={  start_time:start_time,                 time to start process
            ;          startID:[StrMon,StrDay,StrHr,StrMin,StrSec],  (widget ID's that are no longer valid)
            ;          stop_time:stop_time,                 time to stop processing
            ;          stopID:[StpMon,StpDay,StpHr,StpMin,StpSec],     (widget ID's that are no longer valid)
            ;          MedianFilters:4                       value for Median filter
            ;          GradientThresh:12                    value for gradient threshold
            ;          Thresh:-25                           value for threshold
            ;          multipleFiles:1                       value for how many files to do
            ;          OBJFile:!true,
            ;          asciiFile:!false,         used to indicate output of log files
            ;          ok:!false}

            ;add following part to choose a sweet spot for RICO and CPI version II for best results. added on January 26,2005.
            ; if (*pstateinfo).roi_frameheader_version eq 40 then begin
            ;   mo_message=[['These Roi files are from UAV (CPI II) with roi_version number 40'],$
            ;               ['       Bryan found in RICO that the sweet spot is: '],$
            ;               ['       filter=12, Darkness=-24,-25, gradient=17 to 21  '],$
            ;               ['Here we will use: filter=12, Darkness=-35, gradient=40 as default.']]
            ;   rrrr=dialog_message(mo_message,/information)
            ;   parameters.MEDIANFILTERS= 4
            ;   parameters.GRADIENTTHRESH= 40
            ;   parameters.THRESH        = -35
            ;  endif

            if(parameters.ok)then begin

                if(parameters.multipleFiles gt 1)then begin
                    process_multipleFiles,parameters,pStateInfo
                endif else begin
                    ;                if(parameters.asciiFile)then begin
                    ;                    ; ask user for a file name
                    ;                    ; use a default as a suggestion
                    ;                    suggest = strmid((*pStateInfo).InFileName,0,rstrpos((*pStateInfo).InFileName,'.')) + '_LOG.txt'
                    ;                    if((*pStateInfo).ASCIIFile eq '')then (*pStateInfo).ASCIIFile = dialog_pickfile(title='Enter an ASCII file name and press OK',file=suggest)

                    ;                    openw,lun,(*pStateInfo).ASCIIFile,/get
                    ;                    (*pStateInfo).AsciiLUN = lun

                    ;                    ; write header line
                    ;                    header = 'frm#   Flags    Len     Wid     Dark   Area    Perim      Centroid    Rndns   XMnt   YMnt   RBnd   FrcD Foc COff Cry Conf'
                    ;                    printf,(*pStateInfo).AsciiLUN,header

                    ;                endif

                    ; processing a new obj file, reset file parameters
                    if((*pStateInfo).objLUN ne -1)then begin
                        free_lun,(*pStateInfo).objLUN
                        (*pStateInfo).objLUN = -1
                    endif

                    initpTimeInfo, pStateInfo,multiple = 0
                    process_frames , parameters,pStateInfo

                    ; update pStateInfo with current objData
                    if(ptr_valid((*pStateInfo).pObjList))then begin
                        objData = get_obj_header((*pStateInfo).ObjLUN,(*(*pStateInfo).pObjList)[(*pStateInfo).ImgPos-1].fPos)
                        ; store obj info
                        (*pStateInfo).pObjData = ptr_new(objData)
                    endif

                    if (parameters.ASCIIFile)then begin
                        ; add log files for each
                        ; first do particle log file
                        pLink = (*(*pStateInfo).pTimeInfo).pCurrent_link
                        (*pLink).sendASCII = 1
                        (*pLink).output = 1

                        (*pLink).sendASCII = 4
                        (*pLink).Format = 'spec1'
                        select = bytarr(50) + 1B
                        select[47]=0   ; skip boundary
                        (*pLink).pSelect = ptr_new(select)
                        ; call processing
                        index = Process_timeSeries( pStateInfo)
                        close_ascii,pStateInfo

                        ; then do frame log
                        (*pLink).Format = 'frame'
                        index = Process_timeSeries( pStateInfo)
                        close_ascii,pStateInfo

                        ; finally do hertz log
                        (*pLink).Format = 'hertz'
                        index = Process_timeSeries( pStateInfo)
                        close_ascii,pStateInfo
                    endif

                endelse
            endif

            if(parameters.ok)then r = dialog_message('Move mouse over ROI to see parameters, left click on an ROI to toggle Perimeter display',/info)
        endif ELSE  Ret = DIALOG_MESSAGE("A file needs to be open before auto processing.")

    end


    ;'read_objects':Load_Object_file,pStateInfo, /get_filename

    'XLOADCT': xloadct,group=event.top,updateCallBack = 'redo',updateCBData=pStateInfo

    'about':begin
    title =(*pStateInfo).appname +  ' vers ' + strtrim((*pStateInfo).version,2)
    msg = [[title],['copyright SPEC, INC. 2000'],['Contact SPEC Inc for information at 303-449-1105']]
    r = dialog_message(msg,/info)
end
'rev':begin
display_help,group=event.top
end

;'Preferences':preferences,pStateInfo
else:r = dialog_message('missing menu case in main_event')
endcase
end
endcase

heap_gc;,/verbose
end

