pro find_Image_Parameters, B, contour_area
    ; AreaContour90,AreaImg90,AreaSpt90,AreaContour,AreaImg,AreaSpt

    ;input is image B
    ;output is contur_area; which is the max of contour_area 0 and 90 degrees.

    ;poison spot area is the total area of the image minus the contour_area

    ;**********************************************************
    ;%B is a digital binary image: matrix m x n consisting of "0" and "1"
    ;   [n,m]=size(B);  %find dimension of B
    ;   %find Dmax, Dspot Dring
    ;   Dmaxi=zeros(1,n);  % predetermine Dmaxi
    ;   for ni=1:n
    ;       Jones=find(B(ni,:));   %find the numbers of all ones in the column "ni"
    ;       if ~isempty(Jones)    % skip the column if empty
    ;            Dmaxi(ni)=Jones(end)-Jones(1)+1
    ;       end
    ;   end

    ;%dimensions of the digital images
    ;AreaContour=sum(Dmaxi);        % area inside the contour
    ;AreaImg=sum(sum(B));             % shaded area of the image
    ;AreaSpt=AreaContour-AreaImg; % area of the Poisson spot

    ;Then rotate the image 90deg and repeat the above
    ;or do the same calculations along the rows "m", in this case the rotation is unnecessary.
    ;*************************************************************
    n=n_elements(B(*,0));  %find dimension of B
    m=n_elements(B(0,*))
    ;find Dmax, Dspot Dring
    Dmaxi=intarr(n);       ;predetermine Dmaxi
    for ni=0,n-1 do begin
        index=where(B(ni,*) eq 0,contG); %find the numbers of all ones in the column "ni"
        if contG gt 0 then Dmaxi(ni)=index(contG-1)-index(0)+1 else Dmaxi(ni)=0
    endfor

    ; dimensions of the digital images
    AreaContour=total(Dmaxi);       % area inside the contour
    ;AreaImg=total(B);          % shaded area of the image
    ;AreaSpt=AreaContour-AreaImg;  % area of the Poisson spot

    ;rotate the image 90 degree and repeat above
    Dmaxi=intarr(m);       ;predetermine Dmaxi
    for ni=0,m-1 do begin
        index=where(B(*,ni) eq 0,contG); %find the numbers of all ones in the column "ni"
        if contG gt 0 then Dmaxi(ni)=index(contG-1)-index(0)+1 else Dmaxi(ni)=0
    endfor

    ; dimensions of the digital images
    AreaContour90=total(Dmaxi);       % area inside the contour
    ; AreaImg90=total(B);          % shaded area of the image
    ;AreaSpt90=AreaContour90-AreaImg90;  % area of the Poisson spot
    contour_area=max([areacontour90,areaContour])
end
;*************************************************************************************


