pro generate_zoomed_asciiHorV,HorV,info, ave_info

    Common  DataBlock,alldataH,alldataV,ADataH,ADataV,FirstData,LastData,StripData,FirstDataV,LastDataV,StripDataV,OneHzH,OneHzV

    OD = {_DerivedDataRev2}
    print, "File name is currently: ", info.currentFname
    ;  ; Put the info structure back in its storage location.

    sub_strs=strsplit(info.currentPname,'\',/extract)
    parent_dir=strjoin(sub_strs(0:n_elements(sub_strs)-2),'\')+'\'
    fname = parent_dir + HorV+"_zoomed-ascii-" + ave_info.StartTimeString + '-TO-' + ave_info.EndTimeString + '-' + info.datestamp + ".txt"

    if HorV eq 'H' then allData=alldataH else alldata=alldataV

    ;----------------------------------------------------------------------
    ; Assume the month and year will not change during the data collection
    ;----------------------------------------------------------------------
    year = fix(strmid(info.datestamp,0,2))
    month = fix(strmid(info.datestamp,2,2))
    ; AD.AllMonths = year * 12 + month

    ;replace this by exact time from teh zoomed period.
    ;h_array =  (*alldataH)[ave_info.H_First_Index:ave_info.H_Last_Index]
    ;v_array =  (*alldataV)[ave_info.V_First_Index:ave_info.V_Last_Index]
    ;**************************************************************
    index=where((*alldata).nanoseconds ge ave_info.startnanoseconds and $
        (*alldata).nanoseconds le ave_info.endnanoseconds,contGG)
    if contGG gt 1 then begin
        h_array=(*alldata)(index)
    endif else begin
        h_array=replicate({_DerivedDataRev2},2)
        h_array(0).nanoseconds=ave_info.startnanoseconds
        h_array(1).nanoseconds=ave_info.startnanoseconds+1
        h_array(0).area=-100
        h_array(1).area=-101
    endelse
    h_array[*].Imagewords = 1 ;this will allow us to determine H/V after we intermix the H/V files
    both_array  = [h_array]  ; Make a combined array of both H and V

    bsize = n_elements(both_array)

    if bsize eq 1 then begin;   added this to handle Ian's 2DS_128 mode.
        both_array=replicate({_DerivedDataRev2},2)
        both_array(0)=h_array(0)
        both_array(1)=h_array(0)
    endif


    ;testme = both_array[1:bsize-1].Nanoseconds - both_array[0:bsize-2].Nanoseconds

    gttest = where(both_array[1:bsize-1].Nanoseconds gt both_array[0:bsize-2].Nanoseconds,gtcount)
    gttest1 = where(both_array[1:bsize-1].Nanoseconds lt both_array[0:bsize-2].Nanoseconds,gtcount1)

    print, gtcount,gtcount1
    if (gtcount1 ne 0) then begin
        ; r = dialog_message(['Time sequence problem detected in file:',fname,'Please contact C.Wieland with info about filename.'],TITLE = 'Please Contact C.Wieland')
    endif
    ;-----------------------------------------------------------------------
    ; save the data
    ;-----------------------------------------------------------------------

    ;----------------------------------------------------------
    ; Lets store the  ASCII files in their own subdirectory under the
    ;   directory where the .BIN files used for their creation are located.


    PUSHD, !currentHPname    ; change our path to the directory where the .BIN files we're using are located
    valid = 0
    ON_IOERROR, file_problem
    file_mkdir, 'ASCII'   ; create (if it's not already there) the directory to store PNG's in
    cd,'ASCII'            ; make this our current directory

    ptr = 0L
    maxptr = n_elements(both_array)
    OpenW, ascii_lun, fname, /Get_Lun

    ;write the header lines
    note_line1='Nanoseconds is since midnight of the date, hh:mm:ss:*** is the particle endtime,  Area is shaded pixel area, all sizes are in unit pixel.  L1 is size in TAS direction, L2 is size in photo-diode array'
    note_line2='direction, F1 is the counts of image reaching the diode array edges, F1=0, not touching any edges, F2=1 or 2,  touch upper or lower edge, F1=3 mean particle is too big so that both ends of the '
    note_line3='diode array are touched. Adj1 is enhancement factor which is a function of L1. PC1 is image center in pixel unit relative to the 128 diode array. '
    note_line4='Tick is probe"s_clock_counter at the end of a particle, maxlength, maxwidth,perimeterum(in unit um), L4, L5 L7 L8 are other measures of particle size. W8_t is inter-particle time. reject=0 means good particles.'
    note_line5='LargestStltA(square microns) is other measure of Area, Alexei1(square pixel) is largest area of the boundary contours by summing the length from outer most two points in X  and Y direction.'
    name_line='C Otas Oalexei Old_NanoSeconds  NanoSeconds hh:mm:ss:mms:ums:nns      Area Nslice  L2 F1  Adj1 PC1   TAS   Warn      Ticks   ' + $
        '   maxlength   maxwidth perimeterum  L4    L5    L7     L8           W8_t         W8t_new  reject rjtype NofSatellite LargestStltA  Alexei1  L1n  adj0'

    printf,ascii_lun,ave_info.binfilename; ;give the source file-name
    printf,ascii_lun,'Number of '+HorV+' Channel events is:   ',ContGG
    printf,ascii_lun,'Notes:'
    printf,ascii_lun,note_line1
    printf,ascii_lun,note_line2
    printf,ascii_lun,note_line3
    printf,ascii_lun,note_line4
    printf,ascii_lun,note_line5
    printf,ascii_lun,'Names of variable in each column:'
    printf,ascii_lun,name_line


    while(ptr lt maxptr) do begin
        ;if (both_array[ptr].Imagewords eq 1) then begin
        ;   a = string(format = '(%"H %d %d %d %d %d %d %8.5g %d %8.5g")',$
        ;       AD.AllMonths, both_array[ptr].Nanoseconds, both_array[ptr].Area, both_array[ptr].L1, both_array[ptr].L2, both_array[ptr].F1, both_array[ptr].Adj1,both_array[ptr].Pc1,both_array[ptr].TAS)
        ;endif else begin
        ;   a = string(format = '(%"V %d %d %d %d %d %d %8.5g %d %8.5g")',$
        ;       AD.AllMonths, both_array[ptr].Nanoseconds, both_array[ptr].Area, both_array[ptr].L1, both_array[ptr].L2, both_array[ptr].F1, both_array[ptr].Adj1,both_array[ptr].Pc1,both_array[ptr].TAS)
        ;endelse
        if (both_array[ptr].Imagewords eq 1) then begin
            ;a = string(format = '(%"H %d A %d %d %d %d %8.5g %d %8.5g %d %d %d %d %d %d %d %d %d %d %d")',$
            this_time=SPEC_Nano2HMS(both_array[ptr].Nanoseconds);   AD.AllMonths,
            ;                    H                      nano hh:mm:ss Area  L1   L2     F1    adj1    pc1     TAS   warn  ticks   L3     L4       L5        L7    L8      W8_t  reject  alexei1,L1n, adj0
            a = string(format='(A1,1x,I3,1x,F9.1,1x,I14,1x,I14,1x,A20,1x,I7,1x,I4,1x,I4,1x, I1,1x,F6.2,1x,F6.2,1x,I3,1x,I5,1x,I14,1x,F8.1,1x,F8.1,1x,F10.1,1x,F6.1,1x,F6.1,1x,F6.1,1x,F6.1,1x,I14,1x,I14,1x,I6,1x,I6,1x,I6,1x,2(F12.1,1x),F8.1,1x,F4.1)',$
                HorV,Both_array[ptr].tasold,Both_array[ptr].alexei1old,Both_array[ptr].nanosecsold,$; old nano-seconds
                both_array[ptr].Nanoseconds, this_time, both_array[ptr].Area, both_array[ptr].Nslice,$
                both_array[ptr].L2, both_array[ptr].F1, both_array[ptr].Adj1,both_array[ptr].Pc1,$  ;pC1 is F6.2
                both_array[ptr].TAS,Both_array[ptr].warn, both_array[ptr].probecounter, both_array[ptr].maxlength,both_array[ptr].maxwidth, both_array[ptr].perimeterum,$; 10.1 is perimeter.
                both_array[ptr].L4,both_array[ptr].L5,both_array[ptr].L7,both_array[ptr].L8,both_array[ptr].W8_t,$;  I14 is w8_t.
                both_array[ptr].w8_t_clean,both_array[ptr].reject,both_array[ptr].noisebyte,both_array[ptr]. NUM_SATELLITES,$
                both_array[ptr].largest_Satellite_area, both_array[ptr].Alexei1,Both_array[ptr].L1n,Both_array[ptr].adj0)
        endif

        printf, ascii_lun, a
        ptr++
    endwhile

    Close ,ascii_lun
    Free_Lun, ascii_lun

    valid = 1
    file_problem: if valid eq 0 then begin
        r = dialog_message('Error, cannot create directory ASCII, or cannot create the ASCII file!',TITLE = 'Update Error')
    endif
    ;******************* done H-channel writting the data

    ;************************************************************************************************
    POPD
    ON_IOERROR, NULL

    ;Widget_Control, ave_info.statusID, DYNAMIC_RESIZE=1, Set_Value= "Ascii file written: " + fname
    device, CURSOR_STANDARD= !ARROW_CURSOR  ; show hourglass while we process the data
    ; r = dialog_message(['ASCII file has been created:',fname],TITLE = 'Zoomed ASCII data written')

    ;Widget_Control, info.statusID, DYNAMIC_RESIZE=1, Set_Value="Opened: " + info.currentFname

end

;************************************************************

pro generate_zoomed_ascii,info, ave_info

    generate_zoomed_asciiHorV,'H',info, ave_info
    generate_zoomed_asciiHorV,'V',info, ave_info

end

;*******************************************************************
