pro plot_archive_mean_psd_and_the_a3vcpiview_cmpA_psd


    ;get a3vcpiview saved.txt psds---file 1
    get_2dsview_psd_cmp_psd,x2ds,y2ds1,filename1,pathnm1

    y1=y2ds1.y4;     ; Mass_psd;  of V
    y1h=y2ds1.y8

    ;get archived saved.txt psds---file 2
    get_2dsview_psd_cmp_psd,x2ds,y2ds2,filename2,pathnm1

    y2=y2ds2.y1;     ; Hconc_psd; of M4
    y2h=y2ds2.y8

    ; plot only 2 curves

    window,1,xs=400,ys=400
    loadct,0
    !P.thick=1
    !P.CHARSIZE=1
    !P.multi=[0,1,1]
    white=!D.N_COLORS-1
    !P.BACKGROUND=white

    index=where(y1h gt 0.0,contG)
    if contG gt 0 then begin
        ymin1=min(y1h(index))
    endif else ymin1=0.0001

    index=where(y2h gt 0.0,contG)
    if contG gt 0 then begin
        ymin2=min(y2h(index))
    endif else ymin2=0.0001

    ymin=min([ymin1,ymin2])
    ymax=max([max(y1h),max(y2h)])
    ymin=10.0^floor(Alog10(ymin))
    ymax=10.0^ceil(Alog10(ymax))



    PLOT, x2ds, y1h, COLOR=0, XRANGE=[10,10000], /Xlog,$
        Xstyle = 1, YLOG=1,xtitle='Particle Size(um)',TITLE='2DS--PSDs ',$
        THICK=1, YRANGE=[ymin, ymax],ystyle=1, charsize=1.0,$
        YTITLE='mg/L/um';  Yticks=ytikn,Ytickn=myticknames

    oplot,x2ds,y2h,color=255

    xyouts,310, 350,'2dsV CMP_psd',color=0,/device
    xyouts,310, 330,'2dsV archive_mean',color=255,/device

    pathnm=file_dirname(filename2)+'\'
    write_png,pathnm+'File1_file2__M_psd_compare.png',tvrd(true=1)

    window,2,xs=400,ys=400

    index=where(y1 gt 0.0,contG)
    if contG gt 0 then begin
        ymin1=min(y1(index))
    endif else ymin1=0.0001

    index=where(y2 gt 0.0,contG)
    if contG gt 0 then begin
        ymin2=min(y2(index))
    endif else ymin2=0.0001

    ymin=min([ymin1,ymin2])
    ymax=max([max(y1),max(y2)])
    ymin=10.0^floor(Alog10(ymin))
    ymax=10.0^ceil(Alog10(ymax))



    PLOT, x2ds, y1, COLOR=0, XRANGE=[10,10000], /Xlog,$
        Xstyle = 1, YLOG=1,xtitle='Particle Size(um)',TITLE='2DS--PSDs ',$
        THICK=1, YRANGE=[ymin, ymax],ystyle=1, charsize=1.0,$
        YTITLE='#/L/um';  Yticks=ytikn,Ytickn=myticknames

    oplot,x2ds,y2,color=255

    xyouts,310, 350,'2dsV CMP_psd',color=0,/device
    xyouts,310, 330,'2dsV archive_mean',color=255,/device

    pathnm=file_dirname(filename2)+'\'
    write_png,pathnm+'File1_file2__N_psd_compare.png',tvrd(true=1)


    ;stop
    ;Ok, SO far the Hconc, Hypts Hextn, Hmass agrees with 2dsview comp_psd results.
end; end of plot_2ds_1Hz_mean_psd
;*************************************************

pro get_2dsview_psd_cmp_psd,x2ds,y2ds,filename,pathnm
    ;read 2ds psd data file
    filter_str='*PSD_CMP*.txt'
    if n_elements(pathnm) ne 0 then begin
        filename=dialog_pickfile(filter=filter_str,path=pathnm,title='Pick a 2ds psd *PSD_CMP*.txt file')
    endif else begin
        filename=dialog_pickfile(filter=filter_str,get_path=pathnm,title='Pick a 2ds psd *PSD_CMP*.txt file')
    endelse

    combined_string='xbin_edges'
    find_string_pos,filename,combined_string,pos; get the first header line position.

    data=read_ascii(filename,count=n_lines);  find how many lines in the data file.
    ;read in the 2ds binedges and bin heights data
    records_c=n_lines-pos
    data=read_ascii(filename,data_start=pos,Num_records=records_c)
    data=data.field1
    x2ds=data[0,0:records_c-1]
    col2=data[1,0:records_c-1]
    col3=data[2,0:records_c-1]
    col4=data[3,0:records_c-1]
    col5=data[4,0:records_c-1]
    col6=data[5,0:records_c-1]
    col7=data[6,0:records_c-1]
    col8=data[7,0:records_c-1]
    col9=data[8,0:records_c-1]
    y2ds={y1:col2,y2:col3,y3:col4,y4:col5,y5:col6,y6:col7,y7:col8,y8:col9}
end
;***************************************************

pro find_string_pos,filename,search_string,pos
    ;search_string='PDs =';'WYSIWYG:'
    ;filename='abcdefg.ascii'
    ; Note: the input search_tsring can be someting like this: 'abcd egfhj hhhh'
    result=read_ascii(filename,count=n_lines);   ;find out how many lines in the file.

    for i=2,n_lines-1 do begin
        result=read_ascii(filename,data_start=i-1,header=readed_line,num_records=1)
        ;skip i-1 lines, read in readed_line as header, and read 1 records.
        aa=readed_line(*,0)
        nn=n_elements(aa)
        last_line=readed_line(nn-1,*)
        last_line=strtrim(last_line,2);   ; take teh leading and tailing balnks away.

        ;print,readed_line; ;print,'aaaaaaaaaaaaa';;print,last_line;print,'*************'

        find = STRCMP(last_line, search_String, strlen(search_string), /FOLD_CASE)
        if (find eq 1) then begin
            pos=i-1
            break;   ;breakout of the for loop.
        endif else begin
            pos=0
        endelse
    endfor

    if pos eq 0 then begin
        print, 'Data line with ',search_string,' not found in file: ',filename
        ;stop
    endif;  print, pos
end; ;end of function find_string_pos.

;***********************************************************
