;***********************************************************************
pro ZoomChartDrop1_event, event
    Widget_Control, event.top, Get_UValue=ave_info, /No_Copy  ; get our info structure
    mess = 'Running procedure #'+ strtrim(string(ave_info.DropdownFunction1),2)+ ' from the top dropdown list'
    r = dialog_message(mess,TITLE = 'Dropdown Function in zoomchartevents.pro')
    ;call subroutine to draw the time series plots and Psd plots

    case ave_info.dropdownfunction1 of
        0: L_choice='M1'
        1: L_choice='M2'
        2: L_choice='M3'
        3: L_choice='M4'
        4: L_choice='M5'
        5: L_choice='M6'
        6: L_choice='M7'
        else: L_choice='M1'
    endcase
    DrawTimeSeries_hires_mo, ave_info,L_choice
    Draw_Default_averaged_psd,ave_info,L_choice
    ; Plot_HiRes_time_series_and_psd_of_the_period,ave_info
    Widget_Control, event.top, Set_UValue=ave_info, /No_Copy  ; get our info structure
end

;***********************************************************************
pro ZoomDrop1_event, event
    Widget_Control, event.top, Get_UValue=ave_info, /No_Copy  ; get our info structure
    ave_info.DropdownFunction1 = event.index
    Widget_Control, event.top, Set_UValue=ave_info, /No_Copy  ; get our info structure
end
;****************************************************************************************
;***********************************************************************
pro ZoomDrop2_event, event
    Widget_Control, event.top, Get_UValue=ave_info, /No_Copy  ; get our info structure
    if event.index eq 0 then begin;   ; to save the png plot.
        ZoomChartPNG_event, ave_info; event
    endif
    if event.index eq 1 then begin;   ; to save the zoomed ascii data.
        datestamp=strmid(ave_info.binfilename,17,26)
        info={currentPname:!currentHPname,currentFname:!currentHFname,datestamp:datestamp}
        generate_zoomed_ascii, info, ave_info
    endif
    if event.index eq 2 then begin  ; to pring the png
        ZoomchartPrint_event,ave_info
    endif

    Widget_Control, event.top, Set_UValue=ave_info, /No_Copy  ; get our info structure
end
;****************************************************************************************
;***********************************************************************
pro ZoomDrop3_event, event
    Widget_Control, event.top, Get_UValue=ave_info, /No_Copy  ; get our info structure
    if event.index eq 0 then begin;   ; to do compare psd.
        ;compare_psd_methods_event, ave_info
        a3vcpiview_psd_methods,ave_info
    endif
    if event.index eq 1 then begin;   ; to do compare psd with size of equivalnet spherical area.
        a3vcpiview_psd_methods_area_equivalent,ave_info
    endif
    if event.index eq 2 then begin  ; to pring the png

    endif

    Widget_Control, event.top, Set_UValue=ave_info, /No_Copy  ; get our info structure
end
;****************************************************************************************

pro DrawTimeSeries_hires_mo, ave_info,L_choice
    Common  DataBlock,alldataH,alldataV,ADataH,ADataV,FirstData,LastData,StripData,$
        FirstDataV,LastDataV,StripDataV,avestripdata,avestripdataV
    forward_function SPEC_Nano2HMS

    Widget_Control, ave_info.ZoomWindowSeriesDrawID, Get_Value=wid

    bluecolor  = GetColor("Navy",  !D.Table_Size-2)
    redcolor   = GetColor("Red",   !D.Table_Size-2)
    whitecolor = GetColor("White", !D.Table_Size-2)
    ;-------------------------------------------------------------
    ;This routine use ave_info --user selected start-time and endtime to get
    ;particles within the time period to make high resolution time series plots,
    ;always 300 bins. concentration, extinction, IWC vs time.
    info={Nbins:300}
    ptr=ptr_new(info,/no_copy)
    Get_one_TMS_Trace_300bin_HV_time_series,ptr,ave_info,L_choice,'H','conc',Hypts1,Hystr1
    Get_one_TMS_Trace_300bin_HV_time_series,ptr,ave_info,L_choice,'H','extI',Hypts2,Hystr2
    Get_one_TMS_Trace_300bin_HV_time_series,ptr,ave_info,L_choice,'H','IWC', Hypts3,Hystr3
    Get_one_TMS_Trace_300bin_HV_time_series,ptr,ave_info,L_choice,'V','conc',Vypts1,Vystr1
    Get_one_TMS_Trace_300bin_HV_time_series,ptr,ave_info,L_choice,'V','extI',Vypts2,Vystr2
    Get_one_TMS_Trace_300bin_HV_time_series,ptr,ave_info,L_choice,'V','IWC', Vypts3,Vystr3

    ; Look at the first and last particles in this
    ;  file for the range of timestamps.
    ;---------------------------------------------

    plot_string =  !ZOOM_START_STRING +  $
        " to " + !ZOOM_END_STRING
    plot_string2 =' Images: '+ave_info.Hpartcont+' '+ave_info.Vpartcont; ave_info.Hpartcont is string.

    OverFlow_deadTime ='OverFlowDeadtime: '+ $
        string(format = '(%"H=%6.3f s ")',ave_info.HDT_ovfl) + $
        string(format = '(%"V=%6.3f s")',ave_info.VDT_ovfl)
    Mask_deadTime ='MasK_Deadtime: '+ $
        string(format = '(%"H=%6.3f s ")',ave_info.HDT_mask) + $
        string(format = '(%"V=%6.3f s")',ave_info.VDT_mask)
    L1_deadTime   ='L1_Deadtime: '+ $
        string(format = '(%"H=%6.3f s ")',ave_info.HDT_L1) + $
        string(format = '(%"V=%6.3f s")',ave_info.VDT_L1)
    Bad1_deadtime='badtyp1_deadtime: '+ $
        string(format = '(%"H=%6.3f s ")',ave_info.HDT_bad1) + $
        string(format = '(%"V=%6.3f s")',ave_info.VDT_bad1)

    Bad2_deadtime='badtyp2_deadtime: '+ $
        string(format = '(%"H=%6.3f s ")',ave_info.HDT_bad2) + $
        string(format = '(%"V=%6.3f s")',ave_info.VDT_bad2)

    chart1 =    [0.10, 0.680, 0.95, 0.925]
    chart2 =    [0.10, 0.680 - 0.31, 0.95, 0.925-0.31]
    chart3 =    [0.10, 0.680 - 0.62, 0.95, 0.925-0.62]

    axisColor = GetColor("Navy",  !D.Table_Size-2)
    dataColor = GetColor("Navy",  !D.Table_Size-2)
    backColor = GetColor("White", !D.Table_Size-2)

    thisCharsize = Str_Size('A Sample String', 0.25)

    strf = 'aaa'; SPEC_Nano2HMS(local_FirstData.Nanoseconds)
    strl = 'bbb'; SPEC_Nano2HMS(local_LastData.Nanoseconds)

    fullrange = 0ULL
    binwidth = 0ULL
    ;fullrange = local_LastData.Nanoseconds - local_FirstData.Nanoseconds
    fullrange = ave_info.endNanoseconds - ave_info.startNanoseconds
    binwidth = fullrange/8
    curbin = ave_info.startNanoseconds

    tnames = StrArr(9)
    FOR i=0,8 DO BEGIN
        tnames(i) =  strtrim(strmid(SPEC_Nano2HMS(curbin),0,12),2)
        curbin += binwidth
    ENDFOR

    ;-------------------------------
    ;Set up X axis tick labels.
    ;-------------------------------
    !X.TICKNAME = tnames
    !X.TICKS = 8

    !P.Multi = [0,3,1,0,1]  ; Make sure we're plotting at the top position
    ymax=max([Hypts1,Vypts1])
    MyYrange=[0.0,ymax]

    H_dead = string(format = '(%"H=%6.3f Secs ")',ave_info.Hdeadtime)
    V_dead = string(format = '(%"V=%6.3f Secs")',ave_info.Vdeadtime)
    main_title = 'Particle Concentration (H=BLUE, V=RED) Deadtime '+ H_dead + V_dead
    y_title = 'Concentration'
    ;----------------------------------------------------
    ; Make sure the window we're plotting to is selected
    ;----------------------------------------------------
    Widget_Control, ave_info.ZoomWindowSeriesDrawID, Get_Value=wid
    WSet, wid

    thisCharsize = 1.8


    Plot, Hypts1, Yrange=myYrange,$
        Background=backcolor, $           ; The background color of the display.
        Charsize=thisCharsize, $          ; The character size, as determined by Str_Size.
        Color=axiscolor, $                ; The color of the axes.
        XStyle=1, $                       ; Exact axis scaling. No autoscaled axes.
        ; XTickformat='(I6)', $
        Title = main_title, $
        YTitle = y_title , $
        Position=chart1 ; , $
        ;XTICKFORMAT='MYXTICKS'
        oplot,Vypts1,color=redcolor


    ymax=max([Hypts2,Vypts2])
    MyYrange=[0.0,ymax]
    main_title = 'Extinction(H=BLUE, V=RED)   Method:'+L_choice +'     '+OverFlow_deadTime
    y_title = 'Extinction'


    Plot, Hypts2,Yrange=myYrange, $
        Background=backcolor, $           ; The background color of the display.
        Charsize=thisCharsize, $          ; The character size, as determined by Str_Size.
        Color=axiscolor, $                ; The color of the axes.
        XStyle=1, $                       ; Exact axis scaling. No autoscaled axes.
        ; XTickformat='(I6)', $
        Title = main_title, $
        YTitle = y_title , $
        Position=chart2 , $
        /NOERASE ;, $
        ; XTICKFORMAT='MYXTICKS'
        Oplot,Vypts2, color = redcolor

    ymax=max([Hypts3,Vypts3])
    MyYrange=[0.0,ymax]

    main_title = 'IWC (H=BLUE, V=RED)     ' + Mask_Deadtime + '    ' + L1_deadtime
    y_title    = 'Iwc, (g/m3)'


    Plot, Hypts3, Yrange=myYrange,$
        Background=backcolor, $           ; The background color of the display.
        Charsize=thisCharsize, $          ; The character size, as determined by Str_Size.
        Color=axiscolor, $                ; The color of the axes.
        XStyle=1, $                       ; Exact axis scaling. No autoscaled axes.
        ; XTickformat='(I6)', $
        Title = main_title, $
        YTitle = y_title , $
        Position=chart3 , $
        /NOERASE
    ; XTICKFORMAT='MYXTICKS'
    Oplot,Vypts3, color = redcolor
    xyouts,180, 4, Bad1_deadtime+'   '+bad2_deadtime, color=bluecolor,size=1,/device

    !X.TICKNAME = ''
    !X.TICKS = 0

    XYOUTS,25,470, 'In.File: ' + strmid(!CurrentHFname,strlen(!CurrentHPname)) +$
        ' Frm ' + plot_string + ' ' + plot_string2 ,color=bluecolor, size=1, /device
    device, CURSOR_STANDARD= !ARROW_CURSOR  ; show hourglass while we process the data
end; end of drawtimeseries_Hires_mo.pro
;*************************************************************************************************************
;********************************************
pro  Draw_default_averaged_psd,ave_info,L_choice
    Common  DataBlock,alldataH,alldataV,ADataH,ADataV,FirstData,LastData,StripData,$
        FirstDataV,LastDataV,StripDataV,avestripdata,avestripdataV
    Widget_Control, ave_info.ZoomWindowDrawID, Get_Value=wid



    forward_function  SPEC_Nano2HMS_struct, strrepl
    widget_control, /hourglass;  show hourglass while following is processing. june 18, 2005

    delta_s =(ave_info.endnanoseconds-ave_info.startnanoseconds)/1000000000.0

    if delta_s lt 10000.0 then  $
        delta_s ='dT='+string(delta_s,format='(F6.1)')+'s'  $
        else delta_s ='dT='+string(delta_s,format='(I6)')+'s'

    !ZOOM_START_STRING = SPEC_Nano2HMS(ave_info.StartNanoSeconds)
    !ZOOM_END_STRING = SPEC_Nano2HMS(ave_info.EndNanoSeconds)
    plot_string = !ZOOM_START_STRING +"--" + !ZOOM_END_STRING

    plot_string2 =  strtrim(string(10000),2) + ' H , ' + $
        strtrim(string(20000),2) + ' V Data Points'

    message_string = 'Zoomed data from ' + !ZOOM_START_STRING +  $
        " to " + !ZOOM_END_STRING + ' , ' + plot_string2

    Widget_Control, ave_info.ZoomWindowID, TLB_SET_TITLE = message_string

    ; replace above with following.
    if L_choice ne 'M6' then begin
        Calculate_one_psd_trace,'H',L_choice,ave_info,'binc',xpts,Hbinc,ystr,deadtime,HPartcont,dBz,Ra,Rb
        Calculate_one_psd_trace,'H',L_choice,ave_info,'conc',xpts,Hconc,ystr,deadtime,HPartcont,dBz,Ra,Rb
        Calculate_one_psd_trace,'H',L_choice,ave_info,'Aice',xpts,Hextn,ystr,deadtime,HPartcont,dBz,Ra,Rb
        Calculate_one_psd_trace,'H',L_choice,ave_info,'IWC',xpts, Hiwc, ystr,deadtime,HPartcont,dBz,Ra,Rb
        Calculate_one_psd_trace,'H',L_choice,ave_info,'Lwc',xpts, HLwc, ystr,deadtime,HPartcont,dBz,Ra,Rb
        Calculate_one_psd_trace,'V',L_choice,ave_info,'binc',xpts,Vbinc,ystr,deadtime,VPartcont,dBz,Ra,Rb
        Calculate_one_psd_trace,'V',L_choice,ave_info,'conc',xpts,Vconc,ystr,deadtime,VPartcont,dBz,Ra,Rb
        Calculate_one_psd_trace,'V',L_choice,ave_info,'Aice',xpts,Vextn,ystr,deadtime,VPartcont,dBz,Ra,Rb
        Calculate_one_psd_trace,'V',L_choice,ave_info,'IWC',xpts, Viwc, ystr,deadtime,VPartcont,dBz,Ra,Rb
        Calculate_one_psd_trace,'V',L_choice,ave_info,'Lwc',xpts, VLwc, ystr,deadtime,VPartcont,dBz,Ra,Rb
    endif

    if L_choice eq 'M6' then begin
        Calculate_one_psd_trace_M6,'H','M1',ave_info,'binc',xpts,Hbinc1,ystr,deadtime,HPartcont,dBz,Ra,Rb
        Calculate_one_psd_trace_M6,'H','M2',ave_info,'binc',xpts,Hbinc2,ystr,deadtime,HPartcont2,dBz,Ra,Rb
        Hbinc=Hbinc2
        Hbinc(64:*)=Hbinc1(64:*)
        Hbinc(52:63)=(Hbinc1(52:63)+Hbinc2(52:63))/2.0

        Calculate_one_psd_trace_m6,'H','M1',ave_info,'conc',xpts,Hconc1,ystr,deadtime,HPartcont,dBz,Ra,Rb
        Calculate_one_psd_trace_m6,'H','M2',ave_info,'conc',xpts,Hconc2,ystr,deadtime,HPartcont2,dBz,Ra,Rb
        Hconc=Hconc2
        Hconc(64:*)=Hconc1(64:*)
        Hconc(52:63)=(Hconc1(52:63)+Hconc2(52:63))/2.0

        Calculate_one_psd_trace_M6,'H','M1',ave_info,'Aice',xpts,Hextn1,ystr,deadtime,HPartcont,dBz,Ra,Rb
        Calculate_one_psd_trace_M6,'H','M2',ave_info,'Aice',xpts,Hextn2,ystr,deadtime,HPartcont2,dBz,Ra,Rb
        Hextn=Hextn2
        Hextn(64:*)=Hextn1(64:*)
        Hextn(52:63)=(Hextn1(52:63)+Hextn2(52:63))/2.0

        Calculate_one_psd_trace_m6,'H','M1',ave_info,'IWC',xpts, Hiwc1, ystr,deadtime,HPartcont,dBz,Ra,Rb
        Calculate_one_psd_trace_m6,'H','M2',ave_info,'IWC',xpts, Hiwc2, ystr,deadtime,HPartcont2,dBz,Ra,Rb
        Hiwc=Hiwc2
        Hiwc(64:*)=Hiwc1(64:*)
        Hiwc(52:63)=(Hiwc1(52:63)+Hiwc2(52:63))/2.0

        Calculate_one_psd_trace_m6,'H','M1',ave_info,'Lwc',xpts, HLwc1, ystr,deadtime,HPartcont,dBz,Ra,Rb
        Calculate_one_psd_trace_m6,'H','M2',ave_info,'Lwc',xpts, HLwc2, ystr,deadtime,HPartcont2,dBz,Ra,Rb
        HLwc=HLwc2
        HLwc(64:*)=HLwc1(64:*)
        HLwc(52:63)=(HLwc1(52:63)+HLwc2(52:63))/2.0
        ;*********************************************************************************************

        Calculate_one_psd_trace_M6,'V','M1',ave_info,'binc',xpts,Vbinc1,ystr,deadtime,VPartcont,dBz,Ra,Rb
        Calculate_one_psd_trace_M6,'V','M2',ave_info,'binc',xpts,Vbinc2,ystr,deadtime,VPartcont2,dBz,Ra,Rb
        Vbinc=Vbinc2
        Vbinc(64:*)=Vbinc1(64:*)
        Vbinc(52:63)=(Vbinc1(52:63)+Vbinc2(52:63))/2.0

        Calculate_one_psd_trace_m6,'V','M1',ave_info,'conc',xpts,Vconc1,ystr,deadtime,VPartcont,dBz,Ra,Rb
        Calculate_one_psd_trace_m6,'V','M2',ave_info,'conc',xpts,Vconc2,ystr,deadtime,VPartcont2,dBz,Ra,Rb
        Vconc=Vconc2
        Vconc(64:*)=Vconc1(64:*)
        Vconc(52:63)=(Vconc1(52:63)+Vconc2(52:63))/2.0

        Calculate_one_psd_trace_M6,'V','M1',ave_info,'Aice',xpts,Vextn1,ystr,deadtime,VPartcont,dBz,Ra,Rb
        Calculate_one_psd_trace_M6,'V','M2',ave_info,'Aice',xpts,Vextn2,ystr,deadtime,VPartcont2,dBz,Ra,Rb
        Vextn=Vextn2
        Vextn(64:*)=Vextn1(64:*)
        Vextn(52:63)=(Vextn1(52:63)+Vextn2(52:63))/2.0

        Calculate_one_psd_trace_m6,'V','M1',ave_info,'IWC',xpts, Viwc1, ystr,deadtime,VPartcont,dBz,Ra,Rb
        Calculate_one_psd_trace_m6,'V','M2',ave_info,'IWC',xpts, Viwc2, ystr,deadtime,VPartcont2,dBz,Ra,Rb
        Viwc=Viwc2
        Viwc(64:*)=Viwc1(64:*)
        Viwc(52:63)=(Viwc1(52:63)+Viwc2(52:63))/2.0

        Calculate_one_psd_trace_m6,'V','M1',ave_info,'Lwc',xpts, VLwc1, ystr,deadtime,VPartcont,dBz,Ra,Rb
        Calculate_one_psd_trace_m6,'V','M2',ave_info,'Lwc',xpts, VLwc2, ystr,deadtime,VPartcont2,dBz,Ra,Rb
        VLwc=VLwc2
        VLwc(64:*)=VLwc1(64:*)
        VLwc(52:63)=(VLwc1(52:63)+VLwc2(52:63))/2.0
    endif;  end of L_choice eq 'M6'


    WSet, wid
    bluecolor = GetColor("Navy", !D.Table_Size-2)
    redcolor = GetColor("Red", !D.Table_Size-2)
    whitecolor = GetColor("White", !D.Table_Size-2)

    erase,color='ffffff'x  ; get background to white

    XYOUTS,240,290,"REDRAWING ",color=bluecolor, size=4 , /device
    FOR i=0,5 DO BEGIN  ; seems to be needed to get the "REDRAW" to fully appear
        PRINT, " "
    ENDFOR

    pxs=0.01D ; in mm
    strbsz = 0.01D ; in mm
    alpha = 0.115D
    beta = 1.218D
    microns_per_pixel = 10


    current_multi = !P.MULTI
    num_plots_per_row = 2
    num_plots_per_column = 2
    current_plot_position = 0
    !P.MULTI = [current_plot_position, num_plots_per_row, num_plots_per_column, 0, 0]
    !X.OMARGIN = [1.5,0.0]  ; We need this because the Area plot X axis label extends off the left edge of the window


    ;-------------------------------------------------------------------
    ; Determine which particles we're plotting, H or V
    ;-------------------------------------------------------------------

    mincntsperbin = ave_info.AveMinCountPerBin
    minbinwid = ave_info.AveMinBinSize
    xmin = ave_info.AveXMin
    xmax = ave_info.AveXMax
    xlog_setting = ave_info.AveXLog
    ylog_setting = ave_info.AveYLog

    ;IF (!CURRENT_CHANNEL EQ !H_CHART) THEN BEGIN


    subfile_str=strsplit(!currentHFname,'\',/extract)
    binfilename='Input_file: '+strtrim(subfile_str(n_elements(subfile_str)-1),2)

    ;now get the axis maximum minimums for the plots
    index=where(Hbinc ne 0.0,contG)
    if contG gt 0 then  ymin = min(Hbinc(index)) else ymin=0.1 ; get min, but don't include bins where there are no counts
    index=where(Vbinc ne 0.0,contG)
    if contG gt 0 then  ymin_v = min(Vbinc(index)) else ymin_v=0.1
    if (ymin_v lt ymin) then ymin = ymin_v

    ymax = max([Hbinc,Vbinc])
    ymax= ymax;  take the maximum of the two values
    if (ylog_setting eq 1) then begin
        ymin = 10.0 ^ floor(alog10(ymin))
        ymax = 10.0^ceil(alog10(ymax))
    endif
    Xrange_AB=[10,3000.0]
    Yrange_AB=[1.0,ymax]
    subtitle1='microns (H=Blue,V=Red)'

    PLOT, xpts, Hbinc, COLOR=bluecolor, XRANGE=XRANGE_AB, Xlog=xlog_setting,$
        YTITLE='#/bin', Xstyle = 1, YLOG=Ylog_setting,background= whitecolor,$
        TITLE=binfilename, PSYM=10, THICK=1, YRANGE=Yrange_AB,  $
        pos=[0.08,0.55,0.46,0.95],xmargin=[3,1],xtitle=subtitle1,YSTYLE=YStyle
    oplot,xpts,Vbinc,color=redcolor
    ;end of plot 1 of 4 *******************************************************************************

    index=where(Hconc ne 0.0,contG)
    if contG gt 0 then  ymin = min(Hconc(index)) else ymin=0.1 ; get min, but don't include bins where there are no counts
    index=where(Vconc ne 0.0,contG)
    if contG gt 0 then  ymin_v = min(Vconc(index)) else ymin_v=0.1
    if (ymin_v lt ymin) then ymin = ymin_v

    ymax = max([Hconc,Vconc])

    if ymax le ymin then ymax=1.0+ymin

    if (ylog_setting eq 1) then begin
        ymin = 10.0 ^ floor(alog10(ymin))
        ymax = 10.0^ceil(alog10(ymax))
    endif

    Xrange_AB=[10,3000.0]
    Yrange_AB=[ymin,ymax]
    subtitle2='microns (H=Blue,V=Red)'

    ;get yticks numbers and xy for axis plots and the Yticklables;.
    ytikn=ceil(Alog10(ymax))-floor(Alog10(Ymin))  > 2
    yymo1=10.0^(floor(Alog10(YMin)))
    yymo2=10.0^(ceil(Alog10(YMax)))
    convert_thisValue_to_string,yymo1, myticknames
    myticknames=' '
    for i=1,ytikn do begin
        this_value=10.^( floor(Alog10(ymin)) +i)
        convert_thisValue_to_string,this_value,this_string
        myticknames=[myticknames,this_string]
    endfor

    PLOT, xpts, Hconc, COLOR=bluecolor, XRANGE=XRANGE_AB, Xlog=xlog_setting,$
        Xstyle = 1, YLOG=ylog_setting,xtitle=subtitle2,TITLE='Time:'+plot_string,$
        PSYM=10, THICK=1, YRANGE=[yymo1,yymo2],ystyle=ystyle,$
        pos=[0.55,0.55,0.93,0.95],xmargin=[3,1],$; Yticks=ytikn,Ytickn=myticknames,$
        YTITLE='#/L/um';  Yticks=ytikn,Ytickn=myticknames
    oplot,xpts,Vconc,COLOR=redColor
    ;end of plot 2 of 4 *******************************************************************************

    index=where(Hextn ne 0.0,contG)
    if contG gt 0 then  ymin = min(Hextn(index)) else ymin=0.1 ; get min, but don't include bins where there are no counts
    index=where(Vextn ne 0.0,contG)
    if contG gt 0 then  ymin_v = min(Vextn(index)) else ymin_v=0.1
    if (ymin_v lt ymin) then ymin = ymin_v

    ymax = max([Hextn,Vextn])
    if (ylog_setting eq 1) then begin
        ymin = 10.0 ^ floor(alog10(ymin))
        ymax = 10.0^ceil(alog10(ymax))
    endif
    Xrange_AB=[10,3000.0]
    Yrange_AB=[ymin,ymax]
    subtitle1='microns (H=Blue,V=Red)'

    PLOT, xpts, Hextn, COLOR=bluecolor, XRANGE=XRANGE_AB, Xlog=xlog_setting,$
        YTITLE='Area: mm2/L/um', Xstyle = 1, YLOG=Ylog_setting,background= whitecolor,$
        TITLE=delta_s+' Method:'+L_choice, PSYM=10, THICK=1, YRANGE=Yrange_AB,  $
        pos=[0.08,0.06,0.46,0.46],xmargin=[3,1],xtitle=subtitle1,YSTYLE=YStyle
    oplot,xpts,Vextn,color=redColor
    ;end of plot 3 of 4 *******************************************************************

    index=where(Hiwc ne 0.0 and Hiwc gt 0.0 ,contG)
    if contG gt 0 then  ymin = min(Hiwc(index)) else ymin=0.1 ; get min, but don't include bins where there are no counts
    index=where(VIwc ne 0.0 and Viwc gt 0.0,contG)
    if contG gt 0 then  ymin_v = min(Viwc(index)) else ymin_v=0.1
    if (ymin_v lt ymin) then ymin = ymin_v

    ymax = max([Hiwc,Viwc])
    if (ylog_setting eq 1) then begin

        if ymin eq ymax then ymax=ymax+0.1

        ymin = 10.0 ^ floor(alog10(ymin))
        ymax = 10.0^ceil(alog10(ymax))
    endif
    Xrange_AB=[10,3000.0]
    Yrange_AB=[ymin,ymax]
    ;get yticks numbers and xy for axis plots and the Yticklables;.
    ytikn=ceil(Alog10(ymax))-floor(Alog10(Ymin))
    yymom1=10.0^(floor(Alog10(YMin)))
    yymom2=10.0^(ceil(Alog10(YMax)))
    convert_thisValue_to_string,yymo1, myticknames
    myticknames=' '
    for i=1LL,ytikn do begin
        this_value=10.^( floor(Alog10(ymin)) +i)
        convert_thisValue_to_string,this_value,this_string
        myticknames=[myticknames,' ']
    endfor


    PLOT, xpts, Hiwc, COLOR=blueColor, XRANGE=XRANGE_AB, Xlog=xlog_setting, $
        XTITLE='Particle Size(um)', Xstyle = 1, YLOG=ylog_setting,$
        PSYM=10, THICK=1, YRANGE=[yymom1,yymom2], $  ; YSTYLE=YStyle,$
        pos=[0.55,0.06,0.93,0.46],xmargin=[3,1],$                                    ;Yticks=ytiknm,Ytickn=myticknames,$
        YTITLE='IWC: g/m3/um', title='Particle #:  H=' + String(Hpartcont) + '   V=' + String(VpartCont)

    oplot,xpts, Viwc,COLOR=redColor

    ;end of plot 4 of 4 *****************************************************************


    ave_info.StartTimeString = strrepl(!ZOOM_START_STRING,':','-')  ; replace any ":" with "-" for a valid Windows filename
    ave_info.EndTimeString = strrepl(!ZOOM_END_STRING,':','-')
    ave_info.BaseFilenameString = strmid(!CurrentHFname,strlen(!CurrentHPname)+5,12) ; extract just the date/time portion of the horiz.bin file
    ave_info.NumDataPointsH = long64(Hpartcont*1.0)
    ave_info.NumDataPointsV = long64(Vpartcont*1.0)
    rrr="No" ;dialog_message('Save ascii of the psd plot ?',/question);  ;only need ascii in here.
    if rrr eq 'Yes' then begin
        out_filename='psd_plot_ascii.txt'
        write_psd_to_ascii_file,out_filename,xpts,Hbinc,Vbinc,$ ; numbers is #/bin
            Hconc,Vconc,Hextn,Vextn,Hiwc,HLwc,Viwc,VLwc,$; size is #/L/um
            binfilename,plot_string,delta_s,Hpartcont,Vpartcont
    endif
    ;save the plot data to a pointer for writing toe ascii file.
    ave_info.binfilename=binfilename
    ave_info.plot_string=plot_string
    ave_info.delta_s=delta_s
    ave_info.Hpartcont=string(Hpartcont)
    ave_info.Vpartcont=string(Vpartcont)
    ave_info.pxpts =ptr_new(xpts)
    ave_info.Hbinc=ptr_new(Hbinc)
    ave_info.Hconc=ptr_new(Hconc)
    ave_info.Hextn=ptr_new(Hextn)
    ave_info.Hiwc=ptr_new(Hiwc)
    ave_info.HLwc=ptr_new(HLwc)
    ave_info.Vbinc=ptr_new(Hbinc)
    ave_info.Vconc=ptr_new(Vconc)
    ave_info.Vextn=ptr_new(Vextn)
    ave_info.Viwc =ptr_new(Viwc)
    ave_info.VLwc=ptr_new(VLwc)

end;  end of Draw-averaged_psd



;********************************************************************************************************
;********************************************************************
pro Calculate_one_psd_trace,HorV,L_choice,ave_info,this_param,$ ;input
    xpts,ypts,ystr,deadtime,Partcont,dBz,Ra,Rb; ouput

Common  DataBlock,alldataH,alldataV,ADataH,ADataV,FirstData,LastData,StripData,$
    FirstDataV,LastDataV,StripDataV,avestripdata,avestripdataV

get_the_psd_sizes,HorV,L_choice,ave_info,has_data,sizes,areas,adjs,csp,livetimeVolume,deadtime,Partcont,adjustmentfactor
Original_factor=1.0;ave_info.criteria.Hfactor

SVdefault=livetimevolume
if strupcase(HorV) eq 'H' then begin
    microns_per_pixel =!microns_per_pixelH
endif else begin
    microns_per_pixel =!microns_per_pixelV
endelse

;the 200bins is fixed 10,20,20,30,30, ********, 1990,1990,2000
nbins=83
make_83_bins,HorV, nbins,nedges,xpts;  xpts=[0.001, 15, 25,... 9995, 100000]
;get the dBZ Ra and Rb vales from sizes.

get_dBz_effective_Ra_Rb,HorV, sizes,areas,adjs,DBz,Ra,Rb

;  added a few more bins:  [2005 2205 2405  2605 2805 3005 100000]    6 moer bins.
;***************************************************************************************
ypts = fltarr(nedges)
if has_data eq 1 then begin
    alpha = 0.115D
    beta = 1.218D

    for j=0,nedges-2,2 do begin
        binwidth=(xpts[j+1]-xpts[j])
        if j eq 0 then binwidth=microns_per_pixel
        LiterTum=binwidth*SVdefault
        somarr=where(sizes lt xpts[j+1] and sizes ge xpts[j] and adjs gt 0.0,contG) ; Handle all but last bins

        if contG gt 0 then begin;  if there is no particles, area and mass should be zero
            this_adj1=adjs(somarr)
            this_sizes=sizes(somarr)
            this_area =areas(somarr)*(microns_per_pixel/1000.0D)^2; mm^2; areas is in unit pixel^2. 1pix=10um=0.01mm.
            this_csp=csp(somarr); units are um^3.

            ;if this_param eq 'conc' then ;stop

            case this_param of
                "binc": begin
                    ypts[j:j+1]=contG;  # only, it is Hbinc[j:j+1] = contG;  # only
                    ;print,contG;  ;              stop
                end
                "conc": ypts[j:j+1] =total(this_adj1)/LiterTum; #/L/um . Plot_Size[j:j+1]
                "Aice": begin
                    area_liq   =0.000001*(!pi*this_sizes^2)/4.0;   this_sizes is in unit um.
                    This_area_use= area_liq < this_area
                    ypts[j:j+1] =total(this_adj1*this_area_use)/LiterTum; area mm^2/Liter/um. Hextn
                end

                "Aliq": begin
                    This_area_use =0.000001*(!pi*this_sizes^2)/4.0
                    ypts[j:j+1] =total(this_adj1*this_area_use)/LiterTum; area mm^2/Liter/um. Hextn
                end

                "IWC":  begin
                    get_IWC_from_adj_n_sizes,total_IWC,alpha,beta,this_adj1,this_sizes,this_area
                    ypts[j:j+1]=total_IWC/LiterTum
                    ;ypts[j:j+1]=917.0*alpha*total(this_adj1*this_area^beta)/LiterTum; Hiwc for ice, mg/M3/mu.
                end

                "Icsp": begin  ;      ypts[j:j+1]=917.0*alpha*total(this_adj1*this_area^beta)/LiterTum; plot_mass for ice, mg/M3/mu.
                    get_Icsp_from_adj_n_csp,total_Icsp,this_adj1,this_csp,this_sizes
                    ypts[j:j+1]=total_Icsp/LiterTum

                end

                "Lwc":  ypts[j:j+1]=(0.1^9.0*!pi/6.0)*total(this_adj1*this_sizes^3)/LiterTum; liquid water. g/M3/um.
            endcase

        endif ; else begin
        ; no need to assign all ypts[j:j+1]
        ; endelse
    endfor
    xpts(0)=microns_per_pixel/2.0

    ;handle last bin;  save a lot of if statement in the for loop
    j=nedges-2
    somarr=where(sizes ge max(xpts) and adjs gt 0.0,contG);   max(xpts)=2010.0
    binwidth=(xpts[j+1]-xpts[j]);       xpts(j+1)=2010.0 also.
    LiterTum=binwidth*SVdefault
    ; somarr=where(sizes lt xpts[j+1] and sizes ge xpts[j],contG) ; Handle all but last bins

    if contG eq 0 then begin;  there is no particles, area and mass should be zero
        ; do nothing becasue ypts(j:j+1) are already =0.
    endif else begin
        this_adj1=adjs(somarr)
        this_sizes=sizes(somarr)
        this_area =areas(somarr)*(microns_per_pixel/1000.0D)^2; mm^2; areas is in unit pixel^2. 1pix=10um=0.01mm.
        this_csp=csp(somarr)
        case this_param of
            "binc": ypts[j:j+1]=contG;  # only, it is Hbinc[j:j+1] = contG;  # only
            "conc": ypts[j:j+1] =total(this_adj1)/LiterTum; #/L/um . Plot_Size[j:j+1]
            "Aice": begin
                area_liq   =0.000001*(!pi*this_sizes^2)/4.0
                This_area_use= area_liq < this_area
                ypts[j:j+1] =total(this_adj1*this_area_use)/LiterTum; area mm^2/Liter/um. Hextn
                ;stop
            end
            "Aliq": begin
                This_area_use =0.000001*(!pi*this_sizes^2)/4.0
                ypts[j:j+1] =total(this_adj1*this_area_use)/LiterTum; area mm^2/Liter/um. Hextn
            end

            "IWC":  begin ;ypts[j:j+1]=917.0*alpha*total(this_adj1*this_area^beta)/LiterTum; Hiwc for ice, mg/M3/mu.
                get_IWC_from_adj_n_sizes,total_IWC,alpha,beta,this_adj1,this_sizes,this_area
                ypts[j:j+1]=total_IWC/LiterTum
            end


            "Icsp": begin
                get_Icsp_from_adj_n_csp,total_Icsp,this_adj1,this_csp,this_sizes
                ypts[j:j+1]=total_Icsp/LiterTum
            end

            "Lwc":  ypts[j:j+1]=(0.1^9.0*!pi/6.0)*total(this_adj1*this_sizes^3)/LiterTum; liquid water. g/M3/um.
        endcase
    endelse
endif ; if has_data =1

;make adjustment for M4 which is L7 ; Number/bin don't need to be adjusted.
if L_choice eq 'M4' or L_choice eq 'M3' or L_choice eq 'M5' then begin
    ;plot_Size =adjustmentfactor*plot_Size; adjf=(L1GT0_and_criteria)/(L1NL4_criteria).
    if this_param eq "binc" then ypts=ypts else ypts=ypts*adjustmentfactor
endif
case this_param of
    "binc": ystr='#/bin'
    "conc": ystr='#/L/um'
    "Aice": ystr='mm^2/L/um'
    "Aliq": ystr='mm^2/L/um'
    "IWC":  ystr='g/m3/mu'
    "Icsp": ystr='g/m3/mu'
    "Lwc":  ystr='g/m3/um'
endcase
;calculate the integrated value
ave_value=0.0
for i=0,n_elements(ypts)-2 do begin
    ave_value=ave_value+ypts(i)*(xpts(i+1)-xpts(i))
endfor

case this_param of
    "binc": partcont=partcont
    "conc": partcont=ave_value
    "Aice": partcont=2.0*ave_value
    "Aliq": partcont=2.0*ave_value;  ;;; one of them can be delted later if no this_param match it.
    "IWC":  partcont=ave_value
    "Icsp": partcont=ave_value
    "Lwc":  partcont=ave_value
endcase
;check if the partcont equal to the sum of all bins
;if this_param eq 'binc' then begin
;total_bin_sum=total(ypts)/2.0
; if partcont ne total_bin_sum then begin
;print, 'bin sum Not Equal partcount !!!!!!!'
;stop
; endif
;endif

; partcont=ave_value

end; end of pro calculate_one_psd_trace
;*************************************************************

pro Calculate_one_psd_trace_M6,HorV,L_choice,ave_info,this_param,$ ;input
    xpts,ypts,ystr,deadtime,Partcont,sizes,adjs,areas; ouput

Common  DataBlock,alldataH,alldataV,ADataH,ADataV,FirstData,LastData,StripData,$
    FirstDataV,LastDataV,StripDataV,avestripdata,avestripdataV

get_the_psd_sizes_M6,HorV,L_choice,ave_info,has_data,sizes,areas,adjs,csp,livetimeVolume,deadtime,Partcont,adjustmentfactor
Original_factor=1.0;ave_info.criteria.Hfactor

SVdefault=livetimevolume

if HorV eq 'H' then microns_per_pixel = !microns_per_pixelH else microns_per_pixel =!microns_per_pixelV

;the 200bins is fixed 10,20,20,30,30, ********, 1990,1990,2000
nbins=83
make_83_bins,HorV,nbins,nedges,xpts

ypts = fltarr(nedges)
if has_data eq 1 then begin
    alpha = 0.115D
    beta = 1.218D

    for j=0,nedges-2,2 do begin
        binwidth=(xpts[j+1]-xpts[j])
        LiterTum=binwidth*SVdefault
        somarr=where(sizes lt xpts[j+1] and sizes ge xpts[j] and adjs gt 0.0,contG) ; Handle all but last bins

        if contG gt 0 then begin;  if there is no particles, area and mass should be zero
            this_adj1=adjs(somarr)
            this_sizes=sizes(somarr)
            this_area =areas(somarr)*(microns_per_pixel/1000.0)^2; mm^2; areas is in unit pixel^2. 1pix=10um=0.01mm.
            this_csp=csp(somarr)
            ;if this_param eq 'conc' then ;stop
            case this_param of
                "binc": ypts[j:j+1]=contG;  # only, it is Hbinc[j:j+1] = contG;  # only
                "conc": ypts[j:j+1] =total(this_adj1)/LiterTum; #/L/um . Plot_Size[j:j+1]
                "Aice": begin
                    areas_liq =(!pi*0.000001*This_sizes^2)/4.0
                    areas_ice =this_area
                    this_area  = areas_liq < areas_ice
                    ypts[j:j+1] =total(this_adj1*this_area)/LiterTum; area mm^2/Liter/um. Hextn
                end

                "Aliq": begin
                    This_area_use=(!pi*0.000001*This_sizes^2)/4.0
                    ypts[j:j+1] =total(this_adj1*this_area_use)/LiterTum; area mm^2/Liter/um. Hextn
                end
                "IWC":  begin
                    get_IWC_from_adj_n_sizes,total_IWC,alpha,beta,this_adj1,this_sizes,this_area
                    ypts[j:j+1]=total_IWC/LiterTum
                    ;ypts[j:j+1]=917.0*alpha*total(this_adj1*this_area^beta)/LiterTum; Hiwc for ice, mg/M3/mu.
                end

                "Icsp": begin  ;      ypts[j:j+1]=917.0*alpha*total(this_adj1*this_area^beta)/LiterTum; plot_mass for ice, mg/M3/mu.
                    get_Icsp_from_adj_n_csp,total_Icsp,this_adj1,this_csp,this_sizes
                    ypts[j:j+1]=total_Icsp/LiterTum
                end


                "Lwc":  ypts[j:j+1]=(0.1^9.0*!pi/6.0)*total(this_adj1*this_sizes^3)/LiterTum; liquid water. g/M3/um.
            endcase

        endif ; else begin
        ; no need to assign all ypts[j:j+1]
        ; endelse
    endfor
    xpts(0)=microns_per_pixel/2.0

    ;handle last bin;  save a lot of if statement in the for loop
    j=nedges-2
    somarr=where(sizes ge max(xpts) and adjs gt 0.0,contG);   max(xpts)=2010.0
    binwidth=(xpts[j+1]-xpts[j]);       xpts(j+1)=2010.0 also.
    LiterTum=binwidth*SVdefault
    ; somarr=where(sizes lt xpts[j+1] and sizes ge xpts[j],contG) ; Handle all but last bins

    if contG eq 0 then begin;  there is no particles, area and mass should be zero
        ; do nothing becasue ypts(j:j+1) are already =0.
    endif else begin
        this_adj1=adjs(somarr)
        this_sizes=sizes(somarr)
        this_area =areas(somarr)*(microns_per_pixel/1000.0D)^2.0; mm^2; areas is in unit pixel^2. 1pix=10um=0.01mm.
        this_csp=csp(somarr)
        case this_param of
            "binc": ypts[j:j+1]=contG;  # only, it is Hbinc[j:j+1] = contG;  # only
            "conc": ypts[j:j+1] =total(this_adj1)/LiterTum; #/L/um . Plot_Size[j:j+1]
            "Aice": begin
                areas_liq =(!pi*(microns_per_pixel/1000.0D)^2.0*This_sizes^2)/4.0
                areas_ice =this_area
                this_area  = areas_liq < areas_ice
                ypts[j:j+1] =total(this_adj1*this_area)/LiterTum; area mm^2/Liter/um. Hextn
            end
            "Aliq": begin
                This_area=(!pi*(microns_per_pixel/1000.0D)^2.0*This_sizes^2)/4.0
                ypts[j:j+1] =total(this_adj1*this_area)/LiterTum; area mm^2/Liter/um. Hextn
            end

            "IWC":  begin ;ypts[j:j+1]=917.0*alpha*total(this_adj1*this_area^beta)/LiterTum; Hiwc for ice, mg/M3/mu.
                get_IWC_from_adj_n_sizes,total_IWC,alpha,beta,this_adj1,this_sizes,this_area
                ypts[j:j+1]=total_IWC/LiterTum
            end

            "Icsp": begin  ;      ypts[j:j+1]=917.0*alpha*total(this_adj1*this_area^beta)/LiterTum; plot_mass for ice, mg/M3/mu.
                get_Icsp_from_adj_n_csp,total_Icsp,this_adj1,this_csp,this_sizes
                ypts[j:j+1]=total_Icsp/LiterTum
            end

            "Lwc":  ypts[j:j+1]=(0.1^9.0*!pi/6.0)*total(this_adj1*this_sizes^3)/LiterTum; liquid water. g/M3/um.
        endcase
    endelse
endif ; if has_data =1

;make adjustment for M4 which is L7 ; Number/bin don't need to be adjusted.
if L_choice eq 'M4' or L_choice eq 'M3' or L_choice eq 'M5' then begin
    ;plot_Size =adjustmentfactor*plot_Size; adjf=(L1GT0_and_criteria)/(L1NL4_criteria).
    if this_param eq "binc" then ypts=ypts else ypts=ypts*adjustmentfactor
endif
case this_param of
    "binc": ystr='#/bin'
    "conc": ystr='#/L/um'
    "Aice": ystr='mm^2/L/um'
    "Aliq": ystr='mm^2/L/um'
    "IWC":  ystr='g/m3/mu'
    "Icsp":  ystr='g/m3/mu'
    "Lwc":  ystr='g/m3/um'
endcase
;calculate the integrated value
ave_value=0.0
for i=0,n_elements(ypts)-2 do begin
    ave_value=ave_value+ypts(i)*(xpts(i+1)-xpts(i))
endfor

case this_param of
    "binc": partcont=partcont
    "conc": partcont=ave_value
    "Aice": partcont=2.0*ave_value
    "Aliq": partcont=2.0*ave_value
    "IWC":  partcont=ave_value
    "Icsp":  partcont=ave_avlue
    "Lwc":  partcont=ave_value
endcase
;check if the partcont equal to the sum of all bins
if this_param eq 'binc' then begin
    total_bin_sum=total(ypts)/2.0
    if partcont ne total_bin_sum then begin
        print, 'bin sum Not Equal partcount !!!!!!!'
        ;stop
    endif
endif

; partcont=ave_value
end; end of pro calculate_one_psd_trace_M6
;*************************************************************
;********************************************************************
pro Calculate_one_psd_trace_area,HorV,L_choice,ave_info,this_param,$ ;input
    xpts,ypts,ystr,xstr,deadtime,Partcont,mincntsperbin,minbinwid; ouput

Common  DataBlock,alldataH,alldataV,ADataH,ADataV,FirstData,LastData,StripData,$
    FirstDataV,LastDataV,StripDataV,avestripdata,avestripdataV

alpha = 0.115D
beta = 1.218D

get_the_psd_sizes,HorV,L_choice,ave_info,has_data,sizes,areas,adjs,livetimeVolume,deadtime,Partcont,adjustmentfactor
this_areas =areas*0.0001; mm^2; areas is in unit pixel^2. 1pix=10um=0.01mm.
get_lwcmass_iwcMass_eqDiam, alpha,beta,sizes,This_areas,lwc_masses,iwc_masses,eqDiam

Original_factor=1.0;ave_info.criteria.Hfactor

SVdefault=livetimevolume
LiterTum=SVdefault;  output of unihist is   counts/(bin_width)

;***************************************************************************************
; print,'lwc_masses=',lwc_masses

if has_data eq 1 then begin
    ; this_area =areas(somarr)*0.0001; mm^2; areas is in unit pixel^2. 1pix=10um=0.01mm.
    ; mincntsperbin=2.0
    ; minbinwid=10.0
    case this_param of
        "eqdm": begin
            unihist_adj,EqDiam,mincntsperbin,minbinwid,xpts,vals,adjs
            ypts=vals/LiterTum; #/L/um.
            ystr='#/L/um'
            xstr='Equivalent Diam (um)'
        end
        "conc": begin
            unihist_adj,sizes,mincntsperbin,minbinwid,xpts,vals,adjs
            ypts=vals/LiterTum; #/L/um.
            ystr='#/L/um'
            xstr='Particle size (um)'
        end

        "area": begin
            unihist_adj,areas,mincntsperbin,minbinwid,xpts,vals,adjs
            ypts=vals/LiterTum; #/L/um^2 .
            ystr='#/L/um^2'
            xstr='Area (um^2)'
        end

        "IWC":  begin
            unihist_adj,iwc_masses,mincntsperbin,minbinwid,xpts,vals,adjs
            ypts=vals/LiterTum; #/L/ug.
            ystr='#/L/ug'
            xstr='Iwc_mass (ug)'
        end
        "Lwc":  begin
            unihist_adj,lwc_masses,mincntsperbin,minbinwid,xpts,vals,adjs
            ypts=vals/LiterTum; #/L/ug.
            ystr='#/L/ug'
            xstr='Lwc_mass (ug)'
        end
    endcase
endif else begin; end of if has_data =1
    xpts=[5,100]
    ypts=[0.0,0.0]
    case this_param of
        "eqdm": begin
            ystr='#/L/um'
            xstr='Equivalent Diam (um)'
        end
        "conc": begin
            ystr='#/L/um'
            xstr='Particle size (um)'
        end

        "area": begin
            ystr='#/L/um^2'
            xstr='Area (um^2)'
        end

        "IWC":  begin
            ystr='#/L/ug'
            xstr='Iwc_mass (ug)'
        end
        "Lwc":  begin
            ystr='#/L/ug'
            xstr='Lwc_mass (ug)'
        end
    endcase
endelse


;make adjustment for M4 which is L7 ; Number/bin don't need to be adjusted.
if L_choice eq 'M4' or L_choice eq 'M3' or L_choice eq 'M5' then begin
    ypts=ypts*adjustmentfactor
endif

;calculate the integrated value
ave_value=0.0
for i=0,n_elements(ypts)-2 do begin
    ave_value=ave_value+ypts(i)*(xpts(i+1)-xpts(i))
endfor

case this_param of
    "eqdm": partcont=partcont
    "conc": partcont=ave_value
    "Aice": partcont=2.0*ave_value
    "Aliq": partcont=2.0*ave_value
    "IWC":  partcont=ave_value
    "Icsp":  partcont=ave_avlue
    "Lwc":  partcont=ave_value
endcase
;check if the partcont equal to the sum of all bins
;if this_param eq 'binc' then begin
;total_bin_sum=total(ypts)/2.0
; if partcont ne total_bin_sum then begin
;print, 'bin sum Not Equal partcount !!!!!!!'
;stop
; endif
;endif

; partcont=ave_value

end; end of pro calculate_one_psd_trace_area
;*************************************************************

pro Calculate_one_psd_trace_M6_area,HorV,L_choice,ave_info,this_param,$ ;input
    xpts,ypts,ystr,xstr,deadtime,Partcont,sizes,adjs,areas; ouput

Common  DataBlock,alldataH,alldataV,ADataH,ADataV,FirstData,LastData,StripData,$
    FirstDataV,LastDataV,StripDataV,avestripdata,avestripdataV

get_the_psd_sizes_M6,HorV,L_choice,ave_info,has_data,sizes,areas,adjs,livetimeVolume,deadtime,Partcont,adjustmentfactor
Original_factor=1.0;ave_info.criteria.Hfactor

SVdefault=livetimevolume

;the 200bins is fixed 10,20,20,30,30, ********, 1990,1990,2000
nbins=83
make_83_bins,nbins,nedges,xpts

ypts = fltarr(nedges)
if has_data eq 1 then begin
    alpha = 0.115D
    beta = 1.218D

    for j=0,nedges-2,2 do begin
        binwidth=(xpts[j+1]-xpts[j])
        LiterTum=binwidth*SVdefault
        somarr=where(sizes lt xpts[j+1] and sizes ge xpts[j] and adjs ne 0.0,contG) ; Handle all but last bins

        if contG gt 0 then begin;  if there is no particles, area and mass should be zero
            this_adj1=adjs(somarr)
            this_sizes=sizes(somarr)
            this_area =areas(somarr)*0.0001; mm^2; areas is in unit pixel^2. 1pix=10um=0.01mm.
            ;if this_param eq 'conc' then stop
            case this_param of
                "eqdm": ypts[j:j+1]=contG;  # only, it is Plot_Numbers[j:j+1] = contG;  # only
                "conc": ypts[j:j+1] =total(this_adj1)/LiterTum; #/L/um . Plot_Size[j:j+1]
                "extn": ypts[j:j+1] =total(this_adj1*this_area)/LiterTum; area mm^2/Liter/um. plot_area
                "IWC":  begin
                    get_IWC_from_adj_n_sizes,total_IWC,alpha,beta,this_adj1,this_sizes,this_area
                    ypts[j:j+1]=total_IWC/LiterTum
                    ;ypts[j:j+1]=917.0*alpha*total(this_adj1*this_area^beta)/LiterTum; plot_mass for ice, mg/M3/mu.
                end
                "Lwc":  ypts[j:j+1]=(0.1^9.0*!pi/6.0)*total(this_adj1*this_sizes^3)/LiterTum; liquid water. g/M3/um.
            endcase

        endif ; else begin
        ; no need to assign all ypts[j:j+1]
        ; endelse
    endfor
    xpts(0)=5.0

    ;handle last bin;  save a lot of if statement in the for loop
    j=nedges-2
    somarr=where(sizes ge max(xpts),contG);   max(xpts)=2010.0
    binwidth=(xpts[j+1]-xpts[j]);       xpts(j+1)=2010.0 also.
    LiterTum=binwidth*SVdefault
    ; somarr=where(sizes lt xpts[j+1] and sizes ge xpts[j],contG) ; Handle all but last bins

    if contG eq 0 then begin;  there is no particles, area and mass should be zero
        ; do nothing becasue ypts(j:j+1) are already =0.
    endif else begin
        this_adj1=adjs(somarr)
        this_sizes=sizes(somarr)
        this_area =areas(somarr)*0.0001; mm^2; areas is in unit pixel^2. 1pix=10um=0.01mm.
        case this_param of
            "eqdm": ypts[j:j+1]=contG;  # only, it is Plot_Numbers[j:j+1] = contG;  # only
            "conc": ypts[j:j+1] =total(this_adj1)/LiterTum; #/L/um . Plot_Size[j:j+1]
            "extn": ypts[j:j+1] =total(this_adj1*this_area)/LiterTum; area mm^2/Liter/um. plot_area
            "IWC":  begin ;ypts[j:j+1]=917.0*alpha*total(this_adj1*this_area^beta)/LiterTum; plot_mass for ice, mg/M3/mu.
                get_IWC_from_adj_n_sizes,total_IWC,alpha,beta,this_adj1,this_sizes,this_area
                ypts[j:j+1]=total_IWC/LiterTum
            end
            "Lwc":  ypts[j:j+1]=(0.1^9.0*!pi/6.0)*total(this_adj1*this_sizes^3)/LiterTum; liquid water. g/M3/um.
        endcase
    endelse
endif ; if has_data =1

;make adjustment for M4 which is L7 ; Number/bin don't need to be adjusted.
if L_choice eq 'M4' or L_choice eq 'M3' or L_choice eq 'M5' then begin
    ;plot_Size =adjustmentfactor*plot_Size; adjf=(L1GT0_and_criteria)/(L1NL4_criteria).
    if this_param eq "binc" then ypts=ypts else ypts=ypts*adjustmentfactor
endif
case this_param of

    "eqdm": begin
        ystr='#/L/um'
        xstr='Equivalent Diam (um)'
    end
    "conc": begin
        ystr='#/L/um'
        xstr='Particle size (um)'
    end

    "area": begin
        ystr='#/L/um^2'
        xstr='Area (um^2)'
    end

    "IWC":  begin
        ystr='#/L/ug'
        xstr='Iwc_mass (ug)'
    end
    "Lwc":  begin
        ystr='#/L/ug'
        xstr='Lwc_mass (ug)'
    end
endcase

;calculate the integrated value
ave_value=0.0
for i=0,n_elements(ypts)-2 do begin
    ave_value=ave_value+ypts(i)*(xpts(i+1)-xpts(i))
endfor

case this_param of
    "eqdm": partcont=partcont
    "conc": partcont=ave_value
    "extn": partcont=2.0*ave_value
    "IWC":  partcont=ave_value
    "Lwc":  partcont=ave_value
endcase
;check if the partcont equal to the sum of all bins
if this_param eq 'binc' then begin
    total_bin_sum=total(ypts)/2.0
    if partcont ne total_bin_sum then begin
        print, 'bin sum Not Equal partcount !!!!!!!'
        ;stop
    endif
endif

; partcont=ave_value
end; end of pro calculate_one_psd_trace_M6_area
;*************************************************************

;******************************************************************
;*****************************************************************
Pro Get_one_TMS_Trace_300bin_HV_time_series,ptr,ave_info,L_choice,HorV,this_param,ypts,ystr
    ;the input channel_type is 'H' or 'V'; output is  ypts=fltarr(300)

    ;take away the origial_factor; it is always 1.0 now, because sample vloue is fixed.


    Common  DataBlock,alldataH,alldataV,ADataH,AData

    alpha = 0.115D ; this hsould be changed to 0.115 according to brad' paper
    beta = 1.218D   ;this should be changed to 1.218  june 8, 2005.

    DenomSum = 0.0D
    Nbins=(*ptr).Nbins
    ypts=dblarr(Nbins);Nbins=300 or some number.
    ystr=' '

    if strupcase(HorV) eq 'H' then begin
        microns_per_pixel = !microns_per_pixelH
        alldata = alldataH
        subindex = *(ave_info.Hsubindex)
    endif else begin
        microns_per_pixel = !microns_per_pixelV
        alldata = alldataV
        subindex = *(ave_info.Vsubindex)
    endelse

    pxs=microns_per_pixel/1000.0;     mm optically realized size of the array elements
    dww = !DWW_main; 63.0mm in 2D-S, 50.8 mm in 3V-CPI adjust in a3VCPIView.pro
    pxs = microns_per_pixel   ; 10 micrometers or 0.01mm optically realized size of the array elements
    strbsz = pxs ; 10 micrometers or 0.01mm pixel size in the TAS direction (strobe size)
    constant = pxs * strbsz * 0.000001D  ; for IWC calculation

    sadefault=!pixels*pxs*dww

    if subindex(0) ne -1 then begin
        has_data=1

        alldata_nanoseconds=(*alldata)(subindex).nanoseconds
        alldata_area       =(*alldata)(subindex).area

        datasets={nanoseconds:0LL,L1n:0,L2:0,L3:0,L4:0,L5:0,L7:0.0,L8:0.0,F1:0,w8_t:0LL,$
            adj1:0.0,adj0:1.0,area:0.0,Alexei1:0.0,tas:0.0,reject:0,roundness:0.0,maxlength:0.0}
        nnnH=n_elements(subindex)
        subdata=replicate(datasets,nnnH)
        subdata.nanoseconds=(*alldata)(subindex).nanoseconds
        subdata.L1n        =(*alldata)(subindex).L1n
        subdata.L2         =(*alldata)(subindex).L2
        subdata.L3         =(*alldata)(subindex).L3
        subdata.L4         =(*alldata)(subindex).L4
        subdata.L5         =(*alldata)(subindex).L5
        subdata.L7         =(*alldata)(subindex).L7
        subdata.L8         =(*alldata)(subindex).L8
        subdata.w8_t       =(*alldata)(subindex).w8_t
        subdata.F1         =(*alldata)(subindex).F1
        subdata.area       =(*alldata)(subindex).area
        subdata.Alexei1    =(*alldata)(subindex).Alexei1
        subdata.Adj1       =(*alldata)(subindex).adj1
        subdata.Adj0       =(*alldata)(subindex).adj0
        subdata.tas        =(*alldata)(subindex).tas
        subdata.reject     =(*alldata)(subindex).reject
        subdata.roundness  =(*alldata)(subindex).roundness
        subdata.maxlength  =(*alldata)(subindex).maxlength
    endif else begin
        has_data=0
        rrrrrrrrr=dialog_message('No'+ HorV+' subset data',/information)
        return
    endelse

    if has_data eq 0 then return

    Nbins=(*ptr).Nbins

    totalNS=ave_info.endnanoseconds-ave_info.startnanoseconds
    time_binsize=totalNS/Nbins


    if time_binsize lt 1 then begin
        rrrrrr=dialog_message('There is less than 1 nanosec in a bin, try again !',/information)
        return
    endif

    ;get the sample volume
    if strupcase(HorV) eq 'H' then begin
        SE_Volume=*(ave_info.Hsv)
    endif else SE_volume=*(ave_info.Vsv);  SE_volume is 300 bin values.


    ;if the total bins are not 300, then need to update the bins into what is desired Nbins.
    if Nbins ne 300 then begin
        if strupcase(HorV) eq 'H' then SE_volume=*((*ptr).Hsv) else SE_volume=*((*ptr).Vsv)
    endif

    startbin_time=ave_info.startNanoseconds
    endbin_time=ave_info.startNanoseconds+time_binsize;   totalNS/300LL; endbin_time

    for i=0LL,Nbins-1LL do begin
        pindex=where(alldata_nanoseconds gt startbin_time and alldata_nanoseconds le endbin_time, contG)
        if contG eq 0 then begin
            ypts(i)=0.0;  ypts =NumSum =0.0; NumSum_Extinction = 0.0;  NumSum_IWC =0.0;  NUmSum_LWC =0.0
            contgood=0
            SE_volume(i)=1000.0
            adjustmentfactor=1.0
            ; SE_VolumeO=99.0
        endif else begin ; there are particles within the bin
            Bin_alldata_area=alldata_area[pindex]
            ; if channel_type eq 'V' then begin
            ; Get_Vsv_deadtime_between_time1_time2,startbin_time,endbin_time,SE_volumeO,Vdeadtime
            ; endif else begin
            ; Get_Hsv_deadtime_between_time1_time2,startbin_time,endbin_time,SE_volumeO,Hdeadtime
            ;       endelse
            dummy=where(bin_alldata_area gt 0,total_valid_cnt);  total_good_cont in this bin.

            ;********************************************************************
            indexgood=where(subdata.nanoseconds gt startbin_time and subdata.nanoseconds le endbin_time,contGood)
            if L_choice ne 'M6' then begin
                if contGood gt 0 then begin  ;cont is number of slected-particles.
                    Bin_data=subdata[indexgood]; this contains particles good/selected by criteria, not by methods yet.
                    ;get the particle area and adj and adjustment factor values which accounts for M3 M4 methods.
                    get_tms_area_adjs,HorV,L_choice,Bin_data,areas,sizes,adjs,adjustmentfactor; sizes in pixels.
                    areas=areas > 0.0; take off some warning particles that is labeled area= -200, -201, -202, -203.
                    junk=where(adjs gt 0.0, evts_counts)

                    ; TAF Case statement found no matches. crash here 2012-10-29
                    ; TAF update, this_param was 'extI', but only 'extn' was in the case below, need to check which is correct...

                    case this_param of
                        'evts': begin
                            ypts(i)=evts_counts;   contGood;changed on oct.10, 2008.
                        end
                        'conc': ypts(i)=total(adjs)/SE_volume(i);  NumSum =total(Adjs) ;summing the Adj1's for each particle for the numerator
                        'extI': ypts(i)=2.0*total(Adjs * Areas*(microns_per_pixel/1000.0)^2)/SE_volume(i); mm^2.0  ; NumSum_Extinction = total(Adjs * Areas* 0.0001)
                        'extL': ypts(i)=2.0*total(Adjs * Areas*(microns_per_pixel/1000.0)^2)/SE_volume(i); mm^2.0  ; NumSum_Extinction = total(Adjs * Areas* 0.0001)
                        'IWC':  begin; ypts(i)=917.0*alpha*total(adjs*(Areas*0.0001)^beta)/SE_volume ;mg   ;NumSum_IWC
                            sizes=sizes*microns_per_pixel; changes it to be um.
                            areas_mm2=areas*pxs*pxs;  change to =mm^2.
                            get_IWC_from_adj_n_sizes,total_IWC,alpha,beta,adjs,sizes,areas_mm2; ouput is mg.
                            sizes=sizes/microns_per_pixel
                            ypts(i)=total_IWC/SE_volume(i); mg/L/um.
                        end

                        'Lwc': begin; nov 29, 2007.
                            ypts(i)=(0.1^(9)*!pi/6.0)*total(adjs*(float(sizes*microns_per_pixel))^3)/SE_volume(i);  mg/L, LWC.   sizes in pixels.
                        end
                    endcase
                    ;if i eq 294 then stop
                endif else begin
                    ypts(i)=0.0
                    adjustmentfactor=0.0
                endelse
            endif; end of  L_choise ne 'M6'

            if L_choice eq 'M6' then begin
                if contGood gt 0 then begin  ;cont is number of slected-particles.
                    Bin_data=subdata[indexgood]; this contains particles good/selected by criteria, not by methods yet.

                    get_M6_tms_area_adjs,HorV,'M1',Bin_data,areas,sizes1,adjs1,partcont1,yptsM1,AptsM1,Iptsm1,LptsM1,has_dataM1,single_binwidths,adjustmentfactorM1; sizes in pixels.
                    get_M6_tms_area_adjs,HorV,'M2',Bin_data,areas,sizes2,adjs2,partcont2,yptsM2,AptsM2,Iptsm2,LptsM2,has_dataM2,single_binwidths,adjustmentfactorM2; sizes in pixels.

                    Make_M1M2_64bins_data,xpts,yptsM1,yptsM2,$ ; input
                        HyptsM1M2,Hbin1,Hbin2,Hbin3; output; also PartcontM1, partcontM2
                    Make_M1M2_64bins_data,xpts,AptsM1,AptsM2,$ ; input
                        HAptsM1M2,Hbin1b,Hbin2b,Hbin3b; output; also PartcontM1, partcontM2
                    Make_M1M2_64bins_data,xpts,IptsM1,IptsM2,$ ; input;  I means ice
                        HIptsM1M2,Hbin1c,Hbin2c,Hbin3c; output; also PartcontM1, partcontM2
                    Make_M1M2_64bins_data,xpts,LptsM1,LptsM2,$ ; input;  I means ice
                        HLptsM1M2,Hbin1d,Hbin2d,Hbin3d; output; also PartcontM1, partcontM2

                    has_data=has_dataM1 or has_dataM2;    note that
                    adjustmentfactor=1.0
                    M6conc =total(HyptsM1M2*single_binwidths) ; #/L
                    M6extn = 2.0*total(HAptsM1M2*single_binwidths);  mm^2/L
                    M6IWC =total(HIptsM1M2*single_binwidths);    mg/L
                    M6LWC =total(HLptsM1M2*single_binwidths);    mg/L

                    case this_param of
                        'evts': begin
                            ypts(i)=partcont1+partcont2
                        end
                        'conc': ypts(i)=M6conc/SE_volume(i);  NumSum =total(Adjs) ;summing the Adj1's for each particle for the numerator
                        'extn': ypts(i)=M6extn/SE_volume(i); mm^2.0  ; NumSum_Extinction = total(Adjs * Areas* 0.0001)
                        'extI': ypts(i)=M6extn/SE_volume(i); mm^2.0  ; NumSum_Extinction = total(Adjs * Areas* 0.0001)
                        'extL': ypts(i)=M6extn/SE_volume(i); mm^2.0  ; NumSum_Extinction = total(Adjs * Areas* 0.0001)

                        'IWC':  ypts(i)=M6Iwc/SE_volume(i); mg/L.
                        'Lwc':  ypts(i)=M6LWC/SE_volume(i); mg/L
                    endcase
                endif else begin
                    ypts(i)=0.0
                    adjustmentfactor=0.0
                endelse
            endif; end of if L_choice eq M6.
        endelse;  end else of there are particles within the bin.

        final_factor=adjustmentfactor

        if this_param eq 'evts' then begin
            if adjustmentfactor ne 0 then  ypts(i)=ypts(i)/adjustmentfactor
        endif else ypts(i)=ypts(i)*final_factor

        startbin_time=endbin_time
        endbin_time=startbin_time+time_binsize

        if ypts(i) lt 0.0 then begin
            rrs=dialog_message(['The '+strtrim(string(i),2)+'th Time Series bin-height is less than zero !!'],/information)
        endif;stop


    endfor
    case this_param of
        "evts": ystr='#/bin'
        "conc": ystr='#/L'
        ;"extn": ystr='1/km' ; TAF changing extn to extI, as this_param is extI 2012-10-29
        "extI": ystr='1/km'
        "extL": ystr='1/km'
        "IWC":  ystr='g/m3'
        "Lwc":  ystr='g/m3'
    endcase


end; ;end of get_one_Tms_tarce_300bin_time_series.pro
;******************************************************************
;******************************************************************

;****************************************************************************
pro Get_alexei_correct_size,Dmax,Dimg,sizes_L4,SizeDo
    ;input Dmax-----maximium area of the alexei's  90 or 0 degree counter area; chris_code curr_data.alexei1
    ;input Dimg-----total area of the image, curr_data.Area from chris code.
    ;input sizes_L4-------sizes using L4   and using L8 size also. sizes_L4 is in unit um.
    ;output sizeDo ----the corrected size of the particle.----Sept 14, 2005.
    ;note that we change alexei tabel 40 for be all 1.0  if  Dimg/Dmax is in focus.

    get_alexeis_table,Ratio_DmDo,Ratio_DpDm; teh ration tells
    ; the relation of Dimg, Dpson spot, and the apparent size and true size
    indexGT=where(Dimg-Dmax gt 0.0,contGT)
    if contGT gt 0 then begin
        mymessage='Dimg greater than Dmax !!! '+string(contGT)+'Times'
        ; rrr=dialog_message(mymessage,/information)
        outputfilename=strmid(!currentHFname,0,strlen(!currentHFname)-4)+'PopUpMessages.txt'
        ;!currentHPname+'Pop_up_messages.txt'
        openw,8,outputfilename,/append
        printf,8,mymessage
        close,8
        Dimg(indexGT)=Dmax(indexGT)
    endif

    ratio=sqrt(1.0-float(Dimg)/float(Dmax));   ; it is a vector of the imput variables.

    ;redo SizeDo agian using interpol method.
    min_RDpDm=min(Ratio_DpDm)
    max_RDpDm=max(Ratio_DpDm)
    Ratio    =(Ratio > min_RDpDm) < Max_RDpDm
    rdmdo    =interpol(Ratio_DmDo,Ratio_DpDm, ratio); if rdmdo less than 1,it will enlarge the particel should not be that way.
    sizeDo  =Sizes_L4/(rdmdo); >1.0) ; sizeDo is not multiple of 10. in unit of um.

end; end of pro Get_alexei_correct_size,Dmax,Dimg,SizeDo
;****************************************************************************
;get alexeis table
;***********************************************************
pro get_alexeis_table,Ratio_DmDo,Ratio_DpDm
    ; filename=dialog_pickfile(filter='Alexeis_table.txt')
    a3vcpiviewloc = strpos(!path,'2DSVIEW')
    end_semicolonloc = strpos(!path,';',a3vcpiviewloc)
    start_semicolonloc = strpos(!path,';',a3vcpiviewloc,/reverse_search)
    length=end_semicolonloc-start_semicolonloc-1
    a3vcpiviewPath = strmid(!path,start_semicolonloc+1,length)

    ;filename=a3vcpiviewPath+'\Alexeis_table.txt'
    ;filename='.\Alexeis_table.txt'

    ;filename='D:\SPEC\3VCPI_Dec15_Setup\3VCPIView_1.0.21_2ds_updates\Alexeis_table.txt'

    filename = !SPEC_3VCPI_DIR + '\Alexeis_table.txt'

    data=read_ascii(filename,data_start=4)

    Ratio_DmDo=transpose(data.field1(1,*))
    ;Ratio_DiDm=transpose(data.field1(2,*))
    Ratio_DpDm=transpose(data.field1(4,*))
end;**************end of get_alxeis_table
;**************************************************
;**************************************************************
pro  get_the_psd_sizes,HorV,L_choice,ave_info,has_data,sizes,areas,adjs,csp,livetimeVolume,deadtime,Partcont,adjustmentfactor
    Common  DataBlock,alldataH,alldataV,ADataH,ADataV,FirstData,LastData,StripData,$
        FirstDataV,LastDataV,StripDataV,avestripdata,avestripdataV

    if HorV eq "H" then begin
        subindex=*(ave_info.Hsubindex)
        livetimevolume=ave_info.HliveV
        deadtime=ave_info.Hdeadtime
        alldata = alldataH

        if subindex(0) ne -1 then begin
            csp =(*alldata)(subindex).csp
        endif else csp=[0.0,0.0]

        microns_per_pixel=!microns_per_pixelH
    endif

    if HorV eq "V" then begin
        subindex=*(ave_info.Vsubindex)
        livetimevolume=ave_info.VliveV
        deadtime=ave_info.Vdeadtime
        alldata = alldataV

        if subindex(0) ne -1 then begin
            csp =(*alldata)(subindex).csp
        endif else csp=[0.0,0.0]

        microns_per_pixel=!microns_per_pixelV
    endif

    totN =n_elements(subindex)
    adjustmentfactor=0

    if subindex(0) ne -1 then begin
        has_data=1
        Partcont=strtrim(n_elements(subindex)); This partCont may change if not round and if adjs=0 because of F1 selections. see later.
        ; see later for modification of Partcont at end of if statement.

        case L_choice of
            'M1': begin
                sizes = (*alldata)(subindex).L1n*microns_per_pixel; unit is pixels. microns_per_pixel=0.01 ; length of particles in microns
                areas = (*alldata)(subindex).area
                adjustmentfactor=1.0
                adjs  = (*alldata)(subindex).adj1; (*alldata)(subindex).adj0
                if !filter eq 1 then adjs=adjs*(*alldata)(subindex).adj0
            end

            'M2': begin
                sizes = (*alldata)(subindex).L5; unit is pixels. microns_per_pixel=0.01 ; length of particles in microns
                areas = (*alldata)(subindex).area
                F1    = (*alldata)(subindex).F1
                adj0s =(*alldata)(subindex).adj0
                totN=n_elements(sizes)
                get_method2adjvalues_of_normal,HorV,sizes,F1,adjs
                index =where(adjs gt 0.0,totNF);   total acceted levels.
                if totNF gt 0 then begin
                    has_data=1
                    adjustmentfactor=float(totN)/float(totNF)
                    adj0s =adj0s(index)
                    adjs  =adjs(index)
                    areas =areas(index)
                    sizes=sizes(index)*microns_per_pixel;; note that in bin counts, we should use adjs not eq 0 particles to get into a bin.
                    if !filter eq 1 then adjs=adjs*adj0s
                endif else has_data=0

            end
            'M3': begin
                sizes = 1.8*(*alldata)(subindex).L3
                areas = (*alldata)(subindex).area
                adj0s =(*alldata)(subindex).adj0
                F1    = (*alldata)(subindex).F1
                roundness=(*alldata)(subindex).roundness;  index3 =where(roundness eq 1,contG)
                totN=n_elements(sizes)
                get_method3adjvalues,HorV,sizes,F1,adjs
                index =where(adjs gt 0.0 and roundness eq 1,totNF);   total acceted levels. only use those quasi round particles.
                if totNF gt 0 then begin
                    has_data=1
                    adjustmentfactor=float(totN)/float(totNF)
                    adj0s =adj0s(index)
                    adjs  =adjs(index)
                    sizes=sizes(index)*microns_per_pixel;; note that in bin counts, we should use adjs not eq 0 particles to get into a bin.
                    areas =!pi*(sizes(index))^2/4.0;      in unit pixel^2
                    Partcont=strtrim(totNF,2)
                    if !filter eq 1 then adjs=adjs*adj0s
                endif else has_data=0


            end
            'M4':begin  ; It get the same thing as "M6=0, L_choice=M4" of  get64binUltimate, ypts.
            sizes   =(*alldata)(subindex).L7;   in pixels
            areas   =(*alldata)(subindex).area  ; ;areas=!pi*sizes^2/4.0;    in unit pixel^2
            F1      =(*alldata)(subindex).F1
            adj0s   =(*alldata)(subindex).adj0
            roundness=(*alldata)(subindex).roundness
            get_method4adjvalues,HorV,sizes,F1,adjs; ;input sizes has to be in unit pixels
            indexaccepted=where(adjs gt 0.0, accepted_count);   % all final accepted particles that are not touching the edges.
            if accepted_count gt 0 then begin
                has_data=1
                adjustmentfactor=float(totN)/float(accepted_count);  this
                sizes=sizes(indexaccepted)*microns_per_pixel;                  in unit um.
                adjs = adjs(indexaccepted)*adj0s(indexaccepted)
                areas=areas(indexaccepted)
                Partcont=strtrim(n_elements(adjs))
                adj0s=adj0s(indexaccepted)
                csp  =csp(indexaccepted)
                if !filter eq 1 then  adjs=adjs*adj0s
            endif else has_data=0
        end; end of M4 method

        'M5':begin
        sizes   =(*alldata)(subindex).L8;   in pixels
        areas   =(*alldata)(subindex).area  ; ;areas=!pi*sizes^2/4.0;    in unit pixel^2
        F1      =(*alldata)(subindex).F1
        adj0s   =(*alldata)(subindex).adj0
        roundness=(*alldata)(subindex).roundness
        get_method4adjvalues,HorV,sizes,F1,adjs; ;input sizes has to be in unit pixels
        indexaccepted=where(adjs gt 0.0, accepted_count);   % all final accepted particles that are not touching the edges.
        if accepted_count gt 0 then begin;     ; shuld we do roundness ?  evaluation !
            has_data=1
            adjustmentfactor=float(totN)/float(accepted_count);  this
            sizes=sizes(indexaccepted)*microns_per_pixel;                  in unit um.
            adjs = adjs(indexaccepted)*adj0s(indexaccepted)
            areas=areas(indexaccepted)
            Partcont=strtrim(n_elements(adjs))
            adj0s=adj0s(indexaccepted)
            csp  =csp(indexaccepted)
            if !filter eq 1 then  adjs=adjs*adj0s
        endif else has_data=0
    end; end; of M5 method

    'M7': begin
        sizes = (*alldata)(subindex).L5; unit is pixels. microns_per_pixel=0.01 ; length of particles in microns
        maxlength =(*alldata)(subindex).maxlength;  in pixels too.
        areas = (*alldata)(subindex).area
        adj0s = (*alldata)(subindex).adj0
        F1    = (*alldata)(subindex).F1
        get_method7adjvalues,HorV,sizes,maxlength,F1,adjs
        indexaccepted=where(adjs gt 0.0, accepted_count);   % all final accepted particles that are not touching the edges.
        if accepted_count gt 0 then begin
            has_data=1
            adjustmentfactor=float(totN)/float(accepted_count);  this
            sizes=maxlength(indexaccepted)*microns_per_pixel
            adjs =adjs(indexaccepted)
            areas=areas(indexaccepted)
            csp  =csp(indexaccepted)
            Partcont=strtrim(n_elements(adjs))
            adj0s=adj0s(indexaccepted)
            if !filter eq 1 then  adjs=adjs*adj0s
        endif else has_data=0
    end

endcase
; modify partcont because F1 and roundness selection criteria.
junk=where(adjs ne 0.0, nozero_count)
Partcont=strtrim(string(nozero_count),2)

endif else begin
    has_data=0
    Partcont='0';strtrim(n_elements(subinxex))
    livetimevolume=999999.0; ave_info.HliveV
    deadtime=ave_info.Hdeadtime
    sizes=[0.0]
    areas=[0.0]
    adjs=0.0
    adjustmentfactor=0.0
endelse

end;  end of get_the_psd_sizes,L_choices,Vsubindex,sizes,adjs
;*****************************************************************

pro  get_the_psd_sizes_M6,HorV,L_choice,ave_info,has_data,sizes,areas,adjs,csp,livetimeVolume,deadtime,Partcont,adjustmentfactor
    Common  DataBlock,alldataH,alldataV,ADataH,ADataV,FirstData,LastData,StripData,$
        FirstDataV,LastDataV,StripDataV,avestripdata,avestripdataV

    start_time = ave_info.startnanoseconds
    end_time   = ave_info.endnanoseconds

    if HorV eq "H" then begin
        livetimevolume=ave_info.HliveV
        deadtime=ave_info.Hdeadtime
        alldata = alldataH
        microns_per_pixel=!microns_per_pixelH
    endif

    if HorV eq "V" then begin
        livetimevolume=ave_info.VliveV
        deadtime=ave_info.Vdeadtime
        alldata = alldataV
        microns_per_pixel=!microns_per_pixelV
    endif

    subindex = where((*alldata).nanoseconds gt start_time and (*alldata).nanoseconds le end_time $
        and (*alldata).area gt 0 and (*alldata).reject eq 0 and (*alldata).area gt 0.9*(*alldata).alexei1, totN)

    if totN ge 1 then begin
        csp =(*alldata)(subindex).csp
    endif else csp=[0.0,0.0]


    if totN ge 1 then begin
        has_data=1
        Partcont=strtrim(n_elements(subindex))

        case L_choice of
            'M1': begin
                sizes = (*alldata)(subindex).L1n*microns_per_pixel; unit is pixels. microns_per_pixel=0.01 ; length of particles in microns
                areas = (*alldata)(subindex).area
                adjustmentfactor=1.0
                adjs  = (*alldata)(subindex).adj1; (*alldata)(subindex).adj0
                if !filter eq 1 then adjs=adjs*(*alldata)(subindex).adj0
            end

            'M2': begin
                sizes = (*alldata)(subindex).L5; unit is pixels. microns_per_pixel=0.01 ; length of particles in microns
                areas = (*alldata)(subindex).area
                F1    = (*alldata)(subindex).F1
                adj0s =(*alldata)(subindex).adj0
                totN=n_elements(sizes)
                get_method2adjvalues_of_normal,HorV,sizes,F1,adjs
                index =where(adjs gt 0.0,totNF);   total acceted levels.
                if totNF gt 0 then begin
                    has_data=1
                    adjustmentfactor=float(totN)/float(totNF)
                    adj0s =adj0s(index)
                    adjs  =adjs(index)
                    areas =areas(index)
                    sizes=sizes(index)*microns_per_pixel;; note that in bin counts, we should use adjs not eq 0 particles to get into a bin.
                    if !filter eq 1 then adjs=adjs*adj0s
                endif else has_data=0
            end
        endcase
    endif else begin
        has_data=0
        Partcont='0';strtrim(n_elements(subinxex))
        livetimevolume=999999.0; ave_info.HliveV
        sizes=[0.0]
        areas=[0.0]
        adjs=0.0
        adjustmentfactor=0.0
    endelse
end;  end of get_the_psd_sizes_M6,L_choices,Vsubindex,sizes,adjs


pro  get_tms_area_adjs,HorV,L_choice,Bin_data,areas,sizes,adjs,adjustmentfactor
    case L_choice of
        'M1': begin ; use L1 sizes
            areas = Bin_data.area
            sizes = Bin_data.L1n
            adj0s = Bin_data.adj0
            adjs  = Bin_data.adj1
            if !filter eq 1 then adjs=adjs*adj0s
            adjustmentfactor=1.0
        end

        'M2': begin ;use L4 size
            areas = Bin_data.area
            sizes = Bin_data.L5
            adj0s = Bin_data.adj0
            F1    = Bin_data.F1
            indexjunk=where(areas gt 0.0,totN)
            get_method2adjvalues_of_normal,HorV,sizes,F1,adjs
            indexacceptedF =where(adjs gt 0.0, totNF)
            if totNF gt 0 then begin
                areas =areas(indexacceptedF)
                sizes =sizes(indexacceptedF)
                adjs  =adjs(indexacceptedF)
                adj0s =adj0s(indexacceptedF)
                adjustmentfactor=float(totN)/float(totNF)
                if !filter eq 1 then adjs=adjs*adj0s
            endif else has_data=0
        end
        'M3': begin  ;use L3 sizes
            sizes = 1.8*Bin_data.L3
            areas = Bin_data.area
            adj0s =Bin_data.adj0
            F1    = Bin_data.F1

            roundness=bin_data.roundness
            indexjunk=where(areas gt 0.0,totN)
            get_method3adjvalues,HorV,sizes,F1,adjs
            indexacceptedF =where(adjs gt 0.0, totNF)
            if totNF gt 0 then begin
                areas =areas(indexacceptedF)
                sizes =sizes(indexacceptedF)
                adjs  =adjs(indexacceptedF)
                adj0s =adj0s(indexacceptedF)
                adjustmentfactor=float(totN)/float(totNF)
                if !filter eq 1 then adjs=adjs*adj0s
            endif else has_data=0

        end
        'M4':begin ; use L4 sizes and then correct it to L7=alxei's size
        sizes=bin_data.L7
        areas=bin_data.area
        adj0s=Bin_data.adj0
        F1 =Bin_data.F1
        indexjunk=where(areas gt 0.0,totN)
        get_method4adjvalues,HorV,sizes,F1,adjs
        indexacceptedF =where(adjs gt 0.0, totNF)
        if totNF gt 0 then begin
            areas =areas(indexacceptedF)
            sizes =sizes(indexacceptedF)
            adjs  =adjs(indexacceptedF)
            adj0s =adj0s(indexacceptedF)
            adjustmentfactor=float(totN)/float(totNF)
            if !filter eq 1 then adjs=adjs*adj0s
        endif else has_data=0
    end; end of 'M4' case.

    'M5':begin ; use L4 sizes and then correct it to L7=alxei's size
    sizes=bin_data.L8
    adj0s=Bin_data.adj0
    F1 =Bin_data.F1
    ; Dmax =Bin_data.alexei1;  ;maximium total countor_area from alexei's
    ; Dimg =Bin_data.area;     ;total image area from chris code.
    roundness=bin_data.roundness
    ;index =where(Dmax gt 0.0 and roundness eq 1,contDmax)
    areas=bin_data.area;    areas=!pi*sizes^2/4.0;    in unit pixel^2

    indexjunk=where(areas gt 0.0,totN)
    get_method4adjvalues,HorV,sizes,F1,adjs
    indexacceptedF =where(adjs gt 0.0, totNF)
    if totNF gt 0 then begin
        areas =areas(indexacceptedF)
        sizes =sizes(indexacceptedF)
        adjs  =adjs(indexacceptedF)
        adj0s =adj0s(indexacceptedF)
        adjustmentfactor=float(totN)/float(totNF)
        if !filter eq 1 then adjs=adjs*adj0s
    endif else has_data=0

end; end of 'M5' case.

'M7': begin ;use L5 and maxlength for dof and  size
    areas = Bin_data.area
    sizes = Bin_data.L5
    maxlength =Bin_data.Maxlength
    adj0s = Bin_data.adj0
    adjustmentfactor=1.0
    F1    = Bin_data.F1
    indexjunk=where(maxlength gt 0.0,totN)
    get_method7adjvalues,HorV,sizes,maxlength,F1,adjs
    indexaccepted=where(adjs gt 0.0, accpted_count);   % all final accepted particles that are not touching the edges.
    if accpted_count gt 0 then begin
        adjustmentfactor=float(totN)/float(accpted_count);  this
        sizes=Maxlength(indexaccepted)
        adj0s=adj0s(indexaccepted)
        areas=areas(indexaccepted)
        adjs =adjs(indexaccepted)
        if !filter eq 1 then adjs=adjs*adj0s
    endif else has_data=0
end

endcase
;stop
end; end of get_tms_area_adjs,L_choice, bin_data,area,adjs
;******************************************************************

pro  get_M6_tms_area_adjs,HorV,L_choice,Bin_data,areas,sizes,adjs,partcont,Ypts,Apts,Ipts,Lpts,has_data,single_binwidths,adjustmentfactor

    if HorV eq 'H' then microns_per_pixel = !microns_per_pixelH else microns_per_pixel =!microns_per_pixelV
    has_data=0
    Partcont=0.0;strtrim(n_elements(subinxex))
    sizes=[0.0]
    areas=[0.0]
    adjs=0.0
    adjustmentfactor=0.0


    case L_choice of
        'M1': begin ; use L1 sizes
            areas = Bin_data.area
            sizes = Bin_data.L1n
            adj0s = Bin_data.adj0
            reject= Bin_data.reject
            Alexei1=Bin_data.alexei1
            F1     =Bin_data.F1
            index=where(areas gt 0.9*alexei1 and areas gt 0.0 and reject eq 0.0, partcont)

            if partcont gt 0 then begin
                has_data=1
                F1=F1(index)
                areas=areas(index)
                adj0s=adj0s(index)
                sizes=sizes(index)
                get_method1adjvalues_of_M6,HorV,sizes,F1,adjs
                adjustmentfactor=1.0;.
                if !filter eq 1 then adjs=adjs*adj0s
            endif  else has_data=0
        end

        'M2': begin ;use L4 size
            areas = Bin_data.area
            sizes = Bin_data.L5
            adj0s = Bin_data.adj0
            alexei1=Bin_data.alexei1
            reject =Bin_data.reject
            F1    = Bin_data.F1
            index=where(areas gt 0.9*alexei1 and areas gt 0.0 and reject eq 0.0, partcont)
            if partcont gt 0 then begin
                F1=F1(index)
                areas=areas(index)
                adj0s=adj0s(index)
                sizes=sizes(index)
                get_method2adjvalues_of_M6,'H',sizes,F1,adjs
                indexaccepted=where(adjs gt 0, totNF)
                if totNF gt 0 then begin
                    adjustmentfactor=float(partcont)/float(totNF);.
                    adjs =adjs(indexaccepted)
                    adj0s=adj0s(indexaccepted)
                    areas=areas(indexaccepted)
                    sizes=sizes(indexaccepted)
                    if !filter eq 1 then adjs=adjs*adj0s
                    has_data=1
                endif else has_data =0

            endif else has_data=0
        end
    endcase

    sizes=sizes*microns_per_pixel
    make_61_bins_ultimate,microns_per_pixel, nbins, nedges, xpts, dbl_binwidths
    single_binwidths=dbl_binwidths(0:n_elements(dbl_binwidths)-1:2)
    ;*******************************************************
    ;SVdefault=1.0

    xpts(0)=0.001;  ;make_61_bins,nbins,nedges,xpts,dbl_binwidths
    nedges=n_elements(xpts)
    ypts = fltarr(nedges)
    Apts =fltarr(nedges)
    Ipts =fltarr(nedges)
    Lpts =fltarr(nedges)

    if has_data eq 1 then begin
        alpha = 0.115D
        beta = 1.218D

        for j=0,nedges-2,2 do begin  ;sizes should be in um in here ?????
            binwidth=dbl_binwidths(j);  (xpts[j+1]-xpts[j]); this in uni unit of um.
            LiterTum=binwidth;  *SVdefault
            somarr=where(sizes lt xpts[j+1] and sizes ge xpts[j],contG) ; Handle all but last bins
            if contG gt 0 then begin;  if there is no particles, area and mass should be zero
                this_adj1=adjs(somarr)
                this_area=areas(somarr);       in unit pixels.
                This_sizes=sizes(somarr);      in unit um.

                ypts[j:j+1] =total(this_adj1)/LiterTum; #/L/um . Plot_Size[j:j+1]

                This_area_mm2=This_area*microns_per_pixel*microns_per_pixel/1000000.0; change it to be mm2.

                Apts[j:j+1] =total(this_adj1*this_area_mm2)/LiterTum; area mm^2/Liter/um. Hextn
                get_IWC_from_adj_n_sizes,total_IWC,alpha,beta,this_adj1,this_sizes,this_area_mm2
                Ipts[j:j+1]=total_IWC/LiterTum;  mg/L/um
                Lpts[j:J+1]=(!pi/6.0)*total(This_adj1*(float(This_sizes))^3)*0.000000001/LiterTum;  mg/um, LWC. sizes in um.

            endif ; else begin
            ; no need to assign all ypts[j:j+1]
            ; endelse
        endfor

        ;**********************************************************
        xpts(0)=microns_per_pixel/2.0
        ;handle last bin;  save a lot of if statement in the for loop
        j=nedges-2
        somarr=where(sizes ge max(xpts),contG);   max(xpts)=2010.0
        binwidth=20.0*microns_per_pixel; (xpts[j+1]-xpts[j]);       xpts(j+1)=2010.0 also.
        LiterTum=binwidth; *SVdefault;somarr=where(sizes lt xpts[j+1] and sizes ge xpts[j],contG) ; Handle all but last bins

        if contG eq 0 then begin;  there is no particles, area and mass should be zero
            ; do nothing becasue ypts(j:j+1) are already =0.
        endif else begin
            this_adj1=adjs(somarr)
            this_area=areas(sommarr)
            This_sizes=sizes(somarr)

            ypts[j:j+1] =total(this_adj1)/LiterTum; #/L/um . Plot_Size[j:j+1]


            This_area_mm2=This_area*microns_per_pixel*microns_per_pixel/1000000.0; change it to be mm2.

            Apts[j:j+1] =total(this_adj1*this_area_mm2)/LiterTum; area mm^2/Liter/um. Hextn

            This_area_mm2=This_area*0.0001; change it to be mm2.
            get_IWC_from_adj_n_sizes,total_IWC,alpha,beta,this_adj1,this_sizes,this_area_mm2

            Ipts[j:j+1]=total_IWC/LiterTum
            Lpts[j:J+1]=(0.1^9*!pi/6.0)*total(This_adj1*(float(This_sizes))^3)/LiterTum;  mg/um, LWC. sizes in um.
        endelse
        ; stop
    endif ; if has_data =1

    ;change ypts to single value arrays
    ;if total(ypts) gt 0.0 then stop
    k=indgen(n_elements(ypts)/2)*2
    ypts=ypts(k)
    Apts=Apts(k)
    Ipts=Ipts(k)
    Lpts=LPts(k)
    sizes=sizes/microns_per_pixel;  recovered sizes to be pixels.
    ;end of step 2
    ;******************************************************************************
end; end of get_M6_tms_area_adjs,L_choice, bin_data,area,adjs

;**************************************************************
pro Get_allindexs_and_boolean_subsetindexs,ave_info,Hallindex,Hsubindex,Hfactor,Vallindex,VsubIndex,Vfactor
    IF AVE_INFO.FILTER EQ 0 THEN BEGIN

        Get_allindexs_and_boolean_subsetindexs_noisy,ave_info,Hallindex,Hsubindex,Hfactor,Vallindex,VsubIndex,Vfactor
    ENDIF ELSE BEGIN

        Get_allindexs_and_boolean_subsetindexs_CLEAN,ave_info,Hallindex,Hsubindex,Hfactor,Vallindex,VsubIndex,Vfactor
    ENDELSE
    ;calculate teh 300 bin SE_volume one time for all.
    Hsv=fltarr(300)
    Vsv=fltarr(300)

    Get_Hsv_Vsv,300,Hsv,Vsv,ave_info

    ave_info.Hsv=ptr_new(Hsv)
    ave_info.Vsv=ptr_new(Vsv)
end; end of get_allindex_and_boolean_substeindex,ave_info,Hall*****************Vallindex*****************



pro Get_allindexs_and_boolean_subsetindexs_noisy,ave_info,Hallindex,Hsubindex,Hfactor,Vallindex,VsubIndex,Vfactor
    ;note that Hallindex is all particles including fake one. THis needs for calculated deadtime and sample volume.
    ;and  that Hsubindex is all particles with L1 gt 0 and statisfying the criteria. This is needed for
    ;calculating the factor (total_valid/selected_particle) to bump up the psd and tms.
    ;here the subsetindex will include spurious particles. alldata*.reject =0 and 1.
    Common  DataBlock,alldataH,alldataV,ADataH,ADataV,FirstData,LastData,StripData,$
        FirstDataV,LastDataV,StripDataV,avestripdata,avestripdataV

    Hallindex=where((*alldataH).nanoseconds gt ave_info.startnanoseconds and $
        (*alldataH).nanoseconds le ave_info.endnanoseconds,contG)
    ;catch the boolean logic error and return

    ErrorNo=0;    errorno=Error_number
    Catch,ErrorNo
    if ErrorNo ne 0 then begin
        Catch,/Cancel
        ;Err_Message=[['Error occured in Get_allindexs_and_boolean_subsetindexs_noisy.pro:'],$
        ;             ['the input boolean string is not correct:'],$
        ;             [' variable or operator not right !!!'],$
        ;             ['Error Number:'+strtrim(!error,2)]];,$
        ;            ; Err_string]
        ;aarr=dialog_message(Err_message,/Error)
        return
    endif

    if ave_info.criteria.on eq 1 then begin

        if contG ge 1 then begin
            L1n=(*alldataH)(Hallindex).L1n;    these are in unit pixels.
            L2=(*alldataH)(Hallindex).L2
            L3=1.8*(*alldataH)(Hallindex).L3
            L4=(*alldataH)(Hallindex).L4
            L5=(*alldataH)(Hallindex).L5
            ;                          Get_alexei_correct_size,Dmax,Dimg,sizes_L4,L7
            L7=(*alldataH)(Hallindex).L7
            PC1=(*alldataH)(Hallindex).PC1;  in unit pixels
            PC3x=(*alldataH)(Hallindex).PC3x
            PC3y=(*alldataH)(Hallindex).PC3y
            PC4x=(*alldataH)(Hallindex).PC4x
            PC4y=(*alldataH)(Hallindex).PC4y
            Area=(*alldataH)(Hallindex).Area
            A3  =(*alldataH)(Hallindex).A3
            Alexei1=(*alldataH)(Hallindex).alexei1
            reject =(*alldataH)(Hallindex).reject
            w8_t   =(*alldataH)(Hallindex).w8_t
            focus  =(*alldataH)(Hallindex).focus
            roundness=(*alldataH)(Hallindex).roundness
            roundness1 = (*alldataH)(Hallindex).roundness1
            roundness2 = (*alldataH)(Hallindex).roundness2
            roundness3 = (*alldataH)(Hallindex).roundness3
            L1r        = (*alldataH)(Hallindex).L1r
            maxLength  = (*alldataH)(Hallindex).maxLength
            maxWidth   = (*alldataH)(Hallindex).maxWidth
            perimeter  = (*alldataH)(Hallindex).perimeter
            F1    =(*alldataH)(Hallindex).F1
            H     =((*alldataH)(Hallindex).noisebyte and 16)/16;hand-removal noise bit.
            S     =((*alldataH)(Hallindex).noisebyte and 8)/8;  because vectors like [1,1,1,0,0,***,0,1,1,0,0]
            T     =((*alldataH)(Hallindex).noisebyte and 4)/4
            D     =((*alldataH)(Hallindex).noisebyte and 2)/2
            N     =((*alldataH)(Hallindex).noisebyte and 1)

            junk=where(w8_t eq 0 and L1n gt 0,contzero)
            if contzero gt 0 then begin
                Wmessage='Warning !There"re '+strtrim(contzero,2)+' cases intra-particle-w8-time is 0 and L1n gt 0 !'
                ; junk=dialog_message(Wmessage,/information)
            endif
            ;stop

            if !Infocus_on eq 0 then begin
                if strlen(ave_info.criteria.text) lt 4 then begin
                    mystring="Localindex=where(L1n gt 0,LocCont)"
                endif else begin
                    mystring="Localindex=where((L1n gt 0) and ("+ave_info.criteria.text+"),LocCont)"
                endelse
            endif

            if !Infocus_on eq 1 then begin
                if strlen(ave_info.criteria.text) lt 4 then begin
                    mystring="Localindex=where(L1n gt 0 and focus gt !focuspercent,LocCont)"
                endif else begin
                    mystring="Localindex=where((L1n gt 0) and (focus gt !focuspercent) and ("+ave_info.criteria.text+"),LocCont)"
                endelse
            endif

            result=execute(mystring)

            result=where((*alldataH)(Hallindex).L1n gt 0.0,total_valid_particles)
            if LocCont gt 0 then begin ; there are particles satisfy the criteria
                Hsubindex=Hallindex(Localindex)
                total_valid_subset_particles=n_elements(Hsubindex)
                if total_valid_particles ge 1.0 then begin
                    Hfactor=float(total_valid_subset_particles)/float(total_valid_particles)
                endif else begin
                    Hfactor=0.0
                endelse

            endif else begin ;end of if LocCont gt 0
                Hsubindex=-1
                Hfactor=0.0
            endelse
            ;end of if LocCont eq 0
        endif else begin ; end of if contG gt 0.
            Hsubindex=-1
            Hfactor=0.0
        endelse

        ;end of if contG eq 0
    endif else begin; end of ave_info.criteria.on eq 1

        if !Infocus_on eq 0 then begin
            Hfactor=1.0;      Hsubindex=Hallindex
            Hsubindex=where((*alldataH).nanoseconds gt ave_info.startnanoseconds and $
                (*alldataH).nanoseconds le ave_info.endnanoseconds and $
                (*alldataH).L1n gt 0)
        endif

        if !Infocus_on eq 1 then begin
            focus  =(*alldataH).focus
            Hsubindex=where((*alldataH).nanoseconds gt ave_info.startnanoseconds and $
                (*alldataH).nanoseconds le ave_info.endnanoseconds and $
                (*alldataH).L1n gt 0 and focus gt !focuspercent)
            Hfactor=n_elements(Hallindex)/float(n_elements(Hsubindex) > 1.0)
        endif

    endelse
    ;further get rid of bad particles particles which has L2=L4=L5 and has neighbours
    ; get_rid_of_bad_Hparticles,Hsubindex, Hgoodindex
    ; if Hgoodindex(0) ne -1 then Hk=float(n_elements(Hsubindex))/float(n_elements(Hgoodindex)) else Hk=0.0
    ave_info.Hallindex=ptr_new(Hallindex)
    ave_info.Hsubindex=ptr_new(Hsubindex)

    ;get the V indexs

    Vallindex=where((*alldataV).nanoseconds gt ave_info.startnanoseconds and $
        (*alldataV).nanoseconds le ave_info.endnanoseconds,contG)
    if ave_info.criteria.on eq 1 then begin

        if contG ge 1 then begin
            L1n=(*alldataV)(Vallindex).L1n
            L2=(*alldataV)(Vallindex).L2
            L3=1.8*(*alldataV)(Vallindex).L3
            L4=(*alldataV)(Vallindex).L4
            L5=(*alldataV)(Vallindex).L5
            L7=(*alldataV)(Vallindex).L7
            PC1=(*alldataV)(Vallindex).PC1
            PC3x=(*alldataV)(Vallindex).PC3x
            PC3y=(*alldataV)(Vallindex).PC3y
            PC4x=(*alldataV)(Vallindex).PC4x
            PC4y=(*alldataV)(Vallindex).PC4y
            Area=(*alldataV)(Vallindex).Area
            A3  =(*alldataV)(Vallindex).A3
            Alexei1=(*alldataV)(Vallindex).alexei1
            reject =(*alldataV)(Vallindex).reject
            w8_t   =(*alldataV)(Vallindex).w8_t
            focus  =(*alldataV)(Vallindex).focus
            roundness=(*alldataV)(Vallindex).roundness
            roundness1=(*alldataV)(Vallindex).roundness1
            roundness2=(*alldataV)(Vallindex).roundness2
            roundness3=(*alldataV)(Vallindex).roundness3
            L1r        = (*alldataV)(Vallindex).L1r
            maxLength  = (*alldataV)(Vallindex).maxLength
            maxWidth   = (*alldataV)(Vallindex).maxWidth
            perimeter  = (*alldataV)(Vallindex).perimeter
            F1    =(*alldataV)(Vallindex).F1
            H     =((*alldataV)(Vallindex).noisebyte and 16)/16;hand-removal noise bit.
            S     =((*alldataV)(Vallindex).noisebyte and 8)/8;  because vectors like [1,1,1,0,0,***,0,1,1,0,0]
            T     =((*alldataV)(Vallindex).noisebyte and 4)/4
            D     =((*alldataV)(Vallindex).noisebyte and 2)/2
            N     =((*alldataV)(Vallindex).noisebyte and 1)

            junk=where(w8_t eq 0 and L1n gt 0,contzero)
            if contzero gt 0 then begin
                Wmessage='Warning !There"re '+strtrim(contzero,2)+' cases intra-particle-w8-time is 0 and L1n gt 0 !'
                ; junk=dialog_message(Wmessage,/information)
            endif

            if !Infocus_on eq 0 then begin
                if strlen(ave_info.criteria.text) lt 4 then begin
                    mystring="Localindex=where(L1n gt 0,LocCont)"
                endif else begin
                    mystring="Localindex=where((L1n gt 0) and ("+ave_info.criteria.text+"),LocCont)"
                endelse
            endif

            if !Infocus_on eq 1 then begin
                if strlen(ave_info.criteria.text) lt 4 then begin
                    mystring="Localindex=where(L1n gt 0 and focus gt !focuspercent,LocCont)"
                endif else begin
                    mystring="Localindex=where((L1n gt 0) and focus gt !focuspercent and ("+ave_info.criteria.text+"),LocCont)"
                endelse
            endif

            result=execute(mystring)
            result=where((*alldataV)(Vallindex).L1n gt 0.0,total_valid_particles)

            if LocCont gt 0 then begin ; there are particles satisfy the criteria
                Vsubindex=Vallindex(Localindex)
                total_valid_subset_particles=n_elements(Vsubindex)

                if total_valid_particles ge 1.0 then begin
                    Vfactor=float(total_valid_subset_particles)/float(total_valid_particles)
                endif else begin
                    Vfactor=0.0
                endelse
            endif else begin ;end of if LocCont gt 0
                Vsubindex=-1
                Vfactor=0.0
            endelse
            ;end of if LocCont eq 0
        endif else begin ; end of if contG gt 0.
            Vsubindex=-1
            Vfactor=0.0
        endelse

        ;end of if contG eq 0
    endif else begin  ; end of ave_info.criteria.on eq 1
        if !infocus_on eq 0 then begin
            Vfactor=1.0;   ; Vsubindex=Vallindex
            Vsubindex=where((*alldataV).nanoseconds gt ave_info.startnanoseconds and $
                (*alldataV).nanoseconds le ave_info.endnanoseconds and $
                (*alldataV).L1n gt 0)
        endif

        if !infocus_on eq 1 then begin
            focus  =(*alldataV).focus
            Vsubindex=where((*alldataV).nanoseconds gt ave_info.startnanoseconds and $
                (*alldataV).nanoseconds le ave_info.endnanoseconds and $
                (*alldataV).L1n gt 0 and focus gt !focuspercent)
            Vfactor=float(n_elements(Vallindex))/(n_elements(Vsubindex))
        endif
    endelse;  end of ave_info.criteria.on eq 0

    ;get_rid_of_bad_Vparticles,Vsubindex, Vgoodindex
    ;if Vgoodindex(0) ne -1 then Vk=float(n_elements(Vsubindex))/float(n_elements(Vgoodindex)) else Vk=0.0
    ave_info.criteria.Hfactor=Hfactor;*Hk
    ave_info.criteria.Vfactor=Vfactor;*Vk

    ave_info.Vallindex=ptr_new(Vallindex)
    ave_info.Vsubindex=ptr_new(Vsubindex)

    if ave_info.criteria.on eq 1 then begin
        if strlen(ave_info.criteria.text) gt 4 then begin
            ave_info.criteria.label='criteria='+ave_info.criteria.text
        endif else ave_info.criteria.label='criteria=none'
    endif else begin
        ave_info.criteria.label='criteria=None'
    endelse

end ; end of get_allindex_and_boolean_subsetindex_noisy.pro



pro Get_allindexs_and_boolean_subsetindexs_clean, ave_info, Hallindex, Hsubindex, Hfactor, Vallindex, VsubIndex, Vfactor, round_flag=round_flag

    if(not keyword_set(round_flag)) then begin
        round_flag = -1
    endif

    ; fills Hsubindex and Vsubindex with the index values of the particles matching the time and custom criteria
    ; in ave_info

    ; ave_info = {criteria:criteria,                 $
    ;             startnanoseconds:startnanoseconds, $
    ;             endnanoseconds:endnanoseconds,     $
    ;             Hallindex:ptr_new(),               $
    ;             Hsubindex:ptr_new(),               $
    ;             Vallindex:ptr_new(),               $
    ;             Vsubindex:ptr_new()}

    ;note that Hallindex is all particles including fake one. THis needs for calculated deadtime and sample volume.
    ;and  that Hsubindex is all particles with L1 gt 0 and statisfying the criteria. This is needed for
    ;calculating the factor (total_valid/selected_particle) to bump up the psd and tms.
    ;here the subsetindex will include spurious particles. alldata*.reject =0 and 1.
    Common  DataBlock,alldataH,alldataV,ADataH,ADataV,FirstData,LastData,StripData,$
        FirstDataV,LastDataV,StripDataV,avestripdata,avestripdataV

    ;Hallindex=where((*alldataH).nanoseconds gt ave_info.startnanoseconds and $
    ;                (*alldataH).nanoseconds le ave_info.endnanoseconds,contG)


    ; TAF temporarily adding the Roundness criteria -- need a switch though

    ; initial values used 2012-07-09, not strict enough

    ;defsysv, '!Roundness1_min',  .75
    ;defsysv, '!Roundness1_max', 2.
    ;defsysv, '!Roundness2_min', 0.
    ;defsysv, '!Roundness2_max',  .2
    ;defsysv, '!Roundness3_min',  .9
    ;defsysv, '!Roundness3_max', 1.1

    ;defsysv, '!Roundness1_min',  .8
    ;defsysv, '!Roundness1_max', 2.
    ;defsysv, '!Roundness2_min', 0.
    ;defsysv, '!Roundness2_max',  .2
    ;defsysv, '!Roundness3_min',  .999
    ;defsysv, '!Roundness3_max', 1.001

    if(round_flag eq 2) then begin ; show only not round particles
        Hallindex=where((*alldataH).nanoseconds gt ave_info.startnanoseconds and $
            (*alldataH).nanoseconds le ave_info.endnanoseconds and $
            not ((*alldataH).Roundness1 gt !Roundness1_min and $
            (*alldataH).Roundness1 lt !Roundness1_max and $
            (*alldataH).Roundness1 gt !Roundness2_min and $
            (*alldataH).Roundness2 lt !Roundness2_max and $
            (*alldataH).Roundness3 gt !Roundness3_min and $
            (*alldataH).Roundness3 lt !Roundness3_max) $
            , contG)
    endif else if(round_flag eq 1) then begin ; show only round particles
        Hallindex=where((*alldataH).nanoseconds gt ave_info.startnanoseconds and $
            (*alldataH).nanoseconds le ave_info.endnanoseconds and $
            (*alldataH).Roundness1 gt !Roundness1_min and $
            (*alldataH).Roundness1 lt !Roundness1_max and $
            (*alldataH).Roundness1 gt !Roundness2_min and $
            (*alldataH).Roundness2 lt !Roundness2_max and $
            (*alldataH).Roundness3 gt !Roundness3_min and $
            (*alldataH).Roundness3 lt !Roundness3_max $
            , contG)
    endif else begin ; don't worry about roundness
        Hallindex=where((*alldataH).nanoseconds gt ave_info.startnanoseconds and $
            (*alldataH).nanoseconds le ave_info.endnanoseconds,contG)
    endelse

    ;catch the boolean logic error and return
    ;***********************************************************************
    ErrorNo=0;    errorno=Error_number
    Catch,ErrorNo
    if ErrorNo ne 0 then begin
        Catch,/Cancel
        ;Err_Message=['Error occured in Get_allindexs_and_boolean_subsetindexs_clean.pro:',$
        ;             'Error Number:'+strtrim(!error,2)];,$
        ;                ; Err_string]
        ;aarr=dialog_message(Err_message,/Error)
        return
    endif
    ;************************************************************************
    if ave_info.criteria.on eq 1 then begin
        ; stop
        ;******************************************************************************
        if contG ge 1 then begin
            L1n=(*alldataH)(Hallindex).L1n;    these are in unit pixels.
            L2=(*alldataH)(Hallindex).L2
            L3=1.8*(*alldataH)(Hallindex).L3
            L4=(*alldataH)(Hallindex).L4
            L5=(*alldataH)(Hallindex).L5
            ;                          Get_alexei_correct_size,Dmax,Dimg,sizes_L4,L7
            L7=(*alldataH)(Hallindex).L7
            PC1=(*alldataH)(Hallindex).PC1;  in unit pixels
            PC3x=(*alldataH)(Hallindex).PC3x
            PC3y=(*alldataH)(Hallindex).PC3y
            PC4x=(*alldataH)(Hallindex).PC4x
            PC4y=(*alldataH)(Hallindex).PC4y
            Area=(*alldataH)(Hallindex).Area
            A3  =(*alldataH)(Hallindex).A3
            Alexei1=(*alldataH)(Hallindex).alexei1
            reject= (*alldataH)(Hallindex).reject
            w8_t  = (*alldataH)(Hallindex).w8_t
            focus = (*alldataH)(Hallindex).focus
            roundness=(*alldataH)(Hallindex).roundness
            roundness1=(*alldataH)(Hallindex).roundness1
            roundness2=(*alldataH)(Hallindex).roundness2
            roundness3=(*alldataH)(Hallindex).roundness3
            L1r        = (*alldataH)(Hallindex).L1r
            maxLength  = (*alldataH)(Hallindex).maxLength
            maxWidth   = (*alldataH)(Hallindex).maxWidth
            perimeter  = (*alldataH)(Hallindex).perimeter
            F1    =(*alldataH)(Hallindex).F1
            H     =((*alldataH)(Hallindex).noisebyte and 16)/16;hand-removal noise bit.
            S     =((*alldataH)(Hallindex).noisebyte and 8)/8;  because vectors like [1,1,1,0,0,***,0,1,1,0,0]
            T     =((*alldataH)(Hallindex).noisebyte and 4)/4
            D     =((*alldataH)(Hallindex).noisebyte and 2)/2
            N     =((*alldataH)(Hallindex).noisebyte and 1)
            ;******************************************************************************
            ;stop
            ;******************************************************************************
            ;*****************************************************************************
            ;**************************************************
            junk=where(w8_t eq 0 and L1n gt 0 ,contzero)
            if contzero gt 0 then begin
                Wmessage='Warning !There"re '+strtrim(contzero,2)+' cases intra-particle-w8-time is 0 and L1n gt 0 !'
                ;junk=dialog_message(Wmessage,/information)
            endif
            ; stop
            ;*****************************************************************************************
            if !infocus_on eq 0 then begin
                if strlen(ave_info.criteria.text) lt 4 then begin
                    mystring="Localindex=where(L1n gt 0 and reject eq 0,LocCont)"
                endif else begin
                    mystring="Localindex=where((L1n gt 0 and reject eq 0) and ("+ave_info.criteria.text+"),LocCont)"
                endelse
            endif

            if !infocus_on eq 1 then begin
                if strlen(ave_info.criteria.text) lt 4 then begin
                    mystring="Localindex=where(L1n gt 0 and reject eq 0 and focus gt !focuspercent, LocCont)"
                endif else begin
                    mystring="Localindex=where((L1n gt 0 and reject eq 0) and focus gt !focuspercent and ("+ave_info.criteria.text+"),LocCont)"
                endelse
            endif


            result=execute(mystring)
            ;stop
            result=where((*alldataH)(Hallindex).L1n gt 0.0 and (*alldataH)(Hallindex).reject eq 0, total_valid_particles)
            if LocCont gt 0 then begin ; there are particles satisfy the criteria
                Hsubindex=Hallindex(Localindex)
                total_valid_subset_particles=n_elements(Hsubindex)
                if total_valid_particles ge 1.0 then begin
                    Hfactor=float(total_valid_subset_particles)/float(total_valid_particles)
                endif else begin
                    Hfactor=0.0
                endelse

            endif else begin ;end of if LocCont gt 0
                Hsubindex=-1
                Hfactor=0.0
            endelse
            ;end of if LocCont eq 0
        endif else begin ; end of if contG gt 0.
            Hsubindex=-1
            Hfactor=0.0
        endelse

        ;end of if contG eq 0
    endif else begin; end of ave_info.criteria.on eq 1
        if !infocus_on eq 0 then begin
            Hfactor=1.0;      Hsubindex=Hallindex
            Hsubindex=where((*alldataH).nanoseconds gt ave_info.startnanoseconds and $
                (*alldataH).nanoseconds le ave_info.endnanoseconds and $
                (*alldataH).L1n gt 0 and (*alldataH).reject eq 0)
        endif

        if !infocus_on eq 1 then begin
            ;firsr get all acceptable particles' count, no matter what focus value.
            junk=where((*alldataH).nanoseconds gt ave_info.startnanoseconds and $
                (*alldataH).nanoseconds le ave_info.endnanoseconds and $
                (*alldataH).L1n gt 0 and (*alldataH).reject eq 0,count_all_accepted)
            focus = (*alldataH).focus
            Hsubindex=where((*alldataH).nanoseconds gt ave_info.startnanoseconds and $
                (*alldataH).nanoseconds le ave_info.endnanoseconds and $
                (*alldataH).L1n gt 0 and (*alldataH).reject eq 0 and focus gt !focuspercent)
            Hfactor=float(count_all_accepted)/(n_elements(Hsubindex))
        endif

    endelse

    ;further get rid of bad particles particles which has L2=L4=L5 and has neighbours
    ; get_rid_of_bad_Hparticles,Hsubindex, Hgoodindex
    ; if Hgoodindex(0) ne -1 then Hk=float(n_elements(Hsubindex))/float(n_elements(Hgoodindex)) else Hk=0.0
    ave_info.Hallindex=ptr_new(Hallindex)
    ave_info.Hsubindex=ptr_new(Hsubindex)

    ;get the V indexs
    ;***************************************************************************

    ;Vallindex=where((*alldataV).nanoseconds gt ave_info.startnanoseconds and $
    ;                (*alldataV).nanoseconds le ave_info.endnanoseconds,contG)


    if(round_flag eq 2) then begin ; show only not round particles
        Vallindex=where((*alldataV).nanoseconds gt ave_info.startnanoseconds and $
            (*alldataV).nanoseconds le ave_info.endnanoseconds and $
            not ((*alldataV).Roundness1 gt !Roundness1_min and $
            (*alldataV).Roundness1 lt !Roundness1_max and $
            (*alldataV).Roundness1 gt !Roundness2_min and $
            (*alldataV).Roundness2 lt !Roundness2_max and $
            (*alldataV).Roundness3 gt !Roundness3_min and $
            (*alldataV).Roundness3 lt !Roundness3_max) $
            , contG)
    endif else if(round_flag eq 1) then begin ; show only round particles
        Vallindex=where((*alldataV).nanoseconds gt ave_info.startnanoseconds and $
            (*alldataV).nanoseconds le ave_info.endnanoseconds and $
            (*alldataV).Roundness1 gt !Roundness1_min and $
            (*alldataV).Roundness1 lt !Roundness1_max and $
            (*alldataV).Roundness1 gt !Roundness2_min and $
            (*alldataV).Roundness2 lt !Roundness2_max and $
            (*alldataV).Roundness3 gt !Roundness3_min and $
            (*alldataV).Roundness3 lt !Roundness3_max $
            , contG)
    endif else begin ; don't worry about roundness
        Vallindex=where((*alldataV).nanoseconds gt ave_info.startnanoseconds and $
            (*alldataV).nanoseconds le ave_info.endnanoseconds,contG)
    endelse



    if ave_info.criteria.on eq 1 then begin
        ;*****************************************************
        if contG ge 1 then begin
            ;stop
            L1n=(*alldataV)(Vallindex).L1n
            L2=(*alldataV)(Vallindex).L2
            L3=1.8*(*alldataV)(Vallindex).L3
            L4=(*alldataV)(Vallindex).L4
            L5=(*alldataV)(Vallindex).L5
            L7=(*alldataV)(Vallindex).L7
            PC1=(*alldataV)(Vallindex).PC1
            PC3x=(*alldataV)(Vallindex).PC3x
            PC3y=(*alldataV)(Vallindex).PC3y
            PC4x=(*alldataV)(Vallindex).PC4x
            PC4y=(*alldataV)(Vallindex).PC4y
            Area=(*alldataV)(Vallindex).Area
            A3  =(*alldataV)(Vallindex).A3
            Alexei1=(*alldataV)(Vallindex).alexei1
            reject =(*alldataV)(Vallindex).reject
            w8_t   =(*alldataV)(Vallindex).w8_t
            focus = (*alldataV)(Vallindex).focus
            roundness=(*alldataV)(Vallindex).roundness
            roundness1=(*alldataV)(Vallindex).roundness1
            roundness2=(*alldataV)(Vallindex).roundness2
            roundness3=(*alldataV)(Vallindex).roundness3
            L1r        = (*alldataV)(Vallindex).L1r
            maxLength  = (*alldataV)(Vallindex).maxLength
            maxWidth   = (*alldataV)(Vallindex).maxWidth
            perimeter  = (*alldataV)(Vallindex).perimeter
            F1    =(*alldataV)(Vallindex).F1
            H     =((*alldataV)(Vallindex).noisebyte and 16)/16;hand-removal noise bit.
            S     =((*alldataV)(Vallindex).noisebyte and 8)/8;  because vectors like [1,1,1,0,0,***,0,1,1,0,0]
            T     =((*alldataV)(Vallindex).noisebyte and 4)/4
            D     =((*alldataV)(Vallindex).noisebyte and 2)/2
            N     =((*alldataV)(Vallindex).noisebyte and 1)
            ;*****************************************************************************
            ;*****************************************************************************
            ;*****************************************************************************
            ;****************************************
            junk=where(w8_t eq 0 and L1n gt 0 ,contzero)
            if contzero gt 0 then begin
                Wmessage='Warning !There"re '+strtrim(contzero,2)+' cases intra-particle-w8-time is 0 and L1n gt 0!'
                ; junk=dialog_message(Wmessage,/information)
            endif
            ;*************************************
            ;stop
            if !infocus_on eq 0 then begin
                if strlen(ave_info.criteria.text) lt 4 then begin
                    mystring="Localindex=where(L1n gt 0 and reject eq 0,LocCont)" ;reject=0 means it is good.
                endif else begin
                    mystring="Localindex=where((L1n gt 0 and reject eq 0) and ("+ave_info.criteria.text+"),LocCont)"
                endelse
            endif

            if !infocus_on eq 1 then begin
                if strlen(ave_info.criteria.text) lt 4 then begin
                    mystring="Localindex=where(L1n gt 0 and reject eq 0 and focus gt !focuspercent,LocCont)" ;reject=0 means it is good.
                endif else begin
                    mystring="Localindex=where((L1n gt 0 and reject eq 0) and focus gt !focuspercent and ("+ave_info.criteria.text+"),LocCont)"
                endelse
            endif


            result=execute(mystring)
            result=where((*alldataV)(Vallindex).L1n gt 0.0 and (*alldataV)(Vallindex).reject eq 0,total_valid_particles)

            if LocCont gt 0 then begin ; there are particles satisfy the criteria
                Vsubindex=Vallindex(Localindex)
                total_valid_subset_particles=n_elements(Vsubindex)
                if total_valid_particles ge 1.0 then begin
                    Vfactor=float(total_valid_subset_particles)/float(total_valid_particles)
                endif else begin
                    Vfactor=0.0
                endelse
            endif else begin ;end of if LocCont gt 0
                Vsubindex=-1
                Vfactor=0.0
            endelse
            ;end of if LocCont eq 0
        endif else begin ; end of if contG gt 0.
            Vsubindex=-1
            Vfactor=0.0
        endelse

        ;end of if contG eq 0
    endif else begin  ; end of ave_info.criteria.on eq 1
        if !infocus_on eq 0 then begin
            Vfactor=1.0;   ; Vsubindex=Vallindex
            Vsubindex=where((*alldataV).nanoseconds gt ave_info.startnanoseconds and $
                (*alldataV).nanoseconds le ave_info.endnanoseconds and $
                (*alldataV).L1n gt 0 and (*alldataV).reject eq 0)
        endif

        if !infocus_on eq 1 then begin
            ;first get all acceptable particles' count, no matter what focus value.
            junk=where((*alldataV).nanoseconds gt ave_info.startnanoseconds and $
                (*alldataV).nanoseconds le ave_info.endnanoseconds and $
                (*alldataV).L1n gt 0 and (*alldataV).reject eq 0,count_all_accepted)

            focus = (*alldataV).focus
            Vsubindex=where((*alldataV).nanoseconds gt ave_info.startnanoseconds and $
                (*alldataV).nanoseconds le ave_info.endnanoseconds and $
                (*alldataV).L1n gt 0 and (*alldataV).reject eq 0 and focus gt !focuspercent)

            Vfactor=float(count_all_accepted)/(n_elements(Vsubindex) >1)
        endif

    endelse;  end of ave_info.criteria.on eq 0
    ;*************************************************************

    ;get_rid_of_bad_Vparticles,Vsubindex, Vgoodindex
    ;if Vgoodindex(0) ne -1 then Vk=float(n_elements(Vsubindex))/float(n_elements(Vgoodindex)) else Vk=0.0
    ave_info.criteria.Hfactor=Hfactor;*Hk
    ave_info.criteria.Vfactor=Vfactor;*Vk

    ave_info.Vallindex=ptr_new(Vallindex)
    ave_info.Vsubindex=ptr_new(Vsubindex)

    if ave_info.criteria.on eq 1 then begin
        if strlen(ave_info.criteria.text) gt 4 then begin
            ave_info.criteria.label='criteria='+ave_info.criteria.text
        endif else ave_info.criteria.label='criteria=none'
    endif else begin
        ave_info.criteria.label='criteria=None'
    endelse

    ;stop
end;   ;end of get_allindex_and_boolean_subsetindex_clean.pro
;***************************************************************

;**************************************************************************
;***************************************************************************
pro get_method2adjvalues_of_Normal,HorV,Lsizes,F1,adj2
    dww = !DWW_main; 63.0mm in 2D-S, 50.8 mm in 3V-CPI adjust in a3VCPIView.pro
    ;    here Lsizes is L4; Lsizes has to be in unit pixels.
    if strupcase(HorV) eq 'H' then microns_per_pixel=!microns_per_pixelH else  microns_per_pixel=!microns_per_pixelV
    pxs=MICRONS_PER_PIXEL/1000.0
    SAdefault =128.0D*pxs*dww; in mm^2.
    pxs_squared=pxs*pxs; mm^2
    ;dof=(5.13*Lsizes*Lsizes*pxs_squared)*1000.0;  unit=mm
    if !infocus_on eq 1 then begin
        if !focuspercent eq 0.7 then dof=(4.41*Lsizes*Lsizes*pxs_squared)*1000.0;  unit=mm
        if !focuspercent eq 0.8 then dof=(3.61*Lsizes*Lsizes*pxs_squared)*1000.0;  unit=mm
        if !focuspercent eq 0.9 then dof=(2.07*Lsizes*Lsizes*pxs_squared)*1000.0;  unit=mm
    endif else dof=(5.13*Lsizes*Lsizes*pxs_squared)*1000.0;  unit=mm
    SA2actual  =(127.0-Lsizes)*pxs*(dof < dww)
    index=where(Lsizes eq 127 or Lsizes eq 0.0 or (F1 and 3) ne 0,contG)
    if contG gt 0 then SA2actual(index)=-1.0
    adj2=SAdefault/SA2actual
    indexn=where(SA2actual le 0.0,contG)
    if contG gt 0 then adj2(indexn)=0.0
end; end of get_method2adjvalues_of_normal,HorV,Lsizes,F1,adj2
;**************************************************************************************
;***************************************************************************
pro get_method2adjvalues_of_M6,HorV,Lsizes,F1,adj2
    dww = !DWW_main; 63.0mm in 2D-S, 50.8 mm in 3V-CPI adjust in a3VCPIView.pro
    ;    here Lsizes is L4; Lsizes has to be in unit pixels.
    if strupcase(HorV) eq 'H' then microns_per_pixel=!microns_per_pixelH else  microns_per_pixel=!microns_per_pixelV
    pxs=MICRONS_PER_PIXEL/1000.0
    SAdefault =128.0D*pxs*dww; in mm^2.
    pxs_squared=pxs*pxs; mm^2
    ;dof=(5.13*Lsizes*Lsizes*pxs_squared)*1000.0;  unit=mm
    if !infocus_on eq 1 then begin
        if !focuspercent eq 0.7 then dof=(4.41*Lsizes*Lsizes*pxs_squared)*1000.0;  unit=mm
        if !focuspercent eq 0.8 then dof=(3.61*Lsizes*Lsizes*pxs_squared)*1000.0;  unit=mm
        if !focuspercent eq 0.9 then dof=(2.07*Lsizes*Lsizes*pxs_squared)*1000.0;  unit=mm
    endif else dof=(2.07*Lsizes*Lsizes*pxs_squared)*1000.0;  unit=mm
    SA2actual  =(127.0-Lsizes)*pxs*(dof < dww)
    index=where(Lsizes eq 127 or Lsizes eq 0.0 or (F1 and 3) ne 0,contG)
    if contG gt 0 then SA2actual(index)=-1.0
    adj2=SAdefault/SA2actual
    indexn=where(SA2actual le 0.0,contG)
    if contG gt 0 then adj2(indexn)=0.0
end; end of get_method2adjvalues_of_M6,HorV,Lsizes,F1,adj2
;**************************************************************************************
pro get_method3adjvalues,HorV,Lsizes,F1,adj3
    dww = !DWW_main; 63.0mm in 2D-S, 50.8 mm in 3V-CPI adjust in a3VCPIView.pro
    ;    here Lsizes is L3, L3 in unit pixels.

    if strupcase(HorV) eq 'H' then microns_per_pixel=!microns_per_pixelH else  microns_per_pixel=!microns_per_pixelV
    pxs=MICRONS_PER_PIXEL/1000.0

    SAdefault =128.0D*pxs*dww; unit should mm^2.
    min_pxs_strbsz=pxs; mm
    min_pxs_strbsz_squared=min_pxs_strbsz*min_pxs_strbsz; mm^2
    ;dof=(5.13*Lsizes*Lsizes*min_pxs_strbsz_squared)*1000.0; unit=mm; 5.13 is in unit um.
    if !infocus_on eq 1 then begin
        if !focuspercent eq 0.7 then dof=(4.41*Lsizes*Lsizes*min_pxs_strbsz_squared)*1000.0;  unit=mm
        if !focuspercent eq 0.8 then dof=(3.61*Lsizes*Lsizes*min_pxs_strbsz_squared)*1000.0;  unit=mm
        if !focuspercent eq 0.9 then dof=(2.07*Lsizes*Lsizes*min_pxs_strbsz_squared)*1000.0;  unit=mm
    endif else dof=(5.13*Lsizes*Lsizes*min_pxs_strbsz_squared)*1000.0;  unit=mm
    SA3actual  =(127.0-Lsizes)*pxs*(dof < dww)
    index=where(Lsizes eq 127 or (F1 and 3) ne 0 or Lsizes eq 0.0, contG);  remember these
    if contG gt 0 then SA3actual(index)=-1.0;          values whose adj should be zero.
    adj3=SAdefault/SA3actual
    indexn=where(SA3actual le 0.0,contG)
    if contG gt 0 then adj3(indexn)=0.0
end; end of get_method3adjvalues,HorV,Lsizes,F1,adj3

pro get_method4adjvalues,HorV,Lsizes,F1,adj4
    dww = !DWW_main; 63.0mm in 2D-S, 50.8 mm in 3V-CPI adjust in a3VCPIView.pro
    ;    here Lsizes is L7, L7 in unit pixels.

    if strupcase(HorV) eq 'H' then microns_per_pixel=!microns_per_pixelH else  microns_per_pixel=!microns_per_pixelV
    pxs=MICRONS_PER_PIXEL/1000.0
    SAdefault =128.0D*pxs*dww; unit should mm^2.

    min_pxs_strbsz_squared=pxs*pxs; mm^2
    ; dof=(5.13*Lsizes*Lsizes*min_pxs_strbsz_squared)*1000.0; unit=mm; 5.13 is in unit um.
    if !infocus_on eq 1 then begin
        if !focuspercent eq 0.7 then dof=(4.41*Lsizes*Lsizes*min_pxs_strbsz_squared)*1000.0;  unit=mm
        if !focuspercent eq 0.8 then dof=(3.61*Lsizes*Lsizes*min_pxs_strbsz_squared)*1000.0;  unit=mm
        if !focuspercent eq 0.9 then dof=(2.07*Lsizes*Lsizes*min_pxs_strbsz_squared)*1000.0;  unit=mm
    endif else dof=(5.13*Lsizes*Lsizes*min_pxs_strbsz_squared)*1000.0;  unit=mm
    SA4actual  =(127.0-Lsizes)*pxs*(dof < dww)
    index = where(Lsizes eq 127 or (F1 and 3) ne 0 or Lsizes eq 0.0, contG)
    if contG gt 0 then SA4actual(index)=-1.0
    adj4=SAdefault/SA4actual
    indexn=where(SA4actual le 0.0,contG)
    if contG gt 0 then adj4(indexn)=0.0
end; end of get_method4adjvalues,HorV,Lsizes,F1,adj4

pro get_method7adjvalues,HorV,Lsizes,maxlength,F1,adj7
    dww=!DWW_main; 63.0mm in 2D-S, 50.8 mm in 3V-CPI adjust in a3VCPIView.pro  here Lsizes is L5; Lsizes has to be in unit pixels.
    SAdefault =128.0D*0.01*dww; in mm^2.
    pxs_H=0.01; mm
    pxs_V=0.01;mm
    strbsz=0.01;mm
    if HorV eq 'H' then pxs=pxs_H else pxs=pxs_V
    pxs_squared=pxs*pxs; mm^2
    ;dof=(5.13*Lsizes*Lsizes*pxs_squared)*1000.0;  unit=mm
    if !infocus_on eq 1 then begin
        if !focuspercent eq 0.7 then dof=(4.41*maxlength*maxlength*pxs_squared)*1000.0;  unit=mm
        if !focuspercent eq 0.8 then dof=(3.61*maxlength*maxlength*pxs_squared)*1000.0;  unit=mm
        if !focuspercent eq 0.9 then dof=(2.07*maxlength*maxlength*pxs_squared)*1000.0;  unit=mm
    endif else dof=(5.13*maxlength*maxlength*pxs_squared)*1000.0;  unit=mm

    SA2actual  =(127.0-Lsizes)*pxs*(dof < dww);   here Lszies should be L5. effective size relative the the 128 diodes.

    index=where(Lsizes eq 127 or Lsizes eq 0.0 or (F1 and 3) ne 0,contG);  remove particel touching the edges.
    if contG gt 0 then SA2actual(index)=-1.0
    adj7=SAdefault/SA2actual
    indexn=where(SA2actual le 0.0,contG)
    if contG gt 0 then adj7(indexn)=0.0
end; end of get_method7adjvalues,HorV,Lsizes,maxlength,F1,adj2
;**************************************************************************************


pro get_method6adjvalues,HorV,Lsizes,F1,adj2;  added Dec 11, 2006.
    dww = !DWW_main; 63.0mm in 2D-S, 50.8 mm in 3V-CPI adjust in a3VCPIView.pro
    ;    here Lsizes is L4; Lsizes has to be in unit pixels.

    if strupcase(HorV) eq 'H' then microns_per_pixel=!microns_per_pixelH else  microns_per_pixel=!microns_per_pixelV
    pxs=MICRONS_PER_PIXEL/1000.0
    SAdefault =128.0D*pxs*dww; unit should mm^2.
    pxs_squared=pxs*pxs; mm^2
    ;dof=(5.13*Lsizes*Lsizes*pxs_squared)*1000.0;  unit=mm
    dof=(2.07*Lsizes*Lsizes*pxs_squared)*1000.0;  unit=mm;  this is fou in focus.

    SA2actual  =(127.0-Lsizes)*pxs*(dof < dww)
    index=where(Lsizes eq 127 or (F1 and 3) ne 0 or Lsizes eq 0.0,contG)
    if contG gt 0 then SA2actual(index)=-1.0;   reguires it not touching the edges.
    adj2=SAdefault/SA2actual
    indexn=where(SA2actual le 0.0,contG)
    if contG gt 0 then adj2(indexn)=0.0
end; end of get_method6adjvalues,HorV,Lsizes,F1,adj2

;*******************************************************************************
;***************************************************************************
pro get_method1adjvalues_of_Normal,HorV,Lsizes,F1,adj1;  added Dec 17, 2006.
    dww = !DWW_main; 63.0mm in 2D-S, 50.8 mm in 3V-CPI adjust in a3VCPIView.pro
    ;    here Lsizes is L1; Lsizes has to be in unit pixels.for Normal M1.

    if strupcase(HorV) eq 'H' then microns_per_pixel=!microns_per_pixelH else  microns_per_pixel=!microns_per_pixelV

    pxs=MICRONS_PER_PIXEL/1000.0
    SAdefault =128.0D*pxs*dww; in mm^2.
    pxs_squared=pxs*pxs; mm^2
    dof=(5.13*Lsizes*Lsizes*pxs_squared)*1000.0;  unit=mm;   that is chris's adj1
    ; dof=(2.07*Lsizes*Lsizes*pxs_squared)*1000.0;  unit=mm

    SA1actual  =(127.0+Lsizes)*pxs*(dof < dww)
    index=where(Lsizes eq 0.0,contG)
    if contG gt 0 then SA1actual(index)=-1.0
    adj1=SAdefault/SA1actual
    indexn=where(SA1actual le 0.0,contG)
    if contG gt 0 then adj1(indexn)=0.0
end; end of get_method1adjvalues_of_Normal,HorV,Lsizes,F1,adj1
;***************************************************************************
pro get_method1adjvalues_of_M6,HorV,Lsizes,F1,adj1;  added Dec 17, 2006.
    dww = !DWW_main; 63.0mm in 2D-S, 50.8 mm in 3V-CPI adjust in a3VCPIView.pro
    ;    here Lsizes is L1; Lsizes has to be in unit pixels.for Method6's M1
    if strupcase(HorV) eq 'H' then microns_per_pixel=!microns_per_pixelH else  microns_per_pixel=!microns_per_pixelV
    pxs=MICRONS_PER_PIXEL/1000.0
    SAdefault =128.0D*pxs*dww; unit should mm^2.

    pxs_squared=pxs*pxs; mm^2
    ; dof=(5.13*Lsizes*Lsizes*pxs_squared)*1000.0;  unit=mm;   that is chris's adj1
    dof=(2.07*Lsizes*Lsizes*pxs_squared)*1000.0;  unit=mm

    SA1actual  =(127.0+Lsizes)*pxs*(dof < dww)
    index=where(Lsizes eq 0.0,contG)
    if contG gt 0 then SA1actual(index)=-1.0
    adj1=SAdefault/SA1actual
    indexn=where(SA1actual le 0.0,contG)
    if contG gt 0 then adj1(indexn)=0.0
end; end of get_method1adjvalues,HorV,Lsizes,F1,adj1

;*******************************************************************************

pro get_rid_of_bad_Hparticles,subindex0,goodHindex
    Common  DataBlock,alldataH,alldataV,ADataH,ADataV,FirstData,LastData,StripData,$
        FirstDataV,LastDataV,StripDataV,avestripdata,avestripdataV

    HnnnM1=n_elements((*alldataH).L1n)-1LL
    if subindex0(0) eq -1 then begin
        goodHindex=[-1]
        return
    endif
    L2=(*alldataH)(subindex0).L2
    L4=(*alldataH)(subindex0).L4
    L5=(*alldataH)(subindex0).L5
    index=where( L2 eq L4 and L2 eq L5,contG)
    if contG eq 0 then goodHindex=subindex0
    if contG gt 1 and contG ne n_elements(subindex0) then begin
        psindex=subindex0(index);  possible bad particle's index.
        subindex=subindex0;  subindex will be  changed as we are geting rid of some bad ones.
        for i =0,contG-1 do begin
            this_particle_index=psindex(i)
            this_PC1 =(*alldataH)(this_particle_index).PC1

            pre_index=this_particle_index-1
            while (*alldataH)(pre_index).area le 0.0 and pre_index gt 0 do begin
                pre_index=pre_index-1
            endwhile
            if (*alldataH)(pre_index).L2 eq (*alldataH)(pre_index).L4 and $
                (*alldataH)(pre_index).L2 eq (*alldataH)(pre_index).L5 and $
                (*alldataH)(pre_index).PC1 eq this_PC1 then bad1=1 else bad1=0

            nex_index=this_particle_index+1
            while (*alldataH)(nex_index).area le 0.0 and nex_index lt HnnnM1 do begin
                nex_index=nex_index+1
            endwhile
            if (*alldataH)(nex_index).L2 eq (*alldataH)(nex_index).L4 and $
                (*alldataH)(nex_index).L2 eq (*alldataH)(nex_index).L5 and $
                (*alldataH)(nex_index).PC1 eq this_PC1 then bad2=1 else bad2=0

            if bad1+bad2 gt 0 then begin; this particle is bad.
                index=where(subindex ne this_particle_index);  note that the initial subindex is always biger
                ; than or equal to psindex in number of elements.
                subindex=subindex(index);  get rid of one bad particle.
            endif
        endfor; end of for i=0,contG-1; possible bad particles is less that # of initial subindex
        goodHindex=subindex
    endif
    if contG eq n_elements(subindex0) then goodHindex=[-1]; this means all are bad particles.
end; end of get_rid_of_bad_Hparticles,'H',subindex0, goodindex
;*********************************************************************
;*******************************************************************
;label the spurious particles.
pro  Label_spurious_Hparticles_and_Vparticles
    Common  DataBlock,alldataH,alldataV,ADataH,ADataV,FirstData,LastData,StripData,$
        FirstDataV,LastDataV,StripDataV,avestripdata,avestripdataV
    ;first do labeling the H  bad particles.
    HnnnM1=n_elements((*alldataH) .L1n)-1LL
    index=where((*alldataH).area lt 0.0,contG)
    if contG gt 0 then (*alldataH)(index).reject=1; label fake and deadtime markers are rejcted particles.

    psindex=where((*alldataH).L2 eq (*alldataH).L4 and (*alldataH).L2 eq (*alldataH).L5 and (*alldataH).L2 gt 0, contG); PSble bad-particle index.
    if contG eq 0 then a=0; do nothing; no particles need to be labeled.
    if contG gt 0 then begin
        for i =0LL,contG-1LL do begin
            this_particle_index=psindex(i)
            this_PC1 =(*alldataH)(this_particle_index).PC1

            pre_index=(this_particle_index-1LL) > 0
            while (*alldataH)(pre_index).area le 0.0 and pre_index gt 0 do begin
                pre_index=pre_index-1
            endwhile
            if (*alldataH)(pre_index).L2 eq (*alldataH)(pre_index).L4 and (*alldataH)(pre_index).L2 gt 0 and $
                (*alldataH)(pre_index).L2 eq (*alldataH)(pre_index).L5 and (*alldataH)(pre_index).PC1 eq this_PC1 $
                then bad1=1 else bad1=0

            nex_index=this_particle_index+1 <HnnnM1
            while (*alldataH)(nex_index).area le 0.0 and nex_index lt HnnnM1 do begin
                nex_index=nex_index+1
            endwhile
            if (*alldataH)(nex_index).L2 eq (*alldataH)(nex_index).L4 and (*alldataH)(nex_index).L2 gt 0 and $
                (*alldataH)(nex_index).L2 eq (*alldataH)(nex_index).L5 and (*alldataH)(nex_index).PC1 eq this_PC1 $
                then bad2=1 else bad2=0

            if bad1+bad2 gt 0 then (*alldataH)(this_particle_index).reject=1; this particle is bad.
        endfor; end of for i=0,contG-1; possible bad particles is less that # of initial subindex
    endif; end if contG gt 0.
    ;second do labeling the V  bad particles.
    VnnnM1=n_elements((*alldataV).L1n)-1LL
    index=where((*alldataV).area lt 0.0,contG)
    if contG gt 0 then (*alldataV)(index).reject=1; label fake and deadtime markers are rejcted particles.

    psindex=where((*alldataV).L2 eq (*alldataV).L4 and (*alldataV).L2 eq (*alldataV).L5 and (*alldataV).L2 gt 0, contG); PSble bad-particle index.
    if contG eq 0 then a=0; do nothing; no particles need to be labeled.
    if contG gt 0 then begin
        for i =0LL,contG-1LL do begin
            this_particle_index=psindex(i)
            this_PC1 =(*alldataV)(this_particle_index).PC1

            pre_index=(this_particle_index-1LL) > 0
            while (*alldataV)(pre_index).area le 0.0 and pre_index gt 0 do begin
                pre_index=pre_index-1
            endwhile
            if (*alldataV)(pre_index).L2 eq (*alldataV)(pre_index).L4 and (*alldataV)(pre_index).L2 gt 0 and $
                (*alldataV)(pre_index).L2 eq (*alldataV)(pre_index).L5 and (*alldataV)(pre_index).PC1 eq this_PC1 $
                then bad1=1 else bad1=0

            nex_index=this_particle_index+1
            while (*alldataV)(nex_index).area le 0.0 and nex_index lt VnnnM1 do begin
                nex_index=nex_index+1
            endwhile
            if (*alldataV)(nex_index).L2 eq (*alldataV)(nex_index).L4 and (*alldataV)(nex_index).L2 gt 0 and $
                (*alldataV)(nex_index).L2 eq (*alldataV)(nex_index).L5 and (*alldataV)(nex_index).PC1 eq this_PC1 $
                then bad2=1 else bad2=0

            if bad1+bad2 gt 0 then (*alldataV)(this_particle_index).reject=1; this particle is bad.

        endfor; end of for i=0,contG-1; possible bad particles is less that # of initial subindex
    endif; end if contG gt 0; for V particles
    ; stop
end; end of Label_spurious_Particles.
;*******************************************************************
pro plot_HV_particle_enter_pixels_distrubution,norm1,norm2,norm3,norm4,norm5
    Common  DataBlock,alldataH,alldataV,ADataH,ADataV,FirstData,LastData,StripData,$
        FirstDataV,LastDataV,StripDataV,avestripdata,avestripdataV
    index=where((*alldataH).L2 eq 1 and (*alldataH).L4 eq 1 and (*alldataH).L5 eq 1, contG1)
    if contG1 gt 0 then Pc1=(*alldataH)(index).PC1 else Pc1=[-1,-1]
    H1=histogram(Pc1,binsize=1,min=0,max=127)
    xxx1=indgen(n_elements(H1))
    ymin1=min(H1,max=ymax1)

    index=where((*alldataH).L2 eq 2 and (*alldataH).L4 eq 2 and (*alldataH).L5 eq 2, contG2)
    if contG2 gt 0 then Pc1=(*alldataH)(index).PC1 else Pc1=[-1,-1]
    H2=histogram(Pc1,binsize=1,min=0,max=127)
    xxx2=indgen(n_elements(H2))
    ymin2=min(H2,max=ymax2)

    index=where((*alldataH).L2 eq 3 and (*alldataH).L4 eq 3 and (*alldataH).L5 eq 3, contG3)
    if contG3 gt 0 then Pc1=(*alldataH)(index).PC1 else Pc1=[-1,-1]
    H3=histogram(Pc1,binsize=1,min=0,max=127)
    xxx3=indgen(n_elements(H3))
    ymin3=min(H3,max=ymax3)

    index=where((*alldataH).L2 eq 4 and (*alldataH).L4 eq 4 and (*alldataH).L5 eq 4, contG4)
    if contG4 gt 0 then Pc1=(*alldataH)(index).PC1 else Pc1=[-1,-1]
    H4=histogram(Pc1,binsize=1,min=0,max=127)
    xxx4=indgen(n_elements(H4))
    ymin4=min(H4,max=ymax4)


    index=where((*alldataH).L2 eq (*alldataH).L4 and (*alldataH).L4 eq (*alldataH).L5 and (*alldataH).L2 gt 0, contGe)
    if contGe gt 0 then Pc1=(*alldataH)(index).PC1 else Pc1=[-1,-1]
    He=histogram(Pc1,binsize=1,min=0,max=127)
    xxxe=indgen(n_elements(He))
    ymine=min(He, max=ymaxe)

    ;finding out index that is  (not(L2=L4=L5 and L2 gt 0)) and (L2 gt 0)

    index=where(((*alldataH).area gt 0) and not( (*alldataH).L2 eq (*alldataH).L4 and $
        (*alldataH).L4 eq (*alldataH).L5 and $
        (*alldataH).L2 gt 0 ), contGn)
    if contGn gt 0 then Pc1=(*alldataH)(index).PC1 else Pc1=[-1,-1]
    Hn=histogram(Pc1,binsize=1,min=0,max=127)
    xxxn=indgen(n_elements(Hn))
    yminn=min(Hn, max=ymaxn)

    !X.tickname=['0','16','32','48','64','80','96','112','128']
    !X.ticks=8
    whitecolor = GetColor("White", !D.Table_Size-2)
    bluecolor = GetColor("Navy", !D.Table_Size-2)
    REDcolor = GetColor("RED", !D.Table_Size-2)
    Xrange_AB=[0,127]

    window,/free,xsize=72*12,ysize=72*10,title='H L2=L4=L5=1 PC1 distribution'
    !P.multi=[0,3,2]
    !P.charsize=2.0

    Yrange_AB=[ymin1,ymax1]
    PLOT,xxx1,H1, COLOR=redColor, XRANGE=xrange_AB, YTITLE='Counts',Xstyle = 1,$
        TITLE='H L2=L4=L5=1 PC1 distribution  N='+strtrim(contG1,2),YRANGE=yrange_AB,$
        pos=[0.08,0.68,0.47,0.95],xmargin=[3,1],xtitle=' ',YSTYLE=1,background= whitecolor
    index=sort(H1)
    max3=index(124:127)
    oplot,xxx1(max3),H1(max3),color=bluecolor,psym=2
    xyouts,150,660,'max_y1:  Pc='+strtrim(xxx1(max3(0)),2),color=bluecolor,charsize=1.0,/device
    xyouts,150,645,'max_y2:  Pc='+strtrim(xxx1(max3(1)),2),color=bluecolor,charsize=1.0,/device
    xyouts,150,630,'max_y3:  Pc='+strtrim(xxx1(max3(2)),2),color=bluecolor,charsize=1.0,/device
    xyouts,150,615,'max_y4:  Pc='+strtrim(xxx1(max3(3)),2),color=bluecolor,charsize=1.0,/device
    ;end of plot 1 of 6 ***********************************************************************************

    Yrange_AB=[ymin4,ymax4]
    PLOT, xxx4, H4, COLOR=redColor, XRANGE=XRANGE_AB, Xstyle = 1,$
        TITLE='H L2=L4=L5=4 PC1 distribution  N='+strtrim(contG4,2),YRANGE=yrange_AB,$
        pos=[0.53,0.68,0.93,0.95],xmargin=[2,1],Yticks=6,Ytickn=[' ',' '],background= whitecolor
    axis,yaxis=1,YTITLE='counts',ystyle=1,yrange=yrange_AB
    index=sort(H4)
    max3=index(124:127)
    oplot,xxx4(max3),H4(max3),color=bluecolor,psym=2
    xyouts,550,660,'max_y1:  Pc='+strtrim(xxx4(max3(0)),2),color=bluecolor,charsize=1.0,/device
    xyouts,550,645,'max_y2:  Pc='+strtrim(xxx4(max3(1)),2),color=bluecolor,charsize=1.0,/device
    xyouts,550,630,'max_y3:  Pc='+strtrim(xxx4(max3(2)),2),color=bluecolor,charsize=1.0,/device
    xyouts,550,615,'max_y4:  Pc='+strtrim(xxx4(max3(3)),2),color=bluecolor,charsize=1.0,/device
    ;end of plot 2 of 6 ***********************************************************************************

    Yrange_AB=[ymin2,ymax2]
    PLOT, xxx2, H2, COLOR=redColor, XRANGE=XRANGE_AB, YTITLE='Counts',Xstyle = 1,$
        TITLE='H L2=L4=L5=2 PC1 distribution  N='+strtrim(contG2,2),YRANGE=yrange_AB,background= whitecolor,$
        pos=[0.08,0.40,0.47,0.62],xmargin=[3,1],YSTYLE=1
    index=sort(H2)
    max3=index(124:127)
    oplot,xxx2(max3),H2(max3),color=bluecolor,psym=2
    xyouts,150,420,'max_y1:  Pc='+strtrim(xxx2(max3(0)),2),color=bluecolor,charsize=1.0,/device
    xyouts,150,405,'max_y2:  Pc='+strtrim(xxx2(max3(1)),2),color=bluecolor,charsize=1.0,/device
    xyouts,150,390,'max_y3:  Pc='+strtrim(xxx2(max3(2)),2),color=bluecolor,charsize=1.0,/device
    xyouts,150,375,'max_y4:  Pc='+strtrim(xxx2(max3(3)),2),color=bluecolor,charsize=1.0,/device
    ;end of plot 3 of 6 ***********************************************************************************

    Yrange_AB=[ymine,ymaxe]
    PLOT, xxxe, He, COLOR=redColor, XRANGE=XRANGE_AB, Xstyle = 1,$
        TITLE='H L2=L4=L5>0 PC1 distribution  N='+strtrim(contGe,2),YRANGE=yrange_AB,$
        pos=[0.53,0.40,0.93,0.62],xmargin=[2,1],Yticks=6,Ytickn=[' ',' '],background= whitecolor
    axis,yaxis=1,YTITLE='counts',ystyle=1,yrange=yrange_AB
    index=sort(He)
    max3=index(124:127)
    oplot,xxxe(max3),He(max3),color=bluecolor,psym=2
    xyouts,550,420,'max_y1:  Pc='+strtrim(xxxe(max3(0)),2),color=bluecolor,charsize=1.0,/device
    xyouts,550,405,'max_y2:  Pc='+strtrim(xxxe(max3(1)),2),color=bluecolor,charsize=1.0,/device
    xyouts,550,390,'max_y3:  Pc='+strtrim(xxxe(max3(2)),2),color=bluecolor,charsize=1.0,/device
    xyouts,550,375,'max_y4:  Pc='+strtrim(xxxe(max3(3)),2),color=bluecolor,charsize=1.0,/device
    ;end of plot 4 of 6 ***********************************************************************************

    Yrange_AB=[ymin3,ymax3]
    PLOT, xxx3, H3, COLOR=redColor, XRANGE=XRANGE_AB, YTITLE='Counts',Xstyle = 1,$
        TITLE='H L2=L4=L5=3 PC1 distribution  N='+strtrim(contG3,2),YRANGE=yrange_AB,background= whitecolor,$
        pos=[0.08,0.08,0.47,0.34],xmargin=[3,1],xtitle='Particle"s Center location, Pixels',YSTYLE=1
    index=sort(H3)
    max3=index(124:127)
    oplot,xxx3(max3),H3(max3),color=bluecolor,psym=2
    xyouts,150,225,'max_y1:  Pc='+strtrim(xxx3(max3(0)),2),color=bluecolor,charsize=1.0,/device
    xyouts,150,210,'max_y2:  Pc='+strtrim(xxx3(max3(1)),2),color=bluecolor,charsize=1.0,/device
    xyouts,150,195,'max_y3:  Pc='+strtrim(xxx3(max3(2)),2),color=bluecolor,charsize=1.0,/device
    xyouts,150,180,'max_y4:  Pc='+strtrim(xxx3(max3(3)),2),color=bluecolor,charsize=1.0,/device
    ;end of plot 5 of 6 ***********************************************************************************

    Yrange_AB=[yminn,ymaxn]
    PLOT, xxxn, Hn, COLOR=redColor, XRANGE=XRANGE_AB, Xstyle = 1,$
        TITLE='H L>0 & Not(L2=L4=L5) PC1 distribution N='+strtrim(contGn,2),YRANGE=yrange_AB,background= whitecolor,$
        pos=[0.53,0.08,0.93,0.34],xmargin=[2,1],xtitle='Particle"s Center location, Pixels',YSTYLE=1
    index=sort(Hn)
    max3=index(124:127)
    oplot,xxxn(max3),Hn(max3),color=bluecolor,psym=2
    xyouts,550,225,'max_y1:  Pc='+strtrim(xxxn(max3(0)),2),color=bluecolor,charsize=1.0,/device
    xyouts,550,210,'max_y2:  Pc='+strtrim(xxxn(max3(1)),2),color=bluecolor,charsize=1.0,/device
    xyouts,550,195,'max_y3:  Pc='+strtrim(xxxn(max3(2)),2),color=bluecolor,charsize=1.0,/device
    xyouts,550,180,'max_y4:  Pc='+strtrim(xxxn(max3(3)),2),color=bluecolor,charsize=1.0,/device
    ;end of plot 6 of 6 ***********************************************************************************
    outputfilename=strmid(!currentHFname,0,strlen(!currentHFname)-4)+'PC1_Histogram.png'
    write_png,outputfilename,tvrd(true=1)
    !P.multi=[0,1,1]
    !P.charsize=1.0

end; plot_HV_particle_enter_pixels_distrubution,norm1,norm2,norm3,norm4,norm5
;*************************************************************************
;*********************************************************************************
pro Cleaning_HV_spurious_particle_enter_pixels_distrubution
    Common  DataBlock,alldataH,alldataV,ADataH,ADataV,FirstData,LastData,StripData,$
        FirstDataV,LastDataV,StripDataV,avestripdata,avestripdataV
    allindex=where((*alldataH).area gt 0.0,contall)
    if contall eq 0 then begin
        ;no good particles in this file.
        return
    endif

    index=where((*alldataH).L2 eq 1 and (*alldataH).L4 eq 1 and (*alldataH).L5 eq 1, contG1)
    if contG1 gt 0 then begin; findout if there are bad partilces in this group.
        for i=0, contG1 do begin
            this_particle_index=index(i)
            PC1=(*alldataH)(index(i)).PC1;  this particle's center location.
            Vindex=index(i)

            ;plan to get 200 particles before this particle.
            count=0
            pre_index=(this_particle_index-1LL) > 0
            while count le 200 le 0.0 and pre_index gt 0 do begin
                if (*alldataH)(pre_index).area gt 0.0 then begin
                    count=count+1
                    PC1=[PC1,(*alldataH)(pre_index).PC1]
                    Vindex=[Vindex,pre_index]
                endif
                pre_index=pre_index-1LL
            endwhile

            ;plan to get 200 particles after this particle.
            count=0
            nex_index=this_particle_index+1LL <HnnnM1
            while count lt 200 le 0.0 and nex_index gt HnnnM1 do begin
                if (*alldataH)(nex_index).area gt 0.0 then begin
                    count=count+1
                    PC1=[PC1,(*alldataH)(nex_index).PC1]
                    Vindex=[Vindex,nex_index]
                endif
                nex_index=nex_index+1LL
            endwhile
            ;now we have a vector of 401 length or at least 201 in length or fewer if file don't have much.
            H1=histogram(PC1,binsize=1,min=1,max=127)
            x1=indgen(n_elements(H1))+1
            meanv=mean(H1)
            maxv=max(H1)
            index=where(H1 eq maxV)
            PC1_max=x1(index);  this is the PC1_values that has maximium counts.
            dummy=where(PC1_max eq This_PC1,Match);  if This_PC1 eq one of the PC1_max, then Match=1
            if maxV ge 5.0*meanV and Match gt 0 then begin;  this_PC1 is bad.
                (*alldataH)(this_particle_index).reject =1
            endif ; so far we know if this_PC1 is bad or not.
            if maxV ge 5.0*meanV and Match eq 0 then begin; this_PC1 may still be bad.
                ;take away those maxV particles and find the max again from the remaining set.
            endif
            done=0
            Vector=[1,2,3,4,5,6,9]
            ; while done eq 0 do begin
            ;   meanv=mean(vector)
            ;  maxv=max(vector)
            ; if maxv ge 5.0*meanv then begin
            ;   index=where(vector ne maxv,contG)
            ;  if contG gt 0 then  vector=vector(index) else   done=0
            ;en;dif else begin
            ;     done=1
            ;    endelse
            ;endwhile
        endfor
    endif
end; Cleaning_HV_spurious_particle_center_pixels_distrubution
;*****************************************************************
pro get_IWC_from_adj_n_sizes,total_IWC,alpha,beta,this_adj1,this_sizes,this_area

    ;help, total_IWC, alpha,beta,this_adj1,this_sizes,this_area


    ;if(check_math()) then begin
    ;   help, this_adj1
    ;   print, this_adj1[0]
    ;endif



    ; TAF set flagged negative areas to zero for the total IWC calculations
    temp_area = this_area

    ; TAF set flagged negative areas to zero for the total IWC calculations
    flag_index = where(temp_area lt 0, count)

    if(count gt 0) then begin
        temp_area[flag_index] = 0
    endif
    ;mass1 = alpha * double(this_area_use)^beta ; here sizes in um, area in mm^2 ; sizes is im um.
    mass1=alpha*double(temp_area)^beta; ;here sizes in um, area in mm^2 ; sizes is im um.
    mass2 = 0.917 * (0.1^9.0 * !pi/6.0) * This_sizes^3.0 ; size in um water-mass. milligrams.


    ;if(check_math() gt 0) then begin
    ;   help, mass2
    ;   print, mass2[0]
    ;endif

    mass3=mass1 < mass2;   take the less elements of the two arrays


    ;if(check_math() gt 0) then begin
    ;   help, mass3
    ;   print, mass3[0]
    ;   aaaa = mass1[0] < mass2[0]
    ;   print, "masses 1-3, aaaa", mass1[0], mass2[0], mass3[0], aaaa
    ;endif

    total_IWC=total(this_adj1*mass3);  mass is milligrams.
    ;if total_IWC gt 0.0 then ;stop

    ;help, mass1, mass2, mass3, this_area, this_adj1, total_IWC


end; get_IWC_from_adjand sizes,total_IWC,this_adj1,this_sizes,this_area



pro get_lwcmass_iwcMass_eqDiam,alpha,beta,sizes,areas,lwc_masses,iwc_masses,eqDiam
    mass1=1000.0*alpha*areas^beta; ;here sizes in um, area in mm^2 ; sizes is im um,mass is ug
    lwc_masses=0.917*(0.1^6.0*!pi/6.0)*sizes^3.0; size in um water-mass. ug.
    iwc_masses=mass1 < lwc_masses;   take the less elements of the two arrays
    eqDiam =2.0*(3.0*iwc_masses/(0.917*4.0*!pi))^(1.0/3.0)*100.0; um
    ;mass is milligrams.
end; get_lwcmass_iwcmass,alpha,beta, sizes, areas,



pro get_Icsp_from_adj_n_csp, total_IWC, this_adj1, this_csp , this_sizes
    alpha = 0.135
    beta  = 0.793   ; from Paul and Brad's paper of  Januray 2006-improvement in Determination of ice Water Content JAPMandClimat.

    mass1 = (10.0^(-9.0*beta)) * alpha * double(this_csp)^beta ; here csp in um, area in mm^2 ; sizes is im um.
    mass2 = 0.917*(0.1^9.0*!pi/6.0)*This_sizes^3.0; size in um water-mass. milligrams.
    mass3 =mass1 < mass2

    total_IWC = total(this_adj1 * mass3) ; mass is milligrams.
end ; get_IWC_from_adjand sizes,total_IWC,this_adj1,this_sizes,this_area



pro calculate_wait_time_of_all_HVparticles, HorV
    Common  DataBlock,alldataH,alldataV

    if HorV eq 'H' then begin
        timetk=long64((*alldataH).probecounter)
        area=(*alldataH).area
        Nslice=long64((*alldataH).Nslice)
    endif else begin
        timetk=long64((*alldataV).probecounter)
        area=(*alldataV).area
        Nslice=long64((*alldataV).Nslice)
    endelse

    index=where(area eq -102,contG)
    if contG gt 0 then area(index)=-100
    index=where(area eq -103,contG)
    if contG gt 0 then area(index)=-101

    index=where(area eq -105,contG)
    if contG gt 0 then area(index)=-100
    index=where(area eq -106,contG)
    if contG gt 0 then area(index)=-101

    index=where(area eq -107,contG)
    if contG gt 0 then area(index)=-100
    index=where(area eq -108,contG)
    if contG gt 0 then area(index)=-101

    index=where(area eq -109,contG)
    if contG gt 0 then area(index)=-100
    index=where(area eq -110,contG)
    if contG gt 0 then area(index)=-101
    ;***************************************************************
    ;index=where(area eq -200,contG)
    ; if contG gt 0 then area(index)=-200
    ; index=where(area eq -201,contG)
    ; if contG gt 0 then area(index)=-201

    index=where(area eq -202,contG)
    if contG gt 0 then area(index)=-200
    index=where(area eq -203,contG)
    if contG gt 0 then area(index)=-201

    index=where(area eq -205,contG)
    if contG gt 0 then area(index)=-200
    index=where(area eq -206,contG)
    if contG gt 0 then area(index)=-201

    index=where(area eq -207,contG)
    if contG gt 0 then area(index)=-200
    index=where(area eq -208,contG)
    if contG gt 0 then area(index)=-201

    index=where(area eq -209,contG)
    if contG gt 0 then area(index)=-200
    index=where(area eq -210,contG)
    if contG gt 0 then area(index)=-201

    nnn=n_elements(timetk)
    nnnm1=nnn-1LL
    W8_t=lon64arr(nnn)
    deadtime=0LL;   this is to accumulate deadtime since a good particle is done.
    deadtime_start=timetk(0)
    if n_elements(area) ge 2 then begin
        if area(0) eq -104 then Last_good_particle_time=timetk(1) else Last_good_particle_time=timetk(0)

        for  i=1LL, nnnm1 do begin
            case area(i) of
                -104:  W8_t(i)=0LL;timetk(i)-timetk(i-1)
                -100:  begin
                    W8_t(i) =0LL;timetk(i)-timetk(i-1)
                    deadtime_start=timetk(i)
                end
                -101:  begin
                    W8_t(i) = 0LL;timetk(i)-timetk(i-1)
                    deadtime=deadtime+timetk(i)-deadtime_start;  deadtime+
                end
                -200:  begin ; ignore it; these particles are reject =2 particles.
                    W8_t(i) =0LL
                end
                -201:  begin  ;ignore it; these particles are reject =2 particles.
                    W8_t(i) = 0LL;   there deadtime should not be accummulated.
                end
                else: begin
                    w8_t(i)=timetk(i)-last_good_particle_time-deadtime-Nslice(i)
                    last_good_particle_time=timetk(i)
                    deadtime=0LL
                    deadtime_start=timetk(i);  this line is not necessary, but put in here for sure case.
                end
            endcase
        endfor

        if w8_t(1) lt 0 and area(0) eq -104 then begin
            w8_t(1) =0;  get rid of case time=45s,49.8s,49.83s ...45.1s cases.
        endif

        if HorV eq 'H' then  (*alldataH).w8_t=w8_t else (*alldataV).w8_t=w8_t

        indexmo=where(w8_t eq 0 and area gt 0.0, contmo);   we need to reject this particle also.


        ;if contmo gt 0 then begin
        if 0 then begin; TAF this is detecting the error in 3V-CPI data

            mymessage='Warning ! '+HorV+':there are '+string(contmo)+' W8_t eq 0 and area gt 0.0  !'

            ;if !autoarchive eq 0 then rrr=dialog_message(mymessage,/information)
            ;open a file to write the problematic time periods.
            outputfilename=strmid(!currentHFname,0,strlen(!currentHFname)-4)+'PopUpMessages.txt'
            openw,8,outputfilename,/append
            printf,8,mymessage
            if HorV eq 'H' then begin
                for ii=0LL,contmo-1LL do begin
                    lastindex=(indexmo(ii)+1LL) < (nnn-1LL)
                    printf,8, format='(A,1x,I10,1x,3(F14.1,1x))','Index and 3 Area  :',indexmo(ii),(*alldataH)(indexmo(ii)-1LL:lastindex).area
                    printf,8, format='(A,1x,I10,1x,3(F14.1,1x))','Index and 3 Nslice:',indexmo(ii),(*alldataH)(indexmo(ii)-1LL:lastindex).Nslice
                    printf,8, format='(A,1x,I10,1x,3(I14,1x))',  'Index and 3 Ticks :',indexmo(ii),(*alldataH)(indexmo(ii)-1LL:lastindex).probecounter
                    printf,8, format='(A,1x,I10,1x,3(I14,1x))',  'index and 3 Nanos :',indexmo(ii),(*alldataH)(indexmo(ii)-1LL:lastindex).nanoseconds
                endfor
                (*alldataH)(indexmo).reject=1;  reject all of these particles.
            endif

            if HorV eq 'V' then begin
                for ii=0LL,contmo-1LL do begin
                    lastindex=(indexmo(ii)+1LL) < (nnn-1LL)
                    printf,8, format='(A,1x,I10,1x,3(F14.1,1x))','Index and 3 Area  :',indexmo(ii),(*alldataV)(indexmo(ii)-1LL:lastindex).area
                    printf,8, format='(A,1x,I10,1x,3(F14.1,1x))','Index and 3 Nslice:',indexmo(ii),(*alldataV)(indexmo(ii)-1LL:lastindex).Nslice
                    printf,8, format='(A,1x,I10,1x,3(I14,1x))',  'Index and 3 Ticks :',indexmo(ii),(*alldataV)(indexmo(ii)-1LL:lastindex).probecounter
                    printf,8, format='(A,1x,I10,1x,3(I14,1x))',  'index and 3 Nanos :',indexmo(ii),(*alldataV)(indexmo(ii)-1LL:lastindex).nanoseconds
                endfor
                (*alldataV)(indexmo).reject=1;  reject all of these particles.
            endif

            close,8
        endif;  end of if w8_t=0 and area gt 0.0

        indexmo=where(w8_t lt 0 and area gt 0.0, contmo);  There must be some non-monotonic particles in here.

        ;if contmo gt 0 then begin
        if 0 then begin ; TAF temporary workaround for 3V-CPI files
            mymessage='Warning ! '+HorV+':there are '+string(contmo)+' W8_t less than 0 and area gt 0.0  !'

            ;open a file to write the problematic time periods.
            outputfilename=strmid(!currentHFname,0,strlen(!currentHFname)-4)+'PopUpMessages.txt'
            openw,8,outputfilename,/append
            printf,8,mymessage

            if HorV eq 'H' then begin

                for ii=0LL,contmo-1LL do begin
                    lastindex=(indexmo(ii)+1LL) < (nnn-1LL)
                    printf,8, format='(A,1x,I10,1x,3(F14.1,1x))','Index and 3 Area  :',indexmo(ii),(*alldataH)(indexmo(ii)-1LL:lastindex).area
                    printf,8, format='(A,1x,I10,1x,3(F14.1,1x))','Index and 3 Nslice:',indexmo(ii),(*alldataH)(indexmo(ii)-1LL:lastindex).Nslice
                    printf,8, format='(A,1x,I10,1x,3(I14,1x))',  'Index and 3 Ticks :',indexmo(ii),(*alldataH)(indexmo(ii)-1LL:lastindex).probecounter
                    printf,8, format='(A,1x,I10,1x,3(I14,1x))',  'Index and 3 Nanos :',indexmo(ii),(*alldataH)(indexmo(ii)-1LL:lastindex).nanoseconds
                endfor

                ; now examine and reject the non-monotonic particles and assign warn values.
                for i=0LL,contmo-1LL do begin;  The current Index is one before this index.
                    This_index=indexmo(i);  This is tc
                    ; look for next real event; tc+1
                    done=0
                    indexp1=(This_index+1LL) < nnnm1;  muts use parenthesis.
                    while done eq 0 do begin
                        if ((*alldataH)(indexp1).Nslice gt 0) or (indexp1 eq nnnm1) then done=1 else  indexp1=(indexp1+1LL) < nnnm1
                    endwhile

                    ; look for earlier real event;tc-1
                    done=0
                    indexn1=(This_index-1LL) >0
                    while done eq 0 do begin
                        if ((*alldataH)(indexn1).Nslice gt 0) or (indexn1 eq 0) then done=1 else  indexn1=(indexn1-1LL) >0
                    endwhile

                    ; look for earlier-earlier real event;tc-2
                    done=0
                    indexn2=(indexn1-1LL) >0
                    while done eq 0 do begin
                        if ((*alldataH)(indexn2).Nslice gt 0) or (indexn2 eq 0) then done=1 else  indexn2=(indexn2-1LL) >0
                    endwhile

                    Tcn2=timetk(indexn2)

                    Tcn1=timetk(indexn1)
                    Tcn10=tcn1-Nslice(indexn1)

                    Tc=timetk(this_index)
                    Tc0=Tc-Nslice(This_index)

                    Tcp1=timetk(indexp1)
                    Tcp10=tcp1-Nslice(indexp1)

                    if tcp1 lt Tcn2 then begin;  p1 is this_index plus one.  n2 is this_index minues 2.
                        print,'Strange and trouble -----Report this to mo and brad !!!'
                        ;stop;   Report this to mo and brad.

                        indexb=where((*alldataH).probecounter gt (*alldataH)(this_index).probecounter)
                        ;stop
                        indexG=indexb(0)+LINDGEN(this_index-indexb(0))
                        print,'range=',indexb(0), ' to ', this_index
                        (*alldataH)(indexg).reject=2
                        (*alldataH)(indexg).warn=1
                        (*alldataH)(indexg).Nslice=0
                        (*alldataH)(indexg).L1n=0.0
                        (*alldataH)(indexg).w8_t=0
                        (*alldataH)(indexg).area=(*alldataH)(indexg).area < 0
                        (*alldataH)(indexg).probecounter=(*alldataH)((indexb(0)-1LL)>0).probecounter
                        (*alldataH)(indexg).nanoseconds=(*alldataH)((indexb(0)-1LL)>0).nanoseconds
                        ;stop;   Report this to mo and brad.
                    endif
                    ;case 1, if tc0<=tcn2 or tc>=tcp10 then reject_tc=2 and Nslice_Tc=0
                    case1=tc0 le tcn2 or tc ge tcp10
                    if case1 eq 1 then begin
                        (*alldataH)(this_index).reject=2
                        (*alldataH)(this_index).warn=1
                        (*alldataH)(this_index).Nslice=0
                        (*alldataH)(this_index).L1n=0.0
                        (*alldataH)(this_index).w8_t=0
                        (*alldataH)(this_index).area=(*alldataH)(this_index).area < 0
                        ; (*alldataH)(this_index).probecounter=(*alldataH)(indexn1).probecounter

                        (*alldataH)(indexn1).warn=1
                        (*alldataH)(indexp1).warn=1


                        mymessage='H-Non-monotic time at '+string((*alldataH)(this_index).nanoseconds) + $
                            ' reject=2. index='+strtrim(string(This_index),2)+' HMS ='+SPEC_Nano2HMS((*alldataH)(this_index).nanoseconds)
                        printf,8,mymessage
                    endif; end of case1

                    ;case2; if tc10 <=tcn2 or tcn1 >=tcp10  then reject_tcn1
                    case2=tcn10 le tcn2 or tcn1 ge tcp10
                    if case2 eq 1 then begin
                        (*alldataH)(indexn1).reject=2
                        (*alldataH)(indexn1).warn=1
                        (*alldataH)(indexn1).Nslice=0
                        (*alldataH)(indexn1).L1n=0.0
                        (*alldataH)(indexn1).w8_t=0
                        (*alldataH)(indexn1).area=(*alldataH)(indexn1).area <0
                        ; (*alldataH)(indexn1).probecounter=(*alldataH)(indexn2).probecounter
                        (*alldataH)(this_index).warn=1
                        (*alldataH)(indexn2).warn=1


                        mymessage='H-Non-monotic time at '+string((*alldataH)(indexn1).nanoseconds) + $
                            ' reject=2. index='+strtrim(string(indexn1),2)+' HMS ='+SPEC_Nano2HMS((*alldataH)(indexn1).nanoseconds)
                        printf,8,mymessage
                    endif; end of case 2

                    ;case3; if neither case1 and case2 are satisfied, thne reject_tc=2
                    if case1 eq 0 and case2 eq 0 then begin
                        (*alldataH)(this_index).reject=2
                        (*alldataH)(this_index).warn=1
                        (*alldataH)(this_index).Nslice=0
                        (*alldataH)(this_index).L1n=0.0
                        (*alldataH)(this_index).w8_t=0
                        (*alldataH)(this_index).area=(*alldataH)(this_index).area <0
                        ; (*alldataH)(this_index).probecounter=(*alldataH)(indexn1).probecounter
                        (*alldataH)(indexn1).warn=1
                        (*alldataH)(indexp1).warn=1

                        mymessage='H-Non-monotic time at '+string((*alldataH)(this_index).nanoseconds) +$
                            ' reject=2. index='+strtrim(string(This_index),2)+' HMS ='+SPEC_Nano2HMS((*alldataH)(this_index).nanoseconds)
                        printf,8,mymessage
                    endif; end of case 3
                endfor; endfor of if H channel non-Monontonic.
            endif; endif of if HorV eq 'H'

            if HorV eq 'V' then begin
                for ii=0LL,contmo-1LL do begin
                    lastindex=(indexmo(ii)+1LL) < (nnn-1LL)
                    printf,8, format='(A,1x,I10,1x,3(F14.1,1x))','Index and 3 Area  :',indexmo(ii),(*alldataV)(indexmo(ii)-1LL:lastindex).area
                    printf,8, format='(A,1x,I10,1x,3(F14.1,1x))','Index and 3 Nslice:',indexmo(ii),(*alldataV)(indexmo(ii)-1LL:lastindex).Nslice
                    printf,8, format='(A,1x,I10,1x,3(I14,1x))',  'Index and 3 Ticks :',indexmo(ii),(*alldataV)(indexmo(ii)-1LL:lastindex).probecounter
                    printf,8, format='(A,1x,I10,1x,3(I14,1x))',  'Index and 3 Nanos :',indexmo(ii),(*alldataV)(indexmo(ii)-1LL:lastindex).nanoseconds
                endfor
                ;***************************************************************************

                ; now examine and reject the non-monotonic particles and assign warn values.
                for i=0LL,contmo-1LL do begin;  The current Index is one before this index.
                    This_index=indexmo(i)
                    ; look for next real event; tc+1
                    done=0
                    indexp1=(This_index+1LL) <(nnn-1LL)
                    while done eq 0 do begin
                        if ((*alldataV)(indexp1).Nslice gt 0) or (indexp1 eq nnn-1LL) then done=1 else indexp1=(indexp1+1LL) <(nnn-1LL)
                    endwhile

                    ; look for earlier real event;tc-1
                    done=0
                    indexn1=(This_index-1LL) > 0
                    while done eq 0 do begin
                        if ((*alldataV)(indexn1).Nslice gt 0) or (indexn1 eq 0) then done=1 else indexn1=(indexn1-1LL) >0
                    endwhile

                    ; look for earlier-earlier real event;tc-2
                    done=0
                    indexn2=(indexn1-1LL) >0
                    while done eq 0 do begin
                        if ((*alldataV)(indexn2).Nslice gt 0) or (indexn2 eq 0) then done=1 else indexn2=(indexn2-1LL) >0
                    endwhile

                    Tcn2=timetk(indexn2)

                    Tcn1=timetk(indexn1)
                    Tcn10=tcn1-Nslice(indexn1)

                    Tc=timetk(this_index)
                    Tc0=Tc-Nslice(This_index)

                    Tcp1=timetk(indexp1)
                    Tcp10=tcp1-Nslice(indexp1)

                    if tcp1 lt Tcn2 then begin
                        print,'Strange and trouble -----Report this to mo and brad !!!'
                        ; stop;   Report this to mo and brad.
                        indexb=where((*alldataV).probecounter gt (*alldataV)(this_index).probecounter)
                        indexG=indexb(0)+LINDGEN(this_index-indexb(0))
                        print,'range=',indexb(0), ' to ', this_index
                        ;stop
                        (*alldataV)(indexg).reject=2
                        (*alldataV)(indexg).warn=1
                        (*alldataV)(indexg).Nslice=0
                        (*alldataV)(indexg).L1n=0
                        (*alldataV)(indexg).w8_t=0
                        (*alldataV)(indexg).area=(*alldataV)(indexg).area < 0
                        (*alldataV)(indexg).probecounter=(*alldataV)((indexb(0)-1LL)>0).probecounter
                        (*alldataV)(indexg).nanoseconds =(*alldataV)((indexb(0)-1LL)>0).nanoseconds
                        ;stop
                    endif

                    ;case 1, if tc0<=tcn2 or tc>=tcp10 then reject_tc=2 and Nslice_Tc=0
                    case1=tc0 le tcn2 or tc ge tcp10
                    if case1 eq 1 then begin
                        (*alldataV)(this_index).reject=2
                        (*alldataV)(this_index).warn=1
                        (*alldataV)(this_index).Nslice=0
                        (*alldataV)(this_index).L1n=0
                        (*alldataV)(this_index).w8_t=0
                        (*alldataV)(this_index).area=(*alldataV)(this_index).area < 0
                        ;(*alldataV)(this_index).probecounter=(*alldataV)(indexn1).probecounter

                        (*alldataV)(indexn1).warn=1
                        (*alldataV)(indexp1).warn=1


                        mymessage='V-Non-monotic time at '+string((*alldataV)(this_index).nanoseconds) + $
                            ' reject=2. index='+strtrim(string(This_index),2)+' HMS ='+SPEC_Nano2HMS((*alldataV)(this_index).nanoseconds)
                        printf,8,mymessage
                    endif; end of case1

                    ;case2; if tc10 <=tcn2 or tcn1 >=tcp10  then reject_tcn1
                    case2=tcn10 le tcn2 or tcn1 ge tcp10
                    if case2 eq 1 then begin
                        (*alldataV)(indexn1).reject=2
                        (*alldataV)(indexn1).warn=1
                        (*alldataV)(indexn1).Nslice=0
                        (*alldataV)(indexn1).L1n=0
                        (*alldataV)(indexn1).w8_t=0
                        (*alldataV)(indexn1).area=(*alldataV)(indexn1).area <0
                        ;(*alldataV)(indexn1).probecounter=(*alldataV)(indexn2).probecounter
                        (*alldataV)(this_index).warn=1
                        (*alldataV)(indexn2).warn=1

                        mymessage='V-Non-monotic time at '+string((*alldataV)(indexn1).nanoseconds) + $
                            ' reject=2. index='+strtrim(string(indexn1),2)+' HMS ='+SPEC_Nano2HMS((*alldataV)(indexn1).nanoseconds)
                        printf,8,mymessage
                    endif; end of case 2

                    ;case3; if neither case1 and case2 are satisfied, thne reject_tc=2
                    if case1 eq 0 and case2 eq 0 then begin
                        (*alldataV)(this_index).reject=2
                        (*alldataV)(this_index).warn=1
                        (*alldataV)(this_index).Nslice=0
                        (*alldataV)(this_index).L1n=0
                        (*alldataV)(this_index).w8_t=0
                        (*alldataV)(this_index).area=(*alldataV)(this_index).area < 0
                        ;(*alldataV)(this_index).probecounter=(*alldataV)(indexn1).probecounter
                        (*alldataV)(indexn1).warn=1
                        (*alldataV)(indexp1).warn=1

                        mymessage='V-Non-monotic time at '+string((*alldataV)(this_index).nanoseconds) +$
                            ' reject=2. index='+strtrim(string(This_index),2)+' HMS ='+SPEC_Nano2HMS((*alldataV)(this_index).nanoseconds)
                        printf,8,mymessage

                    endif; end of case 3
                endfor; endfor for V-channel non-monotonic
            endif; end if HorV eq V.
            close,8
        endif; endif if contmo gt 0 , there is w8_t less than 0 particles, non-monotonics ones.
    endif else begin;   end if there are 2 or more particles.
        ; There is no need to do anything in here.  The channel has only one particle----no sense to doing anything with it.
    endelse
end; end of  calculate_wait_time_of_all_HVparticles,HorV
;***********************************************************


;***********************************************************
pro get_deadtime_between_tick1_and_tick2,HorV,tick1,tick2,deadtime
    Common  DataBlock,alldataH,alldataV

    if HorV eq 'H' then begin
        index=where((*alldataH).probecounter ge tick1 and $
            (*alldataH).probecounter le tick2)
        if index(0) eq -1 then begin
            deadtime=0
            return
        endif else begin
            area =(*alldataH)(index).area
            timetk=(*alldataH)(index).probecounter
        endelse

    endif


    if HorV eq 'V' then begin
        index=where((*alldataV).probecounter ge tick1 and $
            (*alldataV).probecounter le tick2)
        if index(0) eq -1 then begin
            deadtime=0
            return;,
        endif else begin
            area =(*alldataV)(index).area
            timetk=(*alldataV)(index).probecounter
        endelse
    endif

    ;change mask time to deadtime
    ;also make mask start time and end-time as deadtime.
    indexmask=where(area eq -102,contGmask)
    if contGmask gt 0 then area(indexmask) =-100
    indexmask=where(area eq -103,contGmask)
    if contGmask gt 0 then area(indexmask)=-101

    ;also make bad1 start time and end-time as deadtime.
    indexmask=where(area eq -105,contGmask)
    if contGmask gt 0 then area(indexmask) =-100
    indexmask=where(area eq -106,contGmask)
    if contGmask gt 0 then area(indexmask) =-101

    ;also make bad2 start time and end-time as deadtime.
    indexmask=where(area eq -107,contGmask)
    if contGmask gt 0 then area(indexmask) =-100
    indexmask=where(area eq -108,contGmask)
    if contGmask gt 0 then area(indexmask) =-101

    ;also make bad3 start time and end-time as deadtime.
    indexmask=where(area eq -109,contGmask)
    if contGmask gt 0 then area(indexmask)=-100
    indexmask=where(area eq -110,contGmask)
    if contGmask gt 0 then area(indexmask) =-101

    ;find the deadtime particles; area=-100 is dead_time_start,  area=-101 is dead_time_end
    index3=where(area eq -100 or area eq -101, contG3)
    if contG3 eq 0 then begin  ; no deadtime
        deadtime=0.0
        return
    endif

    index1=where(area eq -100, contG1)
    index2=where(area eq -101, contG2)


    if contG1 eq 0 and contG2 eq 1 then begin  ; some deadTime     deadS****|**** deadE  ******|
        deadtime=(timetk(index2(0))-tick1)
        return
    endif


    if contG1 eq 1 and contG2 eq 0 then begin  ; some deadTime     deadE****|**** deads  ******|
        deadtime=(tick2-timetk(index1(0)))
        return
    endif


    if contG1 ge 1 and contG2 ge 1 then begin  ; a few dead periods ***|****deads deadE******|*****

        deadtime_array=timetk(index3)
        ;determine if the first deadtime mark and last deadtime mark are beginning or startting of a deadtime.
        if area(index3(0)) eq -101 then begin
            deadtime_array=[tick1,deadtime_array]
        endif
        if area(index3(contG3-1)) eq -100 then begin
            deadtime_array=[deadtime_array,tick2]
        endif
        ;now dt_array are in teh format of {start,end} pairs
        nnnn=n_elements(deadtime_array)
        starttime=deadtime_array[0:nnnn-1:2]
        endtime  =deadtime_array[1:nnnn-1:2]
        delta_dt=(endtime-starttime)
        deadtime=total(delta_dt)
    endif
end

pro calculate_L7_of_all_H_andV_particles
    Common  DataBlock,alldataH,alldataV,ADataH,ADataV,FirstData,LastData,StripData,$
        FirstDataV,LastDataV,StripDataV,avestripdata,avestripdataV

    ;first do H-particles
    L4=(*alldataH).L4
    Nslice=(*alldataH).Nslice
    L1n   =(*alldataH).L1n
    L5=(*alldataH).L5

    ;roundness=(L1 gt 0.49*L5) and (L5 gt 0.49*L1 or L5  gt 50) ;  50 is 50 pixels.
    roundness=(Nslice ge !roundness_threshold1*L5) and $
        (L5 ge !roundness_threshold1*Nslice or L5  gt !roundness_threshold2)

    (*alldataH).roundness=roundness*1.0

    Area=(*alldataH).Area
    Alexei1=(*alldataH).alexei1

    ;calculate teh focus value.
    A1C=Alexei1
    indexC1=where(Alexei1 le 0, contC1)
    if contC1 gt 0 then begin
        A1C(indexC1)=100
        focus=float(Area)/A1C
        focus(indexC1)=0.0
    endif  else begin
        focus=float(Area)/A1C
    endelse
    (*alldataH).focus=focus

    L7=L5; for particle greater than 40 pixel. No need to calculate their size.

    ;do The L7 for smaller size particles.
    index=where( L5 lt 40 and L5 gt 0.0 and area lt 0.9*Alexei1, contGGG);  only smaller size and out of focus particles.
    if contGGG gt 0 then begin
        L5s=L5(index);                      ; s means smaller set of values.
        Areas =Area(index)
        Alexei1s=Alexei1(index)

        get_alexei_correct_size,Alexei1s, Areas,L5s*1.0,L7s;  % L7s is in pixels. .
        L7(index)=L7s
    endif
    (*alldataH).L7=L7
    (*alldataH).adj0=1.0+L7*0.0

    ;********************************************************************
    ;now do V-particles
    L4=(*alldataV).L4
    L1n=(*alldataV).L1n
    Nslice=(*alldataV).Nslice
    L5=(*alldataV).L5

    ;roundness=(L1 gt 0.49*L5) and (L5 gt 0.49*L1 or L5  gt 50) ;  50 is 50 pixels.
    roundness=(Nslice ge !roundness_threshold1*L5) and $
        (L5 ge !roundness_threshold1*Nslice or L5  gt !roundness_threshold2)
    (*alldataV).roundness=roundness*1.0


    Area=(*alldataV).Area
    Alexei1=(*alldataV).alexei1

    ;calculate teh focus value.
    A1C=Alexei1
    indexC1=where(Alexei1 le 0, contC1)
    if contC1 gt 0 then begin
        A1C(indexC1)=100
        focus=float(Area)/A1C
        focus(indexC1)=0.0
    endif else begin
        focus=float(Area)/A1C
    endelse
    (*alldataV).focus=focus

    L7=L5; for particle greater than 40 pixel. No need to calculate their size.

    ;do The L7 for smaller size particles.
    index=where( L5 lt 40 and L5 gt 0.0 and area lt 0.9*Alexei1, contGGG);  only smaller size and out of focus particles.

    if contGGG gt 0 then begin
        L5s=L5(index);                      ; s means smaller set of values.
        Areas =Area(index)
        Alexei1s=Alexei1(index)
        get_alexei_correct_size,Alexei1s, Areas,L5s*1.0,L7s;  % L7s is in pixels. .
        L7(index)=L7s
    endif

    (*alldataV).L7=L7
    (*alldataV).adj0=1.0+L7*0.0

end; end of calculate_L&_of_all_H_and_V_particles
;***********************************************************
pro calculate_L8_of_all_H_andV_particles
    Common  DataBlock,alldataH,alldataV,ADataH,ADataV,FirstData,LastData,StripData,$
        FirstDataV,LastDataV,StripDataV,avestripdata,avestripdataV
    ;first do H-particles
    L4=(*alldataH).L4
    L1n=(*alldataH).L1n
    Area=(*alldataH).Area
    Alexei1=(*alldataH).alexei1
    L8=L4*0.0

    indexs=where(L1n gt 0.0, contGGG)
    if contGGG gt 0 then begin
        L4s   =L4(indexs)
        L1ns  =L1n(indexs)
        Areas =Area(indexs)
        Alexei1s=Alexei1(indexs)
        L4ns  =2.0*sqrt(Areas*L4s/L1ns/!pi)

        Get_alexei_correct_size,Alexei1s,areas,L4ns,L8s
        L8(indexs) =L8s
    endif

    (*alldataH).L8=L8
    ;********************************************************************
    ;first do V-particles
    L4=(*alldataV).L4
    L1n=(*alldataV).L1n
    Area=(*alldataV).Area
    Alexei1=(*alldataV).alexei1
    L8=L4*0.0

    indexs=where(L1n gt 0.0, contGGG)
    if contGGG gt 0 then begin
        L4s     =L4(indexs)
        L1ns    =L1n(indexs)
        Areas   =Area(indexs)
        Alexei1s=Alexei1(indexs)
        L4ns    =2.0*sqrt(Areas*L4s/L1ns/!pi)

        Get_alexei_correct_size,Alexei1s,areas,L4ns,L8s
        L8(indexs) =L8s
    endif
    (*alldataV).L8=L8; in units of pixels.
    ;********************************************************************
end; end of calculate_L&_of_all_H_and_V_particles
;***********************************************************
pro calculate_AccDeadtime_of_all_H_andV_particles
    Common  DataBlock,alldataH,alldataV
    ;Do H-channel first.   The accDTtick includes all Nslice deadtime also. januray24,2008.
    AccDT=0LL
    nnn=n_elements((*alldataH).L1n)
    (*alldataH)(0).accDTtick=0LL
    for i=1LL,nnn-1LL do begin
        case (*alldataH)(i).area of
            -101: accDT=accDT+(*alldataH)(i).probecounter-(*alldataH)(i-1).probecounter
            -103: accDT=accDT+(*alldataH)(i).probecounter-(*alldataH)(i-1).probecounter
            -106: accDT=accDT+(*alldataH)(i).probecounter-(*alldataH)(i-1).probecounter
            -108: accDT=accDT+(*alldataH)(i).probecounter-(*alldataH)(i-1).probecounter
            -110: accDT=accDT+(*alldataH)(i).probecounter-(*alldataH)(i-1).probecounter
            ;-201: accDT=accDT+(*alldataH)(i).probecounter-(*alldataH)(i-1).probecounter
            ;-203: accDT=accDT+(*alldataH)(i).probecounter-(*alldataH)(i-1).probecounter
            ;-206: accDT=accDT+(*alldataH)(i).probecounter-(*alldataH)(i-1).probecounter
            ;-208: accDT=accDT+(*alldataH)(i).probecounter-(*alldataH)(i-1).probecounter
            ;-210: accDT=accDT+(*alldataH)(i).probecounter-(*alldataH)(i-1).probecounter
            else: accDt=accDT+((*alldataH)(i).reject ne 2)*((*alldataH)(i).Nslice); area
            ;   can be -100,-102,-105,-107,-109,0,-104or>0in here. added rejec ne 2 in March 19, 2008.
        endcase
        (*alldataH)(i).accDTtick=accDT
    endfor

    ;Do V-channel second.
    AccDT=0LL
    nnn=n_elements((*alldataV).Nslice)
    (*alldataV)(0).accDTtick=0LL
    for i=1LL,nnn-1LL do begin
        case (*alldataV)(i).area of
            -101: accDT=accDT+(*alldataV)(i).probecounter-(*alldataV)(i-1).probecounter
            -103: accDT=accDT+(*alldataV)(i).probecounter-(*alldataV)(i-1).probecounter
            -106: accDT=accDT+(*alldataV)(i).probecounter-(*alldataV)(i-1).probecounter
            -108: accDT=accDT+(*alldataV)(i).probecounter-(*alldataV)(i-1).probecounter
            -110: accDT=accDT+(*alldataV)(i).probecounter-(*alldataV)(i-1).probecounter
            ;-201: accDT=accDT+(*alldataV)(i).probecounter-(*alldataV)(i-1).probecounter
            ;-203: accDT=accDT+(*alldataV)(i).probecounter-(*alldataV)(i-1).probecounter
            ;-206: accDT=accDT+(*alldataV)(i).probecounter-(*alldataV)(i-1).probecounter
            ;-208: accDT=accDT+(*alldataV)(i).probecounter-(*alldataV)(i-1).probecounter
            ;-210: accDT=accDT+(*alldataV)(i).probecounter-(*alldataV)(i-1).probecounter
            else: accDT=accDT+ ((*alldataV)(i).reject ne 2)*((*alldataV)(i).Nslice)
        endcase
        (*alldataV)(i).accDTtick=accDT
    endfor
end; end of calculate_accDeadtime_all_H_and_V_particles
;***********************************************************
pro calculate_Adj1_of_all_H_andV_particles,HorV
    Common  DataBlock,AllDataH,AllDataV

    if HorV eq 'H' then begin; pixel_size_H can be 10um or 50um
        dww            =!dww_main
        pxs            =!microns_per_pixelH/1000.0
        strbsz_squared =!microns_per_pixelH*!microns_per_pixelH
        alldata = alldataH
    endif else begin
        dww            =!dww_main
        pxs            =!microns_per_pixelV/1000.0
        strbsz_squared =!microns_per_pixelV*!microns_per_pixelV
        alldata = alldataV
    endelse

    sa_default     = !pixels* pxs* dww ;  unit mm^2 ==128*0.01*58.0; or 128*0.01*63.0
    This_L1n=(*alldata).L1n
    index=where(This_L1n le 0,contG)
    if contG gt 0 then This_L1n(index)=1.0

    dof = (5.13 * This_L1n*this_L1n*strbsz_squared) / 1000.0D ;; convert to mm
    SA_actual =(127.0 + This_L1n) * pxs*( dof < dww)

    adj1=Sa_default/SA_actual

    if contG gt 0 then adj1(index)=0.0

    (*alldata).adj1=adj1

    ; below should be handled due to pointer use
    ;if HorV eq 'H' then alldataH = alldata else alldataV = alldata

end; end of calculate_adj1_of_all_H_and_V_particles, HorV
;***********************************************************


pro correct_tas_of_HV_particles; including fake particles.
    Common  DataBlock,alldataH,alldataV



    ;get House keeping HKtas and HKtime
    get_House_keeping_tas_and_time,HKtas,HKnanoseconds



    if n_elements(HKtas) eq 0  then begin
        ;r=dialog_message(' No HK tAS data available,  No TAS correction is done !!!',/information)
        print, ' No HK tAS data available,  No TAS correction is done !!!'

        ; PLEASE PLEASE PLEASE!!! NO MORE POPUP WARNINGS!!!

        return
    endif; added by moqixu mo on Aprile 24, 2012.  some HK_Txt_files don't have any data so there is no HKtas return. no TAS correction.

    ; TAF commented and emulating for now
    MeanTAS=mean(HKtas,/NaN) > 0.1
    ;MeanTAS = 150.
    ;stop


    ; TAF temporary test to see if we can kickstart this with better tas values
    print, "temporarily setting TAS to mean HKtas"
    (*alldataH).tas[*] = MeanTAS
    (*alldataV).tas[*] = MeanTAS
    print, "proceeding with correct_tas_of_HV_particles...."

    MeanTAS_str=strtrim(string(meanTAS),2)+ ' m/s.'
    MeanTAS_3str=strtrim(string(3.0*meanTAS),2)+ ' m/s'
    MeanTAS_03str=strtrim(string(0.3*meanTAS),2) +' m/s. '

    ;correct only those tas values that is greater than 3*mean and less that 0.3*mean
    indexC=where((*alldataH).tas gt 3.0*MeanTas or $
        (*alldataH).tas lt 0.3*meanTas , nnn)
    junk=where((*alldataH).L1n ne 0.0, contNonefake)
    total_N_str =strtrim(string(contNonefake),2)

    if nnn gt 0 then begin;  there are points need to be corrected.
        line0=' The mean Tas of this file is '+meanTAS_str
        line1=' There  are '+total_N_str +' none fake  H  particles'
        line2=' But there are '+ strtrim(string(nnn),2)+' Particle"s have'
        line3=' TAS Greater than '+meanTAS_3str+ ' or less than '+meanTAS_03str
        line4=' They will be corrected by refrencing House Keeping data.'
        line5=' Please wait ..............................'

        my_message=[[line0],[line1],[line2],[line3],[line4],[line5]]
        ;open a file to write the problematic time periods.
        outputfilename=strmid(!currentHFname,0,strlen(!currentHFname)-4)+'PopUpMessages.txt'

        openw,8,outputfilename,/append
        printf,8,my_message
        close,8

        for i=0LL, nnn-1LL do begin
            this_index=indexC(i)
            this_tick =(*alldataH)(this_index).probecounter
            ;get earlier particle's valid tas.
            index1=where((*alldataH).probecounter lt this_tick and (*alldataH).tas gt 0.3*meanTas,contG)
            if contG gt 0 then begin; there is a valid tas before the particle.
                tas_before=(*alldataH)(index1(contG-1)).tas
            endif else tas_before=meanTas

            ;get next valid particles tas
            index1=where((*alldataH).probecounter gt this_tick and (*alldataH).tas gt 0.3*meanTas,contG)
            if contG gt 0 then begin; there is a valid tas before the particle.
                tas_after=(*alldataH)(index1(0)).tas
            endif else tas_after=meanTas

            This_tas=(tas_before+tas_after)/2.0
            (*alldataH)(this_index).tas=this_tas
        endfor

    endif

    print,'Done re-assigning the H particle TAS if something is wrong.'

    ;correct only those tas values that is greater than 3*mean and less that 0.3*mean
    indexC=where((*alldataV).tas gt 3.0*MeanTas or (*alldataV).tas lt 0.3*meanTas, nnn)

    junk=where((*alldataV).L1n ne 0.0, contNonefake)
    total_N_str =strtrim(string(contNonefake),2)

    if nnn gt 0 then begin;  there are points need to be corrected.
        line0=' The mean Tas of this file is '+meanTAS_str
        line1=' There  are '+total_N_str +' none fake V particles'
        line2=' But there are '+ strtrim(string(nnn),2)+' Particle"s have'
        line3=' TAS Greater than '+meanTAS_3str+ ' or less than '+meanTAS_03str
        line4=' They will be corrected by refrencing House Keeping data.'
        line5=' Please wait ..............................'
        my_message=[[line1],[line2],[line3],[line4],[line5]]
        ;open a file to write the problematic time periods.
        outputfilename=strmid(!currentHFname,0,strlen(!currentHFname)-4)+'PopUpMessages.txt'
        openw,8,outputfilename,/append
        printf,8,my_message
        close,8


        for i=0LL, nnn-1LL do begin
            this_index=indexC(i)
            this_tick =(*alldataV)(this_index).probecounter
            ;get earlier particle's valid tas.
            index1=where((*alldataV).probecounter lt this_tick and (*alldataV).tas gt 0.3*meanTas,contG)
            if contG gt 0 then begin; there is a valid tas before the particle.
                tas_before=(*alldataV)(index1(contG-1)).tas
            endif else tas_before=meanTas

            ;get next valid particles tas
            index1=where((*alldataV).probecounter gt this_tick and (*alldataV).tas gt 0.3*meanTas,contG)
            if contG gt 0 then begin; there is a valid tas before the particle.
                tas_after=(*alldataV)(index1(0)).tas
            endif else tas_after=meanTas

            This_tas=(tas_before+tas_after)/2.0
            (*alldataV)(this_index).tas=this_tas
        endfor
    endif
    print,'Done re-assigning the V particle TAS if something is wrong.'

end; end of correct_tas_of_HV_particles
;***********************************************************

pro re_assign_fake_particles_area_values
    Common  DataBlock,alldataH,alldataV

    ;do Hparticles first
    nnnH=n_elements((*alldataH).area)

    indexf=where((*alldataH).area eq -100,contF)
    if contF ge 2 then begin
        for i=0LL,contF-1LL do begin
            This_index=indexF(i) < (nnnH-2LL)
            if (*alldataH)(this_index+1LL).area ne -101 then (*alldataH)(this_index).area=-200L
        endfor
    endif

    indexf=where((*alldataH).area eq -101,contF)
    if contF gt 0 then begin
        for i=0LL,contF-1LL do begin
            This_index=indexF(i)
            if this_index gt 0 then begin
                if (*alldataH)(this_index-1LL).area ne -100 then (*alldataH)(this_index).area=-201L
            endif
        endfor
    endif

    indexf=where((*alldataH).area eq -102,contF)
    if contF gt 0 then begin
        for i=0LL,contF-1LL do begin
            This_index=indexF(i) < (nnnH-2LL)
            if (*alldataH)(this_index+1LL).area ne -103 then (*alldataH)(this_index).area=-202L
        endfor
    endif

    indexf=where((*alldataH).area eq -103,contF)
    if contF gt 0 then begin
        for i=0LL,contF-1LL do begin
            This_index=indexF(i)
            if this_index gt 0 then begin
                if (*alldataH)(this_index-1LL).area ne -102 then (*alldataH)(this_index).area=-203L
            endif
        endfor
    endif

    ;do Vparticles now
    nnnV=n_elements((*alldataV).area)

    indexf=where((*alldataV).area eq -100,contF)
    if contF ge 2 then begin
        for i=0LL,contF-1LL do begin
            This_index=indexF(i) < (nnnV-2LL)
            if (*alldataV)(this_index+1LL).area ne -101 then (*alldataV)(this_index).area=-200L
        endfor
    endif

    indexf=where((*alldataV).area eq -101,contF)
    if contF gt 0 then begin
        for i=0LL,contF-1LL do begin
            This_index=indexF(i)
            if this_index gt 0 then begin
                if (*alldataV)(this_index-1LL).area ne -100 then (*alldataV)(this_index).area=-201L
            endif
        endfor
    endif

    indexf=where((*alldataV).area eq -102,contF)
    if contF gt 0 then begin
        for i=0LL,contF-1LL do begin
            This_index=indexF(i) < (nnnV-2LL)
            if (*alldataV)(this_index+1LL).area ne -103 then (*alldataV)(this_index).area=-202L
        endfor
    endif

    indexf=where((*alldataV).area eq -103,contF)
    if contF gt 0 then begin
        for i=0LL,contF-1LL do begin
            This_index=indexF(i)
            if this_index gt 0 then begin
                if (*alldataV)(this_index-1LL).area ne -102 then (*alldataV)(this_index).area=-203L
            endif
        endfor
    endif
end; end of re_assign_fake_particles_area_values
;****************************************************************

pro get_House_keeping_tas_and_time,HKtas,HKnanoseconds

    ; TAF need to update this to 3VCPI compatible

    ;get House keeping HKtas and HKtime
    ;get the upper directory:
    substrs=strsplit(!currentHPname,'\',/extract)
    up_pathnm=strjoin(substrs(0:n_elements(substrs)-2),'\')+'\'
    short_Fname=strmid(!currentHFname,strlen(!currentHPname),strlen(!currentHFname)-strlen(!currentHPname))
    ;infile =up_pathnm+'HK_TXT' + strmid(Short_Fname,5,strlen(Short_Fname)-9) + '.2DS'
    infile =up_pathnm+'HK_TXT' + strmid(Short_Fname,5,strlen(Short_Fname)-9) + '.2DSCPI'
    result=query_ascii(infile,info);   if it is a valid ascii file or not.---info is the returned strcuture.


    if(result gt 0) then begin
        if(info.lines gt 5) then begin
            result=read_ascii(infile,data_start=5,count=nnn)
            openR,1,infile
            dummy='ab'
            readF,1,format='(A////)',dummy; read a line and then skip 4 lines.
            ;assign arrays for the readin parameters

            ; TAF below are all intarr(nnn-1) in 2D-S, throwing out last line?

            hh  =intarr(nnn)
            mm  =intarr(nnn)
            ss  =intarr(nnn)
            ms  =intarr(nnn)
            us  =intarr(nnn)
            ns  =intarr(nnn)
            HKnanoseconds=Long64(nnn)
            HKtas =fltarr(nnn)

            for i=0L,long(nnn)-1L do begin
                ;read one line at a time.
                thisline='abcdefg'
                readF,1,format='(1A)',thisline;   ; the line conains following parameters.
                ;year,mmddhhmmss,roinumber,arrtime,ts,deadTime,length,width,areaA,perimP,$
                S = STRSPLIT(thisline, ' ', /EXTRACT)
                S = strjoin(S)
                S = strsplit(S,':',/extract)
                S=strjoin(S,',')
                S=strsplit(S,',',/extract)

                if((size(s))[1] ne 7) then begin ; sometimes the last line is corrupted, skip line and resume processing
                    nnn = i ; truncate the last entry

                    hh = hh[0:nnn-1L]
                    mm = mm[0:nnn-1L]
                    ss = ss[0:nnn-1L]
                    ms = ms[0:nnn-1L]
                    us = us[0:nnn-1L]
                    ns = ns[0:nnn-1L]
                    HKTAS = HKTAS[0:nnn-1L]
                    ;HKnanoseconds = HKnanoseconds[0:nnn-1L]

                    break
                endif else begin
                    hh(i)=S(0)
                    mm(i)=S(1)
                    ss(i)=S(2)
                    ms(i)=S(3)
                    us(i)=S(4)
                    ns(i)=S(5)
                    ;HKTAS(i)            =S(42);  true air speed.
                    HKTAS(i)            =S(6);  true air speed.
                endelse
            endfor

            close,1
            ;select the only the part of data from the start-time and end-time of the zoomed periods.
            HKnanoseconds=(hh*3600LL+mm*60LL+ss*1LL)*1000000000LL+ms*1000000LL+us*1000LL+ns*1LL
        endif
    endif else begin;   if result=0 or info.line is less that 5 lines.
        HKtas=0.0
        HKnanoseconds=0LL
    endelse
end; end of get House keeping HKtas and HKtime

;****************************************************************************
pro show_my_message,my_message
    ;input my_message has to be arrays of several string elements.
    window,/free,xs=800,ys=400, title='information'
    redcolor = GetColor("Red", !D.Table_Size-2)
    whitecolor =GetColor("White", !D.Table_Size-2)
    erase,color='ffffff'x  ; get background to white
    nlines=n_elements(my_message)
    dy=400/nlines
    for i=0L,nlines-1L  do begin
        xyouts,10,400-i*dy,my_message(i),charsize=1.0,color=redcolor,/device
    endfor
    wait,2
    ; Wdelete
end; show_my_message,my_message
;****************************************************

;******************************************************************************
;*********************************************************************************
pro Get_Hsv_Vsv,Nbins,Hsv,Vsv,ave_info
    Common  DataBlock,AllDataH,AllDataV
    ;Hsv=fltarr(Nbins);  Original Nbins=300LL
    ;Vsv=fltarr(Nbins)
    totalNS=ave_info.endnanoseconds-ave_info.startnanoseconds
    time_binsize=totalNS/Nbins
    if time_binsize lt 1  then begin
        ; rrrrrr=dialog_message('There is less than 1 nanosec in a bin, try again !',/information)
        return
    endif
    StartBin_time=ave_info.startnanoseconds
    Endbin_time=Startbin_time+time_binsize

    for i=0LL, NBins-1LL do begin
        ;Get_Vsv_deadtime_between_time1_time2,startbin_time,endbin_time,VSE_volume,Vdeadtime
        ;Get_Hsv_deadtime_between_time1_time2,startbin_time,endbin_time,HSE_volume,Hdeadtime
        Get_total_DTs_btw_T1T2,'V',startbin_time,endbin_time,Vdeadtime,Fullticks,VSE_Volume
        Get_total_DTs_btw_T1T2,'H',startbin_time,endbin_time,Hdeadtime,Fullticks,HSE_Volume
        Hsv(i)=HSE_volume
        Vsv(i)=VSE_volume
        startbin_time=Endbin_time
        Endbin_time=startbin_time+time_binsize
    endfor

    ;ave_info.Hsv=ptr_new(Hsv)
    ;ave_info.Vsv=ptr_new(Vsv)
end; end of Get_Hsv_Vsv,ave_info
;*********************************************************************************

pro  Plot_unsorted_particles_nanotimes_and_ticks_and_tas,HorV
    Common  DataBlock,AllDataH,AllDataV
    substr=strsplit(!currentHFname,'\',/extract)
    binfilename=substr(n_elements(substr)-1)

    ;**************************************************
    if HorV eq 'H' then begin
        nanos = (*alldataH).nanoseconds
        ticks = (*alldataH).probecounter
        tas   = (*alldataH).tas
        area  = (*alldataH).alexei1
    endif

    if HorV eq 'V' then begin
        nanos = (*alldataV).nanoseconds
        ticks = (*alldataV).probecounter
        tas   = (*alldataV).tas
        area  = (*alldataV).alexei1
    endif


    x=indgen(n_elements(area),/L64)
    if n_elements(area) eq 1 then begin
        x=[x,x]
        nanos=[nanos,nanos]
        ticks=[ticks,ticks]
        tas=[tas,tas]
        area=[area, area]
    endif
    nnn=n_elements(nanos)

    window,1,xs=800,ys=720
    !P.multi=[0,1,4]
    bluecolor =GetColor("Navy", !D.Table_Size-2)
    redcolor = GetColor("Red", !D.Table_Size-2)
    whitecolor =GetColor("White", !D.Table_Size-2)
    erase,color='ffffff'x  ; get background to white
    ;k1=170000
    ;k2=180000

    plot,x,nanos/1000000000.0/3600.0,color=bluecolor,background=whitecolor,/ynozero,position=[0.1,0.77,0.96,0.96],$
        title='Unsorted '+HorV+' Particle Time in hours since Midnight',ytitle='Hours',charsize=2.0,xtick_get=xtickvales,/nodata;$
        nticks=n_elements(xtickvales)
    xticknames=strarr(nticks)
    FOR i=0,nticks-1 DO BEGIN
        xticknames(i) =  strtrim(string(round(xtickvales(i))),2)
    ENDFOR

    !X.TICKNAME = xticknames
    wdelete,1

    window,1,xs=800,ys=720
    !P.multi=[0,1,4]
    erase, color = 'ffffff'x  ; get background to white

    plot,x,nanos/1000000000.0/3600.0,color=bluecolor,background=whitecolor,/ynozero,position=[0.1,0.77,0.96,0.96],$
        title='Unsorted '+HorV+' Particle Time in hours since Midnight',ytitle='Hours',charsize=2.0;$
        ;see if there are non-monotonic ticks and nanoseconds.
        diffticks   = long64(nanos(1:nnn-1)) - long64(nanos(0:nnn-2))
    index_ticks = where(diffticks lt 0,contG)

    if contG gt 1 then begin
        x_ticks=index_ticks
        y_ticks=nanos(index_ticks)/1000000000.0/3600.0
        oplot,x_ticks,y_ticks,color=bluecolor,psym=2

    endif

    if contG eq 1 then begin
        x_ticks = index_ticks
        y_ticks = nanos(index_ticks)/1000000000.0/3600.0
        oplot,[x_ticks,x_ticks],[y_ticks,y_ticks],color=bluecolor,psym=2

    endif

    ;xrange=[k1,k2]
    plot,x,ticks/100000000.0,color=redcolor,background=whitecolor,/ynozero,position=[0.1,0.53,0.96,0.72],$
        title = 'Unsorted ' + HorV + ' Particle Time in ticks (1 tick=10 microns 10^8 ticks is equivalent to 1km ) ', ytitle = 'Ticks(km)', charsize=2.0;,$
        ;xrange=[k1,k2]; yrange=[20, 50]
        ;see if there are non-monotonic ticks and nanoseconds.
        diffticks=long64(ticks(1:nnn-1))-long64(ticks(0:nnn-2))
    index_ticks=where(diffticks lt 0,contG)
    if contG gt 1 then begin
        x_ticks=index_ticks
        y_ticks=ticks(index_ticks)/100000000.0
        oplot,x_ticks,y_ticks,color=bluecolor,psym=2
    endif
    if contG eq 1 then begin
        x_ticks=index_ticks
        y_ticks=ticks(index_ticks)/100000000.0
        oplot,[x_ticks,x_ticks],[y_ticks,y_ticks],color=bluecolor,psym=2
    endif

    plot,x,tas,color=bluecolor,background=whitecolor,charsize=2.0,yrange=[min(TAS)-5.0, max(TAS)+5.0],position=[0.1,0.29,0.96,0.48],$
        title = 'Unsorted '+HorV+' TAS (m/s)  Data File: '+binfilename,ytitle='Tas(m/s)';,$;,yrange=[100,115],$
        ;xrange=[k1,k2];; xrange=[31900LL,32000LL]


        maxY=1.5*max(area)

    if maxY le 0.1 then maxY=10.0

    plot,x,area,color=redcolor,background=whitecolor,ylog=1,position=[0.1,0.05,0.96,0.24],$
        ytitle = 'Alexei1(Pixel)',charsize=2.0,xtitle='particle sequence number', Yrange=[0.1,maxY],$
        title  = 'Unsorted '+HorV+' particle-area-alexei1 (in unit pixels):';, xrange=[k1,k2]

    outputfilename=strmid(!currentHFname,0,strlen(!currentHFname)-4)+$
        '_'+HorV+'_nanos_ticks_unsorted.png'
    write_png,outputfilename,tvrd(true=1)


end;  Plot_unsorted_particles_nanotimes_and_ticks_and_tas,HorV


pro  Plot_shifted_unsorted_particles_nanotimes_and_ticks_and_tas,HorV,The_index
    Common  DataBlock,alldataH,alldataV
    substr=strsplit(!currentHFname,'\',/extract)
    binfilename=substr(n_elements(substr)-1)

    ;**************************************************
    if HorV eq 'V' then begin
        nanos=(*alldataV).nanoseconds
        ticks=(*alldataV).probecounter
        tas  =(*alldataV).tas
        area =(*alldataV).area
    endif else begin
        nanos=(*alldataH).nanoseconds
        ticks=(*alldataH).probecounter
        tas  =(*alldataH).tas
        area =(*alldataH).area
    endelse

    x=indgen(n_elements(area),/L64)
    if n_elements(area) eq 1 then begin
        x=[x,x]
        nanos=[nanos,nanos]
        ticks=[ticks,ticks]
        tas=[tas,tas]
        area=[area, area]
    endif
    nnn=n_elements(nanos)

    ; fix the time jump of non-monotonic problems.
    ; The_index=[903LL,9071LL, 127484LL];   index of the jump point.

    for k=0, n_elements(The_index)-1 do begin
        Dt_nanos=nanos(the_index(k)-1)-nanos(The_index(k))
        DT_ticks=ticks(the_index(k)-1)-ticks(The_index(k))
        nanos(The_index(k):*)=nanos(The_index(k):*)+Dt_nanos
        ticks(The_index(k):*)=ticks(The_index(k):*)+Dt_ticks
    endfor

    window,1,xs=600,ys=600
    !P.multi=[0,1,4]
    bluecolor =GetColor("Navy", !D.Table_Size-2)
    redcolor = GetColor("Red", !D.Table_Size-2)
    whitecolor =GetColor("White", !D.Table_Size-2)
    erase,color='ffffff'x  ; get background to white

    plot,x,nanos/1000000000.0,color=bluecolor,background=whitecolor,/ynozero,$
        title='shifted-Unsorted '+HorV+'-Particle_nanos/10^9',ytitle='Nanoseconds',charsize=2.0;$
        ;see if there are non-monotonic ticks and nanoseconds.
        diffticks=long64(nanos(1:nnn-1))-long64(nanos(0:nnn-2))
    index_ticks=where(diffticks lt 0,contG)
    if contG gt 1 then begin
        x_ticks=index_ticks
        y_ticks=nanos(index_ticks)/1000000000.0
        oplot,x_ticks,y_ticks,color=bluecolor,psym=2
    endif
    if contG eq 1 then begin
        x_ticks=index_ticks
        y_ticks=nanos(index_ticks)/1000000000.0
        oplot,[x_ticks,x_ticks],[y_ticks,y_ticks],color=bluecolor,psym=2
    endif
    ;xrange=[k1,k2]
    plot,x,ticks/10000000.0,color=redcolor,background=whitecolor,$
        title='shifted-Unsorted '+HorV+'-Particle_ticks/10^7',ytitle='Ticks',charsize=2.0;,$
        ;xrange=[k1,k2]; yrange=[20, 50]
        ;see if there are non-monotonic ticks and nanoseconds.
        diffticks=long64(ticks(1:nnn-1))-long64(ticks(0:nnn-2))
    index_ticks=where(diffticks lt 0,contG)
    if contG gt 1 then begin
        x_ticks=index_ticks
        y_ticks=ticks(index_ticks)/10000000.0
        oplot,x_ticks,y_ticks,color=bluecolor,psym=2
    endif
    if contG eq 1 then begin
        x_ticks=index_ticks
        y_ticks=ticks(index_ticks)/10000000.0
        oplot,[x_ticks,x_ticks],[y_ticks,y_ticks],color=bluecolor,psym=2
    endif

    plot,x,tas,color=bluecolor,background=whitecolor,charsize=2.0,$
        title='shift-Unsorted '+HorV+'-True-air',ytitle='Tas m/s';,$;,yrange=[100,115],$
        ;xrange=[k1,k2];; xrange=[31900LL,32000LL]

        plot,x,area,color=redcolor,background=whitecolor,$
        ytitle='Area',charsize=2.0,xtitle=binfilename, $
        title='shifted-Unsorted '+HorV+'-particle-area:';, xrange=[k1,k2]

    outputfilename=strmid(!currentHFname,0,strlen(!currentHFname)-4)+$
        '_'+HorV+'_nanos_ticks_shifted_unsorted.png'
    write_png,outputfilename,tvrd(true=1)
    answer='y'; 'no'
    ; print,'Is it good ? y/n:'
    ; read,answer

    if answer eq 'y' then begin

        if HorV eq 'H' then begin
            (*alldataH).nanoseconds=nanos
            (*alldataH).probecounter=ticks
        endif

        if HorV eq 'V' then begin
            (*alldataV).nanoseconds=nanos
            (*alldataV).probecounter=ticks
        endif

    endif; end of if answer ='y'

end;  Plot_shifted_unsorted_particles_nanotimes_and_ticks_and_tas
;   above added on August 29, 2008.


;******************************************************************************

pro Check_live_time_calculations,HorV,starttime,endtime,LiveTime1,LiveTime2
    Common DataBlock,alldataH,alldataV

    Get_JustDeadtime_between_time1_time2,HorV,starttime,endtime,$
        StartTicks1,EndTicks1,DT_mask,DT_ovfl,DT_L1,DT_bad1,DT_bad2
    deadtime1=DT_mask+DT_ovfl+DT_L1+DT_bad1+DT_bad2
    liveTime1=long64(EndTicks1-StartTicks1-deadtime1)

    ; print,'livetime1: S, E ticks:',StartTicks1, endTicks1


    Get_LiveTime2_using_w8_t,HorV,StartTime,endtime,StartTicks2,EndTicks2,livetime2

    if abs(livetime1 - livetime2) gt 2.0 then begin
        print,HorV,'  LiveTime1=',long64(liveTime1), ' Livetime2=',livetime2,'  delta_ticks=',abs(livetime1-livetime2)
        print,format='(A,5x,I16,2x,I16,2x,A,2x,I16)', 'Live1 S_E ticks:', startticks1,endticks1,'  FT=',long64(endticks1-startticks1)
        print,format='(A,5x,I16,2x,I16,2x,A,2x,I16)', 'Live2 S_E ticks:', startticks2,endticks2,'  FT=',long64(endticks2-startticks2)

        my_message='Warning: |livetime1-livetime2|='+ string(abs(livetime1-livetime2))+ ' ticks between Time:'+string(starttime)+'--'+string(endtime)
        ;rrr=dialog_message('Livetime1 no equal to LiveTime2 !!!!',/information)
        outputfilename=strmid(!currentHFname,0,strlen(!currentHFname)-4)+'PopUpMessages.txt'
        openw,8,outputfilename,/append
        printf,8,format='(A)',my_message
        close,8
        ;index=where((*alldataH).probecounter gt startTicks1 and (*alldataH).probecounter lt endTicks1)
        ;index=where((*alldataV).probecounter gt startTicks1 and (*alldataV).probecounter lt endTicks1)
        ; if HorV eq 'H' then begin
        ; index=where((*alldataH).probecounter gt startTicks1 and (*alldataH).probecounter lt endTicks1)
        ; print,index
        ; print,(*alldataH)(index).area
        ; print,(*alldataH)(index).L1
        ; print,(*alldataH)(index).probecounter
        ; endif
        ; stop
        ;print,(*alldataV)(index).area;print,(*alldataV)(index).L1; print,(*alldataV)(index).probecounter
    endif

end; end of Check_live_time_calculations,HorV,LiveTime1,LiveTime2
;************************************************************************


pro Reject_Particles_btw_SE_Mkpair_N_assign_irregular_Value100,HorV
    Common  DataBlock,alldataH,alldataV;  assigen warn=warn+100 to particles.
    ;*************************************************************************
    if HorV eq 'H' then begin;  modified on Feb. 26, 2008.
        timeticks=long64((*alldataH).probecounter)
        area=(*alldataH).area
        Nslice=long64((*alldataH).Nslice)
    endif else begin
        timeticks=long64((*alldataV).probecounter)
        area=(*alldataV).area
        Nslice=long64((*alldataV).Nslice)
    endelse

    nF=n_elements(timeticks)-1LL

    index=where(area eq -102,contG)
    if contG gt 0 then area(index)=-100
    index=where(area eq -103,contG)
    if contG gt 0 then area(index)=-101

    index=where(area eq -105,contG)
    if contG gt 0 then area(index)=-100
    index=where(area eq -106,contG)
    if contG gt 0 then area(index)=-101

    index=where(area eq -107,contG)
    if contG gt 0 then area(index)=-100
    index=where(area eq -108,contG)
    if contG gt 0 then area(index)=-101

    index=where(area eq -109,contG)
    if contG gt 0 then area(index)=-100
    index=where(area eq -110,contG)
    if contG gt 0 then area(index)=-101
    ;***************************************************************
    index=where(area eq -200,contG)
    if contG gt 0 then area(index)=-100
    index=where(area eq -201,contG)
    if contG gt 0 then area(index)=-101

    index=where(area eq -202,contG)
    if contG gt 0 then area(index)=-100
    index=where(area eq -203,contG)
    if contG gt 0 then area(index)=-101

    index=where(area eq -205,contG)
    if contG gt 0 then area(index)=-100
    index=where(area eq -206,contG)
    if contG gt 0 then area(index)=-101

    index=where(area eq -207,contG)
    if contG gt 0 then area(index)=-100
    index=where(area eq -208,contG)
    if contG gt 0 then area(index)=-101

    index=where(area eq -209,contG)
    if contG gt 0 then area(index)=-100
    index=where(area eq -210,contG)
    if contG gt 0 then area(index)=-101
    ;***********************************************************************
    index1=where(area eq -100,contG1)
    index2=where(area eq -101,contG2)

    if HorV eq 'H' then begin
        if contG1 eq contG2 and contG1 gt 0 then begin

            for i=0LL, contG1-1LL do begin
                startTick=timeticks(index1(i))
                endtick  =timeticks(index2(i))
                index=where(timeticks gt starttick and timeticks lt endtick and $
                    timeticks ne timeticks(0) and timeticks ne timeticks(NF), contG)
                if contG gt 0 then begin
                    ;(*alldataH)(index).reject=2;  their L1, area, w8_t has to be assigned as 0 also ?????
                    (*alldataH)(index).warn  =(*alldataH)(index).warn+100
                    (*alldataH)(index).Nslice =0;  (*alldataH)(index).Nslice+(*alldataH)(index).w8_t
                    (*alldataH)(index).w8_t  =0
                    (*alldataH)(index).reject=2;  (*alldataH)(index2(i)).probecounter
                endif
            endfor
        endif else begin
            if (contG1 + contG2) ne 0 then begin
                rrr=dialog_message('H--Start-marker0 and end-marker1 is not in pairs !!',/information)
                ;stop
            endif
        endelse
    endif; end of if HorV eq 'H' ;  for H_channel

    if HorV eq 'V' then begin
        if contG1 eq contG2 and contG1 gt 0 then begin
            for i=0LL, contG1-1LL do begin
                startTick=timeticks(index1(i))
                endtick  =timeticks(index2(i))
                index=where(timeticks gt starttick and timeticks lt endtick and $
                    timeticks ne timeticks(0) and timeticks ne timeticks(NF), contG)
                if contG gt 0 then begin
                    ;(*alldataV)(index).reject=2;  their L1, area, w8_t has to be assigned as 0 also ?????
                    (*alldataV)(index).warn  =(*alldataV)(index).warn+100
                    (*alldataV)(index).Nslice =0;  (*alldataH)(index).Nslice+(*alldataH)(index).w8_t
                    (*alldataV)(index).w8_t  =0
                    (*alldataV)(index).reject=2;  =(*alldataV)(index2(i)).probecounter
                endif; of contG gt 0
            endfor
        endif else begin
            if (contG1 + contG2) ne 0 then begin
                rrr=dialog_message(' V--Start-marker0 and end-marker1 is not in pairs !!',/information)
                ;stop
            endif
        endelse
    endif; end of if HorV eq 'V' ;  for V_channel
end; Reject_Particles_btw_SE_Mkpair_N_assign_irregular_Vlaue2,HorV



pro Get_spec_ticks, HorV, In_nanos, out_ticks, Findex;  use this since janu29. 2008
    Common  DataBlock,alldataH,alldataV; Findex is the earlier image's index. Outicks is same as in_time.
    ;looking for the closest in time particle as reference to get the ticks of the input time.
    if HorV eq 'H' then alldata=alldataH else alldata=alldataV

    index=where( (*alldata).nanoseconds le In_nanos and $
        (   ((*alldata).area gt 0.0 and ((*alldata).reject eq 0 or (*alldata).reject eq 1)) $
        or ((*alldata).area eq -104)    ), contG)
    if contG gt 0 then begin; there is some particles before the input time.
        This_index=index(contG-1)
        nanos=(*alldata)(this_index).nanoseconds
        ticks=(*alldata)(this_index).probecounter
        tas  =(*alldata)(this_index).tas
    endif else begin; There is no particles ??? impossible ???
        index=where( (*alldata).nanoseconds le In_nanos and (*alldata).nanoseconds gt 0 and $
            ((*alldata).reject eq 0 or (*alldata).reject eq 1 or (*alldata).tas eq -104), contG)
        if contG gt 0 then  begin
            This_index=index(contG-1)
            nanos=(*alldata)(this_index).nanoseconds
            ticks=(*alldata)(this_index).probecounter
            tas  =(*alldata)(this_index).tas
        endif else begin
            indexgt0=where((*alldata).probecounter gt 0,contGT0)
            if contGT0 gt 0 then begin
                out_ticks=(*alldata)(indexgt0(0)).probecounter
                Findex =indexgt0(0)
            endif   else begin
                out_Ticks=0LL
                Findex =0LL
            endelse
            return
        endelse
    endelse
    out_ticks=ticks+long64((long64(In_nanos)-long64(nanos))*double(tas)/10000.0)
    index=where((*alldata).probecounter eq out_ticks,contU)
    if contU eq 1 then Findex=index(0) else begin
        index=where((*alldata).probecounter lt out_ticks,contUU)
        if contUU gt 0 then Findex=index(contUU-1LL) else Findex=0
    endelse
    if out_ticks gt max((*alldata).probecounter)  then out_ticks=-999LL

end; Get_spec_ticks,HorV,In_nanos,out_ticks



pro Get_spec_ticks2, HorV, startnanos, endnanos, startticks, endticks, ST0_index, ET0_index
    Common  DataBlock,alldataH,alldataV; Findex is the earlier image's index. Outicks is same as in_time.
    ;looking for the closest in time particle as reference to get the ticks of the input time.

    ; TAF updating Get_spec_ticks, which was always called in pairs, with starttime and endtime, to fetch both startticks and endticks at once
    ; The problem was that with the larger search space for endtime, the where statement was finding a diffent particle for the tick base,
    ; so sometimes the startticks was larger than the endticks, leading to bad sample volume calculations

    if HorV eq 'H' then begin
        index = where((*alldataH).nanoseconds le startnanos and $
            (((*alldataH).area gt 0.0 and ((*alldataH).reject eq 0 or (*alldataH).reject eq 1)) or $
            ((*alldataH).area eq -104)), contG)

        if contG gt 0 then begin; there is some particles before teh input time.
            This_index = index(contG-1)

        endif else begin; There is no particles ??? impossible ???
            index = where((*alldataH).nanoseconds le startnanos and $
                ((*alldataH).reject eq 0 or (*alldataH).reject eq 1 or (*alldataH).tas eq -104), contG)

            if contG gt 0 then  This_index = index(contG-1) else This_index = 0
        endelse

        nanos = (*alldataH)(this_index).nanoseconds
        ticks = (*alldataH)(this_index).probecounter
        tas   = (*alldataH)(this_index).tas

        startticks = ticks + long64((long64(startnanos) - long64(nanos)) * double(tas)/10000.0)
        index = where((*alldataH).probecounter le startticks, contU)
        if contU gt 0 then ST0_index = index(contU-1LL) else ST0_index=0

        endticks = ticks + long64((long64(  endnanos) - long64(nanos)) * double(tas)/10000.0)
        index = where((*alldataH).probecounter le   endticks, contU)
        if contU gt 0 then ET0_index = index(contU-1LL) else ET0_index=0
    endif else begin;  for HorV eq 'V'
        index = where((*alldataV).nanoseconds le startnanos and $
            (((*alldataV).area gt 0.0 and ((*alldataV).reject eq 0 or (*alldataV).reject eq 1)) or $
            ((*alldataV).area eq -104)), contG)

        if contG gt 0 then begin
            this_index = index(contG-1)
        endif else begin
            index = where((*alldataV).nanoseconds le startnanos and $
                ((*alldataV).reject eq 0 or (*alldataV).reject eq 1 or (*alldataV).tas eq -104), contG)

            if contG gt 0 then This_index = index(contG-1) else This_index=0
        endelse

        nanos = (*alldataV)(this_index).nanoseconds
        ticks = (*alldataV)(this_index).probecounter
        tas   = (*alldataV)(this_index).tas

        startticks = ticks + long64((long64(startnanos) - long64(nanos)) * double(tas)/10000.0)
        index = where((*alldataV).probecounter le startticks, contU)
        if contU gt 0 then ST0_index = index(contU-1LL) else ST0_index=0

        endticks = ticks + long64((long64(  endnanos) - long64(nanos)) * double(tas)/10000.0)
        index = where((*alldataV).probecounter le   endticks, contU)
        if contU gt 0 then ET0_index = index(contU-1LL) else ET0_index=0
    endelse
end; Get_spec_ticks2



pro correct_HV_particles_nanotimes,HorV; ;add 1000.0 to the warn values if not the same as before.
    Common  DataBlock,alldataH,alldataV,ADataH,ADataV,FirstData,LastData,StripData,FirstDataV,$
        LastDataV

    if HorV eq 'V' then begin
        nanos=(*alldataV).nanoseconds
        nanos_old=nanos
        ticks=(*alldataV).probecounter
        tas  =(*alldataV).tas;   note that even the fake particles has none zero tas values now.
        area =(*alldataV).area
    endif else begin
        nanos=(*alldataH).nanoseconds
        nanos_old=nanos
        ticks=(*alldataH).probecounter
        tas  =(*alldataH).tas;   note that even the fake particles has none zero tas values now.
        area =(*alldataH).area
    endelse

    nnn=n_elements(area);  total number of parricles.

    index=where(area eq -104, contG)
    if contG ne 0 then begin
        print,'area=-104 index: ',index, 'and tas(index)=',tas(index)
    endif

    ;case 1:
    if contG eq 0 then begin;     there is no air speed change
        nanoPerTick=double(10000.0)/double(tas(0)); ; so nano_second is uniformly proportional to the count ticks.
        nanos=long64(nanos(0))+long64((long64(ticks)-long64(ticks(0)))*nanoPertick)
    endif
    ;stop;print,index

    ;case 2:
    if contG eq 1 then begin; contG can be as large as nnn-1;  usually it will be very small.
        if area(nnn-1LL) eq -104 or area(0) eq -104 then begin;  -104 is at begin or end.
            start_index=0LL
            this_index=nnn-1LL

            nanoPerTick=double(10000.0)/double(tas(start_index))
            delta_ticks=long64(ticks(start_index:this_index))-long64(ticks(start_index))
            delta_nanos=long64( delta_ticks*nanoPerTick  )
            nanos(start_index:this_index)=nanos_old(start_index)+delta_nanos
        endif else begin;  -104 is somewhere in the middle
            ; do first section.
            start_index=0LL
            this_index=index(0)-1LL

            nanoPerTick=double(10000.0)/double(tas(start_index))
            delta_ticks=long64(ticks(start_index:this_index))-long64(ticks(start_index))
            delta_nanos=long64( delta_ticks*nanoPerTick  )
            nanos(start_index:this_index)=nanos_old(start_index)+delta_nanos

            ; do last section.
            start_index=index(0)
            this_index=nnn-1LL

            nanoPerTick=double(10000.0)/double(tas(start_index))
            delta_ticks=long64(ticks(start_index:this_index))-long64(ticks(start_index))
            delta_nanos=long64( delta_ticks*nanoPerTick  )
            nanos(start_index:this_index)=nanos(start_index)+delta_nanos
            ; now finished.
        endelse
    endif;  end of there is only 0ne -104 values.

    ;case 3: there are 2 -104 values.
    if contG eq 2 then begin
        ;do first section   -104 to next -104.
        start_index=0LL
        this_index=(index(0)-1LL) > 0

        nanoPerTick=double(10000.0)/double(tas(start_index))
        delta_ticks=long64(ticks(start_index:this_index))-long64(ticks(start_index))
        delta_nanos=long64( delta_ticks*nanoPerTick  )
        nanos(start_index:this_index)=nanos_old(start_index)+delta_nanos

        ; do second section.   from index(1) to end.
        start_index=index(0)
        this_index=index(1)-1LL

        nanoPerTick=double(10000.0)/double(tas(start_index))
        delta_ticks=long64(ticks(start_index:this_index))-long64(ticks(start_index))
        delta_nanos=long64( delta_ticks*nanoPerTick  )
        nanos(start_index:this_index)=nanos(start_index)+delta_nanos

        ; do last section.   from index(1) to end.
        start_index=index(1)
        this_index=nnn-1LL

        nanoPerTick=double(10000.0)/double(tas(start_index))
        delta_ticks=long64(ticks(start_index:this_index))-long64(ticks(start_index))
        delta_nanos=long64( delta_ticks*nanoPerTick  )
        nanos(start_index:this_index)=nanos(start_index)+delta_nanos
        ; endif
    endif;  end of there is only two -104 values.

    ;case 4:
    if contG ge 3 then begin; contG can be as large as nnn-1;  usually it will be very small.
        ;do the first section from 0 to first Tas change index
        ;case4-1; first particle is -104.
        if area(0) eq -104 then begin
            for i=0LL, contG-2LL do begin
                start_index=index(i);   0LL
                this_index=index(i+1)-1LL ; index(1)

                nanoPerTick=double(10000.0)/double(tas(start_index))
                delta_ticks=long64(ticks(start_index:this_index))-long64(ticks(start_index))
                delta_nanos=long64(delta_ticks*nanoPerTick  )
                nanos(start_index:this_index)=nanos_old(start_index)+delta_nanos
                ;nanos(start_index:this_index)=nanos(start_index)+delta_nanos
            endfor

            ;do the last section from index(contG-1) to n_elements(ticks)===last particle. tas is constant.
            ;***************************************************
            start_index=index(contG-1LL)
            This_index=n_elements(nanos_old)-1LL
            nanoPertick=double(10000.0)/tas(This_index);  for next segment nanoPerTick
            delta_ticks=long64(ticks(start_index:this_index))-long64(ticks(start_index));;can be positive and nagtive values.
            delta_nanos=long64(delta_ticks*nanoPerTick)
            nanos(start_index:this_index)=long64(nanos_old(start_index))+delta_nanos
            ;***************************************************************
        endif; case4-1. if first particle is -104.

        if area(0) ne -104 then begin
            ; do the first section; that is from 0 to index(0)
            start_index=0LL
            this_index=index(0)-1LL ; index(1)
            nanoPerTick=double(10000.0)/double(tas(start_index))
            delta_ticks=long64(ticks(start_index:this_index))-long64(ticks(start_index))
            delta_nanos=long64( delta_ticks*nanoPerTick  )
            nanos(start_index:this_index)=nanos_old(start_index)+delta_nanos

            ; do the other sections.
            for i=0LL, contG-2LL do begin
                start_index=index(i);   0LL
                this_index=index(i+1)-1LL ; index(1)

                nanoPerTick=double(10000.0)/double(tas(start_index))
                delta_ticks=long64(ticks(start_index:this_index))-long64(ticks(start_index))
                delta_nanos=long64( delta_ticks*nanoPerTick  )
                nanos(start_index:this_index)=nanos_old(start_index)+delta_nanos
                ;nanos(start_index:this_index)=nanos(start_index)+delta_nanos
            endfor

            ;do the last section from index(contG-1) to n_elements(ticks)===last particle. tas is constant.
            ;***************************************************
            start_index=index(contG-1LL)
            This_index=n_elements(nanos_old)-1LL
            nanoPertick=double(10000.0)/tas(This_index);  for next segment nanoPerTick
            delta_ticks=long64(ticks(start_index:this_index))-long64(ticks(start_index));;can be positive and nagtive values.
            delta_nanos=long64(delta_ticks*nanoPerTick)
            nanos(start_index:this_index)=long64(nanos_old(start_index))+delta_nanos
            ;***************************************************************
        endif; case4-2. if first particle is not -104.
    endif; end if of if contG ge 3

    if HorV eq 'V' then  (*alldataV).nanoseconds=nanos
    if HorV eq 'H' then  (*alldataH).nanoseconds=nanos

    ;now print out the difference of the calculations
    window,1,xs=600,ys=600
    erase,color='ffffff'x  ; get background to white
    !P.multi=[0,1,1]
    bluecolor =GetColor("Navy", !D.Table_Size-2)
    redcolor = GetColor("Red", !D.Table_Size-2)
    whitecolor =GetColor("White", !D.Table_Size-2)

    diffs=(long64(nanos_old)-long64(nanos))*tas/10000.0; change diff to be ticks

    if n_elements(diffs) eq 1 then diffs=[diffs,diffs]

    plot,diffs,color=bluecolor,ytitle='Nanos_in_ticks of (Old-New)',charsize=1,yrange=[-5,5],$
        background=whitecolor,title=HorV+'-Difference between the old_time and New Time',xtitle='Particle Sequence Number'

    outputfilename=strmid(!currentHFname,0,strlen(!currentHFname)-4)+$
        '_'+HorV+'_new_oldtime_difference.png'
    write_png,outputfilename,tvrd(true=1)
    wait,2

    wdelete,!D.window

    deltaNanos=abs(diffs)
    indexm=where(deltaNanos gt 1.5 and area gt 0, contNomatch)
    ;stop
    if HorV eq 'V' and contNomatch gt 0 then begin
        (*alldataV)(indexm).warn=(*alldataV)(indexm).warn+1000.0
    endif
    if HorV eq 'H' and contNomatch gt 0 then begin
        (*alldataH)(indexm).warn=(*alldataH)(indexm).warn+1000.0
    endif
    ;**************************************************************************************
end;  correct_HV_particles_nanotimes,HorV

;******************************************************************************

;***********************************************************************
pro make_83_bins,HorV,nbins,nedges,xpts;  added this on May 3, 2007.
    nbins=83;   first xx bins is the same archive's 61 bins upto 2005.
    nedges=2*nbins
    xpts=dblarr(2*nbins)

    if strupcase(HorV) eq 'H' then begin
        microns_per_pixel=!microns_per_pixelH
    endif else begin
        microns_per_pixel=!microns_per_pixelV
    endelse

    xpts(0)=microns_per_pixel/2.0

    for i =0, 19  DO BEGIN ; from 15, 15,25,25, ******205,205.
        xpts[2*i+1:2*i+2] =xpts(0)+(i+1)*microns_per_pixel
    endfor
    for i =20,34  DO BEGIN ; from 205 225, 245,265,285, *****485,485,505,505
        xpts[2*i+1:2*i+2] =20.5*microns_per_pixel +(i-19)*2.0*microns_per_pixel
    endfor

    for i =35,44  DO BEGIN ; from 555,555,605,606,*******1005,1005
        xpts[2*i+1:2*i+2] =(50.5+(i-34)*5.0)*microns_per_pixel
    endfor

    for i =45,54  DO BEGIN ; from 1105,1105,*******2005,2005
        xpts[2*i+1:2*i+2] =(100.5+(i-44)*10.0)*microns_per_pixel
    endfor

    for i =55,59  DO BEGIN ; from 2205,2205,*******3005,3005
        xpts[2*i+1:2*i+2] =(200.5+(i-54)*20.0)*microns_per_pixel
    endfor

    for i=60,69 do begin
        xpts[2*i+1:2*i+2] =(300.5+(i-59)*20.0)*microns_per_pixel
    endfor

    for i=70,81 do begin
        xpts[2*i+1:2*i+2] =(500.5+(i-69)*50.0)*microns_per_pixel
    endfor

    xpts(165)=10000.0*microns_per_pixel
    xpts(0) =0.001

end; end of make_83_bins
;***********************************************************************

pro correct_HV_first_last_particles_ticks
    Common  DataBlock,alldataH,alldataV

    ;another way to find out if it is split file or first_last_file.
    First_number=(*alldataH)(0).nanoseconds mod 1000000000LL; if First_number=0 then it is a dbl_fake
    nnn=n_elements((*alldataH).area)
    Last_number =(*alldataH)(nnn-1).nanoseconds mod 1000000000LL; if last_number=999999999 it is dble_fake.

    if nnn gt 1 then begin
        ;first for H-channel. assume there are laways 2 particles.
        print,'old_F1st_2ticks',(*alldataH)(0:1).probecounter
        delta_nanos=long64((*alldataH)(1).nanoseconds)-long64((*alldataH)(0).nanoseconds)
        delta_ticks=long64(delta_nanos*(*alldataH)(0).tas/10000.0)
        New0_tick=(*alldataH)(1).probecounter-delta_ticks
        if  First_number eq 0 and (*alldataH)(0).area eq -104 then begin; it is a dble_fake, need correction.
            if (*alldataH)(0).probecounter ne New0_tick then (*alldataH)(0).probecounter=New0_tick
            print,'new_First_2ticks=',(*alldataH)(0:1).probecounter
            print,'old_F1st_2nanos',(*alldataH)(0:1).nanoseconds
        endif

        ; do the last one. index=nnn-1
        print,'old_last_2ticks',(*alldataH)(nnn-2:nnn-1).probecounter
        delta_nanos=long64((*alldataH)(nnn-1).nanoseconds)-long64((*alldataH)(nnn-2).nanoseconds)
        delta_ticks=long64(delta_nanos*(*alldataH)(nnn-2).tas/10000.0)
        newE_tick=(*alldataH)(nnn-2).probecounter+delta_ticks
        if last_number eq 999999999LL and (*alldataH)(nnn-1).area eq -104 then begin; it is a dble_fake, need correction.
            if (*alldataH)(nnn-1).probecounter ne newE_tick then (*alldataH)(nnn-1).probecounter=newE_tick
            print,'new_last_2ticks=',(*alldataH)(nnn-2:nnn-1).probecounter
            print,'old_last_2nanos',(*alldataH)(nnn-2:nnn-1).nanoseconds
        endif
    endif; end of if nnn gt 1.

    ;********************************* do the V-channel **********************************
    First_number=(*alldataV)(0).nanoseconds mod 1000000000LL; if First_number=0 then it is a dbl_fake
    nnn=n_elements((*alldataV).area)
    Last_number =(*alldataV)(nnn-1).nanoseconds mod 1000000000LL; if last_number=999999999 it is dble_fake.

    ;first for V-channel. assume there are laways 2 particles.
    if nnn gt 1 then begin
        print,'old_F1st_2ticks',(*alldataV)(0:1).probecounter
        delta_nanos=long64((*alldataV)(1).nanoseconds)-long64((*alldataV)(0).nanoseconds)
        delta_ticks=long64(delta_nanos*(*alldataV)(0).tas/10000.0)
        New0_tick=(*alldataV)(1).probecounter-delta_ticks
        if  First_number eq 0 and (*alldataV)(0).area eq -104 then begin; it is a dble_fake, need correction.
            if (*alldataV)(0).probecounter ne New0_tick then (*alldataV)(0).probecounter=New0_tick
            print,'new_First_2ticks=',(*alldataV)(0:1).probecounter
            print,'old_F1st_2nanos',(*alldataV)(0:1).nanoseconds
        endif

        ; do the last one. index=nnn-1
        print,'old_last_2ticks',(*alldataV)(nnn-2:nnn-1).probecounter
        delta_nanos=long64((*alldataV)(nnn-1).nanoseconds)-long64((*alldataV)(nnn-2).nanoseconds)
        delta_ticks=long64(delta_nanos*(*alldataV)(nnn-2).tas/10000.0)
        newE_tick=(*alldataV)(nnn-2).probecounter+delta_ticks
        if last_number eq 999999999LL and (*alldataV)(nnn-1).area eq -104 then begin; it is a dble_fake, need correction.
            if (*alldataV)(nnn-1).probecounter ne newE_tick then (*alldataV)(nnn-1).probecounter=newE_tick
            print,'new_last_2ticks=',(*alldataV)(nnn-2:nnn-1).probecounter
            print,'old_last_2nanos',(*alldataV)(nnn-2:nnn-1).nanoseconds
        endif
    endif; end of if nnn gt 1.
    ;********************* done V-channel **********************************

end; correct_HV_first_last_particles_ticks

pro free_all
    ;+
    ; ROUTINE:  free_all

    ; PURPOSE:  free up all logical units

    ; USEAGE:   free_all

    ; OUTPUT:   none

    ; DISCUSSION:
    ;           Produces a list of all open files.  For each item in the
    ;           list the user may enter one of the following reponses:

    ;           quit -- do not close this file, quit free_all
    ;           view -- do not close this file, view list of remaining open files
    ;           all  -- close this file and all remaining open files
    ;           yes  -- close this file
    ;           no   -- do not close this file

    ;           Note: only the first letter of the response is actually used in
    ;           free_all.

    ; SIDE EFFECTS:
    ;           closes open files

    ; EXAMPLE:
    ;         IDL> openw,/get_lun,lun1,'junk1'
    ;         IDL> openw,/get_lun,lun2,'junk2'
    ;         IDL> openw,/get_lun,lun3,'junk3'
    ;         IDL> openw,/get_lun,lun4,'junk4'
    ;         IDL> openw,/get_lun,lun5,'junk5'
    ;         IDL> free_all
    ;         Close junk1, logical unit 101 (quit,view/all/yes/no)?: y
    ;         Close junk2, logical unit 102 (quit,view/all/yes/no)?: y
    ;         Close junk3, logical unit 103 (quit,view/all/yes/no)?: a
    ;         Close junk4, logical unit 104
    ;         Close junk5, logical unit 105


    ; AUTHOR:   Paul Ricchiazzi                        17 Mar 98
    ;           Institute for Computational Earth System Science
    ;           University of California, Santa Barbara
    ;           paul@icess.ucsb.edu

    ; REVISIONS:

    ;-


    ans='y'
    for i=1, 128 do begin
        a=fstat(i)
        if a.open eq 1 then free_lun,i
    endfor
end

;***************************************************************
pro Label_all_saw_tooth_events, HorV;  on March 28th, we saw saw_tooths events in  ISDAC data for -100 -101 events.
    Common  DataBlock,alldataH,alldataV;   ; Those cause neagtive ave_w8_t and thresholdC1 C2 problem.


    if HorV eq 'H' then begin
        timetk=long64((*alldataH).probecounter)
        area=(*alldataH).area
    endif else begin
        timetk=long64((*alldataV).probecounter)
        area=(*alldataV).area
    endelse

    index=where(area eq -102,contG)
    if contG gt 0 then area(index)=-100
    index=where(area eq -103,contG)
    if contG gt 0 then area(index)=-101

    index=where(area eq -105,contG)
    if contG gt 0 then area(index)=-100
    index=where(area eq -106,contG)
    if contG gt 0 then area(index)=-101

    index=where(area eq -107,contG)
    if contG gt 0 then area(index)=-100
    index=where(area eq -108,contG)
    if contG gt 0 then area(index)=-101

    index=where(area eq -109,contG)
    if contG gt 0 then area(index)=-100
    index=where(area eq -110,contG)
    if contG gt 0 then area(index)=-101

    nnnm1=n_elements(area)-1LL

    index=where(area eq -101,contG)

    if contG gt 0 then begin

        if HorV eq 'H' then begin
            for i=0LL,contG-1LL do begin
                if timetk(index(i)) gt timetk( (index(i)+1LL) < nnnm1) then begin
                    (*alldataH)(index(i)-1LL).area=-200
                    (*alldataH)(index(i)).area    =-201
                    (*alldataH)(index(i)-1LL).Nslice=0
                    (*alldataH)(index(i)).Nslice   =0
                endif
            endfor
        endif; end of H

        if HorV eq 'V' then begin
            for i=0LL,contG-1LL do begin
                if timetk(index(i)) gt timetk( (index(i)+1) < nnnm1) then begin
                    (*alldataV)(index(i)-1LL).area=-200
                    (*alldataV)(index(i)).area    =-201
                    (*alldataV)(index(i)-1LL).Nslice=0
                    (*alldataV)(index(i)).Nslice   =0
                endif
            endfor
        endif;  end of V

    endif;  end of if contG gt 0

end; ;Label_all_saw_tooth_events
;**************************************************************
